/* apx2pif.c - Just read in the 3D PIF file off the disk and
 * stuff it into a PIF file.
 * 
 * Rob Ashmore
 * Purdue University
 * August 1998
*/
#include "../libr/libPIF.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>


typedef struct __imgHead_t__
  {/* IMAGEHEAD_T */
    int    header;
    int    image;
  }/* IMAGEHEAD_T */ imgHead_t;

pifHead_t pifHead;


int main(int argc, char **argv)
{/* MAIN */
  int       i,j,k,l,m,n,binCol,binRow,binSec;
  fString_t fName,readWrite;
  int       luNum,binFactor, binSwitch,imgOffset;
  char      inFile[128],outFile[128];
  float     *float_buffer;
  BYTE      *char_buffer;
  int       tsbRow,yOut,yOut2;
  BYTE      thisByte;
  forPifHead_t  thisHead;
  FILE *fIn;

  sprintf(inFile,"lilly_rev.apx");
  sprintf(outFile,"lilly_rev.pif");
  fName.addr     = (char *)malloc(sizeof(char)*764);
  readWrite.addr = (char *)malloc(sizeof(char)*64);

  fIn = fopen(inFile,"r");

  binCol = binRow = 512;
  binSec = 1;
  char_buffer = (BYTE *)malloc(sizeof(BYTE)*binCol*binRow*binSec);
	
  fread(char_buffer, sizeof(BYTE), (binCol * binRow), fIn);
  fclose(fIn);

  /* Now flip the image for TSB storing on disk */
  for(j=0;j<binRow/2;j++)
    {/* Do rows in TSB order */
      /* Do rows in TSB order */
      tsbRow = binRow - j - 1;
      yOut = (tsbRow*binCol);
      yOut2= (j*binCol);
      for(k=0;k<binCol;k++)
	{/* Write it a BYTE at a time */
	  thisByte= (BYTE)char_buffer[yOut+k];
	  char_buffer[yOut+k] = (BYTE)char_buffer[yOut2+k];
	  char_buffer[yOut2+k] = (BYTE)thisByte;
	}/* Write it a BYTE at a time */
    }/* Do rows in TSB order */

  sprintf(fName.addr,outFile);
  sprintf(readWrite.addr,"w");

  pif_init_head_(&thisHead);
  luNum = 7;
  thisHead.luNum = luNum;
#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open_(fName.addr, &luNum, readWrite.addr);
#endif

  thisHead.mode = 6;
  thisHead.numCols = binCol;
  thisHead.numRows = binRow;
  thisHead.numSecs = 1;
  thisHead.nimg = 1;
  pif_write_gh_(&thisHead);
  thisHead.imgNum = 1;
  pif_write_dh_(&thisHead);

  imgOffset = 1024;
  pif_write_byte_image_(&luNum, char_buffer, 
			&imgOffset,
			&binCol, &binRow, &binSec);
  
  pif_close_(&luNum);
  free(fName.addr);


}/* MAIN */




/* End of apx2pif.c */
