/*********************************************************
 *   Converter.c -
 *   
 *   Synopsis: 	This program propts the user for a conversion
 *   	       	that they want accomplished and the program
 *		prompts them for the proper files and then
 *		calls the appropriate conversion executable
 * 		to get the job done  
 *
 *   Created By: 	Brant C. French
 *   Date:  		5-20-97
 *
 *   Last Modified:	7-31-97
 *********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#define TRUE 1
#define FALSE 0

#define DATEMODIFIED "Aug-5-1999"

int Get_Info(char *infilename,char *outfilename,char *inextention,
              char *outextention,char *convert,
              char *optionlist,char *options) {
  char sysCall[256],tempname[80];
  int x;
  FILE *fp;

#ifdef VMS
  sprintf(sysCall,"dir *.%s",inextention);
#else
  sprintf(sysCall,"ls *.%s",inextention);
#endif
  printf ("\n\nPrinting list of .%s files\n",inextention);
  system(sysCall);
  printf ("\nEnter the source file WITH extention.\n");
  printf ("(i.e. type: test.%s NOT test): ",inextention);
  if (strcmp(inextention,"bp")==0)
    printf ("\nFor BP files enter the filename as test_001.bp\n");
  gets(infilename);
  gets(infilename);
  if (strcmp(inextention,"bp")!=0)
    {/* Not bp */
/*
      if(strrchr(infilename,'.')==0)
	sprintf(tempname,"%s%s%s",infilename,".",inextention);
      else 
*/
	sprintf(tempname,"%s",infilename);
    }/* Not bp */
  else 
    sprintf(tempname,"%s",infilename);
  if (!(fp=fopen(tempname,"r"))) {
    if (strcmp(infilename,"")!=0) {
      printf ("Error: %s not found\n",tempname);
      printf ("If file is .BP make sure the first image starts with");
      printf (" _001\n");
      printf (" _001 and that all subsequent files are ordered in ");
      printf ("increasing order...\n");
    }
    fclose(fp);
    return(0);
  }
  fclose(fp);
#ifdef VMS
  sprintf(sysCall,"dir *.%s",outextention);
#else
  sprintf(sysCall,"ls *.%s",outextention);
#endif
  printf ("\n\nPrinting list of .%s files\n",outextention);
  system(sysCall);
  printf ("\nEnter the destination file WITH extention.\n");
  printf ("(i.e. type: test.%s NOT test): ",outextention);
  gets(outfilename);

  printf ("Enter any options or type <help> to get a list of available\n");
  printf ("options (type <enter> if you don't want any options): ");
  gets (options);
  for (x=0;x<strlen(options);x++)
    options[x]=tolower(options[x]);
  while (strcmp(options,"help")==0) {
    printf ("\n\n%s options: \n",convert);
    printf ("   %s\n\n",optionlist);
    printf ("Enter any options or type <help> to get a list of available\n");
    printf (" options (type <enter> if you don't want any options): ");
    gets (options);
  }
  return(1);
}

int main(void)
{
  char sysCall[256];  /* The string to hold the system call */
  char ans[20];  /* The answer that the user gave to a question */
  int cont = TRUE;  /* Whether the person wants to do another conversion */
  char infilename[80],outfilename[80],options[80];
  int x;

#ifdef NEEDED_ANYMORE
  printf ("\n\n\n              Welcome to the universal converter.\n\n\n");
  printf ("       Please note that the file naming philosophy of UNICONV\n\
has changed.  You are required to enter the entire filename WITH\n\
extension now for both input and output.  That is, if you want to\n\
convert test.tif to test.pif you must enter 'test.tif' and 'test.pif'\n\
when prompted.  This will allow you to use whatever extension you\n\
want.   RWA 12/23/98\n\n\n\n\n");
  printf ("Enter to continue ... ");
  x= getchar();
#endif

  printf("\n\n\n\n\n");
  banner("uniconv");
  printf ("              Welcome to the universal converter.\n\n");
  while (cont) {
    printf ("Type <help> for assistance on how to use the converter\n");
    printf ("This is a list of supported conversions: \n");

    printf (" A) mrc->PIF               M) \n");
    printf (" B) PIF->mrc               N) \n");
    printf (" C) PIF(6,7)->PIF(46)      O) \n");
    printf (" D) PIF->ccp4              P) \n");
    printf (" E) TIFF(Zeiss)->PIF       R) \n");
    printf (" F) ccp4->PIF              S) \n");
    printf (" G) TIFF(Nikon)->PIF       T) PIFmap->PIFsf\n");
    printf (" H)                        U) PIFsf->PIFmap\n");
    printf (" I)                        V) Xplor->PIFsf\n");
    printf (" J)                        W) PIFsf->ASCIIsf\n");
    printf (" K)                        X) ASCIIsf(tsb)->PIFsf\n");
    printf (" L)                        Y) RAW->PIF\n");
    printf ("                           Z) \n");
    printf (" 1)                        2) PackedPIF->ScanPIF \n");

    printf ("\n");
    printf ("		 help) Help	 Q) Quit\n");
    /*    printf ("  Last Modified: %s",DATEMODIFIED); */
    printf ("\n Please look at the help file if this is your first time \n");
    printf (" Using this program to get syntax for this converter\n");
    printf ("Enter the letter of the type of conversion you would like: ");
    scanf ("%s",ans);
    for (x=0;x<strlen(ans);x++)
      ans[x] = toupper(ans[x]);

    /* MRC2PIF */
    if (strcmp(ans,"A")==0) 
      { /* If Mrc2Pif */
	sprintf(sysCall,"mrc2pif");
	system(sysCall);
      } /* If Mrc2Pif */

    /* PIF2MRC */
    if (strcmp(ans,"B")==0) 
      {/* PIF2MRC */
        sprintf(sysCall,"pif2mrc");
	system(sysCall);
      }/* PIF2MRC */

#ifdef VMS
    /* PCK2PIF */
    if (strcmp(ans,"C")==0) { 
      if (Get_Info(infilename,outfilename,"pck","pif","PCK2PIF",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"convert %s %s",infilename,outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"convert %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y')
        system(sysCall);
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
    }
#endif /* VMS */


    /* PIF boxed modes 6 and 7 to PIF boxed float mode 46 */
    if (strcmp(ans,"C")==0) { 
      if (Get_Info(infilename,outfilename,"pif","pif","pif6-7_2_pif46",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      sprintf(sysCall,"pif6-7_2_pif46 %s %s",infilename,outfilename);
      system(sysCall);
      sprintf(sysCall,"ls -l %s",outfilename);
      system(sysCall);
      }
    }


    /* PIF2ccp4 */
    if (strcmp(ans,"D")==0) 
      {/* PIF2ccp4 */
        sprintf(sysCall,"pif2ccp4");
	system(sysCall);
      }/* PIF2ccp4 */


    /* ccp4_2_pif */
    if (strcmp(ans,"F")==0) 
      {/* ccp4_2_pif */
        sprintf(sysCall,"ccp4_2_pif");
	system(sysCall);
      }/* ccp4_2_pif */


    /* TIFF(Zeiss)2PIF */
    if (strcmp(ans,"E")==0) { 
#ifdef VMS
      if (Get_Info(infilename,outfilename,"tif","pif","TIFF(Zeiss)2PIF",
		   "-od -endian -emulsion -pixavg # -revcontrast ",
		   options)) {
      if (strcmp(options,"")==0)
        sprintf(sysCall,"convert %s %s",infilename,outfilename);
      else  
        sprintf(sysCall,"convert %s %s %s",infilename,outfilename,
						options);
      system(sysCall);
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
#else
      char pifStr[1024];
      printf("Enter tiff filename - \n");
      fscanf(stdin,"%s",pifStr);
      sprintf(sysCall,"tiff2pif %s",pifStr);
      system(sysCall);
      sprintf(sysCall,"ls -l *.pif");
      system(sysCall);
#endif
    }


    /* TIFF(Nikon)2PIF */
    if (strcmp(ans,"G")==0) { 
      char pifStr[1024];
      printf("\n\n");
      system("ls *.tif*");
      printf("\nEnter tiff filename - ");
      fflush(stdout);
      fscanf(stdin,"%s",pifStr);
      sprintf(sysCall,"tiff2pif %s",pifStr);
      system(sysCall);
      sprintf(sysCall,"invertContrast %s",pifStr);
      system(sysCall);
      sprintf(sysCall,"ls -l *.pif");
      system(sysCall);
    }


    /* BP2PCK */
    if (strcmp(ans,"H")==0) { 
      if (Get_Info(infilename,outfilename,"bp","pck","BP2PCK",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"bp2pif %s %s",infilename,outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"bp2pif %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y') {
        system(sysCall); 

        sprintf(sysCall,"convert %s %s %s",outfilename,
			outfilename,"-reverse");
        system(sysCall); /* pif2pck */

        /* Now do cleanup */
        printf ("This program created extra files in this conversion.\n");
        printf ("Do you wish to get rid of the most recent file %s%s?\n",
               outfilename,".pif");
        printf ("This will not delete any previous files of this name:\n");
        sprintf (sysCall,"del %s%s;0",outfilename,".pif");
        system(sysCall);
      }
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
    }

    /* IMG2PCK */
    if (strcmp(ans,"I")==0) { 
      if (Get_Info(infilename,outfilename,"img","pck","IMG2PCK",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"convert %s %s",infilename,
					outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"convert %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y') {
        system(sysCall);

        sprintf(sysCall,"convert %s %s %s",outfilename,
			outfilename,"-reverse");
        system(sysCall); /* pif2pck */

        /* Now do cleanup */
        printf ("This program created extra files in this conversion.\n");
        printf ("Do you wish to get rid of the most recent file %s%s?\n",
               outfilename,".pif");
        printf ("This will not delete any previous files of this name:\n");
        sprintf (sysCall,"del %s%s;0",outfilename,".pif");
        system(sysCall);
      }
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
    }


    /* IMG2BP */
    if (strcmp(ans,"z")==0) 
      {/* img 2 bp */ 
	char temp1[256],temp2[256];
	char *s1;
	if (Get_Info(infilename,outfilename,"img","bp","IMG2BP",
		     "No options available",options)) {
	  ans[0]='y';  /* Set this so that we do the system call */
	  sprintf(temp1,"%s",infilename);
	  sprintf(temp2,"%s",infilename);
	  s1 = strrchr(temp1,'.');
	  if(s1)
	    sprintf(s1,".pif");
	  s1 = strrchr(temp2,'.');
	  if(s1)
	    sprintf(s1,".pck");
	  if (strcmp(options,"")==0)
	    sprintf(sysCall,"convert %s %s",infilename,
		    temp1);
	  else {
	    printf ("Options not supported. Do you wish to write with");
	    printf (" no options? "); 
	    scanf("%s",ans);
	    if (tolower(ans[0]) == 'y')
	      sprintf(sysCall,"convert %s %s",infilename,temp1);
	  }
	  if (ans[0] == 'y') {
	    system(sysCall);
	    
	    sprintf(sysCall,"convert %s %s %s",temp2,temp1,
		    "-reverse");
	    system(sysCall); /* pif2pck */
	    
	    printf ("\n\n\nPCK2BP\n\n\n");
	    sprintf(sysCall,"pck2bp %s %s",temp2,
		    outfilename);
	    system(sysCall); /* pck2bp */
	    
	    /* Now do cleanup */
	    printf ("This program created extra files in this conversion.\n");
	    printf ("Do you wish to get rid of the most recent file %s%s?\n",
		    outfilename,".pif");
	    printf ("This will not delete any previous files of this name:\n");
	    sprintf (sysCall,"del %s%s;0",outfilename,".pif");
	    system(sysCall);
	    printf ("Do you wish to get rid of the most recent file %s%s?\n",
		    outfilename,".pck");
	    printf ("This will not delete any previous files of this name:\n");
	    sprintf (sysCall,"del %s%s;0",outfilename,".pck");
	    system(sysCall);
	  }
	  sprintf(sysCall,"dir /siz/date %s",outfilename);
	  system(sysCall);
	}
      }/* img 2 bp */ 

    /* TIFF(Zeiss)2PCK */
    if (strcmp(ans,"J")==0) 
      { 
	char temp1[256],temp2[256];
	char *s1;
	if (Get_Info(infilename,outfilename,"tif","pck","TIFF(Zeiss)2PCK",
		     "-reverse -od -endian -emulsion -pixavg #",options)) {
	  sprintf(temp1,"%s",infilename);
	  sprintf(temp2,"%s",infilename);
	  s1 = strrchr(temp1,'.');
	  if(s1)
	    sprintf(s1,".pif");
	  s1 = strrchr(temp2,'.');
	  if(s1)
	    sprintf(s1,".pck");
	  if (strcmp(options,"")==0)
	    sprintf(sysCall,"convert %s %s",infilename, temp1);
	  else  
	    sprintf(sysCall,"convert %s %s %s",infilename,temp1,
		    options);
	  system(sysCall); /* tiff2pif */
	  sprintf(sysCall,"convert %s %s %s",outfilename,temp1,"-reverse");
	  system(sysCall); /* pif2pck */
	  printf ("This program created extra files in this conversion.\n");
	  printf ("Do you wish to get rid of the most recent file %s%s?\n",
		  outfilename,".pif");
	  printf ("This will not delete any previous files of this name:\n");
	  sprintf (sysCall,"del %s%s;0",outfilename,".pif");
	  system(sysCall);
	  sprintf(sysCall,"dir /siz/date %s",outfilename);
	  system(sysCall);
	}
      }


    /* TIFF(Zeiss)2BP */
    if (strcmp(ans,"K")==0) 
      { 
	char temp1[256],temp2[256];
	char *s1;

	if (Get_Info(infilename,outfilename,"tif","bp","TIFF(Zeiss)2BP",
		     "-reverse -od -endian -emulsion -pixavg #",options)) 
	  {
	    sprintf(temp1,"%s",infilename);
	    sprintf(temp2,"%s",infilename);
	    s1 = strrchr(temp1,'.');
	    if(s1)
	      sprintf(s1,".pif");
	    s1 = strrchr(temp2,'.');
	    if(s1)
	      sprintf(s1,".pck");
	    if (strcmp(options,"")==0)
	      sprintf(sysCall,"convert %s %s",infilename,temp1);
	    else  
	      sprintf(sysCall,"convert %s %s %s",infilename,temp1,options);
	    system(sysCall); /* tiff2pif */
	    sprintf(sysCall,"convert %s %s %s",temp2,temp1,"-reverse");
	    system(sysCall); /* pif2pck */
	    sprintf(sysCall,"pck2bp %s %s",temp2,outfilename);
	    system(sysCall); /* pck2bp */
	    printf ("This program created extra files in this conversion.\n");
	    printf ("Do you wish to get rid of the most recent file %s%s?\n",
		    outfilename,".pif");
	    printf ("This will not delete any previous files of this name:\n");
	    sprintf (sysCall,"del %s%s;0",outfilename,".pif");
	    system(sysCall);
	    printf ("Do you wish to get rid of the most recent file %s%s?\n",
		    outfilename,".pck");
	    printf ("This will not delete any previous files of this name:\n");
	    sprintf (sysCall,"del %s%s;0",outfilename,".pck");
	    system(sysCall);
	    sprintf(sysCall,"dir /siz/date %s",outfilename);
	    system(sysCall);
	  }
      }

    /* PIF2APX */
    if (strcmp(ans,"L")==0) 
      { 
	if (Get_Info(infilename,outfilename,"pif","apx","PIF2APX",
		     "No options available",options)) {
	  ans[0]='y';  /* Set this so that we do the system call */
	  if (strcmp(options,"")==0)
	    sprintf(sysCall,"pif2apx %s %s",infilename,outfilename);
	  else {
	    printf ("Options not supported. Do you wish to write with");
	    printf (" no options? "); 
	    scanf("%s",ans);
	    if (tolower(ans[0]) == 'y')
	      sprintf(sysCall,"pif2apx %s %s",infilename,outfilename);
	  }
	  if (ans[0] == 'y')
	    system(sysCall);
	  sprintf(sysCall,"dir /siz/date %s",outfilename);
	  system(sysCall);

	}
      }

    else if (strcmp(ans,"M")==0) 
      { /* map_convert */ 
	system("map_convert");
      }

    else if (strcmp(ans,"HELP")==0) 
      {
	system("more conv$:help.txt"); 
	printf ("\n\nHit <Enter> to continue");
	ans[0]=getchar();
	ans[0]=getchar();
	ans[0]='H'; /* Got to return the ans back to proper name */
      }

#ifdef USETHIS
    /* PCX2PIF - doesn't work anymore ???*/
    if (strcmp(ans,"N")==0) { 
      if (Get_Info(infilename,outfilename,"pcx","pif","PCX2PIF",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"pcx2pif %s %s",infilename,outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"pcx2pif %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y')
        system(sysCall);
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
    }
#endif

    /* RAW2PIF */
    if (strcmp(ans,"Y")==0) { 
      if (Get_Info(infilename,outfilename,"raw","pif","RAW2PIF",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"raw2pif %s %s",infilename,outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"raw2pif %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y')
        system(sysCall);
/*
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
*/
      }
    }

    /* GAT2PIF */
    if (strcmp(ans,"O")==0) { 
      if (Get_Info(infilename,outfilename,"smh","pif","GAT2PIF",
               " -silent",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"gat2pif %s %s",infilename,outfilename);
      else {
        sprintf(sysCall,"gat2pif %s %s %s",infilename,outfilename,options);
      }
      if (ans[0] == 'y')
        system(sysCall);
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
    }

    /* PIF2MAP */
    if (strcmp(ans,"P")==0) { 
      if (Get_Info(infilename,outfilename,"pif","map","PIF2MAP",
                    "No options available",options)) {
        
        ans[0]='y';  /* Set this so that we do the system call */
        if (strcmp(options,"")==0)
          sprintf(sysCall,"map2pif %s %s -reverse",outfilename,infilename);
        else {
          printf ("Options not supported. Do you wish to write with");
          printf (" no options? "); 
          scanf("%s",ans);
          if (tolower(ans[0]) == 'y')
            sprintf(sysCall,"map2pif %s %s -reverse",outfilename,infilename);
        }
        if (ans[0] == 'y')
          system(sysCall);
	sprintf(sysCall,"dir /siz/date %s",outfilename);
	system(sysCall);
      } /* If Get_Info */
    } /* If Map2Pif */

    /* DAT2PIF */
    if (strcmp(ans,"R")==0) { 
      if (Get_Info(infilename,outfilename,"dat","pif","DAT2PIF",
                    "No options available",options)) {
        
        ans[0]='y';  /* Set this so that we do the system call */
        if (strcmp(options,"")==0)
          sprintf(sysCall,"dat2pif %s %s",infilename,outfilename);
        else {
          printf ("Options not supported. Do you wish to write with");
          printf (" no options? "); 
          scanf("%s",ans);
          if (tolower(ans[0]) == 'y')
            sprintf(sysCall,"dat2pif %s %s",infilename,outfilename);
        }
        if (ans[0] == 'y')
          system(sysCall);
	sprintf(sysCall,"dir /siz/date %s",outfilename);
	system(sysCall);
      } /* If Get_Info */
    } /* If dat2pif */



    /* imgbox2PIF */
    if (strcmp(ans,"S")==0) { 
      if (Get_Info(infilename,outfilename,"img","pif","IMGBOX2PIF",
                    "No options available",options)) {
        
        ans[0]='y';  /* Set this so that we do the system call */
        if (strcmp(options,"")==0)
          sprintf(sysCall,"convert %s %s -box",
		  infilename,outfilename);
        else {
          printf ("Options not supported. Do you wish to write with");
          printf (" no options? "); 
          scanf("%s",ans);
          if (tolower(ans[0]) == 'y')
            sprintf(sysCall,"convert %s %s -box",
		    infilename,outfilename);
        }
        if (ans[0] == 'y')
          system(sysCall);
	sprintf(sysCall,"dir /siz/date %s",outfilename);
	system(sysCall);
      } /* If Get_Info */
    } /* If dat2pif */



    /* PIFmap->PIFsf */
    if (strcmp(ans,"T")==0) { 
	sprintf(sysCall,"emmap3dt");
	system(sysCall);
        system("dir *.pif");
    } 


    /* PIFsf->PIFmap */
    if (strcmp(ans,"U")==0) { 
	sprintf(sysCall,"emsf3dbt");
	system(sysCall);
        system("dir *.pif");
    } 


    /* Xplor->PIFsf */
    if (strcmp(ans,"V")==0) { 
	sprintf(sysCall,"emsformat_pif");
	system(sysCall);
        system("dir *.pif");
    } 


    /* PIFsf -> ASCIIsf */
    if (strcmp(ans,"W")==0) 
      { /* If pif2sf */
	if (Get_Info(infilename,outfilename,"psf","asf","PIF2SF",
		     "No options available",options)) {
	  
	  ans[0]='y';  /* Set this so that we do the system call */
	  if (strcmp(options,"")==0)
	    sprintf(sysCall,"pif2sf %s %s",
		    infilename,outfilename);
	  else {
	    printf ("Options not supported. Do you wish to write with");
	    printf (" no options? "); 
	    scanf("%s",ans);
	    if (tolower(ans[0]) == 'y')
	      sprintf(sysCall,"pif2sf %s %s",
		      infilename,outfilename);
	  }
	  if (ans[0] == 'y')
	    system(sysCall);
	  sprintf(sysCall,"dir /siz/date %s",outfilename);
	  system(sysCall);
	} /* If Get_Info */
      } /* If pif2sf */


    /* ASCIIsf(tsb) -> PIFsf */
    if (strcmp(ans,"X")==0) 
      { /* If tsbsf2pif */
	if (Get_Info(infilename,outfilename,"asf","psf","TSBSF2PIF",
		     "No options available",options)) {
	  
	  ans[0]='y';  /* Set this so that we do the system call */
	  if (strcmp(options,"")==0)
	    sprintf(sysCall,"tsbsf2pif %s %s",
		    infilename,outfilename);
	  else {
	    printf ("Options not supported. Do you wish to write with");
	    printf (" no options? "); 
	    scanf("%s",ans);
	    if (tolower(ans[0]) == 'y')
	      sprintf(sysCall,"tsbsf2pif %s %s",
		      infilename,outfilename);
	  }
	  if (ans[0] == 'y')
	    system(sysCall);
	  sprintf(sysCall,"dir /siz/date %s",outfilename);
	  system(sysCall);
	} /* If Get_Info */
      } /* If tsbsf2pif */


    /* ctf-image  PIF -> PRF */
    if (strcmp(ans,"Z")==0) 
      { /* If ctf-image */
	if (Get_Info(infilename,outfilename,"pif","prf","ctf-image",
		     "No options available",options)) {
	  
	  ans[0]='y';  /* Set this so that we do the system call */
	  if (strcmp(options,"")==0)
	    sprintf(sysCall,"ctf_image %s %s",
		    infilename,outfilename);
	  else {
	    printf ("Options not supported. Do you wish to write with");
	    printf (" no options? "); 
	    scanf("%s",ans);
	    if (tolower(ans[0]) == 'y')
	      sprintf(sysCall,"ctf_image %s %s",
		      infilename,outfilename);
	  }
	  if (ans[0] == 'y')
	    system(sysCall);
	  sprintf(sysCall,"dir /siz/date %s",outfilename);
	  system(sysCall);
	} /* If Get_Info */
      } /* If ctf-image */


#ifdef DOES_THIS_EVEN_EVER_WORK
    /* PIF2APX */
    if (strcmp(ans,"N")==0) { 
      if (Get_Info(infilename,outfilename,"pif","apx","PIF2APX",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"pcx2apx %s %s",infilename,outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"pif2apx %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y')
        system(sysCall);
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
    }
#endif /* ifdef DOES_THIS_EVEN_EVER_WORK */

    /* BYTE box PIF to i4 box PIF */
    if (strcmp(ans,"1")==0) { 
      if (Get_Info(infilename,outfilename,"pif","pif","boxb2boxi4",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"boxb2boxi4 %s %s",infilename,outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"boxb2boxi4 %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y')
        system(sysCall);
      sprintf(sysCall,"dir /siz/date %s",outfilename);
      system(sysCall);
      }
    }

    /* Packed box (mode==6) PIF to Scan (mode==0) PIF */
    if (strcmp(ans,"2")==0) { 
      if (Get_Info(infilename,outfilename,"pif","pif","pack2scan",
               "No options available",options)) {
      ans[0]='y';  /* Set this so that we do the system call */
      if (strcmp(options,"")==0)
        sprintf(sysCall,"pack2scan %s %s",infilename,outfilename);
      else {
        printf ("Options not supported. Do you wish to write with");
        printf (" no options? "); 
        scanf("%s",ans);
        if (tolower(ans[0]) == 'y')
          sprintf(sysCall,"pack2scan %s %s",infilename,outfilename);
      }
      if (ans[0] == 'y')
        system(sysCall);
      sprintf(sysCall,"ls %s",outfilename);
      system(sysCall);
      }
    }

    if (strcmp(ans,"Q")==0) {
      printf ("\n\nThank you for using the universal image converter.\n");
      cont = FALSE;
    }
    if (strcmp(ans,"Q")!=0 && strcmp(ans,"HELP")!=0) {
      printf ("Hit <Enter> to continue");
      /* ans[0]=getchar(); */
      while ((ans[0] = getchar())!='\n');
    }

  } /* End loop */
  return(1);
}

