/* convpif.c - 
 * 
 * Rob Ashmore
 * Purdue University
 * May 1998
*/
#include "../libr/libPIF.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>


typedef struct __imgHead_t__
  {/* IMAGEHEAD_T */
    int    header;
    int    image;
  }/* IMAGEHEAD_T */ imgHead_t;

pifHead_t pifHead;



int main(int argc, char **argv)
{/* MAIN */
  int       i,j,k,l,m,n,binCols,binRows,binSecs;
  fString_t fName,readWrite,descStr;
  int       luNum,binFactor, binSwitch;
  int       img_bkg;
  imgHead_t imageOffsets[532];
  int       nimg, htype, numCols, numRows, numSecs,
            mode, endianNess, img_min, img_max, imgOffset;
  float     floatScaleFactor, recipFloatScaleFactor, 
            img_avg, img_std, junkFloat;
  char      versionStr[55];
  char      descriptionStr[128];
  char      timeStr[128];
  char      micrographStr[128];
  char      scanNumberStr[128];
  BYTE      *b_buffer[500],*thisB;
  float     *float_buffer;
  float     *section_buffer;
  short     *short_buffer,*thisS;
  int       *int_buffer;
  int       thisSection, thisOffset;
  float     aoverb, map_abang, a_cell,b_cell, c_cell, 
            alp, bet, gam, dela, delb, delc;
  int       t_matrix[6];
  int       convTsb;
  float     minPixel, maxPixel;
  int       packRadius,symmetry;
  float     dthe, dphi_90;
  int       thisI, cen;
  char      inFile[256],outFile[256];
  int       minInt,maxInt,thisInt;
  short     thisShort, thisBkg;
  float     thisSF,minFloat,maxFloat, dist;
  forPifHead_t  thisHead, outHead;
  BYTE *byte_buffer;
  FILE *fIn;


  binFactor = 1;

  printf("Input filename - \n");
  scanf("%s",inFile);
  printf("Output filename - \n");
  scanf("%s",outFile);

  fName.addr = (char *)malloc(sizeof(char)*64);
  sprintf(fName.addr,inFile);  
printf("After[%s]\n",fName.addr);
  descStr.addr = (char *)malloc(sizeof(char)*81);
printf("DE[%s]\n",descStr.addr);
  readWrite.addr = (char *)malloc(sizeof(char)*4);
  sprintf(readWrite.addr,"r");
printf("RW[%s]\n",readWrite.addr);

  sprintf(fName.addr,inFile);
  sprintf(readWrite.addr,"r");

  luNum = 7;
#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open_(fName.addr, &luNum, readWrite.addr);
#endif

  sprintf(fName.addr,outFile);
  sprintf(readWrite.addr,"w");

  luNum = 8;
#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open_(fName.addr, &luNum, readWrite.addr);
#endif


  thisHead.luNum = 7;
  pif_read_gh_(&thisHead);
  thisHead.luNum = 7;
  memcpy(&outHead,&thisHead,sizeof(forPifHead_t));
  outHead.luNum = 8;
  pif_write_gh_(&outHead);

  byte_buffer = (BYTE *)malloc(sizeof(BYTE)*
				 (thisHead.numCols)*
				 (thisHead.numRows));
  
  numSecs = thisHead.numSecs;
  numRows = thisHead.numRows;
  numCols = thisHead.numCols;

  cen = numCols / 2;
  for(i=0;i<thisHead.nimg;i++)
    {/* Do all images */


      thisHead.imgNum = outHead.imgNum = i+1;
      pif_read_dh_(&thisHead);
      thisHead.luNum = 7;
      memcpy(&outHead,&thisHead,sizeof(forPifHead_t));
      outHead.luNum = 8;
      pif_write_dh_(&outHead);

      imgOffset = 512 +
	(512 * (i+1)) +
	  (numCols*numRows*i);
      pif_read_byte_image_(&thisHead.luNum,
			   byte_buffer,
			   &imgOffset,
			   &numCols,&numRows,&numSecs
			   );
      thisBkg = byte_buffer[0];
      for(j=0;j<numRows;j++)
	{/* Rows */
	  for(k=0;k<numCols;k++)
	    {/* Do all */
	      thisOffset = ( (j * numCols) +  k );
	      dist = sqrt((double)((j-cen)*(j-cen)+(k-cen)*(k-cen)));
	      if(dist <= cen)
		byte_buffer[thisOffset] = (BYTE)(byte_buffer[thisOffset]-
						 thisBkg);
	    }/* Do all */
	}/* Rows */
      imgOffset = 512 +
	(512 * (i+1)) +
	  (numCols*numRows*i);
      pif_write_byte_image_(&outHead.luNum,
			   byte_buffer,
			   &imgOffset,
			   &numCols,&numRows,&numSecs
			   );
    }/* Do all images */
	 
	 
  pif_close(&thisHead.luNum);
  pif_close(&outHead.luNum);
  free(fName.addr);
	 
	 
}/* MAIN */




/* End of convpif.c */
