#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libr$dev:convertlib.h"

int pixelSwitch,yforxSwitch,eorSwitch;

int main(int argc,char **argv) {
  FILE *fp;
  int x,y,i,j,tmpInt;
  char string[100];
  char filename[100];
  short min,max;
  int bmax,bmin,status;
  float scaleFactor;
  fString_t outfileName;
  short junkShort;
  int offset=512;
  BYTE temp;

  if (argc<3) {
    printf (
"Usage:  %s datfile(without extentions) piffile.pif. <-eorSwitch>\n",
	    "dat2pif");
    printf ("Note: This program needs both a .dat and .hdr file with\n");
    printf ("	the header info in the .hdr file and the data in the\n");
    printf ("	.dat file.  These files must have the same name with\n");
    printf ("	only different extentions.  This is why no extention\n");
    printf ("	is supplied with the dat file but one for the pif file\n");
    printf ("	is necessary.\n");
    exit(0);
  }

  pixelSwitch = TRUE;   /* I think this is always needed... ??? */
  yforxSwitch = FALSE;
  eorSwitch   = FALSE;
  if(argc > 3)
    {/* Check switches */
      for(i=3;i<argc;i++)
	{/* DO all */
	  if((strstr(argv[i],"pixel")) ||
	     (strstr(argv[i],"PIXEL")))
	    pixelSwitch = TRUE;
	  if((strstr(argv[i],"yforx")) ||
	     (strstr(argv[i],"YFORX")))
	    yforxSwitch = TRUE;
	  if((strstr(argv[i],"eor")) ||
	     (strstr(argv[i],"EOR")))
	    eorSwitch = TRUE;
	}/* DO all */
    }/* Check switches */
  
  sprintf (filename,"%s.hdr",argv[1]);
  if (!(fp=fopen(filename,"r"))) {
    printf ("Error: Opening file %s\n",filename);
    exit(0);
  }
  x=0;
  printf ("Reading header...\n");
  while(fscanf(fp,"%s",string)!=EOF&&x<16) {
    x++;
    if (x==7)
      numCols=strtod(string,0);
    else if (x==15)
      numRows=strtod(string,0);
  }

  /* Switch y and x concepts */
  if(yforxSwitch)
    {/* switch */
      printf("Switching Y for X.\n");
      tmpInt  = numCols;
      numCols = numRows;
      numRows = tmpInt;
    }/* switch */

  fclose(fp);
  printf ("numCols[%d] numRows[%d]\n",numCols,numRows);

  sprintf (filename,"%s.dat",argv[1]);
  if (!(fp=fopen(filename,"r"))) {
    printf ("Error: Opening file %s\n",filename);
    exit(0);
  }
  short_buffer = (short *)malloc(sizeof(short)*numRows*numCols+2);
  byte_buffer = (BYTE *)malloc(sizeof(BYTE)*numRows*numCols);
  printf ("Reading buffer in file %s...\n",filename);

  if(eorSwitch)
    {/* Get it a row at a time */
      for(i=0;i<numRows;i++)
	{/* rows */
	  fread((short_buffer+(i*numCols)),sizeof(short),numCols,fp);
	  fread(&junkShort,sizeof(short),1,fp);
	}/* rows */

    }/* Get it a row at a time */
  else
    fread((short_buffer),sizeof(short),numRows*numCols,fp);

#ifdef DEBUG
printf("Before read [%d]\n",*short_buffer);
  status= fread(short_buffer,sizeof(short),1,fp);
printf("After read [%d]  [%d]\n",*short_buffer,status);
exit(0);
#endif

  min=max=short_buffer[0];
  for (x=0;x<numRows*numCols;x++) {
    if (short_buffer[x]<min) min = short_buffer[x];
    else if (short_buffer[x]>max) max = short_buffer[x];
  }
  scaleFactor = 255.0/(float)(max-min);

  for (x=0;x<numRows*numCols;x++) 
    byte_buffer[x] = (BYTE)((short_buffer[x]-min)*scaleFactor); 
  

  /* Here's where the pixel switching occurs */
  if(pixelSwitch)
    {/* Switch them */
printf("Pixel Switching.\n");
      for (y=1;y<numRows;y+=2) {
	for (x=0;x<numCols/2;x++) {
	  temp = byte_buffer[y*numCols+x];
	  byte_buffer[y*numCols+x] = byte_buffer[y*numCols+(numCols-x-1)];
	  byte_buffer[y*numCols+(numCols-x-1)]=temp;
	}
      }
      
    }/* Switch them */

  floatScaleFactor=1.0; recipFloatScaleFactor=1.0;
  htype=1; numSecs=1; mode=0; endianNess=0; nimg=1;
  sprintf(versionStr,"dat2pif");
  #ifdef VMS
          outfileName.addr = (char *)calloc(strlen(argv[2]),
                          sizeof(char));
          strcpy(outfileName.addr,argv[2]);
          outfileName.length = strlen(argv[2]);
          outfileName.type = 14;
          outfileName.class = 1;
          pif_open_vms_(&outfileName,&lun,"w");
  #else
          pif_open_(argv[2],&lun,"w");
  #endif
  pif_write_header_(&lun,&nimg,&floatScaleFactor,&recipFloatScaleFactor, 
			&htype,&numCols,&numRows,&numSecs,&mode,
			&endianNess,versionStr);
  pif_write_image_header_(&lun,&nimg,&floatScaleFactor,&img_bkg,
				&img_min,&img_max,&img_avg,&img_std,
				&numCols,&numRows,&numSecs,
				&offset,&mode,descriptionStr,timeStr,
				micrographStr,scanNumberStr);
  offset=1024;
  pif_write_byte_image_(&lun,byte_buffer,&offset,&numCols,&numRows,&numSecs);
  return 1;
}






