
      program emsformat
C
      implicit none
C
	INCLUDE 'PIFHEAD.INC'
	RECORD /PIFHEAD_T/ SFHEAD
C        
	BYTE      READWRITE(4)
      character*50 index, label, filein, fileout
      integer h, k, l, numSfs, jj 
      real cell, pixel, fcalc, sigma, phi, astar, absMax
C
	INCLUDE 'STRUCFAC.INC'
	RECORD /strucFac_T/ stFacs(1)
	pointer   (stFacs_p,stFacs)
	logical  malloc
C
      write(*,30) ' Enter the input filename:'
      read(*,30) filein
      write(*,30) ' Enter the dimension of one axis of the unit cell:'
	print *, ' MAKE SURE IT IS IN FLOATING POINT FORMAT!!!'
      read(*,40) cell
Ca    We are just doing this as pixel size == 1.0 here.  They
Ca    need to use the header concept in emsf3dbt to change the
Ca    pixel size.
Ca      write(*,30) ' Enter the pixel size:'
Ca      read(*,40) pixel
      pixel = 1.0
      write(*,30) ' Enter the output filename:'
      read(*,30) fileout
Ca      write(*,30) ' Enter the number of structure factors:'
Ca      read(*,50) numSfs


      open(11, file=filein, status='old')
Ca      open(12, file=fileout, status='new')

Ca      write(12,50) 2
Ca      write(12,*)
Ca      write(12,60) 1, 3
Ca      write(12,70) 0,0,0,0,0,0
      astar = pixel/cell
Ca	print *, 'Follows is astar, pixel, cell'
Ca	print *, astar,pixel,cell
Ca      write(12,80) astar, astar, astar, 90.0, 90.0, 90.0
Ca      write(12,80) 0.0,0.0,0.0,0.0,0.0,0.0
Ca      write(12,90) 0.0,0.0,1.0 
Ca150   read(11,100,end=99) index, h, k, l, label, fcalc, phi
Ca      write(12,200) h, k, l, fcalc/100000.0, phi, 0.0, 
Ca      write(12,200) h, k, l, fcalc/1000.0, phi, 0.0, 
Ca     & sqrt((h*h + k*k + l*l)*astar*astar)
Ca      goto 150


      numSfs = 0
150   read(11,100,end=99) index, h, k, l, label, fcalc, phi
        numSfs = numSfs + 1
      goto 150

99    close(11)

      print *, numSfs, ' Structure factors found ...'

Ca    Now open it back up now that we know how many there are
      open(11, file=filein, status='old')

      stFacs_p = malloc(2*3*4*4*numSfs)
	absMax = 99.9     ! Inlcude the 90 degrees for alp/bet/gam etc...
      do jj=1, numSfs
         read(11,100,end=999) index, h, k, l, label, fcalc, phi

         if(mod(jj,10000) .eq. 0) print *, jj

	   stFacs(jj).h = h
	   stFacs(jj).k = k
	   stFacs(jj).l = l
	   stFacs(jj).amp  = fcalc/100000.0
	   stFacs(jj).phi  = phi
	   stFacs(jj).sig  = 0.0
	   stFacs(jj).dstr = sqrt((h*h + k*k + l*l)*astar*astar)

	   if(ABS(stFacs(jj).amp) .gt. absMax) absMax = ABS(stFacs(jj).amp)
	   if(ABS(stFacs(jj).phi) .gt. absMax) absMax = ABS(stFacs(jj).phi)

      enddo

      call pif_init_head(sfHead)
	SFHEAD.LUNUM = 2
	READWRITE(1)  = 'w'
	print *, 'Writing PIF file '
	CALL PIF_OPEN (fileout, SFHEAD.LUNUM, READWRITE) 
	sfhead.mode    = 31
	sfhead.a_cell  = astar
	sfhead.b_cell  = astar
	sfhead.c_cell  = astar
	sfhead.alp     = 90.0
	sfhead.bet     = 90.0
	sfhead.gam     = 90.0

	sfHead.numRows = numSfs
	sfHead.numCols = 1
	sfHead.numSecs = 1

	sfhead.scalef  = 2147483648.0 / (absMax+ 2.0)

	call pif_write_gh(sfHead)
	call pif_write_dh(sfHead)

	call pif_write_sf(sfHead, stFacs)

	call pif_close (sfHead.luNum) ! CLOSE AND SAVE STRUCTURE FACTOR FILE

	call free(stFacs_p)

        goto 999

30    format(a)
40    format(f10.4)
50    format(i12)
60    format(2i12)
70    format(6i5)
80    format(3f10.6,3f10.4)
90    format(3f10.4)
Ca 100   format(a6, 3i5, a7, 2f10.3)
100   format(a6, 3i5, a7, 2f15.3)
200   format(3i5,3f10.4,f10.5)

999    close(11)
      end

 
