
#include <stdio.h>
#ifdef _WIN32
  #include <UnixToWin.h>
#else
  #include <unistd.h>
  #include <sys/socket.h>
  #include <netinet/in.h>
  #include <netinet/tcp.h>
#endif
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <sys/stat.h>
#include <sys/types.h>

int readIMAGIC(const char *fsp3, int n,int nodata) {
	List *list;
	EMData *tmp;
	int ret;
	imagicH *hed;
	FILE *in,*inh;
	char *fsp,*fsp2,*t;
	float *data;
	short *sdata;
	unsigned char *cdata,jj;
	char *lab[] = { "","Byte reversed ","" };
	int i,j,count,type,ord=0;
	
	if(!imagich)hed=(imagicH *)Smalloc(sizeof(imagicH),1);
	else hed=imagich;
	
	flags=EMDATA_CHANGED;
	fsp=(char *)malloc(strlen(fsp3)+5);
	fsp2=(char *)malloc(strlen(fsp3)+5);
	strcpy(fsp,fsp3);
	strcpy(fsp2,fsp3);
	if (strrchr(fsp3,'.')!=NULL) { *(strrchr(fsp,'.'))=0; *(strrchr(fsp2,'.'))=0; }
	
	strcat(fsp2,".hed");
	strcat(fsp,".img");
	
	inh=fopen(fsp2,"rb");
	in=fopen(fsp,"rb");
	if (inh==NULL || in==NULL) { error("ERROR: cannot open imagic file",ERR_ERROR); Sfree(hed,1); zero(); return -1; }
	
	fread(hed,4,256,inh);
	rewind(inh);
	
	if (strrchr(fsp,'/')==NULL) setName(fsp);
	else setName(strrchr(fsp,'/')+1);
	setPath(fsp);
	
	// check byte order of image (header must match image)
	t=(char *)&hed->headrec;
	if (ByteOrder::is_machine_big_endian()) {
	    if (t[0]==0&&t[1]==0) ord=0; else ord=1;
	}
	else {
	    if (t[0]==0&&t[1]==0) ord=1; else ord=0;
	}
	
	if (strncmp(hed->type,"REAL",4)==0) type=1;
	else if (strncmp(hed->type,"INTG",4)==0) type=0;
	else {
		error("Unsupported imagic type\n",ERR_ERROR);
		fclose(in);
		fclose(inh);
		Sfree(hed,1);
		zero();
		return -1;
	}
	
	if (ord) { 
		//	fprintf(stderr,"Image %s is in opposite byte order, data byte order will be inverted\n",fsp);
		swapint((char *)hed,14);
		swapint((char *)&hed->ixold,14);
		swapint((char *)&hed->SPACE,207);
	}
	
	count=hed->count+1;
	if (n>=count) { fclose(in); fclose(inh); free(hed); zero(); return -1; }
	
	portable_fseek(inh,1024*n,SEEK_SET);
	EMAN_off_t cur_offset = ((EMAN_off_t)n)*hed->nx*hed->ny*(2+2*type);
	portable_fseek(in,cur_offset,SEEK_SET);
	fread(hed,4,256,inh);
	
	if (ord==1) { 
		swapint((char *)hed,14);
		swapint((char *)&hed->ixold,14);
		swapint((char *)hed->SPACE,207);
	}
	
	if (nodata) flags|=EMDATA_NODATA;
	setSize(hed->nx,hed->ny,1);
	imagich=hed;
	
	if (!nodata) {
		data=getData();
		sdata=(short *)data;
		cdata=(unsigned char *)data;
		
		// read the data (remember to flip y
		for (i=ny-1; i>=0; i--) {
			if (updProgress && updProgress(ny-i-1,ny,"Reading IMAGIC file")) break;
			fread(cdata+i*nx*(2+2*type),nx*(2+2*type),1,in);
		}
		if (updProgress) updProgress(0,0,NULL);
		
		if (type) {
			if (ord) swapint((char *)data,nx*ny);
		}
		else {
			if (ord) {
				for (i=nx*ny-1; i>=0; i--) { 
					jj=cdata[i*2]; 
					cdata[i*2]=cdata[i*2+1];
					cdata[i*2+1]=jj;
					data[i]=sdata[i];
				}
			}
			else {
				for (i=nx*ny-1; i>=0; i--) data[i]=sdata[i];
			}
		}
		
	}
	
	fclose(in);
	fclose(inh);
	
	free(fsp);
	free(fsp2);
	
	pixel=4.66667;
	parent=NULL;
	pathnum=n;
	dx=dy=dz=0;
	if (!goodf(&hed->MRC1[0])) hed->MRC1[0]=0;
	if (!goodf(&hed->MRC1[1])) hed->MRC1[1]=0;
	if (!goodf(&hed->MRC1[2])) hed->MRC1[2]=0;
	setRAlign(hed->MRC1[1],hed->MRC1[2],hed->MRC1[0]);	// inappropriate use, but what the heck
	nimg=hed->MRC2;
	atime=time(0);
	hed->SPACE[0]=0;
	hed->label[79]=0;
	setName(hed->label);
	if (name[0]=='!' && name[1]=='-') {
		i=sscanf(name+2," %f %f %f %f %f %f %f %f %f %f %f",
			ctf,ctf+1,ctf+2,ctf+3,ctf+4,ctf+5,ctf+6,ctf+7,ctf+8,ctf+9,ctf+10); 
		if (i==11) flags|=EMDATA_HASCTF;
		else printf("Incomplete CTF info: %s\n",name);
		//	printf("IMGCTF '%s' %f %f %f\n",name,ctf[0],ctf[1],ctf[2]);
	}
	if (name[0]=='!' && name[1]=='$') {
		sscanf(name+2," %f,%f",ctf,ctf+10);
	}
	//calcHist(Min(),Max());
	doneData();
	update();
	return(0);
}

int readIMAGIC3d(const char *fsp3,int nodata)
{
	List *list;
	EMData *tmp;
	int ret;
	imagicH *hed;
	FILE *in,*inh;
	char *fsp,*fsp2,*t;
	float *data;
	short *sdata;
	unsigned char *cdata;
	char *lab[] = { "","Byte reversed ","" };
	int i,j,count,type,ord=0;
	
	hed=(imagicH *)Smalloc(sizeof(imagicH),1);
	
	flags=EMDATA_CHANGED;
	fsp=(char *)malloc(strlen(fsp3)+5);
	fsp2=(char *)malloc(strlen(fsp3)+5);
	strcpy(fsp,fsp3);
	strcpy(fsp2,fsp3);
	if (strrchr(fsp3,'.')!=NULL) { *(strrchr(fsp,'.'))=0; *(strrchr(fsp2,'.'))=0; }
	
	strcat(fsp2,".hed");
	strcat(fsp,".img");
	
	inh=fopen(fsp2,"rb");
	in=fopen(fsp,"rb");
	if (inh==NULL || in==NULL) { error("ERROR: cannot open imagic file",ERR_ERROR); Sfree(hed,1); zero(); return -1; }
	
	fread(hed,4,256,inh);
	rewind(inh);
	
	if (strrchr(fsp,'/')==NULL) setName(fsp);
	else setName(strrchr(fsp,'/')+1);
	setPath(fsp);
	
	// check byte order of image (header must match image)
	t=(char *)&hed->headrec;
	if (ByteOrder::is_machine_big_endian()) {
	    if (t[0]==0&&t[1]==0) ord=0; else ord=1;
	}
	else {
	    if (t[0]==0&&t[1]==0) ord=1; else ord=0;
	}
	
	if (strncmp(hed->type,"REAL",4)==0) type=1;
	else if (strncmp(hed->type,"INTG",4)==0) type=0;
	else {
		error("Unknown imagic type\n",ERR_ERROR);
		fclose(in);
		fclose(inh);
		Sfree(hed,1);
		zero();
		return -1;
	}
	
	if (ord) {
		swapint((char *)hed,14);
		swapint((char *)&hed->ixold,14);
		swapint((char *)&hed->SPACE,207);
	}
	
	count=hed->count+1;
	
	if (!(count==hed->nx || (hed->nx==hed->ny && hed->nx==count*2-1))) { return readIMAGIC(fsp3,0,nodata); }	// if it isn't a valid 3d file (cube) return the first 2d image
	//{ printf("Imagic3d invalid %d,%d,%d\n",hed->nx,hed->ny,count); zero(); return(1); }
	
	if (nodata) flags|=EMDATA_NODATA;
	setSize(hed->nx,hed->ny,count);
	imagich=hed;
	
	if (!nodata) {
		data=getData();
		sdata=(short *)data;
		cdata=(unsigned char *)data;
		
		printf("Imagic3d -> %d,%d,%d\n",nx,ny,nz);
		
		// read the data
		for (j=0; j<nz; j++) {
			if (updProgress && updProgress(j,nx,"Reading IMAGIC 3D file")) break;
			for (i=ny-1; i>=0; i--) {
				fread(cdata+(i+j*ny)*nx*(2+2*type),nx*(2+2*type),1,in);
			}
		}
		
		if (updProgress) updProgress(0,0,NULL);
		
		if (type) {
			if (ord) swapint((char *)data,nx*ny*nz);
		}
		else {
			if (ord) {
				for (i=nx*ny*nz-1; i>=0; i--) { 
					j=cdata[i*2]; 
					cdata[i*2]=cdata[i*2+1];
					cdata[i*2+1]=j;
					data[i]=sdata[i];
				}
			}
			else {
				for (i=nx*ny*nz-1; i>=0; i--) data[i]=sdata[i];
			}
		}
	}
	
	fclose(in);
	fclose(inh);
	
	free(fsp);
	free(fsp2);
	
	pixel=4.66667;
	parent=NULL;
	pathnum=0;
	dx=dy=dz=0;
	setRAlign(0,0,0);
	atime=time(0);
	//calcHist(Min(),Max());
	doneData();
	vol_table = 0;
	update();
	return(0);
}



main(int argc, char **argv)
{/* MAIN */





}/* MAIN */


