/* invertContrast.c - Just read in the 2D PIF file off the disk and
 * stuff it into a PIF file.
 * 
 * Rob Ashmore
 * Purdue University
 * August 1998
*/
#include "../libR/libPIF.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>


typedef struct __imgHead_t__
  {/* IMAGEHEAD_T */
    int    header;
    int    image;
  }/* IMAGEHEAD_T */ imgHead_t;

pifHead_t pifHead;


int main(int argc, char **argv)
{/* MAIN */
  int       i,j,k,l,m,n,binCol,binRow,binSec;
  fString_t fName,readWrite;
  int       luNum,binFactor, binSwitch,imgOffset;
  char      inFile[1024],outFile[1024];
  float     *float_buffer,minF,maxF;
  short     *short_buffer;
  BYTE      *byte_buffer;
  forPifHead_t  thisHead;
  char invertStr[256];
  char *s1;

  printf("Do you want to invert contrast? (y/N) -");
  scanf("%s",invertStr);
  if(*invertStr != 'Y' && *invertStr != 'y')
    exit(0);
#ifdef OLDWAY
  printf("PIF filename - ");
  scanf("%s",inFile);
#else
  if(argc < 2)
    {
      printf("[INVERTCONTRAST] too few args.\n");
      exit(0);
    }
  sprintf(inFile,"%s",argv[1]);
  s1 = strrchr(inFile,'.');
  if(s1)
    sprintf(s1,".pif");
  else
    sprintf(inFile,"%s.pif",argv[1]);
#endif
  sprintf(outFile,inFile);
  fName.addr = (char *)malloc(sizeof(char)*64);
  readWrite.addr = (char *)malloc(sizeof(char)*64);
  sprintf(fName.addr,inFile);
  sprintf(readWrite.addr,"r");
  i= thisHead.luNum = 4;
#ifdef VMS
  pif_open_vms_(&fName, &i, readWrite.addr);
#else
  pif_open_(fName.addr, &i, readWrite.addr);
#endif

  pif_read_gh_(&thisHead);
  thisHead.imgNum = 1;
  pif_read_dh_(&thisHead);

  if(thisHead.mode != 1  && thisHead.mode != 0  )
    {/* Error */
      printf("invertContrast for Nikon Scanned files only.\n");
      exit(0);
    }/* Error */

  if(thisHead.mode == 0  )
    {
      printf("************************************************\n");
      printf("* Warning - Scanned file has only 8 bit depth. *\n");
      printf("************************************************\n");
    }

  binCol = thisHead.numCols;
  binRow = thisHead.numRows;
  binSec = 1;

	
  imgOffset  = thisHead.imgOffset;
  if(thisHead.mode==0)
    {/* byte data */
      byte_buffer = (BYTE *)malloc(sizeof(BYTE)*binCol*binRow*binSec);
      pif_read_byte_image_(&thisHead.luNum,
			   byte_buffer, 
			   &imgOffset,
			   &binCol, &binRow, &binSec);
      /* Invert  */
      for(j=0;j<(thisHead.numRows);j++)
	for(k=0;k<(thisHead.numCols);k++)
	  {/* Do all */
	    byte_buffer[(
			  (j * (binCol)) +
			  k
			  )] = (BYTE)255 -
	      byte_buffer[(
			    (j * (binCol)) +
			    k
			    )] ;
	  }/* Do all */
    }/* byte data */
  else
    {/* short dataq */
      short_buffer = (short *)malloc(sizeof(short)*binCol*binRow*binSec);
      pif_read_short_image_(&thisHead.luNum,
			    short_buffer, 
			    &imgOffset,
			    &binCol, &binRow, &binSec);
      /* Invert  */
      for(j=0;j<(thisHead.numRows);j++)
	for(k=0;k<(thisHead.numCols);k++)
	  {/* Do all */
	    short_buffer[(
			  (j * (binCol)) +
			  k
			  )] = (short)0 -
	      short_buffer[(
			    (j * (binCol)) +
			    k
			    )] ;
	  }/* Do all */
    }/* short dataq */
  


  pif_close(&thisHead.luNum);

  sprintf(fName.addr,outFile);
  sprintf(readWrite.addr,"w");

  luNum = 7;
  thisHead.luNum = luNum;
#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open_(fName.addr, &luNum, readWrite.addr);
#endif

  pif_write_gh_(&thisHead);
  thisHead.imgNum = 1;
  pif_write_dh_(&thisHead);

  imgOffset  = 1024;
  if(thisHead.mode==0)
    pif_write_byte_image_(&(thisHead.luNum),
			  byte_buffer, 
			  &imgOffset,
			  &binCol, &binRow, &binSec);
  else
    pif_write_short_image_(&(thisHead.luNum),
			   short_buffer, 
			   &imgOffset,
			   &binCol, &binRow, &binSec);
  
  pif_close_(&luNum);
  free(fName.addr);


}/* MAIN */




/* End of invertContrast.c */
