
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#ifdef VMS
/* #include "libr$dev:libPIF.h" */
#include "libr$dev:convertlib.h"
#else
#include "../libr/libPIF.h"
#include "../libr/convertlib.h"
#endif




/************************************************************
 * Main- This program reads converts from MAP 2 PIF and from
 * PIF 2 MAP format 
*/
int main(int argc,char **argv) {
  char infilename[80],outfilename[80];
  int i,j,k,x, quadSwitch,reverseSwitch;
  int binFactor, symm;
  float dthe, dphi_90;
  char ans[80];
  forPifHead_t thisHead;
  float a_star, b_star, c_star, alp_star, bet_star, gam_star;
  float pixelSize;
  int pixSizUnits;
  float res_out;
  int ctfMode;
  float tempFactor;
  float wiener;

  if ((argc < 3)||(argc>4)) {
    printf ("Usage: map2pif mapfile piffile [options] (no extentions)\n");
    printf ("\n Example: map2pif this that  (converts this.map");
    printf (" to that.pif)\n\n");
    printf ("Options: \n");
    printf ("  -reverse   		Performs a pif2map convertion.\n");
    printf ("  -quad    		PIFmap is a QUAD PIFmap.\n\n");
    exit(0);
  }
 
  mode = 20;

  quadSwitch= reverseSwitch= FALSE;
  if (argc>=4) 
    {/* We have options */ 
      for(i=0;i<argc;i++)
	{/* Look at all args */
	  if(EQU(argv[i],"-reverse") ||
	     EQU(argv[i],"-REVERSE") )
	    reverseSwitch = TRUE;
	  if(EQU(argv[i],"-quad") ||
	     EQU(argv[i],"-QUAD") )
	    quadSwitch = TRUE;
	}/* Look at all args */
    }/* We have options */ 
      
  if(quadSwitch)
    mode = 21;

  if (!reverseSwitch) 
    { /* If map2pif */
      if(strrchr(argv[1],'.')==0)
	sprintf(infilename,"%s.map",argv[1]);
      else sprintf(infilename,"%s",argv[1]);
      if(strrchr(argv[2],'.')==0)
	sprintf(outfilename,"%s.pif",argv[2]);
      else sprintf(outfilename,"%s",argv[2]);
      nimg = 1; img_avg = 1.0; img_std = 1.0;
      read_MAP(infilename);  
      printf("desc[%s]\n",descriptionStr);
      /* We already have these in the MAP header 
      calcMapShortStats((short *)short_buffer,&img_bkg,&img_min,&img_max,
			&img_avg,&img_std,numRows,numCols,numSecs);
      calcShortScaleFactor(&floatScaleFactor,&recipFloatScaleFactor,img_min,
			   img_max,img_avg,img_std); 
			   */
      img_min = (int)map_min;
      img_max = (int)map_max;
      img_avg = 0.0;
      img_std = 0.0;
      printf("Calculated recipSF[%f] map_scalef[%f]\n",
	     recipFloatScaleFactor, map_scalef);
      map_scalef = MIN(recipFloatScaleFactor,map_scalef);
      recipFloatScaleFactor = map_scalef;
      floatScaleFactor = 1.0 / map_scalef;
      
      printf ("img_min[%d] img_max[%d]\n",img_min,img_max);
#ifdef VMS
      fileName.addr = (char *)calloc(strlen(outfilename),sizeof(char));
      strcpy(fileName.addr,outfilename);
      fileName.length = strlen(outfilename);
      fileName.type = 14;
      fileName.class = 1;
      pif_open_vms_(&fileName,&lun,"w");
#else 
      pif_open_(outfilename,&lun,"w");
#endif
      htype = 1; /* All images are same size */
      printf ("Writing to file %s...\n",outfilename);
      pif_write_header_(&lun,&nimg,&recipFloatScaleFactor,
			&htype,&numCols,&numRows,&numSecs,&mode,&endianNess,
			versionStr);
      for (x=0;x<nimg;x++) { /* For all images */
	int thisImg = x+1;
	imgOffset = 512+512*x+x*numCols*numRows*numSecs*sizeof(short);
#ifdef ORIG_WAY
	pif_write_image_header_(&lun,&thisImg,&recipFloatScaleFactor,&img_bkg,
				&img_min,&img_max,&img_avg,&img_std,
				&numCols,&numRows,&numSecs,&imgOffset,&mode,
				descriptionStr,timeStr,micrographStr,
				scanNumberStr);
#endif /* ORIG_WAY */
	packRadius = (numCols)/2;   /* find a better place for this ... */
	binFactor = 1;
	a_star = b_star= c_star= alp_star= bet_star= gam_star= 0.0;
	pixelSize = 1.0;
	pif_write_data_header_(&lun,&recipFloatScaleFactor,&img_bkg,
			       &img_min,&img_max,&img_avg,&img_std,
			       &numCols,&numRows,&numSecs,&imgOffset,&mode,
			       &htype,
			       descriptionStr,
			       &aoverb, &map_abang,
			       &a_cell,&b_cell,
			       &c_cell, &alp, &bet,
			       &gam, &dela, &delb, &delc,
			       &a_star, &b_star, &c_star,
			       &alp_star, &bet_star, &gam_star,
			       &pixelSize,
			       t_matrix, &packRadius,
			       &binFactor, &dthe, &dphi_90, &symm,
			       &pixSizUnits, &res_out,
			       &ctfMode, &tempFactor,
			       &wiener
			       );
	
	imgOffset = 1024+512*x+numCols*numRows*numSecs*sizeof(short)*x;
	pif_write_short_image_(&lun,(short *)short_buffer,&imgOffset,
			       &numCols,&numRows,&numSecs);
      } /* For all images */
      if (short_buffer)
	free(short_buffer);  /* Be nice and free the memory when done */
    } /* If map2pif */
  else 
    { /* If pif2map */
      if(strrchr(argv[2],'.')==0)
	sprintf(infilename,"%s.pif",argv[2]);
      else sprintf(infilename,"%s",argv[2]);
      if(strrchr(argv[1],'.')==0)
	sprintf(outfilename,"%s.map",argv[1]);
      else sprintf(outfilename,"%s",argv[1]);
      /* Read the PIF */
#ifdef VMS
      fileName.addr = (char *)calloc(strlen(infilename),sizeof(char));
      strcpy(fileName.addr,infilename);
      fileName.length = strlen(infilename);
      fileName.type = 14;
      fileName.class = 1;
      pif_open_vms_(&fileName,&lun,"r");
#else 
      pif_open_(infilename,&lun,"r");
#endif



#ifdef  REALLY_OLD_CODE 
      pif_read_header_(&lun,&nimg,&recipFloatScaleFactor,
		       &htype,&numCols,&numRows,&numSecs,&mode,
		       &endianNess,versionStr);
      sprintf(floatScaleStr,"%f",floatScaleFactor);
      for (x=0;x<nimg;x++) { /* For all images */
	int thisImg = x+1;
	fileName.addr = (char *)calloc(strlen(outfilename),sizeof(char));
	imgOffset = 512+x*512+x*numCols*numRows*numSecs*sizeof(short);
#ifdef ORIG_WAY
	pif_read_image_header_(&lun,&thisImg,&recipFloatScaleFactor,
			       &img_bkg,&img_min,&img_max,&img_avg,&img_std,
			       &numCols,&numRows,&numSecs,&imgOffset,&mode,
			       &htype,&descriptionStr);
#endif /* #ifdef ORIG_WAY */
	
	pif_read_data_header_(&lun,&thisImg,&recipFloatScaleFactor,
			      &img_bkg,&img_min,&img_max,&img_avg,&img_std,
			      &numCols,&numRows,&numSecs,&imgOffset,&mode,
			      &htype,descriptionStr,
			      &aoverb, &map_abang,
			      &a_cell,&b_cell,
			      &c_cell, &alp, &bet,
			      &gam, &dela, &delb, &delc,
			      t_matrix,
			      &binFactor, &dthe, &dphi_90, &symm
			      );
	printf("desc[%s]\n",descriptionStr);

	if(binFactor==2)
	  {/* We've got this binned down on disk */
	    numCols = (numCols/2)+1;
	    numRows = (numRows/2)+1;
	    numSecs = (numSecs/2)+1;
	    if((numCols % 2)==0)
		numCols--;
	    if((numRows % 2)==0)
	      numRows--;
	    if((numSecs % 2)==0)
	      numSecs--;
	  }/* We've got this binned down on disk */

	imgOffset = 1024+x*512+x*numCols*numRows*numSecs*sizeof(short);
	
	/* We have to allocate this here since pif_read_short_image_ 
	   doesn't allocate space for the short_buffer */
	short_buffer = (short *)malloc(sizeof(short)*numCols
				       *numRows*numSecs*nimg);
	pif_read_short_image_(&lun,(short *)short_buffer,&imgOffset,
			      &numCols,&numRows,&numSecs);
	/* No - we shoudl just believe the stats we read from the disk
	   as that's done in "float" space. 
	   calcMapShortStats((short *)short_buffer,&img_bkg,
	   &img_min,&img_max,&img_avg,&img_std,numCols,numRows,
	   numSecs);  */
	/* Clean this up - what exactly is recipFSF??? */
	map_scalef = recipFloatScaleFactor;
	recipFloatScaleFactor = 1.0 / map_scalef;
	floatScaleFactor = 1.0 / recipFloatScaleFactor;
	/* OBSOLETE??? 
	calcShortScaleFactor(&map_scalef,&floatScaleFactor,img_min,
			     img_max,img_avg,img_std);
			     */
	/* Adjust these for scaling factor */
	printf("float[%f]recip[%f]mapscalef[%f]\n",floatScaleFactor,
	       recipFloatScaleFactor,map_scalef);
	map_min = (float)(img_min * recipFloatScaleFactor);
	map_max = (float)(img_max * recipFloatScaleFactor);

	printf("map_min[%f] map_max[%f]\n",map_min,map_max);
      } /* For all images */
#endif /* REALLY_OLD_CODE */

      thisHead.luNum = lun;
      pif_read_gh_(&thisHead);
      if(thisHead.mode != 20)
	{/* Error */
	  printf("Error - not a PIF MAP file. [%d]\n",thisHead.mode);
	  exit(0);
	}/* Error */

      thisHead.imgNum = 1;
      pif_read_dh_(&thisHead);
      map_scalef = recipFloatScaleFactor= thisHead.recipFloatScaleFactor;
      floatScaleFactor = 1.0 / recipFloatScaleFactor;

      img_bkg  = thisHead.img_bkg;
      img_avg  = thisHead.datar4_avg;
      img_std  = thisHead.datar4_std;
      numCols    = thisHead.numCols;
      numRows    = thisHead.numRows;
      numSecs    = thisHead.numSecs;
      imgOffset  = thisHead.imgOffset; 
      htype      = thisHead.htype; 
      aoverb     = thisHead.aoverb; 
      map_abang  = thisHead.map_abang;
      a_cell     = thisHead.a_cell;
      b_cell     = thisHead.b_cell;
      c_cell     = thisHead.c_cell; 
      alp        = thisHead.alp; 
      bet        = thisHead.bet; 
      gam        = thisHead.gam; 
      dela       = thisHead.dela; 
      delb       = thisHead.delb; 
      delc       = thisHead.delc;
      binFactor  = thisHead.binFactor;
      dthe       = thisHead.dthe; 
      dphi_90    = thisHead.dphi_90; 

      if(binFactor==2)
	{/* We've got this binned down on disk */
	  numCols = (numCols/2)+1;
	  numRows = (numRows/2)+1;
	  numSecs = (numSecs/2)+1;
	  if((numCols % 2)==0)
	    numCols--;
	  if((numRows % 2)==0)
	    numRows--;
	  if((numSecs % 2)==0)
	    numSecs--;
	  }/* We've got this binned down on disk */
      
      imgOffset = 1024;
      
      /* We have to allocate this here since pif_read_short_image_ 
	   doesn't allocate space for the short_buffer */
      short_buffer = (short *)malloc(sizeof(short)*numCols
				       *numRows*numSecs);
      pif_read_short_image_(&lun,(short *)short_buffer,&imgOffset,
			    &numCols,&numRows,&numSecs);
      
      map_min =  map_max = 0.0;
      for(i=0;i<numSecs;i++)
	{
	  int yOff;
	  for(j=0;j<numRows;j++)
	    {
	      yOff = (i*numCols*numRows)+(j*numCols);
	      for(k=0;k<numCols;k++)
		{
		  map_min = MIN(map_min,(float)short_buffer[yOff+k]);
		  map_max = MAX(map_max,(float)short_buffer[yOff+k]);
		}
	    }
	}
      map_min *= recipFloatScaleFactor;
      map_max *= recipFloatScaleFactor;
      printf("map_min[%f] map_max[%f]\n",map_min,map_max);

      /* Write the MAP */
#ifdef OLDWAY
      write_MAP(outfilename); 
#else
      write_MAP_Fortran(outfilename, map_min, map_max); 
#endif
      if (short_buffer)
	free(short_buffer);  /* Be nice and free the memory when done */
    } /* If pif2map */
  return(1);
} /* End Main */

