

/*******************************************************************
 * Dumps MAP files in ASCII 
 *******************************************************************/

#include <string.h>
#include <stdio.h>                              /* For printf and so on. */
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <unistd.h>
#ifdef VMS
#include <processes.h>
#endif


#include "../libr/libPIF.h"

pifHead_t pifHead;

#define MAP 7
#define TRUE 1
#define FALSE 0



/************************************************************************
 * OS transfer point.  The main routine does all the one-time setup and *
 * then calls XtAppMainLoop.                                            *
 ************************************************************************/
unsigned int main(argc, argv)
int argc;                           /* Command line argument count. */
char *argv[];                       /* Pointers to command line args. */
{/* MAIN */
  int n,choice,name,i,j,emWrt,numSecs,k,l,m,nCol,nRow;
  char fname[256];
  int       binCol,binRow,binSec;
  fString_t fName,readWrite;
  int       luNum,binFactor, binSwitch;
  char      inFile[128],outFile[128];
  float     *float_buffer;
  forPifHead_t  thisHead;


  if(argc < 2)
    {/* usage */
      printf("USAGE:  mapdump pifMapFile.pif  \n\n");
      exit(0);
    }/* usage */

  sprintf(inFile,argv[1]);
  fName.addr = (char *)malloc(sizeof(char)*64);
  readWrite.addr = (char *)malloc(sizeof(char)*12);
  sprintf(fName.addr,inFile);
  sprintf(readWrite.addr,"r");
  i= thisHead.luNum = 4;
#ifdef VMS
  pif_open_vms_(&fName, &i, readWrite.addr);
#else
  pif_open_(fName.addr, &i, readWrite.addr);
#endif

  pif_read_gh_(&thisHead);
  thisHead.imgNum = 1;
  pif_read_dh_(&thisHead);

  if(thisHead.mode != 20)
    {/* Error */
      printf("mapdump for PIFmap files only.\n");
      exit(0);
    }/* Error */

  if(thisHead.binFactor==2)
    {/* 1/2 */
      binSec  = thisHead.numSecs/2+1;  
      binRow  = thisHead.numRows/2+1;
      binCol  = thisHead.numCols/2+1;
      if((binSec%2)==0)
	binSec--;
      if((binRow%2)==0)
	binRow--;
      if((binCol%2)==0)
	binCol--;
    }/* 1/2 */
  else
    {/* Normal */
      binCol = thisHead.numCols;
      binRow = thisHead.numRows;
      binSec = thisHead.numSecs;
    }/* Normal */

  float_buffer = (float *)malloc(sizeof(float)*binCol*binRow*binSec);
	
  thisHead.datar4_min = thisHead.datar4_max = 0.0;
  pif_read_wmapi2_(&thisHead, float_buffer, &binCol, &binRow, &binSec);
  
  numSecs = binSec;
  nRow    = binRow;
  nCol    = binCol;

  for(m=0;m<numSecs;m++)
    {/* Sec */
      printf("Section Number: [%d]\n\n",m);
      for(k=0;k<nRow;k++)
	{/* row */
	  printf("\nRow Number: [%d]\n",k);
	  for(l=0;l<nCol;l++)
	    {/* Print all */
#ifdef DOZEROS
	      if(float_buffer[((m*nCol*nRow)+(k*nCol)+l)] != 0.0){}
#endif
	      if(TRUE)
		{/* DO it */
#ifdef OLDWAY
		  printf("s[%3d]r[%3d]c[%3d] - %f\n");
#endif
		  printf("%5.2f\t",
			 float_buffer[((m*nCol*nRow)+(k*nCol)+l)]);
		  if(l>2 && (((l+1)%10)==0))
		    printf("\n");
		}/* DO it */
	    }/* Print all */
	}/* row */

    }/* Sec */

}/* MAIN */


