/* File pck2bp.c */

#define VERSION "1.01_970707"

#include "libr$dev:convertlib.h"




/********************************
 *    MAIN                      *
 ********************************/

int main(int argc, char **argv)
{/* MAIN */
  FILE *fIn;
  int i,j,toggle;

  if(argc<2)
    {/* usage */
      printf("Usage: pck2bp pckFile bpFileRoot\n\n\
         e.g.  pck2bp myFile.pck myBPfile    !(Note: no extension on BP)\n\
\n\
        Options:\n\
              -float        Float data before writing BP\n\
\n");
      exit(0);
    }/* usage */
  else
    {/* get from command line */
      /* Check for -REVERSE switch */
      largeSwitch= reverseSwitch= bpSwitch= endianSwitch= odSwitch= FALSE;

      for(i=0;i<argc;i++)
	{/* Look at all of them */
	  if(strcmp(argv[i],"-LARGE")==0 ||
	     strcmp(argv[i],"-large")==0 )
	    largeSwitch= TRUE;
	  else if(strcmp(argv[i],"-BPFILE")==0 ||
		  strcmp(argv[i],"-bpfile")==0 )
	    bpSwitch= TRUE;
	  else if(strcmp(argv[i],"-OD")==0 ||
		  strcmp(argv[i],"-od")==0 )
	    odSwitch= TRUE;
	  else if(strcmp(argv[i],"-ENDIAN")==0 ||
		  strcmp(argv[i],"-endian")==0 )
	    endianSwitch= TRUE;
	  else if(strcmp(argv[i],"-FLOAT")==0 ||
		  strcmp(argv[i],"-float")==0 )
	    floatSwitch= TRUE;
	  else if(strcmp(argv[i],"-REVERSE")==0 ||
		  strcmp(argv[i],"-reverse")==0 )
	    reverseSwitch= TRUE;
	}/* Look at all of them */
      
      if(reverseSwitch)
	{/* Reverse these */
	  sprintf(inFilename,argv[2]);
	  sprintf(outFilename,argv[1]);
	}/* Reverse these */
      else
	{/* normal */
	  sprintf(inFilename,argv[1]);
	  sprintf(outFilename,argv[2]);
	}/* normal */

    }/* get from command line */


  fileName.addr = (char *)calloc(64,sizeof(char));  
  fileName.length = 64;
  fileName.type = 14;
  fileName.class = 1;

  fIn= fopen(inFilename,"r");
  if(!fIn)
    {/* Error in open */
      printf("Can't open [%s]\n",inFilename);
      exit(0);
    }/* Error in open */
  
  /* What kind of file have we got here??? */
  determineFileType(fIn);
      
  
  if(fileType==PACKED)
    {/* Old purdue packed */
      readPacked(fIn);
      calcStats(byte_buffer, &img_bkg, &img_min,
		&img_max, &img_avg, &img_std,
		numCols,numRows,FALSE);
    }/* Old purdue packed */
  else
    {/* Error */
      printf("Infile must be packed format.\n\n");
      exit(0);
    }/* Error */

  fclose(fIn);
  
  writeBPfile(outFilename);
  
      
  if(fileType==PACKED)
    free(byte_buffer); 

  
}/* MAIN */





/* End of File pck2bp.c */
