/* file pck2bp.h */

#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>


#define MAX(x,y)  (((x)>(y)) ? (x) : (y))  
#define MIN(x,y)  (((x)<(y)) ? (x) : (y))

#define TRUE 1
#define FALSE 0

#define MAXINT 2147483647  
#define MAXIMAGES 2000  

typedef unsigned char BYTE; 

typedef struct __fortran_Strings__
  {/* FORTRAN_STRINGS */
    short  length;
    BYTE   type;
    BYTE   class;
    char   *addr;
  }/* FORTRAN_STRINGS */ fString_t;

typedef struct __tifTag_t__
  {/* tifTag_t */
    int    tagid;
    int    dataType;
    int    dataCount;
    int    dataOffset;
  }/* tifTag_t */ tifTag_t;

/* Struct for Purdue INT*2 file header */
typedef struct _purdueHead_t
  {/* PURDUEHEAD_T */
    short numCols,numRows;
    short img_bkg;
    int   nimg,nrec_last;
    int   bimg_sizes;
    int   img_min,img_max;
    float img_avg,img_std;
    int   file_id1, file_id2;
    short junk;
  }/* PURDUEHEAD_T */ purdueHead_t;



fString_t fileName;                 /* What file do they want? */

extern void exit();
extern void *malloc();
extern void *calloc();
extern double strtod();
extern double sqrt();

extern void img_stats();
extern void img_write();

extern void free();

extern void mainEmimg_sub(); 
extern void img_write_recl_open_rob();
extern void read_bp(); 
extern void write_bp(); 
extern void open_bp(); 


#define IMAGE              32   /* Keep these off the same bits so we can   */
#define PACKED             64   /* bitwise AND them (&)                     */
#define ALL                2
#define MAP                16
#define PORTABLE           128
#define PACKEDPORTABLE     4    /* NOT the same as PACKED here */
#define TIFF               8
#define BP                 9

int intNcol, intNrow, lun;
int readSize,writeSize,em_wrt,choice;

int endianSwitch,bpSwitch,odSwitch,floatSwitch;
int reverseSwitch,largeSwitch;
int fileType;


float floatScaleFactor;
float recipFloatScaleFactor;

float junkFloat;

int   ncol,nrow,img_min,img_max,img_bkg;
int backGrounds[MAXIMAGES];
int imgMins[MAXIMAGES],imgMaxs[MAXIMAGES];
float img_avg,img_std;
float imgAvgs[MAXIMAGES],imgStds[MAXIMAGES];
int nimg,nrec_last,bimg_sizes,asked;
int inHeight,inWidth,maxInWidth;
int headOff,thisOffset;

BYTE *byte_buffer;
unsigned short *short_buffer;

int rec_length, nrecords, nrows_per_record;
int nrecords_per_row, numRecs, recLength, totLength;
int mrc_nx, mrc_ny, mrc_nz, mrc_mode;
int mrc_nxstart, mrc_nystart, mrc_nzstart;
int mrc_mx, mrc_my, mrc_mz, mrc_mapc, mrc_mapr, mrc_maps;
int mrc_ispg, mrc_nsymbt;
int mrc_extra[29], mrc_nlabl, mrc_label[20][10], mrc_rec;
int    mrc_xlength, mrc_ylength, mrc_zlength;
int    mrc_alpha, mrc_beta, mrc_gamma;
int    mrc_min, mrc_max, mrc_mean, mrc_std, mrc_xorigin, mrc_yorigin;
float    rows_per_record, records_per_row;
char inFilename[164],outFilename[128];


/* Tiff file parameters */
int bitsPerSample, compression, pmi, orientation, samplesPerPixel,
  planarConfig, tileWidth,tileLength, tileOffsets,tileByteCounts;
int tileByteCountsType;
int tilesInImage,tilesAcross,tilesDown;



/* End of file pck2bp.h */





