
#define VERSION 1.0000000
#include <ctype.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#ifdef VMS
#include "libr$dev:convertlib.h"
#else
#include "../libr/convertlib.h"
#endif

BYTE *apx_buffer;

int main(int argc,char **argv) {
  FILE *fp;
  char infilename[80],outfilename[80];
  int mode;
  int x;
  fString_t descriptorStr;
  forPifHead_t thisHead;
  int expandFactor,beginR512,beginC512;
  int i,j,k,l;
  BYTE tmpB;

  if (argc!=3) {
    printf ("Usage: pif2axp piffile axpfile\n");
    exit(0);
  }       
  sprintf(infilename,"%s",argv[1]);
  sprintf(outfilename,"%s",argv[2]);
  thisHead.luNum = lun = 4;
  #ifdef VMS 
	fileName.addr = (char *)calloc(strlen(infilename),sizeof(char));
	strcpy(fileName.addr,infilename);
	fileName.length = strlen(infilename);
	fileName.type = 14;
	fileName.class = 1;
	pif_open_vms_(&fileName,&lun,"r");
  #else 
	pif_open_(infilename,&lun,"r");
  #endif

  pif_read_gh_(&thisHead);

  /*if (lun==0) {
    printf ("Error opening file %s\n",infilename);
    exit(0);
  } */
  printf ("Entering read_pif with %s\n",infilename);
/*
  pif_read_header_(&lun,&nimg,&floatScaleFactor,&recipFloatScaleFactor,
		&htype,&numCols,&numRows,&numSecs,&mode,&endianNess,
		versionStr);
*/

  nimg = thisHead.nimg;
  numCols = thisHead.numCols;
  numRows = thisHead.numRows;
  numSecs = thisHead.numSecs;
  printf("nimg=[%d][%d][%d]\n",nimg,numRows,numCols);
  printf("nimg,nc,nr,ns=[%d][%d][%d][%d]\n",nimg,numRows,numCols,numSecs);
  byte_buffer = (BYTE *)malloc(sizeof(BYTE)*numRows*numCols*nimg);

  for (x=0;x<1;x++) 
    { /* For all images */
      int thisImg = x+1;
      
      thisHead.imgNum = x+1;
      pif_read_dh_(&thisHead);
      /*
	 imgOffset = 512+x*512+x*numCols*numRows*numSecs*sizeof(BYTE);
	 pif_read_image_header_(&lun,&thisImg,&recipFloatScaleFactor,
	 &img_bkg,&img_min,&img_max,&img_avg,&img_std,
	 &numCols,&numRows,&numSecs,&imgOffset,&mode,
	 &htype,&descriptorStr);
	 */
      imgOffset = 1024+(x*512)+(x*numCols*numRows*numSecs*sizeof(BYTE));
      printf("imgOffset=[%d]  lun[%d]\n",imgOffset,lun);
      pif_read_byte_image_(&lun,byte_buffer,&imgOffset,&numCols,
			   &numRows,&numSecs);
    } /* For all images */

  pif_close_(&thisHead.luNum);

  printf ("Entering write apx with %s\n",outfilename);
  /* write_apx(outfilename,mode); */
  /* APX is defined as a 512 x 512 BYTE buffer on the disk - no header */

  apx_buffer = (BYTE *)malloc(512*512*sizeof(BYTE));

  expandFactor = (int)(512 / numCols);
  if(expandFactor < 1)
    expandFactor = 1;
  beginR512 = 256 - (int)((float)((float)(numRows * expandFactor) / 2.0));
  beginC512 = 256 - (int)((float)((float)(numCols * expandFactor) / 2.0));
  for(i=0;i<numRows;i++)
    {/* rows */

      for(j=0;j<numCols;j++)
	{/* cols */
	  for(k=0;k<expandFactor;k++)
	    {/* expand it */
	      for(l=0;l<expandFactor;l++)
		{/* expand it */
		  apx_buffer[(
			      ((beginR512+(i*expandFactor)+k)*512) +
			      (beginC512+(j*expandFactor)+l)
			      )
			     ] =
			       byte_buffer[((i*numCols)+j)];
		}/* expand it */
	    }/* expand it */
	    
	}/* cols */

    }/* rows */

  /* Now flip it from TSB row order */
  for(i=0;i<256;i++)
    {
      for(j=0;j<512;j++)
	{/* Switch rows */
	  tmpB = apx_buffer[((512-i)*512)+j];
	  apx_buffer[((512-i)*512)+j] = 
	      apx_buffer[(i*512)+j] ;
	  apx_buffer[(i*512)+j] = tmpB;
	}/* Switch rows */
    }
  numCols = numRows = 512;
  
  lun = 8;
  nimg = 1;
  htype = 1; 
  mode = 0;  /* Let's make these scanned image type */
  mode = 6;  /* Let's make these packed image type */
  floatScaleFactor = 1.0; recipFloatScaleFactor = 1.0;

  /* If the image is the first than create a new file and write output */
  /* to that file */
#ifdef VMS
  fileName.addr = (char *)calloc(strlen(outfilename),
				    sizeof(char));
  strcpy(fileName.addr,outfilename);
  fileName.length = strlen(outfilename);
  fileName.type = 14;
  fileName.class = 1;
  pif_open_vms_(&fileName,&lun,"w");
#else
  pif_open_(outfilename,&lun,"w");
#endif
  imgOffset = 0;
  numSecs=1;
  pif_write_byte_image_(&lun,apx_buffer,&imgOffset,&numCols,
			&numRows,&numSecs);


  return(1);

}/* MAIN */  
