/* ppp2pck.c */
/* *********************************************************** *
 *
 * Program to convert Purdue Portable Packed images generated
 * in UNIX environemtn into VMS .pck packed image format for
 * compatibility with exisiting VMS FORTRAN code.
 *
 * *********************************************************** */

#include "ppp2pck.h"


/*********************************************************
 * usage() - Tell them how to use the program.
*/
static void usage()
{/* USAGE */

  printf("ppp2pck inPut-PPP-filename  outPut-PCK-filename\n");
  exit(0);

}/* USAGE */




/********************************
 *   MAIN                       *
 ********************************/
unsigned int main(argc, argv)
int argc;                           /* Command line argument count. */
char *argv[];                       /* Pointers to command line args. */
{/* MAIN */
  int n;
  FILE *fIn,*fOut;
  int file_id,numImages,lastRecord,bimg_sizes;
  char s1[1024];
  unsigned char *char_image_buffer;


  /* First see if they've got enough args */
  if(argc<3)
    usage();

  /* Let's do this in a FORTRAN descriptor in case we need to
   * call any FORTRAN routines.
   */
  fileName.addr = (char *)calloc(64, sizeof(char));  
  fileName.length = 64;

  fileName.type = 14;
  fileName.class = 1;

  /* Open the input file */
  fIn= fopen(argv[1],"r");
  if(fIn==NULL)
    {/* Error */
      printf("Error opening input file [%s]\n",fileName.addr);
      exit(0);
    }/* Error */

  fread(&file_id,sizeof(int),1,fIn);
printf("file_id=[%d]\n",file_id);
  fread(&file_id,sizeof(int),1,fIn);
printf("file_id=[%d]\n",file_id);
  
  if(file_id != -64)
    {/* Bad karma */
      printf("Invalid file type [%d]\n",file_id);
      exit(0);
    }/* Bad karma */

  fread(s1,sizeof(char),504,fIn);

  fread(&numImages,sizeof(int),1,fIn);
  fread(&lastRecord,sizeof(int),1,fIn);

  fread(&bimg_sizes,sizeof(int),1,fIn);

  fread(s1,sizeof(char),500,fIn);

  char_image_buffer= (unsigned char *)malloc((lastRecord*512)*sizeof(char));

  fread(char_image_buffer,sizeof(char),(lastRecord*512),fIn);
  fclose(fIn);

  /* Give them some feedback */
  printf("NumImages[%d]  lastRecord[%d]  bimg_sizes[%d]\n",
	 numImages,lastRecord,bimg_sizes);


  /* Now for the outfile */
  sprintf(fileName.addr,"%s",argv[2]);

#ifdef OLDWAY
  fOut= fopen(fileName.addr,"w","RFM=FIX","BLS=512");
  fOut= fopen(fileName.addr,"w","RFM=FIX","BLS=512");
#endif
  fOut= fopen(fileName.addr,"w","RFM=FIX","RAT=NONE","MRS=512");
  if(fOut==NULL)
    {/* Error */
      printf("Error opening output file [%s]\n",fileName.addr);
      exit(0);
    }/* Error */
  printf("Writing output [%d]\n",fOut);

  fseek(fOut,0,0);
  file_id = -10;
  fwrite(&file_id,sizeof(int),1,fOut);
  fwrite(&file_id,sizeof(int),1,fOut);

  fseek(fOut,512,0);
  fwrite(&numImages,sizeof(int),1,fOut);
  fwrite(&lastRecord,sizeof(int),1,fOut);
  fwrite(&bimg_sizes,sizeof(int),1,fOut);

  for(i=0;i<(lastRecord);i++)
    {/* Do all records */
      fseek(fOut,((i+2)*512),0);
      fwrite((char_image_buffer+(i*512)),sizeof(char),512,fOut);
      printf("[%d]  ",i);
    }/* Do all records */

  printf("\n\n");

  fclose(fOut);

}/* MAIN */






