/* sf2pif - Convert PIF format Structure Factor files to old TSB
 * Structure Factor files.
 *
 * This program is modelled after the format of MAVIS.SF and probably
 * will need to be "hacked" to make it work on other data sets.
 *  
 * Need to hack this EVERY time to get it to work - look at the 
 * read statements to get it working right. 
 *  
 * July 2003  Added the concept of a '~/.sf2pifrc' file to help figure
 * out what the field lengths and positions are.
 *
 *  
 * Rob Ashmore
 * Purdue University
 * November 1998
*/

#ifdef VMS
#include "libr$dev:libPIF.h"
#else
#include "../libR/libPIF.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

char inStr[256];
char outStr[256];

int starts[100],fins[100];

#define VERSION "1.0_20010606"

/*********************************************************
 * get_str() - Get a string of ascii characters.  Allocate
 * any storage necessary here locally.  Trash any leading
 * white space found.  Also trash any trailing WS.
*/
void get_str(flptr, brkchr, string, leadWhiteSpace)
  FILE *flptr;
  char brkchr;
  char *string;
  int leadWhiteSpace;
{/* GET_STR */
  char ans;
  char *s1;
  
  ans= ' ';
  if(leadWhiteSpace)
    {/* get rid of leading white space */
      while(!feof(flptr) && ans==' ')
	ans= fgetc(flptr);         /* Eat the white space */
    }/* get rid of leading white space */
  s1= string;
  while(!feof(flptr) && (ans!='\n' && ans!=brkchr))
    {/* Get the string */
      *(s1++)= ans;
      ans= fgetc(flptr);
    }/* Get the string */
  while((*(s1-1)==' ' || *(s1-1)=='\t') && s1 > string)
    s1--;
  *s1= '\0';                   /* Terminate the string */

}/* GET_STR */


/*****************************************************************
 * subStr() -
*/
void subStr(char *inStr, char *outStr, int strt, int end)
{/* SUBSTR */
  int i,j,k,lngth,tot;

  lngth = strlen(inStr);
  tot = 0;
  for(i=strt;i<=end;i++)
    {/* Do all */
      if(i < lngth)
	{/* OK */
	  outStr[tot] = inStr[i];
	}/* OK */
      else
	{
	  outStr[tot] = '\0';
	}
      tot++;

    }/* Do all */

  outStr[tot] = '\0';

}/* SUBSTR */





void main(int argc, char **argv)
{/* MAIN */
  int i,j,pifMode,tot;
  int h, k, l;
  float tmp1, tmp2;
  forPifHead_t sfHeader;
  fString_t rWrite,outFileName;
  float astar,bstar,cstar,absMax;
  char inpifFile[256];
  strucFact_t *stFacs;
  int thisImg;
  FILE *fIn,*fRC;
  char fStr[1024];

  if(argc < 3)
    {/* usage */
      printf("USAGE:  sf2pif inputSFfile.sf outputPIFfile.pif <astar>\n");
      exit(0);
    }/* usage */

  banner("sf2pif");
  printf("Converting [%s] to [%s] ...\n",argv[1],argv[2]);

  sprintf(fStr,"%s/.sf2pifrc",getenv("HOME"));
  fRC = fopen(fStr,"r");
  if(fRC)
    {/* open */
      int tot;
      tot = 0;
      printf("Reading init file.\n");
      while(!feof(fRC))
	{
	  get_str(fRC, ' ', inStr, TRUE);
	  starts[tot] = (int)strtod(inStr,0);
	  get_str(fRC, '\n', inStr, TRUE);
	  fins[tot] = (int)strtod(inStr,0);
	  tot++;
	}
      fclose(fRC);
    }/* open */
  else
    {/* init */
      printf("NO init file.\n");
      starts[0] = 0;
      fins[0]   = 5;
      starts[1] = 6;
      fins[1]   = 10;
      starts[2] = 11;
      fins[2]   = 15;
      starts[3] = 16;
      fins[3]   = 25;
      starts[4] = 26;
      fins[4]   = 35;
    }/* init */

  /* Now read the inpifFile */
  sprintf(inpifFile,argv[1]);
  fIn = fopen(inpifFile,"r");

  pif_init_head_(&sfHeader);

  /* Initialize for  */
  if(argc<=3)
    {/* init */
      astar =  bstar = cstar = 0.002157; 
    }/* init */
  else
    {/* get it */
      astar =  bstar = cstar = (float)strtod(argv[3],0); /* 0.002157; */
    }/* get it */
  printf("astar [%f]\n",astar);

  tot = 0; 
  absMax = 99.9; /* For 90 degree angles */
  if(fIn)
    {/* OK to read */

      /*

      fprintf(fIn,"          2\n");
      fprintf(fIn," \n");
      fprintf(fIn,"          1           3\n");
      fprintf(fIn,"    0     0     0     0     0     0\n");
      fprintf(fIn,"%9.6f %9.6f %9.6f %9.4f %9.4f %9.4f\n",
	      astar,bstar,cstar,90.0,90.0,90.0);
      fprintf(fIn,"%9.6f %9.6f %9.6f %9.4f %9.4f %9.4f\n",
	      0.0,0.0,0.0,0.0,0.0,0.0);
      fprintf(fIn,"%9.4f %9.4f %9.4f\n",
	      0.0,0.0,1.0);
      */

      while(!feof(fIn))
	{/* REad all */

	  for(i=0;i<128;i++)
	    {
	      inStr[i] = outStr[i] = '\0';
	    }

	  get_str(fIn, '\n', inStr, FALSE);

#ifdef TOM_WAY_1
	  subStr(inStr,outStr,0,5);
	  h = (int)strtod(outStr,0);
	  subStr(inStr,outStr,6,10);
	  k = (int)strtod(outStr,0);
	  subStr(inStr,outStr,11,15);
	  l = (int)strtod(outStr,0);

	  subStr(inStr,outStr,16,25);
	  tmp1 = (float)strtod(outStr,0);
	  subStr(inStr,outStr,26,35);
	  tmp2 = (float)strtod(outStr,0);
#endif /*ifdef TOM_WAY_1*/

	  subStr(inStr,outStr,starts[0],fins[0]);
	  h = (int)strtod(outStr,0);
	  subStr(inStr,outStr,starts[1],fins[1]);
	  k = (int)strtod(outStr,0);
	  subStr(inStr,outStr,starts[2],fins[2]);
	  l = (int)strtod(outStr,0);

	  subStr(inStr,outStr,starts[3],fins[3]);
	  tmp1 = (float)strtod(outStr,0);
	  subStr(inStr,outStr,starts[4],fins[4]);
	  tmp2 = (float)strtod(outStr,0);


	  if((h!=0) ||
	     (k!=0) ||
	     (l!=0) ||
	     (tmp1 != 0.0) ||
	     (tmp2 != 0.0))
	    tot++;

	}/* REad all */

      sfHeader.numRows = tot;
      stFacs = (strucFact_t *)malloc(sizeof(strucFact_t)*sfHeader.numRows);

      rewind(fIn);
      for(i=0;i<tot;i++)
	{/* REad all */

	  for(j=0;j<128;j++)
	    {
	      inStr[j] = outStr[j] = '\0';
	    }

	  get_str(fIn, '\n', inStr, FALSE);

#ifdef TOM_WAY_1
	  subStr(inStr,outStr,0,5);
	  h = (int)strtod(outStr,0);
	  subStr(inStr,outStr,6,10);
	  k = (int)strtod(outStr,0);
	  subStr(inStr,outStr,11,15);
	  l = (int)strtod(outStr,0);

	  subStr(inStr,outStr,16,25);
	  tmp1 = (float)strtod(outStr,0);
	  subStr(inStr,outStr,26,35);
	  tmp2 = (float)strtod(outStr,0);
#endif  /*ifdef TOM_WAY_1 */

	  subStr(inStr,outStr,starts[0],fins[0]);
	  h = (int)strtod(outStr,0);
	  subStr(inStr,outStr,starts[1],fins[1]);
	  k = (int)strtod(outStr,0);
	  subStr(inStr,outStr,starts[2],fins[2]);
	  l = (int)strtod(outStr,0);

	  subStr(inStr,outStr,starts[3],fins[3]);
	  tmp1 = (float)strtod(outStr,0);
	  subStr(inStr,outStr,starts[4],fins[4]);
	  tmp2 = (float)strtod(outStr,0);

	  stFacs[i].h= h;
	  stFacs[i].k= k;
	  stFacs[i].l= l;
	  stFacs[i].a_amp= tmp1/100000.0;
	  stFacs[i].b_phi= tmp2;
	  stFacs[i].sig = 0.0;
	  stFacs[i].dstr= sqrt((h*h + k*k + l*l)*astar*astar);
          
          absMax = MAX(absMax,fabs(stFacs[i].a_amp));
          absMax = MAX(absMax,fabs(stFacs[i].b_phi));

	  if((i % 10000)==0)
	    printf("[%d]\n", i);

	  if(
	     (i > (tot-20)) ||
	     (i < (20))
	     )
	    {/* Just print the last ones to check it */

	      printf("[%d] %d %d %d %f %f\n",
		     i,h,k,l,tmp1,tmp2);

	    }/* Just print the last ones to check it */

	}/* REad all */

    }/* OK to read */
  printf("\n");
  fclose(fIn);



  i= 4;
  sfHeader.luNum = i;
  rWrite.addr = malloc(sizeof(char)*4);
  rWrite.length = 1;
  outFileName.addr = malloc(sizeof(char)*64);
  outFileName.length = 64;
  sprintf(rWrite.addr,"w");
  sprintf(outFileName.addr,argv[2]);

#ifdef VMS
  pif_open_vms_(&outFileName, &i, rWrite.addr);
#else
  pif_open_(outFileName.addr, &i, rWrite.addr);
#endif

  /* Initialize for mavis.sf */
  sfHeader.a_cell = astar;
  sfHeader.b_cell = bstar;     /* 0.002157; */
  sfHeader.c_cell = cstar;
  sfHeader.a_star = astar;
  sfHeader.b_star = bstar;     /* 0.002157; */
  sfHeader.c_star = cstar;
  pifMode = sfHeader.mode = 31;
  absMax = MAX(absMax,fabs((float)astar));
  sfHeader.floatScaleFactor  = (2147483648.0 / (absMax+ 2.0));
    
  pif_write_gh_(&sfHeader);

  thisImg = 1;  /* For fortran */

  sfHeader.imgNum = thisImg;
  pif_write_dh_(&sfHeader);

  pif_write_sf(&sfHeader, stFacs);

  pif_close(&(sfHeader.luNum));

  printf("Done.\n");


}/* MAIN */
