


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef unsigned char BYTE;
#define MAX(x,y)  (((x)>(y)) ? (x) : (y))  
#define MIN(x,y)  (((x)<(y)) ? (x) : (y))


void main(int argc, char **argv)
{/* MAIN */
  int i,j,k,y,x;
  FILE *fIn,*fOut;
  float scaleFactor, thisPixelFloat;
  int range,thisPixel,minOrig,maxOrig;
  BYTE int_image_buffer[(513*513)];
  char fName[256];

  if(argc<2)
    {/* usage */
      printf(
       "mkPix rangeOfDataInPixels(Use 2 character string as in 08 for 8)\n");
      exit(0);
    }/* usage */

  sprintf(fName,"lilly_rev%s.apx",argv[1]);
  range= (int)strtod(argv[1],0);
  printf("%s  %d\n",fName,range);

  fIn = fopen("lilly_rev.apx" , "r");
  fOut= fopen(fName, "w");

  minOrig = 9999;
  maxOrig = -99;

  for(y=0;y<512;y++)
    {/* DO y */
      BYTE thisBuf;
      for(x=0;x<512;x++)
	{/* do x */
	  fread(&thisBuf,sizeof(BYTE),1,fIn);
	  minOrig = MIN(minOrig,(int)thisBuf);
	  maxOrig = MAX(maxOrig,(int)thisBuf);
	  int_image_buffer[(((int)(y)*512)+(int)(x))] = 
	                                           (BYTE)(thisBuf);
	}/* do x */
    }/* DO y */
printf("max=%d  min=%d\n",maxOrig,minOrig);

  scaleFactor = ((float)range / ((float)maxOrig - (float)minOrig) );
printf("scale=%f\n",scaleFactor);

  for(y=0;y<512;y+= 2)
    {/* DO y */
      BYTE thisBuf;
      for(x=0;x<512;x+= 2)
	{/* do x */
	  thisBuf = (BYTE)((128+(range/2))-range) + (BYTE)
	    ((float)((float)(int_image_buffer[(((int)(y)*512)+(int)(x))]) -
		     (float)minOrig) * (float)scaleFactor);
	  fwrite(&thisBuf,sizeof(BYTE),1,fOut);
	  thisBuf = (BYTE)((128+(range/2))-range) + (BYTE)
	    ((float)((float)(int_image_buffer[(((int)(y)*512)+(int)(x+1))]) -
		     (float)minOrig) * (float)scaleFactor);
	  fwrite(&thisBuf,sizeof(BYTE),1,fOut);
	}/* do x */
      for(x=0;x<512;x+= 2)
	{/* do x */
	  if((y==0&&x==0)|| (y==2&&x==0))
	    {/* Special case */
	      if(y==0)
		thisBuf = 0;
	      else thisBuf= 255;
	      fwrite(&thisBuf,sizeof(BYTE),1,fOut);
	      fwrite(&thisBuf,sizeof(BYTE),1,fOut);
	    }/* Special case */
	  else 
	    {/* normal */
	      thisBuf = (BYTE)((128+(range/2))-range) + (BYTE)
		((float)((float)(int_image_buffer[(((int)(y+1)*512)+
						   (int)(x))]) -
			 (float)minOrig) * (float)scaleFactor);
	      fwrite(&thisBuf,sizeof(BYTE),1,fOut);
	      thisBuf = (BYTE)((128+(range/2))-range) + (BYTE)
		((float)((float)(int_image_buffer[(((int)(y+1)*512)+
						   (int)(x+1))]) -
			 (float)minOrig) * (float)scaleFactor);
	      fwrite(&thisBuf,sizeof(BYTE),1,fOut);
	    }/* normal */
	}/* do x */
    }/* DO y */


  fclose(fIn);
  fclose(fOut);


  /* Now check to see what out min/max is */
  fIn = fopen(fName , "r");

  minOrig = 9999;
  maxOrig = -99;

  for(y=0;y<512;y++)
    {/* DO y */
      BYTE thisBuf;
      for(x=0;x<512;x++)
	{/* do x */
	  fread(&thisBuf,sizeof(BYTE),1,fIn);
	  minOrig = MIN(minOrig,(int)thisBuf);
	  maxOrig = MAX(maxOrig,(int)thisBuf);
	}/* do x */
    }/* DO y */
printf("max=%d  min=%d\n",maxOrig,minOrig);

  fclose(fIn);

  /* Now check to see what out min/max is without 255 and 0 */
  fIn = fopen(fName , "r");

  minOrig = 9999;
  maxOrig = -99;

  for(y=0;y<512;y++)
    {/* DO y */
      BYTE thisBuf;
      for(x=0;x<512;x++)
	{/* do x */
	  fread(&thisBuf,sizeof(BYTE),1,fIn);
	  if(thisBuf > 0 && thisBuf < 255)
	    {/* Use for max/min */
	      minOrig = MIN(minOrig,(int)thisBuf);
	      maxOrig = MAX(maxOrig,(int)thisBuf);
	    }/* Use for max/min */
	}/* do x */
    }/* DO y */
printf("max=%d  min=%d\n",maxOrig,minOrig);

  fclose(fIn);



}/* MAIN */
