

C  ****************************************************************************
C  *                                                                          *
C  *                      *****     EMCORORG.FOR     *****                    *
C  *                                                                          *
C  *    ROUTINE FOR IDENTIFYING THE ORIGINS OF CIRCULARLY SYMMETRIC PARTICLES.*
C  *                                                                          *
C  *    OCTOBER 1987  PURDUE UNIVERSITY VAX 11/750, T. BAKER.                 *
C  *    AUGUST 1988  PURDUE UNIVERSITY VAX 8550, T. BAKER.                    *
C  *    24-FEB-1993 BY T. BAKER.                                              *
C  *    LAST MODIFIED 12-NOV-2003 BY RWA - Port to Linux                      *
C  ****************************************************************************
C
	IMPLICIT NONE
C
	COMMON /CORORG_COM/ RES_MIN, RES_MAX, GRAPHICS, SAVEDATA,
	1                   BATCH, X_SHIFT, Y_SHIFT
	INTEGER*4 IOPT, I
	REAL*4    RES_MIN, RES_MAX, X_SHIFT, Y_SHIFT
	LOGICAL   GRAPHICS, SAVEDATA, BATCH, YESNO
C  ----------------------------------------------------------------------------
C
	call banner("emcororg\0")
	PRINT *, 'EMCORORG: Identify highest peak in cross-correlation IMAGE'
Ca	PRINT *, '          24-Feb-93 [TSB]'
	call banner ('EMCORORG\0')
  100	PRINT *
	PRINT *, '********************************************************'
	PRINT *, '* EMCORORG OPTIONS: (CC = cross-correlate)             *'
	PRINT *, '* ----------------------------------------             *'
	PRINT *, '* CC image(s) with ONE reference (e.g. an average) (1) *'
	PRINT *, '* CC image with itself, rotated by 180 degress     (2) *'
	PRINT *, '* CC image(s) with corresponding reference(s)      (3) *'
	PRINT *, '* EXIT PROGRAM                                     (4) *'
	PRINT *, '*                                                      *'
	PRINT *, '* NOTE: Option #3 ONLY WORKS in BATCH mode.            *'
	PRINT *, '********************************************************'
Ca	IF(SYS$INTERACTIVE()) THEN
	   BATCH = .FALSE.
  200	   WRITE(6,'(''$ENTER CHOICE: '')')
	   READ (5,'(I)',ERR=200) IOPT
	   IF(IOPT.GT.4 .OR. IOPT.LT.1 .OR. IOPT.EQ.3) THEN
	     CALL BELL (2)
	     PRINT *, '******************************************'
	     PRINT *, '* Only options available are 1, 2, and 4 *'
	     PRINT *, '******************************************'
	     GO TO 200
	   ENDIF
	   IF(IOPT.EQ.4) CALL TSBEND
  300	   WRITE(6,'(''$USE AUTOMATIC <CR> OR INTERACTIVE(1) PEAK
	1 IDENTIFICATION ROUTINE?: '')')
	   READ (5,'(I)',ERR=300) I
	   IF(I.NE.1) THEN
	      GRAPHICS = .FALSE.
	    ELSE
	      GRAPHICS = .TRUE.
Ca	      CALL LX_INIT (.TRUE.)
Ca	      IF(LXERR.NE.0) CALL EXIT  ! LEXIDATA NOT AVAILABLE
Ca	      CALL LX_TABINIT
Ca	      LXCUR_TYPE = 0
Ca	      LXCUR_COL  = 0
Ca	      CALL LX_CURON
	   ENDIF
	   graphics = .false.  ! Always for now - no Lexidata exists...
	   SAVEDATA = .FALSE.
	   WRITE(6,'(''$STORE REFINED ORIGINS IN EMCORORG.TMP? Y/<N>: '')')
	   CALL GET_YESNO (YESNO, .FALSE.)
	   IF(YESNO) SAVEDATA = .TRUE.
Ca	 ELSE
Ca	   EM_WRT   = 0
Ca	   BATCH    = .TRUE.
Ca	   GRAPHICS = .FALSE.		! CAN'T USE GRAPHICS IN BATCH MODE
Ca	   SAVEDATA = .TRUE.
Ca	   READ (5,'(I,4F)') IOPT, RES_MIN, RES_MAX, X_SHIFT, Y_SHIFT
Ca	ENDIF
Ca endif of sys$interactive

C
	IF(SAVEDATA) THEN
	  CLOSE (UNIT=3)
	  OPEN (UNIT=3, FILE='EMCORORG.TMP', STATUS='NEW',
	1       ACCESS='SEQUENTIAL', FORM='FORMATTED')
	ENDIF
	IF(IOPT.EQ.1 .OR. IOPT.EQ.2) CALL CORORG12 (IOPT)
	IF(IOPT.EQ.3 .AND. BATCH) CALL CORORG3
	IF(BATCH) CALL TSBEND
	GO TO 100
	END

C  ******************************************************************
C  *                                                                *
C  *            *****     SUBROUTINE CORORG12     *****             *
C  *                                                                *
C  *  Modified by T. Baker, D. Belnap  21 DEC 1993		    *
C  ******************************************************************
C
	SUBROUTINE CORORG12 (IOPT)
C
	IMPLICIT NONE
C
	INCLUDE '../libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, outHead
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, outHead
C
	COMMON /CORORG_COM/ RES_MIN, RES_MAX, GRAPHICS, SAVEDATA,
	1                   BATCH, X_SHIFT, Y_SHIFT
Ca	INTEGER*4 NCOL_AVG, NROW_AVG, BKG1, BKG2, FFT1_ADDR, FFT2_ADDR
	INTEGER*4 NCOL_AVG, NROW_AVG
	real*4    BKG1, BKG2
	INTEGER*4 NCOL1, NCOL2, NROW1, NROW2, NSEC2, EM_ERR
Ca	INTEGER*4 I, J, IMG1_ADDR, REF_ADDR, AVG_ADDR, CC_MAP
	INTEGER*4 I, J
	INTEGER*4 NCONTUR, NCONTUR_LIM, ICLIM, IDIM1, IDIM2, IOPT
	INTEGER*4 NCYCLE , ARRAY_SIZE, NPEAK, MPEAK, IREC, NLIM
	INTEGER*4 ID, IDIM1_OLD, COUNT, FFT_NFAC, NFACT
	integer*4 bimg_num1,bimg_num2,bimg_numlim,bimg_step
	real*4    img_bkg
	PARAMETER (NLIM=5000, NCONTUR_LIM = 50)
	REAL*4    PEAKS (3,NLIM), CLIM, CVALS(NCONTUR_LIM), DIV
	REAL*4    RES_MIN, RES_MAX, RES_TMP1, RES_TMP2
	REAL*4    X_SHIFT, Y_SHIFT, DX, DY
	REAL*4    MIN_OLD, MAX_OLD, THE, PHI, OME, OX, OY
	real*4    map_min,map_max,map_avg,map_std
	real*4    FFT1_ADDR(1), FFT2_ADDR(1)
	real*4    cc_map(1),fft_origx,fft_origy,fft_fzero
	LOGICAL   GRAPHICS, SAVEDATA, SAVEAVG, FIRSTIMG, NEW
	LOGICAL   MAP_REFERENCE, YESNO, BYTEDATA_IN, BATCH
	logical   fft_full, em_wrt
	CHARACTER TITLE*80, FILENAME*256, NEWFILE*256
	CHARACTER img_filename*256
	CHARACTER map_filename*256
	real*4    img1_addr(1),avg_addr(1),ref_addr(1)
	BYTE      READWRITE(4)
	DATA      CLIM, NCONTUR, SAVEAVG
	1       /150.0,      25, .FALSE./
	pointer   (img1_addr_p,img1_addr),(avg_addr_p,avg_addr)
	pointer   (fft1_addr_p,fft1_addr),(fft2_addr_p,fft2_addr)
	pointer   (ref_addr_p,ref_addr),(cc_map_p,cc_map)
	integer   malloc
C  ----------------------------------------------------------------------------
C
	NCYCLE   = 0
	FFT_NFAC = 2		     ! DOUBLES DEFAULT FFT SIZE FOR CC FUNCTION
	FIRSTIMG = .TRUE.
C  ****************************************
C  *    OPEN FIRST PARTICLE IMAGE FILE    *
C  ****************************************
Ca  275	EM_ERR = 1
Ca	IF(.NOT.BATCH) THEN 
Ca	   EM_WRT = 1
Ca	 ELSE
Ca	   EM_WRT = 0
Ca	ENDIF
  275	BYTEDATA_IN = .FALSE.

Ca	EM_wrt = 1

Ca	EM_ERR = 1
Ca	DO WHILE (EM_ERR.NE.0)
Ca	  IMG_FILENAME = ' '
Ca	  CALL IMG_OPEN (1, NCOL1, NROW1)
Ca	ENDDO

	print *, 'Enter img filename - '
	read(*,'(A)')img_filename
	IMGHEAD.LUNUM = 7			    ! UNIT FOR INPUT IMAGE FILE
	READWRITE(1) = 'r'
	id = 1
	IF(ID.EQ.1) THEN
	   CALL pif_open (IMG_FILENAME, IMGHEAD.LUNUM, READWRITE)
	   CALL pif_read_gh (IMGHEAD)
	ENDIF
	imgHead.imgNum = 1
	CALL pif_read_dh (IMGHEAD)
	nrow1 = imgHead.numRows
	ncol1 = imgHead.numCols
	img_bkg = imgHead.img_bkg
Ca   WHY do we have to do this ???
	img_bkg = 0
	bimg_numlim = imgHead.nimg
	if(imgHead.mode .ne. 46) then
	   print *, 'Must be mode==46 PIF file.'
	   call tsbend
	endif

	NEWFILE = IMG_FILENAME
	batch = .false.
	IF(FIRSTIMG) NEW = .TRUE.
Ca	BYTEDATA_IN = BYTEDATA
	BYTEDATA_IN = .true.
	IF(BYTEDATA_IN) THEN
	  BIMG_NUM1 = 1
	  BIMG_NUM2 = BIMG_NUMLIM
	  BIMG_STEP = 1
Ca	  CALL IMG_PACK_GETRANGE
	  IF(BIMG_NUM1.NE.BIMG_NUM2) THEN
	    IF(.NOT.BATCH) THEN
	       WRITE(6,'(''$COMPUTE AN AVERAGE? (STORED IN
	1 EMCORORG.AVG) Y/<N>: '')')
	       CALL GET_YESNO (SAVEAVG, .FALSE.)
	     ELSE
	       SAVEAVG = .TRUE.
	    ENDIF
	  ENDIF
	  ID = BIMG_NUM1
Ca	  CALL IMG_PACK_FIND (1, ID, NCOL1, NROW1, IREC)
Ca	  READ(1'IREC) TITLE
Ca	  WRITE(6,'(1X,A)') TITLE

	  irec = 1
	print *, ' irec=', irec

	ENDIF
C
Ca  300	EM_WRT     = 0			      ! SUPRESS FURTHER TERMINAL OUTPUT
  300	FFT_ORIGX  = NCOL1/2
	FFT_ORIGY  = NROW1/2
	BKG1       = IMG_BKG
Ca	CALL LIB$GET_VM (2*NCOL1*NROW1, IMG1_ADDR)
	img1_addr_p = malloc (4*NCOL1*NROW1)
	IF(SAVEAVG .AND. FIRSTIMG) THEN
Ca	  CALL LIB$GET_VM (2*NCOL1*NROW1, AVG_ADDR)
	  avg_addr_p = malloc (2*NCOL1*NROW1)
	  NCOL_AVG = NCOL1
	  NROW_AVG = NROW1
	ENDIF
Ca	if(bytedata_in) bytedata = .true.
Ca	CALL IMG_FILL (1, %VAL(IMG1_ADDR), NCOL1, NROW1, IREC)
Ca	call pif_read_imgi1(imgHead,img1_addr,ncol1,nrow1,id)
	imgHead.imgNum = id
	call pif_read_dh(imgHead)
	call pif_read_boxi4(imgHead,img1_addr)
	CALL FFT_SETDIM_DEF_SAME (NCOL1,NROW1,IDIM1,IDIM2,FFT_NFAC)
	IF(FIRSTIMG) THEN
	   IDIM1_OLD = IDIM1
Ca	   CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT1_ADDR)
Ca	   CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT2_ADDR)
	   fft1_addr_p = malloc (8*IDIM1*IDIM2)
	   fft2_addr_p = malloc (8*IDIM1*IDIM2)
	   RES_TMP1 = 0.0
	   RES_TMP2 = SQRT(FLOAT(IDIM1/(2*FFT_NFAC))**2.0 +
	1                  FLOAT(IDIM2/(2*FFT_NFAC))**2.0)
	 ELSE
	   IF(IDIM1.NE.IDIM1_OLD) THEN
	     CALL BELL (2)
	     PRINT *, '****************************'
	     PRINT *, '* Inconsistent IMAGE sizes *'
	     PRINT *, '****************************'
	     NCYCLE = NCYCLE - 1
	     GO TO 900
	   ENDIF
	ENDIF
C
  400	IF(BYTEDATA_IN .AND. NCYCLE.GT.0) GO TO 500
	IF(.NOT.BATCH) THEN
C         ************************************************************
C---------*    SET CORRELATION RESOLUTION LIMITS: RES_MIN,RES_MAX    *
C         ************************************************************
	  WRITE(6,'(''$RES_MIN,RES_MAX (<CR>='',F6.1,'','',F6.1,''):
	1   '')') RES_TMP1, RES_TMP2
	  READ (5,'(2F)',ERR=400) RES_MIN, RES_MAX
	  IF(RES_MIN.LE.0.0) RES_MIN = RES_TMP1
	  IF(RES_MAX.LE.0.0) RES_MAX = RES_TMP2
	  RES_TMP1 = RES_MIN
	  RES_TMP2 = RES_MAX
	ENDIF
	RES_MIN = RES_MIN*FFT_NFAC
	RES_MAX = RES_MAX*FFT_NFAC
C
  500	IF(NCYCLE.EQ.0) THEN
	  IF(IOPT.EQ.1) THEN 			! OPEN REFERENCE PARTICLE FILE
	    COUNT = 0
	    IF(BATCH) GO TO 610
	    PRINT *, '****************************************'
	    PRINT *, '* ENTER NAME OF REFERENCE Image        *'
	    PRINT *, '* "EXIT" or <CR> = terminate program   *'
	    PRINT *, '****************************************'
  600	    WRITE(6,'(''$FILENAME: '')')
	    FILENAME = ' '
  610	    READ (5,'(A)',ERR=600,END=999) FILENAME
	    CALL STRING_UPPER (FILENAME)
	    IF(FILENAME(1:4).EQ.'EXIT' .OR. FILENAME.EQ.' ')
	1     CALL TSBEND
	    MAPHEAD.LUNUM = 8	! UNIT FOR INPUT mapFile
	    READWRITE(1) = 'r'
	    CALL pif_open (FILENAME, MAPHEAD.LUNUM, READWRITE)
	    CALL pif_read_gh (MAPHEAD)
	    if(mapHead.mode .ne. 46) then
	       print *, 'MUST be a pif mode==46 file.'
	       call tsbend
	    endif
	    mapHead.imgNum = 1
	    CALL pif_read_dh (MAPHEAD)
Ca	    CALL FILE_CHECK (2, FILENAME)
Ca	    CLOSE (UNIT=2)
Ca	    IF(FILE_ID.EQ.-999) THEN
Ca	       CALL BELL (1)
Ca	       COUNT = COUNT + 1
Ca	       IF(COUNT.GE.11) THEN
Ca	         CALL BELL (3)
Ca	         PRINT *, '*******************************************'
Ca	         PRINT *, '* Program termination: cannot locate file *'
Ca	         CALL TSBEND
Ca	       ENDIF
Ca	       GO TO 600
Ca	    ENDIF
Ca	    IF(IABS(FILE_ID).EQ.3) THEN			   ! MAP REFERENCE DATA
Ca	       NFACT         = 4
Ca	       MAP_REFERENCE = .TRUE.
	       MAP_FILENAME  = FILENAME
Ca	       CALL MAP_OPEN (2, NCOL2, NROW2, NSEC)
Ca	       IF(NSEC.GT.1) THEN
Ca	         CALL BELL (2)
Ca	         PRINT *, '****************************************'
Ca	         PRINT *, '* Program terminate: cannot use 3D MAP *'
Ca	         CALL TSBEND
Ca	       ENDIF
Ca	       BKG2 = 0
Ca	       CALL LIB$GET_VM (4*NCOL2*NROW2, REF_ADDR)
Ca	       CALL MAP_FILL_2D (2, %VAL(REF_ADDR), NCOL2, NROW2)
	       ref_addr_p = malloc(2*NCOL2*NROW2)
	       ncol2 = mapHead.numCols
	       nrow2 = mapHead.numRows
	       nsec2 = mapHead.numSecs
	       call pif_read_imgi1(mapHead,ref_addr,ncol2,nrow2,1)
	       MAP_REFERENCE = .FALSE.
	       bkg2 = imgHead.img_bkg
Ca	     ELSE					! IMAGE REFERENCE DATA
Ca	       NFACT         = 2
Ca	       MAP_REFERENCE = .FALSE.
Ca	       IMG_FILENAME  = FILENAME
Ca	       CALL IMG_OPEN (2, NCOL2, NROW2)
Ca	       BKG2  = IMG_BKG
Ca	       CALL LIB$GET_VM (2*NCOL2*NROW2, REF_ADDR)
Ca	       CALL IMG_FILL (2, %VAL(REF_ADDR), NCOL2, NROW2, 0)
Ca	    ENDIF
C
	    IF(.NOT.BATCH) THEN
  700	      WRITE(6,'(''$ORIGIN CORRECTION FOR REFERENCE DATA'',
	1      '' (<CR>=0.0,0.0): '')')
	      READ(5,'(2F)',ERR=700) X_SHIFT, Y_SHIFT
	    ENDIF
	  ENDIF
	ENDIF
C
	IMG_BKG = BKG1
	CALL IMG_FFT_FILL_local (IMG1_ADDR, NCOL1, NROW1,
	1                  FFT1_ADDR, IDIM1, IDIM2,img_bkg)
	PRINT *, '*****************************************'
	PRINT *, '* Fourier transform first IMAGE         *'
	CALL FFT_2D (FFT1_ADDR, IDIM1, IDIM2)
	IF(NCYCLE.EQ.0 .AND. IOPT.EQ.1) THEN
	   PRINT *, '* Fourier transform REFERENCE           *'
	   IF(MAP_REFERENCE) THEN
	      CALL MAP_FFT_FILL (REF_ADDR, NCOL2, NROW2, 1, 1,
	1                        FFT2_ADDR, IDIM1, IDIM2)
	    ELSE
	      IMG_BKG = BKG2
	      CALL IMG_FFT_FILL_local (REF_ADDR, NCOL2, NROW2,
	1                FFT2_ADDR, IDIM1, IDIM2, img_bkg)
	   ENDIF
	   CALL FFT_2D (FFT2_ADDR, IDIM1, IDIM2)
	 ELSE IF (IOPT.EQ.2) THEN
	   PRINT *, '* Fourier transform rotated IMAGE       *'
	   ARRAY_SIZE = 2*IDIM1*IDIM2				! # LONG WORDS
	   CALL COPY_R4 (FFT1_ADDR, FFT2_ADDR, ARRAY_SIZE)
	   FFT_FULL = .TRUE.
	   CALL FFT_FLIP (FFT2_ADDR, IDIM1, IDIM2,fft_full)
	   X_SHIFT = FLOAT (IDIM1 - NCOL1 + 1)
	   Y_SHIFT = FLOAT (IDIM2 - NROW1 + 1)
	   CALL FFT_PSHIFT (FFT2_ADDR, IDIM1, IDIM2, X_SHIFT,
	1                   Y_SHIFT,fft_full)
	ENDIF
C
	PRINT *, '* Compute the cross-correlation pattern *'
Ca	CALL LIB$GET_VM (4*IDIM1*IDIM2, CC_MAP)
	cc_map_p = malloc (4*IDIM1*IDIM2)
	CALL CCF_FFT (FFT1_ADDR, FFT2_ADDR, CC_MAP,
	1             IDIM1, IDIM2, RES_MIN, RES_MAX,
	2             map_min,map_max,map_avg,map_std,em_wrt)
	MIN_OLD = MAP_MIN
	MAX_OLD = MAP_MAX
	CALL MAP_SCALE_local (CC_MAP, IDIM1, IDIM2, 1, MIN_OLD,
	1               MAX_OLD, 1.0, 255.0,
	2               MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD)
	PRINT *, '*****************************************'
C
	CALL MAP_PEAKSEARCH (CC_MAP, IDIM1, IDIM2, PEAKS, NLIM,
	1                    NPEAK, 230.0)
	CALL PEAK_SORT_HI_local (PEAKS, NPEAK)
	CALL PEAK_CHK  (PEAKS, NPEAK, MPEAK, 1.5, em_wrt)
	CALL PEAK_SORT_HI_local (PEAKS, NPEAK)
  800	CALL CORORG12_PEAK (CC_MAP, IDIM1, IDIM2, PEAKS, NPEAK, 
	1 ICLIM, CLIM, NCONTUR, NCONTUR_LIM, CVALS, X_SHIFT, Y_SHIFT,
	2 IOPT, GRAPHICS, SAVEDATA, DX, DY, ID, THE, PHI, OME, OX, OY,
	1 NEWFILE, NEW, fft_origx,fft_origy)
C
  900	CONTINUE
	IF(BIMG_NUM1.EQ.BIMG_NUM2) BYTEDATA_IN = .FALSE.
	IF(BYTEDATA_IN) GO TO 950
	WRITE(6,'(''$CONTINUE <CR> OR EXIT (1) THIS ROUTINE?: '')')
	READ (5,'(I)',ERR=900) I
	IF(I.EQ.1) THEN
	  IF(GRAPHICS) THEN
Ca	    CALL LX_TABOFF
Ca	    CALL LX_CUROFF
Ca	    CALL LX_CLOSE
	  ENDIF
Ca	  CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT1_ADDR)
Ca	  CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT2_ADDR)
Ca	  CALL LIB$FREE_VM (2*NCOL1*NROW1, IMG1_ADDR)
Ca	  CALL LIB$FREE_VM (NFACT*NCOL2*NROW2, REF_ADDR)
Ca	  CALL LIB$FREE_VM (4*IDIM1*IDIM2, CC_MAP)
	  call free (fft1_addr_p)
	  call free (fft2_addr_p)
	  call free (img1_addr_p)
	  call free (ref_addr_p)
	  call free (cc_map_p)
	  RETURN
	ENDIF
  950	IF(SAVEAVG) THEN
	  IMG_BKG = BKG1
	  CALL IMG_SHIFT_local (IMG1_ADDR, NCOL1, NROW1, -DX, -DY,
	1                  img_bkg)
	  CALL r4_IMG_ADDIMG (AVG_ADDR, IMG1_ADDR, NCOL_AVG,
	1                  NROW_AVG)
	ENDIF
	NCYCLE   = NCYCLE + 1
	FIRSTIMG = .FALSE.
	NEW      = .FALSE.
Ca	CALL LIB$FREE_VM (2*NCOL1*NROW1, IMG1_ADDR)
Ca	CALL LIB$FREE_VM (NFACT*NCOL2*NROW2, REF_ADDR)
Ca	CALL LIB$FREE_VM (4*IDIM1*IDIM2, CC_MAP)
	call free (img1_addr_p)
	call free (ref_addr_p)
	call free (cc_map_p)
C
	IF(.NOT.BYTEDATA_IN) GO TO 275
C
	ID = ID + BIMG_STEP
	IF(BIMG_STEP.GT.0) THEN
	   IF(ID.GT.BIMG_NUM2 .OR. ID.GT.BIMG_NUMLIM) GO TO 999
	 ELSE
	   IF(ID.LT.BIMG_NUM2 .OR. ID.LT.1) GO TO 999
	ENDIF
Ca	CALL IMG_PACK_FIND (1, ID, NCOL1, NROW1, IREC)
Ca	READ(1'IREC) TITLE
Ca	WRITE(6,'(1X,A)') TITLE

	imgHead.imgNum = id
	CALL pif_read_dh (IMGHEAD)
	nrow1 = imgHead.numRows
	ncol1 = imgHead.numCols
	bimg_numlim = imgHead.nimg
	if(imgHead.mode .ne. 46) then
	   print *, 'Must be mode==46 PIF file.'
	   call tsbend
	endif

	GO TO 300
C
  999	IF(SAVEAVG) THEN
	  IMG_FILENAME = 'emcororg.avg'
	  call pif_init_head(outHead)
	  outHead.luNum = 9
	  readWrite(1) = 'w'
	  call pif_open (img_filename, outHead.luNum, readWrite)
	  outHead.mode = 6
	  outHEad.numCols = ncol_avg
	  outHEad.numRows = nrow_avg
	  call pif_write_gh(outHead)
	  call pif_write_dh(outHead)
	  call pif_write_byteshort_image(outHead.luNum, avg_addr,
	1         1024,ncol_avg, nrow_avg, 1)
	  call pif_close(outHead.luNum)
Ca	  DIV          = FLOAT(NCYCLE)
Ca	  CALL IMG_DIVIDE (AVG_ADDR, NCOL_AVG, NROW_AVG, DIV)
Ca	  CALL IMG_STATS (AVG_ADDR, NCOL_AVG, NROW_AVG)
Ca	  CALL IMG_BKGND (AVG_ADDR, NCOL_AVG, NROW_AVG)
Ca	  CALL IMG_WRITE (3, AVG_ADDR, NCOL_AVG, NROW_AVG)
	ENDIF
	IF(GRAPHICS) THEN
Ca	  CALL LX_TABOFF
Ca	  CALL LX_CUROFF
Ca	  CALL LX_CLOSE
	ENDIF
	RETURN
C
	END

C  ******************************************************************
C  *                                                                *
C  *          *****     SUBROUTINE CORORG12_PEAK     *****          *
C  *                                                                *
C  *    SUBROUTINE TO PLOT CORRELATION MAP PEAK ARRAY AS CONTOURS   *
C  *     ON THE LEXIDATA                                            *
C  ******************************************************************
C
	SUBROUTINE CORORG12_PEAK (CC_MAP, NCOL, NROW, PEAKS, NPEAK, 
	1 ICLIM, CLIM, NCONTUR, NCONTUR_LIM, CVALS, X_SHIFT, Y_SHIFT,
	2 IOPT, GRAPHICS, SAVEDATA, DX, DY, ID, THE, PHI, OME,
	3 OX, OY, NEWFILE, NEW,fft_origx,fft_origy)
C
	IMPLICIT NONE
C
	COMMON    /VPLT/ COSANG, SINANG, ICX, ICY, ICOL
	INTEGER*4 NCONTUR, NPIXX, NPIXY, NYSTRT, NXSTRT, NY, ICHK, NLIM
	INTEGER*4 ITYPE, NCELLX, NCELLY, ICX, ICY, NPEAK, IX, IY, CLEVEL
	INTEGER*4 NCOL, NROW, IOPT, ID, ICLIM, NCONTUR_LIM
	INTEGER*2 I, J, ICOL, IMG(15,15)
	INTEGER*2 XPOS, YPOS, PUCK, IPEAKX, IPEAKY
	REAL*4    AMPS(15,15), XP(15), YP(15), CVALS(NCONTUR_LIM)
	REAL*4    PEAKS(3,NPEAK), HALFX, HALFY, CC_MAP(NCOL,NROW)
	REAL*4    COSANG, SINANG, CLIM, SCLX, SCLY, ZMAX, DIV
	REAL*4    XSIZE, YSIZE, CONTOUR_STEP, DX, DY, PEAKX, PEAKY
	REAL*4    X_SHIFT, Y_SHIFT, THE, PHI, OME, OX, OY, DELX, DELY
	REAL*4    DX_AVG/0.0/, DY_AVG/0.0/
	real*4    fft_origx,fft_origy
	LOGICAL   GRAPHICS, SAVEDATA, YESNO, NEW
	CHARACTER*256 NEWFILE
	DATA      SINANG/1.0/, COSANG/0.0/
C  ----------------------------------------------------------------------------
C
Ca  100	IF(.NOT.GRAPHICS) GO TO 200
Ca	IF(LXDEV_1280) THEN
Ca	   NPIXX = 750
Ca	   NPIXY = 750
Ca	   XSIZE = 750.0
Ca	   YSIZE = 750.0
Ca	   DIV   =  50.0
Ca	 ELSE
Ca	   NPIXX = 375
Ca	   NPIXY = 375
Ca	   XSIZE = 375.0
Ca	   YSIZE = 375.0
Ca	   DIV   =  25.0
Ca	ENDIF
Ca	CALL LX_ERASE
Ca	CALL LX_CTSET (1, 1, 255, 255, 255)
Ca	DO I = 1,NCONTUR	      	      ! MAP CONTOURS FROM RED TO YELLOW
Ca	  LXCT_R(I) = 155 + INT(100.0 * FLOAT(I-1)/FLOAT(NCONTUR-1))
Ca	  LXCT_G(I) =  55 + INT(200.0 * FLOAT(I-1)/FLOAT(NCONTUR-1))
Ca	  LXCT_B(I) = INT(50.0 * FLOAT(I-1)/FLOAT(NCONTUR-1))
Ca	ENDDO
Ca	CALL LX_CTSET (2, NCONTUR, LXCT_R, LXCT_G, LXCT_B)
Ca  200	ICHK    = 0					 ! FAST PLOT OF VECTORS
Ca	ICX     = LX_XCEN-(NPIXX/2)
Ca	ICY     = LX_YCEN-(NPIXY/2)
Ca	ICOL    = 1					! BOX OUTLINED IN WHITE
	HALFX   = FLOAT(NCOL)/2.0
	HALFY   = FLOAT(NROW)/2.0
Ca	IF(GRAPHICS) THEN
Ca	  CALL MAPDSP_VECPLT (   0.,   0., 3, ICHK)
Ca	  CALL MAPDSP_VECPLT (   0.,YSIZE, 2, ICHK)
Ca	  CALL MAPDSP_VECPLT (XSIZE,YSIZE, 2, ICHK)
Ca	  CALL MAPDSP_VECPLT (XSIZE,   0., 2, ICHK)
Ca	  CALL MAPDSP_VECPLT (   0.,   0., 2, ICHK)
Ca	ENDIF
	DO J = 1,15				 ! LOAD CONTOUR ARRAY WITH AMPS
	  IY = NINT(PEAKS(2,1)) + (J-8)
	  IF(IY.LE.0)    IY = IY + NROW
	  IF(IY.GT.NROW) IY = IY - NROW
	  DO I = 1,15
	    IX = NINT(PEAKS(1,1)) + (I-8)
	    IF(IX.LE.0)    IX = IX + NCOL
	    IF(IX.GT.NCOL) IX = IX - NCOL
	    AMPS(I,J) = CC_MAP(IX,IY)
	  END DO
	END DO
	DO J = 15,1,-1
	  WRITE(6,'(1X,15I4))') (NINT(AMPS(I,J)),I=1,15)
	ENDDO
	IPEAKX = NINT(PEAKS(1,1)) - 1
	IPEAKY = NINT(PEAKS(2,1)) - 1
	IF(IPEAKX.GT.INT(HALFX)) IPEAKX = IPEAKX - NCOL
	IF(IPEAKY.GT.INT(HALFY)) IPEAKY = IPEAKY - NROW
	WRITE(6,'('' The central point corresponds to pixel location '',
	1 2I5)') IPEAKX, IPEAKY
	CALL TRUS_POLYS (AMPS, IPEAKX, IPEAKY, PEAKX, PEAKY)
C
	IF(IOPT.EQ.2) THEN
	   WRITE(6,1000) PEAKX, PEAKY, -(PEAKX/2.0), -(PEAKY/2.0)
	   IF(SAVEDATA .AND. .NOT.GRAPHICS) THEN
	     IF(NEW) WRITE(3,'(1X,A)') NEWFILE
	     DELX = -(OX - FFT_ORIGX + PEAKX/2.0)
	     DELY = -(OY - FFT_ORIGY + PEAKY/2.0)
	     WRITE(3,1020) ID, THE, PHI, OME, 
	1     (FFT_ORIGX-(PEAKX/2.0)), (FFT_ORIGY-(PEAKY/2.0)),
	2     DELX, DELY
	   ENDIF
	   DX = -(PEAKX/2.0)
	   DY = -(PEAKY/2.0)
	 ELSE
	   WRITE(6,1000) PEAKX, PEAKY, -PEAKX, -PEAKY
	   IF(SAVEDATA .AND. .NOT.GRAPHICS) THEN
	     IF(NEW) WRITE(3,'(1X,A)') NEWFILE
	     DELX = -(OX - FFT_ORIGX + PEAKX - X_SHIFT)
	     DELY = -(OY - FFT_ORIGY + PEAKY - Y_SHIFT)
	     WRITE(3,1020) ID, THE, PHI, OME,
	1     (FFT_ORIGX-PEAKX+X_SHIFT), (FFT_ORIGY-PEAKY+Y_SHIFT),
	2     DELX, DELY
	   ENDIF
	   DX = -PEAKX
	   DY = -PEAKY
	ENDIF
	IF(.NOT.GRAPHICS) RETURN
C
Ca	CONTOUR_STEP = CLIM/(NCONTUR-1)
Ca	DO I = 1,NCONTUR
Ca	  CVALS(I) = (255-CLIM) + CONTOUR_STEP*(I-1)
Ca	ENDDO
Ca	SCLX = XSIZE/14.0
Ca	SCLY = YSIZE/14.0
Ca	DO CLEVEL = 1,NCONTUR
Ca	  ICOL = 1 + CLEVEL
Ca	  ZMAX = CVALS(CLEVEL)
Ca	  CALL CONTUR_A (AMPS, IMG, XP, YP, 14, 14, SCLX, SCLY, ZMAX)
Ca	ENDDO
CaC
Ca  300	PRINT *, '**********************************************',
Ca	1 '********************'
Ca	PRINT *, '*   Use the data tablet puck to identify the
Ca	1 center of the peak  *'
Ca	PRINT *, '*                                           
Ca	1                     *'
Ca	PRINT *, '* YELLOW: pick point           WHITE: change
Ca	1 plot parameters     *'
Ca	PRINT *, '* BLUE  : change cursor        GREEN: EXIT  
Ca	1                     *'
Ca	PRINT *, '**********************************************',
Ca	1 '********************'
Ca	WRITE(6,'('' PEAK POSITION IS AT '')')
Ca  400	CALL LX_TABPOS (XPOS, YPOS, PUCK)
Ca	IF(PUCK.EQ.0) THEN					! YELLOW BUTTON
Ca	   DX    = FLOAT(XPOS-LX_XCEN) / DIV
Ca	   DY    = FLOAT(YPOS-LX_YCEN) / DIV
Ca	   PEAKX = PEAKS(1,1) - 1.0 + DX
Ca	   PEAKY = PEAKS(2,1) - 1.0 + DY
Ca	   IF(PEAKX.GT.HALFX) PEAKX = PEAKX - NCOL
Ca	   IF(PEAKY.GT.HALFY) PEAKY = PEAKY - NROW
Ca	   IF(IOPT.EQ.2) THEN
Ca	      WRITE(6,1010) PEAKX, PEAKY, -(PEAKX/2.0), -(PEAKY/2.0)
Ca	      IF(SAVEDATA) THEN
Ca	        IF(NEW) WRITE(3,'(1X,A)') NEWFILE
Ca	        DELX = OX - FFT_ORIGX + PEAKX/2.0
Ca	        DELY = OY - FFT_ORIGY + PEAKY/2.0
Ca	        WRITE(3,1020) ID, THE, PHI, OME, 
Ca	1        (FFT_ORIGX-(PEAKX/2.0)), (FFT_ORIGY-(PEAKY/2.0)),
Ca	2        DELX, DELY
Ca	      ENDIF
Ca	    ELSE
Ca	      WRITE(6,1010) PEAKX, PEAKY, -PEAKX, -PEAKY
Ca	      IF(SAVEDATA) THEN
Ca	        IF(NEW) WRITE(3,'(1X,A)') NEWFILE
Ca	        DELX = OX - FFT_ORIGX + PEAKX - X_SHIFT
Ca	        DELY = OY - FFT_ORIGY + PEAKY - Y_SHIFT
Ca	        WRITE(3,1020) ID, THE, PHI, OME,
Ca	1        (FFT_ORIGX-PEAKX+X_SHIFT), (FFT_ORIGY-PEAKY+Y_SHIFT),
Ca	2        DELX, DELY
Ca	      ENDIF
Ca	      DX = -PEAKX
Ca	      DY = -PEAKY
Ca	   ENDIF
Ca	 ELSE IF (PUCK.EQ.1) THEN				! WHITE BUTTON
Ca	   CALL CORORG_PLOTINFO (NCONTUR, NCONTUR_LIM, ICLIM, CLIM)
Ca	   GO TO 100
Ca	 ELSE IF (PUCK.EQ.2) THEN				! BLUE BUTTON
Ca	   CALL LX_TAB_CUROPTIONS
Ca	   GO TO 300
Ca	 ELSE							! GREEN BUTTON
Ca	   RETURN
Ca	ENDIF
Ca	GO TO 400
C
 1000	FORMAT(' QUADRATIC FIT: PEAKX,PEAKY ',2F7.3,
	1      '  ORIGIN SHIFT DX,DY = ',2F7.3)
 1010	FORMAT('+PEAK POSITION IS AT ',2F7.3,
	1      '  ORIGIN SHIFT DX,DY = ',2F7.3)
 1020	FORMAT(I5,',',5(F8.3,','),' ,',F8.3,',',F8.3)
	END

C  ******************************************************************
C  *                                                                *
C  *            *****     SUBROUTINE CORORG3     *****              *
C  *                                                                *
C  *    LAST MODIFIED 29-JAN-1993 BY T. BAKER.                      *
C  ******************************************************************
C
	SUBROUTINE CORORG3
C
	IMPLICIT NONE
C
	INCLUDE '../libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, imgHead
	COMMON /PIFHEAD/   MAPHEAD, imgHead
C
	COMMON /CORORG_COM/ RES_MIN, RES_MAX, GRAPHICS, SAVEDATA,
	1                   BATCH, X_SHIFT, Y_SHIFT
	INTEGER*4 NCOL1, NCOL2, NROW1, NROW2, NSEC, REF_ID
Ca	INTEGER*4 I, J, CC_MAP, SAVE_ID
	INTEGER*4 I, J, SAVE_ID
	INTEGER*4 IDIM1, IDIM2, NPEAK, MPEAK, IREC, NLIM
Ca	INTEGER*4 ID, IDIM1_OLD, FFT_NFAC, FFT1_ADDR, FFT2_ADDR
	INTEGER*4 ID, IDIM1_OLD, FFT_NFAC
	real*4    img_bkg, BKG2, BKG1
	PARAMETER (NLIM=5000)
	REAL*4    PEAKS (3,NLIM), RES_MIN, RES_MAX, MIN_OLD, MAX_OLD
	REAL*4    X_SHIFT, Y_SHIFT, DX, DY, THE, PHI, OME, OX, OY
	real*4    fft_origx,fft_origy,map_min,map_max
	real*4    fft_fzero,map_avg,map_std
	LOGICAL   MAP_REFERENCE, BYTEDATA_IN, SAVEDATA, FIRST, NEW
	LOGICAL   BATCH, GRAPHICS,fft_full,em_wrt
	CHARACTER TITLE*80, FILENAME*256, NEWFILE*256
	CHARACTER map_filename*256
	CHARACTER img_filename*256
	real*4    ref_addr(1), FFT1_ADDR(1), FFT2_ADDR(1), cc_map(1)
	BYTE      READWRITE(4),img1_addr(1)
	pointer   (ref_addr_p,ref_addr),(img1_addr_p,img1_addr)
	pointer   (fft1_addr_p,fft1_addr),(cc_map_p,cc_map)
	pointer   (fft2_addr_p,fft2_addr)
	integer   malloc
C  ----------------------------------------------------------------------------
C
Ca	EM_WRT      = 0			      ! SUPRESS FURTHER TERMINAL OUTPUT
	FFT_NFAC    = 2		     ! DOUBLES DEFAULT FFT SIZE FOR CC FUNCTION
	RES_MIN     = RES_MIN*FFT_NFAC
	RES_MAX     = RES_MAX*FFT_NFAC
	BYTEDATA_IN = .FALSE.			! HAVE TO OPEN FIRST IMAGE FILE
	FIRST       = .TRUE.
C  **********************************
C  *    OPEN REFERENCE DATA FILE    *
C  **********************************
	FILENAME = ' '
	READ (5,'(A)') FILENAME
	MAPHEAD.LUNUM = 8	! UNIT FOR INPUT mapFile
	READWRITE(1) = 'r'
	CALL pif_open (FILENAME, MAPHEAD.LUNUM, READWRITE)
	CALL pif_read_gh (MAPHEAD)
	if(mapHead.mode .ne. 20) then
	   print *, 'MUST be a pifMap (mode==20) file.'
	   call tsbend
	endif
	mapHead.imgNum = 1
	CALL pif_read_dh (MAPHEAD)
Ca	CALL STRING_UPPER (FILENAME)
Ca	CALL FILE_CHECK (2, FILENAME)
Ca	CLOSE (UNIT=2)
Ca	IF(FILE_ID.EQ.-999) THEN
Ca	  PRINT *, '**********************************************'
Ca	  PRINT *, '* EXIT PROGRAM: Cannot locate reference file *'
Ca	  CALL TSBEND
Ca	ENDIF
	MAP_FILENAME  = FILENAME
Ca	CALL MAP_OPEN (2, NCOL2, NROW2, NSEC)

Ca	REF_ID = FILE_ID
Ca	CALL LIB$GET_VM (4*NCOL2*NROW2, REF_ADDR)

	ref_addr_p = malloc (4*NCOL2*NROW2)

C  **************************
C  *    INPUT IMAGE DATA    *
C  **************************
  100	IF(.NOT.BYTEDATA_IN) THEN
	  IMG_FILENAME = ' '
	  print *, 'Enter img filename - '
	  read(*,'(A)')img_filename
Ca	  CALL IMG_OPEN (1, NCOL1, NROW1)
	  IMGHEAD.LUNUM = 11	! UNIT FOR INPUT IMAGE FILE
	  READWRITE(1) = 'r'
	  CALL pif_open (IMG_FILENAME, IMGHEAD.LUNUM, READWRITE)
	  CALL pif_read_gh (IMGHEAD)
	  imgHead.imgNum = 1
	  CALL pif_read_dh (IMGHEAD)
	  nrow1 = imgHead.numRows
	  ncol1 = imgHead.numCols
	  if(imgHead.mode .ne. 46) then
	     print *, 'Must be mode==46 PIF file.'
	     call tsbend
	  endif
	  NEW         = .TRUE.
	  NEWFILE     = IMG_FILENAME
Ca	  BYTEDATA_IN = BYTEDATA
	  BYTEDATA_IN = .true.
Ca	  SAVE_ID     = FILE_ID
	ENDIF
	READ (5,'(I,5F)',END=999) ID, THE, PHI, OME, OX, OY
	IF(BYTEDATA_IN) THEN
	  IF(ID.LE.0) THEN
	    BYTEDATA_IN = .FALSE.
	    GO TO 100
	  ENDIF
	  imgHead.imgNum = id
	  CALL pif_read_dh (IMGHEAD)
Ca	  CALL IMG_PACK_FIND (1, ID, NCOL1, NROW1, IREC)
Ca	  READ(1'IREC) TITLE
Ca	  WRITE(6,'(1X,A)') TITLE
	ENDIF
  200	FFT_ORIGX  = NCOL1/2
	FFT_ORIGY  = NROW1/2
	BKG1       = IMG_BKG
Ca	CALL LIB$GET_VM (2*NCOL1*NROW1, IMG1_ADDR)
	img1_addr_p = malloc(2*NCOL1*NROW1)

Ca	CALL IMG_FILL (1, IMG1_ADDR, NCOL1, NROW1, IREC)
	call pif_read_imgi1(imgHead,img1_addr,ncol1,nrow1,id)

	CALL FFT_SETDIM_DEF_SAME (NCOL1,NROW1,IDIM1,IDIM2,FFT_NFAC)
	IF(FIRST) THEN
	   IDIM1_OLD  = IDIM1
Ca	   CALL LIB$GET_VM (4*IDIM1*IDIM2, CC_MAP)
Ca	   CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT1_ADDR)
Ca	   CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT2_ADDR)
	   cc_map_p    = malloc (4*IDIM1*IDIM2)
	   fft1_addr_p = malloc (8*IDIM1*IDIM2)
	   fft2_addr_p = malloc (8*IDIM1*IDIM2)
	 ELSE
	   IF(IDIM1.NE.IDIM1_OLD) THEN
	     CALL BELL (2)
	     PRINT *, '***************************************************'
	     PRINT *, '* Inconsistent IMAGE sizes require different FFTs *'
	     CALL TSBEND
	   ENDIF
	ENDIF
C  ************************************************
C  *    FOURIER TRANSFORM THE INPUT IMAGE DATA    *
C  ************************************************
	IMG_BKG = BKG1
	CALL IMG_FFT_FILL_local (IMG1_ADDR, NCOL1, NROW1,
	1                  FFT1_ADDR, IDIM1, IDIM2, img_bkg)
	CALL FFT_2D (FFT1_ADDR, IDIM1, IDIM2)
C  ***************************
C  *    LOAD REFERENCE MAP   *
C  ***************************
	IMG_BKG = 0.0
Ca	FILE_ID = REF_ID

Ca	CALL MAP_FILL_2D (2, REF_ADDR, NCOL2, NROW2)
	ref_addr_p = malloc(2*NCOL2*NROW2)
	ncol2 = mapHead.numCols
	nrow2 = mapHead.numRows
	nsec  = mapHead.numSecs
	call pif_read_imgi1(mapHead,ref_addr,ncol2,nrow2,1)
	BKG2 = mapHead.img_bkg

Ca	FILE_ID = SAVE_ID
C  *******************************************************************
C  *    LOAD REFERENCE INTO FFT ARRAY, FOURIER TRANSFORM IT, AND     *
C  *     CROSS-CORRELATE WITH THE INPUT IMAGE DATA.                  *
C  *******************************************************************
Ca	CALL MAP_FFT_FILL (REF_ADDR, NCOL2, NROW2, 1, 1,
Ca	1                  FFT2_ADDR, IDIM1, IDIM2)
	IMG_BKG = BKG2
	CALL IMG_FFT_FILL_local (REF_ADDR, NCOL2, NROW2,
	1                FFT2_ADDR, IDIM1, IDIM2, img_bkg)


	CALL FFT_2D (FFT2_ADDR, IDIM1, IDIM2)
	CALL CCF_FFT (FFT1_ADDR, FFT2_ADDR, CC_MAP,
	1             IDIM1, IDIM2, RES_MIN, RES_MAX)
	MIN_OLD = MAP_MIN
	MAX_OLD = MAP_MAX
	CALL MAP_SCALE_local (CC_MAP, IDIM1, IDIM2, 1, MIN_OLD,
	1               MAX_OLD, 1.0, 255.0,
	2               MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD)
	CALL MAP_PEAKSEARCH (CC_MAP, IDIM1, IDIM2, PEAKS, NLIM,
	1                    NPEAK, 230.0)
	CALL PEAK_SORT_HI_local (PEAKS, NPEAK)
	CALL PEAK_CHK  (PEAKS, NPEAK, MPEAK, 1.5,em_wrt)
	CALL PEAK_SORT_HI_local (PEAKS, NPEAK)
	CALL CORORG3_PEAK (CC_MAP, IDIM1, IDIM2, PEAKS, NPEAK, 
	1 X_SHIFT, Y_SHIFT, DX, DY, ID, THE, PHI, OME, OX, OY, NEWFILE,
	2 NEW)
	TITLE = ' '
	NEW   = .FALSE.			      ! FINISHED WITH INPUT IMAGE
	FIRST = .FALSE.			      ! FINISHED WITH FIRST INPUT IMAGE
Ca	CALL LIB$FREE_VM (2*NCOL1*NROW1, IMG1_ADDR)
	CALL FREE (IMG1_ADDR_p)
	GO TO 100
C
Ca  999	CALL LIB$FREE_VM (4*NCOL2*NROW2, REF_ADDR)
  999	CALL FREE (REF_ADDR_p)
	RES_MIN = RES_MIN/FFT_NFAC
	RES_MAX = RES_MAX/FFT_NFAC
	RETURN
	END

C  ******************************************************************
C  *                                                                *
C  *          *****     SUBROUTINE CORORG3_PEAK     *****           *
C  *                                                                *
C  ******************************************************************
C
	SUBROUTINE CORORG3_PEAK (CC_MAP, NCOL, NROW, PEAKS, NPEAK, 
	1 X_SHIFT, Y_SHIFT, DX, DY, ID, THE, PHI, OME, OX, OY, NEWFILE,
	2 NEW)
C
	IMPLICIT NONE
C
	INTEGER*4 NLIM, NPEAK, IX, IY, NCOL, NROW, ID
	INTEGER*2 I, J, IMG(15,15), XPOS, YPOS, IPEAKX, IPEAKY
	REAL*4    AMPS(15,15), XP(15), YP(15)
	REAL*4    PEAKS(3,NPEAK), HALFX, HALFY, CC_MAP(NCOL,NROW)
	REAL*4    DX, DY, PEAKX, PEAKY, DX_AVG/0.0/, DY_AVG/0.0/
	REAL*4    X_SHIFT, Y_SHIFT, THE, PHI, OME, OX, OY, DELX, DELY
	real*4    fft_origx,fft_origy
	LOGICAL   NEW
	CHARACTER*256 NEWFILE
C  ----------------------------------------------------------------------------
C
  100	HALFX = FLOAT(NCOL)/2.0
	HALFY = FLOAT(NROW)/2.0
     	FFT_ORIGX  = NCOL/2
	FFT_ORIGY  = NROW/2
	DO J = 1,15				 ! LOAD CONTOUR ARRAY WITH AMPS
	  IY = NINT(PEAKS(2,1)) + (J-8)
	  IF(IY.LE.0)    IY = IY + NROW
	  IF(IY.GT.NROW) IY = IY - NROW
	  DO I = 1,15
	    IX = NINT(PEAKS(1,1)) + (I-8)
	    IF(IX.LE.0)    IX = IX + NCOL
	    IF(IX.GT.NCOL) IX = IX - NCOL
	    AMPS(I,J) = CC_MAP(IX,IY)
	  END DO
	END DO
	DO J = 15,1,-1
	  WRITE(6,'(1X,15I4))') (NINT(AMPS(I,J)),I=1,15)
	ENDDO
	IPEAKX = NINT(PEAKS(1,1)) - 1
	IPEAKY = NINT(PEAKS(2,1)) - 1
	IF(IPEAKX.GT.INT(HALFX)) IPEAKX = IPEAKX - NCOL
	IF(IPEAKY.GT.INT(HALFY)) IPEAKY = IPEAKY - NROW
	WRITE(6,'('' The central point corresponds to pixel location '',
	1 2I5)') IPEAKX, IPEAKY
	CALL TRUS_POLYS (AMPS, IPEAKX, IPEAKY, PEAKX, PEAKY)
C
	WRITE(6,1000) PEAKX, PEAKY, -PEAKX, -PEAKY
	IF(NEW) WRITE(3,'(1X,A)') NEWFILE
	DELX = -(OX - FFT_ORIGX + PEAKX - X_SHIFT)
	DELY = -(OY - FFT_ORIGY + PEAKY - Y_SHIFT)
	WRITE(3,1020) ID, THE, PHI, OME,
	1   (FFT_ORIGX-PEAKX+X_SHIFT), (FFT_ORIGY-PEAKY+Y_SHIFT),
	2   DELX, DELY
	DX = -PEAKX
	DY = -PEAKY
	RETURN
C
 1000	FORMAT(' QUADRATIC FIT: PEAKX,PEAKY ',2F7.3,
	1      '  ORIGIN SHIFT DX,DY = ',2F7.3)
 1020	FORMAT(I5,',',5(F8.3,','),' ,',F8.3,',',F8.3)
	END

C  ****************************************************************************
	SUBROUTINE CORORG_PLOTINFO (NCONTUR, NCONTUR_LIM, ICLIM, CLIM)
C
	IMPLICIT NONE
C
	INTEGER*4 I, NCONTUR, NCONTUR_LIM, ICLIM
	REAL*4    CLIM
C -----------------------------------------------------------------------------
C
  100	WRITE(6,'(''$# CONTOUR LEVELS (<CR>='',I2,''):'')') NCONTUR
	READ (5,'(I)',ERR=100) I
	IF(I.NE.0.AND.(I.LT.2.OR.I.GT.NCONTUR_LIM)) THEN
	  CALL BELL (2)
	  PRINT *, '***************************'
	  PRINT '(A,I2,A)', '* # levels allowed = 2-',
	1   NCONTUR_LIM, ' *'
	  PRINT *, '***************************'
	  GO TO 100
	ENDIF
	IF(I.NE.0) NCONTUR = I
	ICLIM = 255 - NINT(CLIM)
C
  200	WRITE(6,'(''$LOWEST CORRELATION DENSITY LEVEL FOR PLOT
	1 (<CR>='',I3,''):'')') ICLIM
	READ (5,'(I)',ERR=200) I
	IF(I.LT.0.OR.I.GT.250) THEN
	  CALL BELL (2)
	  PRINT *, '***********************************'
	  PRINT *, '* Range must be between 0 and 250 *'
	  PRINT *, '***********************************'
	  GO TO 200
	ENDIF
	IF(I.NE.0) CLIM = 255 - I
	RETURN
C
	END
C******************************************************************************
C                                                                             *
C	Procedure : PEAK_SORT_HI_local                                        *
C	                                                                      *
C	Object  : The Array PEAKS is sorted by such that the highest peak     *
C                  value is stored in the first array position (i.e. de-      *
C                  creasing  order, using a QUICKSORT algorithm, on a key     *
C                  being peaks(3,*).                                          *
C                                                                             *
C	Parameters :                                                          *
C		PEAKS 		REAL*4(3,NPEAK)	Array to be sorted            *
C		NPEAK		INTEGER*4	SIZE of the Array             *
C                                                                             *
C	Authors  :                                                            *
C	           Eric P. Meyer [EPM], Purdue University 18-JUN-87           *
C                                                                             *
C	Release : V01.00	Initial Release			02-JUL-87 EPM *
C                 V01.01        Converted to two PEAK_SORTs     18-MAY-88 TSB *
C	Modified 8 February 1994 by D. Belnap				      *
C******************************************************************************
C                                                                            
c
c 	New Peak Sort Routine using QuickSort Algorithm
C
	SUBROUTINE PEAK_SORT_HI_local (PEAKS, NPEAK)
C
	IMPLICIT NONE
C
	INTEGER*4 NPEAK, MIN_QUICK_SORT_SIZE, STACK_SIZE
	PARAMETER (MIN_QUICK_SORT_SIZE = 9, STACK_SIZE = 1024)
	INTEGER*4 STACK_TOP, LEFT, RIGHT, INDEX_LEFT, INDEX_RIGHT
	INTEGER*4 INDEX, INDEX_2, STACK(STACK_SIZE,2)
	REAL*4    PEAKS(3,NPEAK), KEY, TMP(3), REC(3)
C  -----------------------------------------------------------------------------
C
1000	IF (NPEAK.LE.MIN_QUICK_SORT_SIZE) GO TO 9000
C
	STACK_TOP = 0
	LEFT      = 1
	RIGHT     = NPEAK
C
2000	INDEX_LEFT  = LEFT
	INDEX_RIGHT = RIGHT + 1
	KEY         = PEAKS(3,LEFT)
	REC(1)      = PEAKS(1,LEFT)
	REC(2)      = PEAKS(2,LEFT)
	REC(3)      = PEAKS(3,LEFT)
C                        
3000	INDEX_LEFT = INDEX_LEFT + 1
	IF (INDEX_LEFT.GT.NPEAK) GO TO 4000		! Added 2/8/94 DMB
	IF (PEAKS(3,INDEX_LEFT).GT.KEY) GO TO 3000
C
4000	INDEX_RIGHT = INDEX_RIGHT - 1
	IF (PEAKS(3,INDEX_RIGHT).LT.KEY) GO TO 4000
C   
	IF (INDEX_RIGHT.LE.INDEX_LEFT) THEN
	  TMP(1)               = PEAKS(1,INDEX_RIGHT)
	  TMP(2)               = PEAKS(2,INDEX_RIGHT)
	  TMP(3)               = PEAKS(3,INDEX_RIGHT)
	  PEAKS(1,INDEX_RIGHT) = PEAKS(1,LEFT)
	  PEAKS(2,INDEX_RIGHT) = PEAKS(2,LEFT)
	  PEAKS(3,INDEX_RIGHT) = PEAKS(3,LEFT)
	  PEAKS(1,LEFT)        = TMP(1)
	  PEAKS(2,LEFT)        = TMP(2)
	  PEAKS(3,LEFT)        = TMP(3)
	  GO TO 7000
	ENDIF
C
	TMP(1)               = PEAKS(1,INDEX_RIGHT)
	TMP(2)               = PEAKS(2,INDEX_RIGHT)
	TMP(3)               = PEAKS(3,INDEX_RIGHT)
	PEAKS(1,INDEX_RIGHT) = PEAKS(1,INDEX_LEFT)
	PEAKS(2,INDEX_RIGHT) = PEAKS(2,INDEX_LEFT)
	PEAKS(3,INDEX_RIGHT) = PEAKS(3,INDEX_LEFT)
	PEAKS(1,INDEX_LEFT)  = TMP(1)
	PEAKS(2,INDEX_LEFT)  = TMP(2)
	PEAKS(3,INDEX_LEFT)  = TMP(3)
	GO TO 3000
C
7000	IF (((RIGHT-INDEX_RIGHT).GE.(INDEX_RIGHT-LEFT)).AND.
     +	   ((INDEX_RIGHT-LEFT).GT.MIN_QUICK_SORT_SIZE)) THEN
	  STACK_TOP          = STACK_TOP + 1
	  STACK(STACK_TOP,1) = INDEX_RIGHT + 1
	  STACK(STACK_TOP,2) = RIGHT
	  RIGHT              = INDEX_RIGHT - 1
	  GO TO 2000
	ENDIF
	IF (((INDEX_RIGHT-LEFT).GT.(RIGHT-INDEX_RIGHT)).AND.
     +	   ((RIGHT-INDEX_RIGHT).GT.MIN_QUICK_SORT_SIZE)) THEN
	  STACK_TOP          = STACK_TOP + 1
	  STACK(STACK_TOP,1) = LEFT
	  STACK(STACK_TOP,2) = INDEX_RIGHT - 1
	  LEFT               = INDEX_RIGHT - 1
	  GO TO 2000
	ENDIF
	IF (((RIGHT-INDEX_RIGHT).GT.min_quick_sort_size).AND.
     +	   (MIN_QUICK_SORT_SIZE.GE.(INDEX_RIGHT-LEFT))) THEN
	  LEFT = INDEX_RIGHT + 1
	  GO TO 2000
	ENDIF
	IF (((INDEX_RIGHT-LEFT).GT.MIN_QUICK_SORT_SIZE).AND.
     +	   (MIN_QUICK_SORT_SIZE.GE.(RIGHT-INDEX_RIGHT))) THEN
	  RIGHT = INDEX_RIGHT - 1
	  GO TO 2000
	ENDIF
C
	IF (STACK_TOP.NE.0) THEN
	  LEFT      = STACK(STACK_TOP,1)
	  RIGHT     = STACK(STACK_TOP,2)
	  STACK_TOP = STACK_TOP - 1
	  GO TO 2000
	ENDIF
C
9000	DO INDEX = 2,NPEAK
	  IF (PEAKS(3,INDEX - 1).LT.PEAKS(3,INDEX)) THEN
	    KEY     = PEAKS(3,INDEX)
	    REC(1)  = PEAKS(1,INDEX)
	    REC(2)  = PEAKS(2,INDEX)
	    REC(3)  = PEAKS(3,INDEX)
	    INDEX_2 = INDEX - 1
8100	    PEAKS(1,INDEX_2+1) = PEAKS(1,INDEX_2)
	    PEAKS(2,INDEX_2+1) = PEAKS(2,INDEX_2)
	    PEAKS(3,INDEX_2+1) = PEAKS(3,INDEX_2)
	    INDEX_2            = INDEX_2 - 1
	    IF (INDEX_2.GT.0.AND.
	1    (.NOT.(PEAKS(3,INDEX_2).GT.KEY))) GO TO 8100
	    PEAKS(1,INDEX_2+1) = REC(1)
	    PEAKS(2,INDEX_2+1) = REC(2)
	    PEAKS(3,INDEX_2+1) = REC(3)
	  ENDIF
	ENDDO
C
	RETURN
	END


C  ********************************************************************
C  *                                                                  *
C  *            *****     SUBROUTINE IMG_FFT_FILL_local     *****       *
C  *                                                                  *
C  *    LOAD NCOL X NROW "IMAGE" INTO "FFT" ARRAY TO COMPUTE FFT      *
C  *                                                                  *
C  *    MAY 1987  PURDUE UNIVERSITY VAX 11/750, T. BAKER.             *
C  *    DECEMBER 1989  PURDUE UNIVERSITY VAX 8550, T. BAKER.          *
C  *    LAST MODIFIED  7-AUG-1990 BY T. BAKER.                        *
C  ********************************************************************
C
	SUBROUTINE IMG_FFT_FILL_local (IMG, NCOL, NROW, FFT,IDIM1,IDIM2,
	1           imgBkgP)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, IDIM1, IDIM2, I, J
	real*4    img_bkg,imgBkgP
	real*4    IMG(NCOL,NROW)
	REAL*4    FFT(2*IDIM1,IDIM2), TMP, fft_fzero
	LOGICAL   fft_full
C  -----------------------------------------------------------------------------
C
	img_bkg = imgBkgP
	FFT_FZERO = 0.0
C
	FFT_FULL = .TRUE.
	CALL FFT_CLEAR (FFT, IDIM1, IDIM2, fft_full)	! ZERO THE FFT ARRAY
C
	DO J = 1,NROW
	  DO I = 1,NCOL
	    TMP            = IMG(I,J) - IMG_BKG
	    FFT((2*I)-1,J) = TMP
	    FFT_FZERO      = FFT_FZERO + TMP
	  ENDDO
	ENDDO
C
	RETURN
	END


C  **************************************************************************
C  *                                                                        *
C  *               *****     SUBROUTINE MAP_SCALE_local     *****           *
C  *                                                                        *
C  *    ROUTINE TO RESCALE "MAP" VALUES INSIDE THE RANGE MIN_OLD-MAX_OLD    *
C  *     TO MIN_NEW-MAX_NEW.                                                *
C  *                                                                        *
C  *    WORKS WITH 2D OR 3D "MAP" DATA.                                     *
C  *                                                                        *
C  *    JANUARY 1985  PURDUE UNIVERSITY VAX 11/750, T. BAKER.               *
C  *	Modified screen output, 22 Sept 1994, by D. Belnap		    *
C  *    MODIFIED 16-DEC-1997 BY T. BAKER (Rid of EM.CMM).                   *
C  *    LAST MODIFIED 27-FEB-1998 BY T. BAKER (Make UNIX compatible).       *
C  **************************************************************************
C
	SUBROUTINE MAP_SCALE_local (MAP, NCOL, NROW, NSEC, MIN_OLD, 
	1 MAX_OLD, MIN_NEW, MAX_NEW, MAP_MIN, MAP_MAX, MAP_AVG, 
	2 MAP_STD)
C
	IMPLICIT NONE
C
	INTEGER*2 ITMP(1)
	INTEGER*4 NCOL, NROW, NSEC
	REAL*4    MAP(1), MIN_OLD, MAX_OLD, MIN_NEW, MAX_NEW, TMP(1)
	REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
	POINTER   (ITMP_P,ITMP), (TMP_P,TMP)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	ITMP_P = MALLOC(2*NCOL)			    	    ! ADD VM TRAP HERE
	TMP_P  = MALLOC(4*NCOL)			    	    ! ADD VM TRAP HERE
	CALL MAP$SCALE$loc (MAP, NCOL, NROW, NSEC, MIN_OLD, 
	1 MAX_OLD, MIN_NEW, MAX_NEW, ITMP, TMP, MAP_MIN, MAP_MAX, 
	2 MAP_AVG, MAP_STD)
	IF(ITMP_P.NE.0) CALL FREE (ITMP_P)
	IF(TMP_P.NE.0)  CALL FREE (TMP_P)
C
	RETURN
	END
C  ============================================================================
	SUBROUTINE MAP$SCALE$loc (MAP, NCOL, NROW, NSEC, 
	1 MIN_OLD,MAX_OLD, MIN_NEW, MAX_NEW, ITMP, TMP, MAP_MIN, 
	2 MAP_MAX, MAP_AVG, MAP_STD)
C
	IMPLICIT NONE
C
	INCLUDE '../libEMF/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 NCOL, NROW, NSEC, I, J, K, ARRAY_SIZE
	INTEGER*2 ITMP(NCOL)
	REAL*4    MAP(1), MIN_OLD, MAX_OLD, MIN_NEW, MAX_NEW, DIV, KSTEP
	REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
	REAL*4    SCALE, TMP(NCOL), TMP2, SUMSQ, TOT, VAR, PERCENT
C  ----------------------------------------------------------------------------
C
	ARRAY_SIZE = NCOL*NROW*NSEC
	DIV        = FLOAT(ARRAY_SIZE)
C
	IF(NSEC.GT.1) THEN
	   PRINT *,'*****************************'
	   PRINT *,'*  Rescaling 3D MAP values  *'
	   PRINT *,'*****************************'
	   PRINT *,'OLD values'
	   PRINT *,'MIN_OLD,MAX_OLD =',MIN_OLD, MAX_OLD	
	   PRINT *,'NEW values'
	   PRINT *,'MIN_NEW,MAX_NEW =',MIN_NEW, MAX_NEW
	   PERCENT = 0.0
	   WRITE(*,'(1X,F5.1,''% done with 3D MAP'')') PERCENT
	ENDIF
C
	SCALE = 1.0
	IF(MIN_OLD.NE.MAX_OLD) THEN
	  SCALE = (MAX_NEW-MIN_NEW)/(MAX_OLD-MIN_OLD)
	ENDIF
	MAP_MIN = R4_MAX
	MAP_MAX = R4_MIN
	SUMSQ   = 0.0
	TOT     = 0.0
C
	KSTEP = DIV/10.0
	DO I = 1,ARRAY_SIZE
	  TMP2 = MAP(I)
	  IF(TMP2.GE.MIN_OLD.AND.TMP2.LE.MAX_OLD) THEN
	    TMP2   = MIN_NEW + (TMP2-MIN_OLD) * SCALE
	    MAP(I) = TMP2
	  ENDIF
	  SUMSQ   = SUMSQ + TMP2*TMP2
	  TOT     = TOT + TMP2
	  MAP_MIN = AMIN1(MAP_MIN,TMP2)
	  MAP_MAX = AMAX1(MAP_MAX,TMP2)
	  IF(FLOAT(I).GE.KSTEP) THEN
Ca	    IF(NOTIFY) THEN
Ca	      PERCENT = 100.0*FLOAT(I)/DIV
Ca	      WRITE(*,'(''+'',F5.1)') PERCENT
Ca	      KSTEP = KSTEP + DIV/10.0
Ca	    ENDIF
	  ENDIF
	ENDDO
C
	MAP_AVG = TOT/DIV
	MAP_STD = 0.0
	VAR     = (SUMSQ/DIV) - (MAP_AVG*MAP_AVG)
	IF(VAR.GE.0.0) MAP_STD = SQRT(VAR)
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE IMG_SHIFT     *****                 *
C  *                                                                          *
C  *    SHIFT DATA WITHIN IMG BY XSHIFT,YSHIFT.                               *
C  *                                                                          *
C  *    POINT LAYOUT FOR BI-LINEAR INTERPOLATION SCHEME :                     *
C  *                                                                          *
C  *          D4            D3                                                *
C  *                                                                          *
C  *                    + (dx,dy)                                             *
C  *                    .                                                     *
C  *          D1. . . . .   D2                                                *
C  * 									      *
C  *    THE INTERPOLATION ALGORITHM IS COMPUTED AS FOLLOWS:                   *
C  *                                                                          *
C  *          D1(1-dX)(1-dY) + D2(dX)(1-dY) + D3(dX)(dY) + D4(1-dX)(dY)       *
C  *                                                                          *
C  *    WHICH REDUCES TO:                                                     *
C  *                                                                          *
C  *          D1 + (D2-D1)dx + (D4-D1)dy + (D1-D2+D3-D4)dxdy                  *
C  *                                                                          *
C  *    FEBRUARY 1989 PURDUE UNIVERSITY VAX 8550, T. BAKER                    *
C  *    LAST MODIFIED 25-FEB-1989 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE IMG_SHIFT_local (IMG, NCOL, NROW, XSHIFT, YSHIFT,
	1                           img_bkg)
C
	IMPLICIT NONE
C
Ca	INCLUDE 'EM.CMM'
C
	INTEGER*4 NCOL, NROW
	real*4    img_bkg
	INTEGER*2 IMG(NCOL,NROW), IMG2(1)
	REAL*4    XSHIFT, YSHIFT
	POINTER   (IMG2_P,IMG2)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	IMG2_P = MALLOC (2*NCOL*NROW)
	CALL IMG$SHIFT$loc (IMG, IMG2, NCOL, NROW, XSHIFT, YSHIFT, img_bkg)
	IF(IMG2_P.NE.0) CALL FREE (IMG2_P)
C
	RETURN
	END
C  ============================================================================
	SUBROUTINE IMG$SHIFT$loc (IMG, IMG2, NCOL, NROW, XSHIFT, YSHIFT,
	1                           img_bkg)
C
	IMPLICIT NONE
C
Ca	INCLUDE 'EM.CMM'
C
	INTEGER*4 NCOL, NROW, I, J, IX1, IX2, IY1, IY2, ARRAY_SIZE
	real*4    img_bkg
	INTEGER*2 IMG(NCOL,NROW), IMG2(NCOL,NROW)
	REAL*4    X, Y, DX, DY, XSHIFT, YSHIFT, D1, D2, D3, D4
	LOGICAL   XSTART, XEND, YSTART, YEND
C  ----------------------------------------------------------------------------
C
	DO J = 1,NROW
	  Y   = J - YSHIFT
	  IY1 = INT(Y)
	  IY2 = IY1 + 1
	  DY  = Y - IY1
	  IF(IY1.GE.1 .AND. IY1.LE.NROW) THEN
	     YSTART = .TRUE.
	   ELSE
	     YSTART = .FALSE.
	  ENDIF
	  IF(IY2.GE.1 .AND. IY2.LE.NROW) THEN
	     YEND = .TRUE.
	   ELSE
	     YEND = .FALSE.
	  ENDIF
	  DO I = 1,NCOL
	    X   = I - XSHIFT
	    IX1 = INT(X)
	    IX2 = IX1 + 1
	    DX  = X - IX1
	    IF(IX1.GE.1 .AND. IX1.LE.NCOL) THEN
	       XSTART = .TRUE.
	     ELSE
	       XSTART = .FALSE.
	    ENDIF
	    IF(IX2.GE.1 .AND. IX2.LE.NCOL) THEN
	       XEND = .TRUE.
	     ELSE
	       XEND = .FALSE.
	    ENDIF
	    IF(XSTART.AND.YSTART) THEN
	       D1 = IMG(IX1,IY1)
	     ELSE
	       D1 = IMG_BKG
	    ENDIF
	    IF(XEND.AND.YSTART) THEN
	       D2 = IMG(IX2,IY1)
	     ELSE
	       D2 = IMG_BKG
	    ENDIF
	    IF(XEND.AND.YEND) THEN
	       D3 = IMG(IX2,IY2)
	     ELSE
	       D3 = IMG_BKG
	    ENDIF
	    IF(XSTART.AND.YEND) THEN
	       D4 = IMG(IX1,IY2)
	     ELSE
	       D4 = IMG_BKG
	    ENDIF
	    IMG2(I,J) = D1 + (D2-D1)*DX + (D4-D1)*DY
	1                  + (D1-D2+D3-D4)*DX*DY
	  ENDDO
	ENDDO
C  ********************************
C  *    COPY "IMG2" INTO "IMG"    *
C  ********************************
	ARRAY_SIZE = NCOL*NROW
	CALL COPY_I2 (IMG2, IMG, ARRAY_SIZE)
C
Ca	CALL IMG_STATS (IMG, NCOL, NROW)
C
	RETURN
	END


