C wei
C 1) LIB$GET_VM -- GET_VM
C 2) LIB$FREE_VM -- FREE_VM
C 3) read empft.dat format input lines and the output in emico.dat
C    has same format. note: the magfactor in not there yet, the same
C    parameter is used for triger_delta
C 4) use pif images
C 5) maxinum number of particles are set to 1000
C
C last modified by wei zhang, Feb.25 2001
C=========================================================================
C	PROGRAM - EMICOGRAD
	implicit none
C
	include '../libEM/INCfiles/emicograd.inc/list'
	record	/IMAGE/	IMAGE(MAX_IMAGES)	
	record/conformation/ START, NEXT
	record/save/ DELTA(MAX_IMAGES)
	INTEGER*4 INDEX(0:MAX_SIMPLEX-1), ILIST
	parameter (L_GRAD=7, NLINES=60, NLINES1=NLINES/2+1)
C		Storage will be dynamically allocated using the base 
C			addresses IADDR_AT,IADDR_BT
C
	INTEGER*4	II,JJ,II1,JJ1,II2,JJ2
	REAL*4	  SELF_ERROR(MBR+2)
	INTEGER*4 N_SELF_ERROR(MBR+2)
C	Virtual memory will be allocated for the large arrays after the 
c		buffer arrays for input are released
c
C	REAL*4	  RADERR(MBR+2, MAX_IMAGES, MAX_IMAGES)
C	INTEGER*4 NRADERR(MBR+2, MAX_IMAGES, MAX_IMAGES)
C	REAL*4	  TRADERR(MBR+2, MAX_IMAGES)
C	INTEGER*4 NTRADERR(MBR+2, MAX_IMAGES)
C	REAL*4	  ALINE(NLINES,MBR+2), BLINE(NLINES,MBR+2)
	INTEGER*4 LEN_RADERR, LEN_TRADERR, LEN_ALINE
	INTEGER*4 IADDR_RADERR, IADDR_NRADERR
	INTEGER*4 IADDR_TRADERR, IADDR_NTRADERR
	INTEGER*4 IADDR_ALINE, IADDR_BLINE

C	record/conformation/ SIMPLEX(MAX_SIMPLEX) ! This will be 
c		allocated seperately
	INTEGER*4 LEN_SAVE, LEN_CONFORMATION, MAX_VARY, IADDR_SIMPLEX
C
	record/hand/	HAND_SET(MAX_SET)
	INTEGER*4	N_SET, N_SUM
	REAL*4		SUM_MEAN
C
	REAL*4	  D_THETA, D_PHI, D_OMEGA, D_ORIGX, D_ORIGY, ERR_LIM
	REAL*4	  D_VECTOR, D_FACTOR, GRAD(L_GRAD)
	REAL*4    ALPHA1(NLINES), ALPHA2(NLINES)
	REAL*4    FMOD(MBR), TRANSFORM
	REAL*4	  RSC1, RSC2, DELRSC, RMIN, RMAX, DELR
	REAL*4	  RSCMAX, RINCR, RSCALE, FMOD1, FMIN
	INTEGER*4 NBAND, NSTEP1, NSTEP2, NSTEP3, NSTEP4, INA, N_SUMMED
	INTEGER*4 I, J, K, INCR, NSAMPL, NK, IRAD2, IRAD, N_IMAGES
	INTEGER*4 N_CYCLES, J_CYCLE, N_ACTIVE, IFLIP, ICO_IDIM
	INTEGER*4 N_MOVED(MAX_IMAGES)/MAX_IMAGES*0/
	INTEGER*4 N_SUB_CYCLES/8/
	LOGICAL	  ALLOW_FLIP, CHANGE_PARM /.FALSE./, GET_VM
	LOGICAL   SYS$INTERACTIVE
C  ----------------------------------------------------------------------------
C
	WRITE(6,'('' EMICOGRAD: Refine orientations of up to '', I4,
	1	'' images using '',I3,'' lines for comparison'')')
	1	MAX_IMAGES, NLINES
	WRITE(6,'('' This version uses amplitude weighted residuals for'',
	1	'' refinement '')')
	WRITE(6,'('' VERSION: 24-Jan-92 [TSB]'')')
C
C  ***********************************
C  *    PARAMETERS FOR TRANSF ETC    *
C  ***********************************
	DO WHILE (N_IMAGES.le.0 .or. N_IMAGES.gt.MAX_IMAGES)
	  WRITE(6,'(''$N_IMAGE,IFLIP,ILIST (<CR>='',I4,'',0,0):
	1           '')') MAX_IMAGES
	  READ(5,'(3I)') N_IMAGES, IFLIP, ILIST
	ENDDO
	IF(N_IMAGES.GT.10 .AND. IFLIP.GT.0) THEN
	  IFLIP = 0
	  WRITE(6,'('' HAND CHOICE DISSALLOWED FOR >10 PARTICLES'')')
	ENDIF
	ALLOW_FLIP = .FALSE.
	IF(IFLIP.EQ.2) THEN
	   ALLOW_FLIP = .TRUE.
	   WRITE(6,'('' EVALUATE AND REFINE HAND CHOICE'')')
	 ELSE IF(IFLIP.EQ.1) THEN
	   WRITE(6,'('' ONLY EVALUATE HAND CHOICE'')')
	ENDIF
	IF(ILIST.LE.0) ILIST = 0
C
C		Get limits for test of radial distance scaling
C
	WRITE(6,'('' RANGE OF RADIAL SCALING AND STEP SIZE TO TEST '',
	1 '' (3F)'')')
	WRITE(6,'(''$SCLMIN,SCLMAX,DELSCL <CR>=1.0,1.0,1.0 : '')')
	READ (5,'(3F)') RSC1, RSC2, DELRSC
	IF(RSC1.LE.0.0)   RSC1   = 1.0
	IF(RSC2.LE.0.0)   RSC2   = 1.0
	IF(DELRSC.LE.0.0) DELRSC = 1.0
	WRITE(6,'('' RSC1, RSC2, DELRSC '',3(2x,f))')RSC1, RSC2, DELRSC
c		Get max and min values of radius to be used
C  ***************************************************************
C  *    INPUT DESIRED FFT SIZE AND RANGE OF TRANSFORM TO USE     *
C  *     RES_MAX CANNOT EXCEED FLOAT(MBR)                        *
C  ***************************************************************
	WRITE(6,'(''$FFT_SIZE,RES_MIN,RES_MAX (I,2F): '')')
	READ (5,'(I,2F)') ICO_IDIM, RMIN, RMAX
	IF(RMIN.LE.0.0 .or. RMIN.gt.1.0*MBR) RMIN =  1.0
	IF(RMAX.LE.0.0 .or. RMAX.gt.1.0*MBR) RMAX = 1.0*MBR
	WRITE(6,'('' RMIN,RMAX '',2(2X,F))') RMIN, RMAX
	WRITE(6,'(''$ BANDS IN TF: INCR,NSAMPL <CR>='',x,i2,
	1	'' bands with '' ,x,i2,h, ,x,i2, 
	1	'' : '')') IFix((RMAX-RMIN)/4.0),4,4
	READ (5,'(2I)')  INCR ,NSAMPL
	IF(INCR.le.0) INCR = 4
	NBAND = IFix((RMAX-RMIN)/INCR)
	IF(NBAND .gt. MAX_BAND)   NBAND  = MAX_BAND
	IF(INCR.LE.0)             INCR   = 4
	IF(INCR.GT.MAX_INCR)      INCR   = MAX_INCR
	IF(NSAMPL.LE.0)           NSAMPL = 4
	IF(NSAMPL.GT.MAX_SAMPL)   NSAMPL = MAX_SAMPL
	WRITE(6,'('' NBAND, INCR, NSAMPL '',3(x,i3))') NBAND, INCR, NSAMPL
C
	RSCMAX = AMAX1(RSC2,1.0)
	IRAD2  = RMAX*RSCMAX+1.5
	do while (IRAD2.gt.MBR-INCR)
	    RMAX = RMAX-1.0
	    IRAD2  = RMAX*RSCMAX+1.5
	    CHANGE_PARM = .true.
	ENDDO
C
	IRAD = NBAND*INCR*RSCMAX+1
	do while (IRAD .gt. MBR-INCR ) 
	    NBAND = NBAND-1
	    IRAD = NBAND*INCR*RSCMAX+1
	    CHANGE_PARM = .true.
	ENDDO
C
	DELR   = float(INCR)/float(NSAMPL)
	NSTEP1 = (RMIN+0.1)/DELR
	NSTEP2 = (RMAX+0.1)/DELR
	NSTEP3 = NSTEP2+1
	NSTEP4 = NBAND*NSAMPL
	do while (NSTEP2.gt.MBR .or. NSTEP4.gt.MBR) 
	    NSAMPL = 80/NBAND
	    DELR   = float(INCR)/float(NSAMPL)
	    NSTEP1 = (RMIN+0.1)/DELR
	    NSTEP2 = (RMAX+0.1)/DELR
	    NSTEP3 = NSTEP2+1
	    NSTEP4 = NBAND*NSAMPL
	    CHANGE_PARM = .true.
	ENDDO
C
	IF(IRAD2.GT.IRAD) IRAD = IRAD2
	IF(NSTEP3.GT.IRAD) IRAD = NSTEP3
C
D	WRITE(6,*) 'nstep1,2,3,4', NSTEP1, NSTEP2, NSTEP3, NSTEP4
C
	RINCR  = FLOAT(INCR)
	NK     = 1.1+(RSC2-RSC1)/DELRSC
	do INA = 1,NBAND
	    FMOD(INA) = 0.0
	enddo
C
	IF(CHANGE_PARM) then
	    CALL BELL (2)
	    WRITE(6,
	1   '('' Parameters were changed to fit within program limits'')')
	    WRITE(6,'('' NBAND, INCR, NSAMPL '',3(x,i3))') 
	1	NBAND, INCR, NSAMPL
	    WRITE(6,'('' IRAD, RMIN, RMAX '',x,i3,x,f,x,f))') 
	1	IRAD, RMIN, RMAX
	ENDIF
	WRITE(6,'('' Refinement parameters :'')')
	WRITE(6,'(h$
	1  ''Delta Theta, Delta Phi, Delta Omega, Cycles, Error limit, Fmin ''
	1	/,t5,'' (3f,i,2f <cr>=):'',
	1	3(x,f)x,i3,x,2f,h:)') 1.,1.,1.,10,50.,-1.0
	READ(5,'(3F,I,5F)') D_THETA, D_PHI, D_OMEGA, N_CYCLES, 
	1	ERR_LIM, FMIN, D_FACTOR, D_ORIGX, D_ORIGY
	IF(D_FACTOR.LE.0.0) D_FACTOR = 0.8
	IF( D_THETA.eq.0.0 .and. D_PHI.eq.0.0 .and. D_OMEGA.eq.0.0 
	1 .and. D_ORIGX.EQ.0.0 .and. D_ORIGY.eq.0.0) then
	  D_THETA  =  1.0
	  D_PHI    =  1.0
	  D_OMEGA  =  1.0
	  D_ORIGX  =  0.0
	  D_ORIGY  =  0.0
	  N_CYCLES =   10
	  ERR_LIM  = 50.0
	  FMIN     = -1.0
	ENDIF
C
C	NOTE: SHOULD THE DIVISOR BE 5.0 AS DONE INSIDE LOOP BELOW ???
C
	D_VECTOR = (D_THETA+D_PHI+D_OMEGA+D_ORIGX+D_ORIGY)/3.0
	MAX_VARY = 0
	IF(D_ORIGX.gt.0.0) MAX_VARY=MAX_VARY+1
	IF(D_ORIGY.gt.0.0) MAX_VARY=MAX_VARY+1
	IF(D_OMEGA.gt.0.0) MAX_VARY=MAX_VARY+1
	IF(D_THETA.gt.0.0) MAX_VARY=MAX_VARY+1
	IF(D_PHI.gt.0.0) MAX_VARY=MAX_VARY+1
	IF(D_PHI.gt.0.0 .and. D_THETA.gt.0) MAX_VARY=MAX_VARY+1
C
	WRITE(6,'('' Vector delta = '',f,'' Number of parameters to vary '',
	1	i3)') D_VECTOR, MAX_VARY
C
	IF(D_VECTOR.le.0.0 .or. MAX_VARY.le.0) then
	  WRITE(6,'('' No refinement requested '')')
	  N_CYCLES = 0
	ENDIF
	CALL GRAD_INPUT (IMAGE, N_IMAGES, IRAD, FMIN, RMIN, RMAX,
	1                TRANSFORM, ICO_IDIM)

	CALL GRAD_ORIENTATIONS (IMAGE, N_IMAGES)
C  ******************************************
C  *    ALLOCATE VM FOR THE LARGE ARRAYS    *
C  *     USED BY THE REFINEMENT PROCEDURE   *
C  ******************************************
	CALL LIB$SHOW_VM
	LEN_RADERR  = (IRAD+2)*N_IMAGES*N_IMAGES
	LEN_TRADERR = (IRAD+2)*N_IMAGES*N_IMAGES
	LEN_ALINE   = NLINES*(IRAD+2)
	IF(.NOT.GET_VM(4*2*(LEN_RADERR+LEN_TRADERR+LEN_ALINE),
	1	IADDR_RADERR, 'IADDR_RADERR') ) then
	   WRITE(6,'('' MAIN: Allocation of virtual memory failed!'')')
	   WRITE(6,'('' NEEDED '',i,'' BYTES '')')
	1	4*2*(LEN_RADERR+LEN_TRADERR+LEN_ALINE)
	    CALL LIB$SHOW_VM()
	    CALL EXIT
	 ELSE
	   IADDR_NRADERR  = 4*LEN_RADERR  + IADDR_RADERR
	   IADDR_TRADERR  = 4*LEN_RADERR  + IADDR_NRADERR
	   IADDR_NTRADERR = 4*LEN_TRADERR + IADDR_TRADERR
	   IADDR_ALINE    = 4*LEN_TRADERR + IADDR_NTRADERR
	   IADDR_BLINE    = 4*LEN_ALINE   + IADDR_ALINE
	ENDIF
	CALL LIB$SHOW_VM
	CALL CALC_FINAL_RESIDUAL_ALL_IMAGES (IMAGE, %VAL(IADDR_RADERR),
	1 %VAL(IADDR_NRADERR), ALPHA1, ALPHA2, NLINES,
	2 %VAL(IADDR_ALINE), %VAL(IADDR_BLINE), FMOD, RSC1,
	3 RSC2, DELRSC, RMIN, RMAX, DELR, IRAD, RSCMAX, RINCR,
	4 RSCALE, FMOD1, FMIN, NBAND, N_SUMMED, NSAMPL, NK,
	5 N_IMAGES, TRANSFORM)
	CALL PRINT_ERROR_MATRIX (IMAGE, N_IMAGES)
C
	IF(N_CYCLES.GE.1) THEN
	   WRITE(6,'('' &&&&&&&&&&&& Gradient refinement &&&&&&&&&&&&&& '')')	
	   DO J_CYCLE = 1,N_CYCLES
	     CALL CHECK_FOR_ACTIVE (IMAGE, N_IMAGES, D_VECTOR, N_ACTIVE)
	     CALL GRADIENT_REFINE (IMAGE, J_CYCLE, N_SUB_CYCLES,
	1     N_IMAGES, IRAD, DELR, D_THETA, D_PHI, D_OMEGA, D_VECTOR,
	2     L_GRAD, GRAD, ERR_LIM, ALPHA1, ALPHA2, NLINES, NLINES1,
	3     %VAL(IADDR_ALINE), %VAL(IADDR_BLINE), NBAND, FMOD, N_MOVED,
	4     NSAMPL, NK, RMIN, RMAX, RSCALE, RSC1, DELRSC, FMOD1, 
	5     %VAL(IADDR_NRADERR), %VAL(IADDR_RADERR), N_SUMMED,
	6     TRANSFORM, ALLOW_FLIP, ILIST)
	     D_THETA  = D_FACTOR*D_THETA
	     D_PHI    = D_FACTOR*D_PHI
	     D_OMEGA  = D_FACTOR*D_OMEGA
	     D_ORIGX  = D_FACTOR*D_ORIGX
	     D_ORIGY  = D_FACTOR*D_ORIGY
	     D_VECTOR = (D_THETA+D_PHI+D_OMEGA+D_ORIGX+D_ORIGY)/5.0
	   ENDDO
	 ELSE IF (N_CYCLES.LT.0) THEN
	    WRITE(6,'('' &&&&&&&&&&&& Simplex refinement &&&&&&&&&&&&&& '')')	
	    N_CYCLES         = - N_CYCLES
	    LEN_SAVE         = M_ORIENT
	    LEN_CONFORMATION = 2+MAX_IMAGES*LEN_SAVE
	    IF(.NOT.GET_VM(4*(MAX_VARY+1)*N_IMAGES*
	1    LEN_CONFORMATION,IADDR_SIMPLEX, 'IADDR_SIMPLEX')) THEN
		write(6,'('' Not enough room to open SIMPLEX '')')
	        write(6,'('' needed '',i,'' bytes '')')
	1	4*(MAX_VARY+1)*N_IMAGES*LEN_CONFORMATION
	        CALL LIB$SHOW_VM()
		CALL EXIT
	    ENDIF
	    CALL LIB$SHOW_VM
	    CALL REFINE_SIMPLEX (IMAGE, N_IMAGES, %VAL(IADDR_SIMPLEX),
	1    START, NEXT, DELTA, D_THETA, D_PHI, D_OMEGA, D_ORIGX,
	2    D_ORIGY, %VAL(IADDR_RADERR), %VAL(IADDR_NRADERR), ALPHA1,
	3    ALPHA2, NLINES, %VAL(IADDR_ALINE), %VAL(IADDR_BLINE),
	4    FMOD, RSC1, RSC2,DELRSC, RMIN, RMAX, DELR, IRAD, RSCMAX,
	5    RINCR, RSCALE, FMOD1, FMIN, NBAND, N_SUMMED, NSAMPL, NK,
	6    ERR_LIM, N_CYCLES, TRANSFORM)
	ENDIF	
C
	IF(N_CYCLES.NE.0) THEN
	  WRITE(6,'('' Image orientations after refinement'')')
	  WRITE(6,'('' -----------------------------------'')')
	  CALL GRAD_ORIENTATIONS (IMAGE, N_IMAGES)
	  CALL GRAD_ORIENTATION_CHANGES (IMAGE, N_IMAGES)
	  CALL CALC_FINAL_RESIDUAL_ALL_IMAGES (IMAGE, %VAL(IADDR_RADERR),
	1  %VAL(IADDR_NRADERR), ALPHA1, ALPHA2, NLINES,
	2  %VAL(IADDR_ALINE), %VAL(IADDR_BLINE), FMOD, RSC1,
	3  RSC2, DELRSC, RMIN, RMAX, DELR, IRAD, RSCMAX, RINCR,
	4  RSCALE, FMOD1, FMIN, NBAND, N_SUMMED, NSAMPL, NK,
	5  N_IMAGES, TRANSFORM)
	  CALL PRINT_ERROR_MATRIX (IMAGE, N_IMAGES)
	ENDIF
C
	IF(N_ACTIVE.gt.8 .and. N_ACTIVE.le.MAX_SET) THEN
	   N_SET = N_ACTIVE
	 ELSE IF (N_ACTIVE.gt. MAX_SET) then
	   N_SET = MAX_SET
	 ELSE
	   N_SET = min(50,2**(min(N_IMAGES-1,N_ACTIVE)), MAX_SET)
	ENDIF
C  *****************************************************************
C  *    FOR NOW SUPPRESS ANY ATTEMPTS TO CALCULATE THE HAND SET    *
C  *     IF THERE ARE MORE THAN 10 IMAGES.                         *
C  *****************************************************************
	IF(IFLIP.EQ.0) GO TO 900
	CALL CALCULATE_HAND_SET (IMAGE, N_IMAGES, HAND_SET, N_SET, 
	1	SUM_MEAN, N_SUM)
	CALL PRINT_HAND_SET (HAND_SET, N_SET, SUM_MEAN, N_SUM, N_IMAGES)
  900	CALL CALC_ERROR_VS_RESLN (N_IMAGES,%VAL(IADDR_RADERR),RMIN,RMAX,
	1 %VAL(IADDR_NRADERR),%VAL(IADDR_TRADERR),%VAL(IADDR_NTRADERR),
	2 SELF_ERROR, N_SELF_ERROR, INCR, IRAD)
	CALL PRINT_ERROR_VS_RESLN (N_IMAGES,%VAL(IADDR_RADERR),RMIN,
	1 RMAX, %VAL(IADDR_NRADERR),%VAL(IADDR_TRADERR),
	2 %VAL(IADDR_NTRADERR), INCR, IRAD, ILIST)
	CALL CALC_PRINT_AVG_ERROR_ALL_IMAGES (RMIN, RMAX, INCR,
	1 %VAL(IADDR_TRADERR),%VAL(IADDR_NTRADERR),
	1 SELF_ERROR, N_SELF_ERROR, N_IMAGES, IRAD)
	CALL GRAD_OUTPUT (IMAGE, N_IMAGES)
Cwei add free vm
cwei	CALL FREE_VM(4*2*(LEN_RADERR+LEN_TRADERR+LEN_ALINE),
cwei	1	IADDR_RADERR, 'IADDR_RADERR') 
	CALL EXIT
C  ============================================================================
	END

! GRAD_INPUT
c	
C	Inputs all images by calls to GRAD_READ
C
c		Virtual memory assigned in one lump for all arrays
c	real*4  AT(IRAD*2+1,IRAD+2), BT(IRAD*2+1,IRAD+2), FCUT(IRAD+2)
c
C	ADAPTED FROM INPUT_ALL_IMAGES (29-JUNE-89 VERSION)
C--------------------------------------------------------------------------
	SUBROUTINE GRAD_INPUT (IMAGE, N_IMAGES, IRAD, FMIN, RMIN,
	1                      RMAX, TRANSFORM, ICO_IDIM)
C
	IMPLICIT NONE
C
	INCLUDE		'../libEM/INCfiles/EMICOGRAD.INC/NOLIST'
	INCLUDE	'../libEM/INCfiles/PIFHEAD.INC'
	RECORD	/IMAGE/	IMAGE(MAX_IMAGES)	
C
	REAL*4    FMIN, RMIN, RMAX, TRANSFORM
	INTEGER*4 IRAD, N_IMAGES, I, ICO_IDIM, FFT_ADDR
	INTEGER*4 IADDR_BASE, LEN_ATBT, LEN_ATBTFCUT, LEN_FCUT
Cwei add pif stuff
        INTEGER*4 PIFMODE, BINSWITCH, IDIM1, IDIM2
	INTEGER*4 NCOL, NROW, NSEC
        INTEGER*4 lun,nimg,htype,endianNess, thisNSEC, imgoffset
        REAL*4    floatScaleFactor, recipFloatScaleFactor,scale1,SCALE2
        REAL*4   PERCENT, DIV 
        BYTE      versionStr(35)
        BYTE      readWrite(4)
        CHARACTER FNAME*64, ico_title*80

	LOGICAL   GET_VM
C  ----------------------------------------------------------------------------
C
C  *******************************************
C  *    OPEN VIRTUAL MEMORY FOR TRANSFORM    *
C  *******************************************
	LEN_ATBT     = (2*IRAD+1)*(IRAD+2)
	LEN_FCUT     = IRAD+2
	LEN_ATBTFCUT = (2*LEN_ATBT+LEN_FCUT)
C
	IF(.NOT.GET_VM (N_IMAGES*4*LEN_ATBTFCUT, IADDR_BASE, 
	1	'IADDR_BASE')) then
	   WRITE(6,
	1  '('' input all images: Allocation of virtual memory failed!'')')
	   WRITE(6,'('' needed '',i,'' bytes '')') N_IMAGES*4*(LEN_ATBTFCUT)
	   CALL LIB$SHOW_VM()
	   CALL EXIT
	   RETURN
	ENDIF
	CALL LIB$SHOW_VM()
	CALL GET_VM (8*ICO_IDIM*ICO_IDIM, FFT_ADDR, 'FFT_ADDR')
Cwei add pif image stuff
        LUN = 7
cwz        EM_WRT = 0
        READWRITE(1) = 'r'
   10   WRITE (6,'(''$Enter PIF filename:  '')')
        READ (5,'(A)',ERR=10) FNAME
        
        call pif_open_vms_(FNAME, LUN, readWrite)
        call pif_read_header_ (LUN, nimg,
	1       recipFloatScaleFactor, htype,
	2       NCOL, NROW, NSEC, pifmode, endianNess, versionStr)
Cwei end	
	DO I = 1,N_IMAGES
	  IMAGE(I).IADDR_AT = IADDR_BASE+(I-1)*4*LEN_ATBTFCUT
	  IMAGE(I).IADDR_BT = IMAGE(I).IADDR_AT+4*LEN_ATBT
	  IMAGE(I).IADDR_FCUT = IMAGE(I).IADDR_BT+4*LEN_ATBT
Cwei modified grad_read
	  IMAGE(I).FILE_NAME = FNAME
	  CALL FFT_SETDIM_DEF_SAME (NCOL, NROW, IDIM1, IDIM2, 1)
	  ICO_IDIM = IDIM1
	  TRANSFORM = 1.0*IDIM1
	  CALL GRAD_READ (LUN, I, IRAD, FMIN, RMIN, RMAX,
	1  %VAL(IMAGE(I).IADDR_AT), %VAL(IMAGE(I).IADDR_BT),
	1  IMAGE(I).THETA, IMAGE(I).PHI, IMAGE(I).OMEGA,
	1  IMAGE(I).ORIGX, IMAGE(I).ORIGY,%VAL(IMAGE(I).IADDR_FCUT), 
	1  IMAGE(I).TRIGGER_DEL, %VAL(FFT_ADDR), IMAGE(I).PFT_CC, 
	1  IMAGE(I).PRJ_CC, IMAGE(I).CMP_CC, IMAGE, ICO_IDIM,
	1  NCOL, NROW, IMAGE(I).ID)
	  IMAGE(I).OLD.THETA     = -1000.0
	  IMAGE(I).OLD.RESAVG    = 1.0e20
	  IMAGE(I).OLD.ANGLE     =    -1.0      	! all start 
	  IMAGE(I).PRESENT.ANGLE =    -1.0  		! out in radians
C
C----------------	addition to allow monitoring of flipping of particles
c----------------		through field FLIPPED
	  IMAGE(I).FLIPPED         = .FALSE.
	  IMAGE(I).OLD.FLIPPED     = .FALSE.
	  IMAGE(I).PRESENT.FLIPPED = .FALSE.
	  IMAGE(I).ORIGINAL        = IMAGE(I).PRESENT
C------------------		need this to be compatable with origin refining
c					version of simplex
	ENDDO
	CALL FREE_VM (8*ICO_IDIM*ICO_IDIM, FFT_ADDR, 'FFT_ADDR')
C
        CALL PIF_CLOSE_(LUN)

	RETURN
	END

! GRAD_ORIENTATIONS
c
c	Prints the orientations of all images
C
C	ADAPTED FROM PRINT_IMAGE_ORIENTATIONS (VERSION 9-MAR-1989)
c
C		mrc conversion sdf - 17-jan-87
C	Cosmetic changes made  9-Mar-89 by T. Baker
C----------------------------------------------------------------------------
C
	SUBROUTINE GRAD_ORIENTATIONS (IMAGE, N_IMAGES)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/EMICOGRAD.INC/NOLIST'
	RECORD /IMAGE/ IMAGE(MAX_IMAGES)
	INTEGER*4	N_IMAGES, I
C  ----------------------------------------------------------------------------
C
	WRITE(6,1000)
 1000	FORMAT(' Particle',2X,'Filename',36X,'Theta',5X,'Phi',5X,
	1 'Omega',3X,'Orig_X',2X,'Orig_Y')
C
	DO I = 1,N_IMAGES
	  WRITE(6,'(I6,5X,A,2X,F7.2,2F9.2,2F8.2)')
	1	I, IMAGE(I).FILE_NAME,
	1	mod(IMAGE(I).THETA*DEGREE,360.),
	1	mod(IMAGE(I).PHI*DEGREE,360.),
	1	mod(IMAGE(I).OMEGA*DEGREE,360.),
	1	IMAGE(I).ORIGX, IMAGE(I).ORIGY
	ENDDO
C
	RETURN
	END

! GRAD_READ
c
c
c	Get orientations and read in each image
c		store in direct access file
c
c				sdf 26-nov-1985
c
C		mrc conversion sdf - 17-jan-87
C		last revision sdf 3-feb-87
c
C		conversion back to TSB format 26-june-89
C----------------------------------------------------------------------------
C
	SUBROUTINE GRAD_READ (LUN, IMAGE_NUM, IRAD, FMIN, RMIN, RMAX,
	1 AT, BT, THETA, PHI, OMEGA, ORIGX, ORIGY, FCUT, 
	2 TRIGGER_DEL,  FFT, PFT_CC, PRJ_CC, CMP_CC, IMAGE,
	3 ICO_IDIM, NCOL, NROW, NUM)
C
	IMPLICIT NONE
C
	INCLUDE 'SYS$EMLIB:EM.CMM'
	INCLUDE '../libEM/INCfiles/EMICOGRAD.INC/NOLIST'
        INCLUDE '../libEM/INCfiles/PIFHEAD.INC'
C
	RECORD /IMAGE/ IMAGE(MAX_IMAGES)
C
	INTEGER*4 NCOL, NROW, IMG_ADDR, NCOL1, NROW1
	INTEGER*4 IMAGE_NUM, LUN, IDIM1, IDIM2, ICO_IDIM, IREC
	INTEGER*4 I,  LAST, IRAD, MINR, MAXR, NUM, ARRAY_SIZE
	REAL*4    THETA, PHI, OMEGA, FFT(2*ICO_IDIM,ICO_IDIM)
	REAL*4    FMIN, RMIN, RMAX, TRANSFORM, ORIGX, ORIGY
	REAL*4    AT(1), BT(1), FCUT(1), TRIGGER_DEL
Cwz
	REAL*4    PFT_CC, PRJ_CC, CMP_CC
        INTEGER*4 PIFMODE, BINSWITCH , IMG_NUM
        INTEGER*4 nimg,htype,endianNess, thisNSEC, imgoffset
        REAL*4    floatScaleFactor, recipFloatScaleFactor,scale1,SCALE2
        REAL*4   PERCENT, DIV 
        BYTE      versionStr(35)
        BYTE      readWrite(4)
        CHARACTER FNAME*64, ico_title*80
cwz	CHARACTER*(*)	FILE_NAME
	LOGICAL   SYS$INTERACTIVE
Cwz?	SAVE      NCOL, NROW
C  ----------------------------------------------------------------------------
C
	CALL PIRADDEG (PI, RADIAN, DEGREE)
C
	IF(SYS$INTERACTIVE()) THEN
	  WRITE(6,'('' Input of Image # '',X,I3)') IMAGE_NUM
	ENDIF
cwz	IF(IMAGE_NUM.GT.1 .AND. BYTEDATA) GO TO 200
C  *************************
C  *    OPEN IMAGE FILE    *
C  *************************
cwz  100	LUN          = 1
cwz	EM_WRT       = 0
cwz	IMG_FILENAME = ' '
cwz	CALL IMG_OPEN (LUN, NCOL, NROW)
cwz  200	FILE_NAME = IMG_FILENAME
	IDIM1     = ICO_IDIM
	IDIM2     = ICO_IDIM
cwz	TRANSFORM = 1.0*IDIM1
C  ******************************************************
C  *    GET PARTICLE NUMBER, ORIENTATION, AND ORIGIN    *
C  ******************************************************
	IF(SYS$INTERACTIVE()) THEN
	  PRINT *, '*********************************************'
	  PRINT *, '* ENTER (I,6F FORMAT):                      *'
	  PRINT *, '* NUM,THETA,PHI,OMEGA,ORIGX,ORIGY,T_DEL     *'
	  PRINT *, '* If T_DEL = -1.0, particle is NOT refined. *'
	  PRINT *, '*********************************************'
	  WRITE(6,'(''$NUM,THE,PHI,OME,ORIGX,ORIGY,T_DEL: '')')
	ENDIF
c wei add read pft_cc prj_cc and cmp_cc
	READ (5,'(I,9F)') NUM, THETA, PHI, OMEGA, FFT_ORIGX,
	1                 FFT_ORIGY, TRIGGER_DEL, PFT_CC,
	2		  PRJ_CC, CMP_CC

cwz	IF(NUM.EQ.-999) GO TO 100
cwz	IF(BYTEDATA) THEN
cwz	   IMAGE(IMAGE_NUM).ID = -NUM
cwz	 ELSE
cwz	   IMAGE(IMAGE_NUM).ID =  NUM
cwz	ENDIF
	IF(TRIGGER_DEL.LE.0.0 .AND. TRIGGER_DEL.NE.-1.0) THEN
	  TRIGGER_DEL = 9999.
	ENDIF
	ORIGX = FFT_ORIGX
	ORIGY = FFT_ORIGY
C
cwz	IF(BYTEDATA) THEN
cwz	   CALL IMG_PACK_FIND (LUN, NUM, NCOL, NROW, IREC)
cwz	   ARRAY_SIZE = NCOL*NROW
cwz	   CALL GET_VM (2*ARRAY_SIZE, IMG_ADDR, 'IMG_ADDR')
cwz	   CALL IMG_FILL (LUN, %VAL(IMG_ADDR), NCOL, NROW, IREC)
cwz	 ELSE
cwz	   ARRAY_SIZE = NCOL*NROW
cwz	   CALL GET_VM (2*ARRAY_SIZE, IMG_ADDR, 'IMG_ADDR')
cwz	   CALL IMG_FILL (LUN, %VAL(IMG_ADDR), NCOL, NROW, 0)
cwz	ENDIF
        CALL GET_VM (2*NCOL*NROW, IMG_ADDR,  'IMG_ADDR')
        call pif_read_image_header_ (LUN, NUM,
	1       recipfloatscalefactor, img_bkg,
	2       IMG_MIN, IMG_MAX, IMG_AVG, IMG_STD,
	3       NCOL1, NROW1, thisNSEC, imgOffset, pifMode, htype, 
	4	ico_title)
        
            binSwitch = 0   ! Don't BIN the image  
            
            CALL pif_read_byteShort_image_(LUN, %VAL(IMG_ADDR), 
	1               imgOffset, NCOL, NROW, thisNSEC, binSwitch)

C  *********************************************************************
C  *    COMPUTE FFT, CONVERT TO POLAR, AND BRING DOWN REQUIRED AREA    *
C  *********************************************************************
	CALL IMG_FFT_FILL (%VAL(IMG_ADDR), NCOL, NROW, FFT, IDIM1, IDIM2)
	CALL FFT_2D (FFT, IDIM1, IDIM2)
	CALL FFT_TO_ATBT (FFT, IDIM1, IDIM2, AT, BT, IRAD)
	CALL FREE_VM (2*NCOL*NROW, IMG_ADDR, 'IMG_ADDR')
C  **************************************************
C  *    ZERO LOW VALUE PARTS OF IMAGE USING FMIN    *
C  **************************************************
	MINR = NINT(RMIN)
	MAXR = NINT(RMAX)
	CALL ZMINC (AT, BT, IRAD, MINR, MAXR, FMIN, FCUT)
C
	THETA = THETA*RADIAN
	PHI   = PHI*RADIAN
	OMEGA = OMEGA*RADIAN
C	
	RETURN
	END

! GRAD_OUTPUT
c
c	Prints the orientations of all images in a format suitable for 
c 		input to the refinement program
c
C		mrc conversion sdf - 17-jan-87
C		last revision sdf - 31-jan-87
c		last revision sdf - 11-jan-88
C    LAST MODIFIED 16-NOV-90 BY T. BAKER
C----------------------------------------------------------------------------
c
	SUBROUTINE GRAD_OUTPUT (IMAGE, N_IMAGES)
C
	IMPLICIT NONE
	INCLUDE '../libEM/INCfiles/EMICOGRAD.INC/NOLIST'
	RECORD /IMAGE/ IMAGE(MAX_IMAGES)
	INTEGER*4	N_IMAGES, I
C......................................................................
C
	WRITE(6,'('' Image orientations in proper format for
	1 another run'')')
	WRITE(6,'('' ---------------------------------------
	1------------'')')
	OPEN (UNIT=3, NAME='EMICO.DAT', STATUS='NEW',
	1 ACCESS='SEQUENTIAL', FORM='FORMATTED', CARRIAGECONTROL='LIST')
C
	DO I = 1, N_IMAGES
	  IF(I.EQ.1) THEN
	    WRITE(3,'(A)')    IMAGE(I).FILE_NAME
	    WRITE(6,'(1X,A)') IMAGE(I).FILE_NAME
	  ENDIF
	  IF(I.GT.1 .AND. IMAGE(I).FILE_NAME.NE.IMAGE(I-1).FILE_NAME)
	1  THEN
	    IF(IMAGE(I).ID.LT.0) THEN
	      WRITE(3,'(I5)') -999
	      WRITE(6,'(I5)') -999
	    ENDIF
	    WRITE(3,'(A)')    IMAGE(I).FILE_NAME
	    WRITE(6,'(1X,A)') IMAGE(I).FILE_NAME
	  ENDIF
	  WRITE(3,1020)  IABS(IMAGE(I).ID), 
	2  MOD(IMAGE(I).THETA*DEGREE,360.),
	3  MOD(IMAGE(I).PHI*DEGREE,360.),
	4  MOD(IMAGE(I).OMEGA*DEGREE,360.),
	1  IMAGE(I).ORIGX, IMAGE(I).ORIGY, IMAGE(I).TRIGGER_DEL,
	2  IMAGE(I).PFT_CC, IMAGE(I).PRJ_CC, IMAGE(I).CMP_CC
	  WRITE(6,1020)  IABS(IMAGE(I).ID), 
	2  MOD(IMAGE(I).THETA*DEGREE,360.),
	3  MOD(IMAGE(I).PHI*DEGREE,360.),
	4  MOD(IMAGE(I).OMEGA*DEGREE,360.),
	1  IMAGE(I).ORIGX, IMAGE(I).ORIGY, IMAGE(I).TRIGGER_DEL,
	2  IMAGE(I).PFT_CC, IMAGE(I).PRJ_CC, IMAGE(I).CMP_CC
	ENDDO
C
	CLOSE (UNIT=3, DISP='KEEP')
	RETURN
 1020   FORMAT (1X,I6,',',4(F8.3,','),F7.3,',',3(F6.3,','),F6.3)
C
	END
