C  ****************************************************************************
C  *									      *
C  *	            *****     SUBROUTINE ICO_BRUTE     *****                  *
C  *									      *
C  *    DRIVER ROUTINE FOR BRUTE FORCE SEARCH BY ICO_BRUTE_RSYM.              *
C  *									      *
C  *    JULY 1985  S. FULLER                                                  *
C  *    MODIFIED  2-OCT-1991 BY T. BAKER.                                     *
C  *    LAST MODIFIED  22-sep-2005 dg morgan fixes mistake in call used for         *
C  *                                 ILIST  > 1                               *
C  ****************************************************************************
C
	SUBROUTINE ICO_BRUTE1 (ROT, AT, BT, ARGPOL, FPOL, APOL, BPOL,
	1 IRAD, IDIM1, RADMIN, FMINC, TITLE, ILIST, IMG_NUM, XCEN,YCEN)
C
	IMPLICIT NONE
C
	COMMON /BLOCKP/ NANG, MINR, MAXR, NSAMPL, FMIN
	INTEGER*4 N_PHI(22), IP_START(22), N_ENTRIES, I, IRAD, IDIM1
	INTEGER*4 NTH, NPH, ITH, NANG, MINR, MAXR, NSAMPL, ILIST
	INTEGER*4 TITLE(18), IMG_NUM
	REAL*4	  ROT(1), AT(1), BT(1), ARGPOL(1), FPOL(1)
	REAL*4    APOL(1), BPOL(1), RADMIN, FMINC
	REAL*4	  PHIMAX, THETA, PHI_START(22), FMIN
	REAL*4     XCEN, YCEN
Ca	LOGICAL	  LIB$GET_VM
C_____________________________________________________________________________
C
	THETA     = 69.0
	N_ENTRIES = 0
C
	DO ITH = 1,22
	  PHIMAX         = (THETA-69.0)*32.0/21.0
	  NPH            = INT(PHIMAX + 0.5)
	  IP_START(ITH)  = (32.0 + 0.5) - NPH
	  NPH            = NPH*2 + 1
	  PHI_START(ITH) = -(NPH-1)/2.0
	  N_PHI(ITH)     = NPH
	  THETA          = THETA+ 1.0
	  N_ENTRIES      = N_ENTRIES + N_PHI(ITH)
	ENDDO	
C
	CALL ICO_BRUTE_RSYM1 (ROT, AT, BT, ARGPOL, FPOL, APOL, BPOL, 
	1 PHI_START, N_PHI, IP_START, N_ENTRIES, IRAD, IDIM1, RADMIN,
	2 FMINC, TITLE, ILIST, IMG_NUM, XCEN, YCEN)
C
	RETURN
	END

C  ********************************************************************
C  *                                                                  *
C  *              *****     ICO_BRUTE_RESREAD     *****               *
C  *                                                                  *
C  *    Generates readable output of residual maps from rsym searches *
C  *                                                                  *
C  *    MAY 1985  S. Fuller                                           *
C  *    LAST MODIFIED 12-DEC-88 BY T. BAKER (ADAPTED FROM RESREAD)    *
C  ********************************************************************
C
	SUBROUTINE ICO_BRUTE_RESREAD1 (THETA, RESID, PHI, ID)
C
	IMPLICIT NONE
C
	INCLUDE '../libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ IMGHEAD, chartHead
	COMMON /PIFHEAD/   IMGHEAD, chartHead
C
	COMMON      IREC4
	INTEGER*4   N_SUMRES, MARK, IREC4, RES(65), ID
	INTEGER*2   IRESID(65), I, J, IVAL,k 
	real*4      chartBuf(65,65), minF,maxF
	REAL*4      THETA(22), RESID(22,65), PHI(65), MIN, SUMRES
	BYTE        READWRITE(4)
	CHARACTER*4 OUTCHAR(65)
C  ----------------------------------------------------------------------------
C
	maxF = 0.0
	MIN = 1.0E26
	DO J = 1,65
	  DO I = 1,22
	    IF (ABS(RESID(I,J)).GE.1E-26.AND.MIN.GT.RESID(I,J)) THEN
	      MIN = RESID(I,J)		
	    ENDIF
	  ENDDO
        ENDDO

	print *, '***', ID
C	
	IVAL = 0
	DO J = 1,65
	  DO I = 1,22
	    IF(100.*MIN.GT.RESID(I,J)) IVAL = IVAL + 1
	  ENDDO
        ENDDO
	
	write(6,1000) ival       ! dgm adds this for tracking
 1000   format(/,' IVAL is ',i5,/)
C
	IF(IVAL.LT.22*65/2) THEN
	   WRITE(1,'('' Minimum value is '',F15.4,
	1    ''    All values scaled to this as 10 '')') MIN
	   WRITE(6,'('' Minimum value is '',F15.4,
	1    ''    All values scaled to this as 10 '')') MIN
	   MIN  = MIN*10.0
	   MARK = 10
	 ELSE
	   WRITE(1,'('' Minimum value is '',F15.4,
	1   ''    All values scaled to this as 100 '')') MIN
	   WRITE(6,'('' Minimum value is '',F15.4,
	1   ''    All values scaled to this as 100 '')') MIN
	   MARK = 100
	ENDIF
C
	WRITE(1,'(''1'',4X,22(I4))') (NINT(THETA(I)),I=1,22)
	WRITE(6,'(''1'',4X,22(I4))') (NINT(THETA(I)),I=1,22)
C
	SUMRES   = 0.0
	N_SUMRES = 0
C
	IREC4 = 2 + (ID-1)*65
	DO J = 1,65
	  DO I = 1,22
	    IF(RESID(I,J).GE.1.0E-26) THEN
	      SUMRES   = SUMRES + RESID(I,J)
	      N_SUMRES = N_SUMRES + 1
	    ENDIF
	    IRESID(I) = NINT(100.*AMIN1(99.99,RESID(I,J)/(1.0*MIN)))
	    IF(IABS(IRESID(I)-MARK).LT.10) THEN
	       OUTCHAR(I) = '____'
	     ELSE
	       OUTCHAR(I) = '    '
	    ENDIF
Ca    Let's stuff the emicochart.pif buffer here
Ca    Remember PIF stores in XWindows orientation with 0,0 in ULHC
	    chartBuf(i+20,(65-j)) = resid(i,j)
	    maxF = MAX(maxF,abs(resid(i,j)))
	    IF(IRESID(I).LT.0) IRESID(I) = 0
	  ENDDO
	  WRITE(1,'(5X,22(A4))') (OUTCHAR(I),I=1,22)
	  WRITE(6,'(5X,22(A4))') (OUTCHAR(I),I=1,22)
	  WRITE(1,'(''+'',I3,1X,22I4)') NINT(PHI(J)), (IRESID(I),I=1,22)
	  WRITE(6,'(''+'',I3,1X,22I4)') NINT(PHI(J)), (IRESID(I),I=1,22)
	ENDDO
Cwz  --  BEGIN emicochart.tmp code

	DO k = 1,65
           j=66-k
           DO I = 1,65
	      RES(I)=0
           ENDDO
	  DO I = 1,22
	    IF(RESID(I,J).GE.1.0E-26) THEN
	      SUMRES   = SUMRES + RESID(I,J)
	      N_SUMRES = N_SUMRES + 1
	    ENDIF
	    IRESID(I) = NINT(100.*AMIN1(99.99,RESID(I,J)/(1.0*MIN)))
	    
	    IF(IRESID(I).LT.0) IRESID(I) = 0
	    RES(I+20) = IRESID(I)
	  ENDDO
	 
Ca  Rob - this is where Wei is printing out emicochart.tmp
Ca	  WRITE(4'IREC4)RES
Ca	  WRITE(4)RES
	  IREC4 = IREC4 + 1 
	ENDDO	
Ca  Now write the emicochart.pif file.
	if(id.eq.1) then
Ca         Mult by 4.0 to allow for other particles	   
	   chartHead.recipFloatScaleFactor = (maxF*4.0) / 2147483647.0
	   chartHead.SCALEF = 1.0 / chartHead.recipFloatScaleFactor 
	   call pif_write_gh(chartHead)
	endif
	chartHead.imgNum = id
	call pif_write_dh(chartHead)
	call pif_write_boxi4(chartHead,chartBuf)
	RETURN
	END


C  ****************************************************************************
C  *                                                          		      *
C  *               *****     SUBROUTINE ICO_BRUTE_RSYM       *****            *
C  *                                                                          *
C  *    BRUTE FORCE WHOLE ASYMMETRIC UNIT SEARCH                              *
C  *    SUBROUTINE CALLED BY EMICOFV                                          *
c  *									      *
c  *	This routine has been extensively modified by S. Fuller in june       *
c  *		1985 to overcome the problem of degeneracies of common        *
c  *		lines in projection which lead to improper relative           *
c  *		weighting of the residual for different orientations.         *
c  *	   The program now calculates the chi square for each                 *
c  *		orientation and the probability of that chi square            *
c  *		based on an estimate of the variance obtained from            *
c  *		the matrix of residuals for a fixed theta and phi and         *
c  *		varying omega and the number of degrees of freedom            *
c  *		which is determined from the number of actual points          *
c  *		for which residuals are evalutated and the number of          *
c  *		samples in the complete line.                                 *
c  *	   The routine calculates:                                            *
c  *		    a pure phase difference - ie the original                 *
c  *			    residual used in the Crowther program             *
C  *			     (ARSMIN(ITHETA,IPHI))			      *
c  *		    the phase chi square for which a probability	      *
c  *			    and a weighted chi square are also 		      *
c  *			    calculated					      *
C  *			 (RESMIN(ITHETA,IPHI),RPROB(ITHETA,IPHI)              *
c  *		all seven of these are printed as they are arrayed in         *
c  *		   the asymmmtric unit by ICO_BRUTE_RESREAD		      *
C  *									      *
c  *		The degeneracy of the common lines is compensated in two      *
c  *		  ways. 						      *
C  *			A flag which identifies truely degenerate lines	      *
c  *		  	   is set (IFLAG(NVIEW)) by ico_comlin_a. 	      *
C  *			The distance between the lines is also 		      *
c  *			   calculated or rather the radius for which	      *
c  *			   the common lines will be 1 transform unit	      *
c  *			   seperate (RAD(NVIEW)) by ico_comlin_a and the      *
c  *			   search is made using only those points for	      *
c  *			   which this distance is greater than a 	      *
c  *			   minimum (RADMIN)				      *
C  *		Modified to accept arrays of the phi and theta values for     *
c  *		    the search so that the routine can be used for LIMITED    *
c  *		    or brute force searches through calls to ICOFV_LIMITED    *
c  *		    and ICO_BRUTE respectively.                               *
c  *		Made the value of IFLAG which is taken as indicating 	      *
c  *		    a good pair of common lines a reported parameter.         *
c  *		                (MIN_IFLAG)				      *
c  *		Since portions of the transform are not populated a trap      *
c  *		    has been included to ignore residuals which do not have   *
c  *		    valid  NFREE or NSFREE values. They are included in the  *
c  *		    calculation of sigma sqrd 				      *
c  *								              *
c  *		The chisqr is generated by evaluating the average value       *
c  *		    of the residual on each common line and taking the        *
c  *		    deviation (in the -'ve direction - so that a one          *
c  *		    tailed test of chisquared is used ) as a measure of       *
c  *		    the significance of the particular fit to the other       *
c  *		    fits in the unit cell. The probability is calculated      *
c  *		    on the basis of this chisqr and the number of occupied    * 
c  *		    common lines which went into its calculation and then     * 
c  *		    multiplied by the value of the residual hence low         *
c  *		    residuals which are highly probable will be virtually     *
c  *		    unchanged while those which are very improbable but       *
c  *		    have the same value will be reduced.                      *
c  *		The phase residuals for centrosymmetry are doubled so that    *
c  *		    they have the same average value as those for other phase *
c  *		    comparisons.					      *
c  *		The effect of the probability calculation is applied to       *
c  *		    the plane and the common lines residuals. The effect      *
c  *		    is LIMITED so that a phase residual cannot be             *
c  *		    decreased by more than a factor of 4.0 or increased       *
c  *		    by more than a factor of 10. The tuning of the            *
c  *		    probability for each new data set is done through         *
c  *		    the parameter RPROB_FACT which should be adjusted so that *
C  *                the average probability times _FACT is about 1.0          *
c  *		 							      *
c  *									      *
c  *		Modified 20 jan to clean up output
c  *									      *
c  *									      *
c  *	LAST MODIFIED S.Fuller 15-feb-87				      *
c  *    modified aug 87 to make prob_fact calculation automatic and to 
c  *		list the best values for each residual
c  *
c  *		 sdf 1-sep-87						      *
C  *    LAST MODIFIED  2-OCT-1991 BY T. BAKER.                                *
C  ****************************************************************************
C
	SUBROUTINE ICO_BRUTE_RSYM1 (ROT, AT, BT, ARGPOL, FPOL, APOL, 
	1 BPOL, PHI_START, N_PHI, IP_START, N_ENTRIES, IRAD, IDIM1,
	2 RADMIN, FMINC, TITLE, ILIST, IMG_NUM, XCEN, YCEN)
C
	IMPLICIT NONE
C

	COMMON /BLOCKP/ NANG, MINR, MAXR, NSAMPL, FMIN
	INTEGER*4 NSAMPL, NANG, ILIST, TITLE(18), IMG_NUM
	INTEGER*2 MAX_N_BEST, N_BEST
	PARAMETER (MAX_N_BEST=25)
C
	REAL*4    ARGPOL(NSAMPL,NANG), FPOL(NSAMPL,NANG), FMIN, PHI
	REAL*4	  APOL(NSAMPL,NANG), BPOL(NSAMPL,NANG), FCUT(300)
	REAL*4	  ARSMIN(22,65), RESMIN(22,65), RPROB(22,65)
	REAL*4    AOMMIN(22,65), OMMIN(22,65)
	REAL*4    OUTRES(22*65), THOUT(22), PHI_START(22)
	REAL*4    PHOUT(65), PHOUT2(65), XY_RESID
	REAL*4    DELANG, THETA, PHIMAX, RESBST, X_BEST, Y_BEST
	REAL*4    ALPHA1(37), ALPHA2(37), RES(181,65), RAD(37)
	REAL*4    ANG1, ANG2, OMEGA, S1, S2, TEMP, FMINC
	REAL*4    AT(1), BT(1), OMBEST, T, ROT(3,3,37), DARG
	REAL*4    ARES(181,65), AOMBES, SIGMA, SCHISQ, RCHISQ, IPROB
	REAL*4    ARSBST, SIGMAM, ARG, FACT, PROB
	REAL*4	  RADMIN, DELRAD, RES_SUM, LINE_RES(37,181)
	REAL*4    CHISQR_RES(181), CHISQR, TOT_RES_SUM
	REAL*4	  RPROB_FACT, A_ARSMIN, A_RPROB, A_RESMIN, RADIAN
	REAL*4	XCEN, YCEN
	INTEGER*4 N_LINE_RES(37,181), NPTS(181), NR1, STATUS, IDIM1
	INTEGER*4 NFREE_RES(181), N_RES_SUM, N_TOT_RES_SUM, IRAD
	INTEGER*4 N_ENTRIES, N_PHI(22), IP_START(22), STIME
Ca	INTEGER*4 LIB$INIT_TIMER, LIB$STAT_TIMER, LIB$SHOW_TIMER
	INTEGER*4 MINR, MAXR,  NFREE, NA_ARSMIN, NA_RPROB, NA_RESMIN
	INTEGER*2 NOM, I, J, K, L, ITH, IPH, IFLAG(37), ANPTS, IOM
	INTEGER*2 NPH, IP, JP, IANG1, IANG2, NVIEW, NC, NR
	INTEGER*4 MIN_IFLAG/5/
	INTEGER*4 ID
C
	EQUIVALENCE (OUTRES(1),OMMIN(1,1))
C
	STRUCTURE /BEST/
		REAL*4 VALUE
		INTEGER*2 I1
		INTEGER*2 I2
	END STRUCTURE
	RECORD /BEST/	B_ARSMIN(MAX_N_BEST)
	RECORD /BEST/	B_RESMIN(MAX_N_BEST)
C  ----------------------------------------------------------------------------
C
C  ***************************
C  *    INITIALIZE ARRAYS    *
C  ***************************
	DO I = 1,MAX_N_BEST
	  B_ARSMIN(I).VALUE = 0.0
	  B_RESMIN(I).VALUE = 0.0
	  B_ARSMIN(I).I1    =   0
	  B_RESMIN(I).I1    =   0
	  B_ARSMIN(I).I2    =   0
	  B_RESMIN(I).I2    =   0
	ENDDO
	DO J = 1,65
	  DO I = 1,22
	    ARSMIN(I,J) = 0.0	! CROWTHER PHASE RESIDUAL
	    RESMIN(I,J) = 0.0	! PROBABILITY WEIGHTED PHASE RESIDUAL
	    AOMMIN(I,J) = 0.0	! BEST OMEGA AT THE/PHI FOR CROWTHER RESIDUAL
	    OMMIN(I,J)  = 0.0	! BEST OMEGA AT THE/PHI FOR PROB WEIGHT RESID
	    RPROB(I,J)  = 0.0
	  ENDDO
	ENDDO
	DO J = 1,65
	  PHOUT(J)  = 0.0
	  PHOUT2(J) = 0.0
	  DO I = 1,181
	    RES(I,J) = 0.0
	  ENDDO
	ENDDO
	DO I = 1,22
	  THOUT(I)     = 0.0
	ENDDO
C
	RADIAN = 4.0*ATAN2(1.0,1.0)/180.0
	N_BEST = 10
C
	WRITE(6,*) 'Rsym: Version using number of populated lines as nfree '
	WRITE(6,*) '	and a symmetry weighting near axes '
C
	WRITE(6,*) ' RADMIN = ',RADMIN, ' MIN_IFLAG= ', MIN_IFLAG
C  ************************************************************
C  *    TIMING TO HELP KEEP TRACK OF HOW INNEFICIENT THIS IS. *
C  ************************************************************
Ca	CALL LIB$INIT_TIMER
C
	DELRAD = FLOAT(MAXR-MINR)/(NSAMPL-1.0)
	DELANG = 180.0/(NANG-1)
C  **********************************************
C  *    SET DEFAULT STARTING VALUE FOR THETA    *
C  **********************************************
	THETA = 69.0
C       *************************
C-------*    STEP OVER THETA    *
C       *************************
	DO 500 ITH = 1,22
	  IP         = IP_START(ITH)
	  NPH        = N_PHI(ITH)
	  PHI        = PHI_START(ITH)
	  THOUT(ITH) = THETA
C
Ca	  STATUS = LIB$STAT_TIMER(2,STIME)
Ca	  IF(.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))
Ca	  TEMP = STIME*.01/60.0
C
C dgm change - time estimation is meaningless
C
C	  IF(ITH.EQ.2) THEN
C	    WRITE(6,'(10X,'' ===> Estimated total CPU for search ''
C	1			,F6.1,'' minutes. <===== '',/)')
C	1	float(N_ENTRIES)*TEMP/(FLOAT(N_PHI(1)))
C	  ENDIF
C
	  IF(ITH.GE.2) THEN
C	    WRITE(6,'('' Theta'',F6.2,'' Nphi'',I3,'' IP'',I3,
C	1    '' Start phi'',F7.2,'' Start of cycle'',F5.1,'' mins '')')
C	2    THETA, NPH, IP, PHI, TEMP
C dgm change - times seem meaningless
	    WRITE(6,'('' Theta'',F6.2,'' Nphi'',I3,'' IP'',I3,
	1    '' Start phi'',F7.2)')
	2    THETA, NPH, IP, PHI
	  ENDIF
C         ***********************
C---------*    STEP OVER PHI    *
C         ***********************
	  DO 400 IPH = 1,NPH
	    CALL ICO_COMLIN_A (ROT, THETA, PHI, ALPHA1, ALPHA2, IFLAG,
	1                      RAD, RADIAN)
	    IP              = IP + 1
	    OMEGA           = 0.0
	    RESBST          = 1.0E20
	    ARSBST	    = 1.0E20
	    TOT_RES_SUM     = 0.0
	    N_TOT_RES_SUM   = 0
	    IF(ITH.EQ.22) PHOUT(IP) = PHI
C           *************************
C-----------*    STEP OVER OMEGA    *
C           *************************
	    DO 300 IOM = 1,181
	      ANPTS	          = 0
	      NPTS(IOM)           = 0
	      NFREE_RES(IOM)      = 0
	      CHISQR_RES(IOM)     = 0.0
	      RES(IOM,IPH)        = 0.0
	      ARES(IOM,IPH)       = 0.0
C       *********************************************************
C       *   STEP OVER ALL NON-FLAGGED COMMON LINES.             * 
C       *   BEGIN THE CALCULATION OF A MATRIX OF RESIDUALS FOR  *
C       *   A FIXED THETA,PHI AND WITH VARYING OMEGA .          *  
C       *********************************************************
	      DO 200 NVIEW = 1,37
		LINE_RES(NVIEW,IOM)    = 0.0
		N_LINE_RES(NVIEW,IOM)  = 0
		NR1 = MAX0(1,NINT((RADMIN*RAD(NVIEW)-MINR)/DELRAD))
	        IF(IFLAG(NVIEW).EQ.1) GO TO 200
C
	        ANG1 = AMOD((ALPHA1(NVIEW)+OMEGA),360.0)
	        ANG2 = AMOD((ALPHA2(NVIEW)+OMEGA),360.0)
	        CALL ICO_CHECKANG (ANG1, S1)
	        CALL ICO_CHECKANG (ANG2, S2)
	        IANG1 = ANG1/DELANG + 1.5
	        IANG2 = ANG2/DELANG + 1.5
C
		IF (NR1.GT.NSAMPL) GO TO 200
C               ***************************
C---------------*     STEP OVER NSAMPL    *
C               ***************************
	        DO 100 NR = NR1, NSAMPL
   	          IF(FPOL(NR,IANG1).EQ.0.0) GO TO 100
	          IF(FPOL(NR,IANG2).EQ.0.0) GO TO 100
	          DARG = ABS(S1*ARGPOL(NR,IANG1)-S2*ARGPOL(NR,IANG2))
		  DO WHILE (DARG.GT.360.0)
		    DARG = DARG - 360.0
		  ENDDO
	          IF(DARG.GT.180.) DARG = 360.-DARG
		  ANPTS = ANPTS + 1
	          ARES(IOM,IPH) = ARES(IOM,IPH) + DARG
		  IF(IFLAG(NVIEW).EQ.0 .OR.
	1          IFLAG(NVIEW).ge.MIN_IFLAG) THEN
		      NPTS(IOM)    = NPTS(IOM) + 1
		      RES(IOM,IPH) = RES(IOM,IPH) + DARG*DARG
		      DARG         = (DARG-180.0)*(DARG-180.0)
		      N_LINE_RES(NVIEW,IOM) = N_LINE_RES(NVIEW,IOM) + 1
	              LINE_RES(NVIEW,IOM)   = LINE_RES(NVIEW,IOM) + DARG
	              TOT_RES_SUM           = TOT_RES_SUM + DARG
	              N_TOT_RES_SUM         = N_TOT_RES_SUM + 1
		  ENDIF
  100	        CONTINUE
  200	      CONTINUE
C
C             *******************************************************
C             * CALCULATE THE EQUIVALENT OF THE "CROWTHER RESIDUAL  *
C-------------* EXCEPT FOR THE VARIOUS MODIFICATIONS INTRODUCED FOR *
C             * EXAMPLE VIA FMIN,RAD(NVIEW),ETC.		    *
C             *******************************************************
   	      IF(ANPTS.LE.0) THEN
	         ARES(IOM,IPH) = 0.0
	       ELSE
		 ARES(IOM,IPH) = ARES(IOM,IPH)/FLOAT(ANPTS)
	         IF(ARES(IOM,IPH).LT.ARSBST) THEN
	           ARSBST = ARES(IOM,IPH)
	           AOMBES = OMEGA
	         ENDIF
	      ENDIF
  300	    OMEGA = OMEGA + 1.0					! STEP OVER IOM
C  ***************************************************************************
C  *    Calculate average value of residual over omega for all the half      *
C  *     populated common lines. This is used to calculate chisqr and to     *
C  *     form the total average which is used to normalize the residual      *
C  *     values.                                                             *
C  ***************************************************************************
	IF(N_TOT_RES_SUM.GT.1) THEN
	  RES_SUM = TOT_RES_SUM/float(N_TOT_RES_SUM-1)
	  DO NVIEW = 1,37
	    OMEGA = 0.0
	    DO IOM = 1,181
	      IF( N_LINE_RES(NVIEW,IOM) .gt. 
	1	max0(1,ifix((1.0-FMIN)*0.5*NSAMPL)) ) then
		TEMP = LINE_RES(NVIEW,IOM)/
	1		(FLOAT(N_LINE_RES(NVIEW,IOM)-1)*RES_SUM)
		CHISQR_RES(IOM) = TEMP  + CHISQR_RES(IOM) 
		NFREE_RES(IOM)  = NFREE_RES(IOM) +1
	      ENDIF
	    ENDDO
	  ENDDO
C  **************************************************************************  
C  *    Chisqr is generated so that the square deviation from random fit    *
C  *     is compared to the average deviation from the random fit.  Hence   *
C  *     small deviations are worse.                                        *
C  *                                                                        *
C  *    Will use a weighting by 1/Prob and plot the straight probability    *
C  *     of this deviation from the random fit.	 An average deviation       *
C  *     should have reduced chisqr of 1.0 and prob of 0.5.  This should    *
C  *     be left unchanged by weighting.                                    *
C  **************************************************************************
	  OMEGA = 0.0
	  DO IOM = 1,181
	    IF(NPTS(IOM).GE.1) THEN
	      RES(IOM,IPH) =sqrt(RES(IOM,IPH)/float(NPTS(IOM)))
	      IF(RES(IOM,IPH).LT.RESBST) THEN
	        RESBST = RES(IOM,IPH)
	        OMBEST = OMEGA	      	
	        NFREE  = NFREE_RES(IOM)
	        IF(NFREE.GT.0) CHISQR = CHISQR_RES(IOM)/NFREE
	      ENDIF
	    ENDIF
            OMEGA = OMEGA + 1.0
	  ENDDO
	ENDIF
C
	  IF(NFREE.GT.0 .AND. CHISQR.GT.0.0) THEN
	     CALL PCHISQ (CHISQR, NFREE, PROB, IPROB)
	     RPROB(ITH,IP) = AMAX1(PROB,1.0E-6)
	   ELSE
	     RESBST        = 0.0
	     RPROB(ITH,IP) = 1.0
	  ENDIF
C
	  AOMMIN(ITH,IP) = AOMBES
	  OMMIN(ITH,IP)  = OMBEST
	  RESMIN(ITH,IP) = RESBST
	  ARSMIN(ITH,IP) = ARSBST
  400	PHI   = PHI + 1.0					! STEP OVER IPH
  500	THETA = THETA + 1.0					! STEP OVER ITH
C
C  ***************************************************
C  *    Calculate the probability scaling factors    *
C  *     from the average probability.               *
C  ***************************************************
	NA_RPROB = 0
	A_RPROB  = 0.0
C
	DO ITH = 1,22
	  DO IP = IP_START(ITH)+1, IP_START(ITH) + N_PHI(ITH)
	    IF(RPROB(ITH,IP).GT.0.0) THEN
	      NA_RPROB = NA_RPROB + 1
	      A_RPROB  = A_RPROB + RPROB(ITH,IP)
	    ENDIF
	  ENDDO
	ENDDO
	A_RPROB    = A_RPROB/NA_RPROB
	RPROB_FACT = 1.0/A_RPROB
C
	WRITE(6,'(''  Average prob of phase residual  = '',G12.6,'' for '',
	1 I4,''  points '')') A_RPROB, NA_RPROB
	WRITE(1,'(''  Average prob of phase residual  = '',G12.6,'' for '',
	1 I4,''  points '')') A_RPROB, NA_RPROB
C  **********************************************************************
C  *    Since we have the best of 181 samples (step over omega) the     *
C  *     average probability will be greater than 0.5 - here I use 0.1  *
C  *     which gives a relatively good empirical fit.                   *
C  **********************************************************************
	A_ARSMIN  = 0.0
	A_RESMIN  = 0.0
	NA_ARSMIN = 0 
	NA_RESMIN = 0
C
	DO ITH = 22,1,-1
	  DO IP = IP_START(ITH)+1, IP_START(ITH) + N_PHI(ITH)
	    TEMP = 0.2*(1.0+4.0*amax1(1.0e-2,RPROB(ITH,IP))*RPROB_FACT)
	    RESMIN(ITH,IP) = RESMIN(ITH,IP)*TEMP
C
	    IF(ILIST.EQ.2) THEN
	      CALL ICO_BESTLIST (B_ARSMIN, MAX_N_BEST, N_BEST, 
	1      A_ARSMIN, NA_ARSMIN, ARSMIN(ITH,IP), ITH, IP)
	    ENDIF
	    CALL ICO_BESTLIST (B_RESMIN, MAX_N_BEST, N_BEST, A_RESMIN,
	1    NA_RESMIN, RESMIN(ITH,IP), ITH, IP)
	  ENDDO
	ENDDO
C
	IF(ILIST.EQ.2) A_ARSMIN = A_ARSMIN/NA_ARSMIN
	A_RESMIN = A_RESMIN/NA_RESMIN 
C
Ca	STATUS = LIB$STAT_TIMER(2,STIME)
Ca	IF(.NOT.STATUS) CALL LIB$STOP(%VAL(STATUS))
Ca	TEMP = STIME*.01/60.0
C 	WRITE(6,'('' Search complete '',F9.4,'' minutes'')') TEMP
	WRITE(6,'('' Search complete'')') ! dgm change - times seem meaningless
C  ******************************************************************
C  *    TYPE OUT BEST RESIDUAL AND VALUES OF THETA,PHI AND OMEGA    *
C  ******************************************************************
	WRITE(1,'(/,''  --- Best '',I2,'' Values for each residual '',
	1	'' (excluding neighbors) ---'')') N_BEST
	WRITE(6,'(/,''  --- Best '',I2,'' Values for each residual '',
	1	'' (excluding neighbors) ---'')') N_BEST
	IF(ILIST.NE.2) GO TO 600
C  ******************************************************
C  *    OUTPUT OF ORIGINAL "CROWTHER" PHASE RESIDUAL    *
C  ******************************************************
	WRITE(1,'(/,'' Original residual - in degrees '')')
	WRITE(6,'(/,'' Original residual - in degrees '')')
	WRITE(1,'(/,'' RESIDUAL     THETA       PHI     OMEGA'')')
	WRITE(1,'('' --------------------------------------'')')
	WRITE(6,'(/,'' RESIDUAL     THETA       PHI     OMEGA'')')
	WRITE(6,'('' --------------------------------------'')')
	DO I = 1,N_BEST
	  ITH = B_ARSMIN(I).I1
	  IP  = B_ARSMIN(I).I2
	  WRITE(1,1000) B_ARSMIN(I).VALUE,THOUT(ITH),PHOUT(IP),
	1  AOMMIN(ITH,IP)
	  WRITE(6,1000) B_ARSMIN(I).VALUE,THOUT(ITH),PHOUT(IP),
	1  AOMMIN(ITH,IP)
	ENDDO
	WRITE(6,'('' Average value is '',g12.6,'' for '',i3,'' points.'')') 
	1	A_ARSMIN,NA_ARSMIN
	WRITE(1,'('' Average value is '',g12.6,'' for '',i3,'' points.'')') 
	1	A_ARSMIN,NA_ARSMIN
C  *******************************************************
C  *    OUTPUT OF PROBABILITY WEIGHTED PHASE RESIDUAL    *
C  *******************************************************
  600	WRITE(6,'(/,'' Probability weighted phase residual  '')')
	WRITE(6,'(/,''  RESIDUAL    THETA       PHI     OMEGA'',
	1 ''     ORIGX    ORIGY   RESIDUAL'')')
	WRITE(1,'(/,'' Probability weighted phase residual  '')')
	WRITE(1,'(/,''  RESIDUAL    THETA       PHI     OMEGA'',
	1 ''     ORIGX    ORIGY   RESIDUAL'')')
	WRITE(6,'(1X,70(''-''))')
	WRITE(1,'(1X,70(''-''))')
	IF(ILIST.GE.1) THEN
	  CALL ZMINC (AT, BT, IRAD, MINR, IRAD-1, FMINC, FCUT)
	ENDIF
	DO I = 1,N_BEST
	  ITH = B_RESMIN(I).I1
	  IP  = B_RESMIN(I).I2
	  IF(ITH.EQ.0.OR.IP.EQ.0) goto 601 
	  IF(ILIST.GE.1) THEN
	    CALL ICO_FVORG (ROT, AT, BT, THOUT(ITH), PHOUT(IP),
	1    OMMIN(ITH,IP), FCUT, MINR, IRAD, IDIM1, X_BEST, Y_BEST,
	2    XY_RESID, XCEN, YCEN)                 ! dgm fix - call was wrong
c	2    XY_RESID)
	  ENDIF
	  WRITE(6,1000) B_RESMIN(I).VALUE, THOUT(ITH), PHOUT(IP),
	1  OMMIN(ITH,IP), X_BEST, Y_BEST, XY_RESID
	  WRITE(1,1000) B_RESMIN(I).VALUE, THOUT(ITH), PHOUT(IP),
	1  OMMIN(ITH,IP), X_BEST, Y_BEST, XY_RESID
CWZ	  WRITE(3,1010) IMG_NUM, THOUT(ITH), PHOUT(IP), OMMIN(ITH,IP),
Cwz	1  X_BEST, Y_BEST, 0.0, XY_RESID
	WRITE(3,1010) IMG_NUM, THOUT(ITH), PHOUT(IP), OMMIN(ITH,IP),
	1  XCEN, YCEN, 1.0, XY_RESID
  601	ENDDO
C
	WRITE(6,'('' Average value is '',g12.6,'' for '',i3,'' points.'')') 
	1	A_RESMIN, NA_RESMIN
	WRITE(1,'('' Average value is '',g12.6,'' for '',i3,'' points.'')') 
	1	A_RESMIN, NA_RESMIN
C  ****************************************************
C  *    Fill array for output of phi values PHOUT2    *
C  ****************************************************
	DO IP = 1,NPH
	  J = NPH + 1 - IP
  	  PHOUT2(IP) = PHOUT(J)
	ENDDO
C  *************************************************************
C  *    Normalized phase residual with plane phase residual    *
C  *************************************************************
	WRITE(1,'('' Probability normalized phase residual'')')
	WRITE(6,'('' Probability normalized phase residual'')')
	DO IP = 1,NPH
	  J = NPH + 1 - IP
	  DO I = 1,22
	    OUTRES(I+22*(IP-1)) = RESMIN(I,J)
	  ENDDO
	ENDDO
	ID=IMG_NUM
	CALL ICO_BRUTE_RESREAD1 (THOUT, OUTRES, PHOUT2,ID)
	IF(ILIST.NE.2) RETURN
C  ********************************************
C  *    Original (Crowther) phase residual    *
C  ********************************************
	WRITE(1,'(''1Original "CROWTHER" phase residual '')')
	WRITE(6,'(''1Original "CROWTHER" phase residual '')')
	DO IP = 1,NPH
	  J = NPH + 1 - IP
	  DO I = 1,22
	    OUTRES(I+22*(IP-1)) = ARSMIN(I,J)
	  ENDDO
	ENDDO
	CALL ICO_BRUTE_RESREAD1 (THOUT, OUTRES, PHOUT2,ID)
C
	RETURN
C
 1000	FORMAT(F9.2,6F10.2)
 1010	FORMAT(I5,',',5(F8.3,','),F6.1,', , ,',F8.2)
	END
