C  *****************************************************************************
C  *                                                                           *
C  *                    *****   MAP_DISTRIBUTION.F    *****                    *
C  *                                                                           *
C  *    THIS PROGRAM READS ONE PIFMAPS INTO CORE MEMORY, PRINT OUT             *
C  *         THE DISTRIBUTION OF MAP PIXELS                                    *
C  *    LOGICAL UNITS: 7 = REFERENCE 3D MAP                                    *
C  *                                                                           *
C  *    WEI ZHANG, JAN. 19, 2004                                               *
C  *                                                                           *
C  *****************************************************************************
C
	IMPLICIT NONE
C
C
        INCLUDE '/bio/baker9/rwa/devel/libEMF/INCfiles/EM.CMM'

	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD
 	COMMON /PIFHEAD/   MAPHEAD
C       
	
	INTEGER*4 NCOL, NROW, NSEC, NUMINT, I
	REAL*8    MAP_DIST(1)
	REAL*4    SECTION(1)
	REAL*4    MAX,MIN,R1,R2
	BYTE      READWRITE(4)
	POINTER   (MAP_DIST_P,MAP_DIST)
	POINTER   (SECTION_P,SECTION)
	INTEGER   MALLOC
C       
	
	
	MAPHEAD.LUNUM = 7	! UNIT FOR INPUT IMAGE FILE
	READWRITE(1) = 'r'
	
C       *****************************
C       * LOOP FOR ALL 3D MAP FILES *
C       *****************************
  11	WRITE(6,'(''$PIFMAP FILENAME: '')')
	READ (5,'(A)',ERR=11) MAP_FILENAME
	CALL PIF_OPEN (MAP_FILENAME, MAPHEAD.LUNUM, READWRITE)
	CALL PIF_READ_GH (MAPHEAD)
	NCOL = MAPHEAD.NUMCOLS  
	NROW = MAPHEAD.NUMROWS 
	NSEC = MAPHEAD.NUMSECS 
C       *************************************************************
C       * ALLOCATE VIRTUAL MEMORY FOR MAP AND MASK FILE             *
C       * READ 3D MAP INTO CORE MEMORY WITH SURFACE DENSITY IMPOSED *
C       *************************************************************
	SECTION_P = MALLOC (4*NCOL*NROW)
	   
  19	   WRITE(6,'(''$INNER AND OUTER RADIUE R1, R2: '')')
	   READ (5,'(2F)',ERR=19) R1, R2	
	   
	   
	   CALL MAP_MINMAX(SECTION,MIN,MAX,NCOL,NROW,NSEC,R1,R2)
	   PRINT *, 'MIN= ',MIN
	   PRINT *, 'MAX= ',MAX
  10	   WRITE(6,'(''$THE NUMBER OF INTERVALS: '')') 
	   READ (5,'(I)',ERR=10) NUMINT
	   IF (NUMINT.GT.ABS(MAX-MIN)) THEN
	      NUMINT=ABS(MAX-MIN)
	      PRINT *, 'THE NEW INTERVALS IS ', NUMINT
	   ENDIF

	MAP_DIST_P = MALLOC (8*2*NUMINT)

	   CALL MAP_DISTB(SECTION,MIN,MAX,R1,R2,MAP_DIST,NCOL,NROW,
	1	NSEC,NUMINT)
C       
	      
C       **********************
C       *  CLOSE SOME FILES  *
C       **********************
C 	CALL PIF_CLOSE(MAPHEAD.LUNUM)
	      
	      
C       ******************
C       *  FREE MEMMORY  *  
C       ******************
	      CALL FREE (MAP_DIST_P)
	      CALL FREE (SECTION_P)
	      
	      END
	
C       ==========================================================
C       ==========================================================
C       ==========================================================
	SUBROUTINE MAP_MINMAX (FLOATTMP, MIN, MAX,NCOL, NROW,NSEC,R1,R2)
	
	IMPLICIT NONE
        INCLUDE '/bio/baker9/rwa/devel/libEMF/INCfiles/EM.CMM'
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD
	COMMON /PIFHEAD/   MAPHEAD
	INTEGER*4 NCOL, NROW, NSEC, I, J, K
	REAL*4    FLOATTMP(NCOL,NROW), MIN, MAX,R,R1,R2
	MIN=99999999.0
	MAX=-99999999.0
	
	mapHead.imgNum = 1
	CALL PIF_READ_dH (MAPHEAD)

	DO K = 1,NSEC
	   CALL PIF_READ_SECI2(MAPHEAD, FLOATTMP, NCOL, NROW, K)
	   
	   DO J = 1,NROW
	      DO I = 1,NCOL
		 R=(I-(NCOL+1)/2)**2+(J-(NROW+1)/2)**2+(K-(NSEC+1)/2)**2
		 R=SQRT(R)
		 IF((R.GE.R1).AND.(R.LE.R2) ) THEN
		    IF(FLOATTMP(I,J).GT.MAX) MAX=FLOATTMP(I,J)
		    IF(FLOATTMP(I,J).LT.MIN) MIN=FLOATTMP(I,J)
		 ENDIF
	      ENDDO     
	   ENDDO
	ENDDO
	
	END
	
C       ==========================================================
C       ==========================================================
C       ==========================================================
	
	SUBROUTINE MAP_DISTB (FLOATTMP,MIN, MAX,R1,R2,DIST,NCOL,
	1    NROW, NSEC, NUMINT)
	
C       
	IMPLICIT NONE
C       
        INCLUDE '/bio/baker9/rwa/devel/libEMF/INCfiles/EM.CMM'
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD
	COMMON /PIFHEAD/   MAPHEAD
C       
	INTEGER*4 NCOL, NROW, NSEC, I, J, K, K1,K2, NUMINT
	REAL*8   DIST(2,NUMINT)
	REAL*4    FLOATTMP(NCOL,NROW), INCRE ,MIN, MAX,R,R1,R2
	integer   malloc

	INCRE = (MAX-MIN)/NUMINT	
	DO K=1,NUMINT
	   DIST(1,K)=MIN+(K-1)*INCRE
	   DIST(2,K)=0.0
	ENDDO
	
	mapHead.imgNum = 1
	CALL PIF_READ_dH (MAPHEAD)


	DO K = 1,NSEC
	   CALL PIF_READ_SECI2(MAPHEAD, FLOATTMP, NCOL, NROW, K)
	   
	   DO J = 1,NROW
	      DO I = 1,NCOL
		 R=(I-(NCOL+1)/2.)**2+(J-(NROW+1)/2.)**2+(K-(NSEC+1)/2.)**2
		 R=SQRT(R)
		 IF((R.GE.R1).AND.(R.LE.R2)) THEN
		    DO K1=1,NUMINT-1
		       K2=K1+1
		       IF((FLOATTMP(I,J).GE.DIST(1,K1)).AND.
	1		    (FLOATTMP(I,J).LT.DIST(1,K2)))  THEN
			  DIST(2,K1)=DIST(2,K1)+1.0
		       ENDIF
		    ENDDO
		    IF (FLOATTMP(I,J).GE.DIST(1,NUMINT)) 
	1		 DIST(2,NUMINT)=DIST(2,NUMINT)+1.0
		 ENDIF
	      ENDDO     
	   ENDDO
	ENDDO
	DO K=1,NUMINT
	   PRINT *, K, DIST(1,K), DIST(2,K)
	ENDDO
	
	END
