      SUBROUTINE HDLCF2(IUN,FILNAM,NT,ITITLE,NL,LABEL,CELL,IADD,IWRITE)
C
C PARAMETERS
C
C           IUN  (I)  UNIT NUMBER FOR OUTPUT FILE (0 TO LEAVE
C                     UNCHANGED)
C        FILNAM  (I)  LOGICAL FILE NAME (UP TO 8 CHARACTERS)
C                     (UNCHANGED IF IUN=0)
C            NT  (I)  THE NUMBER OF CHARACTERS OF TITLE INFORMATION TO
C                     BE ADDED (MAY BE 0)
C        ITITLE  (I)  CHARACTER ARRAY CONTAINING THE TITLE INFORMATION.
C                     THE SUBROUTINE WILL AUTOMATICALLY EXCLUDE
C                     TRAILING SPACES FROM THE TITLE INFORMATION
C                     ADDED.  THE USER SHOULD INSERT LEADING SPACES ETC.
C                     IF REQUIRED, TO SEPARATE ADDITIONAL TITLE
C                     INFORMATION FROM THE TITLE INFORMATION ALREADY
C                     PRESENT (UNLESS IADD=2).
C            NL  (I)  THE NUMBER OF CHARACTERS OF LABEL INFORMATION TO
C                     BE ADDED (MAY BE 0)
C         LABEL  (I)  CHARACTER ARRAY CONTAINING THE LABEL INFORMATION
C                     TO BE ADDED TO THE HEADER INFORMATION.
C                      THE SUBROUTINE WILL AUTOMATICALLY EXCLUDE
C                      REDUNDANT SPACES AND WILL SEPARATE THE NEW
C                     NEW LABELS FROM ANY EXISTING LABELS BY A SPACE.
C          CELL  (I)  THIS IS A SIX ELEMENT REAL ARRAY TO CONTAIN THE
C                     CELL DIMENSIONS FOR THE FILE HEADER.  THE CELL
C                     DIMENSIONS ARE INPUT AS A,B,C,ALPHA,BETA AND GAMMA
C                     IN ANGSTROMS AND DEGREES. IF CELL(1)=0.0, THEN
C                     THE EXISTING CELL DIMENSIONS SET UP IN THE
C                     HEADER WILL REMAIN UNCHANGED
C          IADD  (I)  FLAG =0, INITIALISE THE HEADER INFORMATION AND
C                              THEN ADD IN REQUIRED INFORMATION AS
C                              DEFINED BY THE PARAMETERS ABOVE.
C                          =1, ADD IN HEADER INFORMATION, AS DEFINED
C                              IN THE PARAMETERS ABOVE, TO ANY HEADER
C                              INFORMATION ALREADY PRESENT. (NOTE: CELL
C                              DIMENSIONS WILL BE REPLACED RATHER THAN
C                              ADDED)
C                          =2  AS FOR 1 BUT LEADING SPACE INSERTED
C                              BEFORE NEW TITLE INFORMATION
C                          =-1 REPLACE SOME OF TITLE, LABEL, OR CELL
C                              INFORMATION AS SPECIFIED BY NT, NL, AND
C                              CELL, BUT LEAVE OTHER HEADER INFORMATION
C                              UNCHANGED
C       IWRITE  (I)   FLAG =0, DO NOT WRITE THE HEADER INFORMATION TO
C                              THE FILE (USE THIS EXCEPT ON THE LAST
C                              CALL TO HDLCF2)
C                          =1, WRITE THE HEADER INFORMATION TO THE
C                              OUTPUT FILE
C
C SUBROUTINES CALLED 'LCFINC' 'LCFSHF' 'LCFITM' 'WHLCF2'
C
C SPECIFICATION STATEMENTS
C
      LOGICAL RD
      CHARACTER*(*) FILNAM
      CHARACTER*1 ARRAYN(1000),ITITLE(*),LABEL(*),ISP
      DIMENSION IDATA(1),CELL(6)
      COMMON /LCF2/IDDN,MAXDN,CELLN(6),LRECLN,LTITN,LABELN
      COMMON /LCF2AR/ARRAYN
      COMMON /LCF2WK/RD,IN,IOUT,LBUF,IUNIN,NCIN,IUNOUT,NCOUT,
     *               IPOINT(100),NLOOK,KDATA(100)
      CHARACTER*40 FILIN,FILOUT
      COMMON /LCF2FN/FILIN,FILOUT
      SAVE /LCF2/,/LCF2AR/,/LCF2WK/,/LCF2FN/
      DATA ISP/' '/
C
C INITIALISE COMMON /LCF2WK/ IF REQUIRED
C
      CALL INLCF2(5,6,72)
C
C INITIALISE SOME COMMON AREA ENTRIES IF IADD=0
C
      MAXDN=1000
      IF(IADD.NE.0)GO TO 50
      DO 10 I=1,6
      CELLN(I)=0.0
10    CONTINUE
      DO 20 I=1,1000
      ARRAYN(I)=ISP
20    CONTINUE
      LTITN=0
      LABELN=0
      MAXDN=1000
      LRECLN=0
C
C SET FLAG FOR DDNAME IF SPECIFIED
C
50    IF(IUN.NE.0)IDDN=IUN
      IF(IUN.NE.0)FILOUT=FILNAM
C
C ADD IN TITLE INFORMATION IF REQUIRED
C -----------------------------------
C
100   IF(NT.LE.0)GO TO 200
C
C REPLACE TITLE
      IF(IADD.LT.0) LTITN=0
C
C FIND THE NUMBER OF THE LAST SIGNIFICANT CHARACTER
C
      DO 110 I=1,NT
      NCH=NT-I+1
      IF(ITITLE(NCH).NE.ISP)GO TO 120
110   CONTINUE
C
C ADD TITLE INFORMATION TO 'ARRAY'
C
120   IF(IADD.LT.2)GO TO 125
      J=LABELN+LTITN+1
      IF(J.GT.MAXDN)GO TO 140
      LTITN=LTITN+1
      ARRAYN(J)=' '
125   DO 130 I=1,NCH
      J=LABELN+LTITN+1
      IF(J.GT.MAXDN)GO TO 140
      LTITN=LTITN+1
      ARRAYN(J)=ITITLE(I)
130   CONTINUE
      GO TO 200
C
C INSUFFICIENT SPACE FOR ALL TITLE INFORMATION
C
140   N=NCH-I+1
      WRITE(IOUT,2001)
      WRITE(IOUT,2002)N
C
C ADD IN LABEL INFORMATION IF REQUIRED
C -----------------------------------
C
200   IF(NL.EQ.0)GO TO 400
C
C FIND THE NUMBER OF CHARACTERS OF LABEL INFORMATION TO BE ADDED
C (AFTER COMPRESSION)
C
      NOSPAC=0
      IF(LABELN.EQ.0.OR.IADD.LT.0)NOSPAC=1
      IF(LABELN.NE.0.AND.ARRAYN(LABELN).EQ.ISP)NOSPAC=1
      NCH=0
      I=0
210   CALL LCFINC(I,LABEL,NL,*220,*210,*250)
220   NCH=NCH+2
230   CALL LCFINC(I,LABEL,NL,*240,*210,*250)
240   NCH=NCH+1
      GO TO 230
C
C CHECK THAT THERE IS SUFFICIENT SPACE FOR THE LABEL INFORMATION
C
250   IF(NOSPAC.EQ.1)NCH=NCH-1
      IF(NCH+LABELN.LT.MAXDN)GO TO 260
      WRITE(IOUT,2000)
      WRITE(IOUT,2003)
      WRITE(IOUT,2010)
          call ccperr(1,' stop in lcflib.for 2010')
260   N=NCH+LABELN+LTITN-MAXDN
      IF(N.LE.0)GO TO 270
      WRITE(IOUT,2001)
      WRITE(IOUT,2002)N
      LTITN=LTITN-N
C
C SHIFT TITLE INFORMATION AND COPY LABEL INFORMATION INTO 'ARRAYN'
C
270   M1=LABELN+1
      M2=LABELN+LTITN
      IF(IADD.GE.0) GO TO 271
C REPLACE LABELS IF IADD .LT. 0
C NUMBER OF CHARACTERS TO MOVE TITLE
      NCH=NCH-LABELN
      LABELN=0
271   CALL LCFSHF(ARRAYN,M1,M2,NCH)
C
C COPY LABEL INFORMATION REMOVING REDUNDANT SPACES
C
      I=0
280   CALL LCFINC(I,LABEL,NL,*290,*280,*400)
290   IF(NOSPAC.EQ.1)GO TO 295
      LABELN=LABELN+1
      ARRAYN(LABELN)=ISP
295   LABELN=LABELN+1
      NOSPAC=0
      ARRAYN(LABELN)=LABEL(I)
300   CALL LCFINC(I,LABEL,NL,*310,*280,*400)
310   LABELN=LABELN+1
      ARRAYN(LABELN)=LABEL(I)
      GO TO 300
C
C REPLACE CELL DIMENSIONS IF REQUIRED
C ----------------------------------
C
400   IF(CELL(1).EQ.0.0)GO TO 450
      DO 410 I=1,6
      CELLN(I)=CELL(I)
410   CONTINUE
450   CALL LCFITM(ARRAYN,LABELN,NLABL)
      LRECLN=2*NLABL
C
C WRITE HEADER RECORDS IF REQUIRED
C
      IF(IWRITE.NE.1)RETURN
      CALL WHLCF2(IDATA)
C PRINT HEADER INFORMATION
C
      WRITE(IOUT,1001)IUNOUT,NLABL
      WRITE(IOUT,1002)
      CALL LCFPRT(IOUT,ARRAYN,1,LABELN,1,80)
      WRITE(IOUT,1003)
      CALL LCFPRT(IOUT,ARRAYN,LABELN+1,LABELN+LTITN,1,80)
      WRITE(IOUT,1004)CELLN
      RETURN
C
C FORMAT STATEMENTS
C ----------------
C
1001  FORMAT(//,' HEADER INFORMATION FOR OUTPUT LCF FILE ON UNIT',
     *I3,//,' NUMBER OF COLUMNS =',I4)
1002  FORMAT(/,' * COLUMN LABELS:',/)
1003  FORMAT(/,' * TITLE:',/)
1004  FORMAT(/,' * CELL DIMENSIONS:',//,' ',6F8.2)
C
2000  FORMAT(/,' **LCF ERROR**')
2001  FORMAT(/,' *LCF WARNING*')
2002  FORMAT(' **LAST',I3,' CHARACTERS OF TITLE TRUNCATED**')
2003  FORMAT(' **LABEL INFORMATION TOO LONG**')
2010  FORMAT(/,' **PROGRAM TERMINATED**')
      END
