      SUBROUTINE LABPRT(LABELS,NLABS)
C     ================================
C
C
C---- Utility subroutine for MTZ routines - to output an
C     array of character strings across the page nicely
C     eg labels or types
C     Uses subroutine PUTLIN to output to window CURWIN.
C
C---- Arguments :
C
C     LABELS    (I)	CHARACTER*(*)   Array of dimension (NLABS) containing
C                               	the character strings to be output
C
C     NLABS     (I)	INTEGER         number of labels to be output
C
C
C     .. Scalar Arguments ..
      INTEGER NLABS
C     ..
C     .. Array Arguments ..
      CHARACTER LABELS(NLABS)* (*)
C     ..
C     .. Local Scalars ..
      INTEGER ICOL1,ICOL2,ILEN,JDO10,MAXLEN
      CHARACTER STROUT*400
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL PUTLIN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC LEN
C     ..
C
C---- Set up the length of the output line, also set STROUT to blanks
C
      MAXLEN = 80
      STROUT = ' '
      ICOL1 = 0
      ILEN = LEN(LABELS(1))
C
      IF (ILEN.LE.MAXLEN) THEN
C
C---- Loop over the strings
C     Fill up STROUT until MAXLEN, then output a line, leave one
C     blank between each string
C
        DO 10 JDO10 = 1,NLABS
          ILEN = MAX(LENSTR(LABELS(JDO10)),1)
          ICOL2 = ICOL1 + ILEN
C
          IF (ICOL2.LE.MAXLEN) THEN
            STROUT(ICOL1+1:ICOL2) = LABELS(JDO10) (1:ILEN)
            ICOL1 = ICOL2 + 1
          ELSE
C
C              *************************
            CALL PUTLIN(STROUT,'CURWIN')
C              *************************
C
            STROUT = LABELS(JDO10) (1:ILEN)
            ICOL1 = ILEN + 1
          END IF
   10   CONTINUE
C
C---- Output the last line and return
C
C            ***********************
        CALL PUTLIN(STROUT,'CURWIN')
C            ***********************
C
      END IF
C
      END
