      SUBROUTINE LBPRT(IBATCH,IPRINT,RBATCH,CBATCH)
C     =============================================
C
C---- Internal MTZ subroutine (I think!) which copies the batch header
C     information as it is stored in raw form on the files, into the
C     common blocks MBTHDR and CBTHDR, and then calls LBPRTH to make
C     some sense of these numbers.
C
C---- Arguments :
C
C     IBATCH    (I)	INTEGER         batch number
C
C     IPRINT    (I)	INTEGER         print indicator : meaning :
C                               	=0 no print
C                               	=1 print batch title only
C                               	=2 also print orientation block
C                               	.GT. 30 also print orientation block
C                                    	BUT TO IPRINT UNIT NUMBER
C
C     RBATCH    (I)	REAL(*)         array from which integer and real batch
C                               	info is decoded by subroutine wbathd
C                               	this should be equivalenced onto the
C                               	appropriate COMMON block in the calling
C                               	program. The first item is nwords,ie how
C                               	many items in the array, if nword is 0
C                               	then only the title is written to header
C
C     CBATCH    (I)	CHARACTER*(*)   as RBATCH, but for character items - no
C                               	nwords however; title is 1st 70 chars of
C                               	CBATCH.
C
C     The lengths of the RBATCH & CBATCH arrays are parameters here!
C
C
C     .. Parameters ..
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
C     ..
C     .. Scalar Arguments ..
      INTEGER IBATCH,IPRINT
C     ..
C     .. Array Arguments ..
      REAL RBATCH(MBLENG)
      CHARACTER CBATCH*(*)
C     ..
C     .. Arrays in Common ..
      REAL RARRAY
      CHARACTER CARRAY*1
C     ..
C     .. Local Scalars ..
      INTEGER JDO20,JDO30,NWORDS
C     ..
C     .. External Subroutines ..
      EXTERNAL LBPRTH
C     ..
C     .. Common blocks ..
      COMMON /CBTHDR/CARRAY(CBLENG)
      COMMON /MBTHDR/RARRAY(MBLENG)
C     ..
C     .. Equivalences ..
      EQUIVALENCE (NWORDS,RARRAY(1))
C     ..
C     .. Save statement ..
      SAVE /MBTHDR/,/CBTHDR/
C     ..
C
C---- Copy from the input arguments to the dummy common block
C     first we have to get NWORDS out
C
      RARRAY(1) = RBATCH(1)
C
      DO 10 JDO20 = 1,NWORDS
        RARRAY(JDO20) = RBATCH(JDO20)
   10 CONTINUE
C
      DO 20 JDO30 = 1,CBLENG
        CARRAY(JDO30) = CBATCH(JDO30:JDO30)
   20 CONTINUE
C
C          *********************
      CALL LBPRTH(IBATCH,IPRINT)
C          *********************
C
      END
