      SUBROUTINE LCFLBL(N,ARRAYN,LABELN,MIN,MAX,*)
C     ============================================
C
C This subroutine finds the minimum and maximum character numbers
C in a string of labels for a given label number.
C
C
C---- Parameters
C
C                 N (I) NUMBER OF THE LABEL TO BE FOUND
C            ARRAYN (I) CHARACTER ARRAY CONTAINING THE LABELS
C            LABELN (I) NUMBER OF CHARACTERS IN 'ARRAYN'
C               MIN (O) THE NUMBER OF THE FIRST CHARACTER IN THE LABEL
C                       (OR -1 IF ABSENT OR BLANK FIELD)
C               MAX (O) THE NUMBER OF THE LAST CHARACTER IN THE LABEL
C             *         RETURN IF A BLANK FIELD IS FOUND
C
C---- Specification statements
C
      CHARACTER*1 ARRAYN(*),IBL
      DATA IBL/' '/
C
C---- Initialisation statements
C
      IFIELD=0
      I=0
      MIN=-1
      MAX=LABELN
C
C---- Skip spaces up to next occupied field
C
10    I=I+1
      IF(I.GT.LABELN)RETURN 1
      IF(ARRAYN(I).EQ.IBL)GO TO 10
C
C---- An occupied field has been found, calculate the field number
C     and compare it with the one required
C
20    IFIELD=IFIELD+1
      IF(IFIELD.GT.N)RETURN 1
      IF(IFIELD.EQ.N)GO TO 100
C
C---- Required field not yet reached   skip over current field
C
25    I=I+1
      IF(I.GT.LABELN)RETURN 1
      IF(ARRAYN(I).EQ.IBL)GO TO 10
      GO TO 25
C
C---- Required field found   find the end of the field
C
100   MIN=I
110   I=I+1
      IF(I.GT.LABELN)RETURN
      IF(ARRAYN(I).EQ.IBL)GO TO 120
      GO TO 110
120   MAX=I-1
      RETURN
      END
