      SUBROUTINE LHPRT(MINDX,IPRINT)
C     ==============================
C
C
C---- Subroutine to print out the header information from the MTZ
C     COMMON blocks for the MTZ file open on index MINDX.
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     IPRINT    (I)	INTEGER         print indicator : meaning :
C                               	=1 Brief header info printed (default)
C                               	=2 As above plus history info
C                               	=3 Full header dump, symmetry, alles !
C                               	=4 As 1 plus full symmetry 
C                               	any other value, nothing happens
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,IPRINT
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RSYM,VAL_MISS
      INTEGER BATNUM,ISORT,NBATCH,NCOLS,NREFS,NSPGRP,NSYM,NSYMP,
     +          NSETW,SET_ID,CSET_ID,IDEFSET
      CHARACTER CBATR*1,CTYPE*1,LTYPE*1,PGNAM*10,SPGNAM*10,CLABEL*30,
     +          TITLE*70,ENTRY_ID*64,DIFFRN_ID*64

C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,IMAX,IMIN,IPR,ISTAT,JDO10,JDO20,JDO30,JJ
      LOGICAL SORTED,VAL_SET
      CHARACTER CTEMP*1,LINE*400,STROUT*400
      REAL RESMIN,RESMAX
C     ..
C     .. Local Arrays ..
      CHARACTER SYMCHS(MAXSYM)*80
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
      LOGICAL QISNAN
C     ..
C     .. External Subroutines ..
      EXTERNAL BLANK,LABPRT,LERROR,LPHIST,PUTLIN,SYMTR3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT
C     ..
C     .. Common blocks ..
      COMMON /MTZCHR/TITLE(MFILES),CLABEL(MCOLS,MFILES),
     +       CTYPE(MCOLS,MFILES),SPGNAM(MFILES),LTYPE(MFILES),
     +       CBATR(CBLENG,MBATCH,MFILES),PGNAM(MFILES)
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZHAR/NSETW(MFILES),SET_ID(MSETS,MFILES),
     +       ENTRY_ID(MSETS,MFILES),DIFFRN_ID(MSETS,MFILES),
     +       CSET_ID(MCOLS,MFILES),IDEFSET(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/,/MTZCHR/
C     ..
C
C---- Check IPRINT is OK
C
      IF ((IPRINT.GE.1) .AND. (IPRINT.LE.4)) THEN
C
C---- Then check that the MINDX is valid
C
        IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
          WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +      'From LHPRT : Index',MINDX,
     +      ' is out of range (allowed 1..',MFILES,')'
C
C---- Stop here, since this is a bad error, probably from program
C
          ISTAT = 2
          IFAIL = -1
C
C              ************************
          CALL LERROR(ISTAT,IFAIL,LINE)
C              ************************
C
        ELSE
C
C---- Print title, harvesting dataset info, no. of cols, no of refls
C
C              ***********************
          CALL PUTLIN('* Title:','CURWIN')
          CALL BLANK('CURWIN',1)
          CALL PUTLIN(TITLE(MINDX) (1:LENSTR(TITLE(MINDX))),'CURWIN')
          CALL BLANK('CURWIN',1)

          IF (NSETW(MINDX).GT.0) THEN
            WRITE (STROUT,FMT='(A,I4)') '* Number of Datasets =',
     +        NSETW(MINDX)
            CALL PUTLIN(STROUT,'CURWIN')
            CALL BLANK('CURWIN',1)
            CALL PUTLIN('* Dataset ID, project name, dataset name:',
     +        'CURWIN')
            CALL BLANK('CURWIN',1)
            DO 30 JDO30 = 1,NSETW(MINDX)

              WRITE (STROUT,FMT='(I8,1X,A)') 
     +          SET_ID(JDO30,MINDX),ENTRY_ID(JDO30,MINDX)
              CALL PUTLIN(STROUT,'CURWIN')
              WRITE (STROUT,FMT='(9X,A)') 
     +          DIFFRN_ID(JDO30,MINDX)
              CALL PUTLIN(STROUT,'CURWIN')
C
   30       CONTINUE
            CALL BLANK('CURWIN',1)
          ENDIF

          WRITE (STROUT,FMT='(A,I4)') '* Number of Columns =',
     +      NCOLS(MINDX)
          CALL PUTLIN(STROUT,'CURWIN')
          CALL BLANK('CURWIN',1)
          WRITE (STROUT,FMT='(A,I7)') '* Number of Reflections =',
     +      NREFS(MINDX)
C   Something about missing value flag.
          IF(VAL_SET(1,MINDX)) THEN
              CALL PUTLIN(STROUT,'CURWIN')
              CALL BLANK('CURWIN',1)
              IF( QISNAN(VAL_MISS(1,MINDX))) 
     +        WRITE (STROUT,FMT='(A)') 
     +        '* Missing value set to NaN in input mtz  file'
              IF( .NOT.QISNAN(VAL_MISS(1,MINDX))) 
     +        WRITE (STROUT,FMT='(A,F18.2,A)') 
     +        '* Missing value set to ',VAL_MISS(1,MINDX),
     +        ' in input mtz  file'
          END IF
C
          IF(VAL_SET(2,MINDX)) THEN
              CALL PUTLIN(STROUT,'CURWIN')
              CALL BLANK('CURWIN',1)
              IF( QISNAN(VAL_MISS(2,MINDX))) 
     +        WRITE (STROUT,FMT='(A)') 
     +        '* Missing value set to NaN in output mtz  file'
              IF( .NOT.QISNAN(VAL_MISS(2,MINDX))) 
     +        WRITE (STROUT,FMT='(A,F18.2,A)') 
     +        '* Missing value set to ',VAL_MISS(2,MINDX),
     +        ' in output mtz  file'
          END IF
          CALL PUTLIN(STROUT,'CURWIN')
          CALL BLANK('CURWIN',1)
C              ***********************
C
          IF (NBATCH(MINDX).GT.0) THEN
            WRITE (STROUT,FMT='(A,I4)') '* Number of Batches =',
     +        NBATCH(MINDX)
C
C                ***********************
            CALL PUTLIN(STROUT,'CURWIN')
            CALL BLANK('CURWIN',1)
C                ***********************
C
          END IF
C
C---- Print History lines if required
C
          IF ((IPRINT.EQ.2) .OR. (IPRINT.EQ.3)) THEN
C
C                *************
            CALL LPHIST(MINDX)
C                *************
C
          END IF
C
C---- Output label info - different if long output
C
          IF ((IPRINT.EQ.1) .OR. (IPRINT.EQ.2) .OR. (IPRINT.EQ.4)) THEN
C
C                ************************************
            CALL PUTLIN('* Column Labels :','CURWIN')
            CALL BLANK('CURWIN',1)
            CALL LABPRT(CLABEL(1,MINDX),NCOLS(MINDX))
            CALL BLANK('CURWIN',1)
            CALL PUTLIN( '* Column Types :','CURWIN')
            CALL BLANK('CURWIN',1)
            CALL LABPRT(CTYPE(1,MINDX),NCOLS(MINDX))
            IF (NSETW(MINDX).GT.0.AND.NBATCH(MINDX).EQ.0) THEN
             CALL BLANK('CURWIN',1)
             CALL PUTLIN( '* Associated datasets :','CURWIN')
             CALL BLANK('CURWIN',1)
             WRITE (STROUT,FMT='(200I4)')
     +         (CSET_ID(JDO10,MINDX),JDO10 = 1,NCOLS(MINDX))
             CALL PUTLIN(STROUT,'CURWIN')
            ENDIF
C                ************************************
C
          ELSE IF (IPRINT.EQ.3) THEN
            CALL PUTLIN(
     +   '* Column Labels, Types, Ranges [and Dataset IDs] :','CURWIN')
            CALL BLANK('CURWIN',1)
C                ***********************
C
            DO 10 JDO10 = 1,NCOLS(MINDX)
              CTEMP = CTYPE(JDO10,MINDX)
C
              IF ((CTEMP.EQ.'H') .OR. (CTEMP.EQ.'B') .OR.
     +            (CTEMP.EQ.'Y')) THEN
                IMIN = NINT(CRANGE(1,JDO10,MINDX))
                IMAX = NINT(CRANGE(2,JDO10,MINDX))
                IF (CSET_ID(JDO10,MINDX).GT.0) THEN
                 WRITE (STROUT,FMT='(A,1X,A,2X,2I19,1X,I8)') 
     +            CLABEL(JDO10,
     +            MINDX),CTEMP,IMIN,IMAX,CSET_ID(JDO10,MINDX)
                ELSE
                 WRITE (STROUT,FMT='(A,1X,A,2X,2I19)') 
     +            CLABEL(JDO10,
     +            MINDX),CTEMP,IMIN,IMAX
                ENDIF
              ELSE
                IF (CSET_ID(JDO10,MINDX).GT.0) THEN
                 WRITE (STROUT,FMT='(A,1X,A,2X,2F19.4,1X,I8)') 
     +            CLABEL(JDO10,
     +            MINDX),CTEMP,CRANGE(1,JDO10,MINDX),
     +            CRANGE(2,JDO10,MINDX),CSET_ID(JDO10,MINDX)
                ELSE
                 WRITE (STROUT,FMT='(A,1X,A,2X,2F19.4)') 
     +            CLABEL(JDO10,
     +            MINDX),CTEMP,CRANGE(1,JDO10,MINDX),
     +            CRANGE(2,JDO10,MINDX)
                ENDIF
              END IF
C
C                  ***********************
              CALL PUTLIN(STROUT,'CURWIN')
C                  ***********************
C
   10       CONTINUE
C
          END IF
C
C              *****************
          CALL BLANK('CURWIN',1)
C              *****************
C
C---- Cell dimensions for all
C
C              ***********************
          CALL PUTLIN('* Cell Dimensions :','CURWIN')
          CALL BLANK('CURWIN',1)
          WRITE (STROUT,FMT='(6F9.3)') (CELL(JJ,MINDX),JJ=1,6)
          CALL PUTLIN(STROUT,'CURWIN')
          CALL BLANK('CURWIN',1)
C              ***********************
C
C---- Resolution range for all
C
          IF ((NCOLS(MINDX).GE.3).AND.(CTYPE(1,MINDX).EQ.'H')
     +        .AND.(CTYPE(2,MINDX).EQ.'H')
     +        .AND.(CTYPE(3,MINDX).EQ.'H')
     +        .AND.((SRANGE(1,MINDX).GT.0.0)
     +        .OR.(SRANGE(2,MINDX).GT.0.0) ) ) THEN
C
            RESMIN = 1000.0
            IF(SRANGE(1,MINDX).GT.0.000001)
     +        RESMIN = 1./SQRT(SRANGE(1,MINDX))
            RESMAX = 0.5
            IF(SRANGE(2,MINDX).GT.0.000001)
     +        RESMAX = 1./SQRT(SRANGE(2,MINDX))
C
C                *************************
            CALL PUTLIN('*  Resolution Range :','CURWIN')
            CALL BLANK('CURWIN',1)
            WRITE(STROUT,FMT='(2F12.5,6X,A,F9.3,A,F9.3,A)')
     $        (SRANGE(JJ,MINDX),JJ=1,2),'(',RESMIN,' - ',RESMAX,' A )'
            CALL PUTLIN(STROUT,'CURWIN')
            CALL BLANK('CURWIN',1)
C                *************************
C
          END IF
C
C---- Sort order if it is there
C
          SORTED = .FALSE.
C
          DO 20 JDO20 = 1,5
            IF (ISORT(JDO20,MINDX).NE.0) SORTED = .TRUE.
   20     CONTINUE
C
          IF (SORTED) THEN
C
C                ***********************
            CALL PUTLIN('* Sort Order :','CURWIN')
            CALL BLANK('CURWIN',1)
            WRITE (STROUT,FMT='(5I6)') (ISORT(JJ,MINDX),JJ=1,5)
            CALL PUTLIN(STROUT,'CURWIN')
            CALL BLANK('CURWIN',1)
C                ***********************
C
          ELSE
C
C                ***********************
            CALL PUTLIN('* There is no sort order recorded ' //
     +           'in the MTZ header','CURWIN')
            CALL BLANK('CURWIN',1)
C                ***********************
C
          END IF
C
C---- Symmetry: everything for =3 or =4, else just name & number
C
          IF ((IPRINT.EQ.3) .OR. (IPRINT.EQ.4)) THEN
C
            IF (NSYM(MINDX).GT.0) THEN
              WRITE (STROUT,FMT='(A,I3)')
     +          '* Number of Symmetry Operations = ',NSYM(MINDX)
C
C                  ***********************
              CALL PUTLIN(STROUT,'CURWIN')
C                  ***********************
C
              IF (NSYMP(MINDX).GT.0) THEN
                WRITE (STROUT,FMT='(A,I3)')
     +            '* Number of Primitive Operations = ',NSYMP(MINDX)
C
C                    ***********************
                CALL PUTLIN(STROUT,'CURWIN')
C                    ***********************
C
              END IF
C
              IF (NSPGRP(MINDX).GT.0) THEN
                WRITE (STROUT,FMT='(A,I4,6X,A)') '* Space Group =',
     +            NSPGRP(MINDX),SPGNAM(MINDX)
C
C                    ***********************
                CALL PUTLIN(STROUT,'CURWIN')
C                    ***********************
C
              END IF
C
              IF (LTYPE(MINDX).NE.'?') THEN
                CALL PUTLIN('* Lattice Type = ' // LTYPE(MINDX),
     +               'CURWIN')
C                    ***********************
C
              END IF
C
              IF (PGNAM(MINDX).NE.'?') THEN
                CALL PUTLIN('* Point Group Name = ' //
     +            PGNAM(MINDX),'CURWIN')
C                    ***********************
C
              END IF
C
C                  ***********************
              CALL BLANK('CURWIN',1)
              CALL PUTLIN('* Symmetry Operations :','CURWIN')
              CALL BLANK('CURWIN',1)
C                  ***********************
C
              IPR = 1
C
C                  ************************************************
              CALL SYMTR3(NSYM(MINDX),RSYM(1,1,1,MINDX),SYMCHS,IPR)
C                  ************************************************
C
            END IF
          ELSE
             WRITE (STROUT,FMT='(A,A,A,I5,A)')
     $            '* Space group = ',
     $            SPGNAM(MINDX)(1:LENSTR(SPGNAM(MINDX))),
     $            '  (number ',NSPGRP(MINDX),')'
             CALL PUTLIN(STROUT,'CURWIN')
             CALL BLANK('CURWIN',1)
          END IF
        END IF
      END IF
C
      END
