      SUBROUTINE LKYOUT(MINDX,LSPRGO,NLPRGO,NTOK,LINE,IBEG,IEND)
C     ===========================================================
C
C-----Subroutine to read standard input lines of the form
C              LABOUT LabelFC=userFC   LabelPHCAL=userPHCAL ...
C     Use this to read the inputs, and then LWASSN to setup the
C     program label to (new) file label assignments.
C
C---- Arguments:
C
C     LSPRGO    (I)	CHARACTER*30    program label strings (array)
C                               	L(abel) S(tring) PRG(rammme) O(utput)
C
C     NLPRGO    (I)	INTEGER         number of program output labels
C                               	N(umber of) L(abels) PRG(ramme) O(utput)
C
C     NTOK      (I)	INTEGER         from Parser, number of tokens on line
C
C     LINE      (I)	CHARACTER*(*)   the input line
C
C     IBEG,IEND (I)	INTEGER         arrays from the parser, delimiters
C                               	for each token
C
C--- Local or Common variables of interest
C
C    LSUSRO    user supplied label strings
C              L(abel) S(tring) USR() O(utput)
C
C    NLUSRO    number of user output "assignment labels"
C              N(umber of) L(abels) USR() O(utput)
C
C
C     .. Parameters ..
      INTEGER MCOLS,MFILEX
      PARAMETER (MCOLS=200,MFILEX=9)
C     ..
C     .. Scalar Arguments ..
      INTEGER NLPRGO,NTOK,MINDX
      CHARACTER LINE* (*)
C     ..
C     .. Array Arguments ..
      INTEGER IBEG(*),IEND(*)
      CHARACTER*30 LSPRGO(*)
C     ..
C     .. Arrays in Common ..
      INTEGER NLUSRI,NLUSRO
      CHARACTER LSUSRI*30,LSUSRO*30
C     ..
C     .. Local Scalars ..
      INTEGER JDO,JLOOP,JSTART,JTOK
      CHARACTER CWORK*30,CWORK2*30,LC1*30,LC2*30,STROUT*400
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPUPC,PUTLIN
C     ..
C     .. Common blocks ..
      COMMON /MTZLAB/NLUSRI(MFILEX),NLUSRO(MFILEX)
      COMMON /MTZLBC/LSUSRI(MFILEX,MCOLS),LSUSRO(MFILEX,MCOLS)
C     ..
C     .. Save statement ..
      SAVE /MTZLAB/, /MTZLBC/
C     ..
C
      JTOK = NTOK
      JSTART = 2
C
C---- Keyword 
C             LabelFC=userFC   LabelPHCAL=userPHCAL ...
C
      IF (NLPRGO.LE.0) THEN
C
C            ***********************
        CALL PUTLIN(' Error this program has no OUPUT LABELS','ERRWIN')
C            ***********************
C
      ELSE IF (JTOK.LE.1) THEN
C
C            ***********************
        CALL PUTLIN(' **** Warning no argument given for LABOUT',
     +       'ERRWIN')
        CALL PUTLIN('For This Program Default labels will be used' //
     +       ' if possible','ERRWIN')
C            ***********************
C
      ELSE
C
C---- Find output label assignments
C
        DO 40 JLOOP = JSTART,NTOK,2
C
          IF ((JLOOP+1).GT.JTOK) THEN
            GO TO 50
          ELSE
            CWORK = LINE(IBEG(JLOOP) :IEND(JLOOP))
            LC1 = CWORK
C
C                *************
            CALL CCPUPC(CWORK)
C                *************
C
            CWORK2 = LINE(IBEG(JLOOP+1) :IEND(JLOOP+1))
            LC2 = CWORK2
C
C                **************
            CALL CCPUPC(CWORK2)
C                **************
C
            DO 10 JDO = 1,NLPRGO
              IF (CWORK.EQ.LSPRGO(JDO)) THEN
                GO TO 30
              ELSE IF (CWORK2.EQ.LSPRGO(JDO)) THEN
                GO TO 20
              END IF
   10       CONTINUE
C
C                ***********************
            WRITE (STROUT,FMT=
     +        '(''  Neither '',A,'' nor '',A,'' recognised'')') CWORK(1:
     +        LENSTR(CWORK)),CWORK2(1:LENSTR(CWORK2))
            CALL PUTLIN(STROUT,'ERRWIN')
            CALL CCPERR(1, 'Output column assignment does not match'//
     +           ' program labels')
C                ***********************
C
            GO TO 40
   20       NLUSRO(MINDX) = NLUSRO(MINDX) + 1
            LSUSRO(MINDX,JDO) = LC1
            GO TO 40
   30       NLUSRO(MINDX) = NLUSRO(MINDX) + 1
            LSUSRO(MINDX,JDO) = LC2
          END IF
   40   CONTINUE
        RETURN
C
   50   CONTINUE
C
        CALL PUTLIN(' **** Error !!!! for LABOUT ****','ERRWIN')
        CALL PUTLIN(' Not enough argument pairs of type '//
     +           ' Prog_label = User_label','ERRWIN')
C            ***********************
C
      END IF
C
      END
