      SUBROUTINE LKYSET(LSPRGI,NLPRGI,LSUSRJ,KPOINT,ITOK,NTOK,LINE,IBEG,
     +                  IEND)
C     ==================================================================
C
C
C-----Subroutine to parse standard input lines of the form
C              LABIN  item1=name1 item2=name2 ...
C
C     This subroutine returns the User input labels to the calling program
C     (LKYIN doesn't) and the array Kpoint to indicate which of the program
C     labels were set.
C     
C     Note : (i) there is no MINDX argument in this call - it is not tied to any
C                specific file, and the header common blocks are not affected
C                by this subroutine
C
C           (ii) although it looks similar to LKYIN IT DOES NOT REPLACE IT,
C                it just adds extra functionality
C
C---- Arguments:
C
C     LSPRGI    (I)	CHARACTER*30    program label strings (array)
C                               	L(abel) S(tring) PRG(rammme) I(nput)
C
C     NLPRGI    (I)	INTEGER         number of program input labels
C                               	N(umber of) L(abels) PRG(ramme) I(nput)
C
C     LSPRGJ    (O)	CHARACTER*30    user supplied  label strings (array)
C                               	L(abel) S(tring) USR(rammme) I(nput)
C                              		Copy of LSUSRI to return to calling program
C
C     KPOINT    (O)	INTEGER         Indicator whether this LSPRGI is set.
C					-1 if set, 0 if not
C
C     ITOK      (I)	INTEGER         First token to search on line
C     					(allows you to skip the LABIN token)
C
C     NTOK      (I)	INTEGER         from Parser, number of tokens on line
C
C     LINE      (I)	CHARACTER*(*)   the input line
C
C     IBEG,IEND (I)	INTEGER         arrays from the parser, delimiters
C                               	for each token
C
C     .. Parameters ..
      INTEGER           MCOLS
      PARAMETER         (MCOLS=200)
C     ..
C     .. Scalar Arguments ..
      INTEGER           ITOK,NLPRGI,NTOK
      CHARACTER         LINE* (*)
C     ..
C     .. Array Arguments ..
      INTEGER           IBEG(*),IEND(*),KPOINT(*)
      CHARACTER*30      LSPRGI(*),LSUSRJ(*)
C     ..
C     .. Local Scalars ..
      INTEGER           JDO,JLOOP,JSTART,JTOK
      CHARACTER         CWORK*30,CWORK2*30,LC1*30,LC2*30,STROUT*400
C     ..
C     .. Local Arrays ..
      LOGICAL SetPrgLab(MCOLS)
C     ..
C     .. External Functions ..
      INTEGER           LENSTR
      EXTERNAL          LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL          CCPUPC,PUTLIN,CCPERR
C     ..
C
      JSTART = ITOK
      JTOK = NTOK
      DO 10 JDO = 1,NLPRGI
        SetPrgLab(JDO) = .FALSE.
   10 CONTINUE
C
C---- Keyword  LABIN - ASSIGN_HKL_LABELS  item1=name1 item2=name2 ...
C
C      item == program label
C      name == user label
C
      IF (NLPRGI.LE.0) THEN
C
C            ***********************
        CALL PUTLIN(' Error this program has no PROGRAM LABELS',
     +       'ERRWIN')
C            ***********************
C
      ELSE IF (JTOK.LE.1) THEN
C
C            ***********************
        CALL PUTLIN('**** Warning: no argument given for LABIN ',
     +       'ERRWIN')
C            ***********************
C
      ELSE
C
C---- Find input label assignments
C
        DO 60 JLOOP = JSTART,NTOK,2
C
          IF ((JLOOP+1).GT.JTOK) THEN
            GO TO 70
          ELSE
            CWORK = LINE(IBEG(JLOOP) :IEND(JLOOP))
            LC1 = CWORK
C
C                *************
            CALL CCPUPC(CWORK)
C                *************
C
            CWORK2 = LINE(IBEG(JLOOP+1) :IEND(JLOOP+1))
            LC2 = CWORK2
C
C                **************
            CALL CCPUPC(CWORK2)
C                **************
C
            DO 20 JDO = 1,NLPRGI
              IF (CWORK.EQ.LSPRGI(JDO)) THEN
                IF (SetPrgLab(JDO)) GOTO 25
                GO TO 50
              ENDIF
   20       CONTINUE

   25       DO 30 JDO = 1,NLPRGI
              IF (CWORK2.EQ.LSPRGI(JDO)) THEN
                IF (SetPrgLab(JDO)) THEN
                 WRITE (STROUT,FMT=
     +            '('' ERROR with label assignments '',A,'' and '',A)') 
     +            CWORK(1:LENSTR(CWORK)),CWORK2(1:LENSTR(CWORK2))
C
C                      ***********************************************
                  CALL PUTLIN(STROUT,'ERRWIN')
                  CALL CCPERR(1,' ERROR Program label assigned twice')
C                      ***********************************************
C
                ENDIF
                GO TO 40
              END IF
   30       CONTINUE
C
            WRITE (STROUT,FMT=
     +        '(''  Neither '',A,'' nor '',A,'' recognised'')')
     +        CWORK(1:LENSTR(CWORK)),CWORK2(1:LENSTR(CWORK2))
C
C                ***********************
            CALL PUTLIN(STROUT,'ERRWIN')
C                ***********************
C
            WRITE (STROUT,FMT=
     +        '(''  OR maybe '',A,'' has been assigned twice'')') 
     +        CWORK(1:LENSTR(CWORK))
C
C                ***********************
            CALL PUTLIN(STROUT,'ERRWIN')
            CALL CCPERR(1, 'Input column assignment does not match'//
     +               ' program labels')
C                ***********************
   40       CONTINUE
            KPOINT(JDO) = -1
            LSUSRJ(JDO) = LC1
            SetPrgLab(JDO) = .TRUE.
            GO TO 60
   50       CONTINUE
            KPOINT(JDO) = -1
            LSUSRJ(JDO) = LC2
            SetPrgLab(JDO) = .TRUE.
          END IF
   60   CONTINUE
        RETURN
   70   CONTINUE
C
C            ***********************
        CALL PUTLIN(' **** Error !!!! for LABIN ****','ERRWIN')
        CALL PUTLIN(' **** Not enough argument pairs of type ',
     +       'ERRWIN')
        CALL PUTLIN('Prog_label = User_label','ERRWIN')
C            ***********************
C
      END IF
C
      END
