      SUBROUTINE LPHIST(MINDX)
C     ========================
C
C
C---- Subroutine to output the history information from the MTZ
C     file header.  This text can be anything the programmer chooses,
C     (but probably programs stamps at least).
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      INTEGER NHISLM
      PARAMETER (NHISLM=30)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX
C     ..
C     .. Arrays in Common ..
      REAL RBATW,WRANGE,WSRNGE
      INTEGER HDRST,NBATR,NBATW,NCOLW,NHISTL,NREFR,NREFW,RLUN,RPOINT,
     +        WLUN,WOMBAT,NDATMSS,NPLABS
      LOGICAL SORTB,DATMSS
      CHARACTER CBATW*1,PLABS*30,HSCR*80
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ILEN,ISTAT,JDO10
      CHARACTER LINE*400
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL BLANK,LERROR,PUTLIN
C     ..
C     .. Common blocks ..
      COMMON /MTZWRC/PLABS(MCOLS,MFILES),HSCR(NHISLM,MFILES),
     +       CBATW(CBLENG,MBATCH,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZWRK/,/MTZWRC/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LPHIST : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Then check if there are any history lines present
C
        IF (NHISTL(MINDX).EQ.0) THEN
C
C              ****************
          CALL PUTLIN('* There is no History information ' //
     +         'in this MTZ file','CURWIN')
          CALL BLANK('CURWIN',1)
C              *****************
C
        ELSE
C
C---- Read and print the history lines
C
C              ****************
          CALL PUTLIN('* HISTORY for current MTZ file : ','CURWIN')
          CALL BLANK('CURWIN',1)
C              *****************
C
          DO 10 JDO10 = 1,NHISTL(MINDX)
            ILEN = LENSTR(HSCR(JDO10,MINDX))
C
C                ****************
            CALL PUTLIN(HSCR(JDO10,MINDX) (1:ILEN),'CURWIN')
C                ****************
C
   10     CONTINUE
C
C             *****************
          CALL BLANK('CURWIN',1)
C             *****************
C
        END IF
      END IF
C
      END
