      SUBROUTINE LRBATS(MINDX,NBATX,BATCHX)
C     =====================================
C
C---- Subroutine to return the number of batches and their batch
C     serial numbers from the header of a multi-record MTZ file
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     NBATX     (I/O)	INTEGER         Dimension of BATCHX on entry;
C                                       number of batches in the file on
C                               	exit
C
C     BATCHX    (O)	INTEGER         array of dimension at least NBATX
C                               	containing the serial numbers of the
C                               	batches in the file
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,NBATX
C     ..
C     .. Array Arguments ..
      INTEGER BATCHX(*)
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,RBATR,RSYM,SRANGE,VAL_MISS
      INTEGER BATNUM,ISORT,NBATCH,NCOLS,NREFS,NSPGRP,NSYM,NSYMP
      LOGICAL VAL_SET
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ISTAT,JDO10
      CHARACTER LINE*400
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Common blocks ..
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LRBATS : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      END IF
C
C---- Copy number of batches from header
C
      NBATX = NBATCH(MINDX)
C
C---- And copy the batch serial numbers from BATNUM to BATCHX
C     if a multi-record file
C
      IF (NBATCH(MINDX).GT.0) THEN
C
        DO 10 JDO10 = 1,NBATCH(MINDX)
          BATCHX(JDO10) = BATNUM(JDO10,MINDX)
   10   CONTINUE
C
      END IF
C
      END
