      SUBROUTINE LRBRES (MINDX,BATNO)
C     ==============================
C
C---- Subroutine to reset the batch header info pointer to the
C     the batch BATNO, for re-read by subroutine LRBAT, for an MTZ file which
C     has been opened for read on index MINDX.
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     BATNO     (I)	INTEGER         batch number to reset pointer to
C                               	If BATNO = 0, reset to beginning of
C                               	batch headers
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX, BATNO
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RSYM,WRANGE,WSRNGE,VAL_MISS,RBATR,RBATW
      INTEGER ISORT,NCOLS,NCOLW,NPLABS,NREFR,NREFS,NREFW,NSPGRP,NSYM,
     +        NSYMP,RLUN,RPOINT,WLUN,NBATCH,BATNUM,NBATW,WOMBAT,NDATMSS,
     +        NBATR,HDRST,NHISTL
      LOGICAL SORTB,DATMSS,VAL_SET
C     ..
C     .. Local Scalars ..
      CHARACTER  LINE2*400
      INTEGER    ISTAT,IFAIL,JDO10
C     ..
C     .. Common blocks ..
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),
     +       ISORT(5,MFILES),CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/,/MTZWRK/
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE2,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LRBRES : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            *************************
        CALL LERROR(ISTAT,IFAIL,LINE2)
C            *************************
C
      END IF
C
C---- Check if it's really a multi-record file
C
      IF (NBATCH(MINDX).EQ.0) THEN
        WRITE (LINE2,FMT='(A,A,I2,A)') 'From LRBRES : File open on ',
     +   'index',MINDX,' is NOT a multi-record file'
        ISTAT = 2
        IFAIL = -1
C
C            *************************
        CALL LERROR(ISTAT,IFAIL,LINE2)
C            *************************
C
      END IF
C
      IF (BATNO .EQ. 0) THEN
C
C---- Reset the pointer to the current batch header to the start
C
         NBATR(MINDX) =  0
C
      ELSE
C
C---- Reset the pointer to batch BATNO
C     Find it
C
        DO 10, JDO10 = 1, NBATCH(MINDX)
          IF (BATNO .EQ. BATNUM(JDO10,MINDX)) THEN
C
C---- Found, set pointer to previous batch (incremented in LRBAT)
C
            NBATR(MINDX) = JDO10 - 1
            RETURN
C           ======
C
          END IF
 10     CONTINUE
C
C---- Not found
C
        WRITE (LINE2,FMT='(A,A,I2,A,I8)') 
     +        'From LRBRES : File open on ',
     +        'index',MINDX,' has no batch number ',BATNO
        ISTAT = 2
        IFAIL = -1
C
C            *************************
        CALL LERROR(ISTAT,IFAIL,LINE2)
C            *************************
      END IF
C
      RETURN
C
      END
