      SUBROUTINE LRBTIT (MINDX,BATNO,TBATCH,IPRINT)
C     ============================================
C
C---- Subroutine to read batch title for
C     batch BATNO from batch headers from multi-record mtz file open
C     on index MINDX
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     BATNO     (I)	INTEGER         batch number 
C
C     IPRINT    (I)	INTEGER         print flag
C                             		= 0  no print
C                             		= 1  print title
C					= 2  print title & orientation block
C
C     TBATCH    (O)	CHARACTER       batch title
C
C ... Arguments
      INTEGER MINDX, BATNO, IPRINT
      CHARACTER*(*) TBATCH
C
C     .. Common blocks ..
      INTEGER NWORDS,NINTGR,NREALS,IORTYP,LBCELL,MISFLG,
     .     JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,LBMFLG,NDET,
     $     LBSETID,INTPAD
      REAL   CELL,UMAT,PHIXYZ,CRYDAT,DATUM,
     $     PHISTT,PHIEND,PHIRANGE,SCANAX,TIME1,TIME2,
     $     BSCALE,BBFAC,SDBSCL,SDBFAC,BATPAD,E1,E2,E3,GONPAD,
     $     SOURCE,S0,BEMDAT,
     $     DX1,THETA1,DETLM1,DX2,THETA2,DETLM2,DETPAD
      CHARACTER BTITLE*70, GONLAB*8, BTITL*94
C     
      COMMON /CBTHDR/BTITLE,GONLAB(3)
C     
      COMMON /MBTHDR/ NWORDS,NINTGR,NREALS,IORTYP,LBCELL(6),MISFLG,
     .     JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,LBMFLG,
     +     NDET,LBSETID,INTPAD(8),
     +     CELL(6),UMAT(3,3),PHIXYZ(3,2),CRYDAT(12),DATUM(3),
     $     PHISTT,PHIEND,SCANAX(3),TIME1,TIME2,
     $     BSCALE,BBFAC,SDBSCL,SDBFAC,PHIRANGE,BATPAD(11),
     $     E1(3),E2(3),E3(3),
     $     GONPAD(12),SOURCE(3),S0(3),BEMDAT(25),
     $     DX1,THETA1,DETLM1(2,2),DX2,THETA2,DETLM2(2,2),DETPAD(33)
      SAVE /CBTHDR/, /MBTHDR/
      REAL RNWRDS (1)
      EXTERNAL LRBRES, LRBAT
      EQUIVALENCE (NWORDS,RNWRDS)
C     
C--- Set read pointer to this batch
      CALL LRBRES(MINDX,BATNO)
C--- Read Orientation block
C     NB the original of this had BTITLE in the call, but it's in common
C     and updated during the call, so illegal
      BTITL = BTITLE
      CALL LRBAT(MINDX,BATNO,RNWRDS,BTITL,IPRINT)
      BTITLE = BTITL
C
C Copy title
      TBATCH = BTITLE
C
      RETURN
C
      END
