      SUBROUTINE LRHIST(MINDX,HSTRNG,NLINES)
C     =====================================
C
C
C---- Subroutine to return the history information from the MTZ
C     file header.  This text can be anything the programmer chooses,
C     (but probably programs stamps at least).
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     HSTRNG    (O)	CHARACTER       array of (NLINES) with the history lines
C
C     NLINES    (I/O)	INTEGER         on entry, dimension of HSTRNG; on
C                                       exit, number of history lines being
C                                       returned.
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      INTEGER NHISLM
      PARAMETER (NHISLM=30)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,NLINES
C     ..
C     .. Array Arguments ..
      CHARACTER HSTRNG(*)*(*)
C     ..
C     .. Arrays in Common ..
      REAL RBATW,WRANGE,WSRNGE
      INTEGER HDRST,NBATR,NBATW,NCOLW,NHISTL,NPLABS,NREFR,NREFW,RLUN,
     +        RPOINT,WLUN,WOMBAT,NDATMSS
      LOGICAL SORTB,DATMSS
      CHARACTER CBATW*1,PLABS*30,HSCR*80
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ISTAT,JDO10
      CHARACTER LINE*400
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Common blocks ..
      COMMON /MTZWRC/PLABS(MCOLS,MFILES),HSCR(NHISLM,MFILES),
     +       CBATW(CBLENG,MBATCH,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZWRK/,/MTZWRC/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LRHIST : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Then check if there are any history lines present
C
        IF (NHISTL(MINDX).EQ.0) THEN
C
          NLINES = 0
C
        ELSE
C
C---- Copy the history lines to HSTRNG
C
          DO 10 JDO10 = 1,NHISTL(MINDX)
            HSTRNG(JDO10) = HSCR(JDO10,MINDX)
   10     CONTINUE
          NLINES = NHISTL(MINDX)
C
        END IF
      END IF
C
      END
