      SUBROUTINE LRID(MINDX,PNAME,DNAME,ISETS,NDATASETS)
C     ====================================================
C
C---- Subroutine to return information for all datasets from the MTZ file
C     header.
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     PNAME     (O)     CHARACTER       array of dimension at least NDATASETS
C                               	containing the project name on exit
C
C     DNAME     (O)     CHARACTER       array of dimension at least NDATASETS
C                               	containing the dataset name on exit
C
C     ISETS     (O)     INTEGER         array of dimension at least NDATASETS
C                               	containing the dataset id on exit
C
C     NDATASETS (O)     INTEGER         number of datasets in MTZ header
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS
      PARAMETER (MFILES=4,MCOLS=200)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
C     ..
C     .. Scalar Arguments ..
      INTEGER NDATASETS,MINDX,ISETS(*)
      CHARACTER*(*) PNAME(*),DNAME(*)
C     ..
C     .. Local Scalars ..
      INTEGER ISET,ISTAT,IFAIL
      CHARACTER LINE*400
C     ..
C     .. Arrays in Common ..
      INTEGER NSETW,SET_ID,CSET_ID,IDEFSET
      CHARACTER ENTRY_ID*64,DIFFRN_ID*64

      COMMON /MTZHAR/NSETW(MFILES),SET_ID(MSETS,MFILES),
     +       ENTRY_ID(MSETS,MFILES),DIFFRN_ID(MSETS,MFILES),
     +       CSET_ID(MCOLS,MFILES),IDEFSET(MFILES)
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LRID : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ENDIF

C     New dataset to be added to header
      NDATASETS = NSETW(MINDX)
      DO 10 ISET = 1,NDATASETS
        PNAME(ISET) = ENTRY_ID(ISET,MINDX)
        DNAME(ISET) = DIFFRN_ID(ISET,MINDX)
        ISETS(ISET) = SET_ID(ISET,MINDX)
 10   CONTINUE

      END
