      SUBROUTINE LRINFO(MINDX,VERSNX,NCOLX,NREFLX,RANGES)
C     ===================================================
C
C
C---- Subroutine to return information about the MTZ file open for
C     read on index MINDX.
C
C---- Arguments : 
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     VERSNX    (O)	CHARACTER*10    version stamp of MTZ subroutines used
C                               	to write the file.
C
C     NCOLX     (I/O)	INTEGER         on entry, last dimension of RANGES; on
C                                       exit, number of columns in the file
C
C     NREFLX    (O)	INTEGER         number of reflection records in the file
C
C     RANGES    (O)	REAL            array(2,ncolx) containing the minimum
C                               	and maximum values in each column
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      CHARACTER*10 VERSN
      PARAMETER (VERSN='MTZ:V1.1')
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,NCOLX,NREFLX
      CHARACTER VERSNX*10
C     ..
C     .. Array Arguments ..
      REAL RANGES(2,*)
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RSYM,VAL_MISS
      INTEGER BATNUM,ISORT,NBATCH,NCOLS,NREFS,NSPGRP,NSYM,NSYMP
      LOGICAL VAL_SET
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ISTAT,JDO10
      CHARACTER LINE*400
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Common blocks ..
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LRINFO : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Then return the information
C
        VERSNX = VERSN
        NCOLX = NCOLS(MINDX)
        NREFLX = NREFS(MINDX)
C
        DO 10 JDO10 = 1,NCOLS(MINDX)
          RANGES(1,JDO10) = CRANGE(1,JDO10,MINDX)
          RANGES(2,JDO10) = CRANGE(2,JDO10,MINDX)
   10   CONTINUE
C
      END IF
C
      END
