      SUBROUTINE LRNREF(MINDX,REFNUM)
C     ===============================
C
C
C---- Subroutine to return the current reflection number from an
C     MTZ file opened for read. Files are normally read sequentially,
C     the number returned is the number of the *NEXT* reflection
C     record to be read. If you are going to jump about the file
C     with LRSEEK then use this to record the current position before
C     you start, so that it can be restored afterwards, if required.
C
C
C---- Arguments:
C
C     MINDX     (I)	INTEGER         indicates which MTZ file (up to MFILES
C                               	possible open at once)
C
C     REFNUM    (O)	INTEGER         the reflection record number of the
C                               	next reflection to be read
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,REFNUM
C     ..
C     .. Arrays in Common ..
      REAL RBATW,WRANGE,WSRNGE
      INTEGER HDRST,NBATR,NBATW,NCOLW,NHISTL,NPLABS,NREFR,NREFW,RLUN,
     +        RPOINT,WLUN,WOMBAT,NDATMSS
      LOGICAL SORTB,DATMSS
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ISTAT
      CHARACTER LINE*400
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Common blocks ..
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZWRK/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LRNREF : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Return the reflection number
C
        REFNUM = NREFR(MINDX) + 1
C
      END IF
C
      END
