      SUBROUTINE LROPEN(MINDX,FILNAM,IPRINT,IFAIL)
C     =============================================
C
C---- Subroutine to open an MTZ file for read.
C     This should be the first MTZ subroutine called in a set of
C     operations on a pair of files (ie one input and one output).
C     The subroutine zeros all the Header COMMON block entries,
C     opens the specified file and loads the header into the COMMONs,
C     and positions the file ready to read the first data record.
C
C---- Arguments :
C
C     MINDX     (I) 	INTEGER         indicates which MTZ file - 1 index
C                       	        points to both input and output files
C
C     FILNAM    (I)	CHARACTER       name of file to be opened
C
C     IPRINT    (I)	INTEGER         print indicator : meaning :
C     					=0 No MTZ info printed at all
C	                               	=1 Brief header info printed (default)
C	                               	=2 as above plus history info
C        	                       	=3 Full header dump; symmetry
C               	                any other value; nothing happens
C     IFAIL     (O)	INTEGER         error indicator : meaning :
C                               	on exit
C                               	=0 OK
C                               	=-1 no such file (but broken!)
C                               	all other errors cause stop
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
      INTEGER MINCOL
      PARAMETER (MINCOL=3)
      INTEGER NTYP,LTYP
      PARAMETER (NTYP=16,LTYP=9)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      INTEGER SIZE1
      PARAMETER (SIZE1=20)
      INTEGER NHISLM
      PARAMETER (NHISLM=30)
      INTEGER NPARSE
      PARAMETER (NPARSE=200)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER IFAIL,MINDX,IPRINT
      CHARACTER FILNAM* (*)
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RBATW,RSYM,WRANGE,WSRNGE,VAL_MISS
      INTEGER BATNUM,HDRST,ISORT,NBATCH,NBATR,NBATW,NCOLS,NCOLW,NHISTL,
     +        NPLABS,NREFR,NREFS,NREFW,NSPGRP,NSYM,NSYMP,RLUN,RPOINT,
     +        WLUN,WOMBAT,NDATMSS,NSETW,SET_ID,CSET_ID,IDEFSET
      LOGICAL SORTB,DATMSS,VAL_SET
      CHARACTER CBATR*1,CBATW*1,CTYPE*1,LTYPE*1,PGNAM*10,SPGNAM*10,
     +          CLABEL*30,PLABS*30,TITLE*70,HSCR*80,ENTRY_ID*64,
     +          DIFFRN_ID*64
C     ..
C     .. Local Scalars ..
      INTEGER BATFLG,EFLAG,ENDLOP,IER,ISTAT,ITEND,IUNIN,JDO10,JDO55,
     +        JDO100,JDO110,JDO120,JDO130,JDO140,JDO150,JDO190,JDO20,
     +        JDO200,JDO30,JDO40,JDO50,JDO60,JDO80,JDO90,NBATRF,NCOLR,
     +        NITEM,NJUNK,NSYMIN,NTOK,SYFLAG,IRESLT,NSETP,NSETD
      LOGICAL LEND
      CHARACTER KEY*4,MKEY*4,LINE*80,LINE2*400,STROUT*400
C     ..
C     .. Local Arrays ..
      REAL FVALUE(NPARSE)
      INTEGER IBEG(NPARSE),IDEC(NPARSE),IEND(NPARSE),ITYP(NPARSE)
      CHARACTER CTYPES(NTYP)*1,LTYPES(LTYP)*1,CVALUE(NPARSE)*4
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
      EXTERNAL QNAN
C     ..
C     .. External Subroutines ..
      EXTERNAL BLANK,GTPINT,GTPREA,LERROR,LHPRT,LRCLOS,LRHDRL,PARSER,
     +     PUTLIN,QMODE,QOPEN,QSEEK,RBATHD,LSTRSL,SYMFR3, QRARCH,
     +     QREADI, QPRINT, QREADC
C     ..
C     .. Common blocks ..
      COMMON /MTZCHR/TITLE(MFILES),CLABEL(MCOLS,MFILES),
     +       CTYPE(MCOLS,MFILES),SPGNAM(MFILES),LTYPE(MFILES),
     +       CBATR(CBLENG,MBATCH,MFILES),PGNAM(MFILES)
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZWRC/PLABS(MCOLS,MFILES),HSCR(NHISLM,MFILES),
     +       CBATW(CBLENG,MBATCH,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
      COMMON /MTZHAR/NSETW(MFILES),SET_ID(MSETS,MFILES),
     +       ENTRY_ID(MSETS,MFILES),DIFFRN_ID(MSETS,MFILES),
     +       CSET_ID(MCOLS,MFILES),IDEFSET(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/,/MTZCHR/,/MTZWRK/,/MTZWRC/
C     ..
C     .. Data statements ..
C  Adding column types to indicate pairs associated with hkl and -h-k-l
C  Need new indicator for F Q; using G L
C                         J Q; using K M
      DATA CTYPES/'H','J','F','D','Q','P','W','A','B','Y','I','R',
     +            'G','K','L','M'/
      DATA LTYPES/'P','A','B','C','I','F','R','H','?'/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE2,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LROPEN : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
C
C            *************************
        CALL LERROR(2,-1,LINE2)
C            ************************
C
      ELSE
C
C---- Then check that nothing is already open for this index
C     If it is continue, but print warning
C     If already open for read, then probably forgot to call LRCLOS
C     If already open for write, then programmer hasn't read manual!
C     but might not be so bad
C     If open for read AND write, then stop
C
        IF (RLUN(MINDX).NE.0) THEN
          IF (WLUN(MINDX).NE.0) THEN
            WRITE (LINE2,FMT='(A,A,I3,A)')
     +        'From LROPEN : Wrong index in call, files already open',
     +        ' for read AND write on index',MINDX,'  pretty serious'
C
C                *************************
            CALL LERROR(2,-1,LINE2)
C                *************************
C
          ELSE
            WRITE (LINE2,FMT='(A,A,I3,A)')
     +        'From LROPEN : Wrong index in call, file already open for'
     +        ,' read on index',MINDX,' all header info will be lost'
C
C                *************************
            CALL LERROR(1,1,LINE2)
C                *************************
C
C---- Get rid of existing file info with LRCLOS
C
C                *************
            CALL LRCLOS(MINDX)
C                *************
C
          END IF
        END IF
C
        IF (WLUN(MINDX).NE.0) THEN
          WRITE (LINE2,FMT='(A,A,I3,A)')
     +      'From LROPEN : Wrong index in call, file already open for',
     +      ' write on index',MINDX,' output header may be corrupted'
C
C              *************************
          CALL LERROR(1,1,LINE2)
C              *************************
C
        END IF
C
C---- Open the file and record the stream, and set mode=bytes
C     The  MTZ header is written with mode=0, except the header
C     offset and the orientation blocks
C     The reflection records are written with mode=2, words/reals
C
C            ************************
        CALL QOPEN(IUNIN,FILNAM,'RO')
C       set up transparent numbers if necessary:
        CALL QRARCH (IUNIN, 2, IRESLT)
        IF (IRESLT.EQ.0) CALL QPRINT(1,
     +       ' WARNING: no architecture information in file --'//
     +       ' assuming native.')
        CALL QMODE(IUNIN,0,NITEM)
C            ************************
C
        RLUN(MINDX) = IUNIN
C
C---- Zero the header arrays etc.
C
        DO 10 JDO10 = 1,6
          CELL(JDO10,MINDX) = 0.0
   10   CONTINUE
C
        NSYM(MINDX) = 0
        NSYMP(MINDX) = 0
C
        DO 40 JDO40 = 1,MAXSYM
          DO 30 JDO30 = 1,4
            DO 20 JDO20 = 1,4
              RSYM(JDO20,JDO30,JDO40,MINDX) = 0.0
   20       CONTINUE
   30     CONTINUE
   40   CONTINUE
C
        NCOLS(MINDX) = 0
        NDATMSS(MINDX) = 0
        NREFS(MINDX) = 0
        NREFR(MINDX) = 0
        NBATCH(MINDX) = 0
        NPLABS(MINDX) = 0
        SRANGE(1,MINDX) = 1.0E-05
        SRANGE(2,MINDX) = 500.0
C  Default values - VAL_MISS(1,..) ( File for reading) is NaN, 
C                   VAL_MISS(2,..) ( File for writing) is Nan
        CALL QNAN(VAL_MISS(1,MINDX))
        CALL QNAN(VAL_MISS(2,MINDX))
        VAL_SET(1,MINDX) = .FALSE.
        VAL_SET(2,MINDX) = .FALSE.
        NHISTL(MINDX) = 0
        HDRST(MINDX) = 0
        NSETW(MINDX) = 0
        IDEFSET(MINDX) = 0
        TITLE(MINDX) = '   '
        NSPGRP(MINDX) = 0
        SPGNAM(MINDX) = '?'
        LTYPE(MINDX) = '?'
        PGNAM(MINDX) = '?'
C
        DO 50 JDO50 = 1,5
          ISORT(JDO50,MINDX) = 0
   50   CONTINUE
C
        DO 55 JDO55 = 1,MSETS
          SET_ID(JDO55,MINDX) = 0
          ENTRY_ID(JDO55,MINDX) = ' '
          DIFFRN_ID(JDO55,MINDX) = ' '
   55   CONTINUE

        DO 60 JDO60 = 1,MCOLS
          CRANGE(1,JDO60,MINDX) = 0.0
          CRANGE(2,JDO60,MINDX) = 0.0
          CSET_ID(JDO60,MINDX) = 0
          CLABEL(JDO60,MINDX) = '   '
          CTYPE(JDO60,MINDX) = ' '
          RPOINT(JDO60,MINDX) = 0
          PLABS(JDO60,MINDX) = ' '
   60   CONTINUE
C
        NBATRF = 0
        NCOLR = 0
        NSETP = 0
        NSETD = 0
        NSYMIN = 0
        SYFLAG = 1
        BATFLG = 1
C
C---- Read the 1st record of the file, check it's an MTZ file,
C     and go to the start of the header records
C     Read in header records with mode=0 (bytes), except offset
C
C            ******************************
        CALL QSEEK(RLUN(MINDX),1,1,1)
        CALL QREADC(RLUN(MINDX),MKEY,IER)
C            ******************************
C
        IF (IER.NE.0) THEN
          LINE2 = ' From LROPEN : Error reading 1st record of MTZ file'
          LINE2(LENSTR(LINE2)+2:) = FILNAM
C
C              *************************
          CALL LERROR(2,-1,LINE2)
C              *************************
        ELSE
          IF (MKEY(1:3).NE.'MTZ') THEN
            LINE2 = ' From LROPEN : File '
            LINE2(LENSTR(LINE2)+2:) = FILNAM(1:LENSTR(FILNAM))
            IF (LENSTR(LINE2) .NE. 399) 
     .                 LINE2(LENSTR(LINE2)+1:) = ' is not an MTZ file'
C
C                *************************
            CALL LERROR(2,-1,LINE2)
C                *************************
C
          ELSE
C
            IF (IPRINT.GT.0) THEN
              WRITE (STROUT,FMT='(A,I3)')
     +          'HEADER INFORMATION FROM INPUT MTZ FILE ON INDEX',MINDX
C
C                  ***********************
              CALL PUTLIN(STROUT,'CURWIN')
              CALL BLANK('CURWIN',1)
C                  ***********************
C
            END IF
C
C                *************************************
            CALL QMODE(RLUN(MINDX),6,NITEM)
            CALL QREADI(RLUN(MINDX),HDRST(MINDX),1,IER)
            CALL QSEEK(RLUN(MINDX),1,HDRST(MINDX),1)
            CALL QMODE(RLUN(MINDX),0,NITEM)
C                *************************************
C
   70       CONTINUE
C
C---- Got this far, so read and parse the header, and load COMMON blocks
C
C---- Start of loop over header lines
C     -------------------------------
C
C                ************************
            CALL LRHDRL(RLUN(MINDX),LINE)
C                ************************
C
            NTOK = NPARSE
C
C---- Pass header line to parser
C
C                *******************************************************
            CALL PARSER(KEY,LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,NTOK,
     +                  LEND,.FALSE.)
C                *******************************************************
C
C---- And loop over possible keywords
C     -------------------------------
C
C---- VERS - version of routines which wrote the file
C
            IF (KEY.EQ.'VERS') THEN
              IF (LINE(IBEG(2):IEND(2)) .NE. 'MTZ:V1.1')
     +           CALL CCPERR (1,' MTZ version ' // LINE(IBEG(2):IEND(2))
     +     // ' of file incompatible with this version of the software')
              IF (IPRINT.EQ.3) THEN
C
C                    ***********************
                CALL PUTLIN('MTZ file, Version Stamp '//
     +               LINE(IBEG(2):IEND(2)),'CURWIN')
                CALL BLANK('CURWIN',1)
C                    ***********************
C
              END IF
              GO TO 70
C
C---- TITL - read file title
C
            ELSE IF (KEY.EQ.'TITL') THEN
              TITLE(MINDX) = ' '
              IF(NTOK.EQ.1) GO TO 70
              ITEND = IEND(NTOK)
              IF(ITEND .GT.70) ITEND = 70
              TITLE(MINDX) = LINE(IBEG(2) :ITEND)
              GO TO 70
C
C---- NCOL - no. of cols and refls in file
C
            ELSE IF (KEY.EQ.'NCOL') THEN
C
C                  **************************************
              CALL GTPINT(2,NCOLS(MINDX),NTOK,ITYP,FVALUE)
              CALL GTPINT(3,NREFS(MINDX),NTOK,ITYP,FVALUE)
              CALL GTPINT(4,NBATCH(MINDX),NTOK,ITYP,FVALUE)
C                  **************************************
              IF (NBATCH(MINDX).GT.MBATCH) THEN
                 WRITE (LINE2,FMT='(A,I6)')
     +   ' From LROPEN : too many batches in file, maximum is', MBATCH
C
C                     *************************
                 CALL LERROR(2,-1,LINE2)
C                     *************************
              ENDIF
C
              GO TO 70
C
C---- CELL - read in the Cell parameters
C
            ELSE IF (KEY.EQ.'CELL') THEN
C
              DO 80 JDO80 = 1,6
C
C                    *************************************************
             CALL GTPREA(JDO80+1,CELL(JDO80,MINDX),NTOK,ITYP,FVALUE)
C                    *************************************************
C
   80         CONTINUE
C
C---- Set up the S calculation
C
C                  *************************************************
              CALL LSTRSL(MINDX,CELL(1,MINDX),CELL(2,MINDX),
     +                    CELL(3,MINDX),CELL(4,MINDX),CELL(5,MINDX),
     +                    CELL(6,MINDX))
C                  *************************************************
C
              GO TO 70
C
C---- SORT - read in sort order
C
            ELSE IF (KEY.EQ.'SORT') THEN
C
              DO 90 JDO90 = 1,5
C
C                    **************************************************
                CALL GTPINT(JDO90+1,ISORT(JDO90,MINDX),NTOK,ITYP,FVALUE)
C                    **************************************************
C
   90         CONTINUE
              GO TO 70
C
C---- SYMINF - various symmetry stuff
C
            ELSE IF (KEY.EQ.'SYMI') THEN
C
C                  **************************************
              CALL GTPINT(2,NSYM(MINDX),NTOK,ITYP,FVALUE)
              CALL GTPINT(3,NSYMP(MINDX),NTOK,ITYP,FVALUE)
C                  ***************************************
C
              LTYPE(MINDX) = LINE(IBEG(4) :IBEG(4))
C
C                  ***************************************
              CALL GTPINT(5,NSPGRP(MINDX),NTOK,ITYP,FVALUE)
C                  ***************************************
C
              SPGNAM(MINDX) = LINE(IBEG(6) :IEND(6))
              PGNAM(MINDX) = LINE(IBEG(7) :IEND(7))
C
              DO 100 JDO100 = 1,LTYP
                IF (LTYPE(MINDX).EQ.LTYPES(JDO100)) GO TO 70
  100         CONTINUE
C
              WRITE (LINE2,FMT='(A)')
     +     'From LROPEN : Unrecognised Lattice type in header, set to P'
C
C                  *************************
              CALL LERROR(1,1,LINE2)
C                  *************************
C
              LTYPE(MINDX) = 'P'
              GO TO 70
C
C---- SYMM - read in the symmetry cards and convert to matrices
C
            ELSE IF (KEY.EQ.'SYMM') THEN
              IF (SYFLAG.GE.0) THEN
                NSYMIN = NSYMIN + 1
                NJUNK = NSYMIN
                ISTAT = 5
C
C                    *************************************************
                CALL SYMFR3(LINE,ISTAT,NSYMIN,RSYM(1,1,1,MINDX),EFLAG)
C                    *************************************************
C
                IF (EFLAG.GT.0) THEN
                  WRITE (LINE2,FMT='(A,A)')
     +    'From LROPEN : An error occured reading symmetry from header,'
     +              ,' No symmetry information stored'
C
C                      *************************
                  CALL LERROR(1,1,LINE2)
C                      *************************
C
                  NSYM(MINDX) = 0
                  NSYMP(MINDX) = 0
C
                  DO 130 JDO130 = 1,MAXSYM
                    DO 120 JDO120 = 1,4
                      DO 110 JDO110 = 1,4
                        RSYM(JDO110,JDO120,JDO130,MINDX) = 0.0
  110                 CONTINUE
  120               CONTINUE
  130             CONTINUE
C
                  SYFLAG = -1
                END IF
              END IF
              GO TO 70
C
C---- RESO - resolution range
C
            ELSE IF (KEY.EQ.'RESO') THEN
C
C                  ******************************************
              CALL GTPREA(2,SRANGE(1,MINDX),NTOK,ITYP,FVALUE)
              CALL GTPREA(3,SRANGE(2,MINDX),NTOK,ITYP,FVALUE)
C                  ******************************************
C
              GOTO 70
C
C---- VAL_MAGIC - Missing value flag
C---  will either say VAL_MAGIC NAN   or VAL_MAGIC   real
C
            ELSE IF (KEY.EQ.'VALM') THEN
C
C   Second token is NAN -  Call QNAN function.
              IF (ITYP(2).EQ.1)  THEN
                CALL QNAN (VAL_MISS(1,MINDX))
              ELSE
                 CALL GTPREA(2,VAL_MISS(1,MINDX),NTOK,ITYP,FVALUE)
              END IF
              VAL_SET(1,MINDX) = .TRUE.
C  Set output VAL_MISS same as input by default.
              VAL_MISS(2,MINDX) = VAL_MISS(1,MINDX)
C
              GOTO 70
C
C---- COLS - column labels, types and ranges
C
            ELSE IF (KEY.EQ.'COLU') THEN
              NCOLR = NCOLR + 1
              CLABEL(NCOLR,MINDX) = LINE(IBEG(2) :IEND(2))
              CTYPE(NCOLR,MINDX) = LINE(IBEG(3) :IBEG(3))
C
C                  ************************************************
              CALL GTPREA(4,CRANGE(1,NCOLR,MINDX),NTOK,ITYP,FVALUE)
              CALL GTPREA(5,CRANGE(2,NCOLR,MINDX),NTOK,ITYP,FVALUE)
              IF (NTOK.GE.6) 
     +         CALL GTPINT(6,CSET_ID(NCOLR,MINDX),NTOK,ITYP,FVALUE)
C                  ************************************************
C
              DO 140 JDO140 = 1,NTYP
                IF (CTYPE(NCOLR,MINDX).EQ.CTYPES(JDO140)) GO TO 70
  140         CONTINUE
C
              WRITE (LINE2,FMT='(A,I4,A,A,A,A,A)')
     +          'From LROPEN : Column',NCOLR,' Label ',
     +          CLABEL(NCOLR,MINDX),'has unrecognised type (',
     +          CTYPE(NCOLR,MINDX),') - set to R'
C
C                  *************************
              CALL LERROR(1,1,LINE2)
C                  *************************
C
              CTYPE(NCOLR,MINDX) = 'R'
              GO TO 70

C---- Information on datasets used in harvesting

            ELSEIF (KEY.EQ.'NDIF') THEN

              CALL GTPINT(2,NSETW(MINDX),NTOK,ITYP,FVALUE)
              GO TO 70

C---- This works with MTZ files written by current LWCLOS, but
C     might be problems if PROJ or DATA records get out of order.
            ELSEIF (KEY.EQ.'PROJ') THEN
              NSETP = NSETP + 1
              CALL GTPINT(2,SET_ID(NSETP,MINDX),NTOK,ITYP,FVALUE)
              ENTRY_ID(NSETP,MINDX) = LINE(IBEG(3) :IEND(3))
              GO TO 70

            ELSEIF (KEY.EQ.'DATA') THEN
              NSETD = NSETD + 1
              CALL GTPINT(2,SET_ID(NSETD,MINDX),NTOK,ITYP,FVALUE)
              DIFFRN_ID(NSETD,MINDX) = LINE(IBEG(3) :IEND(3))
              GO TO 70
C
C---- BATCH - serial numbers of the batches in the file 
C             (only if NBATCH>0)
C             written 18 numbers per card
C
            ELSE IF (KEY.EQ.'BATC') THEN
              IF (NBATCH(MINDX).NE.0) THEN
                IF (NTOK.LT.13) THEN
                  ENDLOP = NBATRF + NTOK - 1
                ELSE
                  ENDLOP = NBATRF + 12
                END IF
C
                DO 150 JDO150 = NBATRF + 1,ENDLOP
C
C                      ************************************************
                  CALL GTPINT(JDO150-NBATRF+1,BATNUM(JDO150,MINDX),NTOK,
     +                        ITYP,FVALUE)
C                      ************************************************
C
  150           CONTINUE
C
                NBATRF = ENDLOP
              ELSE IF (BATFLG.GT.0) THEN
                WRITE (LINE2,FMT='(A)')
     +      'From LROPEN : Batch information in MTZ header inconsistent'
C
C                    *************************
                CALL LERROR(1,1,LINE2)
C                    *************************
C
                BATFLG = -1
              END IF
              GO TO 70
C
C---- END of header card
C
            ELSE IF (KEY.NE.'END') THEN
C
C---- illegal line, ignore it
C
              WRITE (LINE2,FMT='(A)')
     +      'From LROPEN : Illegal keyword in MTZ header - line ignored'
C
C                  *************************
              CALL LERROR(1,1,LINE2)
              CALL PUTLIN(LINE,'ERRWIN')
              CALL PUTLIN(' ','ERRWIN')
C                  ***********************
C
              GO TO 70
            END IF
C
C---- End of loop over keywords
C     -------------------------
C
C---- Check we have minimum number of columns - should always be true because
C     you can't get out of LWCLOS with less, but check anyway
C
            IF (NCOLS(MINDX).LT.MINCOL) THEN
              WRITE (LINE2,FMT='(A,I4,A,I4)')
     +          'From LROPEN : Header indicates',NCOLS(MINDX),
     +          ' columns, but minimum allowed columns in MTZ file is',
     +          MINCOL
C
C                  *************************
              CALL LERROR(1,1,LINE2)
C                  *************************
C
            END IF
C
C---- Check no. of column cards input equals NCOLS from 1st line
C
            IF (NCOLR.NE.NCOLS(MINDX)) THEN
              WRITE (LINE2,FMT='(A,I4,A,A,I4,A)')
     +          'From LROPEN : Header indicates',NCOLS(MINDX),
     +          ' columns, but ',' there were',NCOLR,
     +          ' column labels in header'
C
C                  *************************
              CALL LERROR(1,1,LINE2)
C                  *************************
C
            END IF
C
C---- Check no. of datasets input equals NSETW from NDIFFRN line
C
            IF (NSETP.NE.NSETW(MINDX)) THEN
              WRITE (LINE2,FMT='(A,I4,A,A,I4,A)')
     +          'From LROPEN : Header indicates',NSETW(MINDX),
     +          ' datasets, but ',' there were',NSETP,
     +          ' PROJECT records in header'
C
C                  *************************
              CALL LERROR(2,-1,LINE2)
C                  *************************
C
            ELSEIF (NSETD.NE.NSETW(MINDX)) THEN
              WRITE (LINE2,FMT='(A,I4,A,A,I4,A)')
     +          'From LROPEN : Header indicates',NSETW(MINDX),
     +          ' datasets, but ',' there were',NSETD,
     +          ' DATASET records in header'
C
C                  *************************
              CALL LERROR(2,-1,LINE2)
C                  *************************
C
            END IF
C
C----Default dataset is that of 1st column (H)
C
            IF (NSETW(MINDX).GT.0) THEN
              IDEFSET(MINDX) = CSET_ID(1,MINDX)
            END IF
C
C---- Check correct number of symmetry cards
C
            IF ((NSYMIN.NE.NSYM(MINDX)) .AND. (SYFLAG.GE.0)) THEN
              WRITE (LINE2,FMT='(A,I3,A,A,I3,A)')
     +          'From LROPEN : Header indicates',NSYM(MINDX),
     +          ' symmetry ops,',' but',NSYMIN,
     +          ' ops were present in header'
C
C                  *************************
              CALL LERROR(1,1,LINE2)
C                  *************************
C
            END IF
C
C---- If BATCH cards in header prepare to read batch headers
C
            IF (NBATCH(MINDX).GT.0) THEN
              IF (NBATRF.NE.NBATCH(MINDX)) THEN
                WRITE (LINE2,FMT='(A,I4,A,I4,A)')
     +            'From LROPEN : Header indicates',NBATCH(MINDX),
     +            ' batches, but',NBATRF,' serial numbers present'
C
C                    *************************
                CALL LERROR(1,1,LINE2)
C                    *************************
C
                NBATCH(MINDX) = NBATRF
              END IF
              NBATR(MINDX) = 0
            END IF
  160       CONTINUE
C
C---- Main header read, continue with any other headers
C
C                ************************
            CALL LRHDRL(RLUN(MINDX),LINE)
C                ************************
C
C---- History header ?
C
            IF (LINE(1:7).EQ.'MTZHIST') THEN
              READ (LINE(9:),FMT='(I3)') NHISTL(MINDX)
C
              DO 170 JDO190 = 1,NHISTL(MINDX)
C
C                    **************************************
                CALL LRHDRL(RLUN(MINDX),HSCR(JDO190,MINDX))
C                    **************************************
C
  170         CONTINUE
              GO TO 160
C
C---- Batch headers
C
            ELSE IF (LINE(1:7).EQ.'MTZBATS') THEN
              IF (NBATCH(MINDX).EQ.0) THEN
                GO TO 190
              ELSE
C
                DO 180 JDO200 = 1,NBATCH(MINDX)
C
C                      **********************************************
                  CALL RBATHD(RLUN(MINDX),NJUNK,RBATR(1,JDO200,MINDX),
     +                        CBATR(1,JDO200,MINDX))
C                      **********************************************
C
  180           CONTINUE
C
                GO TO 160
              END IF
            END IF
C
C---- Absolute end of MTZ file record
C
            IF (LINE(1:15).NE.'MTZENDOFHEADERS') THEN
C
C---- Or there is an error in the file (very unlikely)
C
              WRITE (LINE2,FMT='(A,A)')
     +          'From LROPEN : Unrecognised line in MTZ file header - ',
     +          'file may be corrupt, continuing ...'
C
C                  *************************
              CALL LERROR(1,1,LINE2)
C                  *************************
C
            END IF
            GO TO 200
  190       WRITE (LINE2,FMT='(A,A)')
     +    'From LROPEN : MTZ header indicates that file is standard MTZ'
     +        ,' but there are batch headers present - ignoring them'
C
C                *************************
            CALL LERROR(1,1,LINE2)
C                *************************
C
C---- End of MTZ header processing
C     ============================
C
  200       CONTINUE
C
C---- Output information
C
C                                 ******************
            IF (IPRINT.GT.0) CALL LHPRT(MINDX,IPRINT)
C                                 ******************
C
C---- Position file ready to read reflection records
C     Always call the QMODE=2 before QSEEK - all QSEEKs in MTZLIB are
C     done on words, not bytes
C
C                ******************************
            CALL QMODE(RLUN(MINDX),2,NITEM)
            CALL QSEEK(RLUN(MINDX),1,SIZE1+1,1)
C                ******************************
C
            IFAIL = 0
          END IF
        END IF
      END IF
C
      END
