      SUBROUTINE LRREFM(MINDX,LOGMSS)
C     ===============================
C
C     Returns Logical array which flags missing data entries
C      Array DATMSS set in LRREFF and LRREFL
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER		indicates which MTZ file - 1 index
C     					points to both input and output files
C
C     LOGMSS    (O)	LOGICAL         Array of dimension at least NPLABS(MINDX)
C                                       if LRREFF is being used, or NCOLS(MINDX)
C                                       if LRREFL is being used. In practice,
C                                       dimension MCOLS is safest.
C                                       Contains the logical array LOGMSS on exit
C                                       in order of LRREFF or LRREFL, whichever
C                                       was most recently called.
C                                       IF LOGMSS(..) is TRUE the entry is "missing".
C                                       Maps onto DATMSS.
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX
C     ..
C     .. Array Arguments ..
      LOGICAL LOGMSS(*)
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RBATW,RSYM,WRANGE,WSRNGE,VAL_MISS
      INTEGER BATNUM,HDRST,ISORT,NBATCH,NBATR,NBATW,NCOLS,NCOLW,NHISTL,
     +        NPLABS,NREFR,NREFS,NREFW,NSPGRP,NSYM,NSYMP,RLUN,RPOINT,
     +        WLUN,WOMBAT,NDATMSS
      LOGICAL SORTB,DATMSS,VAL_SET
C     ..
C     .. Local Scalars
      INTEGER JDO
      CHARACTER LINE*132
C     ..
C     .. External Routines ..
      EXTERNAL LERROR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX
C     .. 
C     .. Common Blocks ..
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/,/MTZWRK/
C     ..
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +       'From LRREFM: Index',MINDX,
     +       ' is out of range (allowed 1..',MFILES,')'
        CALL LERROR(2,-1,LINE)
C
C---- Then check that there is a file open
C
      ELSE IF (RLUN(MINDX).EQ.0) THEN
        WRITE (LINE,FMT='(A,I3)')
     +       'From LRREFM : There is no file open for read on index',
     +       MINDX
        CALL LERROR(2,-1,LINE)
      END IF
C     NDATMSS(MINDX) is set as NPLABS(MINDX) or NCOLS(MINDX) in
C     LRREFF and LRREFL respectively.
      DO 20 JDO = 1, NDATMSS(MINDX)
        LOGMSS(JDO) = DATMSS(JDO) 
 20   CONTINUE
      END
