      SUBROUTINE LRTITL(MINDX,FTITLE,LEN)
C     ===================================
C
C
C---- Subroutine to return the title and it's length from the
C     header of an MTZ file.
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     FTITLE    (O)	CHARACTER*(*)   Character string containing the title
C                               	on exit - maximum possible length 70
C
C     LEN       (O)	INTEGER         Length of the title string - ie no. of
C                               	chars from start to last non-blank char
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,LEN
      CHARACTER FTITLE* (*)
C     ..
C     .. Arrays in Common ..
      CHARACTER CBATR*1,CTYPE*1,LTYPE*1,PGNAM*10,SPGNAM*10,
     +          CLABEL*30,TITLE*70
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ISTAT
      CHARACTER LINE*400
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Common blocks ..
      COMMON /MTZCHR/TITLE(MFILES),CLABEL(MCOLS,MFILES),
     +       CTYPE(MCOLS,MFILES),SPGNAM(MFILES),LTYPE(MFILES),
     +       CBATR(CBLENG,MBATCH,MFILES),PGNAM(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZCHR/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LRTITL : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Get actual length of the title  and return title and length
C
        LEN = LENSTR(TITLE(MINDX))
        FTITLE = TITLE(MINDX) (1:LEN)
C
      END IF
C
      END
