      REAL FUNCTION LSTLSQ(MINDX,IH,IK,IL)
C     ===================================
C
C---- Calculate (sin(theta)/lambda)**2 from h,k,l; coef's set by call to
C     LSTRSL, for the file open on index MINDX
C
C---- This is exactly the same as the function STHLSQ in SYMLIB,
C     except that it stores it's variables in the internal MTZ
C     COMMON blocks, and will work if more than one file is open at once.
C
C---- Arguments :
C
C     MINDX	(I)	INTEGER		indicates which MTZ file
C
C     IH,IK,IL	(I)	INTEGER 	Miller indices for the reflection
C
C
C     .. Parameters ..
      INTEGER MFILES
      PARAMETER (MFILES=4)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,IH,IK,IL
C     ..
C     .. Arrays in Common ..
      REAL COEFHH,COEFHK,COEFHL,COEFKK,COEFKL,COEFLL
C     ..
C     .. Common blocks ..
      COMMON /MRCPLT/COEFHH(MFILES),COEFHK(MFILES),COEFHL(MFILES),
     +       COEFKK(MFILES),COEFKL(MFILES),COEFLL(MFILES)
C     ..
C     .. Save Statements ..
      SAVE /MRCPLT/
C     ..
C
      LSTLSQ = IH*IH*COEFHH(MINDX) + IH*IK*COEFHK(MINDX) + 
     +         IH*IL*COEFHL(MINDX) + IK*IK*COEFKK(MINDX) + 
     +         IK*IL*COEFKL(MINDX) + IL*IL*COEFLL(MINDX)
C
      END
