      SUBROUTINE LWASSN(MINDX,LSPRGO,NLPRGO,CTPRGO,IAPPND)
C     ====================================================
C
C
C---- Subroutine to setup the column labels and column types for
C     the output MTZ file. This allows for the user to have specified
C     output column assignments.  Note that this subroutine changes
C     the values in the header common block, so all information about
C     the input files labels and types should already have been
C     extracted.
C
C     If datasets are defined, check all columns have an associated dataset
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     LSPRGO    (I)	CHARACTER*30    array of dimension at least NLPRGO
C                               	containing the program output labels
C
C     NLPRGO    (I)	INTEGER         number of output program labels
C
C     CTPRGO    (I)	CHARACTER*1     array of dimension at least NLPRGO
C                               	containing the output column types
C
C     IAPPND    (I)	INTEGER         =0 replace all existing labels and types
C                               	=1 append to the existing lbls & types
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH,MFILEX
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000,MFILEX=9)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
      INTEGER MINCOL
      PARAMETER (MINCOL=3)
      INTEGER NTYP
      PARAMETER (NTYP=16)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      INTEGER NHISLM
      PARAMETER (NHISLM=30)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER IAPPND,MINDX,NLPRGO
C     ..
C     .. Array Arguments ..
      CHARACTER*1  CTPRGO(*)
      CHARACTER*30 LSPRGO(*)
C     ..
C     .. Scalars in Common ..
      INTEGER NLUSRI,NLUSRO
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RBATW,RSYM,WRANGE,WSRNGE,VAL_MISS
      INTEGER BATNUM,HDRST,ISORT,NBATCH,NBATR,NBATW,NCOLS,NCOLW,NHISTL,
     +        NPLABS,NREFR,NREFS,NREFW,NSPGRP,NSYM,NSYMP,RLUN,RPOINT,
     +        WLUN,WOMBAT,NDATMSS,NSETW,SET_ID,CSET_ID,IDEFSET
      LOGICAL SORTB,DATMSS,VAL_SET
      CHARACTER CBATR*1,CBATW*1,CTYPE*1,LTYPE*1,PGNAM*10,SPGNAM*10,
     +          CLABEL*30,LSUSRI*30,LSUSRO*30,PLABS*30,TITLE*70,HSCR*80,
     +          ENTRY_ID*64,DIFFRN_ID*64
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ILEN,IOUT,ISTAT,JDO10,JDO30,JDO40,JDO50,JDO60,JDO70,
     +        JDO80,JDO90,LSTART,IREFSET
      CHARACTER LINE*400,CWORK*30
C     ..
C     .. Local Arrays ..
      CHARACTER CTYPES(NTYP)*1,CLABTM(MCOLS)*30, CTYPTM(MCOLS)*1
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL BLANK,LABPRT,LERROR,PUTLIN
C     ..
C     .. Common blocks ..
      COMMON /MTZCHR/TITLE(MFILES),CLABEL(MCOLS,MFILES),
     +       CTYPE(MCOLS,MFILES),SPGNAM(MFILES),LTYPE(MFILES),
     +       CBATR(CBLENG,MBATCH,MFILES),PGNAM(MFILES)
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZLAB/NLUSRI(MFILEX),NLUSRO(MFILEX)
      COMMON /MTZLBC/LSUSRI(MFILEX,MCOLS),LSUSRO(MFILEX,MCOLS)
      COMMON /MTZWRC/PLABS(MCOLS,MFILES),HSCR(NHISLM,MFILES),
     +       CBATW(CBLENG,MBATCH,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
      COMMON /MTZHAR/NSETW(MFILES),SET_ID(MSETS,MFILES),
     +       ENTRY_ID(MSETS,MFILES),DIFFRN_ID(MSETS,MFILES),
     +       CSET_ID(MCOLS,MFILES),IDEFSET(MFILES)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA CTYPES/'H','J','F','D','Q','P','W','A','B','Y','I','R',
     +            'G','K','L','M'/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LWASSN : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Work out starting column
C
        IF (IAPPND.EQ.0) THEN
          LSTART = 1
        ELSE
          LSTART = NCOLS(MINDX) + 1
        END IF
C
C---- Work out total number of columns to be written to output file
C
        NCOLW(MINDX) = LSTART + NLPRGO - 1
        IF (NCOLW(MINDX).LT.MINCOL) THEN
          WRITE (LINE,FMT='(A,A,I4)')
     +      'From LWASSN : Not enough output columns -',
     +      ' minimum allowed is',MINCOL
          ISTAT = 2
          IFAIL = -1
C
C              ************************
          CALL LERROR(ISTAT,IFAIL,LINE)
C              ************************
C
        ELSE IF (NCOLW(MINDX).GT.MCOLS) THEN
          WRITE (LINE,FMT='(A,I4)')
     +      'From LWASSN : Too many output columns - maximum allowed is'
     +      ,MCOLS
          ISTAT = 2
          IFAIL = -1
C
C              ************************
          CALL LERROR(ISTAT,IFAIL,LINE)
C              ************************
C
        ELSE
C
C---- Now loop over the new labels, and check the assignments
C
          DO 30 JDO30 = LSTART,NCOLW(MINDX)
            IOUT = JDO30 - LSTART + 1
            IF ((LSUSRO(MINDX,IOUT).NE.' ') .AND. 
     +          (NLUSRO(MINDX).GT.0)) THEN
C
C---- There was a user output assignment, use it
C
              ILEN = LENSTR(LSUSRO(MINDX,IOUT))
              CLABTM(JDO30) = LSUSRO(MINDX,IOUT) (1:ILEN)
              CTYPTM(JDO30) = CTPRGO(IOUT)
            ELSE
C
C---- Check if this column was also an input column, with a user assignment
C
              DO 10 JDO10 = 1,NPLABS(MINDX)
                IF ((LSPRGO(IOUT).EQ.PLABS(JDO10,MINDX)).AND.
     +              (RPOINT(JDO10,MINDX).GT.0)) GO TO 20
   10         CONTINUE
C
C---- Fall through here if no assignments, use output program label
C
              CLABTM(JDO30) = LSPRGO(IOUT)
              CTYPTM(JDO30) = CTPRGO(IOUT)
              GO TO 30
C
C---- Here if using input assignment, but check types match
C
   20         CONTINUE
              CLABTM(JDO30) = CLABEL(RPOINT(JDO10,MINDX),MINDX)
              CTYPTM(JDO30) = CTYPE(RPOINT(JDO10,MINDX),MINDX)
C
C---- Some type checking is done in LRASSN also, but file types not updated
C     if 'R' or blank, this is done here, trust me, this makes sense
C
              IF ((CTYPTM(JDO30).NE.CTPRGO(IOUT)) .AND.
     +            (CTPRGO(IOUT).NE.' ')) THEN 
                IF ((CTYPTM(JDO30).NE.'R') .AND. 
     +              (CTYPTM(JDO30).NE.' ')) THEN
                  ILEN = LENSTR(LSPRGO(IOUT))
                  ISTAT = 1
                  WRITE (LINE,FMT='(10A)')
     +            'From LWASSN : Column type for output program label ',
     +               LSPRGO(IOUT) (1:ILEN),' does not match -',
     +              'file label is ', CLABTM(JDO30)
C
C                      ************************
                  CALL LERROR(ISTAT,IFAIL,LINE)
C                      ************************
                ELSE
                  CTYPTM(JDO30) = CTPRGO(IOUT)
                END IF
              END IF
C
            END IF
   30     CONTINUE
C
C---- Copy the checked labels over, and the (unchecked) types
C
          DO 40 JDO40 = LSTART,NCOLW(MINDX)
            CLABEL(JDO40,MINDX) = CLABTM(JDO40)
            CTYPE(JDO40,MINDX) = CTYPTM(JDO40)
   40     CONTINUE
C
C---- Check that the column labels are not duplicated, stop if they are
C
          DO 60 JDO60 = 1,NCOLW(MINDX)
            CWORK = CLABEL(JDO60,MINDX)(1:LENSTR(CLABEL(JDO60,MINDX)))
            DO 50 JDO50 = 1,NCOLW(MINDX)
              IF ((CWORK.EQ.CLABEL(JDO50,MINDX)).AND.(JDO50.NE.JDO60)) 
     +                                                             THEN
                ISTAT = 2
                IFAIL = -1
                WRITE (LINE,FMT='(A,1X,A,I3,A,I3,A,1X,A)')
     +           'From LWASSN : Duplicate column labels in output file,'
     +           ,'columns ',JDO60,' and ',JDO50,' both have the label'
     +           ,CWORK(1:LENSTR(CWORK))
C
C                    ************************
                CALL LERROR(ISTAT,IFAIL,LINE)
C                    ************************
C
              END IF
   50       CONTINUE
   60     CONTINUE
C
C---- Also check that the new column types are legal
C     If column type is STILL blank, set it to 'R'
C
          DO 80 JDO80 = LSTART,NCOLW(MINDX)
            IF (CTYPE(JDO80,MINDX).NE.' ') THEN
              ISTAT = 1
              DO 70 JDO70 = 1,NTYP
                IF (CTYPE(JDO80,MINDX).EQ.CTYPES(JDO70)) ISTAT = 0
   70         CONTINUE
C
              IF (ISTAT.EQ.1) THEN
                WRITE (LINE,FMT='(A,I4,A)')
     +          'From LWASSN : Unrecognised output column type, column',
     +          JDO80,', set to R'
C
C                    ************************
                CALL LERROR(ISTAT,IFAIL,LINE)
C                    ************************
C
                CTYPE(JDO80,MINDX) = 'R'
              END IF
C
            ELSE
              CTYPE(JDO80,MINDX) = 'R'
            END IF
   80     CONTINUE
C
C---- If datasets are defined, check all columns have an associated dataset
C     If not, set to that of first column dealt with here.
C
          IF (NSETW(MINDX).GT.0) THEN
            IREFSET = IDEFSET(MINDX)
            IF (IREFSET.EQ.0) IREFSET = CSET_ID(1,MINDX)
            IF (IREFSET.EQ.0) IREFSET = SET_ID(1,MINDX)
            DO 90 JDO90 = LSTART,NCOLW(MINDX)
              IF (CSET_ID(JDO90,MINDX).EQ.0) 
     +            CSET_ID(JDO90,MINDX) = IREFSET
 90         CONTINUE
          ENDIF
C
C---- Print out program labels and column labels
C
C              ****************
          CALL PUTLIN('* Output Program Labels :','CURWIN')
          CALL BLANK('CURWIN',1)
          IF (NLPRGO.GT.0) THEN
            CALL LABPRT(LSPRGO,NLPRGO)
          ELSE
            CALL PUTLIN('There were NO output program labels','CURWIN')
          END IF
          CALL BLANK('CURWIN',1)
          CALL PUTLIN('* Output File Labels :','CURWIN')
          CALL BLANK('CURWIN',1)
          CALL LABPRT(CLABEL(1,MINDX),NCOLW(MINDX))
          CALL BLANK('CURWIN',1)
          CALL PUTLIN('* Output File Column Types :','CURWIN')
          CALL BLANK('CURWIN',1)
          CALL LABPRT(CTYPE(1,MINDX),NCOLW(MINDX))
          CALL BLANK('CURWIN',1)
C              *****************
C
        END IF
      END IF
C
      END
