      SUBROUTINE LWBSCL (MINDX,BATNO,BATSCL,NBATSC)
C     ============================================
C
C---- Subroutine to write batch scale & Bfactor for batch BATNO to
C     batch headers for multi-record file open on index MINDX
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     BATNO     (I)	INTEGER         batch number 
C
C     BATSCL	(I)	REAL            array of dimension NBATSC containing
C					batch scale, relative Bfactor,
C                               	SD(Bscale), SD(Bfactor) if NBATSC = 4
C                                	else NBATSC/2 scales or B-factors + Sd's
C
C     NBATSC    (I)	INTEGER         number of batch scales (=0 to clear)
C
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX, BATNO, NBATSC
C     ..
C     .. Array Arguments ..
      REAL BATSCL(NBATSC)
C     ..
C     .. Common blocks ..
      INTEGER NWORDS,NINTGR,NREALS,IORTYP,LBCELL,MISFLG,
     +     JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,LBMFLG,NDET,
     +     LBSETID,INTPAD
      REAL   CELL,UMAT,PHIXYZ,CRYDAT,DATUM,
     +     PHISTT,PHIEND,PHIRANGE,SCANAX,TIME1,TIME2,
     +     BSCALE,BBFAC,SDBSCL,SDBFAC,BATPAD,E1,E2,E3,GONPAD,
     +     SOURCE,S0,BEMDAT,
     +     DX1,THETA1,DETLM1,DX2,THETA2,DETLM2,DETPAD
      CHARACTER BTITLE*70, GONLAB*8, BTITL*94
C     
      COMMON /CBTHDR/BTITLE,GONLAB(3)
C     
      COMMON /MBTHDR/ NWORDS,NINTGR,NREALS,IORTYP,LBCELL(6),MISFLG,
     .     JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,LBMFLG,
     +     NDET,LBSETID,INTPAD(8),
     +     CELL(6),UMAT(3,3),PHIXYZ(3,2),CRYDAT(12),DATUM(3),
     +     PHISTT,PHIEND,SCANAX(3),TIME1,TIME2,
     +     BSCALE,BBFAC,SDBSCL,SDBFAC,PHIRANGE,BATPAD(11),
     +     E1(3),E2(3),E3(3),
     +     GONPAD(12),SOURCE(3),S0(3),BEMDAT(25),
     +     DX1,THETA1,DETLM1(2,2),DX2,THETA2,DETLM2(2,2),DETPAD(33)
      SAVE /CBTHDR/, /MBTHDR/
      EXTERNAL LRBRES, LRBAT, LWBAT
C     
C*** Equivalence undetermined number of scale factors to BSCALE
      REAL SCALES(16)
      EQUIVALENCE (SCALES(1),BSCALE)
      REAL RNWRDS(1)
      EQUIVALENCE (NWORDS, RNWRDS)
C     ..
C     .. Local Scalars ..
      INTEGER JDO10
C
C--- Set read pointer to this batch and read orientation block
C
C          ****************************************
      CALL LRBRES(MINDX,BATNO)
C     NB the original of this had BTITLE in the call, but it's in common
C     and updated during the call, so illegal
      BTITL = BTITLE
      CALL LRBAT(MINDX,BATNO,RNWRDS,BTITL,0)
      BTITLE = BTITL
C          ****************************************
C
      IF (NBATSC .EQ. 0) THEN
         NBSCAL = 0
      ELSE
C
C--- Copy scales
C
         NBSCAL = NBATSC
         DO 10, JDO10=1,NBATSC
            SCALES(JDO10) = BATSCL(JDO10)
 10      CONTINUE
C
      ENDIF
C
C--- Write Orientation block
C
      CALL LWBAT(MINDX,BATNO,RNWRDS,BTITLE)
C
      RETURN
C
      END
