      SUBROUTINE LWBSETID (MINDX,BATNO,PNAME,DNAME)
C     ===========================================================
C
C---- Subroutine to write dataset ID for batch BATNO to
C     batch headers for multi-record file open on index MINDX
C     If LWBAT has been used, the batch headers in RBATW are used,
C     else those in RBATR are used.
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     BATNO     (I)	INTEGER         batch number 
C
C     PNAME     (I)	CHARACTER       project name of dataset
C
C     DNAME     (I)	CHARACTER       dataset name of dataset
C
C     ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
      INTEGER MBLENG, MBLINT, MBLREA
      PARAMETER (MBLENG=185, MBLINT=29, MBLREA=156)

C     .. Scalar Arguments ..
      INTEGER MINDX, BATNO
      CHARACTER*(*) PNAME,DNAME
C     ..
C     .. Common blocks ..
      INTEGER NWORDS,NINTGR,NREALS,IORTYP,LBCELL,MISFLG,
     +     JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,LBMFLG,NDET,
     +     LBSETID,INTPAD
      REAL  BCELL,UMAT,PHIXYZ,CRYDAT,DATUM,
     +     PHISTT,PHIEND,PHIRANGE,SCANAX,TIME1,TIME2,
     +     BSCALE,BBFAC,SDBSCL,SDBFAC,BATPAD,E1,E2,E3,GONPAD,
     +     SOURCE,S0,BEMDAT,
     +     DX1,THETA1,DETLM1,DX2,THETA2,DETLM2,DETPAD
      CHARACTER BTITLE*70, GONLAB*8
C     
      COMMON /CBTHDR/BTITLE,GONLAB(3)
C     
      COMMON /MBTHDR/ NWORDS,NINTGR,NREALS,IORTYP,LBCELL(6),MISFLG,
     .     JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,LBMFLG,
     +     NDET,LBSETID,INTPAD(8),
     +     BCELL(6),UMAT(3,3),PHIXYZ(3,2),CRYDAT(12),DATUM(3),
     +     PHISTT,PHIEND,SCANAX(3),TIME1,TIME2,
     +     BSCALE,BBFAC,SDBSCL,SDBFAC,PHIRANGE,BATPAD(11),
     +     E1(3),E2(3),E3(3),
     +     GONPAD(12),SOURCE(3),S0(3),BEMDAT(25),
     +     DX1,THETA1,DETLM1(2,2),DX2,THETA2,DETLM2(2,2),DETPAD(33)
      SAVE /CBTHDR/, /MBTHDR/
      EXTERNAL LRBRES, LRBAT, LWBAT
C
      REAL CELL,CRANGE,SRANGE,RBATR,RBATW,RSYM,WRANGE,WSRNGE,VAL_MISS
      INTEGER BATNUM,HDRST,ISORT,NBATCH,NBATR,NBATW,NCOLS,NCOLW,NHISTL,
     +        NPLABS,NREFR,NREFS,NREFW,NSPGRP,NSYM,NSYMP,RLUN,RPOINT,
     +        WLUN,WOMBAT,NDATMSS
      LOGICAL SORTB,DATMSS,VAL_SET
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)

      INTEGER NSETW,SET_ID,CSET_ID,IDEFSET
      CHARACTER ENTRY_ID*64,DIFFRN_ID*64
      COMMON /MTZHAR/NSETW(MFILES),SET_ID(MSETS,MFILES),
     +       ENTRY_ID(MSETS,MFILES),DIFFRN_ID(MSETS,MFILES),
     +       CSET_ID(MCOLS,MFILES),IDEFSET(MFILES)
C
C.. Local variables
      INTEGER BSETID
      CHARACTER LINE*400

      REAL RNWRDS(MBLENG)
      EQUIVALENCE (NWORDS, RNWRDS)
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LWBSETID : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ENDIF
C
C---- Find dataset ID corresponding to PNAME/DNAME
C     These datasets should have been read in from input MTZ
C     file or appended using LWID.
C
      DO 50 JDO50 = 1,NSETW(MINDX)
        IF (PNAME.EQ.ENTRY_ID(JDO50,MINDX) .AND.
     +      DNAME.EQ.DIFFRN_ID(JDO50,MINDX)) THEN
          BSETID = SET_ID(JDO50,MINDX)
          GOTO 40
        ENDIF
 50   CONTINUE

      CALL CCPERR(2,' Failed to set dataset ID in batch header.')
      RETURN

 40   CONTINUE

C--- Batches written with LWBAT
      IF (NBATW(MINDX).GT.0) THEN

        DO 10 I = 1,NBATW(MINDX)
         IF (BATNO.EQ.WOMBAT(I,MINDX)) THEN

          DO 15 J = 1,MBLENG
            RNWRDS(J) = RBATW(J,I,MINDX)
 15       CONTINUE
          LBSETID = BSETID
          DO 18 J = 1,MBLENG
            RBATW(J,I,MINDX) = RNWRDS(J) 
 18       CONTINUE
          GOTO 100

         ENDIF
 10     CONTINUE

C--- Batches from input file
      ELSEIF (NBATCH(MINDX).GT.0) THEN

        DO 20 I = 1,NBATCH(MINDX)
         IF (BATNO.EQ.BATNUM(I,MINDX)) THEN

          DO 25 J = 1,MBLENG
            RNWRDS(J) = RBATR(J,I,MINDX)
 25       CONTINUE
          LBSETID = BSETID
          DO 28 J = 1,MBLENG
            RBATR(J,I,MINDX) = RNWRDS(J) 
 28       CONTINUE
          GOTO 100

         ENDIF
 20     CONTINUE

      ELSE
        WRITE (LINE,FMT='(A)') 
     +    'From LWBSETID : no batches present to write to!'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ENDIF

 100  CONTINUE

      RETURN
      END
