      SUBROUTINE LWCELL(MINDX,CELLP)
C     ==============================
C
C
C---- Subroutine to write Cell Parameters into the header common block
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     CELLP     (I)	REAL            array of dimension (6) containing cell
C                               	parameters to write to header
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX
C     ..
C     .. Array Arguments ..
      REAL CELLP(6)
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RBATW,RSYM,WRANGE,WSRNGE,VAL_MISS
      INTEGER BATNUM,HDRST,ISORT,NBATCH,NBATR,NBATW,NCOLS,NCOLW,NHISTL,
     +        NPLABS,NREFR,NREFS,NREFW,NSPGRP,NSYM,NSYMP,RLUN,RPOINT,
     +        WLUN,WOMBAT,NDATMSS
      LOGICAL SORTB,DATMSS,VAL_SET
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ISTAT,JDO10
      CHARACTER LINE*400
      LOGICAL CELLCH
C     .. 
C     .. Intrinsic Functions
      INTRINSIC ABS
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR,LSTRSL
C     ..
C     .. Common blocks ..
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/,/MTZWRK/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LWCELL : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Then update the header block
C
        CELLCH = .FALSE.
        DO 10 JDO10 = 1,6
          IF (ABS(CELL(JDO10,MINDX) - CELLP(JDO10)).GT.0.000006) 
     +      CELLCH=.TRUE.
          CELL(JDO10,MINDX) = CELLP(JDO10)
   10   CONTINUE
C
C---- Set S range to dummy values - no easy way to correct them
C
        SRANGE(1,MINDX) = 1.0E-05
        SRANGE(2,MINDX) = 500.0
C
C---- Print warning is this is done after reflections have been written
C
        IF ((NREFW(MINDX).GT.0).AND. CELLCH) THEN
          WRITE (LINE,FMT='(A,A,A)')
     +      'From LWCELL : You are changing the cell after you have',
     +      'written reflections to file - ',
     +      'resolution limits will be wrong'
          ISTAT = 1
C
C              ************************
          CALL LERROR(ISTAT,IFAIL,LINE)
C              ************************
C
        END IF
C
C---- And setup again for the S calculation
C
C            ******************************************************
        CALL LSTRSL(MINDX,CELL(1,MINDX),CELL(2,MINDX),CELL(3,MINDX),
     +              CELL(4,MINDX),CELL(5,MINDX),CELL(6,MINDX))
C            ******************************************************

      END IF
C
      END
