      SUBROUTINE LWHIST(MINDX,HSTRNG,NLINES)
C     =====================================
C
C
C---- Subroutine to write new history lines to history header.
C     History headers have a maximum of NHISTL lines, we write the new
C     NLINES of history to the header and then fill up any free lines
C     with the older lines.
C
C     Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     HSTRNG    (I)	CHARACTER       array of (NLINES) with the history lines
C
C     NLINES    (I)	INTEGER         number of history lines to be written
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      INTEGER NHISLM
      PARAMETER (NHISLM=30)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX,NLINES
C     ..
C     .. Array Arguments ..
      CHARACTER HSTRNG(NLINES)*80
C     ..
C     .. Arrays in Common ..
      REAL RBATW,WRANGE,WSRNGE
      INTEGER HDRST,NBATR,NBATW,NCOLW,NHISTL,NREFR,NREFW,RLUN,
     +        RPOINT,WLUN,WOMBAT,NDATMSS,NPLABS
      LOGICAL SORTB,DATMSS
      CHARACTER CBATW*1,PLABS*30,HSCR*80
C     ..
C     .. Local Scalars ..
      INTEGER ENDLOP,IFAIL,ISTAT,JDO10,JDO20,JDO5,NLINS,NNONBLANK
      CHARACTER LINE*400
C     ..
C     .. Local Arrays ..
      CHARACTER HISTX(NHISLM)*80
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Common blocks ..
      COMMON /MTZWRC/PLABS(MCOLS,MFILES),HSCR(NHISLM,MFILES),
     +       CBATW(CBLENG,MBATCH,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZWRK/,/MTZWRC/
C     ..
C     NLINS is updated, NLINESshouldn't be
      NLINS = NLINES
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LWHIST : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Check not too many lines - if so take first NHISTL lines
C
        IF (NLINS.GT.NHISLM) THEN
          WRITE (LINE,FMT='(A,I2,A,I2,A)')
     +      'From LWHIST : too many history lines (',NLINS,')',NHISLM,
     +      ' lines written'
          ISTAT = 1
C
C              ************************
          CALL LERROR(ISTAT,IFAIL,LINE)
C              ************************
C
          NLINS = NHISLM
        END IF
C
C---- Copy existing history lines to scratch array
C
        DO 10 JDO5 = 1,NHISTL(MINDX)
          HISTX(JDO5) = HSCR(JDO5,MINDX)
   10   CONTINUE
C
        NNONBLANK = 0
        DO 20 JDO10 = 1,NLINS
          IF (HSTRNG(JDO10).NE.' ') THEN
            NNONBLANK = NNONBLANK + 1
            HSCR(NNONBLANK,MINDX) = HSTRNG(JDO10)
          ENDIF
   20   CONTINUE
        NLINS = NNONBLANK
C
C---- Fill up any space left with lines already in history header
C
        IF (NHISTL(MINDX).GT.0) THEN
          ENDLOP = NHISTL(MINDX) + NLINS
          IF (ENDLOP.GT.NHISLM) ENDLOP = NHISLM
          DO 30 JDO20 = NLINS + 1,ENDLOP
            HSCR(JDO20,MINDX) = HISTX(JDO20-NLINS)
   30     CONTINUE
          NHISTL(MINDX) = ENDLOP
        ELSE
          NHISTL(MINDX) = NLINS
        END IF

      END IF
C
      END
