      SUBROUTINE LWHSTL (MINDX,EXTRA)
C     ====================================
C
C     Write a single line of hstory information to an MTZ file with
C     index MINDX indicating that it was output from the program whose
C     name was previously set with CCPVRS (/CCPRCS) at the
C     current date and time.  EXTRA is more information to append to the
C     record (or blank) .  An example of the information produced might be:
C     From FREERFLAG, 21/ 6/94 18:38:48 with fraction 0.050
C          ^^^^^^^^^                    ^^^^^^^^^^^^^^^^^^^
C          CCPVRS arg                           EXTRA
C     This is just a simplified interface to LWHIST.  The history line
C     will be truncated to 80 characters. 
C
C     Arguments:
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C     PROG      (I)     CHARACTER*(*)   indicates the program responsible
C     EXTRA     (I)     CHARACTER*(*)   extra information
C
      CHARACTER*(*) EXTRA
      INTEGER MINDX
      CHARACTER HIST(1)*80, TIME*8, DATE*8, BUFFER*200, PROG*20
      INTEGER LENSTR
      EXTERNAL LWHIST, CCPDAT, UTIME, LENSTR, CCPPNM
C
      CALL CCPPNM (PROG)
      CALL CCPDAT (DATE)
      CALL UTIME (TIME)
C     Use a largeish buffer and truncate it later if necessary
      WRITE (BUFFER, 10) PROG(:MAX(LENSTR(PROG),1)), DATE, TIME
      BUFFER(LENSTR(BUFFER)+2:) = EXTRA(:MAX(LENSTR(EXTRA),1))
      HIST (1) = BUFFER
 10   FORMAT ('From ',A,', ',A,' ',A)
      CALL LWHIST (MINDX, HIST, 1)
      RETURN
      END
