      SUBROUTINE LWOPEN(MINDX,FILNAM)
C     ===============================
C
C
C---- Subroutine to open an MTZ file for write.
C
C     Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     FILNAM    (I)	CHARACTER       name of file to be opened
C
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
      INTEGER SIZE1
      PARAMETER (SIZE1=20)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      INTEGER NHISLM
      PARAMETER (NHISLM=30)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER MINDX
      CHARACTER FILNAM* (*)
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RBATW,RSYM,WRANGE,WSRNGE,VAL_MISS
      INTEGER BATNUM,HDRST,ISORT,NBATCH,NBATR,NBATW,NCOLS,NCOLW,NHISTL,
     +        NPLABS,NREFR,NREFS,NREFW,NSPGRP,NSYM,NSYMP,RLUN,RPOINT,
     +        WLUN,WOMBAT,NDATMSS,NSETW,SET_ID,CSET_ID,IDEFSET
      LOGICAL SORTB,DATMSS,VAL_SET
      CHARACTER CBATR*1,CBATW*1,CTYPE*1,LTYPE*1,PGNAM*10,SPGNAM*10,
     +          CLABEL*30,PLABS*30,TITLE*70,HSCR*80,ENTRY_ID*64,
     +          DIFFRN_ID*64
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ISTAT,IUNIN,JDO10,JDO20,JDO30,JDO40,JDO50,JDO55,
     +        JDO60,JDO70,JDO80,NITEM
      CHARACTER LINE*400
C     ..
C     .. Local Arrays ..
      INTEGER IDUMMY(SIZE1)
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR,QMODE,QOPEN,QWRITI,QNAN
C     ..
C     .. Common blocks ..
      COMMON /MTZCHR/TITLE(MFILES),CLABEL(MCOLS,MFILES),
     +       CTYPE(MCOLS,MFILES),SPGNAM(MFILES),LTYPE(MFILES),
     +       CBATR(CBLENG,MBATCH,MFILES),PGNAM(MFILES)
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +       VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
      COMMON /MTZWRC/PLABS(MCOLS,MFILES),HSCR(NHISLM,MFILES),
     +       CBATW(CBLENG,MBATCH,MFILES)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
      COMMON /MTZHAR/NSETW(MFILES),SET_ID(MSETS,MFILES),
     +       ENTRY_ID(MSETS,MFILES),DIFFRN_ID(MSETS,MFILES),
     +       CSET_ID(MCOLS,MFILES),IDEFSET(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/,/MTZCHR/,/MTZWRK/,/MTZWRC/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LWOPEN : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Check for other open files on this index - first read files
C  If another file open with a missing value flag set,
C    - transfer it to output as default.
C
        IF (RLUN(MINDX).NE.0 .AND. VAL_SET(1,MINDX) ) THEN
            VAL_MISS(2,MINDX) = VAL_MISS(1,MINDX) 
            VAL_SET(2,MINDX) = VAL_SET(1,MINDX) 
        END IF 
C     If no read file open, then LROPEN has not been called - init. here
C     Some of these not necc. if no read file, but do it for consistency
C
        IF (RLUN(MINDX).EQ.0) THEN
C
          DO 10 JDO10 = 1,6
            CELL(JDO10,MINDX) = 0.0
   10     CONTINUE
C
          NSYM(MINDX) = 0
          NSYMP(MINDX) = 0
C
          DO 40 JDO40 = 1,MAXSYM
            DO 30 JDO30 = 1,4
              DO 20 JDO20 = 1,4
                RSYM(JDO20,JDO30,JDO40,MINDX) = 0.0
   20         CONTINUE
   30       CONTINUE
   40     CONTINUE
C
          NCOLS(MINDX) = 0
          NSETW(MINDX) = 0
          IDEFSET(MINDX) = 0
          NREFS(MINDX) = 0
          NREFR(MINDX) = 0
          NPLABS(MINDX) = 0
          NBATCH(MINDX) = 0
          SRANGE(1,MINDX) = 0.0
          SRANGE(2,MINDX) = 0.0
          TITLE(MINDX) = '   '
          NHISTL(MINDX) = 0
          NSPGRP(MINDX) = 0
          SPGNAM(MINDX) = '?'
          LTYPE(MINDX) = '?'
          PGNAM(MINDX) = '?'
C
          DO 50 JDO50 = 1,5
            ISORT(JDO50,MINDX) = 0
   50     CONTINUE
C
          DO 55 JDO55 = 1,MSETS
            SET_ID(JDO55,MINDX) = 0
            ENTRY_ID(JDO55,MINDX) = ' '
            DIFFRN_ID(JDO55,MINDX) = ' '
   55     CONTINUE

          DO 60 JDO55 = 1,MBATCH
            BATNUM(JDO55,MINDX) = 0
   60     CONTINUE
C
          DO 70 JDO60 = 1,MCOLS
            CRANGE(1,JDO60,MINDX) = 0.0
            CRANGE(2,JDO60,MINDX) = 0.0
            CLABEL(JDO60,MINDX) = '   '
            CTYPE(JDO60,MINDX) = ' '
            RPOINT(JDO60,MINDX) = 0
            PLABS(JDO60,MINDX) = ' '
            CSET_ID(JDO60,MINDX) = 0
   70     CONTINUE
          CALL QNAN (VAL_MISS(2,MINDX))
            VAL_SET(2,MINDX) = .TRUE.
C
        END IF
C
C---- Then the write files - pretty serious if already open
C
        IF (WLUN(MINDX).NE.0) THEN
          WRITE (LINE,FMT='(A,I2,A)')
     +      'From LWOPEN : File already open for write on index',MINDX,
     +      ' - disaster!'
          ISTAT = 2
          IFAIL = -1
C
C              ************************
          CALL LERROR(ISTAT,IFAIL,LINE)
C              ************************
C
        ELSE
C
C---- Everything OK, open the file
C
C              *************************
          CALL QOPEN(IUNIN,FILNAM,'NEW')
          CALL QMODE(IUNIN,2,NITEM)
C              *************************
C
          WLUN(MINDX) = IUNIN
C
C---- Write a dummy first record to the file, to be filled in LWCLOS
C
C              **************************
          CALL QWRITI(IUNIN,IDUMMY,SIZE1)
C              **************************
C
C---- Zero a few variables
C
          DO 80 JDO70 = 1,MCOLS
            WRANGE(1,JDO70,MINDX) = 1.0E6
            WRANGE(2,JDO70,MINDX) = -1.0E6
   80     CONTINUE
C
          NREFW(MINDX) = 0
          NCOLW(MINDX) = 0
          NBATW(MINDX) = 0
          WSRNGE(1,MINDX) = 500.0
          WSRNGE(2,MINDX) = 0.0
          SORTB(MINDX) = .FALSE.
C
          DO 90 JDO80 = 1,MBATCH
            WOMBAT(JDO80,MINDX) = 0
   90     CONTINUE
C
        END IF
      END IF
C
      END
