      SUBROUTINE LWTITL(MINDX,NTITLE,FLAG)
C     ====================================
C
C
C---- Subroutine to update the title of an MTZ file in the header
C     common block
C
C---- Arguments :
C
C     MINDX     (I)	INTEGER         indicates which MTZ file - 1 index
C                               	points to both input and output files
C
C     NTITLE    (I)	CHARACTER*(*)   Character string containing the title
C                               	 - maximum possible length 70
C
C     FLAG      (I)	INTEGER         =0 replace old title with new one
C                               	=1 append new one to old, with one space
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
C     ..
C     .. Scalar Arguments ..
      INTEGER FLAG,MINDX
      CHARACTER NTITLE* (*)
C     ..
C     .. Arrays in Common ..
      CHARACTER CBATR*1,CTYPE*1,LTYPE*1,PGNAM*10,SPGNAM*10,
     +          CLABEL*30,TITLE*70
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL,ILEN,ISTAT,JLEN,KLEN
      CHARACTER LINE*400
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC LEN
C     ..
C     .. Common blocks ..
      COMMON /MTZCHR/TITLE(MFILES),CLABEL(MCOLS,MFILES),
     +       CTYPE(MCOLS,MFILES),SPGNAM(MFILES),LTYPE(MFILES),
     +       CBATR(CBLENG,MBATCH,MFILES),PGNAM(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZCHR/
C     ..
C
C---- First check that the MINDX is valid
C
      IF ((MINDX.LE.0) .OR. (MINDX.GT.MFILES)) THEN
        WRITE (LINE,FMT='(A,I3,A,1X,I1,1X,A)') 
     +    'From LWTITL : Index',MINDX,
     +    ' is out of range (allowed 1..',MFILES,')'
        ISTAT = 2
        IFAIL = -1
C
C            ************************
        CALL LERROR(ISTAT,IFAIL,LINE)
C            ************************
C
      ELSE
C
C---- Then update the title
C
        IF (FLAG.EQ.0) THEN
C
C----    Replace the title
C
          ILEN = LEN(TITLE(MINDX))
          JLEN = LENSTR(NTITLE)
          IF (JLEN.GT.ILEN) THEN
            ISTAT = 1
            WRITE (LINE,FMT='(A,I3,A)')
     +        'From LWTITL : New title is too long, truncated to',ILEN,
     +        ' chars'
C
C                ************************
            CALL LERROR(ISTAT,IFAIL,LINE)
C                ************************
C
            JLEN = ILEN
          END IF
          IF(JLEN.GE.1)TITLE(MINDX) = NTITLE(1:JLEN)
          IF(JLEN.EQ.0)TITLE(MINDX) = ' '
        ELSE
C
C----    Append the new title to the old one
C
          ILEN = LENSTR(TITLE(MINDX))
          JLEN = LENSTR(NTITLE)
          KLEN = LEN(TITLE(MINDX))
C
          IF ((ILEN+JLEN).GT.KLEN) THEN
            ISTAT = 1
            WRITE (LINE,FMT='(A,I3,A)')
     +        'From LWTITL : Title is too long, truncated to',KLEN,
     +        ' chars'
C
C                ************************
            CALL LERROR(ISTAT,IFAIL,LINE)
C                ************************
C
            JLEN = KLEN - (ILEN+1)
          END IF
C
          IF (JLEN .GT. 0) THEN
             TITLE(MINDX) (ILEN+1:ILEN+1) = ' '
             TITLE(MINDX) (ILEN+2:ILEN+JLEN+1) = NTITLE(1:JLEN)
          ENDIF
C
        END IF
C
      END IF
C
      END
