      SUBROUTINE MTZINI
C     =================
C
C---- This subroutine initialises the MTZ file handling system.
C
C     THIS SUBROUTINE MUST BE CALLED BEFORE ANY OTHER MTZLIB SUBROUTINE.
C     Failure to do so may result in unpredictable behaviour (!?)
C
C     This subroutine replaces (6/91) the BLOCK DATA MTZINI.
C
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH,MFILEX
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000,MFILEX=9)
C
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
C     ..
C     .. Arrays in Common ..
      REAL RBATW,WRANGE,WSRNGE
      INTEGER NLUSRI,NLUSRO
      INTEGER HDRST,NBATR,NBATW,NCOLW,NHISTL,NPLABS,NREFR,NREFW,RLUN,
     +        RPOINT,WLUN,WOMBAT,NDATMSS
      LOGICAL SORTB,DATMSS
      CHARACTER LSUSRI*30,LSUSRO*30
C     ..
C     .. Local Scalars ..
      INTEGER JDO10,JDO20,JDO30
C     ..
C     .. External subroutines
      EXTERNAL CCP4H_INIT_LIB
C     ..
C     .. Common blocks ..
      COMMON /MTZLAB/NLUSRI(MFILEX),NLUSRO(MFILEX)
      COMMON /MTZLBC/LSUSRI(MFILEX,MCOLS),LSUSRO(MFILEX,MCOLS)
      COMMON /MTZWRK/NCOLW(MFILES),RLUN(MFILES),WLUN(MFILES),
     +       RPOINT(MCOLS,MFILES),WRANGE(2,MCOLS,MFILES),NREFW(MFILES),
     +       NREFR(MFILES),NPLABS(MFILES),NBATW(MFILES),NBATR(MFILES),
     +       WOMBAT(MBATCH,MFILES),HDRST(MFILES),SORTB(MFILES),
     +       NHISTL(MFILES),RBATW(MBLENG,MBATCH,MFILES),WSRNGE(2,MFILES)
     +       ,DATMSS(MCOLS),NDATMSS(MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZLAB/, /MTZLBC/, /MTZWRK/
C
C---- Initialize those variables which MUST be 0 or ' ' at the very start
C
C     NLUSRI - no. of user input labels (changed by LKYIN)
C     LSUSRI - the labels
C     NLUSRO - no. of user output labels (changed by LKYOUT)
C     LSUSRO - the labels
C     RLUN   - unit numbers for files open for read (>0 means file open)
C     WLUN   - unit numbers for files open for write (>0 means file open)
C
C
      DO 20 JDO20  = 1,MFILEX
        NLUSRI(JDO20) = 0
        NLUSRO(JDO20) = 0
C
        DO 10 JDO10 = 1,MCOLS
          LSUSRI(JDO20,JDO10) = ' '
          LSUSRO(JDO20,JDO10) = ' '
   10   CONTINUE
C
   20 CONTINUE
C
      DO 30 JDO30 = 1,MFILES
        RLUN(JDO30) = 0
        WLUN(JDO30) = 0
 30   CONTINUE
C Iniitialise the html flag so there are no prblems with stderr
      CALL CCP4H_INIT_LIB()

      END
