      SUBROUTINE PTORN1(IBATCH)
C     =========================
C
C This subroutine prints the orientation data for the current
C batch (as read via GTORN1)
C
C
C---- Parameters
C
C      IBATCH (I)   BATCH NUMBER
C
C---- Specification statements
C
      LOGICAL RD
      COMMON /ORIENT/ NWORDS,CELL(6),LCELL(6),UMATR(3,3),JUMPAX,
     .  PHXYZ(3,2),DELRAX,PHISTT,PHIEND,IFTCRD,ETAD,ALAMBD,
     .  DELLAM,DELCOR,DIVHD,DIVVD,BSCALE,BBFAC,SDBSC,SDBB,
     .  NRAST,IRASTR(9)
      COMMON /LCF1WK/RD,IN,IOUT,LBUF,IUNIN,NCIN,IUNOUT,NCOUT,
     *               IPOINT(100),NLOOK,KDATA(100)
      CHARACTER*2 ABC(3)
      CHARACTER*4 AXIS(5,2),BLANK
      SAVE /ORIENT/,/LCF1WK/
      DATA ABC/'A*','B*','C*'/
      DATA AXIS/5*'    ','DIFF','RACT','OMET','ER  ','    '/
      DATA BLANK/'    '/
C
C---- Print orientation data (diffractometer data has jumpax.le.0)
C     if jumpax .ge. 100, treat as area detector block
C
      IF(JUMPAX.GE.100) THEN
	    CALL PTORNA(IBATCH)
	    RETURN
      ENDIF
C
      IF(JUMPAX.LE.0) GO TO 10
      AXIS(1,1)=ABC(JUMPAX)
      K=1
      GO TO 20
C
10    K=2
      AXIS(5,2)=BLANK
      IF(JUMPAX.LT.0) AXIS(5,2)=ABC(-JUMPAX)
C  
20    WRITE(IOUT,1000) IBATCH,CELL,LCELL,((UMATR(I,J),J=1,3),I=1,3),
     .  (AXIS(I,K),I=1,5),PHXYZ,PHISTT,PHIEND,ETAD,ALAMBD,DELLAM,
     .  DELCOR,DIVHD,DIVVD,BSCALE,BBFAC,SDBSC,SDBB
      RETURN
C
C---- Format statements
C
1000  FORMAT(/1X,20('++++')//' Orientation data for batch',I8//
     . ' Cell dimensions ...................',6F7.2/
     . ' Cell fix flags ....................',6I7/
     . ' Orientation matrix U ..............',3F10.4,2(/36X,3F10.4)/
     . ' Mounting axis .....................',5X,5A4/
     . ' Missetting angles phi xyz .........',6F7.2/
     . ' Start and stop phi angles .........',2F7.2/
     . ' Mosaicity .........................',F7.3/
     . ' Wavelength and dispersion .........',3F10.6/
     . ' Divergence ........................',2F7.3/
     . ' Batch scale and temperature factor ',2F7.3/
     . '     standard deviations ...........',2F7.3//
     . 1X,20('++++')/)
      END
