      SUBROUTINE RBATHD(ILUN,BATCH,RBATCH,CBATCH)
C     ===========================================
C
C     Read next batch header from multi-record MTZ file open on
C     unit ILUN, and return its batch number, plus real and
C     character arrays.
C
C---- Arguments :
C
C     ILUN      (I)	INTEGER         LUN on which the file is open
C
C     BATCH     (O)	INTEGER         serial number of this batch
C
C     RBATCH    (O)	REAL(*)         array into which integer and real batch
C                               	info is decoded by subroutine
C                               	this should be equivalenced onto the
C                               	appropriate COMMON block in the calling
C                               	program. The first item is nwords,ie how
C                               	many items in the array, if nword is 0
C                               	then only the title is present
C
C     CBATCH    (O)	CHARACTER(*)*1  as RBATCH, but for character items - no
C                               	nwords however; title is 1st 70 chars of
C                               	CBATCH.
C
C     The lengths of the RBATCH & CBATCH arrays are parameters here!
C
C     .. Parameters ..
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
C     ..
C     .. Scalar Arguments ..
      INTEGER BATCH,ILUN
C     ..
C     .. Array Arguments ..
      REAL RBATCH(MBLENG)
      CHARACTER CBATCH(CBLENG)*1
C     ..
C     .. Local Scalars ..
      INTEGER I,IEND,IFGERR,ISTERR,J,L,NWORDS,NINTGR,NREALS,NITEM,IER
      CHARACTER LINE*80,LINERR*100
C     ..
C     .. External Subroutines ..
      EXTERNAL LERROR,LRHDRL,QMODE,QREADR
C     ..
C
C---- Read first header line to get NWORDS etc., and Batch number
C
C          *****************
      CALL LRHDRL(ILUN,LINE)
C          *****************
C
      READ (LINE(4:),FMT='(4I8)') BATCH,NWORDS,NINTGR,NREALS
C
C---- Read batch title == 1st 70 characters of CBATCH
C
C          *****************
      CALL LRHDRL(ILUN,LINE)
C          *****************
C
      DO 10 I = 1,70
        J = I + 6
        CBATCH(I) = LINE(J:J)
   10 CONTINUE
C
C---- If NWORDS = 0, don't read anything else
C
      IF (NWORDS.GT.0) THEN
Cdw---- Read NINTGR integers followed by NREALS reals as BINARY
         CALL QMODE(ILUN,6,NITEM)
         CALL QREADR(ILUN,RBATCH(1),NINTGR,IER)
         IF (IER.GT.0) GO TO 50
         CALL QMODE(ILUN,2,NITEM)
         CALL QREADR(ILUN,RBATCH(NINTGR+1),NREALS,IER)
         IF (IER.GT.0) GO TO 50
         CALL QMODE(ILUN,0,NITEM)
C             ********************************
C
C---- Read rest of CBATCH (we need to know here how much to read!)
C     Using 2 loops means that CBATCH can expand 
C     in size beyond 1 line later
C
        DO 40 L = 71,CBLENG,75
C
C              *******************
          CALL LRHDRL(ILUN,LINE)
C              *******************
C
          J = 5
          IEND = L + 74
          IF (IEND.GT.CBLENG) IEND = CBLENG
          DO 30 I = L,IEND
            J = J + 1
            CBATCH(I) = LINE(J:J)
   30     CONTINUE
   40   CONTINUE
C
        GO TO 60
C
C---- Error on reading header
C
   50   WRITE (LINERR,FMT='(A,A,I2,A)')
     +  'RBATHD error: Error reading batch header record from',
     +  ' MTZ file, only ',IER,' words read'

        ISTERR = 2
        IFGERR = -1
C
C            ****************************
        CALL LERROR(ISTERR,IFGERR,LINERR)
C            ****************************
C
        RETURN
      END IF
C
   60 CONTINUE
C
      END
