      SUBROUTINE RESET_MAGIC(MINDX,ADATA,BDATA,NCOL,VAL_MAGICA,
     +                                                  VAL_MAGICB)
C     =============================================================
C
C     Resets an array containing Missing value flags VAL_MAGICA  to
C                one  containing Missing value flags VAL_MAGICB
C     If MINDX > 0 then VAL_MAGICA is taken to be the value of the MNF
C                stored in the MTZ header, for MTZ file MINDX. Else the 
C                passed value is taken. The MNF pertaining to the data 
C                need not necessarily be the same as that stored in the
C                header.
C     This allows you to list arrays containing Nan entries.
C     
C
C---- Arguments :
C
C
C     MINDX     (I)     INTEGER         indicates which MTZ file - 1 index
C                                       points to both input and output files
C
C     ADATA      (I)     REAL            array of dimension at least NCOL
C     					containing the reflection record  with
C     					"missing" values set  to VAL_MAGICA
C
C     BDATA      (O)	REAL            Array of dimension at least NCOL
C     					containing the reflection record  with
C     					"missing" values reset  to VAL_MAGIC
C
C     NCOL       (I)	INTEGER         Array size of ADATA
C
C     VAL_MAGICA (I)    REAL            If MINDX = 0 then this value will be
C                                       treated as the MNF pertaining to the
C                                       data. Otherwise 
C
C     VAL_MAGICB (I)	REAL            "Missing value" flag to reset in BDATA
C                                        to allow record to be printed.
C
C     .. Parameters ..
      INTEGER MFILES,MCOLS,MBATCH
      PARAMETER (MFILES=4,MCOLS=200,MBATCH=5000)
      INTEGER MBLENG
      PARAMETER (MBLENG=185)
      INTEGER MAXSYM
      PARAMETER (MAXSYM=192)
C     ..
C     .. Arguments ..
      REAL ADATA(*),BDATA(*),VAL_MAGICA,VAL_MAGICB
      INTEGER MINDX,NCOL
C     ..
C     .. Arrays in Common ..
      REAL CELL,CRANGE,SRANGE,RBATR,RSYM,VAL_MISS
      INTEGER BATNUM,ISORT,NBATCH,NCOLS,
     +        NREFS,NSPGRP,NSYM,NSYMP
      LOGICAL VAL_SET
C     ..
C     .. Local Scalars ..
      INTEGER JDO10
      LOGICAL LVALMS
C     ..
C     .. External Rotuines ..
      EXTERNAL IS_MAGIC
C     ..
C     .. Common blocks ..
      COMMON /MTZHDR/CELL(6,MFILES),NSYM(MFILES),NSYMP(MFILES),
     +       RSYM(4,4,MAXSYM,MFILES),NCOLS(MFILES),NREFS(MFILES),
     +       NBATCH(MFILES),BATNUM(MBATCH,MFILES),ISORT(5,MFILES),
     +       CRANGE(2,MCOLS,MFILES),NSPGRP(MFILES),
     +       RBATR(MBLENG,MBATCH,MFILES),SRANGE(2,MFILES),
     +     VAL_MISS(2,MFILES),VAL_SET(2,MFILES)
C     ..
C     .. Save statement ..
      SAVE /MTZHDR/
C     ..
C
C  If file only opened for Reading .
      IF (MINDX .GT. 0) VAL_MAGICA = VAL_MISS(1,MINDX)
C
C   If the file has been opened for Writing VAL_SET(2,MINDX) will be set
C      and VAL_MISS(2,MINDX) too 
C
      IF (MINDX .GT. 0) THEN
        IF (VAL_SET(2,MINDX)) VAL_MAGICA = VAL_MISS(2,MINDX)
      ENDIF
C
      BDATA(1) = ADATA(1)
      BDATA(2) = ADATA(2)
      BDATA(3) = ADATA(3)
      DO 10 JDO10 = 4,NCOL
        BDATA(JDO10) = ADATA(JDO10)
        CALL IS_MAGIC (VAL_MAGICA,ADATA(JDO10),LVALMS)
        IF(LVALMS) BDATA(JDO10) = VAL_MAGICB
 10   CONTINUE
      END
