      SUBROUTINE RHLCF1(NL,LOOK,LOOKUP,IPRINT)
C
C PARAMETERS (FOR FURTHER DETAILS SEE THE DESCRIPTION OF THE
C             CORRESPONDING PARAMETERS IN THE SUBROUTINE 'SRLCF1')
C
C          NL (I)   NUMBER OF CHARACTERS IN THE ARRAY LOOK (MAY BE
C                   0 OR -NL)
C        LOOK (I)   CHARACTER ARRAY CONTAINING PROGRAM LABELS
C      LOOKUP (I/O) ARRAY RETURNING THE POSITIONS OF THE REQUESTED DATA
C                   ITEMS
C       IPRINT (I)  .TRUE. PRINT HEADER INFORMATION, =.FALSE. DO NOT
C
C THE ITEM 'IDDN' IN COMMON /LCF1/ MUST BE SET TO THE REQUIRED UNIT
C NUMBER FOR THE INPUT FILE (OR EQUIVALENT IF NON-FORTRAN I/O IS
C USED) BEFORE THE SUBROUTINE 'RHLCF1' IS CALLED.
C
C SPECIFICATION STATEMENTS
C
      LOGICAL RD,IPRINT
      CHARACTER*1 ARRAYN(1000),LOOK(*)
      DIMENSION LOOKUP(*)
      COMMON /LCF1/IDDN,MAXDN,CELLN(6),LRECLN,LTITN,LABELN
      COMMON /LCF1AR/ARRAYN
      COMMON /LCF1WK/RD,IN,IOUT,LBUF,IUNIN,NCIN,IUNOUT,NCOUT,
     *               IPOINT(100),NLOOK,KDATA(100)
      SAVE /LCF1/,/LCF1AR/,/LCF1WK/
C
C INITIALISE COMMON /LCF1WK/ IF REQUIRED
C
      CALL INLCF1(5,6,72)
C
C OPEN INPUT FILE
C
      CALL LCF1OR(*800)
C
C READ HEADER RECORDS
C
      MAXDN=1000
      CALL HRLCF1(IERR)
      IF(IERR.NE.0)GO TO(805,810,815,820,825),IERR
      CALL LCFITM(ARRAYN,LABELN,NN)
      IF(NN.NE.NCIN)GO TO 830
C
C PRINT HEADER INFORMATION IF REQUIRED
C
      IF(.NOT.IPRINT)GO TO 200
      WRITE(IOUT,1001)IUNIN,NCIN
      WRITE(IOUT,1002)
      CALL LCFPRT(IOUT,ARRAYN,1,LABELN,1,80)
      WRITE(IOUT,1003)
      CALL LCFPRT(IOUT,ARRAYN,LABELN+1,LABELN+LTITN,1,80)
      WRITE(IOUT,1004)CELLN
C
C SET UP LOOKUP TABLE IF REQUIRED
C
200   IF(NL.EQ.0)RETURN
      CALL LCFSTP(NL,LOOK,LABELN,ARRAYN,NCIN,LOOKUP,NLOOK,
     *IN,IOUT,LBUF)
      IF(NLOOK.EQ.0)RETURN
C
C SET FLAG AND POINTERS FOR 'RDLCF1'
C
      RD=.TRUE.
      DO 250 N=1,NLOOK
      IPOINT(N)=LOOKUP(N)
250   CONTINUE
      RETURN
C
C ERROR CONDITIONS
C
800   WRITE(IOUT,2001)
      WRITE(IOUT,2002)IUNIN
      GO TO 900
805   WRITE(IOUT,2001)
      WRITE(IOUT,2003)
      GO TO 900
810   WRITE(IOUT,2001)
      WRITE(IOUT,2004)
      GO TO 900
815   WRITE(IOUT,2001)
      WRITE(IOUT,2005)
      GO TO 900
820   WRITE(IOUT,2001)
      WRITE(IOUT,2006)
      GO TO 900
825   WRITE(IOUT,2001)
      WRITE(IOUT,2007)
      GO TO 900
830   WRITE(IOUT,2001)
      WRITE(IOUT,2008)NCIN,NN
      GO TO 900
900   WRITE(IOUT,2010)
          call ccperr(1,' stop in lcflib.for 900')
C
C FORMAT STATEMENTS
C
1001  FORMAT(//,' HEADER INFORMATION FROM INPUT LCF FILE ON UNIT',I3,
     *//,' NUMBER OF COLUMNS =',I4)
1002  FORMAT(/,' * COLUMN LABELS:',/)
1003  FORMAT(/,' * TITLE:',/)
1004  FORMAT(/,' * CELL DIMENSIONS:',//,' ',6F8.2)
C
2001  FORMAT(/,' **LCF ERROR**')
2002  FORMAT(' **ERROR IN OPENING INPUT LCF FILE ON UNIT',I3,' **')
2003  FORMAT(' **ERROR ON READING BEGINNING OF HEADER RECORD**')
2004  FORMAT(' **ERROR ON READING CELL DIMENSIONS RECORD(S)**')
2005  FORMAT(' **ERROR ON READING LABELS RECORD(S)**')
2006  FORMAT(' **ERROR ON READING TITLE RECORD(S)**')
2007  FORMAT(' **ERROR ON READING END OF HEADER RECORD**')
2008  FORMAT(' **NO. OF COLUMNS FROM HEADER =',I3,' NO. OF LABELS =',I3,
     *' **')
2010  FORMAT(/,' **PROGRAM TERMINATED**')
      END
