      DOUBLE PRECISION FUNCTION S18AEF(X,IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     BESSEL FUNCTION I0(X)
C
C     **************************************************************
C
C     TO EXTRACT THE CORRECT CODE FOR A PARTICULAR MACHINE-RANGE,
C     ACTIVATE THE STATEMENTS CONTAINED IN COMMENTS BEGINNING  CDD ,
C     WHERE  DD  IS THE APPROXIMATE NUMBER OF SIGNIFICANT DECIMAL
C     DIGITS REPRESENTED BY THE MACHINE
C     DELETE THE ILLEGAL DUMMY STATEMENTS OF THE FORM
C     * EXPANSION (NNNN) *
C
C     ALSO INSERT APPROPRIATE DATA STATEMENTS TO DEFINE CONSTANTS
C     WHICH DEPEND ON THE RANGE OF NUMBERS REPRESENTED BY THE
C     MACHINE, RATHER THAN THE PRECISION (SUITABLE STATEMENTS FOR
C     SOME MACHINES ARE CONTAINED IN COMMENTS BEGINNING CRD WHERE
C     D IS A DIGIT WHICH SIMPLY DISTINGUISHES A GROUP OF MACHINES).
C     DELETE THE ILLEGAL DUMMY DATA STATEMENTS WITH VALUES WRITTEN
C     *VALUE*
C
C     **************************************************************
C
C     .. Parameters ..
      CHARACTER*6                      SRNAME
      PARAMETER                        (SRNAME='S18AEF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION                 X
      INTEGER                          IFAIL
C     .. Local Scalars ..
      DOUBLE PRECISION                 G, T, XBIG, XVSMAL, Y, YBIG
C     .. Local Arrays ..
      CHARACTER*1                      P01REC(1)
C     .. External Functions ..
      INTEGER                          P01ABF
      EXTERNAL                         P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC                        ABS, LOG, EXP
C     .. Data statements ..
C08   DATA XVSMAL /1.0D-4/
C09   DATA XVSMAL /3.2D-5/
C12   DATA XVSMAL /1.0D-6/
C15   DATA XVSMAL /3.2D-8/
      DATA XVSMAL /3.2D-9/
C19   DATA XVSMAL /3.2D-10/
C     FOR DEC VAX
      DATA XBIG,YBIG / 88.0D0, 1.7D+37 /
C     XBIG = LARGEST X SUCH THAT  EXP(X)/SQRT(X) .LT. MAXREAL
C             (ROUNDED DOWN)
C     YBIG = EXP(XBIG)/SQRT(XBIG)
C     FOR IEEE SINGLE PRECISION
CR0   DATA XBIG,YBIG /90.9E0,3.1E+38/
C     FOR IBM 360/370 AND SIMILAR MACHINES
CR1   DATA XBIG,YBIG /177.2D0,2.7D+75/
C     FOR DEC-10, HONEYWELL, UNIVAC 1100(S.P.)
CR2   DATA XBIG,YBIG /90.2D0,6.3D+37/
C     FOR ICL 1900
CR3   DATA XBIG,YBIG /179.3D0,2.2D+76/
C     FOR CDC 7600/CYBER
CR4   DATA XBIG,YBIG /744.9D0,4.7D+321/
C     FOR UNIVAC 1100(D.P.)
CR5   DATA XBIG,YBIG /712.3D0,3.3D+307/
C     FOR IEEE DOUBLE PRECISION
CR7   DATA XBIG,YBIG /713.0D0,1.7D+308/
C     .. Executable Statements ..
C
      T = ABS(X)
C     ERROR 1 TEST
      IF (T.GT.XBIG) GO TO 80
      IFAIL = 0
C     X RANGE TEST
      IF (T.GT.12.0D0) GO TO 60
C     TEST FOR MIDDLE RANGE
      IF (T.GT.4.0D0) GO TO 40
C     SMALL X
C     TEST FOR VERY SMALL X
      IF (T.GT.XVSMAL) GO TO 20
      S18AEF = 1.0D0
      GO TO 100
   20 G = EXP(T)
      T = 0.5D0*T - 1.0D0
C
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = ((((((((((((((+1.25170153D-5)*T-4.67023479D-5)
C08  *    *T+1.19121179D-4)*T-3.77327453D-4)*T+1.16281590D-3)
C08  *    *T-3.14217301D-3)*T+7.69874623D-3)*T-1.71264378D-2)
C08  *    *T+3.41510170D-2)*T-6.04328134D-2)*T+9.41615739D-2)
C08  *    *T-1.28895516D-1)*T+1.57686847D-1)*T-1.86478069D-1)*T +
C08  *    3.08508323D-1
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = (((((((((((((((-3.149367911D-6)*T+1.251701532D-5)
C09  *    *T-3.489221823D-5)*T+1.191211786D-4)*T-3.950426472D-4)
C09  *    *T+1.162815900D-3)*T-3.128640567D-3)*T+7.698746228D-3)
C09  *    *T-1.713197375D-2)*T+3.415101696D-2)*T-6.043165089D-2)
C09  *    *T+9.416157393D-2)*T-1.288956234D-1)*T+1.576868468D-1)
C09  *    *T-1.864780666D-1)*T + 3.085083225D-1
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = (((((((((((((((+3.552213748272D-8*T-1.672619002648D-7)
C12  *    *T+5.866981988794D-7)*T-2.438504834571D-6)
C12  *    *T+9.830542086049D-6)*T-3.613622861718D-5)
C12  *    *T+1.236706911308D-4)*T-3.938874947045D-4)
C12  *    *T+1.158888468912D-3)*T-3.129251464727D-3)
C12  *    *T+7.700609104316D-3)*T-1.713179048190D-2)
C12  *    *T+3.415053905809D-2)*T-6.043168004160D-2)
C12  *    *T+9.416163400294D-2)*T-1.288956212997D-1)
C12  *    *T+1.576868439705D-1
C12   Y = (Y*T-1.864780666100D-1)*T + 3.085083225537D-1
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y = (((((((((((((((-2.530899946655355D-10
C15  *    *T+1.378625787804520D-9)*T-5.841016145715136D-9)
C15  *    *T+2.862900854369717D-8)*T-1.361952673926676D-7)
C15  *    *T+6.013460978748421D-7)*T-2.502852637768319D-6)
C15  *    *T+9.813309263701611D-6)*T-3.606463713226221D-5)
C15  *    *T+1.236829425904201D-4)*T-3.939345014889662D-4)
C15  *    *T+1.158883078270167D-3)*T-3.129232874073100D-3)
C15  *    *T+7.700610548238343D-3)*T-1.713179479244525D-2)
C15  *    *T+3.415053883594465D-2)*T-6.043167950086759D-2
C15   Y = ((((Y*T+9.416163402029200D-2)*T-1.288956213305214D-1)
C15  *    *T+1.576868439699908D-1)*T-1.864780666094668D-1)*T +
C15  *    3.085083225536711D-1
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y = (((((((((((((((-7.48150165756234957D-12
     *    *T+4.44484446637868974D-11)*T-2.10071360134551962D-10)
     *    *T+1.13415934215369209D-9)*T-5.94856273204259507D-9)
     *    *T+2.92096163521178835D-8)*T-1.36042013507151017D-7)
     *    *T+6.00566861079330132D-7)*T-2.50298975966588680D-6)
     *    *T+9.81395862769787105D-6)*T-3.60645571444886286D-5)
     *    *T+1.23682594989692688D-4)*T-3.93934532072526720D-4)
     *    *T+1.15888319775791686D-3)*T-3.12923286656374358D-3)
     *    *T+7.70061052263382555D-3)*T-1.71317947935716536D-2
      Y = ((((((Y*T+3.41505388391452157D-2)
     *    *T-6.04316795007737183D-2)
     *    *T+9.41616340200868389D-2)*T-1.28895621330524993D-1)
     *    *T+1.57686843969995904D-1)*T-1.86478066609466760D-1)*T +
     *    3.08508322553671039D-1
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = (((((((((((((((-1.8784179614174412800D-13
C19  *    *T+1.2089468298240983040D-12)*T-6.3074904316764487680D-12)
C19  *    *T+3.7194763684842307584D-11)*T-2.1329989100573818880D-10)
C19  *    *T+1.1532002547234216346D-9)*T-5.9434264329293442580D-9)
C19  *    *T+2.9180903864909561201D-8)*T-1.3604724152589129050D-7)
C19  *    *T+6.0059431739522308981D-7)*T-2.5029862046131434148D-6)
C19  *    *T+9.8139412868667807577D-6)*T-3.6064558781683970924D-5)
C19  *    *T+1.2368260229532060075D-4)*T-3.9393453156577578087D-4)
C19  *    *T+1.1588831957319864270D-3)*T-3.1292328666662116016D-3
C19   Y = ((((((((Y*T+7.7006105229899461374D-3)
C19  *    *T-1.7131794793558845134D-2)
C19  *    *T+3.4150538839108284692D-2)*T-6.0431679500774614881D-2)
C19  *    *T+9.4161634020088817344D-2)*T-1.2889562133052496374D-1)
C19  *    *T+1.5768684396999586206D-1)*T-1.8647806660946676075D-1)*T +
C19  *    3.0850832255367103953D-1
C
      S18AEF = G*Y
      GO TO 100
C
C     MIDDLE X
   40 G = EXP(T)
      T = 0.25D0*T - 2.0D0
C
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = (((((((((((((((-2.58491708D-6)*T+5.79902384D-6)
C08  *    *T-2.79124210D-6)*T+5.54416320D-6)*T-2.55448774D-5)
C08  *    *T+5.01438907D-5)*T-8.59465309D-5)*T+1.67961894D-4)
C08  *    *T-3.36290944D-4)*T+6.73177142D-4)*T-1.37631504D-3)
C08  *    *T+2.89353541D-3)*T-6.30122230D-3)*T+1.44861278D-2)
C08  *    *T-3.71571541D-2)*T + 1.43431782D-1
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = ((((((((((((((((+1.104771573D-6)*T-2.584917075D-6)
C09  *    *T+1.379937549D-6)*T-2.791242095D-6)*T+1.272517843D-5)
C09  *    *T-2.554487744D-5)*T+4.406764708D-5)*T-8.594653090D-5)
C09  *    *T+1.708101331D-4)*T-3.362909444D-4)*T+6.724521352D-4)
C09  *    *T-1.376315041D-3)*T+2.893626033D-3)*T-6.301222301D-3)
C09  *    *T+1.448612352D-2)*T-3.715715414D-2)*T + 1.434317819D-1
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = (((((((((((((((+2.425721534790D-8*T-6.702448677965D-8)
C12  *    *T+5.653445311965D-8)*T-1.342660594828D-7)
C12  *    *T+5.623121016284D-7)*T-1.297962120106D-6)
C12  *    *T+2.577083077721D-6)*T-5.461269051676D-6)
C12  *    *T+1.142371408329D-5)*T-2.287156222189D-5)
C12  *    *T+4.486676250931D-5)*T-8.742186248288D-5)
C12  *    *T+1.705260897922D-4)*T-3.358360330658D-4)
C12  *    *T+6.725083973161D-4)*T-1.376388812767D-3)
C12  *    *T+2.893620477892D-3
C12   Y = (((Y*T-6.301216956565D-3)
C12  *    *T+1.448612373342D-2)*T-3.715715425644D-2)*T +
C12  *    1.434317818569D-1
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y = (((((((((((((((+2.825585726019810D-10
C15  *    *T-9.096828667154934D-10)*T+1.127807821205358D-9)
C15  *    *T-3.206544995575089D-9)*T+1.318013695388947D-8)
C15  *    *T-3.580576522294057D-8)*T+8.670120481253008D-8)
C15  *    *T-2.152964532328402D-7)*T+5.192357609897779D-7)
C15  *    *T-1.189131231894508D-6)*T+2.614274720462510D-6)
C15  *    *T-5.548439478014173D-6)*T+1.140334358829206D-5)
C15  *    *T-2.282804400092824D-5)*T+4.487387831119869D-5)
C15  *    *T-8.743538291189024D-5)*T+1.705245467454439D-4
C15   Y = (((((((Y*T-3.358335189754990D-4)*T+6.725085919694947D-4)
C15  *    *T-1.376389069008084D-3)*T+2.893620465323518D-3)
C15  *    *T-6.301216944612088D-3)*T+1.448612373373570D-2)
C15  *    *T-3.715715425660841D-2)*T + 1.434317818568503D-1
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y = (((((((((((((((+2.45185252963941089D-11
     *    *T-8.46900307934754898D-11)*T+1.23188158175419302D-10)
     *    *T-3.80370174256271589D-10)*T+1.58599776268172290D-9)
     *    *T-4.66215489983794905D-9)*T+1.24131668344616429D-8)
     *    *T-3.34900221934314738D-8)*T+8.75291839187305722D-8)
     *    *T-2.17653548816447667D-7)*T+5.18632519069546106D-7)
     *    *T-1.18752840689765504D-6)*T+2.61457634142262604D-6)
     *    *T-5.54917762110482949D-6)*T+1.14032404021741277D-5)
     *    *T-2.28278155280668483D-5)*T+4.48739019580173804D-5
      Y = (((((((((Y*T-8.74354291104467762D-5)
     *    *T+1.70524543267970595D-4)
     *    *T-3.35833513200679384D-4)*T+6.72508592273773611D-4)
     *    *T-1.37638906941232170D-3)*T+2.89362046530968701D-3)
     *    *T-6.30121694459896307D-3)*T+1.44861237337359455D-2)
     *    *T-3.71571542566085323D-2)*T + 1.43431781856850311D-1
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = (((((((((((((((-4.8781177932637798400D-13
C19  *    *T+1.8591063411513098240D-12)*T-3.3263935102228889600D-12)
C19  *    *T+1.1504780908334940160D-11)*T-4.9858650699064147968D-11)
C19  *    *T+1.6385610938810420429D-10)*T-4.9724253843991245619D-10)
C19  *    *T+1.5111687324503826760D-9)*T-4.4459427230194587402D-9)
C19  *    *T+1.2503195511458724053D-8)*T-3.3744232366202447987D-8)
C19  *    *T+8.7454812402950374687D-8)*T-2.1745209965767604588D-7)
C19  *    *T+5.1867562074346417550D-7)*T-1.1876386129043432359D-6)
C19  *    *T+2.6145587489026594806D-6)*T-5.5491358755173967651D-6
C19   Y = ((((((((((((Y*T+1.1403245405046993212D-5)
C19  *    *T-2.2827826322589233732D-5)
C19  *    *T+4.4873900992550687052D-5)*T-8.7435427266706018722D-5)
C19  *    *T+1.7052454338865393184D-4)*T-3.3583351339688115207D-4)
C19  *    *T+6.7250859226473849510D-4)*T-1.3763890694005676517D-3)
C19  *    *T+2.8936204653100399418D-3)*T-6.3012169445992907185D-3)
C19  *    *T+1.4486123733735940056D-2)*T-3.7157154256608529617D-2)*T +
C19  *    1.4343178185685031071D-1
C
      S18AEF = G*Y
      GO TO 100
C
C     LARGE X
   60 G = EXP(T-LOG(T)*0.5D0)
      T = 24.0D0/T - 1.0D0
C
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = (((((+2.49574115D-8)*T+2.22642925D-7)*T+2.79704810D-6)
C08  *    *T+5.59827269D-5)*T+2.18216826D-3)*T + 4.01071065D-1
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = ((((((+3.822579830D-9)*T+2.495741155D-8)*T+2.169090557D-7)
C09  *    *T+2.797048103D-6)*T+5.598487707D-5)*T+2.182168256D-3)*T +
C09  *    4.010710651D-1
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = ((((((((((+2.340749923654D-11)*T+7.186180190509D-11)
C12  *    *T+1.579111213677D-10)*T+6.284907334603D-10)
C12  *    *T+3.440923995653D-9)*T+2.369586371205D-8)
C12  *    *T+2.171613059408D-7)*T+2.797705824730D-6)
C12  *    *T+5.598482525317D-5)*T+2.182168172172D-3)*T +
C12  *    4.010710650668D-1
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y = (((((((((((((((-2.411756899398287D-13)
C15  *    *T-2.170471559606428D-12)*T-3.044730035928687D-12)
C15  *    *T+4.496440289935385D-12)*T+1.547327566378010D-11)
C15  *    *T+2.226273536199183D-11)*T+4.586796117551065D-11)
C15  *    *T+1.545697718533012D-10)*T+6.486795836711866D-10)
C15  *    *T+3.443856712516276D-9)*T+2.368833843881964D-8)
C15  *    *T+2.171604498120274D-7)*T+2.797707025776663D-6)
C15  *    *T+5.598482533619400D-5)*T+2.182168172116796D-3)*T +
C15  *    4.010710650668474D-1
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y = (((((((((((((((-1.95679809047625728D-13
     *    *T+4.73229306831831040D-14)*T+1.44572313799118029D-12)
     *    *T+4.30812577328136192D-13)*T-4.29417106720584499D-12)
     *    *T-4.34624739357691085D-12)*T+2.82807056475555021D-12)
     *    *T+8.27719401266046976D-12)*T+1.05863621425699789D-11)
     *    *T+1.89599322920800794D-11)*T+4.82726630988879388D-11)
     *    *T+1.56147127476528831D-10)*T+6.47994117793472057D-10)
     *    *T+3.44345025431425567D-9)*T+2.36884434055843528D-8)
     *    *T+2.17160501061222148D-7)*T+2.79770701849785597D-6
      Y = ((Y*T+5.59848253337377763D-5)
     *    *T+2.18216817211694382D-3)*T +
     *    4.01071065066847416D-1
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = (((((((((((((((-3.3144842200547328000D-14
C19  *    *T+1.2008469636841472000D-14)*T+2.7186179143945420800D-13)
C19  *    *T-3.5759472348495872000D-14)*T-1.0454721503030149120D-12)
C19  *    *T-1.9782650535057817600D-13)*T+2.3978847028834467840D-12)
C19  *    *T+1.5929661492722401280D-12)*T-2.8976380738342092800D-12)
C19  *    *T-4.5692556020853309440D-12)*T-1.2796874612755333120D-12)
C19  *    *T+3.0819891159672381440D-12)*T+6.4220654560433725440D-12)
C19  *    *T+1.0449077288480794624D-11)*T+1.9688661329266574848D-11)
C19  *    *T+4.8317557581369720320D-11)*T+1.5596755827968609280D-10
C19   Y = (((((((Y*T+6.4798546599576738163D-10)
C19  *    *T+3.4434761778711018340D-9)
C19  *    *T+2.3688444310954546095D-8)*T+2.1716049913450601437D-7)
C19  *    *T+2.7977070184547602578D-6)*T+5.5984825333793869167D-5)
C19  *    *T+2.1821681721169444223D-3)*T + 4.0107106506684741582D-1
C
      S18AEF = G*Y
      GO TO 100
C
C     ERROR 1 EXIT
   80 IFAIL = P01ABF(IFAIL,1,SRNAME,0,P01REC)
      S18AEF = YBIG
C
  100 RETURN
      END
