      DOUBLE PRECISION FUNCTION S18AFF(X,IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 8C REVISED. IER-269 (OCT.1980).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     BESSEL FUNCTION I1(X)
C
C     **************************************************************
C
C     TO EXTRACT THE CORRECT CODE FOR A PARTICULAR MACHINE-RANGE,
C     ACTIVATE THE STATEMENTS CONTAINED IN COMMENTS BEGINNING  CDD ,
C     WHERE  DD  IS THE APPROXIMATE NUMBER OF SIGNIFICANT DECIMAL
C     DIGITS REPRESENTED BY THE MACHINE
C     DELETE THE ILLEGAL DUMMY STATEMENTS OF THE FORM
C     * EXPANSION (NNNN) *
C
C     ALSO INSERT APPROPRIATE DATA STATEMENTS TO DEFINE CONSTANTS
C     WHICH DEPEND ON THE RANGE OF NUMBERS REPRESENTED BY THE
C     MACHINE, RATHER THAN THE PRECISION (SUITABLE STATEMENTS FOR
C     SOME MACHINES ARE CONTAINED IN COMMENTS BEGINNING CRD WHERE
C     D IS A DIGIT WHICH SIMPLY DISTINGUISHES A GROUP OF MACHINES).
C     DELETE THE ILLEGAL DUMMY DATA STATEMENTS WITH VALUES WRITTEN
C     *VALUE*
C
C     **************************************************************
C
C     .. Parameters ..
      CHARACTER*6                      SRNAME
      PARAMETER                        (SRNAME='S18AFF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION                 X
      INTEGER                          IFAIL
C     .. Local Scalars ..
      DOUBLE PRECISION                 G, T, XBIG, XVSMAL, Y, YBIG
C     .. Local Arrays ..
      CHARACTER*1                      P01REC(1)
C     .. External Functions ..
      INTEGER                          P01ABF
      EXTERNAL                         P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC                        ABS, SIGN, LOG, EXP
C     .. Data statements ..
C08   DATA XVSMAL /1.0D-4/
C09   DATA XVSMAL /3.2D-5/
C12   DATA XVSMAL /1.0D-6/
C15   DATA XVSMAL /3.2D-8/
      DATA XVSMAL /3.2D-9/
C19   DATA XVSMAL /3.2D-10/
C     FOR DEC VAX
      DATA XBIG,YBIG / 88.0D0, 1.7D+37 /
C     XBIG = LARGEST X SUCH THAT  EXP(X)/SQRT(X) .LT. MAXREAL
C             (ROUNDED DOWN)
C     YBIG = EXP(XBIG)/SQRT(XBIG)
C     FOR IEEE SINGLE PRECISION
CR0   DATA XBIG,YBIG /90.9E0,3.1E+38/
C     FOR IBM 360/370 AND SIMILAR MACHINES
CR1   DATA XBIG,YBIG /177.2D0,2.7D+75/
C     FOR DEC-10, HONEYWELL, UNIVAC 1100(S.P.)
CR2   DATA XBIG,YBIG /90.2D0,6.3D+37/
C     FOR ICL 1900
CR3   DATA XBIG,YBIG /179.3D0,2.2D+76/
C     FOR CDC 7600/CYBER
CR4   DATA XBIG,YBIG /744.9D0,4.7D+321/
C     FOR UNIVAC 1100(D.P.)
CR5   DATA XBIG,YBIG /712.3D0,3.3D+307/
C     FOR IEEE DOUBLE PRECISION
CR7   DATA XBIG,YBIG /713.0D0,1.7D+308/
C     .. Executable Statements ..
C
      T = ABS(X)
C     ERROR 1 TEST
      IF (T.GT.XBIG) GO TO 80
      IFAIL = 0
C     X RANGE TEST
      IF (T.GT.12.0D0) GO TO 60
C     TEST FOR MIDDLE RANGE
      IF (T.GT.4.0D0) GO TO 40
C     SMALL X
C     TEST FOR VERY SMALL X
      IF (T.GT.XVSMAL) GO TO 20
      S18AFF = 0.5D0*X
      GO TO 100
   20 T = 0.125D0*T*T - 1.0D0
C
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = (((((((+3.92892854D-7)*T+1.13063239D-5)*T+2.45223921D-4)
C08  *    *T+3.84762606D-3)*T+4.09286373D-2)*T+2.68657662D-1)
C08  *    *T+9.28758890D-1)*T + 1.19741655D+0
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = (((((((+3.928928537D-7)*T+1.130632386D-5)*T+2.452239209D-4)
C09  *    *T+3.847626062D-3)*T+4.092863729D-2)*T+2.686576622D-1)
C09  *    *T+9.287588901D-1)*T + 1.197416550D+0
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = (((((((((+2.330286285600D-10)*T+1.067670554920D-8)
C12  *    *T+3.923685392897D-7)*T+1.128497044797D-5)
C12  *    *T+2.452243141144D-4)*T+3.847639407499D-3)
C12  *    *T+4.092863718276D-2)*T+2.686576595217D-1)
C12  *    *T+9.287588901146D-1)*T + 1.197416549637D+0
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y = ((((((((((+4.173727097882224D-12)*T+2.330286285600112D-10)
C15  *    *T+1.066627123145040D-8)*T+3.923685392897174D-7)
C15  *    *T+1.128497957799518D-5)*T+2.452243141144006D-4)
C15  *    *T+3.847639404238095D-3)*T+4.092863718276363D-2)
C15  *    *T+2.686576595220928D-1)*T+9.287588901146102D-1)*T +
C15  *    1.197416549636702D+0
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y = (((((((((((+6.24387910353848320D-14)
     *    *T+4.17372709788222413D-12)*T+2.32856921884663846D-10)
     *    *T+1.06662712314503955D-8)*T+3.92368710996392755D-7)
     *    *T+1.12849795779951847D-5)*T+2.45224314039278904D-4)
     *    *T+3.84763940423809498D-3)*T+4.09286371827770484D-2)
     *    *T+2.68657659522092832D-1)*T+9.28758890114609554D-1)*T +
     *    1.19741654963670236D+0
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = ((((((((((((+7.9180648970649600000D-16)
C19  *    *T+6.2438791035384832000D-14)*T+4.1713516784131046400D-12)
C19  *    *T+2.3285692188466384563D-10)*T+1.0666273903797298255D-8)
C19  *    *T+3.9236871099639275503D-7)*T+1.1284979576609523316D-5)
C19  *    *T+2.4522431403927890421D-4)*T+3.8476394042384197425D-3)
C19  *    *T+4.0928637182777048352D-2)*T+2.6865765952209280388D-1)
C19  *    *T+9.2875889011460955436D-1)*T + 1.1974165496367023583D+0
C
      S18AFF = X*Y
      GO TO 100
C
C     MIDDLE X
   40 G = EXP(T)
      T = 0.25D0*T - 2.0D0
C
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = (((((((((((((((+2.04204709D-6)*T-4.39594806D-6)
C08  *    *T+1.31096677D-6)*T-1.89739179D-6)*T+1.36440625D-5)
C08  *    *T-2.21733453D-5)*T+2.35080066D-5)*T-2.41247862D-5)
C08  *    *T+5.59728936D-6)*T+8.42565753D-5)*T-3.67687996D-4)
C08  *    *T+1.17320332D-3)*T-3.40759200D-3)*T+9.76020768D-3)
C08  *    *T-2.99140925D-2)*T + 1.34142493D-1
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = ((((((((((((((((-9.013598912D-7)*T+2.042047089D-6)
C09  *    *T-7.905084934D-7)*T+1.310966772D-6)*T-7.756231083D-6)
C09  *    *T+1.364406247D-5)*T-1.721586589D-5)*T+2.350800662D-5)
C09  *    *T-2.644860471D-5)*T+5.597289356D-6)*T+8.484809269D-5)
C09  *    *T-3.676879960D-4)*T+1.173129378D-3)*T-3.407592004D-3)
C09  *    *T+9.760211205D-3)*T-2.991409248D-2)*T + 1.341424933D-1
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = (((((((((((((((-2.137968646738D-8*T+5.825193532379D-8)
C12  *    *T-4.505657546108D-8)*T+1.021824254180D-7)
C12  *    *T-4.447215247821D-7)*T+9.852042220010D-7)
C12  *    *T-1.805382790889D-6)*T+3.523606198412D-6)
C12  *    *T-6.649860183496D-6)*T+1.142085667417D-5)
C12  *    *T-1.789619803823D-5)*T+2.473724235346D-5)
C12  *    *T-2.620655968490D-5)*T+5.217818255143D-6)
C12  *    *T+8.480011929240D-5)*T-3.676264096858D-4)
C12  *    *T+1.173134117233D-3
C12   Y = (((Y*T-3.407596468626D-3)
C12  *    *T+9.760211025571D-3)*T-2.991409238989D-2)*T +
C12  *    1.341424932927D-1
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y = (((((((((((((((-2.585602855843796D-10
C15  *    *T+8.263393060071838D-10)*T-9.914352278371534D-10)
C15  *    *T+2.772708966945032D-9)*T-1.146662778794534D-8)
C15  *    *T+3.062872297108590D-8)*T-7.213105372475229D-8)
C15  *    *T+1.741345209187592D-7)*T-4.060152623900778D-7)
C15  *    *T+8.884275924436715D-7)*T-1.838822740857724D-6)
C15  *    *T+3.601181743921443D-6)*T-6.631537188516544D-6)
C15  *    *T+1.138210964994464D-5)*T-1.790260037692807D-5)
C15  *    *T+2.474928446808203D-5)*T-2.620517107156340D-5
C15   Y = (((((((Y*T+5.215578508861103D-6)*T+8.479994409371570D-5)
C15  *    *T-3.676261813644457D-4)*T+1.173134128546845D-3)
C15  *    *T-3.407596479277477D-3)*T+9.760211025286696D-3)
C15  *    *T-2.991409238974067D-2)*T + 1.341424932926982D-1
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y = (((((((((((((((-2.27061376122617856D-11
     *    *T+7.79929176497056645D-11)*T-1.10970391104678003D-10)
     *    *T+3.38883570696523350D-10)*T-1.41575617446629553D-9)
     *    *T+4.11321223904934809D-9)*T-1.07563514207617768D-8)
     *    *T+2.84961041291017650D-8)*T-7.28978293484163628D-8)
     *    *T+1.76305222240064495D-7)*T-4.05456611578551130D-7)
     *    *T+8.86951515545183908D-7)*T-1.83910206626348772D-6)
     *    *T+3.60186151617732531D-6)*T-6.63144162982509821D-6)
     *    *T+1.13818992442463952D-5)*T-1.79026222757948636D-5
      Y = (((((((((Y*T+2.47493270133518925D-5)
     *    *T-2.62051678511418163D-5)
     *    *T+5.21557319070236939D-6)*T+8.47999438119288094D-5)
     *    *T-3.67626180992174570D-4)*T+1.17313412855965374D-3)
     *    *T-3.40759647928956354D-3)*T+9.76021102528646704D-3)
     *    *T-2.99140923897405570D-2)*T + 1.34142493292698178D-1
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = (((((((((((((((+4.5775493193216819200D-13
C19  *    *T-1.7377647145171025920D-12)*T+3.0683838993620008960D-12)
C19  *    *T-1.0541784610642067456D-11)*T+4.5665794931233390592D-11)
C19  *    *T-1.4898399423473962189D-10)*T+4.4748047024971893965D-10)
C19  *    *T-1.3458111447069821501D-9)*T+3.9122095980161710162D-9)
C19  *    *T-1.0840504034690950758D-8)*T+2.8732496785343932531D-8)
C19  *    *T-7.2828311971692262588D-8)*T+1.7611785989651199931D-7)
C19  *    *T-4.0549690005824350650D-7)*T+8.8705402749571279009D-7)
C19  *    *T-1.8390856219860622587D-6)*T+3.6018226816369370946D-6
C19   Y = ((((((((((((Y*T-6.6314463061664910712D-6)
C19  *    *T+1.1381909286711502521D-5)
C19  *    *T-1.7902621373343015831D-5)*T+2.4749325297973732372D-5)
C19  *    *T-2.6205167963948297248D-5)*T+5.2155733732522876693D-6)
C19  *    *T+8.4799943820374214419D-5)*T-3.6762618100311115229D-4)
C19  *    *T+1.1731341285593238429D-3)*T-3.4075964792892586671D-3)
C19  *    *T+9.7602110252864721110D-3)*T-2.9914092389740559536D-2)*T +
C19  *    1.3414249329269817831D-1
C
      S18AFF = SIGN(G*Y,X)
      GO TO 100
C
C     LARGE X
   60 G = EXP(T-LOG(T)*0.5D0)
      T = 24.0D0/T - 1.0D0
C
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y = (((((-2.96738127D-8)*T-2.78984102D-7)*T-3.82721490D-6)
C08  *    *T-9.12451446D-5)*T-6.40545370D-3)*T + 3.92624494D-1
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y = ((((((-4.383292624D-9)*T-2.967381267D-8)*T-2.724091627D-7)
C09  *    *T-3.827214904D-6)*T-9.124761019D-5)*T-6.405453697D-3)*T +
C09  *    3.926244942D-1
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y = ((((((((((-2.533926898209D-11)*T-7.774606791952D-11)
C12  *    *T-1.734215243288D-10)*T-7.068696867564D-10)
C12  *    *T-3.965182881278D-9)*T-2.826186206848D-8)
C12  *    *T-2.726853285086D-7)*T-3.827950034494D-6)
C12  *    *T-9.124755347160D-5)*T-6.405453603544D-3)*T +
C12  *    3.926244942041D-1
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y = (((((((((((((((+2.864463574710190D-13)
C15  *    *T+2.296326081181966D-12)*T+3.031081657644896D-12)
C15  *    *T-4.930682983830821D-12)*T-1.625784942705443D-11)
C15  *    *T-2.360757461732030D-11)*T-4.984995964878307D-11)
C15  *    *T-1.704720475191773D-10)*T-7.288220600471799D-10)
C15  *    *T-3.967981996319198D-9)*T-2.825360264463809D-8)
C15  *    *T-2.726844939064504D-7)*T-3.827951362129912D-6)
C15  *    *T-9.124755355333729D-5)*T-6.405453603482220D-3)*T +
C15  *    3.926244942041166D-1
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y = (((((((((((((((+1.99448557598015488D-13
     *    *T-5.77176811730370560D-14)*T-1.48765082315961139D-12)
     *    *T-3.95353303949377536D-13)*T+4.47735589657057690D-12)
     *    *T+4.42966462319664333D-12)*T-3.05957293450420224D-12)
     *    *T-8.69631766630563635D-12)*T-1.11795516742222899D-11)
     *    *T-2.02947854602758139D-11)*T-5.23524129533553498D-11)
     *    *T-1.72060490748583241D-10)*T-7.28107961041827952D-10)
     *    *T-3.96757162863209348D-9)*T-2.82537120880041703D-8)
     *    *T-2.72684545741400871D-7)*T-3.82795135453556215D-6
      Y = ((Y*T-9.12475535508497109D-5)
     *    *T-6.40545360348237412D-3)*T +
     *    3.92624494204116555D-1
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y = (((((((((((((((+3.3679618863005696000D-14
C19  *    *T-1.3569887628689408000D-14)*T-2.7733286267020902400D-13)
C19  *    *T+4.6135638859186176000D-14)*T+1.0726764420299489280D-12)
C19  *    *T+1.7181030171593932800D-13)*T-2.4822246330641940480D-12)
C19  *    *T-1.5863951335214284800D-12)*T+3.0522499336199864320D-12)
C19  *    *T+4.7030271230869504000D-12)*T+1.2431528563850690560D-12)
C19  *    *T-3.2807424254310154240D-12)*T-6.7639380417875619840D-12)
C19  *    *T-1.1056476687880072192D-11)*T-2.1055276286591258112D-11)
C19  *    *T-5.2393348632806530560D-11)*T-1.7187282226057648858D-10
C19   Y = (((((((Y*T-7.2809998359709274272D-10)
C19  *    *T-3.9675987527407277127D-9)
C19  *    *T-2.8253712929434771752D-8)*T-2.7268454372357710872D-7)
C19  *    *T-3.8279513544952731211D-6)*T-9.1247553550908501103D-5)
C19  *    *T-6.4054536034823746802D-3)*T + 3.9262449420411655531D-1
C
      S18AFF = SIGN(G*Y,X)
      GO TO 100
C
C     ERROR 1 EXIT
   80 IFAIL = P01ABF(IFAIL,1,SRNAME,0,P01REC)
      S18AFF = YBIG
C
  100 RETURN
      END
