      SUBROUTINE SLLCF1(IUN,FILNAM,NL,LOOK,LCOL,IPRINT,NCOL,CELL)
C     ===========================================================
C
C This subroutine opens an lcf file and reads the header records.
C A check is made to see whether the specified column labels are
C present or not. (no assignments are read)
C
C
C---- Parameters
C
C         IUN (I)   UNIT NUMBER FOR THE INPUT FILE (OR EQUIVALENT IF
C                   NON-FORTRAN I/O IS USED)
C      FILNAM (I)   LOGICAL FILE NAME (UP TO 8 CHARACTERS)
C          NL (I)   THE NUMBER OF CHARACTERS IN THE ARRAY 'LOOK' WHICH
C                   CONTAINS THE NAMES OF STANDARD COLUMN LABELS WHICH
C                   ARE TO BE LOOKED FOR.
C        LOOK (I)   CHARACTER ARRAY CONTAINING THE COLUMN LABELS
C        LCOL (I/O) THIS ARRAY RETURNS THE POSITIONS OF THE REQUESTED
C                   DATA ITEMS. ON ENTRY TO THE SUBROUTINE THE ENTRIES
C                   IN 'LCOL' MUST BE SET TO 0 FOR OPTIONAL COLUMNS
C                   AND .LT. ZERO FOR COMPULSORY ONES. (COLUMN NUMBERS
C                   OF 0 ARE RETURNED FOR ABSENT OPTIONAL COLUMNS)
C      IPRINT (I)   FLAG =.TRUE.  PRINT (DEFAULT UNIT=6) THE CELL
C                                 DIMENSIONS, LABELS AND TITLE
C                                 INFORMATION AS READ FROM THE FILE
C                                 HEADER.
C                        =.FALSE. DO NOT PRINT THESE DETAILS
C       NCOLS (O)   RETURNS THE NUMBER OF COLUMNS OF REFLECTION
C                   DATA IN THE FILE
C        CELL (O)   6 WORD ARRAY RETURNING THE CELL DIMENSIONS
C                   IN ANGSTROMS AND DEGREES
C
C---- Specification statements
C
      LOGICAL IPRINT
      CHARACTER*(*) FILNAM
      CHARACTER*1 ARRAYN(1000),LOOK(*)
      CHARACTER*2 BLANK
      LOGICAL RD
      DIMENSION LCOL(*),CELL(6)
      COMMON /LCF1/IDDN,MAXDN,CELLN(6),LRECLN,LTITN,LABELN
      COMMON /LCF1AR/ARRAYN
      COMMON /LCF1WK/RD,IN,IOUT,LBUF,IUNIN,NCIN,IUNOUT,NCOUT,
     *               IPOINT(100),NLOOK,KDATA(100)
      CHARACTER*40 FILIN,FILOUT
      COMMON /LCF1FN/FILIN,FILOUT
      SAVE /LCF1/,/LCF1AR/,/LCF1WK/,/LCF1FN/
      DATA BLANK/'  '/
C
C---- Open input file and read header records
C
      FILIN=FILNAM
      LFAIL=0
      IDDN=IUN
      CALL RHLCF1(2,BLANK,LCOL,IPRINT)
      DO 5 I=1,6
      CELL(I)=CELLN(I)
5     CONTINUE
      NCOL=NCIN
      IF(NCIN.GT.100)GO TO 810
      IF(NL.LE.0)RETURN
C
C---- Find the number of column labels in 'look' and in header
C
      CALL LCFITM(ARRAYN,LABELN,NLAB)
      CALL LCFITM(LOOK,NL,NLOOK)
C
C---- Search for requested column labels
C
      DO 20 J=1,NLOOK
      CALL LCFLBL(J,LOOK,NL,L1,L2,*20)
      DO 10 I=1,NLAB
      CALL LCFLBL(I,ARRAYN,LABELN,L3,L4,*10)
      IF(LCFCMP(LOOK,L1,L2,ARRAYN,L3,L4).EQ.1)GO TO 15
10    CONTINUE
C
C---- No match for this column
C
      IF(LCOL(J).EQ.0)GO TO 20
      WRITE(IOUT,2001)
      WRITE(IOUT,2002)J,(LOOK(L),L=L1,L2)
      LFAIL=LFAIL+1
      GO TO 20
C
C---- Label found
C
15    LCOL(J)=I
C
C---- End of labels loop
C
20    CONTINUE
C
C----  Set up items in common for RDLCF1
C
      RD=.TRUE.
      DO 30 J=1,NLOOK
      IPOINT(J)=LCOL(J)
30    CONTINUE
C
      IF(LFAIL.EQ.0)RETURN
      GO TO 800
C
C---- Error conditions
C
800   WRITE(IOUT,2001)
      WRITE(IOUT,2003)
      WRITE(IOUT,2004)
          call ccperr(1,' stop in lcflib.for 90050')
810   WRITE(IOUT,2001)
      WRITE(IOUT,2005)
      WRITE(IOUT,2004)
          call ccperr(1,' stop in lcflib.for 90060')
C
C---- Format statements
C
2001  FORMAT(/,' **LCF ERROR**')
2002  FORMAT(/,' **LABEL NOT FOUND FOR COMPULSORY COLUMN',I3,
     * ' **: ',40A1)
2003  FORMAT(/,' **',I3,' MISSING COMPULSORY COLUMNS IN FILE**')
2004  FORMAT(/,' **PROGRAM TERMINATED**')
2005  FORMAT(/,' **NO. OF COLS IN LCF FILE',I4,' EXCEEDS MAX OF 100**')
      END
