      SUBROUTINE WBATHD(ILUN,BATCH,RBATCH,CBATCH)
C     ==========================================
C
C     Write batch header to Multi-record MTZ file open for write
C     on ILUN, with batch number BATCH, and data in RBATCH and CBATCH
C
C---- Arguments :
C
C     ILUN      (I)	INTEGER         LUN on which the file is open
C
C     BATCH     (I)	INTEGER         serial number of this batch
C
C     RBATCH    (I)	REAL(*)         array from which integer and real batch
C                               	info is encoded by subroutine
C                               	this should be equivalenced onto the
C                               	appropriate COMMON block in the calling
C                               	program. The first item is nwords,ie how
C                               	many items in the array, if nword is 0
C                               	then only the title is written
C
C     CBATCH    (I)	CHARACTER(*)*1  as RBATCH, but for character items - no
C                               	nwords however; title is 1st 70 chars of
C                               	CBATCH.
C
C     The lengths of the RBATCH & CBATCH arrays are parameters here!
C
C     .. Parameters ..
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
C     ..
C     .. Scalar Arguments ..
      INTEGER BATCH,ILUN
C     ..
C     .. Array Arguments ..
      REAL RBATCH(MBLENG)
      CHARACTER CBATCH(CBLENG)*1
C     ..
C     .. Local Scalars ..
      REAL RBATCX,RBATCY,RBATCZ
      INTEGER I,IEND,J,L,NWORDS,NINTGR,NREALS,NITEM
      CHARACTER LINE*80
C     ..
C     .. External Subroutines ..
      EXTERNAL QWRITC,QMODE,QWRITR
C     ..
C
C---- Here are the important EQUIVALENCE statements
C
C     .. Equivalences ..
      EQUIVALENCE (RBATCX,NWORDS)
      EQUIVALENCE (RBATCY,NINTGR)
      EQUIVALENCE (RBATCZ,NREALS)
C     ..
C
C----  Copy RBATCH(1) == NWORDS for testing
C
      RBATCX = RBATCH(1)
      RBATCY = RBATCH(2)
      RBATCZ = RBATCH(3)
C
C---- Write out batch header name and NWORDS
C
      WRITE (LINE,FMT='(A,4I8)') 'BH ',BATCH,NWORDS,NINTGR,NREALS
C
C     ============================
      CALL QWRITC(ILUN,LINE(1:80))
C     ============================
C
C---- Write out batch title == 1st 70 characters of CBATCH
C
      LINE = 'TITLE '
C
      DO 10 I = 1,70
        J = I + 6
        LINE(J:J) = CBATCH(I)
   10 CONTINUE
C
C     ============================
      CALL QWRITC(ILUN,LINE(1:80))
C     ============================
C
C---- If NWORDS = 0, only write out batch title
C
      IF (NWORDS.GT.0) THEN
C---- Write out the orientation block as REALs with one QWRITE call -
C     have to change the mode to 2 and change back to 0 after
C
C            *****************************
        CALL QMODE(ILUN,2,NITEM)
        CALL QWRITR(ILUN,RBATCH(1),NWORDS)
        CALL QMODE(ILUN,0,NITEM)
C            *****************************
C
C---- Write out rest of CBATCH 
C     (we need to know here how much to write!)
C
        LINE = 'BHCH '
C
        DO 40 L = 71,CBLENG,75
          IEND = L + 74
          IF (IEND.GT.CBLENG) IEND = CBLENG
          J = 5
C
          DO 30 I = L,IEND
            J = J + 1
            LINE(J:J) = CBATCH(I)
   30     CONTINUE
C
C         ============================
          CALL QWRITC(ILUN,LINE(1:80))
C         ============================
C
   40   CONTINUE
C
      END IF
C
      END
