      SUBROUTINE WHLCF2(IDATA)
C
C PARAMETERS
C
C       IDATA (I)   DUMMY WORK ARRAY (RETAINED FOR COMPATIBILITY WITH
C                   ORIGINAL LCF ROUTINES.
C
C BEFORE CALLING THE ROUTINE THE FOLLOWING ITEMS MUST BE SET UP
C IN THE COMMON /LCF2/
C
C        IDDN  UNIT NO. OF OUTPUT FILE
C       LTITN  LENGTH OF TITLE INFORMATION
C      LABELN  LENGTH OF LABEL INFORMATION
C       CELLN  CELL DIMENSIONS (A B C ALPHA BETA GAMMA)
C      ARRAYN  THIS MUST HOLD THE REQUIRED TITLE AND LABELS INFORMATION
C
C SPECIFICATION STATEMENTS
C
      LOGICAL RD,RPT
      DIMENSION IDATA(*)
      CHARACTER*1 ARRAYN(1000)
      COMMON /LCF2/IDDN,MAXDN,CELLN(6),LRECLN,LTITN,LABELN
      COMMON /LCF2AR/ARRAYN
      COMMON /LCF2WK/RD,IN,IOUT,LBUF,IUNIN,NCIN,IUNOUT,NCOUT,
     *               IPOINT(100),NLOOK,KDATA(100)
      SAVE /LCF2/,/LCF2AR/,/LCF2WK/
      CALL BADLCF
C
C GET NUMBER OF COLUMNS FROM THE NUMBER OF LABELS
C
      CALL LCFITM(ARRAYN,LABELN,NCOL)
      IF(NCOL.LT.6)GO TO 800
      IF(NCOL.GT.100)GO TO 810
      NCOUT=NCOL
C
C TEST FOR REPEATED LABELS
C
      RPT=.FALSE.
      I=0
130   I=I+1
      CALL LCFLBL(I,ARRAYN,LABELN,M1,M2,*150)
      J=I
140   J=J+1
      CALL LCFLBL(J,ARRAYN,LABELN,M3,M4,*130)
      IF(LCFCMP(ARRAYN,M1,M2,ARRAYN,M3,M4).EQ.0)GO TO 140
      RPT=.TRUE.
      GO TO 820
150   IF(RPT)GO TO 900
C
C ENSURE THAT AT LEAST ONE CHARACTER OF TITLE PRESENT
C
      IF(LTITN.GT.0)GO TO 200
      LTITN=1
      ARRAYN(LABELN+1)=' '
C
C OPEN FILE
C
200   CALL LCF2OW(*850)
C
C WRITE HEADER RECORDS
C
      CALL HWLCF2
      RETURN
C
C ERROR CONDITIONS
C
800   WRITE(IOUT,2001)
      WRITE(IOUT,2002)
      GO TO 900
810   WRITE(IOUT,2001)
      WRITE(IOUT,2003)
      GO TO 900
820   WRITE(IOUT,2001)
      WRITE(IOUT,2004)(ARRAYN(M),M=M1,M2)
      GO TO 130
850   WRITE(IOUT,2001)
      WRITE(IOUT,2005)IUNOUT
900   WRITE(IOUT,2010)
          call ccperr(1,' stop in lcflib.for 90077')
C
C FORMAT STATEMENTS
C
2001  FORMAT(/,' **LCF ERROR**')
2002  FORMAT(' **CANNOT OPEN FILE WITH LESS THAN 6 COLUMNS**')
2003  FORMAT(' **MAXIMUM NUMBER OF COLUMNS IS 100**')
2004  FORMAT(' **REPEATED LABEL** :',(1X,50A1))
2005  FORMAT(' **ERROR ON OPENING LCF FILE ON UNIT',I3,' **')
2010  FORMAT(/,' **PROGRAM TERMINATED**')
      END
