      SUBROUTINE X04BZZ(IFMTR)
C     MARK 8 RELEASE. NAG COPYRIGHT 1980.
C
C     **************** MACHINE-DEPENDENT SUBROUTINE ****************
C
C     X04BZZ SETS UP A FORMAT SPECIFICATION IN THE INTEGER ARRAY
C     IFMTR, FOR PRINTING A REAL VARIABLE TO FULL MACHINE PRECISION
C     IN THE CENTRE OF A FIELD 30 CHARACTERS WIDE.
C
C     SUPPOSE  S+1  SIGNIFICANT DIGITS ARE TO BE PRINTED.  THEN THE
C     FORMAT SPECIFICATION MUST HAVE THE FORM
C     .               MX,1PEW.S,NX
C     WHERE  M, W, S, N  ARE INTEGERS SUCH THAT
C     .     W = S + 7
C     .     M + N = 30 - W
C     .     M = N  IF  S  IS ODD, OR  M = N + 1  IF  S  IS EVEN.
C     ALL UNUSED ELEMENTS OF IFMTR MUST BE FILLED WITH BLANKS.
C
C     IMPLEMENTORS MUST COMPLETE THE ASSIGNMENTS TO ELEMENTS
C     1, 7, 8, 10, 11 AND 13 OF IFMTR.  NOTE THAT 2 CHARACTER
C     POSITIONS ARE PROVIDED FOR  W  AND  S .  IF ONLY 1 CHARACTER
C     IS NEEDED, THE FIRST CHARACTER POSITION SHOULD BE SET TO A
C     BLANK.
C
C     PHILIP E. GILL, ENID M. R. LONG, WALTER MURRAY AND
C     SUSAN M. PICKEN
C     D.N.A.C., NATIONAL PHYSICAL LABORATORY, ENGLAND.
C     JULY 1978
C
C     **************************************************************
C
C     .. ARRAY ARGUMENTS ..
      INTEGER IFMTR(20)
C     ..
C     .. LOCAL SCALARS ..
      INTEGER I1, I2, I3, I4, I5, I6, I7, I8, I9, IBLANK, ICOMMA,ID, IP,
     * IPOINT, IX, IZERO, J
C     ..
      DATA ICOMMA /1H,/
      DATA ID /1HD/
      DATA IP /1HP/
      DATA IPOINT /1H./
      DATA IX /1HX/
      DATA IZERO /1H0/
      DATA I1 /1H1/
      DATA I2 /1H2/
      DATA I3 /1H3/
      DATA I4 /1H4/
      DATA I5 /1H5/
      DATA I6 /1H6/
      DATA I7 /1H7/
      DATA I8 /1H8/
      DATA I9 /1H9/
      DATA IBLANK /1H /
      IFMTR(1) = I4
      IFMTR(2) = IX
      IFMTR(3) = ICOMMA
      IFMTR(4) = I1
      IFMTR(5) = IP
      IFMTR(6) = ID
      IFMTR(7) = I2
      IFMTR(8) = I2
      IFMTR(9) = IPOINT
      IFMTR(10) = I1
      IFMTR(11) = I5
      IFMTR(12) = ICOMMA
      IFMTR(13) = I4
      IFMTR(14) = IX
      DO 20 J=15,20
         IFMTR(J) = IBLANK
   20 CONTINUE
      RETURN
C
C     END OF SUBROUTINE X04BZZ
C
      END
