C"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

	integer*4 MBR, MAX_IMAGES, MAX_SIMPLEX, M_ORIENT
	integer*4 MAX_BAND, MAX_INCR, MAX_SAMPL, MAX_SET
	parameter (MBR=150, MAX_IMAGES=1000, MAX_SIMPLEX=6*MAX_IMAGES+3)
	parameter (MAX_BAND=40, MAX_INCR=10, MAX_SAMPL=10, M_ORIENT=8)
	parameter (MAX_SET=100)
	structure /save/
	    union
		map
		    real*4	THETA
		    real*4	PHI
		    real*4	OMEGA
		    real*4	ORIGX
		    real*4	ORIGY
		    real*4      MAGFAC
		    real*4      PFT_CC
		    real*4      PRJ_CC
		    real*4      CMP_CC
		    real*4	RESAVG
		    real*4	ANGLE	! if>0 - degrees, 
C					! if<0 - radians
C					! if=0 - "cosines"
		    logical	FLIPPED
		end map
		map
		    real*4	X	! this set refers to the 
		    real*4	Y	!    "cosines" representation
		    real*4	BUFF_OMEGA_ORIGX_ORIGY(3)
		    real*4	Z
		end map 
		map
		    real*4	I(M_ORIENT)
		end map
	    end union
	end structure

	structure /IMAGE/
	    character*40		FILE_NAME
	    union   ! allows referencing these as either individuals or 
C		    !	a group
		map
	    	    real*4	THETA
	    	    real*4	PHI
	    	    real*4	OMEGA
	    	    real*4	ORIGX
	    	    real*4	ORIGY
		    real*4      MAGFAC
		    real*4      PFT_CC
		    real*4      PRJ_CC
		    real*4      CMP_CC
	    	    real*4	RESAVG 
		    real*4	ANGLE
		    logical	FLIPPED
		    integer*4   ID
		end map
		map
	    	    record/save/ PRESENT
		end map
	    end union

	    real*4	FZERO
	    integer*4	IADDR_AT
	    integer*4	IADDR_BT
	    real*4	RESMIN(MAX_IMAGES)
	    real*4	RESTOP
	    real*4	RESMIN1(MAX_IMAGES)
	    real*4	RESBOT
	    integer*4	IADDR_FCUT
	    union
		map
	    	    real*4	TRIGGER_DEL
		end map
		map
	    	    real*4	TRIGGER_DELTA
		end map
	    end union
	    logical	ACTIVE
	    record/save/ OLD
	    record/save/ ORIGINAL
	end structure

	structure/conformation/
	    real*4	AVG_ERR
	    integer*4	N_AVG_ERR
	    record/save/ ORIENT(MAX_IMAGES)
	end structure	   	    

	structure/hand/
	    logical	HAND(MAX_IMAGES)	
	    real*4	RES_SUM
	end structure	   	    


C
	integer*4 NLINES, NLINES1, L_GRAD
C
	real*4	  TWOPI/6.283185307/
	real*4	  PI/3.141592654/
	real*4	  DEGREE/57.29577951/
	real*4	  RADIAN/0.017453292/

C"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
c	sdf	6-feb-1989 
c			includes handedness and original residuals	
C	sdf	26-june-1989
c			includes monitoring of flipping
c			variable FLIPPED
c	sdf	28-june-1989
c			include feild ACTIVE which monitors
c			whether this particle is to be
c			refined
c	wz	8-dec-2000
c			include magfac, pft_cc, prj_cc and cmp_cc
c			in the IMAGE structure
c........................................................................
