C  ********************************************************************
C  *                                                                  *
C  *              *****     SUBROUTINE PMAP_FFT     *****             *
C  *                                                                  *
C  *    ROUTINE TO COMPUTE FFT OF POLAR MAP.                          *
C  *                                                                  *
C  *    COLUMNS OF THE POLAR MAP ARE FOURIER TRANSFORMED.             *
C  *                                                                  *
C  *    AUGUST 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.            *
C  *    LAST MODIFIED 15-DEC-1997 BY T. BAKER (RID OF EM.CMM).        *
C  ********************************************************************
C
	SUBROUTINE PMAP_FFT (PMAP, PFFT, A, NROT, NANNULI)
C
	IMPLICIT NONE
C
	INTEGER*4 NANNULI, NROT, I, J, IDIM1
	REAL*4    PMAP(NROT,NANNULI)
	REAL*4    PFFT((NROT*2),NANNULI), A(NROT*2), WORK, DIV, RADIUS
C  ----------------------------------------------------------------------------
C
	DIV   = FLOAT(NROT)
	IDIM1 = NROT
C
	DO I = 1,NANNULI			! STEP THROUGH ANNULI
	  RADIUS = FLOAT(I)
	  DO J = 1,NROT*2			! ZERO ARRAY "A"
	    A(J) = 0.0
	  ENDDO
	  DO J = 1,NROT				! COPY ROW INTO ARRAY
	    A(2*J-1) = PMAP(J,I)
	  ENDDO
	  CALL FOURT (A, IDIM1, 1, 1, 0, WORK)	! TRANSFORM THE COLUMN
	  DO J = 1,NROT*2
	    PFFT(J,I) = RADIUS*A(J)/DIV
	  ENDDO
	ENDDO					! MAIN LOOP
C
	RETURN
	END
