
c	!  Return_to_Unit_Triangle
c	!! ---- from asym.for
c	!!! -----  at 20:56:58 on 25-FEB-90
c
c	! Return_to_Unit_Triangle
c
c
c		The subroutine checks the input orientation for
c		   validity that is lying in the unique triangle
c		   between the five folds at 90,+-31.7 and the
c		   three fold at 69.01,0 (this region is called 
c		   good). 
c			sdf 4-dec-1985
c	
C		mrc conversion sdf - 17-jan-87
c		revision for larger area of return
C		SDF 28-JAN-87
C		last modified 1-feb-87 sdf
C		completely re-written - previous version was wrong
c			sdf 12-jan88
C----------------------------------------------------------------------------
	subroutine Return_to_Unit_Triangle(THETA, PHI, OMEGA, L_DEGREE)
c
	implicit none
c
	real*4 THETA, PHI, OMEGA, DCOS(3), X(3)
	real*4 THETAR, PHIR, OMEGAR
	real*4 DEG_PER_RAD/57.29577951/
	integer IMAT
	logical L_DEGREE, GOOD

c/////////////////////////////////////////////////////////////////////
	logical L_GEOMETRY_INIT	
	real*4 ICOS_ROT(3,3,60) 	! icos rotation matrixes
	
	real*4 THREE_FOLD(3)	! direction cosines for three fold
	real*4 FIVE_FOLD(3)	! direction cosines for five fold
	real*4 ANG_35,ANG_55	! angular distances btw 3fold and 5 folds
	real*4 AREA_STD		! area of asymmetric unit in spherical measure

	common/icos_geometry/ L_GEOMETRY_INIT,
	1	ICOS_ROT, THREE_FOLD, FIVE_FOLD, ANG_35, ANG_55, AREA_STD

c/////////////////////////////////////////////////////////////////////
c.............................................................................
c
c
	if(L_DEGREE) then
	    call polar_to_cosines(THETA, PHI, DCOS)
	else
	    call polar_to_cosines( THETA*DEG_PER_RAD,PHI*DEG_PER_RAD,DCOS)
	end if
c

	if(good(DCOS)) return
c
	if(.not.L_DEGREE) then
	    THETA = THETA*DEG_PER_RAD
	    PHI = PHI*DEG_PER_RAD
	    OMEGA = OMEGA*DEG_PER_RAD
	else
	    call polar_to_cosines( THETAR*DEG_PER_RAD,
	1   PHIR*DEG_PER_RAD,X)	    
	end if
	do IMAT = 1, 60
	    call equivalent_view(THETA, PHI,OMEGA,
	1			ICOS_ROT(1,1,IMAT),
	1			THETAR, PHIR, OMEGAR)
	    call polar_to_cosines(THETAR, PHIR, X)
	    if(good(X)) then
		if(L_DEGREE) then
		    THETA = THETAR
		    PHI = PHIR
		    OMEGA=OMEGAR
		    return
		else
		    THETA = THETAR/DEG_PER_RAD
		    PHI = PHIR/DEG_PER_RAD
		    OMEGA = OMEGAR/DEG_PER_RAD
		    return
		end if
 	    end if
	end do
C

	write(6,'('' RETURN_TO_UNIT_TRIANGLE '')')
	write(6,'('' no equivalent found '')')
	write(6,'('' input values '')')
	write(6,'('' theta '',g)') THETA
	write(6,'('' phi '',g)') PHI
	write(6,'('' omega '',g)') OMEGA
	write(6,'('' Last matrix tried '',i2)') IMAT
	return
	end

! POLAR_TO_COSINES
c
	subroutine POLAR_TO_COSINES(THETA, PHI, X)
C
C		Converts theta, phi angles in degrees to direction 
c		cosines
c
c		a tolerance is set to try to alleviate round off 
c		problems and the total length of the direction cosine
c		vector is set to 1.0
c
c		sdf - 10-jan-88
c
c------------------------------------------------------------------------------

	real*4 THETA,PHI,X(3)
	real*4 TOLER/1.0e-8/

	X(3) = cosd(THETA)
	if(abs(x(3)-1.0).lt.TOLER) then
	    X(2) = sind(PHI)
	    X(1) = sind(PHI)
	else
	    X(2) = sind(THETA)*sind(PHI)
	    X(1) = sind(THETA)*cosd(PHI)
	end if
	do I = 1,3
	   if(abs(X(I)).LT.TOLER) X(I)=0.0
	end do

	call norm(X,X)

	return

	end

!good
c
	logical function good(X)
c
c		This logical function is true if a view is within the 
c	assymetric icosahedral unit defined by the (90,+/- 31.7..) five folds 
c	and the (69.0..,0.0) three-fold. The function does a rough check 
c	first on the direction cosines of the view and then calculates 
c	the spherical measure of the largest triangle formed by the test 
c	point and the bounding symmetry axes. If this is larger than 
c	that of the assymmetric unit, the view is outside the unit.
c
c		sdf 10-jan-88
c------------------------------------------------------------------------
	implicit none
	real*4	TOLER/1.0e-6/
	real*4	X(3)
	real*4  A3X, A5PX, A5X, D3X, D5X, D5PX, AREA_X
	integer I
c//////////////////////////////////////////////////////////////////////
	logical L_GEOMETRY_INIT	
	real*4 ICOS_ROT(3,3,60) 	! icos rotation matrixes
	
	real*4 THREE_FOLD(3)	! direction cosines for three fold
	real*4 FIVE_FOLD(3)	! direction cosines for five fold
	real*4 ANG_35,ANG_55	! angular distances btw 3fold and 5 folds
	real*4 AREA_STD		! area of asymmetric unit in spherical measure
	common/icos_geometry/ L_GEOMETRY_INIT,
	1	ICOS_ROT, THREE_FOLD, FIVE_FOLD, ANG_35, ANG_55, AREA_STD
c/////////////////////////////////////////////////////////////////////
	real*4 sur,excess,A,B,C

	sur(A,B,C) = (A+B+C)/2.0
	excess(A,B,C) =
	1 4.0*atan(sqrt(abs(tan(sur(A,B,C)/2.)
	1 *tan((sur(A,B,C)-A)/2.0)
	1 *tan((sur(A,B,C)-B)/2.0)
	1 *tan((sur(A,B,C)-C)/2.0) ) )  )

c/////////////////////////////////////////////////////////////////////

	GOOD = .false.

	if(.not.L_GEOMETRY_INIT) call geometry_init

	if(X(3).lt.-TOLER .or.
	1	 X(3).gt.THREE_FOLD(3)+TOLER.or.
	2	 abs(X(2)).gt.FIVE_FOLD(2)+TOLER) then
	return
	end if


	D3X = 0.0
	D5X = 0.0
	D5PX = 0.0

	do I = 1,3
	   D3X=(X(I)-THREE_FOLD(I))**2+D3X
	   D5X=(X(I)-FIVE_FOLD(I))**2+D5X
	   if(I.eq.2) then
	      D5PX=(X(I)+FIVE_FOLD(I))**2+D5PX
	   else
	      D5PX=(X(I)-FIVE_FOLD(I))**2+D5PX
	   end if
	end do

	D3X = sqrt(D3X)
	D5X = sqrt(D5X)
	D5PX = sqrt(D5PX)

	A5X=2.0*asin(D5X/2.)
	A5PX=2.0*asin(D5PX/2.)
	A3X=2.0*asin(D3X/2.)
	
	AREA_X =   excess(A5X,A3X,ANG_35)+excess(A5PX,A3X,ANG_35)+
	1	   excess(A5X,A5PX,ANG_55) -
	1	min(excess(A5PX,A3X,ANG_35),excess(A5X,A5PX,ANG_55), 
	1		excess(A5X,A3X,ANG_35) )

	GOOD = AREA_X.lt.(AREA_STD+TOLER)

	return
	end

!  equivalent_view
!! ---- from asym.for
!!! -----  at 20:57:00 on 25-FEB-90

!equivalent_view
c
	subroutine equivalent_view(THETA,PHI,OMEGA,ROT,THETAR,PHIR,OMEGAR)
c
c		should find theta,phi and omega for an equivalent view 
c	which is generated by rotation with rot.
c
c	new formulation which avoids the cummulative errors in the many
C	multiplications of the previous version
C	    formulation suggested by Peter Metcalf
C	    
c		sdf 29-oct-89
c--------------------------------------------------------------------------
	implicit none

	real*4 ROT(3,3)
c-------------------	rotation matrix to generate equivalents
	real*4 VIEW(3,3)
c------------------	  equivalent rotation matrix to crowther angles
	real*4 PROT(3,3)
C----------------     product matrix


	real*4 THETA, PHI, OMEGA
	real*4 THETAR, PHIR, OMEGAR

c.....................................................................

	call crowther_to_matrix(THETA, PHI, OMEGA, VIEW)
	call matmul(PROT,VIEW,ROT)
	call matrix_to_crowther(THETAR, PHIR, OMEGAR, PROT)
	return
	end

! norm
c
	subroutine norm(NX,X)
c
c		Normalizes a vector X and returns the normalized value
c
c		sdf 8-jan-88
c-----------------------------------------------------------------------
	implicit none
	real NX(3),X(3),NDOT
	integer J
	real dot
c.......................................................................
	NDOT = sqrt(abs(dot(X,X)))
	if(NDOT.gt.1.e-20) then
	    do J=1,3
		NX(J)=X(J)/NDOT
	    end do
	else
	    print *,' norm - zero length vector ',X 
	    do J=1,3
		NX(J)=0.0
	    end do
	end if
	return
	end

!dot(x,y)
c
	function dot(x,y)
c
c		Returns the dot product of two 3 dim vectors
c	
c
c		sdf 7-jan-88
c----------------------------------------------------------------------
	implicit none
	real DOT,X(3),Y(3)
c........................................................................
	DOT=X(1)*Y(1)+X(2)*Y(2)+X(3)*Y(3)
	return
	end

!GEOMETRY_INIT
c
	subroutine GEOMETRY_INIT
c
c
c		Initializes the arrays and geometric constants needed by 
c			the return to unit triangle routines
c		The key l_geometry_init is used to force its call upon 
c			the first reference
c
c			sdf 10-jan-88
c
c----------------------------------------------------------------------
	implicit none

	real*8 TAU, AREA_35, AREA_55, DIST_35, DIST_55
	real*8 THETA_THREE, PHI_THREE, THETA_FIVE, PHI_FIVE
	real*8 ARG

	integer	I

c/////////////////////////////////////////////////////////////////////
	logical L_GEOMETRY_INIT	
	real*4 ICOS_ROT(3,3,60) 	! icos rotation matrixes
	
	real*4 THREE_FOLD(3)	! direction cosines for three fold
	real*4 FIVE_FOLD(3)	! direction cosines for five fold
	real*4 ANG_35,ANG_55	! angular distances btw 3fold and 5 folds
	real*4 AREA_STD		! area of asymmetric unit in spherical measure

	common/icos_geometry/ L_GEOMETRY_INIT,
	1	ICOS_ROT, THREE_FOLD, FIVE_FOLD, ANG_35, ANG_55, AREA_STD

c/////////////////////////////////////////////////////////////////////

	call genrot(ICOS_ROT)
	TAU = (1.+dsqrt(5.0d0))/2.0
	ARG =  (1.+TAU*TAU/3.d0-1./(3.d0*TAU*TAU))/(2.d0*TAU/dsqrt(3.0d0))
	THETA_THREE = 90. - dacosd(ARG)
	PHI_THREE = 0.0
	THREE_FOLD(3) = cosd(THETA_THREE)
	THREE_FOLD(2) = 0.0
	THREE_FOLD(1) = sind(THETA_THREE)

	THETA_FIVE = 90.0
	PHI_FIVE = datand(1.0/TAU)


	FIVE_FOLD(1) = cosd(PHI_FIVE)
	FIVE_FOLD(2) = sind(PHI_FIVE)
	FIVE_FOLD(3) = 0.0	


	DIST_35 = 0.0

	do I = 1,3
	   DIST_35=(THREE_FOLD(I)-FIVE_FOLD(I))**2+DIST_35
	end do
	DIST_35 = dsqrt(DIST_35)
	DIST_55 = FIVE_FOLD(2)*2.d0

	ANG_55=2.0*dasin(DIST_55/2.)
	ANG_35=2.0*dasin(DIST_35/2.)
	
	AREA_STD  = 4*3.141592653589793/60.
C			one sixtieth of the sphere surface

	L_GEOMETRY_INIT = .true.

	return
	end

!  crowther_to_matrix
!! ---- from asym.for
!!! -----  at 20:56:56 on 25-FEB-90
	subroutine crowther_to_matrix(THETA,PHI,OMEGA,ROT)
C
C	    generates the rotation matrix corresponding to the crowther
C	    angles THETA, PHI,OMEGA
C
C		sdf 29oct89
C
c--------------------------------------------
	implicit none
	real*4 ROT(3,3) 
	real*4 THETA, PHI,OMEGA

	real*4 CT,ST
	real*4 CP,SP
	real*4 CO,SO

c--------------------------- Taking the crowther angles as eulerian angles 

	ST=sind(THETA)
	CT=cosd(THETA)
	SP=sind(PHI)
	CP=cosd(PHI)
	SO=sind(OMEGA)
	CO=cosd(OMEGA)

	ROT(1,1)= SO*CT*CP-CO*SP             
	ROT(1,2)=-SO*CT*SP-CO*CP
	ROT(1,3)=-SO*ST
	ROT(2,1)= CO*CT*CP+SO*SP
	ROT(2,2)=-CO*CT*SP+SO*CP	
	ROT(2,3)=-CO*ST
	ROT(3,1)= ST*CP
	ROT(3,2)=-ST*SP
	ROT(3,3)= CT
 
	end

! matrix_to_crowther
c
		subroutine matrix_to_crowther(THETA,PHI,OMEGA,ROT)
C	    returns the crowther angles corresponding to a rotation
C	    matrix
C	    
C 	Peter's derivation is based on crowther matrix as:
c-
c	so*ct*cp-co*sp		-so*ct*sp-co*cp		-so*st
c	co*ct*cp+so*sp		-co*ct*sp+so*cp		-co*st
c	st*cp			-st*sp			ct 
C
C		sdf 29-oct-89
C.............................................................

	implicit none

	real*4 ROT(3,3)

	real*4 THETA, PHI, OMEGA

	real*4 OMEGA_MINUS_PHI, OMEGA_PLUS_PHI

	real*4 TOLER/1.0e-6/

c fix rotation matrix if not accurate by this method - bug fix

	if(abs(ROT(3,3))+TOLER .ge. 1.0) then
	    ROT(3,3)=sign(1.0, ROT(3,3))
	end if                                             

c nb all minus signs in atan2 below necessary       
		
	THETA=acosd(ROT(3,3))

	if(sind(THETA).gt.TOLER) then
		OMEGA = atan2d(-ROT(1,3),-ROT(2,3))
		PHI = atan2d(-ROT(3,2),ROT(3,1))
	else  
		if(cosd(THETA).eq.1.0) then
			OMEGA_MINUS_PHI=
     $			  atan2d(ROT(2,2),ROT(2,1))
			OMEGA=0.0              	! arbitrary choice
			PHI=OMEGA-OMEGA_MINUS_PHI     

		else                          	! cosd(theta)=-1
			OMEGA_PLUS_PHI=
     $			   atan2d(ROT(2,2),-ROT(2,1))
			OMEGA=0.0                 ! arbitrary choice
			PHI=OMEGA_PLUS_PHI     
		end if
	end if		
	end

! matmul
c
      subroutine matmul(a,b,c)
c
c	multiply matrix b by matrix c and return the product a
c
c		for double precision matrices
c
c		sdf 6-jan-1988
c--------------------------------------------------------
	implicit none
	real A(3,3),B(3,3),C(3,3),B_COPY(3,3),C_COPY(3,3)
	integer I,J,K
c........................................................................
	do I=1,3
	    do J=1,3
	      	B_COPY(I,J)=B(I,J)
      		C_COPY(I,J)=C(I,J)
	    end do
	end do

	do I=1,3
	    do J=1,3
		A(I,J)=0.0
		do K=1,3
            	    A(I,J)=A(I,J)+B_COPY(I,K)*C_COPY(K,J)
		end do
	    end do
	end do
	return
	end

! GENROT                              
c	
C
      SUBROUTINE   GENROT(ROT)                              

C     modified from G. Bricogne's program GENROT in the MRC package
C
C                 THIS SUBROUTINE GENERATES THE 60 ICOSAHEDRAL ROTATIONS
C                 AND THEIR MATRICES EXPRESSED IN THE ORTHNORMAL FRAME
C                 BASED ON THREE DYADS .
C
c		This is a double precision version
      IMPLICIT real*8 (A-H,O-Z)
C
      REAL*4   ROT(3,3,60)
      real*8	drot(3,3)
      REAL*8   P3(3,3)/9*0.0/,P5(3,3)/9*0.0/
      REAL*8   P3INV(3,3)/9*0.0/,P5INV(3,3)/9*0.0/,TMAT6(3,3)
      REAL*8   TMAT1(3,3),TMAT2(3,3),TMAT3(3,3),TMAT4(3,3),TMAT5(3,3)
      REAL*8   R2Y(3,3,2)/18*0.0/,R2X(3,3,2)/18*0.0/
      REAL*8   S3(3,3,3)/27*0.0/,S5(3,3,5)/45*0.0/
C
c	--------  sdf 6-jan-1988
c-------------------------------------------------------------


      PI = dacos(-1.0d0)
      TPIOV3=PI/1.5
      TPIOV5=PI/2.5
C
      ROOT5=SQRT(5.0)
C
      XX3=ROOT5/6.0
      COS3=SQRT(0.5+XX3)
      SIN3=SQRT(0.5-XX3)
C
      XX5=0.5/ROOT5
      COS5=SQRT(0.5+XX5)
      SIN5=SQRT(0.5-XX5)
C
C
C                  GENERATE Y-DYAD MATRICES .
      DO 10 K=1,3
   10 R2Y(K,K,1)=1.0
      R2Y(1,1,2)=-1.0
      R2Y(2,2,2)=+1.0
      R2Y(3,3,2)=-1.0
C
C                  GENERATE 3-FOLD MATRICES .
      THETA=-TPIOV3
      DO 20 K=1,3
      THETA=THETA+TPIOV3
      COSINE=COS(THETA)
      SINE=SIN(THETA)
      S3(1,1,K)=1.0
      S3(2,2,K)=COSINE
      S3(3,2,K)=SINE
      S3(2,3,K)=-SINE
   20 S3(3,3,K)=COSINE
C
C                  GENERATE 5-FOLD MATRICES .
      THETA=-TPIOV5
      DO 30 K=1,5
      THETA=THETA+TPIOV5
      COSINE=COS(THETA)
      SINE=SIN(THETA)
      S5(1,1,K)=COSINE
      S5(2,1,K)=SINE
      S5(1,2,K)=-SINE
      S5(2,2,K)=COSINE
   30 S5(3,3,K)=1.0
C
C                  GENERATE X-DYAD MATRICES .
      DO 40 K=1,3
   40 R2X(K,K,1)=1.0
      R2X(1,1,2)=1.0
      R2X(2,2,2)=-1.0
      R2X(3,3,2)=-1.0
C
C                  GENERATE  XZ-THREEFOLD TRANSITION MATRICES .
      P3(1,1)=COS3
      P3(3,1)=SIN3
      P3(2,2)=1.0
      P3(1,3)=-SIN3
      P3(3,3)=COS3
      P3INV(1,1)=COS3
      P3INV(3,1)=-SIN3
      P3INV(2,2)=1.0
      P3INV(1,3)=SIN3
      P3INV(3,3)=COS3
C
C                  GENERATE  XZ-FIVEFOLD TRANSITION MATRICES .
      P5(1,1)=COS5
      P5(3,1)=+SIN5
      P5(2,2)=1.0
      P5(1,3)=-SIN5
      P5(3,3)=COS5
      P5INV(1,1)=COS5
      P5INV(3,1)=-SIN5
      P5INV(2,2)=1.0
      P5INV(1,3)=+SIN5
      P5INV(3,3)=COS5
C
C
C                  GENERATE ICOSAHEDRAL ROTATION MATRICES .
      N=0                                        
      DO 100 L2=1,2                       
      CALL   DMATMUL(tmat1,R2Y(1,1,L2),P5)
      DO 100 K5=1,5
      CALL   DMATMUL(tmat2,TMAT1,S5(1,1,K5))
      CALL   DMATMUL(tmat3,TMAT2,P5INV)
      DO 100 J2=1,2
      CALL   DMATMUL(tmat4,TMAT3,R2X(1,1,J2))
      CALL   DMATMUL(tmat5,TMAT4,P3)
      DO 100 I3=1,3
      N=N+1
      CALL   DMATMUL(tmat6,TMAT5,S3(1,1,I3))
      CALL   DMATMUL(drot(1,1),TMAT6,P3INV)
      do ii = 1,3
          do jj = 1,3
		rot(ii,jj,N)=drot(ii,jj)
	  end do
      end do
  100 CONTINUE
C
      RETURN
      END

! dmatmul
c
      subroutine dmatmul(a,b,c)
c
c	multiply matrix b by matrix c and return the product a
c
c		for double precision matrices
c
c		sdf 6-jan-1988
c--------------------------------------------------------
	implicit none
	double precision A(3,3),B(3,3),C(3,3),B_COPY(3,3),C_COPY(3,3)
	integer I,J,K
c........................................................................
	do I=1,3
	    do J=1,3
	      	B_COPY(I,J)=B(I,J)
      		C_COPY(I,J)=C(I,J)
	    end do
	end do

	do I=1,3
	    do J=1,3
		A(I,J)=0.0d0
		do K=1,3
            	    A(I,J)=A(I,J)+B_COPY(I,K)*C_COPY(K,J)
		end do
	    end do
	end do
	return
	end

C  *******************************************************************
C  *                                                                 *
C  *            *****     SUBROUTINE ICO_POLART     *****            *
C  *                                                                 *
C  *    INTERPOLATE TRANSFORM ONTO POLAR GRID                        *
C  *                                                                 *
C  *    REWRITTEN TO MAKE USE OF CALLED ARRAYS RATHER THAN COMMONS   *
C  *    13-JAN-87  STEVE FULLER                                      *
C  *                                                                 *
C  *    SUBROUTINE CALLED BY PROGRAM EMICOFV                         *
C  *    MODIFIED  2-DEC-88 BY T. BAKER (MINOR CLEANUP)               *
C  *    LAST MODIFIED 29-MAY-1989 BY T. BAKER                        *
C  *******************************************************************
C
	SUBROUTINE ICO_POLART (APOL, BPOL, ARGPOL, FPOL, NSAMPL, NANG,
	1	AT, BT, IRAD, MINR, MAXR)
C
	IMPLICIT NONE
C
	INTEGER*4 IRAD, NANG, MINR, MAXR, NSAMPL, NA, NR
	REAL*4    AT((2*IRAD+1)*(IRAD+2)), BT((2*IRAD+1)*(IRAD+2))
	REAL*4    APOL(NSAMPL,NANG), BPOL(NSAMPL,NANG)
	REAL*4	  ARGPOL(NSAMPL,NANG), FPOL(NSAMPL,NANG)
	REAL*4    PI, RADIAN, DEGREE, ANG, DELANG
	REAL*4    RADIUS, DEL_RADIUS, COSANG, SINANG, A, B, X, Y
C  ----------------------------------------------------------------------------
C
	CALL PIRADDEG (PI, RADIAN, DEGREE)
	ANG        = 0.0
	DELANG     = PI/(NANG-1)
	DEL_RADIUS = FLOAT(MAXR-MINR)/FLOAT(NSAMPL-1)
C
	DO NA = 1,NANG
	  RADIUS = MINR
	  COSANG = COS(ANG)
	  SINANG = SIN(ANG)
	  DO NR = 1,NSAMPL
	    X = RADIUS*COSANG
	    Y = RADIUS*SINANG
	    CALL ICO_INTERP (X, Y, A, B, AT, BT, IRAD)
	    APOL(NR,NA)   = A
	    BPOL(NR,NA)   = B
	    FPOL(NR,NA)   = SQRT(A*A + B*B)
	    ARGPOL(NR,NA) = ATAN2(B,A)*DEGREE
	    RADIUS        = RADIUS + DEL_RADIUS
	  ENDDO
	  ANG = ANG+DELANG
	ENDDO
C
	RETURN
	END

c###############################################################################
c
c
c	zminC
C	    Cartesian version of zmin 
c		if FMIN >0 - does a least squares fit of ln(F av)
c		 vs resln and then zeros the transform in resolution 
c		 rings taking the average value at each resolution from 
c		 the plot
c		if FMIN<0 - calculates the average F over the entire
c		 resolution range and zeros the transform point 
c		 if F < /FMIN/*average F
C		Unless the logical variable ZERO is set, the routine only
c		 determines the resolution dependent cutoff but does not
c		 zero the transform
c
c
c				LAST MODIFIED S.Fuller 18-juli-85
c		
c.............................................................................
c
	subroutine zminc(AT,BT,IRAD,MINR,MAXR,FMIN,FCUT)
c
	implicit none
	integer*4 NSAMPL,MINR,MAXR,IRAD
	integer*2 IPRINT1, IPRINT2
	COMMON /COMPR/ IPRINT1, IPRINT2
	real*4 AT((2*IRAD+1)*(IRAD+2)),BT((2*IRAD+1)*(IRAD+2))
	real*4 FAV(300),RESLN(300)
	real*4 FMIN,FCUT(300),RAD
	real*4 A,B,SIGA,SIGB,R,FZERO,FZEROA(300),FSUM
	integer*4 NTOT,INDEX,INDEXM
	integer*4 NZERO,NZEROA(300),I,J, IR, IX, IY, N(300)
	logical ZERO/.FALSE./
c
c............................................................................
c
	FSUM = 0.0
	NTOT = 0
C
	do IR=1,2*MAXR
	  FZEROA(IR)=0.0
	  N(IR)=0
	  FAV(IR)=0.0
	  RESLN(IR)=0.0
	end do
c
	do IX=0,MAXR
	  do IY=0,MAXR
	    RAD=sqrt(float(IX*IX+IY*IY))
	    IR=nint(RAD)
	    if( IR .ge. MINR .and. IR .le. MAXR) then
	      INDEX=IY*(2*IRAD+1)+(IRAD+1+IX)
	      INDEXM=INDEX-2*IX
	      A=sqrt(AT(INDEX)*AT(INDEX)+BT(INDEX)*BT(INDEX))
	      B=sqrt(AT(INDEXM)*AT(INDEXM)+BT(INDEXM)*BT(INDEXM))
	      FAV(IR)=FAV(IR)+A+B
	      N(IR)=N(IR)+2
	      RESLN(IR)=RESLN(IR)+2.0*RAD	
	    ENDIF
	  end do
	end do
c
	do IR=MINR,MAXR
	  if(N(IR).gt.0 .and. FAV(IR).gt.0.0) then
	    FSUM=FSUM+FAV(IR)
	    NTOT=NTOT+N(IR)
	    RESLN(IR)=RESLN(IR)/float(N(IR))
	    FAV(IR)=alog(FAV(IR)/float(N(IR)))
	  else 
	    FAV(IR) =0.0
	  ENDIF
	end do
c
	if(FMIN.gt.0.0) then
	  NSAMPL=MAXR-MINR+1
	  call linfit(RESLN(MINR),FAV(MINR),RESLN,NSAMPL,0,A,SIGA,B,SIGB,R)
Ca	  write(6,'('' linfit: A,SIGA,B,SIGB,R '',
CA	1	5(2x,g12.6))') A,SIGA,B,SIGB,R
	  print *,' linfit: A,SIGA,B,SIGB,R ',
	1	A,SIGA,B,SIGB,R

        ENDIF
c
	FSUM=FSUM/float(NTOT)
	NZERO=0
C
	do IR=MINR,MAXR
	  NZEROA(IR)=0	  
	  if(FMIN .gt. 0.0) then
	    FCUT(IR)=exp(RESLN(IR)*B+A)*FMIN
	  else if(FMIN .lt. 0.0) then
	    FCUT(IR)=FSUM*(-1.0*FMIN)
	  else 
	    FCUT(IR)=FSUM		
	  ENDIF
	end do
C
        if(IPRINT1.NE.1) return  ! Don't complete fraction zeroed calc if
				 !  IPRINT1 < 1
c
	do IX=0,MAXR
	  do IY=0,MAXR
	    RAD=sqrt(float(IX*IX+IY*IY))
	    IR=nint(RAD)
	    if( IR .ge. MINR .and. IR .le. MAXR) then
	      INDEX=IY*(2*IRAD+1)+(IRAD+1+IX)
	      INDEXM=INDEX-2*IX
	      A=sqrt(AT(INDEX)*AT(INDEX)+BT(INDEX)*BT(INDEX))
	      B=sqrt(AT(INDEXM)*AT(INDEXM)+BT(INDEXM)*BT(INDEXM))
	      if(A.lt.FCUT(IR))then
		if(ZERO) then
		  AT(INDEX)=0.0
		  BT(INDEX)=0.0
		ENDIF
		NZEROA(IR)=NZEROA(IR)+1
		NZERO=NZERO+1
	      ENDIF
	      if(B.lt.FCUT(IR))then
		if(ZERO) then
		  AT(INDEXM)=0.0
		  BT(INDEXM)=0.0
		ENDIF
		NZEROA(IR)=NZEROA(IR)+1
		NZERO=NZERO+1
	      ENDIF
	    ENDIF
	  end do
	end do
c
	do IR=MINR,MAXR
	  if(N(IR).gt.0) then
	    FZEROA(IR)=float(NZEROA(IR))/float(N(IR))
	    FAV(IR)=exp(FAV(IR))
	  else
	    FZEROA(IR)=0.0
	    RESLN(IR)=0.0
	    FAV(IR)=0.0
	  ENDIF
	  WRITE(6,'('' RADIUS #'',I3,
	1	'' RESLN '', F7.2,
	1	'' F AVG '',G9.4,
	1	'' F CUTOFF '',G9.4,
	1	'' # '',I5,
	1	'' # ZEROED '',I5
	1	'' % ZEROED '',F5.1)')
	1 IR,RESLN(IR),FAV(IR),FCUT(IR),N(IR),NZEROA(IR),FZEROA(IR)*100.0
	ENDDO
c
	FZERO=float(NZERO)/float(NTOT)
	write(6,'('' Total number of points '',i7,
	1	'' Total number zeroed '',i7,
	1	'' Total fraction zeroed '', g10.4)')NTOT,NZERO,FZERO	
c
	return
	end

c###############################################################################
c
c	zmin 
c		if FMIN >0 - does a least squares fit of ln(F av)
c		 vs resln and then zeros the transform in resolution 
c		 rings taking the average value at each resolution from 
c		 the plot
c		if FMIN<0 - calculates the average F over the entire
c		 resolution range and zeros the transform point 
c		 if F < /FMIN/*average F
c
c					S.Fuller
c		last modified dec-86
c..............................................................................
c
	SUBROUTINE ZMIN (FPOL, NSAMPL, NANG, MINR, MAXR, FMIN)
C
	IMPLICIT NONE
C
	INTEGER*4 NSAMPL,NANG,MINR,MAXR, MSAMPL
	PARAMETER (MSAMPL=300)
	real FPOL(NSAMPL,NANG), FAV(MSAMPL), RESLN(MSAMPL)
	real FMIN,FCUT, A, B, SIGA, SIGB, R, FZERO, FZEROA, FSUM
	integer NZERO,NZEROA,I,J
c..............................................................................
c
	if(NSAMPL.ge.MSAMPL) then
	  WRITE(6,'('' ZMIN:Dimension problem NSAMPL = '',I)') NSAMPL
	  RETURN
	ENDIF
C
	FSUM = 0.0
	DO I = 1,NSAMPL
	  FAV(I)   = 0.0
	  RESLN(I) = MINR+((I-1)*(MAXR-MINR))/float(NSAMPL-1)
	  DO J = 1,NANG
	    FAV(I) = FAV(I) + FPOL(I,J)
	    FSUM   = FSUM   + FPOL(I,J)
	  ENDDO
	  FAV(I) = alog(FAV(I)/float(NANG))
	ENDDO
c
	if(FMIN.gt.0.0) then
	  CALL LINFIT (RESLN,FAV,RESLN,NSAMPL,0,A,SIGA,B,SIGB,R)
	  WRITE(6,'('' LINFIT: A,SIGA,B,SIGB,R '',5(2X,G12.6))')
	1  A,SIGA,B,SIGB,R
	  WRITE(1,'('' LINFIT: A,SIGA,B,SIGB,R '',5(2X,G12.6))')
	1  A,SIGA,B,SIGB,R
        ENDIF
C
	FSUM  = FSUM/float(NSAMPL*NANG)
	NZERO = 0
C
C  dgm fixes mistake in split lines below  by specifying format statements
C
	WRITE(1,1001)
	WRITE(6,1001)
 1001   format(' RADIUS# TF PIXEL RADIUS     F AVG     F CUTOFF  ',
	1 '# ZEROED   % ZEROED',/,1X,66('-'))
C	WRITE(1,'('' RADIUS# TF PIXEL RADIUS     F AVG     F CUTOFF  '
C	1 '# ZEROED   % ZEROED'',/,1X,66(''-''))')
C	WRITE(6,'('' RADIUS# TF PIXEL RADIUS     F AVG     F CUTOFF  ',
C	1 '# ZEROED   % ZEROED'',/,1X,66(''-''))')
C
	DO I = 1,NSAMPL
	  NZEROA = 0	  
	  IF(FMIN.GT.0.0) THEN
	     FCUT = exp(RESLN(I)*B+A)*FMIN
	   ELSE IF (FMIN .LT. 0.0) THEN
	     FCUT = FSUM*(-1.0*FMIN)
	   ELSE 
	     FCUT = FSUM		
	  ENDIF
C
	  DO J = 1,NANG
	    IF(FCUT.GT.FPOL(I,J)) THEN
	      FPOL(I,J) = 0.0
	      NZEROA    = NZEROA + 1
	      NZERO     = NZERO + 1
	    ENDIF
	  ENDDO
	  FZEROA = FLOAT(NZEROA)/FLOAT(NANG)
	  FAV(I) = EXP(FAV(I))
	  WRITE(1,1000) I, RESLN(I), FAV(I), FCUT, NZEROA, FZEROA*100.0
	  WRITE(6,1000) I, RESLN(I), FAV(I), FCUT, NZEROA, FZEROA*100.0
	ENDDO
C
	FZERO = FLOAT(NZERO)/FLOAT(NANG*NSAMPL)
	WRITE(6,'('' Total number zeroed '',I7,
	1	''  Total fraction zeroed '', G10.4)') NZERO, FZERO
	WRITE(1,'('' Total number zeroed '',I7,
	1	''  Total fraction zeroed '', G10.4)') NZERO, FZERO
	FMIN = FZERO
C
	RETURN
 1000	FORMAT(I6,F12.2,F16.2,F12.2,I7,F13.1)
	END

C  *****************************************************************************
C  *									       *
C  *              *****     SUBROUTINE ICO_COMLIN_A     *****      	       *
C  *                                                     		       *
C  *	 FOR PAIRS OF COMMON LINES                 			       *
C  *                                                     		       *
C  *    SUBROUTINE CALLED BY SUBROUTINES RSYM, ICOFV_OMEAG1 AND ICOFV_OMEGA2   *
C  *     OF EMICOFV PROGRAM.                                                   *
C  *									       *
C  *	WARNING: This version OF ICO_COMLIN is not compatible with that used   *
C  *             by later segments of the program set !!!!!!!!!!	       *
C  *									       *
C  *    Routine was modified in June 1985 by S. Fuller to flag common lines    *
C  *     which are degenerate (IFLAG(K)) and to calculate a the minimum radius *
C  *     at which the pairs of common lines will be separated by 1 TRANSFORM   *
C  *     unit (RAD(K).                                                         *
C  *									       *
C  *	Codes for common lines:					               *
C  *									       *
C  *	IFLAG = 0 - the lines match none of these conditions.                  *
C  *									       *
C  *		1 - the two lines are superimposed (ang1 = ang2).	       *
C  *									       *
C  *		2 - the two lines are identical to an earlier pair.            *
C  *		    (i.e. ang1 = ang1' and ang2 = ang2'                        *
C  *									       *
C  *		3 - the two lines are equal to an earlier pair but in reversed *
C  *		    order (i.e. ang1 = ang2' and ang2 = ang1'		       *
C  *									       *
C  *		4 - the two lines are the Friedel of an earlier pair	       *
C  *		    (i.e. ang1 = ang2' + pi and ang2 = ang1' + pi 	       *
C  *		       or ang1 = ang1' + pi and ang2 = ang2' + pi	       *
C  *									       *
C  *		5 - the two lines are Friedel mates (ang1 = ang2 + pi)	       *
C  *									       *
C  *	***     6 - the two lines sum to pi (ang1 + ang2 = pi)                 *
C  *									       *
C  *	MODIFIED 16-juli-1985 by S. Fuller 			               *
C  *    MODIFIED to make the 1 and 4 flags match their definitions in the      *
C  *     comments.                                                             *
C  * 	MODIFIED 15-MAR-88 BY SDF                                              *
C  *    LAST MODIFIED  5-DEC-88 BY T. BAKER (DELETED FLAG #6; FIXED FLAG #4A,  *
C  *                 (PASS VALUE OF RADIAN TROUGH SUBROUTINE ARGUMENT LIST)    *
C  *****************************************************************************
C
	SUBROUTINE ICO_COMLIN_A (ROT,THETA,PHI,ALPHA1,ALPHA2,IFLAG,RAD,
	1 RADIAN)
C
	IMPLICIT NONE
C
	REAL*4    ROT(3,3,37), RADIAN, XX, PHI, THETA
	REAL*4    ALPHA1(37), ALPHA2(37), X(3), Y(3), VEC(3), X0(2)
	REAL*4	  RAD(37), TMP, DIFF, VV, TEST
	INTEGER*2 I, J, K, IFLAG(37)
C  ----------------------------------------------------------------------------
C
	X(1)   = SIND(THETA)*COSD(PHI)
	X(2)   = SIND(THETA)*SIND(PHI)
	X(3)   = COSD(THETA)
	XX     = SQRT(X(1)*X(1) + X(2)*X(2))
	X0(1)  = -X(2)/XX
	X0(2)  =  X(1)/XX
C
	DO 200 K = 1,37
	  RAD(K)   = 1000.0
	  IFLAG(K) =    0
C
	  DO I = 1,3
	    Y(I) = 0.0
	    DO J = 1,3
	      Y(I) = Y(I) + ROT(I,J,K)*X(J)
	    ENDDO
	  ENDDO
C
	  VEC(1) = X(2)*Y(3) - X(3)*Y(2)
	  VEC(2) = X(3)*Y(1) - X(1)*Y(3)
	  VEC(3) = X(1)*Y(2) - X(2)*Y(1)
	  VV     = SQRT(VEC(1)*VEC(1) + VEC(2)*VEC(2) + VEC(3)*VEC(3))
	  IF(VV.LT.0.1)  THEN
	    IFLAG(K) = 1
	    GO TO 200
	  ENDIF
C
	  DO I = 1,3
	    VEC(I) = VEC(I)/VV
	  ENDDO
C
	  DO I = 1,3
	    Y(I) = 0.0
	    DO J = 1,3
	      Y(I) = Y(I) + ROT(J,I,K)*VEC(J)
	    ENDDO
	  ENDDO
C
	  TMP = X0(1)*VEC(1) + X0(2)*VEC(2)
	  IF(TMP.LT.-1.0) TMP = -1.0
	  IF(TMP.GT.1.0)  TMP =  1.0
	  ALPHA1(K) = ACOS(TMP)/RADIAN
	  TMP       = X0(1)*Y(1) + X0(2)*Y(2)
	  IF(TMP.LT.-1.0) TMP = -1.0
	  IF(TMP.GT.1.0)  TMP =  1.0
	  ALPHA2(K) = ACOS(TMP)/RADIAN
	  IF(VEC(3).LT.0.) ALPHA1(K) = 360.-ALPHA1(K)
	  IF(Y(3).LT.0.)   ALPHA2(K) = 360.-ALPHA2(K)
	  DIFF = ABS(ALPHA1(K)-ALPHA2(K))
	  IF(DIFF.GT.180.) DIFF = 360.-DIFF
	  RAD(K) = 2.0*SIND(DIFF/2.0)
	  IF(RAD(K).GT.1.0e-6) then
	     RAD(K) = AMAX1(1.0E-8,1.0/RAD(K))
	   ELSE
	     RAD(K) = 1000.0
	  ENDIF
C         ******************************************
C---------*  IFLAG = 1: TEST IF ALPHA1 = ALPHA2    *
C         ******************************************
	  IF(ALPHA1(K).EQ.ALPHA2(K)) THEN
	    IFLAG(K) = 1
	    RAD(K)   = 1000.0
	 ENDIF
  200 	CONTINUE
C
C  ************************************************************************
C  *    CHECK FOR IDENTICAL PAIRS OF COMMON LINES                         *
C  *                                                                      *
C  *    IFLAG = 2: THE TWO LINES ARE IDENTICAL TO ANOTHER PAIR.           *
C  *               ALPHA1(K) = ALHPA1(J) AND ALPHA2(K) = ALPHA2(J)        *
C  *                                                                      *
C  *    IFLAG = 3: THE TWO LINES ARE IDENTICAL TO ANOTHER PAIR, BUT IN    *
C  *               REVERSED ORDER                                         *
C  *               ALPHA1(K) = ALHPA2(J) AND ALPHA2(K) = ALPHA1(J)        *
C  ************************************************************************
	DO K = 1,36
	  IF(IFLAG(K).EQ.0) THEN
	    DO J = K+1,37
	      IF(IFLAG(J).EQ.0) THEN
	        TEST = ABS(ALPHA1(K)-ALPHA1(J))
	        IF(TEST.LE.0.1) THEN
	          TEST = ABS(ALPHA2(K)-ALPHA2(J))
	          IF(TEST.LE.0.1) THEN
	            IFLAG(J) = 2
	          ENDIF
	        ENDIF
	      ENDIF
	    ENDDO
	  ENDIF
	ENDDO
	DO K = 1,36
	  IF(IFLAG(K).EQ.0) THEN
	    DO J = K+1,37
	      IF(IFLAG(J).EQ.0) THEN
	        TEST = ABS(ALPHA1(K)-ALPHA2(J))
	        IF(TEST.LE.0.1) THEN
	          TEST = ABS(ALPHA2(K)-ALPHA1(J))
	          IF(TEST.LE.0.1) THEN
	            IFLAG(J) = 3
	          ENDIF
	        ENDIF
	      ENDIF
	    ENDDO
	  ENDIF
	ENDDO
C  ***************************************************************************
C  *    CHECK FOR ONE PAIR BEING THE FRIEDEL MATE OF ANOTHER PAIR            *
C  *                                                                         *
C  *    IFLAG = 4: THE TWO LINES ARE THE FRIEDEL OF ANOTHER PAIR.            *
C  *               ALPHA1(K) = ALPHA1(J) + PI AND ALPHA2(K) = ALPHA2(J) + PI *
C  *            OR ALPHA1(K) = ALPHA2(J) + PI AND ALPHA2(K) = ALPHA1(J) + PI *
C  ***************************************************************************
	DO K = 1,36
	  IF(IFLAG(K).EQ.0) THEN
	    DO J = K+1,37
	      IF(IFLAG(J).EQ.0) THEN
	        TEST = ABS( ABS(ALPHA1(K)-ALPHA1(J))-180.0)
		IF(TEST.LE.0.1) THEN
		  TEST = ABS( ABS(ALPHA2(K)-ALPHA2(J))-180.0)
		  IF(TEST.LE.0.1) IFLAG(J) = 4
	        ENDIF
		TEST = ABS( ABS(ALPHA1(K)-ALPHA2(J))-180.0)
		IF(TEST.LE.0.1) THEN
		  TEST = ABS( ABS(ALPHA2(K)-ALPHA1(J))-180.0)
		  IF(TEST.LE.0.1) IFLAG(J) = 4
	        ENDIF
	      ENDIF
	    ENDDO
	  ENDIF
	ENDDO
C
	DO K = 1,37
	  IF(IFLAG(K).EQ.0) THEN
C           ****************************************************
C-----------*    TEST FOR TWO LINES THAT ARE FRIDEL RELATED    *
C           *    IFLAG = 5: ABS(ALPHA1(K)-ALPHA2(K))=180       *
C           ****************************************************
	    TEST = ABS( ABS(ALPHA1(K)-ALPHA2(K))-180.0 )
	    IF(TEST.LE.0.1) IFLAG(K) = 5
C           ****************************************************
C-----------*    TEST FOR TWO LINES THAT ADD TO 180 DEGREES    *
C           *    IFLAG = 6: ABS(ALPHA1(K)+ALPHA2(K))=180       *
C           ****************************************************
C  ***************************************************************
C  *    I DON'T BELIEVE THIS IS AN ALLOWED TEST: TSB 5/DEC/88    *
C  ***************************************************************
C	    TEST = ABS( ABS(ALPHA1(K)+ALPHA2(K))-180.0 )
C	    IF(TEST.LE.0.1) IFLAG(K) = 6
	  ENDIF
	ENDDO
C
	RETURN
	END

C  ****************************************************************************
C! PCHISQ: calling routine for prob chisqr from chiprob
c
c
C	Returns values for prob of REDUCED chisqr.
c
c	When prob chisqr .lt. 1e-8 for NFREE odd use the average of
c	   the even chisqr's on either side. This happens for chisqr
c	   greater than 35.
c
c		sdf 3-nov-87
c................................................................
	subroutine pchisq(RED_CHISQR,NFREE,PROB,IPROB)
C
	implicit none
	real*4	RED_CHISQR,CHISQR,PROB,IPROB, chiprob
	integer	NFREE
C............................................................
	CHISQR=RED_CHISQR*NFREE
	if(mod(NFREE,2).eq.0 .or. CHISQR.lt.35 .or. NFREE.le.2) then
	    PROB = chiprob(CHISQR,NFREE)
	else
	    PROB = (chiprob(CHISQR,NFREE-1)+chiprob(CHISQR,NFREE+1))/2.0
	ENDIF
	IPROB = 1.0 - PROB
	return
	end

C  ****************************************************************************
C ! CHIPROB: returns the probability that chisqr exceeds X for NFREE 
c	degrees of freedom
c
c		The routine uses a recursion formula
c
c		P(chisq>x,nfree) = P(chisqr>X,nfree-2) +
c
c						 (nfree-1)/2
c					(chisqr/2)          * exp(-x/2)
c					_____________________________
c						gamma(nfree/2)
c
c		and the facts that
c
c			P(chisqr>x,2) = exp(-x/2)
c
c			P(chisqr>x,1) = 2*normal(-sqrt(x))
c
c		to set up a iterative calculation.
c
c		The procedure calls the real*8 function normal
c
c		Routine was translated from the Alogol 60 routine in
c		  CACM algorithm 299.
c
c			--- sdf 2-nov-87
c.....................................................................
c
c
	function chiprob(X_VAL,NFREE)
C
	implicit none
	real*4 X_VAL, chiprob
	real*8 Z, C, E, A, Y, S, X
	logical EVEN, BIGX
	integer NFREE
	real*8 NORMAL

C............................................................................

	if(X_VAL.lt.0.0 .or. NFREE.lt.1) then
	    write(6,*) ' chiprob: values of X and NFREE out of bounds ' 
	    write(6,*) ' X = ', X_VAL, ' NFREE = ', NFREE
	    CHIPROB = 0.0
	    return
	ENDIF
	if(X_VAL.eq.0.0) then
	    CHIPROB = 1.0
	    return
	ENDIF

	X = 1.0d0 * X_VAL

	A = 0.5d0 * X

	EVEN = (mod(NFREE,2).eq.0)

	BIGX = (A.gt.(25*0.693147180) )	
c-----------------	limit for accurate val of exp(-a)

	if( (EVEN .or. NFREE.gt.2) .and. .not.BIGX) then
	    Y = exp(-A)
	ENDIF
	if(EVEN) then
	    S = Y
	else
	    S = 2.0d0*normal(-sqrt(X))
	    if (S.eq.0.0d0 .and. NFREE.gt.2 ) then
		 S = 2.d0*exp(-A)
	    ENDIF
c---------------	use the even function value as estimate when the 
c--------------			normal routine returns 0			
	ENDIF

	if (NFREE.gt.2) then
	    X = 0.5d0*(NFREE-1.0)
	    if (EVEN) then
	 	Z = 1.0d0
	    else
		Z = 0.5d0
	    ENDIF
	    if (BIGX) then
		if(EVEN) then
		    E = 0.0
		else 
		    E = 0.572364942925  
c--------------------		 value of ln(sqrt(pi))
		ENDIF
		C = log(A)
		do while (Z.le.(X*1.0001) )
		    E = log(Z)+E
		    S = exp(C*Z-A-E) + S
		    Z = Z + 1.0d0
		end do
		CHIPROB = S
	    else
		if(EVEN) then
		    E = 1.0d0
		else
		    E = 0.564189583548/sqrt(A) 
c---------------------			value of  1/sqrt(pi)
		ENDIF
		C = 0.0d0
		do while (Z.le.(X*1.0001) )
		    E = E*A/Z
		    C = C+E
		    Z = Z + 1.0d0
		end do
		CHIPROB = C*Y+S
	    ENDIF
	else
	    CHIPROB = S
	ENDIF
	return

	end

C! NORMAL: real*8 calculation of integral of normal distribution
C
C	Calculates the value of:
c
c				  x
c				/
c		(1/sqrt(2*pi)) (  exp(-u**2/2)du
c				)
c			       /
c			       -oo
c
c		by means of a series expansion developed by A.M. Murray 
c		 of Aberdeen Univ. The routine is translated from the 
c		 Algol 60 of CACM algorithm # 209 and is preferred for
c		 speed. The routine is accurate to 7 decimal places but
c		 sets values above 6.0 to 1.0 and below -6.0 to 0.0.
c
c
c			sdf 2-nov-87
c
c...................................................................


	function NORMAL(X)
	implicit none
	real*8 X, NORMAL, Z, Y, W	
	if(X.eq.0.0) then
	    Z=0.0
	else
	    Y=abs(X)/2.0
	if(Y.ge.3.0) then
		Z=1.0
	else if(Y.lt.1.0) then
		W = Y*Y
		Z = ((((((((0.000124818987 * W
	1		-0.001075204047) * W + 0.005198775019 ) * W
	2		-0.019198292004) * W + 0.059054035642 ) * W
	3		-0.151968751364) * W + 0.319152932694 ) * W
	4		-0.531923007300) * W + 0.797884560593 ) * Y * 2.0
	else
		Y = Y-2.0
		Z = (((((((((((((-0.000045255659 * Y
	1	+0.000152529290) * Y -0.000019538132) * Y
	2	-0.000676904986) * Y +0.001390604284) * Y
	3	-0.000794620820) * Y -0.002034254874) * Y
	4	+0.006549791214) * Y -0.010557625006) * Y
	5	+0.011630447319) * Y -0.009279453341) * Y
	6	+0.005353579108) * Y -0.002141268741) * Y
	7	+0.000535310849) * Y +0.999936657524
	   ENDIF
	ENDIF
	if(X.gt.0.0) then
	   NORMAL = (Z+1.0)/2.0
	else
	   NORMAL = (1.0-Z)/2.0
	ENDIF
	return
	end

c##############################################################################
c
c	subroutine linfit
c
c	least squares fit to straight line
c
c
c	X 	-array of points for indep variable
c	Y 	-array of points for dep variable
c	SIGMAY  -array of standard deviations for Y data points
c	NPTS	-number of pairs of dat points
c	MODE	-determines method of weighting least squares
c		+1 (instrumental) WEIGHT(I)=1./SIGMAY(I)**2
c		 0 (no weighting) WEIGHT(I)=1.0
c		-1 (statistical)  WEIGHT(I)=1.0/Y(I)
c	A	-y intercept of fitted straight line
c	SIGMAA	-slope of fitted straight line
c	B	-slope of fitted straight line
c	SIGMAB	-standard deviation of B
c	R	-linear correlation coefficient
c
c
c					S.Fuller
c
c............................................................................
c
	subroutine linfit(X,Y,SIGMAY,NPTS,MODE,A,SIGMAA,B,SIGMAB,R)
c
	implicit none
	integer*2 NPTS,MODE,I,NWGT
	real*4	X(NPTS),Y(NPTS),SIGMAY(NPTS),SIGMAA,SIGMAB,A,B,R
	real*4 SUM,SUMX,SUMY,SUMX2,SUMXY,SUMY2
	real*4 WEIGHT,DELTA,VARNCE,AVGWGT
	logical WGTSUM 
c
c.............................................................................
c
	WGTSUM=.false.
	AVGWGT=0.0
	NWGT=0
	SUM=0.0
	SUMX=0.0
	SUMY=0.0
	SUMX2=0.0
	SUMXY=0.0
	SUMY2=0.0
c
C	if MODE is +1 (SIMGAY weighting) or -1 (Y weighting)
c	     , find average value of weight so that zeros
c		in the array can be filled
c
	if (MODE .eq. +1) then
	  do I=1,NPTS
	    if (SIGMAY(I) .eq. 0.0) then
	      WGTSUM=.true.
	    else 
	      AVGWGT=AVGWGT+1.0/(SIGMAY(I)*SIGMAY(I))
	      NWGT=NWGT+1
	    ENDIF
	  end do
c
c	if the SIGMAY array contains 0's replace them with the average 
c	  value of SIGMAY
c
	  if (WGTSUM) then
	    if(NWGT .gt. 0) then
	      AVGWGT=AVGWGT/NWGT
	    else
	      AVGWGT=1.0
	    ENDIF
	  ENDIF
	ENDIF
c
c
	if (MODE .le. -1) then
	  do I=1,NPTS
	    if (Y(I) .eq. 0.0) then
	      WGTSUM=.true.
	    else 
	      AVGWGT=AVGWGT+1.0/abs(Y(I))
	      NWGT=NWGT+1
	    ENDIF
	  end do
c
c	if the Y array contains 0's replace them with the average 
c	  value of weight
c
	  if (WGTSUM) then
	    if(NWGT .gt. 0) then
	      AVGWGT=AVGWGT/NWGT
	    else
	      AVGWGT=1.0
	    ENDIF
	  ENDIF
	ENDIF
c
	do I=1,NPTS
	  if( MODE .le. -1) then
	    if ( Y(I) .ne. 0.0) then
	      WEIGHT=1.0/abs(Y(I))
	    else 
	      WEIGHT=AVGWGT
	    ENDIF
	  else if (MODE .ge. +1) then
	    if ( SIGMAY(I) .ne. 0.0) then
	      WEIGHT=1.0/(SIGMAY(I)*SIGMAY(I))
	    else 
	      WEIGHT=AVGWGT
	    ENDIF
	  else
	    WEIGHT=1.0
	  ENDIF
c
	  SUM = SUM + WEIGHT
	  SUMX =  SUMX + WEIGHT*X(I)	
	  SUMY =  SUMY + WEIGHT*Y(I)	
	  SUMX2 =  SUMX2 + WEIGHT*X(I)*X(I)	
	  SUMXY =  SUMXY + WEIGHT*X(I)*Y(I)	
	  SUMY2 =  SUMY2 + WEIGHT*Y(I)*Y(I)
	end do
c
c
c	Calculate coefficients and standard deviations
c
c
	DELTA = SUM*SUMX2 - SUMX*SUMX
	A = ( SUMX2*SUMY - SUMX*SUMXY)/DELTA
	B = ( SUMXY*SUM - SUMX*SUMY )/DELTA
	if ( MODE .eq. 0) then
	  VARNCE = (SUMY2 + A*A*SUM + B*B*SUMX2 -2.*
     1	   (A*SUMY + B*SUMXY - A*B*SUMX))/float(NPTS-2)
	else
	  VARNCE = 1.0	
	ENDIF
c
	SIGMAA = sqrt(VARNCE*SUMX2 / DELTA)
	SIGMAB = sqrt(VARNCE*SUM / DELTA)
	R = (SUM*SUMXY - SUMX*SUMY)/
     1	  sqrt( DELTA*(SUM*SUMY2 - SUMY*SUMY))
c
	return
	end
