

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include "common.h"

int get_float_(float *inFloat)
{/* GET_FLOAT */
  char inStr[128];

  fscanf(stdin,"%s",inStr);
  *inFloat = (float)strtod(inStr,0);

}/* GET_FLOAT */



int get_int_(int *inInt)
{/* GET_INT */
  char inStr[128];

  fscanf(stdin,"%s",inStr);
  *inInt = (int)strtod(inStr,0);

}/* GET_INT */




int emprint_(char *inStr, ...)
{/* EMPRINT */
#define MAX_EMPRINT 32
  int i,j,numFormats,numTexts,textFirst,thisText,thisFormat;
  int toggleThis,lngth;
  void *args[MAX_EMPRINT];
  char *argFormats[MAX_EMPRINT];
  char *text[MAX_EMPRINT];
  char *s1,*s2,*s3;
  char printStr[512];
  char formatStr[128];
  char argType[MAX_EMPRINT];
  char outStr[2048];
  va_list ap;

  /* We've got to first check to see if things like DEC UNIX
   * has converted our \n and \0 characters into strings like
   * "\n" and "\0"
   */
  sprintf(outStr,"%s",inStr);  /* Let's just work with our own copy here... */
  lngth = strlen(outStr);
  for(i=0;i<lngth-1;i++)
    {/* Search all */
      if((outStr[i] == '\\') && (outStr[i+1]=='n'))
	{/* We've got to replace it */
	  outStr[i] = '\n';
	  for(j=i+1;j<lngth;j++) 
	    outStr[j] = outStr[j+1];
	  lngth --;
	}/* We've got to replace it */
      else if((outStr[i] == '\\') && (outStr[i+1]=='0'))
	{/* We've got to replace it */
	  outStr[i] = '\0';
	  for(j=i+1;j<lngth;j++) 
	    outStr[j] = outStr[j+1];
	  lngth --;
	}/* We've got to replace it */
      else if((outStr[i] == '\\') && (outStr[i+1]=='t'))
	{/* We've got to replace it */
	  outStr[i] = '\t';
	  for(j=i+1;j<lngth;j++) 
	    outStr[j] = outStr[j+1];
	  lngth --;
	}/* We've got to replace it */
      else if((outStr[i] == '\\') && (outStr[i+1]=='r'))
	{/* We've got to replace it */
	  outStr[i] = '\r';
	  for(j=i+1;j<lngth;j++) 
	    outStr[j] = outStr[j+1];
	  lngth --;
	}/* We've got to replace it */
    }/* Search all */

  for(i=0;i<MAX_EMPRINT;i++)
    {/* allocate */
      argFormats[i] = (char *)malloc(sizeof(char)*16);
      text[i]       = (char *)malloc(sizeof(char)*128);
    }/* allocate */

  va_start(ap, inStr);

  s1 = outStr;
  numFormats = numTexts = 0;
  s2 = text[numTexts];
  s3 = argFormats[numFormats];
  textFirst = TRUE;  /* always */
  while(*s1)
    {/* while */

      if(*s1 == '%')
	{/* Start of an argFormat */
	  /* First end the current text */
	  *s2 = '\0';
	  numTexts++;
	  s2 = text[numTexts];
	  while(*s1 != 'd' && *s1 != 'f')
	    {/* DO all */
	      *s3 = *s1;
	      s3++;
	      s1++;		
	    }/* DO all */
	  if(*s1=='d' || *s1=='D')
	    argType[numFormats] = 'd';
	  else if(*s1=='f' || *s1=='F')
	    argType[numFormats] = 'f';
	  *s3 = *s1;
	  s3++;
	  *s3 = '\0';
	  numFormats++;
	  s3 = argFormats[numFormats];
	}/* Start of an argFormat */
      else
	{/* More text */
	  *s2 = *s1;
	  s2++;
	}/* More text */

      s1++;

    }/* while */
  /* End the last text */
  *s2 = '\0';
  numTexts++;

  thisText = thisFormat = 0;
  if(textFirst)
    toggleThis = 0;
  else toggleThis = 1;
  sprintf(printStr,"");
  while(thisText < numTexts ||
	thisFormat < numFormats)
    {/* Build them all */
      if(toggleThis == 0)
	{/* text */
	  sprintf(printStr,"%s%s",printStr,text[thisText]);
	  thisText++;
	}/* text */
      else
	{/* format */
	  if(argType[thisFormat]=='d')
	    sprintf(formatStr,argFormats[thisFormat],
		    *(va_arg(ap, int *)));
	  else
	    sprintf(formatStr,argFormats[thisFormat],
		    *(va_arg(ap, float *)));
	  sprintf(printStr,"%s%s",printStr,formatStr);
	  thisFormat++;
	}/* format */
      toggleThis = !toggleThis;
    }/* Build them all */

  printf(printStr);
  fflush(stdout);

  va_end(ap);


  for(i=0;i<MAX_EMPRINT;i++)
    {/* free */
      free(argFormats[i]);
      free(text[i]);
    }/* free */


}/* EMPRINT */


