
#include "../libr/libPIF.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>


typedef struct __imgHead_t__
  {/* IMAGEHEAD_T */
    int    header;
    int    image;
  }/* IMAGEHEAD_T */ imgHead_t;

pifHead_t pifHead;



int main(int argc, char **argv)
{/* MAIN */
  int       i,j,k,l,m,n,binCols,binRows;
  fString_t fName,readWrite,descStr;
  int       luNum,binFactor, binSwitch;
  int       img_bkg;
  imgHead_t imageOffsets[532];
  int       nimg, htype, numCols, numRows, numSecs,
            mode, endianNess, img_min, img_max, imgOffset;
  float     floatScaleFactor, recipFloatScaleFactor, 
            img_avg, img_std, junkFloat;
  char      versionStr[55];
  char      descriptionStr[128];
  char      timeStr[128];
  char      micrographStr[128];
  char      scanNumberStr[128];
  BYTE      *b_buffer[500],*thisB;
  short     *short_buffer[500],*thisS;
  float     aoverb, map_abang, a_cell,b_cell, c_cell, 
            alp, bet, gam, dela, delb, delc;
  int       t_matrix[6];
  int       convTsb


  binFactor = 0;

  fName.addr = (char *)malloc(sizeof(char)*64);
  /*  sprintf(fName.addr,"brant.pif"); */
  /* sprintf(fName.addr,"justem3:[scratch.rwa]480-raw.pif");  */
  sprintf(fName.addr,"justem3:[scratch.rwa]1856.pif");  
printf("After[%s]\n",fName.addr);
  descStr.addr = (char *)malloc(sizeof(char)*81);
printf("DE[%s]\n",descStr.addr);
  readWrite.addr = (char *)malloc(sizeof(char)*4);
  sprintf(readWrite.addr,"r");
printf("RW[%s]\n",readWrite.addr);

  luNum = 7;
#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open(fName.addr, &luNum, readWrite.addr);
#endif

  if(!pif_read_header_(&luNum,
		       &nimg, 
		       &recipFloatScaleFactor,
		       &htype, &numCols, &numRows, &numSecs,
		       &mode, &endianNess, versionStr))
    {/* Error */
      printf("Trouble reading header [%s].\n",fName.addr);
      exit(0);
    }/* Error */

  for(i=0;i<1;i++)
    {/* Read all headers */
      int thisI;
      thisI = i + 1;  /* For fortran */
      pif_read_data_header_(&luNum, &thisI,
			    &recipFloatScaleFactor,
			    &img_bkg, &img_min, &img_max,
			    &img_avg, &img_std,
			    &numCols, &numRows, &numSecs,
			    &imgOffset, &mode, &htype, 
			    descStr.addr,
			    &aoverb, &map_abang, &map_scalef, &a_cell, 
			    &b_cell, &c_cell, &alp, &bet, &gam, 
			    &dela, &delb, &delc, t_matrix);

      imageOffsets[i].header= imgOffset;
      printf("ncol[%d]nrow[%d]nsec[%d]\n",numCols,numRows,numSecs);
      if(binFactor==2)
	{/* bin it */
	  binCols = numCols / 2 + 1;
	  binRows = numRows / 2 + 1;
	  if((binCols % 2)==0)        /* Must be ODD */
	    binCols -= 1;
	  if((binRows % 2)==0)
	    binRows -= 1;
	  b_buffer[i]  = (BYTE *)malloc(sizeof(BYTE)*
					   (binCols)*(binRows));
	  short_buffer[i] = (short *)malloc(sizeof(short)*
					    (binCols)*(binRows));
	}/* bin it */
      else
	{/* DON'T bin it */
	  b_buffer[i]  = (BYTE *)malloc(sizeof(BYTE)*
					   (numCols*numRows*numSecs));
	  short_buffer[i] = (short *)malloc(sizeof(short)*
					    (numCols*numRows*numSecs));
	}/* DON'T bin it */

      if(binFactor==2)
	binSwitch = -2;   /* Let's do sample average */
      else binSwitch = 0;

printf("imgOffset[%d]\n",imgOffset);
      convTsb = 0;
      binSwitch = 0;
      pif_read_map_short_image_(luNum, %val(float_buffer),
				imgOffset,
				numCols, numRows, numSecs, 
				convTsb,
				recipFloatScaleFactor,
				minMap, maxMap, binSwitch)
        
      imageOffsets[i].image= imgOffset;

    }/* Read all headers */

  pif_close_(&luNum);
  free(fName.addr);

  fName.addr = (char *)malloc(sizeof(char)*64);
  sprintf(fName.addr,"rob.pif");
  sprintf(readWrite.addr,"w");

  if(binFactor==2)
    {/* Binned */
      if(binSwitch == -2)
	{/* DO sampled average */
	  numCols = (numCols / 2)+1;
	  numRows = (numRows / 2)+1;
	  numSecs = (numSecs / 2)+1;
	  if(numSecs==0)
	    numSecs = 1;
	  /* They must be ODD here */
	  if((numCols % 2 )==0)
	    numCols --;
	  if((numRows % 2 )==0)
	    numRows --;
	  if((numSecs % 2 )==0)
	    numSecs --;
	}/* DO sampled average */
      else
	{/* Normal */
	  numCols /= 2;
	  numRows /= 2;
	  numSecs /= 2;
	  if(numSecs==0)
	    numSecs = 1;
	}/* Normal */
    }/* Binned */

#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open_(fName.addr, &luNum, readWrite.addr);
#endif

  floatScaleFactor = 1.0 / recipFloatScaleFactor;

  printf("Write ncol[%d]nrow[%d]nsec[%d]\n",numCols,numRows,numSecs);
  pif_write_header_(&luNum,
		    &nimg, &floatScaleFactor,
		    &recipFloatScaleFactor,
		    &htype, &numCols, &numRows, &numSecs,
		    &mode, &endianNess, versionStr);


  for(i=0;i<nimg;i++)
    {/* Read all headers */
      sprintf(descriptionStr,"Desc [%d]",i);
      sprintf(timeStr,"Time [%d]",i);
      sprintf(micrographStr,"Micro [%d]",i);
      sprintf(scanNumberStr,"Scan [%d]",i);
      imgOffset = imageOffsets[i].header;
      if(binFactor != 1)
	imgOffset = 512 + (512*i)+(i*numCols*numRows);
      printf("Write IH ncol[%d]nrow[%d]nsec[%d]\n",numCols,numRows,numSecs);
      pif_write_image_header_(&luNum, &i,
			      &floatScaleFactor,
			      &img_bkg, &img_min, &img_max,
			      &img_avg, &img_std,
			      &numCols, &numRows, &numSecs,
			      &imgOffset, &mode,
			      descriptionStr,timeStr,micrographStr,
			      scanNumberStr);
      imgOffset = imageOffsets[i].image;
      if(binFactor != 1)
	imgOffset = 512 + (512*i)+(i*numCols*numRows) + 512;
      thisB = b_buffer[i];
      thisS = short_buffer[i];
      for(k=0;k<numSecs;k++)
	for(l=0;l<numRows;l++)
	  for(m=0;m<numCols;m++)
	    {/* Do all */
	      thisB[(k*numCols*numRows)+(l*numCols)+m] = 
		(BYTE)thisS[(k*numCols*numRows)+(l*numCols)+m] ;
	    }/* Do all */
      pif_write_byte_image_(&luNum, thisB,
			    &imgOffset,
			    &numCols, &numRows, &numSecs);
      
    }/* Read all headers */

  pif_close_(&luNum);
  free(fName.addr);


}/* MAIN */
