

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <strings.h>
#include <string.h>

#define FALSE 0 
#define TRUE  1

main(int argc, char **argv)
{/* MAIN */
  int i,l;
  char filename[245],root[245],ans[245],
       sysCall[245],queue[245],fileStr[256];
  int symmetry,numParticles,beginParticle,endParticle,done;
  float rangeX,rangeY,step,centerX,centerY;
  float searchArea,searchStep,fftStep;
  int numAnnulli,radius,refineSwitch, submitSwitch,firstTime;
  FILE *fOut;

  refineSwitch= submitSwitch = FALSE;
  firstTime= TRUE;

  printf("Automatically submit batch jobs here? (1==Yes 0==NO) :");
  fflush(stdout);
  gets(ans);
  if(ans[0]=='1')
    submitSwitch=TRUE;


  printf("Run in (R)efinement mode or Search? (R or [S]) :");
  fflush(stdout);
  gets(ans);
  if(ans[0]=='R' || ans[0]=='r')
    refineSwitch=TRUE;


  printf("Queue name: ");
  fflush(stdout);
  gets(queue);
  if(strcmp(queue,"")==0)
    sprintf(queue,"justem_batch");

  printf("Batch job root Filename: ");
  fflush(stdout);
  gets(root);
  printf("PCK Filename Path [Dev:[dir]myfile.pck]: ");
  fflush(stdout);
  gets(filename);
  printf("Symmetry: ");
  fflush(stdout);
  fscanf(stdin,"%d",&symmetry);

  if(!refineSwitch)
    {/* Do search */
      printf("BeginParticle: ");
      fflush(stdout);
      fscanf(stdin,"%d",&beginParticle);
      printf("EndParticle: ");
      fflush(stdout);
      fscanf(stdin,"%d",&endParticle);
      printf("Center of X search area: ");
      fflush(stdout);
      fscanf(stdin,"%f",&centerX);
      printf("Center of Y search area: ");
      fflush(stdout);
      fscanf(stdin,"%f",&centerY);
    }/* Do search */
  
  printf("Range of X: ");
  fflush(stdout);
  fscanf(stdin,"%f",&rangeX);
  printf("Range of Y: ");
  fflush(stdout);
  fscanf(stdin,"%f",&rangeY);
  printf("Step : ");
  fflush(stdout);
  fscanf(stdin,"%f",&step);
  printf("Num Annulli: ");
  fflush(stdout);
  fscanf(stdin,"%d",&numAnnulli);
  printf("FFT step: ");
  fflush(stdout);
  fscanf(stdin,"%f",&fftStep);
  printf("Radius: ");
  fflush(stdout);
  fscanf(stdin,"%d",&radius);

  printf("root,filename,symm,beg,end,cenx,ceny,rngx,rngy,step,nannu,ffts,rad=\n\
%s %s %d %d %d %f %f %f %f %f %d %f %d\n",
	 root,filename,symmetry,beginParticle,endParticle,
	 centerX,centerY,rangeX,rangeY,step,numAnnulli,
	 fftStep,radius);

  done = FALSE;
  while(!done)
    {/* Do Until done */
      if(refineSwitch)
	{/* Get particle wanted */
	  printf("Particle Number: ");
	  fflush(stdout);
	  fscanf(stdin,"%d",&beginParticle);
	  if(beginParticle==0)
	    exit(0);
	  endParticle= beginParticle;
	  printf("Center of X search area: ");
	  fflush(stdout);
	  fscanf(stdin,"%f",&centerX);
	  printf("Center of Y search area: ");
	  fflush(stdout);
	  fscanf(stdin,"%f",&centerY);
	}/* Get particle wanted */
      
      for(i=beginParticle;i<=endParticle;i++)
	{/* Do all particles */
	  float beginStepX,endStepX,beginStepY,endStepY,j,k;
	  
	  sprintf(fileStr,"%s_%04d.bch",root,i);
	  fOut= fopen(fileStr,"w");
	  if(fOut==NULL)
	    {/* error */
	      printf("Cannot open [%s]\n",fileStr);
	      exit(0);
	    }/* error */
	  
	  beginStepX = centerX - rangeX;
	  endStepX   = centerX + rangeX;
	  beginStepY = centerY - rangeY;
	  endStepY   = centerY + rangeY;
	  for(j=beginStepX;j<=endStepX;j+=step)
	    {/* Do all steps in the rangeX */
	      for(k=beginStepY;k<=endStepY;k+=step)
		{/* do the Y */
		  fprintf(fOut,"$!---------------------------------------\n");
		  fprintf(fOut,"$! Starting permutation X[%f]Y[%f]\n",j,k);
		  fprintf(fOut,"$ run em$:emrotflt\n");
		  fprintf(fOut,"%s\n",filename);
		  fprintf(fOut,"%d\n",i);   /* particle number */
		  fprintf(fOut,"%d,%d,%f\n",symmetry,numAnnulli,fftStep);
		  fprintf(fOut,"%d\n",radius);
		  fprintf(fOut,"0,0,0,1\n");
		  fprintf(fOut,"%f,%f\n",j,k);
		  fprintf(fOut,"\n");
		  fprintf(fOut,"\n");
		  fprintf(fOut,
			  "$ write sys$output \"***************************************\"\n");
		  fprintf(fOut,
			  "$ write sys$output \"* We've just done particle [%d]       *\"\n",i);
		  fprintf(fOut,
			  "$ write sys$output \"* With x==[%f]  y==[%f]               *\"\n",j,k);
		  fprintf(fOut,
			  "$ write sys$output \"***************************************\"\n");
		  fprintf(fOut,"$ wait\n");
		  fprintf(fOut,"$!---------------------------------------\n");
		  
		}/* do the Y */
	    }/* Do all steps in the rangeX */
	  
	  fclose(fOut);
	  
	  if(submitSwitch)
	    {/* Get it cooking */
	      sprintf(sysCall,"submit /queue=%s %s",queue,fileStr);
	      printf("%s\n",sysCall);
	      system(sysCall); 
	      firstTime= FALSE;
	    }/* Get it cooking */
	  
	  
	}/* Do all particles */

      if(refineSwitch)
	done= FALSE;
      else done= TRUE;

    }/* Do Until done */

}/* MAIN */




