
#include "../libr/libPIF.h"

#ifdef VMS
extern void img_trp();
#else
extern void img_trp_();
#endif



void main(int argc, char **argv)
{/* MAIn */
  int i,j,k;
  forPifHead_t pifHead;
  int newNumCols,newNumRows,binSwitch;
  char inStr[256];
  short *short_buffer,*terp_buffer;
  fString_t inFile,outFile;
  BYTE  *byte_buffer;
  FILE *fIn,*fOut;

  if(argc < 5)
    {/* USAGE */
      printf("USAGE:  scanterp inFile outFile newNumCols newNumRows\n");
      exit(0);
    }/* USAGE */

  fIn = fopen(argv[1],"r");
  if(!fIn)
    {/* Error */
      printf("Error opening [%s] for input.\n",argv[1]);
      exit(0);
    }/* Error */

  fOut = fopen(argv[2],"r");
  if(fOut)
    {/* Exists */
      printf("[%s] already exists - do you want to overwrite? (y/N) ",
	     argv[2]);
      scanf("%s",inStr);
      if(inStr[0]=='Y' || inStr[0]=='y')
	{/* OK to continue */}
      else
	exit(0);
    }/* Exists */

  fclose(fIn);
  fclose(fOut);

  inFile.addr  = (char *)malloc(256);
  outFile.addr = (char *)malloc(256);
  sprintf(inFile.addr,"%s",argv[1]);
  sprintf(outFile.addr,"%s",argv[2]);


  newNumCols = (int)strtod(argv[3],0);
  newNumRows = (int)strtod(argv[4],0);

  printf("Preparing to interpolate to [%d,%d]\n",newNumCols,newNumRows);

  /* Now read the input file */
  pif_init_head(&pifHead);

  pifHead.luNum = 7;
#ifdef VMS
  pif_open((char *)&inFile, &pifHead.luNum, "r");
#else
  pif_open((char *)inFile.addr, &pifHead.luNum, "r");
#endif
  pif_read_gh(&pifHead);
  pif_read_dh(&pifHead);

  printf("Reading OLD dimensions [%d,%d] ... \n",
	 pifHead.numCols,pifHead.numRows);

  short_buffer = (short *)malloc(sizeof(short)*pifHead.numCols*
				 pifHead.numRows);
  terp_buffer  = (short *)malloc(sizeof(short)*newNumCols*
				 newNumRows);
  byte_buffer  = (BYTE *)malloc(sizeof(BYTE)*newNumCols*
				 newNumRows);

  binSwitch = 1;
  pif_read_byteshort_image(&pifHead.luNum,
			   short_buffer,
			   &pifHead.imgOffset,
			   &pifHead.numCols,
			   &pifHead.numRows,
			   &pifHead.numSecs,
			   &binSwitch);

  pif_close(&pifHead.luNum);


  /* Now do the interpolation */
  printf ("Interpolating ... \n");
#ifdef VMS
  img_trp(short_buffer, terp_buffer, 
	  &(pifHead.numCols),
	  &(pifHead.numRows),
	  &newNumCols,
	  &newNumRows);
#else
  img_trp_(short_buffer, terp_buffer, 
	   &(pifHead.numCols),
	   &(pifHead.numRows),
	   &newNumCols,
	   &newNumRows);
#endif
  
  /* Now write the output file */
  for(i=0;i<newNumRows;i++)
    {/* rows */
      int thisNewRow;
      thisNewRow = (i * newNumCols);
      for(j=0;j<newNumCols;j++)
	{/* Do all */
	  byte_buffer[thisNewRow + j] = (BYTE)
	    terp_buffer[thisNewRow + j];
	}/* Do all */
    }/* rows */

  printf("Writing [%s] ... \n", argv[2]);
  pifHead.luNum = 7;
#ifdef VMS
  pif_open((char *)&outFile, &pifHead.luNum, "w");
#else
  pif_open((char *)outFile.addr, &pifHead.luNum, "w");
#endif
  pifHead.numCols = newNumCols;
  pifHead.numRows = newNumRows;
  pif_write_gh(&pifHead);
  pif_write_dh(&pifHead);

  pifHead.imgOffset = 1024;
  pif_write_byte_image(&pifHead.luNum,
		       byte_buffer,
		       &pifHead.imgOffset,
		       &newNumCols,
		       &newNumRows,
		       &pifHead.numSecs);

  pif_close(&pifHead.luNum);


}/* MAIn */
