
#include "../libr/libPIF.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>


typedef struct __imgHead_t__
  {/* IMAGEHEAD_T */
    int    header;
    int    image;
  }/* IMAGEHEAD_T */ imgHead_t;

pifHead_t pifHead;



int main(int argc, char **argv)
{/* MAIN */
  int       i,j,k,l,m,n,binCols,binRows,binSecs;
  fString_t fName,readWrite,descStr;
  int       luNum,binFactor, binSwitch;
  int       img_bkg;
  imgHead_t imageOffsets[532];
  int       nimg, htype, numCols, numRows, numSecs,
            mode, endianNess, img_min, img_max, imgOffset;
  float     floatScaleFactor, recipFloatScaleFactor, 
            img_avg, img_std, junkFloat;
  char      versionStr[55];
  char      descriptionStr[128];
  char      timeStr[128];
  char      micrographStr[128];
  char      scanNumberStr[128];
  BYTE      *b_buffer[500],*thisB;
  float     *float_buffer;
  float     *section_buffer;
  float     *short_buffer,*thisS;
  int       thisSection;
  float     aoverb, map_abang, a_cell,b_cell, c_cell, 
            alp, bet, gam, dela, delb, delc;
  int       t_matrix[6];
  int       convTsb;
  float     minPixel, maxPixel;
  int       packRadius,symmetry;
  float     dthe, dphi_90;
  int       thisI;

  binFactor = 1;

  fName.addr = (char *)malloc(sizeof(char)*64);
  /*  sprintf(fName.addr,"brant.pif"); */
  /* sprintf(fName.addr,"justem3:[scratch.rwa]480-raw.pif");  */
  /* sprintf(fName.addr,"justem3:[scratch.rwa]1856_grad.pif");   */
  sprintf(fName.addr,"justem3:[rwa.oldscratch]1856.pif");  
printf("After[%s]\n",fName.addr);
  descStr.addr = (char *)malloc(sizeof(char)*81);
printf("DE[%s]\n",descStr.addr);
  readWrite.addr = (char *)malloc(sizeof(char)*4);
  sprintf(readWrite.addr,"r");
printf("RW[%s]\n",readWrite.addr);

  luNum = 7;
#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open(fName.addr, &luNum, readWrite.addr);
#endif

  if(!pif_read_header_(&luNum,
		       &nimg, 
		       &recipFloatScaleFactor,
		       &htype, &numCols, &numRows, &numSecs,
		       &mode, &endianNess, versionStr))
    {/* Error */
      printf("Trouble reading header [%s].\n",fName.addr);
      exit(0);
    }/* Error */

  thisI = 1;  /* For fortran */
  pif_read_image_header_(&luNum, 
			 &thisI,
			 &recipFloatScaleFactor,
			 &img_bkg, &img_min, &img_max,
			 &img_avg, &img_std,
			 &numCols, &numRows, &numSecs,
			 &imgOffset, &mode,
			 &htype, &descStr);
  
  printf("ncol[%d]nrow[%d]nsec[%d]\n",numCols,numRows,numSecs);
  if(binFactor==2)
    {/* bin it */
      binCols = numCols / 2 + 1;
      binRows = numRows / 2 + 1;
      binSecs = numSecs / 2 + 1;
      if((binCols % 2)==0)        /* Must be ODD */
	binCols -= 1;
      if((binRows % 2)==0)
	binRows -= 1;
      if((binSecs % 2)==0)
	binSecs -= 1;
      short_buffer = (float *)malloc(sizeof(float)*
					(binSecs)*
					(binCols)*(binRows));
    }/* bin it */
  else
    {/* DON'T bin it */
      short_buffer = (float *)malloc(sizeof(float)*
					(numCols*numRows*numSecs));
    }/* DON'T bin it */
  
  if(binFactor==2)
    binSwitch = 2;   /* Let's do sample average */
  else binSwitch = 0;
  
  printf("imgOffset[%d]\n",imgOffset);
  convTsb = FALSE;
  pif_read_map_short_image_(&luNum, 
			    short_buffer,
			    &imgOffset,
			    &numCols, &numRows, &numSecs,
			    &convTsb, &recipFloatScaleFactor,
			    &minPixel, &maxPixel,
			    &binSwitch);
  
  imgOffset;
  
  float_buffer  = (float *)malloc(sizeof(float)*
				  (numCols*numRows*numSecs));
  section_buffer  = (float *)malloc(sizeof(float)*
				  (numCols*numRows*numSecs));
  pif_close_(&luNum);
  free(fName.addr);

  fName.addr = (char *)malloc(sizeof(char)*64);
  sprintf(fName.addr,"rob_section.pif");
  sprintf(readWrite.addr,"w");

  if(binFactor==2)
    {/* Binned */
      numCols = (numCols / 2)+1;
      numRows = (numRows / 2)+1;
      numSecs = (numSecs / 2)+1;
      if(numSecs==0)
	numSecs = 1;
      /* They must be ODD here */
      if((numCols % 2 )==0)
	numCols --;
      if((numRows % 2 )==0)
	numRows --;
      if((numSecs % 2 )==0)
	numSecs --;
    }/* Binned */

#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open_(fName.addr, &luNum, readWrite.addr);
#endif

/*  floatScaleFactor = 0.01; */
  floatScaleFactor = 1.0 / recipFloatScaleFactor;

  printf("Write ncol[%d]nrow[%d]nsec[%d]\n",numCols,numRows,numSecs);
  htype = 1;
  pif_write_header_(&luNum,
		    &nimg, 
		    &recipFloatScaleFactor,
		    &htype, &numCols, &numRows, &numSecs,
		    &mode, &endianNess, versionStr);


  sprintf(descriptionStr,"Desc [%d]",i);
  sprintf(timeStr,"Time [%d]",i);
  sprintf(micrographStr,"Micro [%d]",i);
  sprintf(scanNumberStr,"Scan [%d]",i);
  imgOffset = 512;
  printf("Write IH ncol[%d]nrow[%d]nsec[%d]\n",numCols,numRows,numSecs);
  
  aoverb= map_abang= a_cell= b_cell= c_cell= 
    alp= bet= gam= 
      dela= delb= delc= 0.0;
  t_matrix[0]= 0;
  t_matrix[1]= 0;
  t_matrix[2]= 0;
  t_matrix[3]= 0;
  t_matrix[4]= 0;
  t_matrix[5]= 0;
  packRadius= 0;
  dthe=  dphi_90= 0.0;
  symmetry=0;
  
  pif_write_data_header_(&luNum, 
			 &floatScaleFactor,
			 &img_bkg, &img_min, &img_max,
			 &img_avg, &img_std,
			 &numCols, &numRows, &numSecs,
			 &imgOffset, &mode, &htype,
			 descriptionStr,
			 &aoverb, &map_abang,
			 &a_cell,&b_cell,&c_cell,
			 &alp,&bet,&gam,
			 &dela,&delb,&delc,
			 t_matrix,
			 &packRadius, &binFactor,
			 &dthe, &dphi_90,&symmetry);
  
  imgOffset = 512 + 512;
  thisS = short_buffer;
  for(k=0;k<numSecs;k++)
    {/* Do sections */
      for(l=0;l<numRows;l++)
	for(m=0;m<numCols;m++)
	  {/* Do all */
	    float_buffer[(k*numCols*numRows)+(l*numCols)+m] = 
	      (float)thisS[(k*numCols*numRows)+(l*numCols)+m] ;
	    section_buffer[(l*numCols)+m] = 
	      (float)thisS[(k*numCols*numRows)+(l*numCols)+m] ;
	  }/* Do all */
      thisSection = k+1;
printf("[%d]  nocol[%d]nrow[%d]ns[%d]\n",
       thisSection,numCols,numRows,numSecs);
      pif_write_map_section(&luNum, section_buffer, &thisSection,
			    &numCols, &numRows, &floatScaleFactor);

      
    }/* Do sections */

/*  
  imgOffset = 1024;
printf("nocol[%d]nrow[%d]ns[%d]\n",numCols,numRows,numSecs);

  pif_write_map_float_image(&luNum, float_buffer, 
			    &imgOffset,
			    &numCols, &numRows, &numSecs,
			    &floatScaleFactor);
*/
  
  pif_close_(&luNum);
  free(fName.addr);


}/* MAIN */












