/* file convert_oned.c
 *
 * Program to convert VMS specific oned files into portable
 * files.
 *
 * Rob Ashmore
 * Purdue University
 * November 2001
 */
#include <stdio.h>
#include <stdlib.h>

/* STruct for models */
typedef struct __model_t__
  {/* MODEL_T */
    float   ix1;
    float   ix2;
    float   ix3;
    int     iy1;
    int     iy2;
  }/* MODEL_T */ model_t;

#define MAXMODELS 15

main(int argc, char **argv)
{/* MAIN */
  int i,j,k;
  int modelState[MAXMODELS];
  float ampScrollValue[MAXMODELS],phaseScrollValue[MAXMODELS];
  model_t model[MAXMODELS*515];
  FILE *fIn,*fOut;

  if(argc < 3)
    {/* usage */
      printf("CONVERT_ONED inFIle outFile\n");
      exit(0);
    }/* usage */


  fIn = fopen(argv[1],"r");
  fOut= fopen(argv[2],"w");

  if(!fIn)
    {/* input */
      printf ("Can't open [%s] for input\n\n",argv[1]);
      exit(0);
    }/* input */
  if(!fOut)
    {/* output */
      printf ("Can't open [%s] for output\n\n",argv[2]);
      exit(0);
    }/* output */

  /* REad input */
  for(j=0;j<11;j++)
    {/* DO all models */
      fread(&modelState[j],sizeof(int),1,fIn);
      fread(&ampScrollValue[j],sizeof(float),1,fIn);
      fread(&phaseScrollValue[j],sizeof(float),1,fIn);

      for(i=0;i<515;i++)
	{/* Do entire model */
	  fread(&model[(j*515)+i].ix1,sizeof(float),1,fIn);
	  fread(&model[(j*515)+i].ix2,sizeof(float),1,fIn);
	  fread(&model[(j*515)+i].ix3,sizeof(float),1,fIn);
	  fread(&model[(j*515)+i].iy1,sizeof(int),1,fIn);
	  fread(&model[(j*515)+i].iy2,sizeof(int),1,fIn);
	}/* Do entire model */

    }/* DO all models */
  fclose(fIn);


  /* Write output */
  fprintf(fOut,"Portable ONED format.\n");
  for(j=0;j<11;j++)
    {/* DO all models */

      fprintf(fOut,"%d  %f  %f\n",
	      modelState[j],
	      ampScrollValue[j],
	      phaseScrollValue[j]
	      );
      
      for(i=0;i<515;i++)
	{/* Do entire model */
	  fprintf(fOut,"%f  %f  %f  %d  %d\n",
		  model[(j*515)+i].ix1,
		  model[(j*515)+i].ix2,
		  model[(j*515)+i].ix3,
		  model[(j*515)+i].iy1,
		  model[(j*515)+i].iy2
		  );
	}/* Do entire model */

    }/* DO all models */
  fclose(fOut);



}/* MAIN */
