CONTINUE WITH GETMEM4 !!!

C *****************************************************************************
C	EMPFT SUBROUTINES
C *****************************************************************************
C
C	INFO
C	PFILE_INFO
C	GLOBAL
C	REFINE
C	FILL_PARAMS
C	FREEMEM0
C	FREEMEM1
C	FREEMEM2
C	FREEMEM3
C	FREEMEM4
C	GETMEM0
C	GETMEM1
C	GETMEM2
C	GETMEM3
C	GETMEM4
C	LIST_CCS
C	WRITE_PARAMS
C
C	PFT_ADJUST_NVIEW
C	PFT_CALC_AVGS
C       PFT_CALC_TP
C	PFT_GETMODEL
C	PFT_GETNVIEW
C	PFT_GETTPO
C	PFT_GETT1T2P1
C	PFT_PHIMAX
C	PFT_PRJSPFTS
C	PFT_PRJS_STORE
C	PFTCC
C	PFTCC_AVG
C	PFTCC_AVGFFT
C	PFTCC_CONVERT
C	PFTCC_FILL
C	PFTCC_GETPO
C	PFTCC_GETPRJ
C	PFTCC_GETMAG
C	PFTCC_GETTP
C	PFTCC_GETXY
C	PFTCC_PEAK
C	PFTCC_RAD
C	PFTCC_RES

C  *****************************************************************************
C  *                                                                           *
C  *                     *****     SUBROUTINE INFO     *****                   *
C  *                                                                           *
C  *    ROUTINE FOR OBTAINING INFORMATION FOR RUNNING EMPFT PROGRAM.           *
C  *                                                                           *
C  *    AUGUST 1993  PURDUE UNIVERSITY VAX 4000/90, T. BAKER.                  *
C  *	Modified 20 May 1995, D. Belnap, added GLOBAL search option	       *
C  *	Modified July 1996, D. Belnap, added SCALE and input of filenames      *
C  *	Modified Dec 1996, D. Belnap, changes for SCALE searches & minor fixes *
C  *    14 Jan 1997, D. Belnap, added 222, 522, 622 symmetry                   *
C  *    Modified Jan 1997, D. Belnap, changed GET_PFILE call, added nfold sym. *
C  *                                                                           *
C  *    Added PIF format RW Ashmore & James Conway 5/1997                      *
C  *                                                                           *
C  *  MODIFIED 16-DEC-1997 BY T. BAKER (Rid of EM.CMM).                        *
C  *  MODIFIED  9-JAN-1998 BY T. BAKER (Reorganize input).                     *
C  *  MODIFIED 15-JAN-1998 BY TSB/RWA (*.PIF input of PFTs/PRJs).              *
C  *  MODIFIED  3-FEB-1998 BY TSB (Reorganize input).                          *
C  *  LAST MODIFIED 26-FEB-1998 BY TSB (Add UNIX compatibility).               *
C  *****************************************************************************
C
	SUBROUTINE INFO (NCOL, NROW, NSEC, NCOLBIN, NROWBIN, NSECBIN,
	1 NCIMG, NRIMG, NROT, NANNULI, NPIX, NFILES, NIDS, NIDS_TOT)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	COMMON/PFT_COM/ MODE, BIN, ILIST, TIMER, MAG_CEN, MAG_STEP, 
	1 MAG_NUM, MAG_NORM, XCEN_MODEL, YCEN_MODEL, SYM, DTHE, 
	2 DPHI_90, PFTRAD_LO, PFTRAD_HI, JCUT, PIXRES_MIN, PIXRES_MAX, 
	3 ANN_LO, ANN_HI, VAROPT, SIGCUT, RES_MIN, RES_MAX, IDIM1, 
	4 IDIM2, RADIUS, DEL_ANG, NVIEW, NTHE, NPHI, PRJ_SCALEF, 
	5 PFT_SCALEF, PARAM_FNAMES, IMG_FNAMES
C
	INTEGER*4 NIMG, BIN, BIN2, TIMER
	INTEGER*4 NIDS_TOT, NIDS(999), NCOLBIN, NROWBIN, NSECBIN
	INTEGER*4 NCOL, NROW, NSEC, NVIEW, NTHE, NPHI, NANNULI, NV
	INTEGER*4 I, N_POWER2, NROT, MODE
	INTEGER*4 NCIMG, NRIMG, ILIST, NPIX, T_MATRIX(2,3)
	INTEGER*4 IDIM1, IDIM2, FFT_NFAC, JCUT, ANN_LO, ANN_HI, SYM
	INTEGER*4 IMGOFFSET, MAG_NUM, MAG_NORM
	INTEGER*4 NROTD, NANNULID, NVIEWD, SYMD, NFILES
	REAL*4    PIXSIZ, RECIP_SF, P_MIN, P_MAX
	REAL*4    DEL_ANG, RADIUS , PFTRAD_LO, PFTRAD_HI, PFTRAD_STEP
	REAL*4    PI, RADIAN, DEGREE, DEL_PIXRES, RES_MIN, RES_MAX
	REAL*4    PIXRES_MIN, PIXRES_MAX, RES_TST, SIGCUT, MAG_LO, MAG_HI
	REAL*4    DTHE, DPHI_90, TEST, MAG_CEN, MAG_STEP, RES_LO, RES_HI
	REAL*4    DTHED, DPHI_90D, PRJ_SCALEF, PFT_SCALEF
	REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
	REAL*4    XCEN_MODEL, YCEN_MODEL
	CHARACTER PFT_FILENAME*64, PRJ_FILENAME*64, MAP_FILENAME*64
	CHARACTER PARAM_FNAMES(999)*64, IMG_FNAMES(999)*64, FNAME*64
	LOGICAL   VAROPT
	BYTE      READWRITE(4)
C  ----------------------------------------------------------------------------
C
C  ****************************************************************************
C  *  Input LINE #1: MODE, BIN, SYM, ILIST, TIMER (5I)                        *
C  *                                                                          *
C  *  MODE  =  1 Global orientation search mode (no input origins)            *
C  *        = -1 Global mode (use stored PFTs/PRJs; no input origins)         *
C  *        =  2 Global mode (use input origins)                              *
C  *        = -2 Global mode (use stored PFTs/PRJs; use input origins)        *
C  *        =  3 Refine mode                                                  *
C  *  BIN   = 1 Binfactor of 1 (no data compression)                          *
C  *        = 2 Binfactor of 2 (compresses 3D data by 8X; 2D data by 4X)      *
C  *  ILIST = 0 Minimal output (refined orientations and origins)             *
C  *        = 1 Correlation coefficients written out as functions of radius   *
C  *             and resolution in output files EMPFT.* (* = RADS,RES1,RES2)  *
C  *        = 2 gives ILIST=1 output and correlation coefficients for each    *
C  *             possible view                                                *
C  *  TIMER = 0 gives no information on program segment times.                *
C  *        = 1 reports program segment times.                                *
C  ****************************************************************************
	WRITE(*,'(A)') '$MODE, BIN, SYM, DTHE, DPHI_90, ILIST (3I,2F,I): '
	READ (*,'(3I,2F,2I)',ERR=999) MODE, BIN, SYM, DTHE, DPHI_90, 
	1 ILIST, TIMER
	IF(TIMER.NE.1) TIMER = 0		       ! A PHANTOM SWITCH [TSB]
	IF(MODE.LT.-2 .OR. MODE.GT.3 .OR.MODE.EQ.0) MODE = 1
	IF(SYM.LE.0) SYM = 532
	IF(BIN.NE.2) BIN = 1		     ! Current limit for this set = 2
	IF(MODE.EQ.3 .AND. ILIST.GT.0) THEN
	  ILIST = 0
	  PRINT *,'ILIST set to 0 because you are in REFINE mode'
	ENDIF
	IF(ILIST.NE.1 .AND. ILIST.NE.2) ILIST = 0
C       ***************************************************************
C-------*    Determine NVIEW, the number of model projection views    *
C       ***************************************************************
CTSB
	IF(MODE.EQ.3) THEN					! REFINE MODE
	   IF(DTHE.LE.0.0)       DTHE = 0.5
	   IF(DPHI_90.LE.0.0) DPHI_90 = 0.5
	   IF(NTHE.LE.0)         NTHE =   7
	   IF(NPHI.LE.0)         NPHI =   7
	   NVIEW = NTHE*NPHI
	 ELSE   						! GLOBAL MODE
	   NTHE = 0
	   NPHI = 0
	   IF(DTHE.LE.0.0)    DTHE    = 1.0
	   IF(DPHI_90.LE.0.0) DPHI_90 = 1.0
	   CALL PFT_GETNVIEW (SYM, DTHE, DPHI_90, NTHE, NVIEW)
	ENDIF
C  ****************************************************************************
C  *  Input line #2: PFTRAD_LO, PFTRAD_HI, PFTRAD_STEP, ANN_LO, ANN_HI   *
C  ***********************************************************************
	WRITE(*,'(2A)') '$PFTRAD_LO,PFTRAD_HI,PFTRAD_STEP,ANN_LO,',
	1 'ANN_HI (3F,2I): '
	READ (*,'(3F,2I)',ERR=999,END=999) PFTRAD_LO, PFTRAD_HI, 
	1 PFTRAD_STEP, ANN_LO, ANN_HI
	IF(PFTRAD_LO.LE.1.0)     PFTRAD_LO = 1.0
	IF(PFTRAD_STEP.LE.0.0) PFTRAD_STEP = 1.0
C  ****************************************************************************
C  *  Input line #3: PIXSIZ, RES_LO, RES_HI,JCUT, SIGCUT  *
C  ********************************************************
	WRITE (*,'(A)') '$PIXSIZ,RES_LO,RES_HI,JCUT,SIGCUT (3F,I,F): '
	READ (*,'(3F,I,F)',ERR=999,END=999) PIXSIZ, RES_LO, RES_HI, JCUT, 
	1 SIGCUT
	IF(JCUT.EQ.0) JCUT = 1
	IF(JCUT.LT.0) JCUT = 0
C  **************************************************************
C  *    VAROPT IS CURRENTLY NOT RECCOMMENDED BECAUSE OF BUGS    *
C  *    *****     NEED TO TEST THIS !                           *
C  **************************************************************
	VAROPT = .FALSE.
	IF(SIGCUT.GT.0.0) VAROPT = .TRUE.
C  ****************************************************************************
C  *  Input line #4: MAG_CEN, MAG_STEP, MAG_NUM, MAG_NORM    *
C  ***********************************************************
	WRITE(*,'(2A)') '$MAG_CEN,MAG_STEP,MAG_NUM,MAG_NORM',
	1 ' (2F,I,2I): '
	READ (*,'(2F,2I)',ERR=999,END=999) MAG_CEN, MAG_STEP, MAG_NUM,
	1                                  MAG_NORM
C  ****************************************************************************
C  *  Input line #5: 3D MAP FILENAME (Dummy name if MODE = -1 or -2    *
C  *********************************************************************
	WRITE(*,'(A)') '$3D MAP FILENAME: '
	READ (*,'(A)',ERR=999,END=999) MAP_FILENAME
	IF(MODE.GT.0) THEN
	  MAPHEAD.LUNUM = 1
	  READWRITE(1)  = 'r'
	  CALL PIF_OPEN (MAP_FILENAME, MAPHEAD.LUNUM, READWRITE) 
	  CALL PIF_READ_GH (MAPHEAD)
	  IF(MAPHEAD.MODE.EQ.20) THEN
	     MAPHEAD.IMGNUM = 1                              ! LOAD UP "IMG" #1
	     CALL PIF_READ_DH (MAPHEAD)
	     NCOL = MAPHEAD.NUMCOLS
	     NROW = MAPHEAD.NUMROWS
	     NSEC = MAPHEAD.NUMSECS
	   ELSE
	     PRINT *, 'Invalid PIF mode for 3D MAP'
	     CALL TSBEND
	  ENDIF
	ENDIF
C  ***************************************************************************
C  *  Input line #6: PRJs filename    *
C  ************************************
	WRITE(*,'(A)') '$PRJ filename (<CR>=PFT.PRJS):  '
	PRJ_FILENAME = ' '
	READ (*,'(A)',ERR=999,END=999) PRJ_FILENAME
	IF(PRJ_FILENAME.EQ.' ')  PRJ_FILENAME = 'PFT.PRJS'
C  ***************************************************************************
C  *  Input line #7: PFTs filename    *
C  ************************************
	WRITE(*,'(A)') '$PFT filename (<CR>=PFT.PFTS):  '
	PFT_FILENAME = ' '
	READ (*,'(A)',ERR=999,END=999) PFT_FILENAME
	IF(PFT_FILENAME.EQ.' ')  PFT_FILENAME = 'PFT.PFTS'
	IF(MODE.GT.0) GO TO 100
C       ***************************************************************
C-------*  Need to get NCOL & NROW if reading in stored PRJs/PFTs)    *
C       ***************************************************************
	PRJHEAD.LUNUM = 3
	READWRITE(1)  = 'r'
	CALL PIF_OPEN (PRJ_FILENAME, PRJHEAD.LUNUM, READWRITE)
	CALL PIF_READ_GH (PRJHEAD)
CCC	CALL PIF_READ_HEADER_ (3, NIMG, PRJ_SCALEF, HTYPE, NCOL, NROW, 
CCC	1  NSEC, PIFMODE_P, ENDIANNESS, VERSIONSTR)
	IF(PRJHEAD.MODE.NE.21) THEN
	  PRINT *, 'Invalid PIF mode for PRJ file'
	  CALL TSBEND
	ENDIF
C       ****************************************************
C-------* NOTE: NSEC must be reduced by one because the    *
C       *       last entry in the PRJ file is PRJ_AVG.     *
C       ****************************************************
	PRJHEAD.IMGNUM = 1
	CALL PIF_READ_DH (PRJHEAD)
	NCOL = PRJHEAD.NUMCOLS
	NROW = PRJHEAD.NUMROWS
	NSEC = PRJHEAD.NUMSECS - 1	     ! Last one is the circular average
CCC	CALL PIF_READ_DATA_HEADER_ (3, THISIMG, PRJ_SCALEF, IMG_BKG, 
CCC	1  P_MIN, P_MAX, MAP_AVG, MAP_STD, NCOL, NROW, NSEC, 
CCC	2  IMGOFFSET, PIFMODE_P, HTYPE, DESCRIPTIONSTR, AOVERB, 
CCC	3  MAP_ABANG, A_CELL, B_CELL, C_CELL, ALP, BET, GAM, DELA, 
CCC	4  DELB, DELC, T_MATRIX, BIN2, JUNK1, JUNK2, JUNK3)
	BIN2 = PRJHEAD.BINFACTOR
	IF(BIN.NE.BIN2) THEN
	  PRINT *, '* Stored PRJ/PFT data incompatible with chosen',
	1          ' BIN factor *'
	  CALL TSBEND
	ENDIF
	PFTHEAD.LUNUM = 4
	READWRITE(1)  = 'r'
	CALL PIF_OPEN (PFT_FILENAME, PFTHEAD.LUNUM, READWRITE)
	CALL PIF_READ_GH (PFTHEAD)
CCC	CALL PIF_READ_HEADER_ (4, NIMG, PFT_SCALEF, HTYPE, NROTD, 
CCC	1  NANNULID, NVIEWD, PIFMODE_P, ENDIANNESS, VERSIONSTR)
	IF(PFTHEAD.MODE.NE.22) THEN
	  PRINT *, 'Invalid PIF mode for PFT file'
	  CALL TSBEND
	ENDIF
	PFTHEAD.IMGNUM = 1
	CALL PIF_READ_DH (PFTHEAD)
	NROTD    = PFTHEAD.NUMCOLS
	NANNULID = PFTHEAD.NUMROWS
	NVIEWD   = PFTHEAD.NUMSECS
	BIN2     = PFTHEAD.BINFACTOR
CCC	CALL PIF_READ_DATA_HEADER_ (4, THISIMG, PFT_SCALEF, IMG_BKG, 
CCC	1  P_MIN, P_MAX, MAP_AVG, MAP_STD, NROTD, NANNULID, NVIEWD, 
CCC	2  IMGOFFSET, PIFMODE_P, HTYPE, DESCRIPTIONSTR, AOVERB, 
CCC	3  MAP_ABANG, A_CELL, B_CELL, C_CELL, ALP, BET, GAM, DELA, 
CCC	4  DELB, DELC, T_MATRIX, BIN2, DTHED, DPHI_90D, SYMD)
C  ****************************************************************************
C  *  Input line #8: Parameter data FILENAME  *
C  ********************************************
  100	CALL PFILE_INFO (MODE, NCOL, NROW, NSEC, NCIMG, NRIMG, 
	1 NFILES, NIDS, NIDS_TOT, PARAM_FNAMES, IMG_FNAMES)
C  ************************************************************
C  *    CHECK DEFAULTS FROM INPUT LINES #2-4                  *
C  *                                                          *
C  *    CHECK VALUE OF PFTRAD_HI AGAINST SIZE OF NCOL,NROW    *
C  *     AND USE TO DETERMINE VALUE OF NROT                   *
C  ************************************************************
	RADIUS = (FLOAT(MIN(NCOL-1,NROW-1))/2.0)
	IF(PFTRAD_HI.GT.RADIUS)  PFTRAD_HI = RADIUS
	IF(PFTRAD_HI.LE.0.0)     PFTRAD_HI = RADIUS
	NANNULI = (PFTRAD_HI - PFTRAD_LO + 1.0)/PFTRAD_STEP
	CALL PIRADDEG (PI, RADIAN, DEGREE)
	TEST     = 2*PFTRAD_HI*PI      ! NEED SUFFICIENT SAMPLING AT PFTRAD_HI
	N_POWER2 = 0
	DO WHILE(TEST.GT.1)
	  N_POWER2 = N_POWER2 + 1
	  TEST     = TEST/2.0
	ENDDO
	NROT     = 2**N_POWER2
	DEL_ANG  = 360.0/FLOAT(NROT)
	FFT_NFAC = 2		     ! DOUBLES DEFAULT FFT SIZE FOR CC FUNCTION
	CALL FFT_SETDIM_DEF_SAME (NCOL, NROW, IDIM1, IDIM2, FFT_NFAC)
C
	IF(MODE.GT.0) GO TO 200
C  ********************************************************
C  *    HERE IF READING IN PFT/PRJ DATA FROM DISK.        *
C  *    CHECK TO SEE THAT PFT/PRJ DATA FILES AGREE WITH   *
C  *     INPUTS FROM COMMAND BATCH JOB.                   *
C  ********************************************************
	IF(NROTD .NE. NROT .OR. NANNULID .NE. NANNULI 
	1  .OR. NVIEWD .NE. NVIEW .OR. BIN .NE. BIN2) THEN
	   PRINT *, 'NROT,NANNULI,NVIEW - ', NROT,NANNULI,NVIEW
	   PRINT *, 'NROTD,NANNULID,NVIEWD - ', NROTD,NANNULID,NVIEWD
	   PRINT *, 'BIN,BIN2 - ', BIN, BIN2
	   PRINT *, 'Mismatch between PFT file and batch job params.'
	  CALL TSBEND
	ENDIF
  200	PFTRAD_STEP = 1.0
	DEL_PIXRES  = 0.025
	IF(JCUT.GE.NROT/4)   JCUT  = (NROT/4) - 1
	IF(PIXSIZ.LE.0.0) PIXSIZ = 1.0			  ! PIXEL UNITS ASSUMED
	RES_TST = FLOAT(IDIM1/2)*PIXSIZ
	IF(RES_LO.LE.0.0 .OR. RES_LO.GT.RES_TST) RES_LO = RES_TST
	RES_TST = 2.0*PIXSIZ
	IF(RES_HI.LT.RES_TST) RES_HI = RES_TST
	PIXRES_MIN = RES_LO/PIXSIZ
	PIXRES_MAX = RES_HI/PIXSIZ
	RES_MIN    = FLOAT(IDIM1)/PIXRES_MIN
	RES_MAX    = FLOAT(IDIM1)/PIXRES_MAX
	IF(ILIST.LT.1) GO TO 300
C  ******************************************
C  *  Extra output files if ILIST = 1 or 2  *
C  ******************************************
	OPEN (UNIT=8, FILE='EMPFT.RES1', STATUS='NEW',
	1     ACCESS='SEQUENTIAL', FORM='FORMATTED')
	WRITE(8,'(2A,/,A)') 'Correlation coefficients as function of',
	1 ' resolution (1/pixel) for unmasked data',
	2 ' (computed after X,Y origin refinement)'
	WRITE(8,'(A,10F7.3)')  ' IMG', (I*DEL_PIXRES, I=1,10)
	WRITE(8,'(74(''-''))')
	OPEN (UNIT=9, FILE='EMPFT.RADS', STATUS='NEW',
	1     ACCESS='SEQUENTIAL', FORM='FORMATTED')
	WRITE(9,'(2A)') ' Correlation coefficients as a function of',
	1 ' radius (computed after X,Y origin refinement)'
	OPEN (UNIT=10, FILE='EMPFT.RES2', STATUS='NEW',
	1     ACCESS='SEQUENTIAL', FORM='FORMATTED')
	WRITE(10,'(2A,/,A)') ' Correlation coefficients as function',
	1  ' of resolution (1/pixel) for ANN_LO to ANN_HI masked data',
	2  ' (computed after X,Y origin refinement)'
	WRITE(10,'('' IMG'',10F7.3)')  (I*DEL_PIXRES, I=1,10)
	WRITE(10,'(74(''-''))')
  300	IF(MAG_NUM.LE.0) MAG_NUM = 1
	IF(MOD(MAG_NUM,2).EQ.0) MAG_NUM = MAG_NUM + 1
	IF(IABS(MODE).EQ.1 .AND. MAG_CEN.LE.0.0) THEN
	  MAG_CEN = 1.0
	  PRINT *,'GLOBAL SEARCH mode - you have no MAG values to read in'
	ENDIF
C  *****************************************************************
C  *    BEFORE EXITING THIS ROUTINE, THIS IS WHERE WE MAKE SURE    *
C  *    EVERTHING IS TREATED CORRECTLY TO ACCOMODAT BINNING.       *
C  *****************************************************************
	NCOLBIN = (NCOL/BIN) + 1
	NROWBIN = (NROW/BIN) + 1
	NSECBIN = (NSEC/BIN) + 1
	IF(MOD(NCOLBIN,2).EQ.0) NCOLBIN = NCOLBIN - 1
	IF(MOD(NROWBIN,2).EQ.0) NROWBIN = NROWBIN - 1
	IF(MOD(NSECBIN,2).EQ.0) NSECBIN = NSECBIN - 1
	NROT       = NROT/BIN
	IDIM1      = IDIM1/BIN
	IDIM2      = IDIM2/BIN
	NANNULI    = NANNULI/BIN
	NPIX       = NROT*NANNULI/4
	DEL_ANG    = DEL_ANG*FLOAT(BIN)
	ANN_LO     = ANN_LO/BIN
	ANN_HI     = ANN_HI/BIN
	RADIUS     = FLOAT(NANNULI)
	PFTRAD_LO  = PFTRAD_LO/FLOAT(BIN)
	IF(PFTRAD_LO.LT.1.0) PFTRAD_LO = 1.0
	PFTRAD_HI  = PFTRAD_HI/FLOAT(BIN)
	XCEN_MODEL = (NCOLBIN+1)/2
	YCEN_MODEL = (NROWBIN+1)/2
	IF(ANN_LO.LT.1)       ANN_LO = 0
	IF(ANN_LO.GE.NANNULI) ANN_LO = NANNULI - 1
	IF(ANN_HI.LE.0)       ANN_HI = NANNULI - 1
	IF(ANN_HI.GE.NANNULI) ANN_HI = NANNULI - 1
	WRITE(*,1001) ' EMPFT parameters'
	WRITE(*,1001) ' ------------------------------------------------'
	WRITE(*,1001) ' BIN factor          ', BIN
	WRITE(*,1001) ' Symmetry            ', SYM
	WRITE(*,1001) ' # model views       ', NVIEW
	WRITE(*,1001) ' # images in search  ', NIDS_TOT
	WRITE(*,1001) ' FFT_DIM1,FFT_DIM2   ', IDIM1, IDIM2
	WRITE(*,1002) ' RES_LO,RES_HI       ', RES_LO, RES_HI
	WRITE(*,1002) ' RES_MIN,RES_MAX     ', RES_MIN, RES_MAX
	WRITE(*,1002) ' PIXRES_MIN/MAX      ', PIXRES_MIN, PIXRES_MAX
	WRITE(*,1002) ' Pixel size          ', PIXSIZ
	WRITE(*,1001) ' NANNULI             ', NANNULI
	WRITE(*,1002) ' PFTRAD_LO,PFTRAD_HI ', PFTRAD_LO, PFTRAD_HI
	WRITE(*,1001) ' ANN_LO,ANN_HI       ', ANN_LO, ANN_HI
	WRITE(*,1001) ' NROT                ', NROT
	WRITE(*,1002) ' Delta omega         ', DEL_ANG
	WRITE(*,1002) ' Model XCEN,YCEN     ', XCEN_MODEL, YCEN_MODEL
	WRITE(*,1002) ' MAG(_CEN,_STEP,_NUM)', MAG_CEN, MAG_STEP, MAG_NUM
	IF(MAG_CEN.GT.0.0) THEN
	   MAG_LO = MAG_CEN - (((MAG_NUM-1)/2)*MAG_STEP)
	   MAG_HI = MAG_CEN + (((MAG_NUM-1)/2)*MAG_STEP)
	   WRITE(*,1002) ' MAG range(LO,HI)    ', MAG_LO, MAG_HI
	 ELSE
	   WRITE(*,'(2A)') ' MAG factor centered on input values from',
	1 ' data file'
	ENDIF
	WRITE(*,1001) ' ------------------------------------------------'
	RETURN
C
  999	PRINT *, '************************************************'
	PRINT *, '* BATCH COMMAND JOB input ERROR - STOP program *'
	CALL TSBEND
 1001	FORMAT(A,2I9)
 1002	FORMAT(A,2F9.3,I9)
	END

C  ************************************************************************
C  *								          *
C  *              *****     SUBROUTINE PFILE_INFO     *****               *
C  *								          *
C  *    READS IN  ALL PARAMETER FILENAMES AND CHECKS THE CORRESPONDING    *
C  *     IMAGE FILES TO BE SURE THE IMAGE AND MODEL DATA HAVE THE         *
C  *     SAME DIMENSIONS.                                                 *
C  *								          *
C  *	Prompts user for a parameter data file, opens file, counts        *
C  *	number of particles, finds highest particle number, gets          *
C  *	image filename from first line of file.			          *
C  *								          *
C  *	Adapted from PFT_GETPFILE written by DMB, May 1995.               *
C  *								          *
C  *	MODIFIED 19-JAN-1998 BY T. BAKER (Multiple inout files).          *
C  *	MODIFIED 22-JAN-1998 BY T. BAKER (CTF parameters).                *
C  *	MODIFIED  3-FEB-1998 BY T. BAKER (Save IMG_FILENAMES).            *
C  *    LAST MODIFIED 26-FEB-1998 BY TSB (Add UNIX compatibility).        *
C  ************************************************************************
C
	SUBROUTINE PFILE_INFO (MODE, NCOL, NROW, NSEC, NCIMG, NRIMG, 
	1 NFILES, NIDS, NIDS_TOT, PARAM_FNAMES, IMG_FNAMES)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	COMMON/CTF_STUFF/PIXSIZS, VOLTS, AMPFACS, DELF_MAJORS, 
	1 DELF_MINORS, ANG_DELFS, CS_COEFFS
C
	INTEGER*4 MODE, NIMG, LUN, MAX_ID, ID, NIDS_TOT
	INTEGER*4 NCOL, NROW, NSEC, NCIMG, NRIMG, NFILES
	INTEGER*4 NIDS(999)
	REAL*4    IMG_SCALEF, PIXSIZS(999), VOLTS(999), AMPFACS(999)
	REAL*4    DELF_MAJORS(999), DELF_MINORS(999), ANG_MAJORS(999)
	REAL*4    CS_COEFFS(999), ANG_DELFS(999)
	CHARACTER PARAM_FNAMES(999)*64, IMG_FNAMES(999)*64, FNAME*64
	BYTE      VERSIONSTR(35), READWRITE(4)
C------------------------------------------------------------------------------
C
	NFILES   = 0			 ! COUNT THE NUMBER OF PARAMETER FILES
	NIDS_TOT = 0			 ! COUNT THE NUMBER OF IMAGES TO SEARCH
C
  	WRITE(*,'(A)') '$PARAMETER DATA FILES: '
  100	READ (*,'(A)',ERR=950,END=999) FNAME
C  *************************************************************
C  *  Open file and read first line, make sure it is not data  *
C  *************************************************************
	IF(NFILES.NE.0) THEN
	  CLOSE (UNIT=2, DISP='KEEP')
	  CALL PIF_CLOSE (7)
	ENDIF
	OPEN (UNIT=2, FILE=FNAME, STATUS='OLD', ERR=960,
	1     ACCESS='SEQUENTIAL', FORM='FORMATTED', READONLY, SHARED)
	NFILES = NFILES + 1
	IF(NFILES.GT.999) GO TO 940
	READ (2,'(A)',ERR=970) IMG_FNAMES(NFILES)
	READ (2,'(7F)',ERR=975) PIXSIZS(NFILES), VOLTS(NFILES),
	1 AMPFACS(NFILES), DELF_MAJORS(NFILES), DELF_MINORS(NFILES), 
	2 ANG_MAJORS(NFILES), CS_COEFFS(NFILES)
	PARAM_FNAMES(NFILES) = FNAME
	PRINT *
	WRITE(*,'(A,I4,2A)') ' File #', NFILES, ' is: ', IMG_FNAMES(NFILES)
C  ************************************************************
C  *    OPEN UP PIF FORMAT IMAGE FILE AND CHECK TO MAKE SURE  *
C  *     MODEL MAP DATA SIZE AND IMAGE SIZE ARE EQUIVALENT    *
C  ************************************************************
	IMGHEAD.LUNUM = 7
	READWRITE(1)  = 'r'
	CALL PIF_OPEN (IMG_FNAMES(NFILES), IMGHEAD.LUNUM, READWRITE)
	CALL PIF_READ_GH (IMGHEAD)
CCC	CALL PIF_READ_HEADER_ (LUN, NIMG, IMG_SCALEF, HTYPE, NCIMG, 
CCC	1 NRIMG, NSECIM, PIFMODE, ENDIANNESS, VERSIONSTR)
	NIMG  = IMGHEAD.NIMG
	NCIMG = IMGHEAD.NUMCOLS
        NRIMG = IMGHEAD.NUMROWS
	IF(NCIMG.NE.NCOL .OR. NRIMG.NE.NROW) THEN
	  PRINT *, '=================================================='
	  PRINT *, '|  ERROR!!  Sizes of MAP and IMAGE are unequal.  |'
	  PRINT *, '|  Make them equivalent then rerun program.      |'
	  PRINT *, '=================================================='
	  PRINT *, 'NCOL (map)   = ', NCOL
	  PRINT *, 'NROW (map)   = ', NROW
	  PRINT *, 'NSEC (map)   = ', NSEC
	  PRINT *, 'NCOL (image) = ', NCIMG
	  PRINT *, 'NROW (image) = ', NRIMG
	  CALL TSBEND
	ENDIF
	IF(IABS(MODE).EQ.1) THEN
	  NIDS(NFILES) = NIMG
	  MAX_ID       = NIMG
	  NIDS_TOT     = NIDS_TOT + NIMG
	  GO TO 300
	ENDIF
C  ********************************************************************
C  *  Count particles in parameter file, find one with highest value  *
C  ********************************************************************
	NIDS(NFILES) = 0
	MAX_ID       = 0
  200	READ (2,'(I)',ERR=980,END=300) ID
	NIDS_TOT     = NIDS_TOT + 1
	NIDS(NFILES) = NIDS(NFILES) + 1
	MAX_ID       = MAX(MAX_ID, ID)
	GO TO 200
C  ****************************************************
C  *    HERE WHEN AT END OF CURRENT PARAMETER FILE    *
C  ****************************************************
  300	IF(NIDS(NFILES).EQ.0)  GO TO 990
CTSB	WRITE(*,'(A,I4,A,I4)') ' This datafile has ', NIDS(NFILES), 
CTSB	1 ' images with highest ID =', MAX_ID
	GO TO 100			! CHECK FOR ADDITIONAL PARAMETER FILES
C  ***************************************************************************
C  *    ERROR MESSAGES    *
C  ************************
  940	PRINT *, '***********************************************'
	PRINT *, '* More than 999 parameter files: EXIT program *'
	CALL TSBEND
  950	PRINT *, '**************************************************'
	PRINT *, '* Error reading parameter filename: EXIT program *'
	CALL TSBEND
  960	PRINT *, '**********************************************'
	PRINT *, '* Error opening parameter file: EXIT program *'
	CALL TSBEND
  970	PRINT *, '**********************************************'
	PRINT *, '* Error reading IMAGE filename: EXIT program *'
	CALL TSBEND
  975	PRINT *, '**********************************************'
	PRINT *, '* READ ERROR: 2nd record of PARAMETER file   *'
	CALL TSBEND
  980	PRINT *, '*******************************************'
	PRINT *, '* Error reading particle ID: EXIT program *'
	CALL TSBEND
  990	PRINT *, '*********************************************'
	PRINT *, '* PARAM file contains no data: EXIT program *'
	CALL TSBEND
  999	WRITE(*,'(I5,A,I6,A)') NFILES, ' PARAMETER files and total of', 
	1 NIDS_TOT, ' images for PFT search.'
	CLOSE (UNIT=2, DISP='KEEP')
	CALL PIF_CLOSE (7)
	RETURN
C
	END

C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE FILL_PARAMS     *****               *
C  *                                                                          *
C  *    FILL UP THE PARAMETER ARRAYS BY READING DATA IN FROM ALL PARAMETER    *
C  *     FILES (UNIT = 2).                                                    *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED  4-FEB-1998 BY T. BAKER ().                             *
C  ****************************************************************************
C
	SUBROUTINE FILL_PARAMS (MODE, NFILES, NIDS_TOT, NIDS, FIDS, 
	1 IDS, TS, PS, OS, XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, 
	2 PARAM_FNAMES)
C	
	IMPLICIT NONE
C
	INTEGER*4 MODE, ID, NFILES, NIDS_TOT, FILE, NN, NIDS(999)
	INTEGER*4 FIDS(NIDS_TOT), IDS(NIDS_TOT)
	REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
	CHARACTER PARAM_FNAMES(999)*64, IMG_FILENAME*64
C  ----------------------------------------------------------------------------
C
	IF(IABS(MODE).EQ.1) THEN
	  DO FILE = 1, NFILES
	    DO ID = 1,NIDS(FILE)
	      FIDS(ID) = FILE
	      IDS(ID)  = ID
	    ENDDO
	  ENDDO
	  RETURN
	ENDIF
C
	NN = 1
C  *************************************************************
C  * Loop through PARAMETER files and retrieve particle info   *
C  *************************************************************
	DO 900 FILE = 1,NFILES
	  IF(FILE.GT.1) CLOSE (UNIT=2, DISP='KEEP')
	  OPEN (UNIT=2, FILE=PARAM_FNAMES(FILE), STATUS='OLD', ERR=996,
	1      ACCESS='SEQUENTIAL', FORM='FORMATTED', READONLY, SHARED)
	  READ (2,'(A)',ERR=997) 				! DUMMY READ #1
	  READ (2,'(A)',ERR=998)				! DUMMY READ #2
  100	  READ (2,'(I,6F)',END=900,ERR=999) IDS(NN), TS(NN), PS(NN), 
	1  OS(NN), XS(NN), YS(NN), MAGS(NN)
	  FIDS(NN) = FILE
	  NN       = NN + 1
	  GO TO 100
  900	ENDDO
	NN = NN -1
 	RETURN
C
  996	PRINT *, '***********************************'
	PRINT *, '* ERROR trying to OPEN PARAM file *'
	CALL TSBEND
  997	PRINT *, '****************************************************'
	PRINT *, '* FILL_PARAMS ERROR reading 1st line of PARAM file *'
	CALL TSBEND
  998	PRINT *, '****************************************************'
	PRINT *, '* FILL_PARAMS ERROR reading 2nd line of PARAM file *'
	CALL TSBEND
  999	PRINT *, '**************************************************'
	PRINT *, '* FILL_PARAMS ERROR reading data from PARAM file *'
	CALL TSBEND
	END

C  ****************************************************************************
C  *                                                                          *
C  *                  *****     SUBROUTINE FREEMEM0     *****                 *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED 26-FEB-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM0 (FIDS_P, IDS_P, TS_P, PS_P, OS_P, XS_P, 
	1 YS_P, MAGS_P, CC1S_P, CC2S_P, CC3S_P)
C
	IMPLICIT NONE
C
	INTEGER*4 FIDS(1), IDS(1)
	REAL*4    TS(1), PS(1), OS(1), XS(1), YS(1), MAGS(1), CC1S(1)
	REAL*4    CC2S(1), CC3S(1)
	POINTER   (TS_P,TS), (PS_P,PS), (OS_P,OS), (MAGS_P,MAGS)
	POINTER   (FIDS_P,FIDS), (IDS_P,IDS), (XS_P,XS), (YS_P,YS)
	POINTER   (CC1S_P,CC1S), (CC2S_P,CC2S), (CC3S_P,CC3S)
C  ----------------------------------------------------------------------------
C
	CALL FREE (FIDS_P)
	CALL FREE (IDS_P)
	CALL FREE (TS_P)
	CALL FREE (PS_P)
	CALL FREE (OS_P)
	CALL FREE (XS_P)
	CALL FREE (YS_P)
	CALL FREE (MAGS_P)
	CALL FREE (CC1S_P)
	CALL FREE (CC2S_P)
	CALL FREE (CC3S_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM1     *****                *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 16-JAN-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM1 (NCOLBIN, NROWBIN, NVIEW, NPIX, PRJ_AVG_ADDR, 
	1 PFTS_ADDR, PRJS_ADDR, THETAS_ADDR, PHIS_ADDR)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOLBIN, NROWBIN, NVIEW, NPIX, THETAS_ADDR, PHIS_ADDR
	INTEGER*4 PRJ_AVG_ADDR, PFTS_ADDR, PRJS_ADDR
	LOGICAL   STATUS, FREE_VM, TEST
C  ----------------------------------------------------------------------------
C
	TEST   = .TRUE.
	STATUS = FREE_VM (4*NCOLBIN*NROWBIN,    PRJ_AVG_ADDR,'PRJ_AVG_ADDR')
	STATUS = FREE_VM (4*NVIEW*NPIX,            PFTS_ADDR,'PFTS_ADDR')
	STATUS = FREE_VM (4*NVIEW*NCOLBIN*NROWBIN, PRJS_ADDR,'PRJS_ADDR')
	STATUS = FREE_VM (4*NVIEW,               THETAS_ADDR,'THETAS_ADDR')
	STATUS = FREE_VM (4*NVIEW,                 PHIS_ADDR,'PHIS_ADDR')
C
	IF(.NOT.TEST) THEN
	  PRINT *, '**************************************************'
	  PRINT *, '* FREEMEM1 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM2     *****                *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED  9-JAN-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM2 (NCOL, NROW, NSEC, NROT, NANNULI, PRJ_ADDR,
	1 PROJN_ADDR, TRP_ADDR, ITMP_ADDR, MAP3D_ADDR, PFFT_ADDR, 
	2 PMAP_ADDR, A_ADDR)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, NSEC, NROT, NANNULI
	INTEGER*4 MAP3D_ADDR, PRJ_ADDR, PROJN_ADDR, TRP_ADDR, ITMP_ADDR
	INTEGER*4 PFFT_ADDR, PMAP_ADDR, A_ADDR
	LOGICAL   STATUS, FREE_VM, TEST
C  ----------------------------------------------------------------------------
C
	TEST   = .TRUE.
	STATUS = FREE_VM (4*NCOL*NROW*NSEC, MAP3D_ADDR, 'MAP3D_ADDR')
	STATUS = FREE_VM (4*NCOL*NROW,      PRJ_ADDR,   'PRJ_ADDR')
	STATUS = FREE_VM (4*NCOL*NROW,      PROJN_ADDR, 'PROJN_ADDR')
	STATUS = FREE_VM (4*NCOL*NROW,      TRP_ADDR,   'TRP_ADDR')
	STATUS = FREE_VM (4*NCOL,           ITMP_ADDR,  'ITMP_ADDR')
	STATUS = FREE_VM (4*2*NROT*NANNULI, PFFT_ADDR,  'PFFT_ADDR')
	STATUS = FREE_VM (4*NROT*NANNULI,   PMAP_ADDR,  'PMAP_ADDR')
	STATUS = FREE_VM (4*2*NROT,         A_ADDR,     'A_ADDR')
	IF(.NOT.TEST) THEN
	  PRINT *, '**************************************************'
	  PRINT *, '* FREEMEM2 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM3     *****                *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 16-JAN-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM3 (NVIEW, NPIX, NROT, NANNULI, PFT_AVGS_ADDR, 
	1 SQ2_ADDR,VAR_ADDR, RMS_ADDR, AVER_ADDR, TMP_ADDR)
C
	IMPLICIT NONE
C
	INTEGER*4 NVIEW, NPIX, NROT, NANNULI, PFT_AVGS_ADDR, TMP_ADDR
	INTEGER*4 SQ2_ADDR, VAR_ADDR, RMS_ADDR, AVER_ADDR
	LOGICAL   STATUS, FREE_VM, TEST
C  ----------------------------------------------------------------------------
C
	TEST   = .TRUE.
	STATUS = FREE_VM (4*NVIEW,      PFT_AVGS_ADDR, 'PFT_AVGS_ADDR')
	STATUS = FREE_VM (4*NVIEW,           SQ2_ADDR, 'SQ2_ADDR')
	STATUS = FREE_VM (2*NPIX,            VAR_ADDR, 'VAR_ADDR')
	STATUS = FREE_VM (4*NPIX,            RMS_ADDR, 'RMS_ADDR')
	STATUS = FREE_VM (4*NPIX,           AVER_ADDR, 'AVER_ADDR')
	STATUS = FREE_VM (NROT*NANNULI,      TMP_ADDR,  'TMP_ADDR')
	IF(.NOT.TEST) THEN
	  PRINT *, '**************************************************'
	  PRINT *, '* FREEMEM3 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM4     *****                *
C  *                                                                          *
C  *    FREE UP MEMORY.                                                       *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 25-FEB-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM4 (FFT1_P, FFT3_P, IMG_P, MAP_P, PRJ_P, 
	1 PRJ_ROT_P, IMGPFT_P, PFFT_P, PMAP_P, FLTPMAP_P, PPRJ_P, 
	2 A_P, CCOR_P, ICOR_P, ITMP_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, NVIEW
	INTEGER*2 IMG(1), ICOR(1), ITMP(1)
	REAL*4    FFT1(1), FFT3(1), MAP(1), PRJ(1), PRJ_ROT(1)
	REAL*4    IMGPFT(1), PFFT(1), PMAP(1), FLTPMAP(1)
	REAL*4    PPRJ(1), A(1), CCOR(1)
	POINTER   (FFT1_P,FFT1), (FFT3_P,FFT3), (IMG_P,IMG)
	POINTER   (MAP_P,MAP), (PRJ_P,PRJ), (PRJ_ROT_P,PRJ_ROT)
	POINTER   (IMGPFT_P,IMGPFT), (PFFT_P,PFFT), (PMAP_P,PMAP)
	POINTER   (FLTPMAP_P,FLTPMAP), (PPRJ_P,PPRJ), (A_P,A)
	POINTER   (CCOR_P,CCOR), (ICOR_P,ICOR), (ITMP_P,ITMP)
C  ----------------------------------------------------------------------------
C
	CALL FREE (FFT1_P)
	CALL FREE (FFT3_P)
	CALL FREE (IMG_P)
	CALL FREE (MAP_P)
	CALL FREE (PRJ_P)
	CALL FREE (PRJ_ROT_P)
	CALL FREE (IMGPFT_P)
	CALL FREE (PFFT_P)
	CALL FREE (PMAP_P)
	CALL FREE (FLTPMAP_P)
	CALL FREE (PPRJ_P)
	CALL FREE (A_P)
	CALL FREE (CCOR_P)
	CALL FREE (ICOR_P)
	CALL FREE (ITMP_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM0     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED 26-FEB-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE GETMEM0 (NIDS_TOT, FIDS_P, IDS_P, TS_P, PS_P, OS_P, 
	1 XS_P, YS_P, MAGS_P, CC1S_P, CC2S_P, CC3S_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NIDS_TOT, FIDS(1), IDS(1)
	REAL*4    TS(1), PS(1), OS(1), XS(1), YS(1), MAGS(1), CC1S(1)
	REAL*4    CC2S(1), CC3S(1)
	POINTER   (TS_P,TS), (PS_P,PS), (OS_P,OS), (MAGS_P,MAGS)
	POINTER   (FIDS_P,FIDS), (IDS_P,IDS), (XS_P,XS), (YS_P,YS)
	POINTER   (CC1S_P,CC1S), (CC2S_P,CC2S), (CC3S_P,CC3S)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	FIDS_P = MALLOC(4*NIDS_TOT)
	IDS_P  = MALLOC(4*NIDS_TOT)
	TS_P   = MALLOC(4*NIDS_TOT)
	PS_P   = MALLOC(4*NIDS_TOT)
	OS_P   = MALLOC(4*NIDS_TOT)
	XS_P   = MALLOC(4*NIDS_TOT)
	YS_P   = MALLOC(4*NIDS_TOT)
	MAGS_P = MALLOC(4*NIDS_TOT)
	CC1S_P = MALLOC(4*NIDS_TOT)
	CC2S_P = MALLOC(4*NIDS_TOT)
	CC3S_P = MALLOC(4*NIDS_TOT)
C
	IF(FIDS_P.EQ.0 .OR. IDS_P.EQ.0 .OR. TS_P.EQ.0 .OR. PS_P.EQ.0 .OR. 
	1 OS_P.EQ.0 .OR. MAGS_P.EQ.0 .OR. CC1S_P.EQ.0 .OR. CC2S_P.EQ.0
	2 .OR. CC3S_P.EQ.0) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM0 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM1     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 16-JAN-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE GETMEM1 (NCOLBIN, NROWBIN, NVIEW, NPIX, PRJ_AVG_ADDR, 
	1 PFTS_ADDR, PRJS_ADDR, THETAS_ADDR, PHIS_ADDR)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOLBIN, NROWBIN, NVIEW, NPIX, THETAS_ADDR, PHIS_ADDR
	INTEGER*4 PRJ_AVG_ADDR, PFTS_ADDR, PRJS_ADDR
	LOGICAL   STATUS, GET_VM, TEST
C  ----------------------------------------------------------------------------
C
	TEST   = .TRUE.
	STATUS = GET_VM (4*NCOLBIN*NROWBIN,    PRJ_AVG_ADDR,'PRJ_AVG_ADDR')
	STATUS = GET_VM (4*NVIEW*NPIX,            PFTS_ADDR,'PFTS_ADDR')
	STATUS = GET_VM (4*NVIEW*NCOLBIN*NROWBIN, PRJS_ADDR,'PRJS_ADDR')
	STATUS = GET_VM (4*NVIEW,               THETAS_ADDR,'THETAS_ADDR')
	STATUS = GET_VM (4*NVIEW,                 PHIS_ADDR,'PHIS_ADDR')
C
	IF(.NOT.TEST) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM1 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM2     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    DECEMBER 1997 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED 29-DEC-1997 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE GETMEM2 (NCOL, NROW, NSEC, NROT, NANNULI, PRJ_ADDR,
	1 PROJN_ADDR, TRP_ADDR, ITMP_ADDR, MAP3D_ADDR, PFFT_ADDR, 
	2 PMAP_ADDR, A_ADDR)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, NSEC, NROT, NANNULI
	INTEGER*4 MAP3D_ADDR, PRJ_ADDR, PROJN_ADDR, TRP_ADDR, ITMP_ADDR
	INTEGER*4 PFFT_ADDR, PMAP_ADDR, A_ADDR
	LOGICAL   STATUS, GET_VM, TEST
C  ----------------------------------------------------------------------------
C
	TEST   = .TRUE.
	STATUS = GET_VM (4*NCOL*NROW*NSEC, MAP3D_ADDR, 'MAP3D_ADDR')
	STATUS = GET_VM (4*NCOL*NROW,      PRJ_ADDR,   'PRJ_ADDR')
	STATUS = GET_VM (4*NCOL*NROW,      PROJN_ADDR, 'PROJN_ADDR')
	STATUS = GET_VM (4*NCOL*NROW,      TRP_ADDR,   'TRP_ADDR')
	STATUS = GET_VM (4*NCOL,           ITMP_ADDR,  'ITMP_ADDR')
	STATUS = GET_VM (4*2*NROT*NANNULI, PFFT_ADDR,  'PFFT_ADDR')
	STATUS = GET_VM (4*NROT*NANNULI,   PMAP_ADDR,  'PMAP_ADDR')
	STATUS = GET_VM (4*2*NROT,         A_ADDR,     'A_ADDR')
	IF(.NOT.TEST) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM2 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM3     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 16-JAN-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE GETMEM3 (NVIEW, NPIX, NROT, NANNULI, PFT_AVGS_ADDR, 
	1 SQ2_ADDR,VAR_ADDR, RMS_ADDR, AVER_ADDR, TMP_ADDR)
C
	IMPLICIT NONE
C
	INTEGER*4 NVIEW, NPIX, NROT, NANNULI, PFT_AVGS_ADDR, TMP_ADDR
	INTEGER*4 SQ2_ADDR, VAR_ADDR, RMS_ADDR, AVER_ADDR
	LOGICAL   STATUS, GET_VM, TEST
C  ----------------------------------------------------------------------------
C
	TEST   = .TRUE.
	STATUS = GET_VM (4*NVIEW,      PFT_AVGS_ADDR, 'PFT_AVGS_ADDR')
	STATUS = GET_VM (4*NVIEW,           SQ2_ADDR, 'SQ2_ADDR')
	STATUS = GET_VM (2*NPIX,            VAR_ADDR, 'VAR_ADDR')
	STATUS = GET_VM (4*NPIX,            RMS_ADDR, 'RMS_ADDR')
	STATUS = GET_VM (4*NPIX,           AVER_ADDR, 'AVER_ADDR')
	STATUS = GET_VM (NROT*NANNULI,      TMP_ADDR,  'TMP_ADDR')
	IF(.NOT.TEST) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM3 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM4     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 20-JAN-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE GETMEM4 (NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, 
	1 NVIEW, FFT1, FFT3, IMG, MAP, PRJ, PRJ_ROT, IMGPFT, PFFT, PMAP,
	2 FLTPMAP, PPRJ, A_ARRAY, CCOR, ICOR, ITMP)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, NVIEW
	INTEGER*2 IMG(1), ICOR(1), ITMP(1)
	REAL*4    FFT1(1), FFT3(1), MAP(1), PRJ(1), PRJ_ROT(1)
	REAL*4    IMGPFT(1), PFFT(1), PMAP(1), FLTPMAP(1)
	REAL*4    PPRJ(1), A(1), CCOR(1)
	POINTER   (FFT1_P,FFT1), (FFT3_P,FFT3), (IMG_P,IMG)
	POINTER   (MAP_P,MAP), (PRJ_P,PRJ), (PRJ_ROT_P,PRJ_ROT)
	POINTER   (IMGPFT_P,IMGPFT), (PFFT_P,PFFT), (PMAP_P,PMAP)
	POINTER   (FLTPMAP_P,FLTPMAP), (PPRJ_P,PPRJ), (A_P,A)
	POINTER   (CCOR_P,CCOR), (ICOR_P,ICOR), (ITMP_P,ITMP)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	FIDS_P    = MALLOC (4*NIDS_TOT)
	FFT1_P    = MALLOC (8*IDIM1*IDIM2,       FFT1, 'FFT1')       ! RAW IMAGE
	FFT3_P    = MALLOC (8*IDIM1*IDIM2,       FFT3, 'FFT3') ! MOD PRJ @ T,P,O
	IMG_P     = MALLOC (2*NCOL*NROW,          IMG, 'IMG')
	MAP_P     = MALLOC (4*NCOL*NROW,          MAP, 'MAP')
	PRJ_P     = MALLOC (4*NCOL*NROW,          PRJ, 'PRJ')
	PRJ_ROT_P = MALLOC (4*NCOL*NROW,      PRJ_ROT, 'PRJ_ROT')
	IMGPFT_P  = MALLOC (NROT*NANNULI,      IMGPFT, 'IMGPFT')
	PFFT_P    = MALLOC (4*2*NROT*NANNULI,    PFFT, 'PFFT')
	PMAP_P    = MALLOC (4*NROT*NANNULI,      PMAP, 'PMAP')
	FLTPMAP_P = MALLOC (4*NROT*NANNULI,   FLTPMAP, 'FLTPMAP')
	PPRJ_P    = MALLOC (4*NROT*NANNULI,      PPRJ, 'PPRJ')
	A_P       = MALLOC (4*2*NROT,         A_ARRAY, 'A_ARRAY')
	CCOR_P    = MALLOC (4*NVIEW,             CCOR, 'CCOR')
	ICOR_P    = MALLOC (2*NVIEW,             ICOR, 'ICOR')
	ITMP_P    = MALLOC (4*NCOL,              ITMP, 'ITMP')
	IF() THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM4 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE LIST_CCS     *****                *
C  *                                                                          *
C  *    COMPUTES AND THEN LISTS CORRELATION COEFFICIENTS AS A FUNCTION OF     *
C  *     PARTICLE RADIUS AND RESOLUTION.                                      *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 20-JAN-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE LIST_CCS (NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, 
	1 IMG, MSKIMG, MAP, FFT1, FFT3, FFT4, FFT5, PRJ_ROT, MSKPRJ, 
	2 PPRJ, PMAP, FLTPMAP, IMG_NUM, IMG_BKG, XCEN, YCEN, XCEN2, 
	3 YCEN2, FFT_ORIGX, FFT_ORIGY, RES_MIN, RES_MAX, ANN_LO, ANN_HI, 
	4 RADIUS, PIXRES_MAX, DEL_PIXRES, DEL_ANG, CC_AVG, CC_RES_GLOBAL, 
	5 CC_RAD_GLOBAL)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, IMG_NUM
	INTEGER*4 I, J, ANN_LO, ANN_HI, IMG_BKG, FFT_IEND
	INTEGER*2 IMG(NCOL,NROW), MSKIMG(NCOL,NROW)
	REAL*4    XCEN, YCEN, XCEN2, YCEN2, FFT_ORIGX, FFT_ORIGY, FFT_FZERO
	REAL*4    CCRES(2,20), CCRAD(2,200), DEL_PIXRES, RES_MIN, RES_MAX
	REAL*4    CC_RES_GLOBAL(2,20), CC_AVG, CC_RAD_GLOBAL(2,200)
	REAL*4    RADIUS, DEL_ANG, SUMRSQ, PIXRES_MAX
	REAL*4    FFT1(2*IDIM1,IDIM2), FFT3(2*IDIM1,IDIM2)
	REAL*4    FFT4(2*IDIM1,IDIM2), FFT5(2*IDIM1,IDIM2)
	REAL*4    MAP(NCOL,NROW), MSKPRJ(NCOL,NROW)
	REAL*4    PRJ_ROT(NCOL,NROW), FLTPMAP(NROT,NANNULI)
	REAL*4    PMAP(NROT,NANNULI), PPRJ(NROT,NANNULI)
	LOGICAL   FFT_FULL
C  ----------------------------------------------------------------------------
C
	CALL COPY_I2 (IMG, MSKIMG, NCOL*NROW)
	CALL IMG_MASK (MSKIMG, NCOL, NROW, ANN_LO, ANN_HI, XCEN, YCEN, 
	1 IMG_BKG)
	CALL IMG_FFT_FILL (MSKIMG, NCOL, NROW, FFT4, IDIM1, IDIM2, 
	1 IMG_BKG, FFT_ORIGX, FFT_ORIGY, FFT_FZERO, FFT_IEND, FFT_FULL, 0)
	CALL FFT_2D (FFT4, IDIM1, IDIM2)
	CALL COPY_R4 (PRJ_ROT, MSKPRJ, NCOL*NROW)
	CALL MAP_2DMASK (MSKPRJ, NCOL, NROW, FLOAT(ANN_LO), FLOAT(ANN_HI),
	1 XCEN2, YCEN2, 0.0)
	CALL MAP_FFT_FILL (MSKPRJ, NCOL, NROW, 1, 1, FFT5, IDIM1, IDIM2, 
	2 FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_IEND, FFT_FULL, 0)
	CALL FFT_2D (FFT5, IDIM1, IDIM2)
	CALL PFTCC_RES (FFT1, FFT3, FFT4, FFT5, IDIM1, IDIM2, CCRES, 
	2 DEL_PIXRES)
	CALL FFT_FLT (FFT1, IDIM1, IDIM2, RES_MIN, RES_MAX, 0.0, 0.0, .TRUE.)
	CALL FFT_2DBT (FFT1, IDIM1, IDIM2, IMG, NCOL, NROW, FFT_FULL, 
	1 IMG_BKG)
	CALL IMG_MAP (IMG, MAP, NCOL, NROW, IMG_BKG)
	CALL MAP_POLAR (MAP, NCOL, NROW, FLTPMAP, NROT, NANNULI, XCEN, 
	1 YCEN, 1.0, RADIUS, DEL_ANG)
	CALL MAP_POLAR (PRJ_ROT, NCOL, NROW, PPRJ, NROT, NANNULI, XCEN2, 
	1 YCEN2, 1.0, RADIUS, DEL_ANG)
	CALL PFTCC_RAD (PMAP, FLTPMAP, PPRJ, NROT, NANNULI, ANN_HI, CCRAD)
C
	SUMRSQ = 0.0
	DO I = 1,ANN_HI+1
	  CC_RAD_GLOBAL(1,I) = CC_RAD_GLOBAL(1,I) + CCRAD(1,I)
	  CC_RAD_GLOBAL(2,I) = CC_RAD_GLOBAL(2,I) + CCRAD(2,I)
	  IF(I.GE.ANN_LO) THEN
	    SUMRSQ = SUMRSQ + (I-1)**2
	    CC_AVG = CC_AVG + CCRAD(2,I)*(I-1)**2
	  ENDIF
	ENDDO
	IF(SUMRSQ.GT.0.0) THEN
	   CC_AVG = CC_AVG/SUMRSQ
	 ELSE
	   CC_AVG = 0.0
	ENDIF
	J = NINT(1/(PIXRES_MAX*DEL_PIXRES))
	DO I = 1,J
	  CC_RES_GLOBAL(1,I) = CC_RES_GLOBAL(1,I) + CCRES(1,I)
	  CC_RES_GLOBAL(2,I) = CC_RES_GLOBAL(2,I) + CCRES(2,I)
	ENDDO
	WRITE(8,'(I4,20F7.3)') IMG_NUM, (CCRES(1,I),I=1,J)
	WRITE(10,'(I4,20F7.3)') IMG_NUM, (CCRES(2,I),I=1,J)
	WRITE(9,'('' CCs vs radius for particle'',I4)') IMG_NUM
	WRITE(9,'(I4,2F7.3)') (I-1, CCRAD(1,I), CCRAD(2,I),
	1			   I=1,ANN_HI+1)
	WRITE(9,'(F7.3,'' = Average CC for ANN_LO,ANN_HI='',2I4)')
	1	  CC_AVG, ANN_LO, ANN_HI
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                *****     SUBROUTINE WRITE_PARAMS     *****               *
C  *                                                                          *
C  *    WRITES OUT THE CURRENT PARAMETER ARRAYS TO NEW PARAMETER FILES        *
C  *     FILES (UNIT = 11).                                                   *
C  *    ALSO NORMALIZES THE MAG SCALE FACTORS IF MAG_NORM SET = TO 1.         *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED  6-FEB-1998 BY T. BAKER (Add MAG normalization).        *
C  ****************************************************************************
C
	SUBROUTINE WRITE_PARAMS (NFILES, NIDS_TOT, FIDS, IDS, TS, PS, OS, 
	1 XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, PARAM_FNAMES, 
	2 IMG_FNAMES, MAG_NORM)
C	
	IMPLICIT NONE
C
	COMMON/CTF_STUFF/PIXSIZS, VOLTS, AMPFACS, DELF_MAJORS, 
	1 DELF_MINORS, ANG_DELFS, CS_COEFFS
C
	INTEGER*2 STRING_LEN
	INTEGER*4 NFILES, NIDS_TOT, FILE, FILE_LAST, MAG_NORM
	INTEGER*4 ID, FIDS(NIDS_TOT), IDS(NIDS_TOT)
	REAL*4    PIXSIZS(999), VOLTS(999), AMPFACS(999), CS_COEFFS(999)
	REAL*4    DELF_MAJORS(999), DELF_MINORS(999), ANG_MAJORS(999)
	REAL*4    ANG_DELFS(999), ANG_MAJOR, CS_COEFF, MAG_FACTOR
	REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
	REAL*4    PIXSIZ, VOLTAGE, AMPFAC, DELF_MAJOR, DELF_MINOR
	CHARACTER PARAM_FNAMES(999)*64, IMG_FILENAME*64, NEW_FNAME*64
	CHARACTER IMG_FNAMES(999)*64
C  ----------------------------------------------------------------------------
C
C  *****************************************************
C  *    NORMALIZE MAG SCALE FACTORS IF MAG_NORM = 1    *
C  *****************************************************
	IF(MAG_NORM.EQ.1) THEN
	  MAG_FACTOR = 0.0
	  DO ID = 1, NIDS_TOT
	    MAG_FACTOR = MAG_FACTOR + MAGS(ID)
	  ENDDO
	  MAG_FACTOR = MAG_FACTOR/FLOAT(NIDS_TOT)
	  WRITE(*,'(A,F8.4,A)') ' Mean of MAG scale factors (=', 
	1  MAG_FACTOR,') normalized to 1.0'
	  MAG_FACTOR = 1.0/MAG_FACTOR
	  DO ID = 1, NIDS_TOT
	    MAGS(ID) = MAGS(ID)*MAG_FACTOR
	  ENDDO
	ENDIF
C
	CALL INCREMENT_FNAME_ (PARAM_FNAMES(1), NEW_FNAME)
	OPEN (UNIT=11, FILE=NEW_FNAME, STATUS='NEW',
	1 ACCESS='SEQUENTIAL', FORM='FORMATTED')
	IMG_FILENAME = IMG_FNAMES(1)
	IF(IMG_FILENAME(1:1).EQ.' ') THEN
	   WRITE(11,'(A)') IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	 ELSE
	   WRITE(11,'(A)') ' '//IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	ENDIF
	WRITE(11,1010) PIXSIZS(1), VOLTS(1), AMPFACS(1), DELF_MAJORS(1),
	1 DELF_MINORS(1), ANG_MAJORS(1), CS_COEFFS(1)
	FILE_LAST = FIDS(1)
C
	DO ID = 1,NIDS_TOT
	  FILE = FIDS(ID)
	  IF(FILE_LAST.NE.FILE) THEN
	    CLOSE (UNIT=11, DISP='KEEP')
	    CALL INCREMENT_FNAME_ (PARAM_FNAMES(FILE), NEW_FNAME)
	    OPEN (UNIT=11, FILE=NEW_FNAME, STATUS='NEW',
	1         ACCESS='SEQUENTIAL', FORM='FORMATTED')
	    IMG_FILENAME = IMG_FNAMES(FILE)
	    IF(IMG_FILENAME(1:1).EQ.' ') THEN
	       WRITE(11,'(A)') IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	     ELSE
	       WRITE(11,'(A)') ' '//IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	    ENDIF
	    WRITE(11,1010) PIXSIZS(FILE), VOLTS(FILE), AMPFACS(FILE),
	1    DELF_MAJORS(FILE), DELF_MINORS(FILE), ANG_MAJORS(FILE),
	2    CS_COEFFS(FILE)
	    FILE_LAST = FIDS(ID)
	  ENDIF
	  WRITE(11,1020) IDS(ID), TS(ID), PS(ID), OS(ID), XS(ID), YS(ID),
	1  MAGS(ID), PFT_CCS(ID), PRJ_CCS(ID), CMP_CCS(ID)
	ENDDO
	CLOSE (UNIT=11, DISP='KEEP')
C
 	RETURN
 1000	FORMAT (1X,I6,',',4(F8.3,','),F7.3,',',3(F6.3,','),F6.3)
 1010	FORMAT (1X,F8.4,',',F10.1,',',3(F10.3,','),F10.4,',',F8.2)
 1020	FORMAT (1X,I6,',',4(F8.3,','),F7.3,',',3(F6.3,','),F6.3)
C
	END

C  *************************************************************************
C  *									   *
C  *             *****     SUBROUTINE PFT_ADJUST_NVIEW     *****           *
C  *									   *
C  *  If THETA = 0 or 180 then PHI is undetermined and there are (NPHI-1)  *
C  *  fewer possible orientations.  Adjust NVIEW accordingly.  It will be  *
C  *  changed back to the NTHE*NPHI value after the analysis is over.      *
C  *  (This reversion will occur in the main program.)  Used only in       *
C  *  REFINE mode.                                                         *
C  *									   *
C  *  D. Belnap, 30 Jan 1997, NIH					   *
C  *************************************************************************
C
	SUBROUTINE PFT_ADJUST_NVIEW (THETA1, THETA2, DEL_THE, NVIEW, NPHI)
C
	IMPLICIT NONE
C
	INTEGER*4 NVIEW, NPHI
	REAL*4    THE, THETA1, THETA2, DEL_THE
C ----------------------------------------------------------------------------
C
	THE = THETA1
	DO WHILE (THE.LE.THETA2)
	  IF (THE.EQ.0.0 .OR. THE.EQ.180.0)   NVIEW = NVIEW - NPHI + 1
	  THE = THE + DEL_THE
	ENDDO
C
	END

C  ****************************************************************************
C  *									      *
C  *               *****     SUBROUTINE PFT_CALC_AVGS     *****               *
C  *									      *
C  *  Computes average and std values of MAG, CC_PFT, CC_PRJ, and CC_CMP.     *
C  *									      *
C  *    D. Belnap, July 1996						      *
C  *    LAST MODIFIED  4-FEB-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE PFT_CALC_AVGS (NIDS_TOT, MAGS, PFTCCS, PRJCCS, CMPCCS)
C
	IMPLICIT NONE
C
	INTEGER*4 ID, NIDS_TOT
	REAL*4    MAGS(NIDS_TOT), MAGS_AVG, MAGS_STD
	REAL*4    PFTCCS(NIDS_TOT), PFTCC_AVG, PFTCC_STD
	REAL*4    PRJCCS(NIDS_TOT), PRJCC_AVG, PRJCC_STD
	REAL*4    CMPCCS(NIDS_TOT), CMPCC_AVG, CMPCC_STD
C -----------------------------------------------------------------------------
C
	IF(NIDS_TOT.LE.0) RETURN
C
	WRITE(*,100) NIDS_TOT
  100	FORMAT (' ====================================================',
	1	'=====',
	2       /,' Compute average MAG factor and coefficients,',
	3	' N = ',I7,/,
	4       ' ====================================================',
	5	'=====')
C  ***************************
C  *  Initialze parameters   *
C  ***************************
	MAGS_AVG  = 0.0
	MAGS_STD  = 0.0
	PFTCC_AVG = 0.0
	PFTCC_STD = 0.0
	PRJCC_AVG = 0.0
	PRJCC_STD = 0.0
	CMPCC_AVG = 0.0
	CMPCC_STD = 0.0
C
	DO ID = 1,NIDS_TOT
	  MAGS_AVG  = MAGS_AVG  + MAGS(ID)
	  PFTCC_AVG = PFTCC_AVG + PFTCCS(ID)
	  PRJCC_AVG = PRJCC_AVG + PRJCCS(ID)
	  CMPCC_AVG = CMPCC_AVG + CMPCCS(ID)
	ENDDO
	MAGS_AVG  = MAGS_AVG  / FLOAT(NIDS_TOT)
	PFTCC_AVG = PFTCC_AVG / FLOAT(NIDS_TOT)
	PRJCC_AVG = PRJCC_AVG / FLOAT(NIDS_TOT)
	CMPCC_AVG = CMPCC_AVG / FLOAT(NIDS_TOT)
C  ***************************************************************
C  *  Calculate and list coefficients and standard deviations    *
C  ***************************************************************
	IF(NIDS_TOT.GT.1) THEN
	  DO ID = 1,NIDS_TOT
	    MAGS_STD  =  MAGS_STD  + (MAGS(ID)   - MAGS_AVG)**2
	    PFTCC_STD =  PFTCC_STD + (PFTCCS(ID) - PFTCC_AVG)**2
	    PRJCC_STD =  PRJCC_STD + (PRJCCS(ID) - PRJCC_AVG)**2
	    CMPCC_STD =  CMPCC_STD + (CMPCCS(ID) - CMPCC_AVG)**2
	  ENDDO
	  MAGS_STD  = SQRT( MAGS_STD  / FLOAT(NIDS_TOT-1) )
	  PFTCC_STD = SQRT( PFTCC_STD / FLOAT(NIDS_TOT-1) )
	  PRJCC_STD = SQRT( PRJCC_STD / FLOAT(NIDS_TOT-1) )
	  CMPCC_STD = SQRT( CMPCC_STD / FLOAT(NIDS_TOT-1) )
	ENDIF
C
	WRITE(*,1000) '                     Average  Std. Dev.'
	WRITE(*,1000) '---------------------------------------'
	WRITE(*,1000) ' MAG factor      ', MAGS_AVG,  MAGS_STD
	WRITE(*,1000) ' PFT Coefficient ', PFTCC_AVG, PFTCC_STD
	WRITE(*,1000) ' PRJ Coefficient ', PRJCC_AVG, PRJCC_STD
	WRITE(*,1000) ' CMP Coefficient ', CMPCC_AVG, CMPCC_STD
 1000	FORMAT(A,2(F10.3))
C
	RETURN
	END

C  *************************************************************************
C  *									   *
C  *			   SUBROUTINE PFT_CALC_TP			   *
C  *									   *
C  *  Calculates THETA and PHI angles in the search window.  Taken from    *
C  *  PFTCC_FILL.                                                          *
C  *									   *
C  *  DEL_PHI = DEL_PHI_90 / sin(THE), avoids oversampling near THE=0,180  *
C  *  If THE=0,180 then PHI is undefined, here it is set to 0.0.           *
C  *									   *
C  *  D. Belnap, 30 Jan 1997, NIH					   *
C  *************************************************************************
C
	SUBROUTINE PFT_CALC_TP (THETA, PHI, THE1, THE2, PHI1, DEL_THE,
	1 DEL_PHI_90, NTH, NPH, NVIEW, SYM, MODE)
C
	IMPLICIT NONE
C
	INTEGER*4 NTH, NPH, NVIEW, SYM, MODE, NUM, ITHE, IPHI
	INTEGER*4 THE_OUTBOUNDS
	REAL*4    THETA(NVIEW), PHI(NVIEW), THE1, THE2, PHI1, DEL_THE
	REAL*4    DEL_PHI_90, DEL_PHI, THE, PH, PFT_PHIMAX
C ----------------------------------------------------------------------------
C
	NUM = 0
	THE = THE1
C
	IF (MODE.EQ.3) THEN					! REFINE MODE
	   DO ITHE = 1,NTH
	     IF (THE.EQ.0.0 .OR. THE.EQ.180.0) THEN
	        NUM = NUM + 1
	        THETA(NUM) = THE
	        PHI(NUM)   = 0.0
	      ELSE
	        DEL_PHI = DEL_PHI_90 / SIND(THE)
	        PH = PHI1 - DEL_PHI*(NPH/2)	    !If (REFINE), PHI1 = PHIIN
C	        ***************************************************************
C	        * In REFINE, THE may be <0 or >180, if so "special" treatment *
C	        ***************************************************************
	        IF (THE.LT.0.0) THEN
		   THE_OUTBOUNDS = 1
		   PH = PH + 180.0
		   THE = ABS(THE)
		 ELSE IF (THE.GT.180.0) THEN
		   THE_OUTBOUNDS = 2
		   PH = PH + 180.0
		   THE = 360.0 - THE
		 ELSE
		   THE_OUTBOUNDS = 0
	        ENDIF					!End if (THE < 0)
	        DO IPHI = 1,NPH
		  NUM 	     = NUM + 1
		  THETA(NUM) = THE
		  PHI(NUM)   = PH
		  PH 	     = PH + DEL_PHI
	        ENDDO
C               **********************************************
C---------------*  RESET THETA IF THE_OUTBOUNDS IS 1 OR 2    *
C               **********************************************
	        IF (THE_OUTBOUNDS.EQ.1) THE = -THE		! RESET THE 
	        IF (THE_OUTBOUNDS.EQ.2) THE = 360.0 - THE	! RESET THE 
	     ENDIF				!End if (THE = 0,180)
	     THE = THE + DEL_THE
	   ENDDO					!End do ITHE = 1,NTH
	 ELSE						   ! GLOBAL SEARCH MODE
	   NTH = NINT((THE2-THE1)/DEL_THE) + 1
	   DO ITHE = 1,NTH
	     IF (THE.EQ.0.0 .OR. THE.EQ.180.0) THEN
		NUM        = NUM + 1
		THETA(NUM) = THE
		PHI(NUM)   = 0.0
	      ELSE
		DEL_PHI = DEL_PHI_90 / SIND(THE)
		NPH = NINT((PFT_PHIMAX(SYM,THE)-PHI1)/DEL_PHI) + 1
		PH = PHI1
		DO IPHI = 1,NPH
		  NUM        = NUM + 1
		  THETA(NUM) = THE
		  PHI(NUM)   = PH
		  PH         = PH + DEL_PHI
		ENDDO
	     ENDIF
	     IF (SYM.EQ.532 .AND. THE.EQ.69.09484255211070) THEN
	        THE = 69.0 + DEL_THE		!DEL_THE unlikely to be < 0.1
	      ELSE
	        THE = THE + DEL_THE
	     ENDIF
	   ENDDO		!End do ITHE = 1,NTH
	ENDIF
C
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE PFT_GETNVIEW     *****                *
C  *                                                                           *
C  *    ROUTINE FOR CALCULATING NTHE AND NVIEW FOR GLOBAL MODES	               *
C  *                                                                           *
C  *	PURDUE UNIVERSITY DEC 3000, January 1994, D. Belnap.		       *
C  *    LAST MODIFIED 24-DEC-1997 BY T. BAKER (Use NVIEW variable).            *
C  *****************************************************************************
C
	SUBROUTINE PFT_GETNVIEW (SYM, DTHE, DPHI_90, NTHE, NVIEW)
C
	IMPLICIT NONE
C
	INTEGER*4  SYM, NTHE, NPHI, NVIEW, I
	REAL*4     DTHE, DPHI, DPHI_90, THETA, THE1, THE2, PHI1
	REAL*4     PFT_PHIMAX
C -----------------------------------------------------------------------------
C
	CALL PFT_GETT1T2P1 (SYM, THE1, THE2, PHI1)
	NTHE  = NINT((THE2-THE1)/DTHE) + 1
	THETA = THE1
	NVIEW = 0
	DO I = 1,NTHE
	  IF (THETA.EQ.0.0 .OR. THETA.EQ.180.0) THEN
	     NPHI = 1				!At THETA = 0 or 180, PHI = 0.0
	   ELSE
	     DPHI = DPHI_90 / SIND(THETA)
	     NPHI = NINT( (PFT_PHIMAX(SYM,THETA)-PHI1) / DPHI )  +  1
	  ENDIF
	  NVIEW = NVIEW + NPHI
	  IF (SYM.EQ.532 .AND. THETA.EQ.69.09484255211070) THEN
	     THETA = 69.0 + DTHE
	   ELSE
	     THETA = THETA + DTHE
	  ENDIF
	ENDDO
	END

C  ****************************************************************************
C  *                                                                          *
C  *                  *****     SUBROUTINE PFT_GETTPO     *****               *
C  *                                                                          *
C  *    DETERMINE THETA, PHI, AND OMEGA FOR CURRENT IMAGE.                    *
C  *                                                                          *
C  *    Protocol:                                                             *
C  *     1. Compute polar MAP (PMAP) from raw (Cartesian) IMAGE.              *
C  *     2. Compute polar FFT (PFT) from polar MAP.                           *
C  *     3. Convert image PFT to amplitudes & extract desired portion.        *
C  *     4. Find average value of image PFT (also termed particle PFT).       *
C  *     5. Cross-correlate particle PFT with all reference PFTS to get THETA *
C  *         and PHI (|PHI| for n22 and 532 symmetry, both THETA and PHI may  *
C  *         change if the object is asymmetric or n-fold.                    *
C  *     6. Read in the appropriate projection (PRJ) corresponding to THETA   *
C  *         and |PHI|.                                                       *
C  *     7. Convert PRJ to polar projection (PPRJ).                           *
C  *     8. Cross-correlate PPRJ with PMAP of raw IMAGE to determine sign of  *
C  *         PHI and value of OMEGA (also THETA if SYM=1-20).                 *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *                                                                          *
C  *    MODIFIED  6-FEB-1998 BY T. BAKER (Extracted subs from PFTCC).         *
C  *    LAST MODIFIED  6-FEB-1998 BY T. BAKER ().                             *
C  ****************************************************************************
C
	SUBROUTINE PFT_GETTPO (MODE, NCOL, NROW, NROT, NANNULI, NVIEW, 
	1  JCUT, ILIST, XCEN, YCEN, XCEN2, YCEN2, RADIUS, DEL_ANG, 
	2  PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, 
	3  SQ1, SQ2, THETA, PHI, THE_BEST, PHI_BEST, OME_BEST, DEL_PIXRES, 
	4  PFTS, PFT_AVGS, PRJS, PRJ_SCALEF, CC_PFT, CC_PRJ, MAP, PMAP, 
	5  PFFT, PRJ, PPRJ, IMGPFT, ITMP, ICOR, CCOR, A_ARRAY, FLIP,
	6  INDEX)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, NROT, NANNULI, JCUT, ILIST, MODE
	INTEGER*4 ANN_LO, ANN_HI, NVIEW, VAR(NROT,NANNULI), INDEX
	INTEGER*2 ICOR(NVIEW), ITMP(NCOL)
	REAL*4    XCEN, YCEN, XCEN2, YCEN2, PRJ_SCALEF, DEL_PIXRES
	REAL*4    RADIUS, DEL_ANG, PIXRES_MIN, PIXRES_MAX, CC_PFT, CC_PRJ
	REAL*4    PI, AVG, SQ1, THE_BEST, PHI_BEST, OME_BEST
	REAL*4    THETA(NVIEW), PHI(NVIEW), SQ2(NVIEW)
	REAL*4    MAP(NCOL,NROW), PRJ(NCOL,NROW), PMAP(NROT,NANNULI)
	REAL*4    PRJS(NCOL,NROW,NVIEW), PPRJ(NROT,NANNULI)
	REAL*4    PFFT(2*NROT,NANNULI), PFTS(NROT,NANNULI,NVIEW)
	REAL*4    CCOR(NVIEW), PFT_AVGS(NVIEW)
	REAL*4    A_ARRAY(NROT*2), IMGPFT((NROT/4),NANNULI)
	LOGICAL   FLIP, VAROPT
C -----------------------------------------------------------------------------
C
	CALL MAP_POLAR (MAP, NCOL, NROW, PMAP, NROT, NANNULI, XCEN, YCEN, 
	1 1.0, RADIUS, DEL_ANG)
C
	CALL PMAP_FFT (PMAP, PFFT, A_ARRAY, NROT, NANNULI)
C
	CALL PFTCC_CONVERT (PFFT, IMGPFT, NROT, NANNULI)
C
	CALL PFTCC_AVG (IMGPFT, NROT, NANNULI, JCUT, PIXRES_MIN, 
	1 PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, SQ1)
C
	CALL PFTCC_GETTP (IMGPFT, PFTS, PFT_AVGS, NROT, NANNULI, NVIEW, 
	1 SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, CC_PFT, ANN_LO, ANN_HI, 
	2 VAR, VAROPT, CCOR, ICOR, PI, DEL_PIXRES, AVG, SQ1, ILIST, INDEX)
	THE_BEST = THETA(INDEX)
	PHI_BEST = PHI(INDEX)
C
	CALL PFTCC_GETPRJ (PRJ, NCOL, NROW, ITMP, NVIEW, PRJS, MODE, 
	1 PRJ_SCALEF, INDEX)
C
	CALL MAP_POLAR (PRJ, NCOL, NROW, PPRJ, NROT, NANNULI, XCEN2, 
	1 YCEN2, 1.0, RADIUS, DEL_ANG)
C
	CALL PFTCC_GETPO (PMAP, PPRJ, NROT, NANNULI, DEL_ANG, OME_BEST, 
	1 ANN_LO, ANN_HI, FLIP, CC_PRJ, MODE)
C
	RETURN
	END

C  ******************************************************************
C  *                                                                *
C  *                    SUBROUTINE PFT_GETT1T2P1                    *
C  *                                                                *
C  *  Determines THE1, THE2, and PHI1 based on SYM chosen	    *
C  *                                                                *
C  *  PURDUE UNIVERSITY DEC 3000, Jan 1994, T. Baker and D. Belnap  *
C  *  Added SYM = 2-20, 30 Jan 1997, D. Belnap                      *
C  ******************************************************************
C
	SUBROUTINE PFT_GETT1T2P1 (SYM, THE1, THE2, PHI1)
C
	IMPLICIT NONE
C
	INTEGER*4 SYM
	REAL*4    THE1, THE2, PHI1
C  ----------------------------------------------------------------------------
C
C	**************************************************************
C	*  Initial values.  These are all correct for n22 symmetry.  *
C	**************************************************************
	THE1 = 0.0
	THE2 = 90.0
	PHI1 = 0.0
C	*******************************************************
C	*  Exceptions to the above values:                    *
C	*  SYM = 1    for asymmetric particle,                *
C	*       = 2-20 for particle with nfold about z-axis,  *
C	*       = 532  for icosahedral particle.              *
C	*******************************************************
	IF (SYM.GE.1 .AND. SYM.LE.20) THEN
	   THE2 = 180.0
	 ELSE IF (SYM.EQ.532) THEN
	   THE1 = 69.09484255211070
	ENDIF
C
	RETURN
	END

C  **************************************************************************
C  *                                                                        *
C  *                  *****   FUNCTION PFT_PHIMAX   *****                   *
C  *                                                                        *
C  *  Determines PFT_PHIMAX based on SYM chosen			            *
C  *                                                                        *
C  *  PURDUE UNIVERSITY DEC 3000, Jan,Jun 1994, T. Baker and D. Belnap      *
C  *  Added 222, 522, 622, & 722 symmetries, Dec 1996, Jan 1997, D. Belnap  *
C  *  Added 2-20 n-fold symmetries, 30 Jan 1997, D. Belnap                  *
C  **************************************************************************
C
	REAL*4 FUNCTION PFT_PHIMAX (SYM, THETA)
C
	IMPLICIT NONE
C
	INTEGER*4 SYM
	REAL*4    THETA
C -----------------------------------------------------------------------------
C
	PFT_PHIMAX = 180.0			      ! for asymmetric objects
	IF (SYM.EQ.532) THEN
	   CALL ICO_CALCPHIMAX(THETA, PFT_PHIMAX)
	 ELSE IF (SYM.GE.2 .AND. SYM.LE.20) THEN
	   PFT_PHIMAX = 360.0 / FLOAT(SYM*2)
	 ELSE IF (SYM.EQ.222) THEN
	   PFT_PHIMAX = 90.0
	 ELSE IF (SYM.EQ.522) THEN
	   PFT_PHIMAX = 36.0
	 ELSE IF (SYM.EQ.622) THEN
	   PFT_PHIMAX = 30.0
	 ELSE IF (SYM.EQ.722) THEN
	   PFT_PHIMAX = 360.0/14.0                            ! = 25.7143 deg.
	 ELSE IF (SYM.EQ.822) THEN
	   PFT_PHIMAX = 22.5
	ENDIF
	END

C  ****************************************************************************
C  *                                                                          *
C  *               *****     SUBROUTINE PFT_PRJSPFTS     *****                *
C  *                                                                          *
C  *    STEPS CARRIED OUT BY THIS ROUTINE:                                    *
C  *     1. PROJECT 3D MAP ALONG THETA,PHI,OMEGA(=90).                        *
C  *     2. SAVE 2D PROJECTION IN PRJ ARRAY OR DATA FILE.                     *
C  *     3. CONVERT 2D CARTESIAN PROJECTION MAP INTO 2D POLAR MAP.            *
C  *     4. FOURIER TRANSFORM THE POLAR MAP.                                  *
C  *     5. SAVE POLAR FFT IN PFTS ARRAY.                                     *
C  *                                                                          *
C  *    LOGICAL UNITS: 1 = REFERENCE 3D MAP                                   *
C  *                   3 = PRJ DATABASE FILE (DEFAULT = PFT.PRJS)             *
C  *                   4 = PFT DATABASE FILE (DEFAULT = PFT.PFTS)             *
C  *                                                                          *
C  *    AUGUST 1993  PURDUE UNIVERSITY VAX 4000/90, T. BAKER.                 *
C  *    MODIFIED 17-DEC-1997 BY T. BAKER (Rid of EM.CMM).                     *
C  *    LAST MODIFIED 23-DEC-1997 BY T. BAKER (ADD COMPRESSION CAPABILITY).   *
C  ****************************************************************************
C
	SUBROUTINE PFT_PRJSPFTS (NIMG, NCOL, NROW, NSEC, NROT, NANNULI, 
	1 PROJN, PRJ, MAP3D, THETA, PHI, TRP, PRJ_AVG, ITMP, PMAP, 
	2 XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, PFTRAD_HI, DEL_ANG, PFFT, 
	3 A, ALP, BET, GAM, MODE, PFTS, PRJS)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, NSEC, NIMG, MODE, NROT, NANNULI, ID
	INTEGER*4 I, J, ITMP(NCOL)
	REAL*4    DEL_ANG, XCEN_MODEL, YCEN_MODEL, ALP, BET, GAM
	REAL*4    PFTRAD_LO, PFTRAD_HI, THETA(NIMG), PHI(NIMG)
	REAL*4    PFFT(NROT*2,NANNULI), A(NROT*2)
	REAL*4    MAP3D(NCOL,NROW,NSEC), PROJN(NCOL,NROW)
	REAL*4    PRJ(NCOL,NROW), PMAP(NROT,NANNULI)
	REAL*4    PRJ_AVG(NCOL,NROW), TRP(NCOL,NROW)
	REAL*4    PRJS(NCOL,NROW,NIMG), PFTS((NROT/4),NANNULI,NIMG)
C  ----------------------------------------------------------------------------
C
	IF(MODE.NE.3) WRITE(*,1000)				! GLOBAL MODE
C
	DO ID = 1,NIMG
	  IF(MODE.NE.3) WRITE(*,1010) ID, THETA(ID), PHI(ID)	! GLOBAL MODE
C         **************************************************************
C---------*    NOTE USE OF OMEGA = 90.0 TO GET CORRECT ORIENTATIONS    *
C         **************************************************************
	  CALL MAP_PRJ (1, NCOL, NROW, NSEC, PROJN, PRJ, MAP3D,
	1  THETA(ID), PHI(ID), 90.0, 1.0, FLOAT(NSEC), ALP, BET, GAM)
	  CALL PFT_PRJS_STORE (PRJ, NCOL, NROW, TRP, ID, PRJ_AVG, 
	1  NIMG, ITMP, PRJS)
	  CALL MAP_POLAR (PRJ, NCOL, NROW, PMAP, NROT, NANNULI,
	1  XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, PFTRAD_HI, DEL_ANG)
	  CALL PMAP_FFT (PMAP, PFFT, A, NROT, NANNULI)
C         ************************************************
C---------*    Store current 2D PFFT in 3D PFTS array    *
C         ************************************************
	  DO I = 1,NANNULI
	    DO J = 1,(NROT/4)
	      PFTS(J,I,ID) = SQRT (PFFT(2*J-1,I)**2 + PFFT(2*J,I)**2)
	    ENDDO
	  ENDDO
	ENDDO
C
 1000	FORMAT('  View # Theta    Phi',/,21('-'),/)
 1010	FORMAT ('+',I5,F8.2,F7.2)
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE PFT_PRJS_STORE     *****              *
C  *                                                                           *
C  *    Computes PRJs and PRJ_AVG and stores data in core memory.              *
C  *                                                                           *
C  *    MODIFIED 16-APR-1996, BY DMB/CONWAY (Zero PRJ_AVG array on 1st PRJ     *
C  *    MODIFIED 30-DEC-1997 BY T. BAKER (Output PRJS to disk file).           *
C  *    LAST MODIFIED 14-JAN-1998 BY T. BAKER (Remove option to write to disk) *
C  *****************************************************************************
C
	SUBROUTINE PFT_PRJS_STORE (PRJ, NCOL, NROW, TRP, ID, PRJ_AVG, 
	1 NIMG, ITMP, PRJS)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, ID, I, J, NIMG, EM_WRT, ITMP(NCOL)
	REAL*4    PRJ(NCOL,NROW), TRP(NCOL,NROW), DIV
	REAL*4    PRJ_AVG(NCOL,NROW), PRJS(NCOL,NROW,NIMG)
	REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, XCEN_MOD, YCEN_MOD
C  ----------------------------------------------------------------------------
C
	IF(ID.EQ.1) THEN				! ZERO FOR NEW AVERAGE
	  DO J = 1,NROW
	    DO I = 1,NCOL
	      PRJ_AVG(I,J) = 0.0
	    ENDDO
	  ENDDO
	ENDIF
C
	DO J = 1,NROW
	  DO I = 1,NCOL
	    PRJS(I,J,ID) = PRJ(I,J)
	    PRJ_AVG(I,J) = PRJ_AVG(I,J) + PRJ(I,J)
	  ENDDO
	ENDDO
C  ****************************************************************************
C  *    SPECIAL CASE FOR CIRCULARLY AVERAGED PROJECTION    *
C  *********************************************************
	IF(ID.EQ.NIMG) THEN		 ! CIRCULARLY AVERAGE PRJ_AVG AND SAVE
	  DIV = FLOAT(NIMG)
	  DO J = 1,NROW
	    DO I = 1,NCOL
	      PRJ_AVG(I,J) = PRJ_AVG(I,J)/DIV		   ! TO NORMALIZE DATA
	    ENDDO
	  ENDDO
	  XCEN_MOD = (NCOL+1)/2
	  YCEN_MOD = (NROW+1)/2
	  EM_WRT = 0
	  CALL MAP_SYM (PRJ_AVG, NCOL, NROW, XCEN_MOD, YCEN_MOD, 101,
	1  MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, EM_WRT)
	ENDIF
C
	RETURN
	END

C  ****************************************************************************
	SUBROUTINE PFTCC_AVG (IMGPFT, NROT, NANNULI, JCUT, PIXRES_MIN,
	1 PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, SQ1)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 NROT, NANNULI, J, JN, RSAVE, JSAVE, JCUT, J2
        INTEGER*4 ANN_LO, ANN_HI, IR, R, VAR((NROT/4),NANNULI)
	REAL*4    PTS, IMGPFT((NROT/4),NANNULI), IMGPFT_MAX, AVG, SQ1
	REAL*4    PIXRES, PIXRES_MIN, PIXRES_MAX, PI, TWOPIR
	LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
	J2         = (NROT/4) - 1
	IMGPFT_MAX = R4_MIN
	AVG        =    0.0
	SQ1        =    0.0
        PTS        =    0.0
C
	DO IR = ANN_LO,ANN_HI
	  R      = MIN(NANNULI, IR+1)
	  TWOPIR = 2.0*PI*FLOAT(IR)
	  DO JN = JCUT,J2
	    IF(JN.GT.0) THEN				! TRAP FOR Jo
	       PIXRES = TWOPIR/FLOAT(JN)
	     ELSE
	       PIXRES = 1000.0
	    ENDIF
	    IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 100
	    J = JN + 1
            IF ((VAROPT.AND.VAR(J,R)) .OR. .NOT.VAROPT) THEN
              PTS = PTS + 1.0
	      AVG = AVG + IMGPFT(J,R)
	      SQ1 = SQ1 + IMGPFT(J,R)**2
	      IF(IMGPFT(J,R).GT.IMGPFT_MAX) THEN
	        IMGPFT_MAX = IMGPFT(J,R)
	        RSAVE      = R
	        JSAVE      = J
	      ENDIF
            ENDIF
  100	  ENDDO
	ENDDO
	AVG = AVG/PTS
C
CCC	PRINT *
CCC	PRINT *, 'The maximum peak in the polar-FFT, outside the Jo is:'
CCC	PRINT *, 'RADIUS            =', JSAVE-1
CCC	PRINT *, 'SPATIAL FREQUENCY =', RSAVE-1
CCC	PRINT *, 'VALUE AT POINT    =', IMGPFT(RSAVE,JSAVE)
CCC	PRINT *
CCC	PRINT *,'Average (excluding orders < JCUT & annuli < ANN_LO) =',AVG
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *               *****     SUBROUTINE PFTCC_AVGFFT       *****               *
C  *                                                                           *
C  *    FOURIER TRANSFORM THE CIRCULARLY AVERAGED PROJECTION AVERAGE.          *
C  *    IF MODE.LT.0, READ IN THE CIRCULARLY AVERAGED PROJECTION AVERAGE FROM  *
C  *    DISK FILE.                                                             *
C  *                                                                           *
C  *  MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                          *
C  *  MODIFIED 15-DEC-1997 BY T. BAKER (Rid of EM.CMM).                        *
C  *  MODIFIED 23-DEC-1997 BY T. BAKER (Memory version of PRJ_AVG).            *
C  *  MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PRJ_AVG).                *
C  *  LAST MODIFIED 26-FEB-1998 BY TSB (Add UNIX compatibility).               *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_AVGFFT (PRJ_AVG, NCOL, NROW, NVIEW, ITMP, FFT2,
	1 IDIM1, IDIM2, FFT_ORIGX, FFT_ORIGY, MODE, PRJ_SCALEF)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	INTEGER*4 NCOL, NROW, NVIEW, I, J, IDIM1, IDIM2, MODE, BIN
	INTEGER*4 ITMP(NCOL), FFT_IEND, IMGOFFSET, SEC1, SEC2
	INTEGER*4 CONVTSB
	REAL*4    PRJ_AVG(NCOL,NROW), FFT2(2*IDIM1,IDIM2)
	REAL*4    FFT_ORIGX, FFT_ORIGY, FFT_FZERO, PRJ_SCALEF
	LOGICAL   FFT_FULL
C  ----------------------------------------------------------------------------
C
	IF(MODE.LT.0) THEN			      ! USE DATA STORED ON DISK
	  CALL MAP_CLEAR (PRJ_AVG, NCOL, NROW, 1)
C         ********************************************************
C---------*  Note: The average projection is the NVIEW + 1       *
C         *        projection stored in the *.PIF format file.   *
C         ********************************************************
	  BIN     = 1
	  CONVTSB = 0
	  SEC1    = NVIEW + 1
	  SEC2    = NVIEW + 1
	  CALL PIF_READ_MAPI4 (PRJHEAD, PRJ_AVG, SEC1, SEC2, CONVTSB, 
	1  BIN) 
CRWA	  NSECS = 1
CRWA	  PRJHEAD.NUMSECS = 1
CRWA	  IMGOFFSET = 1024 + ((NVIEW)*NCOL*NROW*4)
CRWA	  CALL PIF_READ_MAP_INT_IMAGE_ (3, PRJ_AVG, IMGOFFSET, NCOL, 
CRWA	1  NROW, NSECS, 0, PRJ_SCALEF, P_MIN, P_MAX, 1)
	ENDIF
C
	CALL MAP_FFT_FILL (PRJ_AVG, NCOL, NROW, 1, 1, FFT2, IDIM1, 
	1 IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_IEND, FFT_FULL, 0)
	CALL FFT_2D (FFT2, IDIM1, IDIM2)
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *               *****     SUBROUTINE PFTCC_CONVERT       *****              *
C  *                                                                           *
C  *    CONVERT PFT TO AMPLITUDES FROM A AND B PARTS.                          *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *    LAST MODIFIED 20-JAN-1998 BY T. BAKER.                                 *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_CONVERT (PFFT, IMGPFT, NROT, NANNULI)
C
	IMPLICIT NONE
C
	INTEGER*4 I, J, NROT, NANNULI
	REAL*4    IMGPFT((NROT/4),NANNULI), PFFT(2*NROT,NANNULI)
C  ----------------------------------------------------------------------------
C
        DO I = 1, NANNULI
          DO J = 1,(NROT/4)
	    IMGPFT(J,I) = SQRT (PFFT(2*J-1,I)**2 + PFFT(2*J,I)**2)
	  ENDDO
	ENDDO
	END

C  *****************************************************************************
C  *                                                                           *
C  *                 *****     SUBROUTINE PFTCC_FILL     *****                 *
C  *                                                                           *
C  *    READ IN THE ENTIRE DATA SET OF POLAR FFTS FOR THE CHOSEN               *
C  *     SEARCH WINDOW.                                                        *
C  *                                                                           *
C  *  DECEMBER 1987  PURDUE UNIVERSITY VAX 11/750, T. BAKER                    *
C  *  MAY 1992  PURDUE UNIVERSITY VAX 8550, J. TESMER.                         *
C  *  Moved THETA,PHI calculations to PFT_CALC_TP, 30 Jan 1997, D. Belnap      *
C  *  MODIFIED 19-DEC-1997 BY T. BAKER (Some output stuff).                    *
C  *  MODIFIED 23-DEC-1997 BY T. BAKER (Using memory for PFTS).                *
C  *  MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PFTs/PRJs).              *
C  *  LAST MODIFIED 26-FEB-1998 BY TSB (Add UNIX compatibility).               *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_FILL (MODE, PFTS, PFT_AVGS, NROT, NANNULI, 
	1 NVIEW, SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, 
	2 VAR, RMS, AVER, VAROPT, SIGCUT, TMP, PFT_SCALEF)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	INTEGER*4 NROT, NANNULI, NVIEW, I, J, JN, K, JCUT, J2, MODE
	INTEGER*4 ANN_LO, ANN_HI, IR, R, NUM, VAR((NROT/4),NANNULI)
	INTEGER*4 SEC1, SEC2, NROT_BY_4, BIN, CONVTSB
	REAL*4    RMS((NROT/4),NANNULI), AVER((NROT/4),NANNULI)
CCC	REAL*4    TMP(NROT/4), PFTS((NROT/4),NANNULI,NVIEW), TMP2, SIGCUT
	REAL*4    TMP((NROT/4),NANNULI), PFTS((NROT/4),NANNULI,NVIEW)
	REAL*4    TMP2, SIGCUT
	REAL*4    PFT_AVGS(NVIEW), PERCENT, PTS, AVE, AVE2, SQ2(NVIEW)
	REAL*4    PI, RADIAN, DEGREE, TWOPIR, PFT_SCALEF
	REAL*4    PIXRES, PIXRES_MIN, PIXRES_MAX, P_MIN, P_MAX
	LOGICAL   VAROPT, NOTIFY
C  ----------------------------------------------------------------------------
C
	BIN       = 1
	CONVTSB   = 0
	NROT_BY_4 = NROT/4
C
	CALL PIRADDEG (PI, RADIAN, DEGREE)
	IF(MODE.LT.0) THEN
	   PRINT *, '*************************************************'
	   PRINT *, '* Load PFT data from disk file into core memory *'
	   PRINT *, '*************************************************'
	   PERCENT = 0.0
	   NOTIFY = .TRUE.
	   WRITE(6,'(F6.1,''% done'')') PERCENT
	 ELSE
	   NOTIFY = .FALSE.
	ENDIF
C
	J2  = NROT_BY_4 - 1
        PTS = 0.0
C
	DO K = 1,NVIEW
	  PTS = 0.0
	  IF(MODE.LT.0) THEN
C           **********************************************
C-----------*    Let's read in just this section.        *
C           **********************************************
	    SEC1 = K
	    SEC2 = K
	    CALL PIF_READ_MAPI4 (PFTHEAD, TMP, SEC1, SEC2, CONVTSB, BIN)
CRWA	    NSECS       = 1
CRWA	    THISANNULUS = 1
CRWA	    IMGOFFSET   = 1024 + ((K-1)*NANNULI*NROT) + ((J-1)*NROT)
CRWA	    CALL PIF_READ_MAP_INT_IMAGE_ (4, TMP, IMGOFFSET, NROT_BY_4, 
CRWA	1    THISANNULUS, NSECS, 0, PFT_SCALEF, P_MIN, P_MAX, 1)
	    DO J = 1,NANNULI
	      DO I = 1,NROT_BY_4
	        PFTS(I,J,K) = TMP(I,J)
	      ENDDO
	    ENDDO
	  ENDIF
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR+1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 200
	      J    = JN + 1
	      PTS  = PTS + 1.0
              TMP2 = PFTS(J,R,K)
              IF(VAROPT) THEN
                AVER(J,R) = AVER(J,R) + TMP2
                VAR(J,R)  = 0
              ENDIF
  200	    ENDDO
	  ENDDO
	  IF(NOTIFY) THEN
	    PERCENT = 100.0*FLOAT(K)/FLOAT(NVIEW)
	    IF(MOD(K,10).EQ.0) THEN
	      WRITE(6,'(''+'',F5.1,''% done'')') PERCENT
	    ENDIF
	  ENDIF
	ENDDO
	IF(NOTIFY)  WRITE(6,'(A)') '+Finished loading data into memory'
C
        AVE2 = 0.0
        IF(VAROPT) THEN
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR+1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 300
	      J        = JN + 1
              RMS(J,R) = 0.0
	      AVE      = AVER(J,R)/FLOAT(NVIEW)
              DO K = 1,NVIEW
                TMP2     = PFTS(J,R,K)
                RMS(J,R) = RMS(J,R) + (TMP2-AVE)**2
	      ENDDO
              RMS(J,R) = SQRT(RMS(J,R)/NVIEW)
              AVE2     = AVE2 + RMS(J,R)
  300	    ENDDO
	  ENDDO
          NUM  = 0
          AVE2 = AVE2/PTS
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR + 1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 400
	      J = JN + 1
              IF (RMS(J,R).GT.SIGCUT*AVE2) THEN
                VAR(J,R) = 1
                NUM      = NUM + 1 
              ENDIF
  400	    ENDDO
	  ENDDO
C
	  PRINT *,'VARIANCE:'
	  PRINT *,'USING POINTS > ',SIGCUT,'*',AVE2
	  PRINT *,'POINTS FROM PFFT BEING USED: ',NUM
        ENDIF
C
	DO K = 1,NVIEW
	  PTS         = 0.0
	  PFT_AVGS(K) = 0.0
          SQ2(K)      = 0.0
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR+1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 500
	      J = JN + 1
              IF((VAROPT.AND.VAR(J,R)) .OR. .NOT.VAROPT) THEN
	        PTS         = PTS + 1.0
                TMP2        = PFTS(J,R,K)
	        PFT_AVGS(K) = PFT_AVGS(K) + TMP2
	        SQ2(K)      = SQ2(K) + TMP2**2
              ENDIF
  500	    ENDDO
	  ENDDO
	  PFT_AVGS(K) = PFT_AVGS(K)/PTS
	ENDDO
C
	RETURN
	END

C  ***************************************************************************
C  *                                                                         *
C  *                 *****     SUBROUTINE PFTCC_GETMAG     *****             *
C  *                                                                         *
C  *	Compares an image against a model 2D projection over a range of      *
C  *    magnifications.  Returns the MAG factor with the best PRJ/IMG        *
C  *    correlation.  Correlation done in real space.	                     *
C  *								             *
C  *	Modified from IMG_CMP_PRJ, July 1996, by D. Belnap                   *
C  *    LAST MODIFIED  8-JAN-1998 BY T. BAKER (CHANGED FROM SCALE TO MAG)    *
C  ***************************************************************************
C
	SUBROUTINE PFTCC_GETMAG (IMG, PRJ, TMP, FFTI, FFTM, NCOL,
	1 NROW, IDIM1, IDIM2, RADLO, RADHI, RESMIN, RESMAX, X_CEN, 
	2 Y_CEN, OME_BEST, MAG_LO, MAG_NUM, MAG_STEP, BEST_MAG,
	3 BEST_CCOEF, IMG_BKG, FFT_ORIGX, FFT_ORIGY)
C
	IMPLICIT NONE
C
	INTEGER*4 I, J, K, NCOL, NROW, IDIM1, IDIM2, MAG_NUM, IMG_BKG
	INTEGER*4 FFT_IEND
	INTEGER*2 IMG(NCOL,NROW)
	REAL*4    TOT, PRJ(NCOL,NROW), TMP(NCOL,NROW)
	REAL*4    FFTI(2*IDIM1,IDIM2), FFTM(2*IDIM1,IDIM2)
	REAL*4    MAG, MAG_STEP, MAG_LO, X_CEN, Y_CEN, RESMIN, RESMAX
	REAL*4    CCOEF, BEST_CCOEF, BEST_MAG, OME_BEST, A, B
	REAL*4    RADLO, RADHI, RADDSQ, RADLOSQ, RADHISQ, YSQ
	REAL*4    FFT_ORIGX, FFT_ORIGY, FFT_FZERO
	REAL*8    SUMA, SUMB, SUMASQ, SUMBSQ, SUMAB
	LOGICAL   FFT_FULL
C  ---------------------------------------------------------------------------
C
C  *******************************
C  *    Initialize parameters    *
C  *******************************
	RADLOSQ    = RADLO*RADLO
	RADHISQ    = RADHI*RADHI
	BEST_CCOEF = 0.0
	BEST_MAG   = 1.0
C  **************************************************************
C  *  Filter in reciprocal space if RESMIN or RESMAX are > 0.0  *
C  **************************************************************
	IF (RESMIN.GT.0.0 .OR. RESMAX.GT.0.0) THEN
	  CALL IMG_FFT_FILL (IMG, NCOL, NROW, FFTI, IDIM1, IDIM2,
	1  IMG_BKG, FFT_ORIGX, FFT_ORIGY, FFT_FZERO, FFT_IEND, FFT_FULL, 
	2  0)
	  CALL MAP_FFT_FILL (PRJ, NCOL, NROW, 1, 1, FFTM, IDIM1, IDIM2, 
	1  FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_IEND, FFT_FULL, 0)
	  CALL FFT_2D (FFTI, IDIM1, IDIM2)
	  CALL FFT_2D (FFTM, IDIM1, IDIM2)
	  IF (RESMAX.GT.0.0) THEN
	    CALL FFT_LOP (FFTI, IDIM1, IDIM2, RESMAX, 0.0, .TRUE.)
	    CALL FFT_LOP (FFTM, IDIM1, IDIM2, RESMAX, 0.0, .TRUE.)
	  ENDIF
	  IF (RESMIN.GT.0.0) THEN
	    CALL FFT_HIP (FFTI, IDIM1, IDIM2, RESMIN, 0.0, .TRUE.)
	    CALL FFT_HIP (FFTM, IDIM1, IDIM2, RESMIN, 0.0, .TRUE.)
	  ENDIF
	  CALL FFT_2D_BACK (FFTI, IDIM1, IDIM2)		       ! Back-transform
	  CALL FFT_2D_BACK (FFTM, IDIM1, IDIM2)		       ! Back-transform
	  CALL FFT_IMG_FILL (FFTI, IDIM1, IDIM2, IMG, NCOL, NROW,
	1  FFT_FULL, IMG_BKG, 0)
	  CALL FFT_MAP_FILL (FFTM, IDIM1, IDIM2, PRJ, NCOL, NROW, 1, 1,
	1  FFT_FULL, 0)
	ENDIF
C  ***************************************************************
C  *    LOOP THROUGH SPECIFIED MAGNIFICATION SCALE FACTOR RANGE  *
C  ***************************************************************
	MAG = MAG_LO
	DO I = 1,MAG_NUM		! INITIALIZE PARAMETERS FOR EACH LOOP
	  SUMA    = 0.0
	  SUMB    = 0.0
	  SUMAB   = 0.0
	  SUMASQ  = 0.0
	  SUMBSQ  = 0.0
	  TOT     = 0.0
	  DO K = 1,NROW		         ! Load PRJ ("Gold standard") into TMP
	    DO J = 1,NCOL
	      TMP(J,K) = PRJ(J,K)
	    ENDDO
	  ENDDO
C	  *******************************************************
C	  *  Scale projection and move it to X,Y origin of IMG  *
C	  *******************************************************
	  CALL INTERP2D (TMP, NCOL, NROW, X_CEN, Y_CEN,
	1  FLOAT(NCOL-1)/2.0, FLOAT(NROW-1)/2.0, OME_BEST, MAG, 0.0)
C	  **********************************************************
C	  *  Loop through IMG and PRJ, get values for coefficient  *
C	  *  calculation, J and K must be within RADLO and RADHI   *
C	  **********************************************************
	  DO K = 1,NROW
	    YSQ = (FLOAT(K)-Y_CEN+1.0)**2
	    DO J = 1,NCOL
	      RADDSQ = (FLOAT(J)-X_CEN+1.0)**2 + YSQ
	      IF(RADDSQ.GE.RADLOSQ .AND. RADDSQ.LE.RADHISQ) THEN
		A      = FLOAT(IMG(J,K) - IMG_BKG)
		B      = TMP(J,K)
		SUMA   = SUMA + A
		SUMB   = SUMB + B
		SUMAB  = SUMAB + A*B
		SUMASQ = SUMASQ + A*A
		SUMBSQ = SUMBSQ + B*B
		TOT    = TOT + 1.0
	      ENDIF
	    ENDDO
	  ENDDO
C	  *************************************
C	  *  Compute correlation coefficient  *
C	  *************************************
	  IF(TOT.EQ.0. .OR. (SUMASQ-SUMA*SUMA).EQ.0. .OR.
	1  (SUMBSQ-SUMB*SUMB).EQ.0.) THEN
	     CCOEF = 1.0E-20
	   ELSE
	     CCOEF = (SUMAB - (SUMA*SUMB)/TOT) /
	1            (SQRT(SUMASQ - (SUMA*SUMA)/TOT)*
	2             SQRT(SUMBSQ - (SUMB*SUMB)/TOT))
	  ENDIF
	  IF(ABS(CCOEF).GT.ABS(BEST_CCOEF)) THEN	! Test for best CCOEF
	    BEST_CCOEF = CCOEF
	    BEST_MAG   = MAG
	  ENDIF
D	  WRITE(6,'('' CCOEF, MAG ='',2F10.4)') CCOEF, MAG
	  MAG = MAG + MAG_STEP			     ! Increment MAG i DO loop
	ENDDO
C
 999	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                 *****     SUBROUTINE PFTCC_GETPO     *****                *
C  *                                                                           *
C  *    FIND BEST OMEGA VALUE AND TEST FOR BEST PHI (POSITIVE OR NEGATIVE).    *
C  *                                                                           *
C  *    NOTE: REAL SPACE CORRELATION COEFFICIENTS ARE USED.                    *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *	Output CCPRJ_BEST, June 1996, D. Belnap                                *
C  *    LAST MODIFIED 29-DEC-1997 BY T. BAKER (Minor cleanup).                 *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_GETPO (PMAP, PPRJ, NROT, NANNULI, DEL_ANG,
	1 OME_BEST, ANN_LO, ANN_HI, FLIP, CCPRJ_BEST, MODE)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 NROT, NANNULI, I, II, J, ANN_LO, ANN_HI, IXOFF
	INTEGER*4 XBEST1, XBEST2, MODE
	REAL*4    PMAP(NROT,NANNULI), PPRJ(NROT,NANNULI), TOT, DEL_ANG
	REAL*4    A, B, SUMA, SUMB, SUMAB, SUMASQ, SUMBSQ, DIFFERENCE
	REAL*4    CCPRJ, CCPRJ_MAX1, CCPRJ_MAX2, CCPRJ_BEST
	REAL*4    OMEGA1, OMEGA2, OME_BEST
	LOGICAL   FLIP
C  -----------------------------------------------------------------------------
C
	CCPRJ_MAX1 = R4_MIN
	CCPRJ_MAX2 = R4_MIN
	SUMA       = 0.0
	SUMB       = 0.0
	TOT        = 0.0
C
	DO J = ANN_LO,ANN_HI
	  DO I = 1,NROT
	    SUMA = SUMA + PMAP(I,J+1)*J
	    SUMB = SUMB + PPRJ(I,J+1)*J
	    TOT  = TOT + 1.0
	  ENDDO
	ENDDO
C  ********************************************
C  *    CHECK FOR POSITIVE PHI ANGLE FIRST    *
C  ********************************************
	DO IXOFF = 0,NROT-1
	  SUMAB  = 0.0
	  SUMASQ = 0.0
	  SUMBSQ = 0.0
	  DO J = ANN_LO,ANN_HI
	    DO I = 1,NROT
	      II     = I + IXOFF
	      IF(II.GT.NROT) II = II - NROT
	      A      = PMAP(I,J+1)*J
	      B      = PPRJ(II,J+1)*J
	      SUMAB  = SUMAB  + A*B
	      SUMASQ = SUMASQ + A*A
	      SUMBSQ = SUMBSQ + B*B
	    ENDDO
	  ENDDO
	  CCPRJ = (SUMAB - (SUMA*SUMB)/TOT) /
	1         (SQRT(SUMASQ - (SUMA*SUMA)/TOT)*
	2         SQRT(SUMBSQ - (SUMB*SUMB)/TOT))
CCC	  WRITE(6,'('' IX,CCPRJ ='',I4,F10.3)') IXOFF, CCPRJ
	  IF(CCPRJ.GT.CCPRJ_MAX1) THEN
	    CCPRJ_MAX1 = CCPRJ
	    XBEST1     = IXOFF
	  ENDIF
	ENDDO
	OMEGA1 = 360.0 - DEL_ANG*XBEST1
CCC	WRITE(6,'('' OMEGA1,CCPRJ ='',F8.1,F10.3)') OMEGA1, CCPRJ_MAX1
C	************************************************************
C-------*  If in REFINEMENT mode, FLIP = .FALSE., exit subroutine  *
C	************************************************************
	IF(MODE.EQ.3) THEN
	  FLIP       = .FALSE.
	  OME_BEST   = OMEGA1
	  CCPRJ_BEST = CCPRJ_MAX1
	  RETURN
	ENDIF
C  ******************************************
C  *    NOW CHECK FOR NEGATIVE PHI ANGLE    *
C  ******************************************
	DO IXOFF = 0,NROT-1
	  SUMAB  = 0.0
	  SUMASQ = 0.0
	  SUMBSQ = 0.0
	  DO J = ANN_LO,ANN_HI
	    DO I = 1,NROT
	      II     = I + IXOFF
	      II     = NROT + 1 - I - IXOFF
	      IF(II.LE.0) II = II + NROT
	      A      = PMAP(I,J+1)*J
	      B      = PPRJ(II,J+1)*J
	      SUMAB  = SUMAB  + A*B
	      SUMASQ = SUMASQ + A*A
	      SUMBSQ = SUMBSQ + B*B
	    ENDDO
	  ENDDO
	  CCPRJ = (SUMAB - (SUMA*SUMB)/TOT) /
	1         (SQRT(SUMASQ - (SUMA*SUMA)/TOT)*
	2         SQRT(SUMBSQ - (SUMB*SUMB)/TOT))
CCC	WRITE(6,'('' IX,CCPRJ ='',I4,F10.3)') IXOFF, CCPRJ
	  IF(CCPRJ.GT.CCPRJ_MAX2) THEN
	    CCPRJ_MAX2 = CCPRJ
	    XBEST2     = IXOFF
	  ENDIF
	ENDDO
	OMEGA2 = 360.0 - DEL_ANG*XBEST2
CCC	WRITE(6,'('' OMEGA2,CCPRJ ='',F8.1,F10.3)') OMEGA2, CCPRJ_MAX2
C
Ca      Calculate the difference between max2 and max1.  If it's 
Ca      significant at all then see if we have to flip it or not.
Ca      We put this in because there are subtle precision differences
Ca      between out SGI Indigo (IRIX 5.3) and our Alpha VAX (VMS 6.1).	
C
        difference = ABS(ccprj_max2 - ccprj_max1)
        if(difference .gt. 0.0001) then
	  IF(CCPRJ_MAX2.GT.CCPRJ_MAX1) THEN
	     FLIP       = .TRUE.
	     OME_BEST   = OMEGA2
	     CCPRJ_BEST = CCPRJ_MAX2
	  ELSE
	     FLIP       = .FALSE.
	     OME_BEST   = OMEGA1
	     CCPRJ_BEST = CCPRJ_MAX1
	  ENDIF
	ELSE
	   FLIP       = .FALSE.
	   OME_BEST   = OMEGA1
	   CCPRJ_BEST = CCPRJ_MAX1
	ENDIF
C
CCC	PRINT *,'CCPRJ_BEST,FLIP = ',CCPRJ_BEST,FLIP
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *               *****     SUBROUTINE PFTCC_GETPRJ       *****               *
C  *                                                                           *
C  *    READ IN THE APPROPRIATE PROJECTION FOR CROSS-CORRELATION WITH THE      *
C  *     RAW IMAGE.                                                            *
C  *                                                                           *
C  *    ADDITIONAL TEST FOR DO-LOOP: NUM.LE.NVIEW (KAD)                        *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *  MODIFIED 23-DEC-1997 BY T. BAKER (Using PRJS in memory).                 *
C  *  MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PFTs/PRJs).              *
C  *  MODIFIED  6-FEB-1998 BY TSB (Use of INDEX instead of T/P arrays).        *
C  *  LAST MODIFIED 26-FEB-1998 BY TSB (Add UNIX compatibility).               *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_GETPRJ (PRJ, NCOL, NROW, ITMP, NVIEW, PRJS, 
	1 MODE, PRJ_SCALEF, INDEX)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	INTEGER*4 NCOL, NROW, I, J, NUM, NVIEW, MODE, ITMP(NCOL)
	INTEGER*4 IMGOFFSET, SEC1, SEC2, INDEX, CONVTSB, BIN
	REAL*4    PRJ(NCOL,NROW), PRJS(NCOL,NROW,NVIEW)
	REAL*4    P_MIN, P_MAX, PRJ_SCALEF
C  ----------------------------------------------------------------------------
C
	CONVTSB = 0
	BIN     = 1 
C  **********************************************************************
C  *    Just read the section desired - calculate the section wanted    *
C  *     by using the offset and using nsecs==1.                        *
C  **********************************************************************
  100	IF(MODE.EQ.-1 .OR. MODE.EQ.-2) THEN	      ! PRJ DATA STORED ON DISK
	   SEC1 = INDEX
	   SEC2 = INDEX
	   CALL PIF_READ_MAPI4 (PRJHEAD, PRJ, SEC1, SEC2, CONVTSB, BIN)
CRWA	   NSECS     = 1
CRWA	   IMGOFFSET = 1024 + (NCOL*NROW*(INDEX-1)*4)
CRWA	   CALL PIF_READ_MAP_INT_IMAGE_ (3, PRJ, IMGOFFSET, NCOL, 
CRWA	1   NROW, NSECS, 0, PRJ_SCALEF, P_MIN, P_MAX, 1)
	 ELSE				      ! PRJ DATA ALREADY IN CORE MEMORY
	   DO J = 1,NROW
	     DO I = 1,NCOL
	       PRJ(I,J) = PRJS(I,J,INDEX)
	     ENDDO
	   ENDDO
	ENDIF
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE PFTCC_GETTP     *****                 *
C  *                                                                           *
C  *    DETERMINES THE BEST THETA,PHI ORIENTATION.                             *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *    MODIFIED 18-AUG-1993 BY T. BAKER.                                      *
C  *	Last modified April 1996 by D. Belnap., fixed bug in extended output   *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_GETTP (IMGPFT, PFTS, PFT_AVGS, NROT, NANNULI, 
	1 NVIEW, SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, CCPFT, ANN_LO, 
	2 ANN_HI, VAR, VAROPT, CCOR, ICOR, PI, DEL_PIXRES, AVG, SQ1, 
	3 ILIST, INDEX)
C
	IMPLICIT NONE
C
	INCLUDE '../libEM/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 INDEX, NROT, NANNULI, NVIEW, I, J, K, J2, ILIST, JN
	INTEGER*4 JCUT, VAR((NROT/4),NANNULI), ANN_LO, ANN_HI, NRAD
	INTEGER*2 ICOR(NVIEW), IR, R, NLIM, NRES
	PARAMETER (NLIM=200)
	REAL*4    IMGPFT((NROT/4),NANNULI), PFTS((NROT/4),NANNULI,NVIEW)
CCC	REAL*4    THETA(NVIEW), PHI(NVIEW), THE_BEST, PHI_BEST
	REAL*4    TOT, AMIN, AMAX
	REAL*4    CCOR(NVIEW), PFT_AVGS(NVIEW), NPTS, PTS(NLIM)
	REAL*4    AVG, SQ1, SQ2(NVIEW), CCPFT, DIV1, DIV2, PI
	REAL*4    DUM1, DUM2
	REAL*4    CCRES(50), CCRAD(NLIM), DEL_PIXRES, TWOPIR, TOTS(NLIM)
	REAL*4    AVG3(NLIM), AVG4(NLIM), SQ3(NLIM), SQ4(NLIM)
	REAL*4    PIXRES, PIXRES_MIN, PIXRES_MAX
	LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
C  *********************************
C  *    INITIALIZE "CCOR" ARRAY    *
C  *********************************
	DO K = 1,NVIEW
	  CCOR(K) = R4_MIN
	ENDDO
C
	J2 = (NROT/4) - 1
C
	DO K = 1,NVIEW
	  NPTS = 0.0
	  TOT  = 0.0
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR + 1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 300
	      J = JN + 1
              IF((VAROPT .AND.VAR(J,R)) .OR. .NOT.VAROPT) THEN
                NPTS = NPTS + 1.0
	        TOT  = TOT + IMGPFT(J,R)*PFTS(J,R,K)
              ENDIF
  300	    ENDDO
	  ENDDO
	  DIV1    = SQRT (SQ1 - NPTS*(AVG**2))
	  DIV2    = SQRT (SQ2(K)-NPTS*(PFT_AVGS(K)**2))
	  CCOR(K) = (TOT-AVG*PFT_AVGS(K)*NPTS)/(DIV1*DIV2)
	ENDDO
C
	AMAX = R4_MIN
	AMIN = R4_MAX
C
	DO K = 1,NVIEW
	  IF(CCOR(K).GT.AMAX) THEN
	    AMAX  = CCOR(K)
	    INDEX = K
	  ENDIF
	  IF(CCOR(K).LT.AMIN .AND. CCOR(K).NE.R4_MIN) AMIN = CCOR(K)
	ENDDO
C
	CCPFT    = AMAX
C  ****************************************************************
C  *    If ILIST > 0, then compute and print extra information    *
C  ****************************************************************
	IF(ILIST.LT.1) RETURN
ccc
ccc	I commented out the ILIST = 1 code, 30 Dec 1996.  D. Belnap
ccc
C	*********************************************************************
C	*    COMPUTE CORRELATION COEFFICIENTS AS A FUNCTION OF PIXEL RES    *
C	*********************************************************************
c	DO I = 1,NLIM
c	  PTS(I)  = 0.0
c	  TOTS(I) = 0.0
c	  SQ3(I)  = 0.0
c	  SQ4(I)  = 0.0
c	  AVG3(I) = 0.0
c	  AVG4(I) = 0.0
c	ENDDO
C
c	NRES = 0
c	DO K = 1,NVIEW
c	  IF(THETA(K).EQ.THE_BEST .AND. PHI(K).EQ.PHI_BEST) THEN
c	    DO IR = ANN_LO,ANN_HI
c	      R      = min(NANNULI, IR + 1)
c	      TWOPIR = 2.0*PI*FLOAT(IR)
c	      DO JN = JCUT,J2
c	        IF(JN.GT.0) THEN			! TRAP FOR Jo
c	           PIXRES = TWOPIR/FLOAT(JN)
c	         ELSE
c	           PIXRES = 1000.0
c	        ENDIF
c	        IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 400
c	        I = INT(1.0/(PIXRES*DEL_PIXRES)) + 1
c	        IF(I.GT.50) GO TO 400
c	        IF(I.GT.NRES) NRES = I
c	        J = JN + 1
c               IF((VAROPT .AND.VAR(J,R)) .OR. .NOT.VAROPT) THEN
c                PTS(I)  = PTS(I) + 1.0
c	          AVG3(I) = AVG3(I) + IMGPFT(J,R)
c	          AVG4(I) = AVG4(I) + PFTS(J,R,K)
c	          TOTS(I) = TOTS(I) + IMGPFT(J,R)*PFTS(J,R,K)
c	          SQ3(I)  = SQ3(I) + IMGPFT(J,R)**2
c	          SQ4(I)  = SQ4(I) + PFTS(J,R,K)**2
c               ENDIF
c  400	      ENDDO
c	    ENDDO
c	    DO I = 1,NRES
c	      IF(PTS(I).LE.0.0) THEN
c	        AVG3(I) = 0.0
c	        AVG4(I) = 0.0
c	       ELSE
c	         AVG3(I) = AVG3(I)/PTS(I)
c	         AVG4(I) = AVG4(I)/PTS(I)
c	      ENDIF
c	      DUM1 = SQ3(I) - PTS(I)*(AVG3(I)**2)
c	      DUM2 = SQ4(I) - PTS(I)*(AVG4(I)**2)
c	      IF(DUM1.LE.0.0 .OR. DUM2.LE.0.0) THEN
c	         CCRES(I) = 0.0
c	       ELSE
c	         DIV1 = SQRT (DUM1)
c	         DIV2 = SQRT (DUM2)
c	         CCRES(I) = (TOTS(I)-AVG3(I)*AVG4(I)*PTS(I)) /
c	1                              (DIV1*DIV2)
c	      ENDIF
c	      WRITE(6,'(F6.3,F8.3,F10.0,F10.1)') I*DEL_PIXRES,
c	1      CCRES(I), PTS(I), AVG3(I)
c	    ENDDO
c	    GO TO 500
c	  ENDIF
c	ENDDO
C
C	******************************************************************
C	*    COMPUTE CORRELATION COEFFICIENTS AS A FUNCTION OF RADIUS    *
C	******************************************************************
c  500	DO I = 1,NLIM
c	  PTS(I)   = 0.0
c	  TOTS(I)  = 0.0
c	  SQ3(I)   = 0.0
c	  SQ4(I)   = 0.0
c	  AVG3(I)  = 0.0
c	  AVG4(I)  = 0.0
c	  CCRAD(I) = 0.0
c	ENDDO
C
c	NRAD     = 0
c	DO K = 1,NVIEW
c	  IF(THETA(K).EQ.THE_BEST .AND. PHI(K).EQ.PHI_BEST) THEN
c	    DO IR = ANN_LO,ANN_HI
c	      R      = min(NANNULI, IR + 1)
c	      TWOPIR = 2.0*PI*FLOAT(IR)
c	      DO JN = JCUT,J2
c	        IF(JN.GT.0) THEN			! TRAP FOR Jo
c	           PIXRES = TWOPIR/FLOAT(JN)
c	         ELSE
c	           PIXRES = 1000.0
c	        ENDIF
c	        IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 600
c	        I = R
c	        IF(I.GT.NLIM) GO TO 600
c	        IF(I.GT.NRAD) NRAD = I
c	        J = JN + 1
c               IF((VAROPT .AND.VAR(J,R)) .OR. .NOT.VAROPT) THEN
c                PTS(I)  = PTS(I) + 1.0
c	          AVG3(I) = AVG3(I) + IMGPFT(J,R)
c	          AVG4(I) = AVG4(I) + PFTS(J,R,K)
c	          TOTS(I) = TOTS(I) + IMGPFT(J,R)*PFTS(J,R,K)
c	          SQ3(I)  = SQ3(I) + IMGPFT(J,R)**2
c	          SQ4(I)  = SQ4(I) + PFTS(J,R,K)**2
c               ENDIF
c  600	      ENDDO
c	    ENDDO
c	    DO I = 1,NRAD
c	      IF(PTS(I).LE.0.0) THEN
c	        AVG3(I) = 0.0
c	        AVG4(I) = 0.0
c	       ELSE
c	         AVG3(I) = AVG3(I)/PTS(I)
c	         AVG4(I) = AVG4(I)/PTS(I)
c	      ENDIF
c	      DUM1 = SQ3(I) - PTS(I)*(AVG3(I)**2)
c	      DUM2 = SQ4(I) - PTS(I)*(AVG4(I)**2)
c	      IF(DUM1.LE.0.0 .OR. DUM2.LE.0.0) THEN
c	         CCRAD(I) = 0.0
c	       ELSE
c	         DIV1 = SQRT (DUM1)
c	         DIV2 = SQRT (DUM2)
c	         CCRAD(I) = (TOTS(I)-AVG3(I)*AVG4(I)*PTS(I)) /
c	1                   (DIV1*DIV2)
c	      ENDIF
c	      WRITE(6,'(I5,F8.3,F10.0,F10.1)') (I-1), CCRAD(I),
c	1           PTS(I), AVG3(I)
c	    ENDDO
c	    WRITE(6,'('' Overall CC ='',F8.3)') CCPFT
c	    GO TO 900
c	  ENDIF
c	ENDDO
C
C	*************************************************************
C	*  If ILIST = 2, print out CCs for each of the NVIEW views  *
C	*************************************************************
  900	IF(ILIST.NE.2)  RETURN
C
	PRINT *,'ABS(Sum of differences (with JCUT and ANN_LO ))'
	PRINT *
	PRINT *,'Num           THETA(Num)     PHI(Num)         ICOR(Num)'
	PRINT *,'-------------------------------------------------------'
	DO K = 1,NVIEW
	  IF(CCOR(K).NE.R4_MIN) THEN
	     ICOR(K) = NINT( (CCOR(K)-AMIN)*100.0/(AMAX-AMIN) )
	   ELSE
	     ICOR(K) = 0
	  ENDIF
CCC	WRITE(6,1000) K, THETA(K), PHI(K), ICOR(K)
	ENDDO
	PRINT *
	PRINT *
C
 1000	FORMAT (I9, '     ',F10.3,'    ',F10.3,'       ',I9)
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE PFTCC_GETXY     *****                 *
C  *                                                                           *
C  *    ROUTINE FOR ESTIMATING THE ORIGINS OF ICOSAHEDRAL PARTICLES BY         *
C  *     CROSS-CORRELATION WITH CIRCULARLY-AVERAGED REFERENCE.                 *
C  *                                                                           *
C  *    NOTE: "RES_MIN" here = 1.0 (NO CHOICE ALLOWED)                         *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *    LAST MODIFIED 17-DEC-1997 BY T. BAKER (Rid of EM.CMM).                 *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_GETXY (FFT1, FFT2, XCEN, YCEN, IDIM1, IDIM2,
	1 RES_MAX, FFT_ORIGX, FFT_ORIGY)
C
	IMPLICIT NONE
C
	INTEGER*4 IDIM1, IDIM2, CC_MAP, EM_WRT
	REAL*4    RES_MAX, XCEN, YCEN, FFT_ORIGX, FFT_ORIGY
	REAL*4    FFT1(2*IDIM1,IDIM2), FFT2(2*IDIM1,IDIM2)
	REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
	LOGICAL   STATUS, GET_VM, FREE_VM
C  ----------------------------------------------------------------------------
C
	EM_WRT = 0
	STATUS = GET_VM (4*IDIM1*IDIM2, CC_MAP, 'CC_MAP')
	CALL CCF_FFT (FFT1, FFT2, %VAL(CC_MAP), IDIM1, IDIM2, 1.0,
	1 RES_MAX, MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, EM_WRT)
	CALL PFTCC_PEAK (%VAL(CC_MAP), IDIM1, IDIM2, XCEN, YCEN,
	1 FFT_ORIGX, FFT_ORIGY)
	STATUS = FREE_VM (4*IDIM1*IDIM2, CC_MAP, 'CC_MAP')
C
	RETURN
	END

C  ******************************************************************
C  *                                                                *
C  *           *****     SUBROUTINE PFTCC_PEAK     *****            *
C  *                                                                *
C  *    SUBROUTINE FIND PEAK OF CROSS-CORRELATION "MAP".            *
C  ******************************************************************
C
	SUBROUTINE PFTCC_PEAK (CC_MAP, NCOL, NROW, XCEN, YCEN, FFT_ORIGX,
	1 FFT_ORIGY)
C
	IMPLICIT NONE
C
	INTEGER*4 IX, IY, IPX, IPY, NCOL, NROW
	INTEGER*2 I, J, IPEAKX, IPEAKY
	REAL*4    AMPS(15,15), XCEN, YCEN, PEAK, FFT_ORIGX, FFT_ORIGY
	REAL*4    HALFX, HALFY, CC_MAP(NCOL,NROW), PEAKX, PEAKY
C  ----------------------------------------------------------------------------
C
	CALL MAP_PEAK (CC_MAP, NCOL, NROW, IPX, IPY, PEAK)
C
	HALFX = FLOAT(NCOL)/2.0
	HALFY = FLOAT(NROW)/2.0
C
	DO J = 1,15				 ! LOAD CONTOUR ARRAY WITH AMPS
	  IY = IPY + (J-8)
	  IF(IY.LE.0)    IY = IY + NROW
	  IF(IY.GT.NROW) IY = IY - NROW
	  DO I = 1,15
	    IX = IPX + (I-8)
	    IF(IX.LE.0)    IX = IX + NCOL
	    IF(IX.GT.NCOL) IX = IX - NCOL
	    AMPS(I,J) = CC_MAP(IX,IY)
	  ENDDO
	ENDDO
CCC	DO J = 15,1,-1
CCC	  WRITE(6,'(1X,15I4))') (NINT(AMPS(I,J)),I=1,15)
CCC	ENDDO
	IPEAKX = IPX - 1
	IPEAKY = IPY - 1
	IF(IPEAKX.GT.INT(HALFX)) IPEAKX = IPEAKX - NCOL
	IF(IPEAKY.GT.INT(HALFY)) IPEAKY = IPEAKY - NROW
	CALL TRUS_POLYS (AMPS, IPEAKX, IPEAKY, PEAKX, PEAKY)
	XCEN = FFT_ORIGX - PEAKX
	YCEN = FFT_ORIGY - PEAKY
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                 *****     SUBROUTINE PFTCC_RAD     *****                  *
C  *                                                                           *
C  *    FIND CORRELATION COEFICIENTS AS FUNCTION OF ANNULUS(RADIUS).           *
C  *                                                                           *
C  *    NOTE: REAL SPACE CORRELATION COEFFICIENTS ARE USED.                    *
C  *                                                                           *
C  *    FEBRUARY 1993  PURDUE UNIVERSITY VAX 8550, T. BAKER.                   *
C  *    LAST MODIFIED 15-FEB-1993 BY T. BAKER.                                 *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_RAD (PMAP, FLTPMAP, PPRJ, NROT, NANNULI, 
	1 ANN_HI, CC)
C
	IMPLICIT NONE
C
	INTEGER*4 NROT, NANNULI, I, II, J, ANN_HI
	REAL*8    SUM12(2,200), SQ1(200), SQ2(200), SQ3(200)
	REAL*4    PMAP(NROT,NANNULI), PPRJ(NROT,NANNULI)
	REAL*4    FLTPMAP(NROT,NANNULI), DIV1, DIV2, DIV3
	REAL*4    CC(2,200), AVG1(200), AVG2(200), AVG3(200)
C  ----------------------------------------------------------------------------
C
	DO I = 1,MIN(NANNULI, ANN_HI+1)
	  AVG1(I) = 0.0
	  AVG2(I) = 0.0
	  AVG3(I) = 0.0
	  SQ1(I)  = 0.0
	  SQ2(I)  = 0.0
	  SQ3(I)  = 0.0
	  DO II = 1,2
	    CC(II,I)    = 0.0
	    SUM12(II,I) = 0.0
	  ENDDO
	  DO J = 1,NROT
	    SUM12(1,I) = SUM12(1,I) + PMAP(J,I)*PPRJ(J,I)
	    SUM12(2,I) = SUM12(2,I) + FLTPMAP(J,I)*PPRJ(J,I)
	    AVG1(I)    = AVG1(I) + PMAP(J,I)
	    AVG2(I)    = AVG2(I) + PPRJ(J,I)
	    AVG3(I)    = AVG3(I) + FLTPMAP(J,I)
	    SQ1(I)     = SQ1(I) + PMAP(J,I)**2
	    SQ2(I)     = SQ2(I) + PPRJ(J,I)**2
	    SQ3(I)     = SQ3(I) + FLTPMAP(J,I)**2
	  ENDDO
	  AVG1(I) = AVG1(I)/FLOAT(NROT)
	  AVG2(I) = AVG2(I)/FLOAT(NROT)
	  AVG3(I) = AVG3(I)/FLOAT(NROT)
	  DIV1    = SQ1(I) - FLOAT(NROT)*(AVG1(I)**2)
	  DIV2    = SQ2(I) - FLOAT(NROT)*(AVG2(I)**2)
	  DIV3    = SQ3(I) - FLOAT(NROT)*(AVG3(I)**2)
	  DIV1    = sign(SQRT(abs(DIV1)), DIV1)
	  DIV2    = sign(SQRT(abs(DIV2)), DIV2)
	  DIV3    = sign(SQRT(abs(DIV3)), DIV3)
	  IF(DIV1*DIV2.LE.0.0) THEN
	     CC(1,I) = 0.0
	   ELSE
	     CC(1,I) = (SUM12(1,I)-AVG1(I)*AVG2(I)*FLOAT(NROT)) /
	1                        (DIV1*DIV2)
	  ENDIF
	  IF(DIV3*DIV2.LE.0.0) THEN
	     CC(2,I) = 0.0
	   ELSE
	     CC(2,I) = (SUM12(2,I)-AVG3(I)*AVG2(I)*FLOAT(NROT)) /
	1                        (DIV3*DIV2)
	  ENDIF
	ENDDO
C
	RETURN
	END

	SUBROUTINE PFTCC_RES (FFT1, FFT3, FFT4, FFT5, IDIM1, IDIM2, CC,
	1 DEL_PIXRES)
C
	IMPLICIT NONE
C
	INTEGER*4 IDIM1, IDIM2, IX, IY, XX, BIN, IXTEST
	INTEGER*4 I, J, IX2, IY2
	REAL*4    CC(2,20), RES, YSQ
	REAL*4    FFT1(2*IDIM1,IDIM2), FFT3(2*IDIM1,IDIM2)
	REAL*4    FFT4(2*IDIM1,IDIM2), FFT5(2*IDIM1,IDIM2)
	REAL*4    DEL_PIXRES, SUM13(20), SUM45(20), PTS(20)
	REAL*4    AVG1(20), AVG3(20), AVG4(20), AVG5(20)
	REAL*4    SQ1(20), SQ3(20), SQ4(20), SQ5(20)
	REAL*4    DIV1, DIV3, DIV4, DIV5, AMP1, AMP3, AMP4, AMP5
C  ----------------------------------------------------------------------------
C
	IXTEST  = IDIM1/2
C
C  ***************************
C  *    INITIALIZE ARRAYS    *
C  ***************************
	DO I = 1,20
	  DO J = 1,2
	    CC(J,I)    = 0.0
	  ENDDO
	  PTS(I)   = 0.0
	  SUM13(I) = 0.0
	  SUM45(I) = 0.0
	  AVG1(I)  = 0.0
	  AVG3(I)  = 0.0
	  AVG4(I)  = 0.0
	  AVG5(I)  = 0.0
	  SQ1(I)   = 0.0
	  SQ3(I)   = 0.0
	  SQ4(I)   = 0.0
	  SQ5(I)   = 0.0
	ENDDO
C
	IY2 = (IDIM2/2) + 1
	DO IY = 1,IY2
	  YSQ = FLOAT(IY-1)**2
	  IX2 = IDIM1
	  IF(IY.EQ.1 .OR. IY.EQ.IY2) THEN
	    IX2 = IDIM1/2
	  ENDIF
	  DO IX = 1,IX2
	    IF(IY.EQ.1 .AND. IX.EQ.1) GO TO 100
	    XX = (IX-1)*2 + 1
	    IF(IX.GT.IXTEST) THEN
	       RES = SQRT ( YSQ + FLOAT(IDIM1-IX+1)**2 ) 
	     ELSE
	       RES = SQRT ( YSQ + FLOAT(IX-1)**2 )
	    ENDIF
	    AMP1 = SQRT(FFT1(XX,IY)**2 + FFT1(XX+1,IY)**2)
	    AMP3 = SQRT(FFT3(XX,IY)**2 + FFT3(XX+1,IY)**2)
	    AMP4 = SQRT(FFT4(XX,IY)**2 + FFT4(XX+1,IY)**2)
	    AMP5 = SQRT(FFT5(XX,IY)**2 + FFT5(XX+1,IY)**2)
	    BIN        = INT( RES/(IDIM1*DEL_PIXRES) ) + 1
	    IF(BIN.GT.20) GO TO 100
	    PTS(BIN)   = PTS(BIN) + 1.0
	    SUM13(BIN) = SUM13(BIN) + AMP1*AMP3
	    SUM45(BIN) = SUM45(BIN) + AMP4*AMP5
	    AVG1(BIN)  = AVG1(BIN) + AMP1
	    AVG3(BIN)  = AVG3(BIN) + AMP3
	    AVG4(BIN)  = AVG4(BIN) + AMP4
	    AVG5(BIN)  = AVG5(BIN) + AMP5
	    SQ1(BIN)   = SQ1(BIN) + AMP1**2
	    SQ3(BIN)   = SQ3(BIN) + AMP3**2
	    SQ4(BIN)   = SQ4(BIN) + AMP4**2
	    SQ5(BIN)   = SQ5(BIN) + AMP5**2
  100	  ENDDO
	ENDDO
C
	DO I = 1,20
	  IF(PTS(I).LE.0.0) THEN
	     AVG1(I) = 0.0
	     AVG3(I) = 0.0
	     AVG4(I) = 0.0
	     AVG5(I) = 0.0
	   ELSE
	     AVG1(I) = AVG1(I)/PTS(I)
	     AVG3(I) = AVG3(I)/PTS(I)
	     AVG4(I) = AVG4(I)/PTS(I)
	     AVG5(I) = AVG5(I)/PTS(I)
	  ENDIF
	  DIV1 = SQ1(I) - PTS(I)*(AVG1(I)**2)
	  DIV3 = SQ3(I) - PTS(I)*(AVG3(I)**2)
	  DIV4 = SQ4(I) - PTS(I)*(AVG4(I)**2)
	  DIV5 = SQ5(I) - PTS(I)*(AVG5(I)**2)
	  DIV1 = sign(SQRT(abs(DIV1)), DIV1)
	  DIV3 = sign(SQRT(abs(DIV3)), DIV3)
	  DIV4 = sign(SQRT(abs(DIV4)), DIV4)
	  DIV5 = sign(SQRT(abs(DIV5)), DIV5)
	  IF(DIV1*DIV3.LE.0.0) THEN
	     CC(1,I) = 0.0
	   ELSE
	     CC(1,I) = (SUM13(I)-AVG1(I)*AVG3(I)*PTS(I))/(DIV1*DIV3)
	  ENDIF
	  IF(DIV4*DIV5.LE.0.0) THEN
	     CC(2,I) = 0.0
	   ELSE
	     CC(2,I) = (SUM45(I)-AVG4(I)*AVG5(I)*PTS(I))/(DIV4*DIV5)
	  ENDIF
	ENDDO
C
	RETURN
	END
