C  *****************************************************************************
C  *                                                                           *
C  *            *****     SUBROUTINE Fill_FFT_cent     *****                   *
C  *                                                                           *
C  *    Rearrange "Fourier style" packed data (array_in) into normal style     *
C  *    image with center in the middle of the array (array_out)               *
C  *    This is especially useful for CC style maps                            *
C  *                                                                           *
C  *    December 2003 MBS  PURDUE UNIVERSITY                                   *
C  *                                                                           *
C  *    LAST MODIFIED 10-Dec-2003 BY M. Sherman                                *
C  *****************************************************************************
	subroutine Rearrange_FFT_Style(idim1, idim2, array_in, array_out) 

	implicit none

	integer*4 idim1, idim2
	integer*4 row, col
	integer*4 i, j, idim1d2, idim2p1, idim2d2

	real*4    array_in (idim1, idim2)
	real*4    array_out(-idim1/2+1:idim1,-idim2/2+1:idim2)

	idim1d2 = idim1/2
	idim2p1 = idim2   + 1
	idim2d2 = idim2/2

	do j = 1, idim2
	   row = j
	   if(row .gt. idim2d2) row = j - idim2
           do i = 1, idim1
              col = i
              if(col .gt. idim1d2) col = i - idim1
              array_out(col,row) = array_in(i,j)
           end do
	end do
	return
	end
