/*--------------------------------------------------------------
 *  $RCSfile: pho_txt_d.h,v $
 *
 *  $Date: 1998/07/21 19:10:10 $
 *  $Author: rwa $
 *  $Locker:  $
 *  $Revision: 1.1 $
 *  $Source: /bio/reo/rwa/devel/phodis_convert/RCS/pho_txt_d.h,v $
 *  $State: Exp $
 *
 *--------------------------------------------------------------
 *--------------------------------------------------------------
 */

#ifndef  _PHO_TXT_D_
#define  _PHO_TXT_D_


/* PHODIS ERROR DESCRIPTION */
/* STEREOPLOTTER substitutes PH with ST */
/* ORTHOPROJECTION substitutes PH with OP */
/* SCANNER substitutes PH with SC */
/* ARCHIEVE substitutes PH with AR */

/* PHD_   PHODIS Disaster 
   PHE_   PHODIS Error
   PHW_   PHODIS Warning
   PHM_   PHODIS Message */
   

/* EXIT status for programs */

#define   PHD_CANTEXECVPNEWPROC    -199 /* Can't execute process %s */
#define   PHD_ILLEGALTASK          -200 /* Illegal task %s ! */
#define   PHD_ILLEGALSTARTID       -201 /* Illegal start ID for process %s ! */
#define   PHD_CANTATTACHSHM        -202 /* Can't attach SHM with key : %s ! */
#define   PHD_CANTWRTSIGNAL        -203 /* Can't write signal to process \
                                            ( pid = %s ) ! */
#define   PHD_CANTWRTMSG           -204 /* Can't write message to pid : %s ! */
#define   PHD_INITPROCESSFAILED    -205 /* Initializing process %s failed ! */
#define   PHD_FATALINITERROR       -206 /* Fatal error when initializing \
                                           process ( pid = %s ) ! */
#define   PHD_PROCKILLEDBYUSER     -207 /* Unexpected process end detectd \n \
                                           Process may be killed by user */
#define   PHD_PROCTERMUNEXPECTED   -208 /* Process %s terminates unexpectedly ! */
/* Licenses */

#define   PHD_LICEXIT              -300 /* Sorry , no license to run this program !\n\n \
                                           Please contact our software support :\n \
                                           c/o Carl Zeiss\n \
                                           Photogrammetric Dep.\n \
                                           73446 Oberkochen\n \
                                           Germany\n \
                                           Phone : ++49 7364 202653\n \
                                           Fax   : ++49 7364 204665\n\n \
                                           Carl Zeiss Inc  Englewood\n \
                                           Phone : ++1 303 799 6838\n \
                                           Fax   : ++1 303 799 8159\n\n \
                                           Carl Zeiss Pte. Ltd.  Singapore\n \
                                           Phone : ++65 741 9600\n \
                                           Fax   : ++65 842 7117 */
#define   PHD_LICMISSKEY           -301 /* Missing license loadkey */
#define   PHD_LICFILENOTFOUND      -302 /* License file not found */
#define   PHD_LICMISSENVIRON       -303 /* Environment variable PHO_LOADKEY not found */
#define   PHD_LICFILEREADERR       -304 /* License file read error */
#define   PHD_LICFILEWRHEADER      -305 /* License file has wrong header */
#define   PHD_LICALREADYINIT       -306 /* License management system already initialized */
#define   PHD_LICNOTINIT           -307 /* License management system is not initialized */
#define   PHD_LICWRONGETHER        -308 /* Get system id failed */
#define   PHD_LICETHERMISSMATCH    -309 /* System id mismatch */
#define   PHD_LICNOTFOUND          -310 /* No license found */
#define   PHM_LICNUMBER            -311 /* License number is %s */



/* IPC Errors */

#define   PHD_MALLOCERROR          -1000 /* No memory to allocate ! */
#define   PHD_SHMOVERFLOW          -1001 /* Data overflow in SHM ! */
#define   PHD_SHMILLEGALDATA       -1002 /* Illegal data in SHM ! */
#define   PHE_SHMDATATOLONG        -1003 /* Data in SHM too long ! */
#define   PHE_SHMNOTATTACHED       -1004 /* SHM is not attached %s ! \n \
                                            Error in function : %s */
#define   PHE_SHMNODATA            -1005 /* No data in SHM %s ! */
#define   PHE_GETWRONGSID          -1006 /* Get wrong SID %s from SHM ! */
#define   PHE_SHMSTGNOSETACT       -1007 /* PHE_SHMSTGNOSETACT */
#define   PHE_SHMNOSID             -1008 /* No SID in SHM ! */
#define   PHM_SHMNODATA            -1009 /* No Data in SHM ! */
#define   PHM_ILLEGALSEMID         -1010 /* Illegal SEMID %s with nsems = %s \
                                            detected ! */
#define   PHE_TRYTOKILLILLPROC     -1011 /* %s tried to kill process with \
                                            illegal pid %s */
#define   PHE_MSGOPEN              -1012 /* Message queue allocation failed */
#define   PHE_MSGCLOSE             -1013 /* Message queue deallocation failed */
#define   PHE_SEMOPEN              -1014 /* Semaphore allocation failed */
#define   PHE_SEMCLOSE             -1015 /* Semaphore deallocation failed */
 
/* Global Errors */

/* #define   PHD_NOLICENSE            -2000 /* Sorry , you have no licence \
                                            to run this program ! */
#define   PHD_RDSYSTEMPAR          -2001 /* Reading system parameters \
                                            failed ! */
#define   PHD_TOOMANYERRORS        -2002 /* Too many unrecoverable errors \
                                            detected ! \n Please terminate \
                                            process %s */

#define   PHE_KEYWORDRESERVED      -2009 /* Keyword %s is reserved for internal use */
#define   PHE_KEYWORDNOTFOUND      -2010 /* Keyword %s not found */
#define   PHE_TOMANYKEYWORDS       -2011 /* To many keyword in file ! */
#define   PHE_ILLEGALKEYWORD       -2012 /* Illegal keyword: %s found ! */
#define   PHE_NOVALUEFORKEYWORD    -2013 /* No value found for keyword %s */
#define   PHE_USEDEFVALFORKEYW     -2014 /* Using default value for keyword \
                                            %s */

#define   PHE_ISTATONLY            -2015 /* Internal use only */
#define   PHE_NOVALFORKEYWINFILE   -2016 /* No value found for keyword %s \
                                            in file %s */
#define   PHE_ILLVALFORKEYWINFILE  -2017 /* Illegal value found for keyword %s \                                            in file %s */
#define   PHM_USEINGVALUE          -2018 /* Using value : %s */


#define   PHW_UNKNOWNPROCSTOPS     -2100 /* Unknown process ( pid = %s ) stops*/
#define   PHE_ILLEGALPID           -2101 /* Illegal Process ( pid = %s ) ! */

#define   PHD_PROCEXITSTATUS       -2110 /* Process %s stops with illegal \
                                            process exit status %s ! */
#define   PHD_DISASTERENDOFSES     -2111 /* Disaster end of session ! */
#define   PHE_ILLEGALPROCCALL      -2112 /* Illegal process call ! */
#define   PHE_ILLEGALSTARTOPT      -2113 /* Illegal start option : %s */
#define   PHE_WRONGVALINCTRL       -2114 /* Wrong value in controlfile : %s */
#define   PHW_FUNCNOTYETSUP        -2115 /* Sorry, this function is not yet supported */

#define   PHE_CANTROPENCFG         -2200 /* Can't open file : %s */
#define   PHE_CANTREADLINE         -2201 /* Can't read line from file %s */
#define   PHE_ILLEGALSTRING        -2202 /* Illegal string */
#define   PHE_ILLEGALCALLPARAM     -2203 /* Illegal call parameter %s in \
                                            routine : %s */
#define   PHE_CSYS_ILL_DEF         -2204 /* Illegal default parameter for \
                                            coordinate system */
#define   PHW_CSYS_DEF_NOTDEF      -2205 /* Not all parameters for the \
                                            coordinate system defined */
#define   PHE_DUPLICATENAME        -2206 /* Duplicate coordinate name */
#define   PHE_NOTACOORDINATE       -2207 /* Value is not a coordinate value */
#define   PHE_NOTAVARIANCE         -2208 /* Value is not a variance value */
#define   PHE_NOTACLAS             -2209 /* Value is not a coordinate clas \
                                            value */
#define   PHE_NOTANAME             -2210 /* Value %s is not a name value */
#define   PHE_OPENERROR            -2211 /* Open error : %s \n \
                                            File : %s */
#define   PHE_INDENTICALPOINTS     -2213 /* Indentical points */
#define   PHE_INTERSECINFINITY     -2217 /* Intersection is to infinity */
#define   PHE_CONDNOTFULFILL       -2218 /* Intersection condition didn't \
                                            fulfill */
#define   PHE_CANTCREATETMP        -2219 /* Can't create temporay file %s */

#define   PHD_NOPATCHENTRY         -2223 /* Number of patch elements to \
                                            allocate <= 0 */
#define   PHW_WRONGPTABLEROWBEG    -2224 /* Row beg. of patch table < 0L */
#define   PHW_WRONGPTABLECOLBEG    -2225 /* Row beg. of patch table < 0L */
#define   PHW_WRONGPTABLEROWEND    -2226 /* Row beg. of patch table < 0L */
#define   PHW_WRONGPTABLECOLEND    -2227 /* Row beg. of patch table < 0L */
 
#define   PHD_NOMEMFORTFMATRIX     -2228 /* No mem for transformation matrix */
#define   PHD_NOMEMFORROTMATRIX    -2229 /* No mem for rotation matrix */
#define   PHE_FAILPATCHIMGENTRY    -2230 /* Failed assign patch limits onto \
                                            ptable*/
#define   PHE_FAILPATCHIMGTBL      -2231 /* Failed assign patch entry onto \
                                            table */

#define   PHE_ILLEGALPATCHID       -2232 /* Illegal patch ID */
#define   PHE_FAILINIPATCHQ        -2233 /* Failed patch quadtree initialize */
#define   PHE_FAILEPIPATCHIMGTBL   -2234 /* Failed epipolar image patch table */
#define   PHE_FAILPATCHISECTBL     -2235 /* Failed intersection patch table */

#define   PHE_FILEFMTWRONG         -2236 /* Format in ascii file is wrong */
#define   PHE_FAILSETTFMATRIX      -2237 /* Failed set transformation matrix */
 
#define   PHD_CZCREATE             -2240 /* PHD_CZCREATE */
#define   PHD_CZOPEN               -2241 /* PHD_CZOPEN */
#define   PHD_CZSETID              -2242 /* PHD_CZSETID */
#define   PHD_CZREAD               -2243 /* PHD_CZREAD */
#define   PHD_CZWRITE              -2244 /* PHD_CZWRITE */
#define   PHD_CZCOLSE              -2245 /* PHD_CZCOLSE */
#define   PHE_NOSAVEPATCH          -2246 /* PHE_NOSAVEPATCH */
#define   PHE_SNOTCREATED          -2247 /* PHE_SNOTCREATED */
 
#define   PHW_CZINFOUSEDEFVAL      -2248 /* Using default values for CZ \
                                            company information */
#define   PHE_PRJNOTSET            -2249 /* Project name not set */
#define   PHE_PRJALREADYEXIST      -2250 /* Project already exists */
#define   PHE_NOTAINT              -2251 /* Value : %s is not of type int */
#define   PHE_NOTADOUBLE           -2252 /* Value : %s is not of type double */
#define   PHE_ILLPARAMETER         -2253 /* Illegal Parameter : %s */
#define   PHE_ILLRECORD            -2254 /* Illegal values in line : %s */
#define   PHE_MODELNOTFOUND        -2255 /* Model : %s not found in project : %s */
#define   PHW_MISSPROJNAME         -2256 /* Missing project name in parameter file */
#define   PHE_DELETEPRJ            -2257 /* Can't delete current Project */
#define   PHE_EXISTPRJ             -2258 /* Project %s doesn't exist */
#define   PHE_ILLPRJNAME           -2259 /* Illegal Project name %s */
#define   PHM_USEPRJNAME           -2260 /* Using Project %s */
#define   PHE_NOMODEL              -2261 /* No Models found in project : %s */
#define   PHW_CTRLPROC             -2262 /* Process control not started */
#define   PHE_ILLSTATE             -2263 /* %s : Illegal gui state. Please close the actual window. */
#define   PHW_ILLMODEL             -2264 /* Illegal model. Please set camera file. */
#define   PHW_NOTALLFILE           -2266 /* Left and Right image name must be set */
#define   PHW_JOBHEAD              -2267 /* ---------- Process %s ---------- */
#define   PHW_JOBSIG               -2268 /* Signal sent to process %s */
#define   PHW_JOBTERM              -2269 /* Process has terminated correctly */
#define   PHW_JOBERROR             -2270 /* Process terminates with an error */
#define   PHW_JOBKILLED            -2271 /* Process seemes to be killed */
#define   PHW_PSEUDOMODELL         -2272 /* Pseudo model detected!\n \
                                            Change Left and Right images */ 
#define   PHE_MODELACTIVE          -2273 /* Active model %s can't be redefined */
#define   PHE_NO_MODELMEMORY       -2274 /* No memory allocated for model structur*/
#define   PHE_DIVISOR              -2275 /* Divisor 0 */
#define   PHW_DIFFRESU             -2276 /* Calculated resolution differs from given resolution */
#define   PHM_RESUGIVE             -2277 /* Given resolution width: %s and height: %s */
#define   PHM_RESUCALC             -2278 /* Calculated resolution width: %s and height: %s */
#define   PHM_USECALCRESU          -2279 /* Using calculated resolution */
#define   PHM_USEGIVERESU          -2280 /* Using given resolution */
#define   PHW_RESUWARNING          -2281 /* Epipolar image could be wrong */
#define   PHE_UNKNOWNMODCORNERS    -2282 /* Corners of %s Model are undefined */


/* File IO errors */

#define   PHE_FILEACCFAILED        -2400 /* Access to file %s failed */

#define   PHE_UNKNOWNFILETYP       -2500 /* Unknown file type %s ! */
#define   PHE_NOTCZFILE            -2501 /* File is not a CZ file ! */
#define   PHE_FILEACCESSMODE       -2502 /* Illegal file access mode %s ! */
#define   PHE_NOTABHDR1FILE        -2503 /* PHE_NOTABHDR1FILE */
#define   PHE_NOHDR0               -2504 /* PHE_NOHDR0 */
#define   PHE_INVALIDHDR0          -2505 /* PHE_INVALIDHDR0 */
#define   PHE_CANTEXTENDHDR0       -2506 /* PHE_CANTEXTENDHDR0 */
#define   PHE_CANTWHDR0            -2507 /* PHE_CANTWHDR0 */
#define   PHE_SIDALREADYINUSE      -2508 /* File with ID %s already in use ! */
#define   PHE_NOSID                -2509 /* PHE_NOSID */
#define   PHE_EOF                  -2510 /* End of file not found ! */
#define   PHE_RNOTENOUGHBYTES      -2511 /* PHE_RNOTENOUGHBYTES */
#define   PHE_WNOTENOUGHBYTES      -2512 /* PHE_WNOTENOUGHBYTES */
#define   PHE_IllEGALHDRPAR        -2513 /* Illegal header parameter */
#define   PHE_ILLEGALSID           -2514 /* Illegal structure ID : %s */
#define   PHE_ILLEGALRECORDNO      -2515 /* PHE_ILLEGALRECORDNO */
#define   PHE_INVALIDRECORD        -2516 /* Invalid Record %s in file : %s */
#define   PHE_CANTWNEWREC          -2517 /* PHE_CANTWNEWREC */
#define   PHE_CANTWSETREC          -2519 /* PHE_CANTWSETREC */
#define   PHE_CANTWSTAREC          -2520 /* PHE_CANTWSTAREC */
#define   PHE_CANTWORTHOREC        -2521 /* PHE_CANTWORTHOREC */
#define   PHE_CANTCRAETEPRJFIL     -2522 /* PHE_CANTCRAETEPRJFIL */
#define   PHE_CANTOPENFORREAD      -2523 /* Can not open file %s for read */
#define   PHE_CANTOPENFORWRITE     -2524 /* Can not open file %s for write */
#define   PHE_REPIMGPARS           -2529 /* Error when reading epipolar image */
#define   PHE_WRONGFILSTAT         -2530 /* Wrong file status */
#define   PHE_NOTADIR              -2531 /* Directory %s does not exist*/
#define   PHE_NOTAFILE             -2532 /* Name is not a file %s */
#define   PHE_FILEWRITE            -2533 /* Error during write to file %s */
#define   PHE_FILEREAD             -2534 /* Error during reading file %s */
#define   PHE_ILLEGALCZBINFILE     -2540 /* Illegal CZ binary file %s */
#define   PHE_ILLEGALFILEMODE      -2541 /* Illegal file mode %s ! */
#define   PHE_ILLEGALHEADERBLOCK   -2542 /* Illegal header block detected ! */
#define   PHE_NOSUCHSID            -2543 /* Structure ID : %s is not legal %s ! */
#define   PHE_NOTENOUGHBYTES       -2544 /* Not enough bytes in file to read ! */
#define   PHE_ILLEGALSTRUCTID      -2545 /* Illegal structure ID detected ! */
#define   PHE_NODATAINFILE         -2546 /* No data in File %s ! */
#define   PHE_ILLEGALFILNAM        -2547 /* Illegal file name %s */
#define   PHE_CTRLINFPATH          -2548 /* Control characters in filnam %s */
#define   PHE_IDENTFPATH           -2549 /* Filename of file %s must not be identical with %s */
#define   PHE_ALREADYEXIST         -2550 /* File %s already exists */


/* new tld errors */

#define PHE_ILLEGALCHANNEL         -2551 /* Channel selector is wrong */
#define PHE_ILLEGALSUBIMAGE        -2552 /* Subimage out of image area */
#define PHE_NOTILESTOREAD          -2553 /* Selected tiles not available */
#define PHE_NODATAFORTILE          -2554 /* No data stored for tile */
#define PHE_ILLEGALSTRUCT          -2555 /* Illegal structure ID */
#define PHE_NOTILEINFILE           -2556 /* Tile data not available */
#define PHE_ILLEGALDTYPE           -2557 /* Illagal image data type */
#define PHE_NOTILESTOWRITE         -2558 /* Selected tiles not available */
#define PHE_EXTCHAN                -2559 /* Extension channel not free */
#define PHE_FILENOTOPEN            -2560 /* File not open */
#define PHE_NOACCESS               -2561 /* Access ID not allocated */
#define PHE_FILEOPEN               -2562 /* File %s already in use */
#define PHE_ILLEGALCREAMODE        -2563 /* Illegal file creation mode */
#define PHE_FILEOPENFORREAD        -2564 /* Illegal file access mode */
#define PHE_NOHISTOGRAM            -2565 /* Histogram not available */
#define PHE_NOLUT                  -2566 /* LUT not available */
#define PHE_SIDPTRNULL             -2567 /* Structure pointer illegal */
#define PHE_FILEOPENOTHERMODE      -2568 /* File %s open with other access mode*/
#define PHE_ILLEGALIMGAREA         -2569 /* Image bounds incorrect */
#define PHE_NOIMAGEFOROVERVIEW     -2570 /* No overview in file */
#define PHE_ILLPYMLEVEL            -2571 /* Illegal Pyramid level %s */

#define PHW_TLDGENOV               -2572 /* No overview found on file \n\
                                            Generating overview in memory \n\ 
                                            For fast access use ov1024 */

/* Serial Mouse Input */

#define   PHE_ILLEGALOPTSERCMD     -2600 /* PHE_ILLEGALOPTSERCMD */
#define   PHE_PMOUSENOTONLINE      -2601 /* P-Mouse is not online ! */
#define   PHE_NOOPENPMOUSE         -2602 /* P-Mouse can't be opened ! */
#define   PHE_PMOUSERECLEN         -2603 /* Recieving record with illegal \
                                            record lenght from P-Mouse ! */
#define   PHE_PMOUSEILLSCALES      -2604 /* Illegal P-Mouse scales defined \
                                            in config file %s %s %s ! */
#define   PHE_PMOUSEILLFINC        -2605 /* Illegal fast key increments */
#define   PHE_NOPMOUSEDEV          -2606 /* No P-Mouse device defined ! */
#define   PHE_NOPMOUSESCALES       -2607 /* No p-Mouse scales defined in \
                                            config file %s ! */
#define   PHE_PMOUSEILLAINC        -2608 /* Illegal alt key increments */
#define   PHE_HWHEELILLSCALES      -2609 /* Illegal P-Mouse scales defined \
                                            in config file %s %s %s ! */
#define   PHE_PMOUSEILLIINC        -2610 /* Illegal moving image increments */

/**** image file I/O ****/

#define   PHE_CANTOPENIMG          -2700 /* Can't open image : %s ! */
#define   PHE_CANTCLOSEIMG         -2701 /* Can't close image : %s ! */
#define   PHE_CANTRDIMGID          -2702 /* Can't set image ID for : %s ! */
#define   PHE_CANTRDIMGHDR         -2703 /* Can't read image header of : %s ! */
#define   PHE_CANTRDIMGDATA        -2704 /* Can't read data from image : %s ! */
#define   PHE_IMGPARDIFFER         -2705 /* Image header parameters differ ! \n
                                            Parameters of image %s \n and \
                                            image %s should be identical ! */ 
#define   PHE_CANTOPENSWC          -2706 /* Can't open software caching \
                                            packet for image : %s\n */
#define   PHE_NOIMGOPENED          -2707 /* No image opened for access !\n
                                            Function set not initialized ! */
#define   PHE_ILLEGALIMGID         -2708 /* Illegal image ID : %s ! */
#define   PHE_SWCNOTINIT           -2709 /* Software caching packet not \
                                            initialized */
#define   PHE_SWCPATCHNOTFOUND     -2710 /* Patch %s not found */
/*
** check_ & get_
*/
#define   PHM_FILNAMDIR            -3001 /* File name points to a directory */
#define   PHM_FILNAMFIL            -3002 /* File name points to no file ! */

#define   PHW_FILNOTEXIST          -3100 /* File %s does not exist */
#define   PHW_ENVNOTEXIST          -3101 /* Environment variable %s does not \
                                            exist */
#define   PHW_EMPTYBUF             -3102
#define   PHW_FILNOTDEF            -3103 /* File %s is not defined */

#define   PHE_ROOTNOTEXIST         -3200 /* Keyword PHO_ROOT does not exist */
#define   PHE_ROOTNOTDIR           -3201 /* Keyword PHO_ROOT does not point \ 
                                            to a system directory */
#define   PHE_DEFCFGNOTEXIST       -3202 /* Default config file : %s \
                                            does not exist ! */
#define   PHE_DEFCFGNOTFIL         -3203 /* Default config file : %s \
                                            is not a file ! */
#define   PHE_HOMENOTEXIST         -3210 /* Keyword PHO_HOME does not exist */
#define   PHE_HOMENOTDIR           -3211 /* Keyword PHO_HOME does not point \ 
                                            to a system directory ! */
#define   PHE_USRCFGNOTEXIST       -3212 /* No config file for current user ! */
#define   PHE_USRCFGNOTFIL         -3213

#define   PHE_TIMEFMT_WRONG        -3350 /* Time format %s is wrong ! */

#define   PHE_KEYWNOTSCAN          -3400 /* Keyword %s : Not scanned ! */
#define   PHE_KEYWSTR_EMPTY        -3401 /* Keyword %s : String is empty */

/* Pyramide generation */

#define   PHE_PYSTEPNOTEQ          -3501 /* Steps are not equal */
#define   PHE_PYNORISINGSTEP       -3502 /* No rising steps */
#define   PHE_PYNOTEQUALFILE       -3503 /* Can't change between separate file  and image file for pyramid data */
#define   PHE_PYNOTEQUALSTEPS      -3504 /* Steps in file and call are different*/
#define   PHE_PYNOTFOUND           -3505 /* Existent pyramid not found */
#define   PHE_PYINTERNERROR        -3506 /* Internal error in pyra() */
#define   PHE_PYNOSUCHLEVEL        -3507 /* No such pyramid level %s */   
#define   PHM_PYMINSIZEREACHED     -3508 /* Minimum size is reached. Level = %s */   
#define   PHM_ALLPYMAVAIL          -3509 /* All pyramids are available */   
#define   PHE_MISSIMGPYM           -3510 /* Not enough image pyramid levels */
#define   PHE_PYRNOTAVAIL          -3511 /* No Pyramids available for image %s*/
#define	  PHE_PYSAMEFILE	   -3512 /* Pyramid file must not be same as image file */
#define   PHW_PYMFILEDELETED	   -3513 /* Pyramid file deleted due to errors that corrupted it */
#define   PHE_PYMTIFFIMAGEEXT      -3514 /* TIFF image files used for pyramid generation must have extension '.tif' */
#define   PHE_PYMTIFFPYMEXT        -3515 /* TIFF pyramid image files must have extension '.pym' */
#define   PHE_PYMTIFFSAMEDIR       -3516 /* TIFF pyramid image file must reside in the same directory as the image file */
#define   PHE_PYMTIFFSAMEBASENAME  -3517 /* TIFF pyramid image file must have the same basename (%s) as the image file */

/* Image compression */
#define   PHW_NOSELECTION          -3550 /* No selection made. Nothing to do. */

/* img routines: 'img'-handling with TIF, SUN, CT */

#define   PHE_IMGNOTIMPLEMENTED    -3601 /* Image type not implemented (file %s) */
#define   PHE_IMGFALSEINDEX        -3602 /* False img file index */
#define   PHE_IMGMUSTCLOSE         -3603 /* You must close file before append */
#define   PHE_IMGOPENERROR         -3604 /* Internal error in img_open */
#define   PHE_IMGNOTEXISTING       -3605 /* Image according to number not existing */
#define   PHE_IMGNOLUTEXISTS       -3606 /* There is no LUT in image */
#define   PHE_IMGCLOSEERROR        -3607 /* Internal error in img_close */
#define   PHE_TIFNOTOPEND          -3608 /* Cannot open TIFF image file */
#define   PHE_TIFDIRNOTEXIST       -3609 /* TIFF directory does not exist */
#define   PHE_TIFFALSEREGION       -3610 /* False region within TIFF file */
#define   PHE_TIFREADERROR         -3611 /* Image file read error */
#define   PHE_FALSEDEPTH           -3612 /* Image has false depth */
#define   PHE_CTALREADYOPEN        -3613 /* One CT file alraedy open! */
#define   PHE_CTHEADER             -3614 /* Error in CT file header */
#define   PHE_IMGCANNOTATTACH      -3615 /* Image: %s cannot attach */
#define   PHE_TLDCANNOTSTART       -3616 /* TLD Image cannot start */
#define   PHE_TIFFCANNOTSTART      -3617 /* TIFF Image cannot start */
#define   PHE_CTCANNOTSTART        -3618 /* CT Image cannot start */
#define   PHE_SUNCANNOTSTART       -3619 /* SUN Image coannot start */
#define   PHE_INVALIDCALLPARAMETER -3620 /* Invalid call parameter */
#define   PHE_ERRORINIMGSTART      -3621 /* Error in image start */
#define   PHW_IMGIDNOTFOUNDINLIST  -3622 /* Image ID not found in the list */
#define   PHW_IMGIDCANNOTDETACH    -3623 /* Image: %s cannot detach */
#define   PHE_TIFFDIRCANNOTSET     -3624 /* TIFF dirctory connot set */
#define   PHW_TIFFIMGOVNOTFOUND    -3625 /* TIFF overview to image not found */
#define   PHE_IMGUNSUPPFUNC        -3626 /* Function %s not supported for current image type */   
#define   PHE_SUNREADCOLORMAP      -3627 /* Cannot read colormap in %s */
#define   PHE_SUNREADERROR         -3628 /* Cannot read data line from %s */
#define   PHE_USGSWRITE            -3629 /* Cannot write to file %s */
#define   PHE_USGSREAD             -3630 /* Cannot read from file %s */
#define   PHE_IMGDIFFER            -3631 /* Existing image differs in rows, cols, channels */
#define   PHE_IMGNOMEMFORDATA      -3632 /* Pointer to memory not initalized */


/* cz_tf */

#define   PHE_TOOFEWIDPNT          -3701 /* Too few identic points */
#define   PHE_NOIDPNT              -3702 /* No identic points found */
#define   PHE_SCHWERP              -3703 /* Error in routine schwerp() */
#define   PHE_ALLPNTONLINE         -3704 /* All old points lie on one straight line */


/***** imc  (image cache) *****/

#define	  PHE_IMCNOMEM		   -3801 /* No free image cache pages left */
#define   PHW_IMCALREADY	   -3802 /* Image cache is already initialised */
#define   PHE_IMCNOENT		   -3803 /* Image or page not found in image cache */
#define   PHW_IMCBUSY		   -3804 /* image page is allocated */
#define   PHW_IMCIDLE		   -3805 /* image page is not available */


/**** GCP Handling ****/

#define   PHE_GCPFILECSTAT         -4000 /* Wrong status %s in gcp file */
#define   PHE_GCPFILECPNAME        -4001 /* Duplicate point name %s in gcp file */
#define   PHE_GCPALREADYINLIST     -4002 /* Point %s already exists in gcp list */
#define   PHE_GCPNOPOINT           -4003 /* No points found in gcp list */
#define   PHE_GCPGUIERROR          -4004 /* Error with the GCP user interface */
#define   PHW_FILEPATHNOTSET       -4005 /* Filepath is not set */
#define   PHW_DOUBLEPARS           -4006 /* Duplicate parameters */
#define   PHM_IMPORT               -4007 /* %s points imported */
#define   PHE_ILLEGALFORMAT        -4008 /* Illegal xyz format */

/**** MATH Routines *****/

#define   MAE_ELEMENTSINCOMP       -4100 /* Element(s) for matrix \
                                            computation are incompatible */
#define   MAE_NOTCREATED           -4101 /* Before executing the function \
                                            matrix have to be created */
#define   MAE_ISNOTSQUARE          -4102 /* Rows != columns   =>   matrix \
                                            is not square */
#define   MAE_ARENOTEQUAL          -4103 /* Matrices are not equal in \ rows and columns */
#define   MAE_SINGULARMATRIX       -4104 /* Determinant of matrix = 0 \
                                            (singular matrix)*/
#define   MAE_ELEMENTSTOOSMALL     -4105 /* Diagonal element of matrix is \
                                            too small */

/**** IMPORT/EXPORT ****/

#define   PHE_WRONGVALINPEX        -4200 /* Wrong value in line %s \
                                            of a PHOREX block */
#define   PHE_MISSCNAMINPEX        -4201 /* Camera block in a PHOREX file \
                                            without a CNAM record */
#define   PHE_MISSCNAMINPHB        -4202 /* Phb camera file %s with \
                                            undefined camid */                  
#define   PHE_WRUNSUPKEYWINPEX     -4203 /* Attempt to write unsupported \
                                            keyword %s to a PHOREX file */
#define   PHE_WRWRONGVALINPEX      -4204 /* Attempt to write wrong value \
                                            to a PHOREX file */
#define   PHE_MISSKEYWINCTRL       -4205 /* Missing mandatory keyword %s \
                                            in controlfile */
#define   PHW_EMPTYPEXFILE         -4206 /* Empty PHOREX file : %s */       
#define   PHE_MISSINAMINPEX        -4207 /* Image block in a PHOREX file \
                                            without a INAM record */
#define   PHE_MISSIOTYINPEX        -4208 /* IOPA record in a PHOREX file \
                                            without a IOTY record */
#define   PHE_IMGBLOCK             -4209 /* Error in image block nr. %s */  
#define   PHE_CAMBLOCK             -4210 /* Error in camera block nr. %s */  
#define   PHE_ILLGCNAMINPEX        -4211 /* Illegal camera name in PHOREX file %s */
#define   PHW_SKIPBLOCK            -4212 /* Block skipped */
#define   PHE_WRFILNAMINPEX        -4213 /* Illegal file name in PHOREX file %s */
#define   PHE_MISSINAMINPHB        -4214 /* Phb di file %s with undefined image id */
#define   PHW_NOORPC               -4215 /* No ORPC record found, \n \
                                            camera reference and photo number \
                                            undefined */
#define   PHW_IMGFILNOTFOUND       -4216 /* Image file %s not found on given path */
#define   PHE_ILLGINAMINPEX        -4217 /* Illegal image name in PHOREX file %s */
#define   PHW_IGNINAM              -4218 /* Ignoring INAM record %s */ 
#define   PHW_NOORPCINMOD          -4219 /* Can not write ORPC records to \  
                                            current PHOREX model block */             
#define   PHE_MISSMODINMOD         -4220 /* Missing model name in PHODIS \
                                            model %s */
#define   PHE_MISSIMGINMOD         -4221 /* Missing image reference in PHODIS \
                                            model %s */
#define   PHE_MODBLOCK             -4222 /* Error in model block nr. %s */  
#define   PHE_MISSMNAMINPEX        -4223 /* Missing MNAM reocrd in PHOREX model block */
#define   PHE_MISSENAMINPEX        -4224 /* Missing ENAM reocrd in PHOREX model block */
#define   PHE_ILLGGNAMINPEX        -4225 /* Illegal gcp file name %s in PHOREX model block */
#define   PHE_MISSMBASINPEX        -4226 /* Missing MBAS record in PHOREX model block */
#define   PHE_MISSMOMEINPEX        -4227 /* Missing MOME record in PHOREX model block */
#define   PHE_MISSMPHIINPEX        -4228 /* Missing MPHI record in PHOREX model block */
#define   PHE_MISSMKAPINPEX        -4229 /* Missing MKAP record in PHOREX model block */
#define   PHE_MISSORPCINMOD        -4230 /* Missing ORPC record in PHOREX model block */
#define   PHE_MISSORPSINMOD        -4231 /* Missing ORPS record in PHOREX model block */
#define   PHE_MISSROPGINMOD        -4232 /* Missing ROPG record in PHOREX model block */
#define   PHW_CANNOTWRTDI          -4233 /* Can not write image specific \  
                                            part of model %s */
#define   PHE_SCAN_RESOLUTION      -4234 /* SCAN_RESOLUTION_MICRONS not found in %s PS1 header file */
#define   PHE_LL_CORNER_ALIGNED    -4235 /* LL_CORNER_ALIGNED_MM(X,Y) not found in %s PS1 header file */
#define   PHE_UL_CORNER_ALIGNED    -4236 /* UL_CORNER_ALIGNED_MM(X,Y) not found in %s PS1 header file */
#define   PHE_UR_CORNER_ALIGNED    -4237 /* UR_CORNER_ALIGNED_MM(X,Y) not found in %s PS1 header file */
#define   PHE_LR_CORNER_ALIGNED    -4238 /* LR_CORNER_ALIGNED_MM(X,Y) not found in %s PS1 header file */
#define   PHE_IMAGE_FORMAT         -4239 /* IMAGE_FORMAT not found in %s PS1 header file */
#define   PHE_IMAGE_FILE_HEADER    -4240 /* IMAGE_FILE_HEADER_SIZE_BYTES not found in %s PS1 header file */
#define   PHE_NUM_TILES_HORIZ      -4241 /* NUM_PIXELS_PER_TILE_HORIZONTALLY not found in %s PS1 header file */ 
#define   PHE_NUM_TILES_VERTICALLY -4242 /* NUM_PIXELS_PER_TILE_VERTICALLY not foun in %s PS1 header file */
#define   PHE_NUM_PIXELS_PER_HORIZ -4243 /* NUM_PIXELS_PER_TILE_HORIZONTALLYFIDUCIAL_COORD_CAM_MM not found in %s PS1 header file */
#define   PHE_NUM_PIXELS_PER_VERT  -4244 /* NUM_PIXELS_PER_TILE_VERTICALLYFIDUCIAL_COORD_MEAS_MM not found in %s PS1 header file */ 
#define   PHE_FID_COORD_CAM_MM     -4245 /* FIDUCIAL_COORD_CAM_MM not found in %s PS1 header file */
#define   PHE_FID_COORD_MEAS_MM    -4246 /* FIDUCIAL_COORD_MEAS_MM not found in %s PS1 header file */ 
#define   PHE_FID_COORD_ALIGNED_MM -4247 /* FIDUCIAL_COORD_ALIGNED_MM not found in %s PS1 header file */ 
#define   PHE_FID_COORD_ALIGNED_PIX -4248 /* FIDUCIAL_COORD_ALIGNED_PIXEL not found in %s PS1 header file */
#define   PHE_WRONGCAMVALUE        -4249 /* Number of photo or image coordinates are wrong in %s PS1 header file */
#define   PHE_TOOFEWFIDUCIALS      -4250 /* Too few fiducials in %s PS1 header file */
#define   PHW_NOPHONOIMGRELATED    -4251 /* Photo number :%s can't be related to any digital image */
#define   PHW_PHONONOCLEAR         -4252 /* Photo number :%s is not unique */
#define   PHW_PHONOAMBIGUITY       -4253 /* Photo number :%s is related to %s image */
#define   PHE_MISSINAMINMOD        -4254 /* Missing INAM record in PHOREX model block */
#define   PHE_MISSMENDINMOD        -4255 /* Missing MEND record in PHOREX model block */
#define   PHE_MISSIENDINMOD        -4256 /* Missing IEND record in PHOREX model block */
#define   PHE_MISSCENDINMOD        -4257 /* Missing CEND record in PHOREX model block */
#define   PHE_MISSENDINMOD         -4258 /* Missing END record in PHOREX model block */
#define   PHE_MISSBLOCKINPEX       -4259 /* Missing block in PHOREX file */
#define   PHE_FILEEXISTSINTABLE    -4260 /* File %s already exists in table */
#define   PHE_MODELEXISTSINTABLE   -4261 /* Model %s already exists in table */
#define   PHE_FILENOTINLIST        -4262 /* File %s doesn't exists in list */
#define   PHE_MODELNOTINLIST       -4263 /* Model %s doesn't exists in list */
#define   PHE_WRONGFILEEXT         -4264 /* Wrong file extension */

/**** image processing ****/

#define   PHE_SUBIMGERROR          -4300 /* Before you must call cz_subimage() */
#define   PHE_MARGINFLAG           -4301 /* False Margin Flag for Median */
#define   PHE_MEDIANERROR          -4302 /* Error in fast_medianmask() */
#define   PHE_HISTFLAG             -4303 /* False flag in cz_histnorm() */
#define   PHE_HISTOGRERROR         -4304 /* Error in cz_histnorm() */
#define   PHE_SOBELFLAG            -4305 /* False in cz_sobel() */
#define   PHE_SUBIMGSIZE           -4306 /* Error with size in cz_procsubimg() */
#define   PHE_SUBIMGMASK           -4307 /* Error with subimage mask */
#define   PHE_HISTNORM             -4308 /* False flag in hist_norm() */
#define   PHE_ROTSCALE             -4309 /* False scale in rotation and scale */
#define   PHE_SCALFLAG             -4310 /* False flag in scal_byte() */
#define   PHE_INOUTFILE            -4311 /* Same names for input and output file */
#define   PHE_ILLEGALFLIP          -4312 /* Illegal flip mode */
#define   PHE_AREATOBIG            -4313 /* Selected area too large */
#define   PHE_OUTOFAREA            -4314 /* row or column value out of image area */
#define   PHE_WRONGDIRECTION       -4315 /* left/right rotation parameter illegal */
#define   PHE_ALPHA                -4316 /* Illegal alpha parameter */
#define   PHE_CHANNELSNEC          -4317 /* Program needs RGB image */
#define   PHE_ILLEGALLUTTYP        -4318 /* Illegal LUT type */
#define   PHE_POLYGONONEPOINT      -4319 /* Polygon needs more than one point */
#define   PHE_NOPOLYGON            -4320 /* No polygon found */
#define   PHE_RCERROR              -4321 /* Row, Column values illegal */
#define   PHE_KONTRAST             -4321 /* Illegal contrast range */
#define   PHE_BACKCOLOR            -4322 /* Keyword PHO_BACKCOLOR parameters illegal */
#define   PHE_NOTARGBIMAGE         -4323 /* The image is not a rgb image */
#define   PHE_WRONGVALUESFORABC    -4324 /* Sum of (A+B+C) > 1 or < 0 */


/**** phb and tld ****/

#define   PHE_WRONGDIREF           -4400 /* Wrong Di-Reference %s in image file %s */
#define   PHW_MISSDIREF            -4401 /* Missing Di-Reference in image file %s */
#define   PHW_NOTEXDIREF           -4402 /* Di-Reference in image file %s \n \
                                            to a not existing Di-File %s */
#define   PHW_OVWRDIREF            -4403 /* Overwriting Di-Reference %s */
#define   PHW_NOCAMFORIMG          -4410 /* No camera reference for image file %s */
#define   PHW_MICAMFORIMG          -4411 /* Camera reference for image file \
                                            %s\n points to a not existing file*/
#define   PHE_WRONGCAM             -4412 /* Illegal data in camera file %s */ 
#define   PHE_WRONGEPOUTPARS       -4413 /* Error during write of di-file %s */ 
#define   PHE_IMGREFNOTFIT         -4414 /* Image info file %s \n\
                                            belongs to image file %s \n\
                                            Use unique file name for image %s */
#define   PHE_WRGROWCOL            -4415 /* Wrong image information : Row %s, Col %s */
#define   PHE_UNSUPCAMTYP          -4416 /* Unsupported camera type in file %s */
#define   PHW_DIFFPIXSIZE          -4417 /* Different pixel size for height and width. Taking value from width ! */

/* utl routine errors */

#define   PHE_AREAFOV              -4500 /* Area field overflow */
#define   PHE_NUMPNTOV             -4501 /* numpnt greater than maxpnt */
#define   PHE_CUTMORE10            -4502 /* Line cuts clipping polygon more than 10 times */
#define   PHW_INTERIORNOTEXIST     -4503 /* Interior orientation of %s image does not exist */
#define   PHW_EXTERIORNOTEXIST     -4504 /* Exterior orientation of %s image does not exist */
#define   PHW_IMAGESCALENOTEXIST   -4505 /* Image scale of %s image does not exist */
#define   PHW_MODELORICANNOTCALC   -4506 /* Orientations of %s model could not calculated */

/**********************/
/**** orientations ****/
/**********************/

/**** general ****/

#define   PHE_READCAM              -5000 /* Error while reading camera file %s */
#define   PHE_CANOTREADDI          -5001 /* Can not read di for image file %s */
#define   PHE_RIONOTAVAILABLE      -5002 /* Interior orientation is not available for image %s */
#define   PHE_REONOTAVAILABLE      -5003 /* Exterior orientation is not available for image %s */
#define   PHE_RCAMNOTAVAILABLE     -5004 /* Camera file is not available */
#define   PHE_RIMGINFONOTAVL       -5005 /* Image info is not available */
#define   PHW_NOORIINIMG           -5006 /* Can not write orientations to \
                                            header of image file %s */
#define   PHE_RRONOTAVAILABLE      -5007 /* Relative orientation is not available */
#define   PHE_RAONOTAVAILABLE      -5008 /* Absolute orientation is not available */
#define   PHW_TERRORI              -5009 /* Terrestrical orientation not yet supported */
#define   PHE_UNSUPIOR             -5010 /* Unsupported type of interior orientation */
#define   PHW_NOHEIGHTAVAIL        -5011 /* No height values available */ 
#define   PHW_NOIMGCORNER          -5012 /* No image area available for \n\*/
                                         /* image %s */
#define   PHW_NOIDPAT              -5013 /* No unsymmetry pattern file \n\*/
                                         /* defined in camera file %s */
#define   PHW_NOFIDPAT             -5014 /* No fiducial pattern file \n\*/
                                         /* defined in camera file %s */
#define   PHW_NOSUCHFID            -5015 /* No such fiducial %s */
#define   PHW_NOPATINIMG           -5016 /* No pattern image found for \n\*/
                                         /* fiducial %s in pattern file %s */
#define   PHE_CANOTWRITEDI         -5017 /* Can not write di for image file %s */
#define   PHE_UNSUPROTSEQ          -5018 /* Unsupported type of angle rotation sequence in exterior orientation */
#define   PHE_CANOTCALCAOANDRO     -5019 /* Can not compute relative and absolute orientations */
#define   PHE_RIOCANNOTREAD        -5020 /* Can not read interior orientation for image %s */
#define   PHE_NOCAMERADEF          -5021 /* Camera is undefined! */

/**** mio ****/

#define   PHE_MIOASSIGNERROR       -5100 /* Can not assign fiducial mark \
                                            to negative pixel coordinates */
#define   PHW_MIOQUIT              -5101 /* Interior orientation aborted */
#define   PHM_MIOASSIGNAGAIN       -5102 /* Select new image part before assignment */
#define   PHE_MIOIMGIO             -5103 /* Image i/o error with file %s in routine %s */        
#define   PHE_MIOWRONGOV           -5104 /* Image smaller than overview */      
#define   PHE_MIOFIDNOTFOUND       -5105 /* Fiducial '%s' not found in the list */        

/**** mbo ****/

#define   PHW_MBOGCPNOTFOUND       -5201 /* Can not find gcp file %s */    
#define   PHE_MBOMODIMGFIT         -5202 /* Image name in model does not \
                                            fit to given name */
#define   PHW_MBOQUIT              -5203 /* Bundle orientation aborted */
#define   PHW_MBOINTOVW            -5204 /* Unsupported resolution ratio between image %s \n\
                                            and its overview \n\
                                            Supported ratios are 2, 4, 8, ... */
#define   PHE_MBOGCPREAD           -5205 /* Error while reading GCP file %s */    
#define   PHW_MBOPIXCOONOTYETSUP   -5206 /* Pixel coordinates not yet supported */
#define   PHW_MBOREMNOTSUP         -5207 /* Remove for control points not supported. \n\
                                            Use GCP handling ! */
#define   PHE_MBOCANNOTREADORI     -5208 /* Error while reading orientation output file %s \n\
                                            Measure additional points to ensure convergent bundle adjustment */    
#define   PHE_MBOIMGIO             -5209 /* Image i/o error with file %s in routine %s */        
#define   PHD_MBOABSOUT            -5210 /* Cannot create file %s \n\
                                            Please check permissions on your current working directory ! */
#define   PHM_NOIDENTPOINTS        -5211 /* No identical points found */
#define   PHW_MBOALLOCCOL          -5212 /* Colour %s cannot be allocated */
#define   PHE_MBO4OR8BIT           -5213 /* This program requires a colour depth of at least 4 BIT */
#define   PHM_PUGACTIVE            -5214 /* PUG measurement is active */
#define   PHM_NOPOINTSELECTED      -5215 /* Select a point name before calling this function */
#define   PHM_SELECTNOTALLOWED     -5216 /* PUG measurement active: Selection not allowed */
#define   PHE_PUGNAMENOTFOUND      -5217 /* Can't find PUG point %s in the point list */
#define   PHE_PUGABORTED           -5218 /* PUG measurement aborted */
#define   PHM_PICKNOTALLOWED       -5219 /* PUG measurement active: Pick not allowed */
#define   PHM_REMOVENOTALLOWED     -5220 /* PUG measurement active:\n Only the measured coordinates of the PUG hole itself may be removed */
#define   PHM_LSMNOTACTIVE         -5221 /* LSM measurement not active */
#define   PHE_NOTSPOTCALIBRATION   -5222 /* SPOT Calibration does not exist */

/**** aio 5300 - 5399 ****/

#define   PHE_AIOCANTLOADIMG       -5300 /* Can't load image part of image : %s
*/
#define   PHE_AIOINSUPROT          -5301 /* Unsupported rotation */
#define   PHE_AIOMISSPREFFILE      -5302 /* Missing predefinition file : %s */
#define   PHE_AIONOSOLBYRANSAC     -5303 /* Matching not possible, check image or camera definition */
#define   PHE_AIOPRECEST           -5304 /* Error during precise location */
#define   PHE_AIOUNSUPTRAF         -5305 /* Unsupported transformation type */
#define   PHE_AIOUNSUPPATRESU      -5306 /* Resolution %s is not yet supported for camera type : %s */   
#define   PHE_AIONOTPATIMG         -5307 /* %s file is not a pattern file or wrong */   
#define   PHE_AIOUNSUPCAMTYPE      -5308 /* Camera type not yet supported : %s */   
#define   PHE_AIOUNDEFINERESU      -5309 /* Undefined resolution in %s pattern file */   
#define   PHD_AIOUNDEFINEMUSTRESU  -5310 /* Undefined resolution of fiducial surrounding */   
#define   PHE_PLATFORMNOTDEF       -5314 /* No platform name defined */
#define   PHE_SUBPIXELESTIM        -5315 /* The subpixel GW corellation cannot be estimated */

/**** aro 5400 - 5499 ****/

#define PHD_TLHUMANHELP      -5400 /* Automation not possible */
#define PHD_TLNOBMALLOC      -5401 /* Cannot allocate a byte matrix */
#define PHD_TLNOBVALLOC      -5402 /* Cannot allocate a byte vector */
#define PHD_TLNOCAMERA       -5403 /* No camera data for %s */
#define PHD_TLNODMALLOC      -5404 /* Cannot allocate a double matrix */
#define PHD_TLNODVALLOC      -5405 /* Cannot allocate a double vector */
#define PHD_TLNOFEALLOC      -5406 /* Cannot allocate a feature list */
#define PHD_TLNOFSSAALLOC    -5407 /* Cannot allocate feature subareas */
#define PHD_TLNOIMAGE        -5408 /* Image %s not found */
#define PHD_TLNOIMALLOC      -5409 /* Cannot allocate an int matrix */
#define PHD_TLNOIORI         -5410 /* No interior orientation for %s */
#define PHD_TLNOIVALLOC      -5411 /* Cannot allocate an int vector */
#define PHD_TLNOLMALLOC      -5412 /* Cannot allocate a long matrix */
#define PHD_TLNOLVALLOC      -5413 /* Cannot allocate a long vector */
#define PHD_TLNOP2DMALLOC    -5414 /* Cannot allocate tmp pair list */
#define PHD_TLNOTFALLOC      -5415 /* Cannot allocate a tmp feature list */
#define PHD_TLNOTMPAALLOC    -5416 /* Cannot allocate tmp pair list */
#define PHD_TLNOBLOCKFOUND   -5447 /* No block file found */
#define PHD_TLBLOCKEMPTY     -5448 /* Empty block */
#define PHE_TLDIVEQUAL0      -5417 /* Divisor = 0 in collinearity equation */
#define PHE_TLEXORMALLOC     -5418 /* Cannot do malloc for EXOR for %s */
#define PHE_TLFILENOTFOUND   -5419 /* File %s not found */
#define PHE_TLIMGSZWRONG     -5420 /* Image size wrong */
#define PHE_TLINORWRONG      -5421 /* Interior orientation wrong */
#define PHE_TLINQMDLFAILED   -5422 /* Error in inquiring the model */
#define PHE_TLIOTYPEWRONG    -5423 /* Type of interior orientation wrong */
#define PHE_TLIOUNDEFINED    -5424 /* No interior orientation available */
#define PHE_TLMOREPYMLVLS    -5425 /* More pyramid levels required */
#define PHE_TLMTX33DET0      -5426 /* Matrix determinant = 0 */
#define PHE_TLMTXDIAEQ0      -5427 /* Matrix diagonal element = 0 */
#define PHE_TLMTXPIVEQ0      -5428 /* Matrix pivot element = 0 */
#define PHE_TLNOBETLVL       -5429 /* Image of intermed. level not available */
#define PHE_TLNOCAMDATA      -5430 /* Cannot get camera data */
#define PHE_TLNOIMGNAME      -5431 /* No image name found */
#define PHE_TLNOIMPTALLOC    -5432 /* Cannot allocate a 2D point vector */
#define PHE_TLNOINORPARS     -5433 /* Interior orientation not available */
#define PHE_TLNONOIMGNAME    -5434 /* Cannot get image name */
#define PHE_TLNOPYRAMID      -5435 /* No pyramid data for %s */
#define PHE_TLNOTENOUGHPTS   -5436 /* Not enough conjugate points */
#define PHE_TLPYRLVLMALLOC   -5437 /* Cannot do malloc for pyramid */
#define PHE_TLSMALLWSZ       -5438 /* Window size too small */
#define PHE_TLWINSZEQ0       -5439 /* Correlation window size = 0 */
#define PHW_TLBIGBETLVL      -5440 /* Image of intermediate level too large */
#define PHW_TLEVBIGERROR     -5441 /* Large model point error */
#define PHW_TLEVFEWPAIRS     -5442 /* Few conjugate points determined */
#define PHW_TLDEFAULTOV_X    -5443 /* Default overlap_x 60% used */
#define PHW_TLDEFAULTOV_Y    -5444 /* Default overlap_y 100% */
#define PHW_TLDEFAULTOV_XY   -5445 /* Default overlap_xy 60% 100% */
#define PHW_TLSAMEPTS        -5446 /* Two points are identical */
#define PHE_AROWRONGINOR     -5447 /* Wrong interior orientation */
#define PHE_TLROTATEDIMG     -5449 /* ARO not yet possible for rotated images */

/**** meo 5500 - 5520 ****/
#define PHE_MEONOPOINTSELECT       -5500 /* No GCP point picked */
#define PHE_MEOONLY512             -5501 /* You can measure only 512 points */
#define PHE_MEONOSUCHPOINT         -5502 /* Selected point %s illegal */
#define PHE_MEONOGCPPOINTS         -5503 /* No GCP points available */
#define PHE_MEOSTEFILEERROR        -5504 /* Cannot write file %s */
#define PHE_MEOIMGFILEERROR        -5505 /* Cannot write file %s */
#define PHW_MEOPOINTALREADYMESURED -5506 /* Point already measured, overwrite ?
*/

/************************** SPOT *******************/
/* Error Numbers for Spot reseved from 6000 - 7000 */
/* PHE_ prints an error
   PHD_ prints an disaster
   PHW_ prints an warning */

#define PHE_SPOT_EXITBASE 6600 /* For exit codes, i.e exit(ier), only 8 bit support */
#define PHE_SPOT_CANNOTFINDZONE  -6000 /* Zone %s not defined in datum %s */
#define PHE_SPOT_DATUMFILESYNTAX -6001 /* Syntax error in datum databsefile */
#define PHE_SPOT_SINGULARDATUMTRANSFER -6002 /* Data error in datum database \n \
                                                transfer %s is singular */
#define PHE_SPOT_SINGULARDATUMINVTRANSFER -6003 /* Data error in datum database \n \
                                                inverse of %s is singular */
#define PHE_SPOT_FAILEDTOALLOCATETR -6004 /* Out of memory \n \
                                             failed to allocate transfer %s */ 
#define PHE_SPOT_DATUMLIBINTERNAL -6005 /* Datumlib Bug : Internal error (%s) */
#define PHW_SPOT_CANNOTOPENGEOID -6006  /* Geoid database (%s) does not exist */
#define PHW_SPOT_GEOIDFILECORRUPTED -6007 /* Geoid database (%s) corrupted */
#define PHE_SPOT_UNKNOWNPROJECTIONTYPE -6008 /* Datum databse error : \n \
                                                unknown projection type (%s) */
#define PHE_SPOT_SPOTLIBINTERNAL -6009  /* SpotLib bug : Internal error */
#define PHE_SPOT_CANTREADIMA -6010      /* SpotImport : Cannot read imagefile */
#define PHE_SPOT_FAILEDTOCREATEFILE -6011 /* Failed to create modelfile (%s) */
#define PHE_SPOT_FAILEDREADMODELFILE -6012 /* Failed to read modelfile! \n (%s)\n*/
#define PHE_SPOT_COULDNOTPARSELEAD -6013 /* Could not parse the Spot Leader file (%s) \n \
                                            The CD might be corrupted or has an unsupported version */
#define PHE_SPOT_COULDNOTPARSEIMAG -6014 /* Could not parse the Spot Image file (%s) \n \
                                            The CD might be corrupted or has an unsupported version */
#define PHE_SPOT_MODELFILENOEXIST -6015 /* The spot model file %s does not exist */
#define PHE_SPOT_FAILEDWRITEMODELFILE -6016 /* Failed to write modelfile (%s!) */            
#define PHE_SPOT_TRANSFUNINITIALIZED -6017 /* Transformations for model uninitialized */            
#define PHE_SPOT_PHOTOWORLD_SINGULAR -6018 /* Photo->World Transformation is singular */
#define PHE_SPOT_NOTAMODELFILE -6019 /* Not a Spot Modelfile! */
#define PHE_SPOT_NONINITIALIZEDMODELFILE -6020 /* Modelfile not initialized: Fatal System Error! */
#define PHE_SPOT_FAILEDWRITEMODELFILE_FATAL -6021 /* Failed to write modelfile\n \
                                                     Fatal : Must be system Error */
#define PHE_SPOT_FAILEDWRITEOPENMODELFILE -6022 /* Failed to open modelfile (%s!) for writing */
#define PHE_SPOT_FAILEDTOREADINFOFILEGUI -6023 /* Failed to read infofile (%s!)\n \
                                                  cannot open computation (FATAL) */
#define PHE_SPOT_FAILEDTOWRITEMODELFILE -6024 /* Failed to write modelfile (%s)\n (%s)\n */
#define PHE_SPOT_NOCALIBRATION -6025 /* No calibration available (file:%s)\n" */
#define PHE_SPOT_FAILEDRESULTCALI -6026 /* Failed to get result - calibration update */

/*Codes 6500.. are for Adjustment Engine */
#define PHE_SPOTO_ILLEGALCALL -6501 /* System Error : SpotOrientation needs interfacefile (*.spot) and datum database file */
#define PHE_SPOTO_MODELFILENOEXIST -6502 /* System Error : Interfacefile missing (*.spot) */
#define PHE_SPOTO_FAILEDTOOPENMODELFILE -6503 /* System Error : Failed to open interfacefile (*.spot) */
#define PHE_SPOTO_FAILEDTOREADMODELFILE -6504 /* System Error : Failed reading interfacefile (*.spot) */
#define PHE_SPOTO_NOTAMODELFILE -6505 /* System Error : Interfacefile (*.spot) is not of correct type */
#define PHE_SPOTO_NOINPUTINMODELFILE -6506 /* System Error : Interfacefile (*.spot) does not contain any data */
#define PHE_SPOTO_NOHEADERSMODELFILE -6507 /* System Error : Interfacefile (*.spot) does not contain Spot headers */
#define PHE_SPOTO_NOAPPROXMODELFILE -6508 /* System Error : Interfacefile (*.spot) does not contain A prior information */
#define PHE_SPOTO_OUTOFMEMORY -6509 /* Allocations fails, out of memory */
#define PHE_SPOTO_ITERATIONUNFINISHED -6510 /* Unstable system, iteration exceeds Upper Limit\n \
                                          Reduce number of parameters or add observations */
#define PHE_SPOTO_ERRORINDATUMDEFINITION -6511 /* Co-ordinate Input and Datum definition do not match */
#define PHE_SPOTO_INTERFACETESTING -6512 /* Developer Error : Testing interface */
#define PHE_SPOTO_SINGULARSYSTEM -6513 /* Failed to compute : system is too unstable\n \
                                          Reduce number of parameters or add observations */
#define PHE_SPOTO_BUGCONTROLLINKS -6514 /* System Error : Program detected a BUG in link creation */
#define PHW_SPOTO_WITHOUTIMAGEOBS -6515 /* Warning: Computation performed without any image observations */
#define PHE_SPOTO_CANNOTOPENDATUM -6516 /* System Error : Computation modules fails to open datum */
#define PHE_SPOTO_COULDNOTAPPROXIMATE -6517 /* Error : Could not compute approximate values (ephemeris)\n / maybe unstable system, reduce number of orbit parameters */
#define PHE_SPOTO_ITERATIONDIVERGES -6518 /* Unstable system, iteration exceeds Upper Limit and Diverges\n \ Reduce number of parameters or add observations */
#define PHE_SPOTO_INVALIDSTD -6519         /* User error : Invalid standard deviation for a parameter observation\n \A standard deviation of zero or a negative standard deviation given */


/**** Xtools ****/

#define   XGE_VISUAL_INFO      -46200   /* Screen has not depth = 8 bits */
#define   XGE_DISPLAY          -46201   /* Display not opened */
#define   XGE_DEF_COLORMAP     -46202   /* Error in getting of Default-Colormap
*/
#define   XGE_GET_GEOMETRY     -46203   /* Not got screen geometry */

#define   XGE_FRAME_INDEX      -46204   /* No free Subframe index */
#define   XGE_LOC_COLORMAP     -46205   /* Error in creating of local colormap */
#define   XGE_DEPTH_24         -46206   /* No depth with 24 bits */
#define   XGE_COLOR_IND        -46207   /* Color index out of range */
#define   XGE_VIEWPORT         -46208   /* No viewport initialised */
#define   XGE_DRAWLINES        -46209   /* False number of points */
#define   XGE_POI_OUT_WIN      -46210   /* Pointer outside of window */
#define   XGE_NO_FRAME         -46211   /* Frame is not opened */
#define   XGE_NO_MEMORY        -46212   /* No memry allocated */
#define   XGE_ZOOM             -46213   /* False zoom factor */
#define   XGE_PIXMODE          -46214   /* False pixel mode */
#define   XGE_PIXDRAW          -46215   /* Error no memory in cz_pixdraw() */
#define   XGE_ZOOMING          -46216   /* Error in zooming */
#define   XGE_NO_CMAP          -46217   /* False Colormap: Must be local */
#define   XGE_CMAPCHANGE       -46218   /* Error in cz_cmap8_change() */
#define   XGE_INCOMP           -46219   /* Image does not fit in window depth */

/**** Texts for PHODIS ST ****/

#define   STE_UNKNOWNSIDREC        -44000 /* Unknown SID recieved : %s */
#define   STE_CANTREADGRDCOORD     -44001 /* Error by reading ground \
                                             coordinates from file %s ! */
#define   STE_CANTREADMODCOORD     -44002 /* Error by reading modell \
                                             coordinates from file %s ! */
#define   STE_UNKNOWNSYNCPNT       -44003 /* Unknown synchronisation point %s recieved */ 
#define   STE_STALREADYOPEN        -44004 /* Stereoplotter already open */
#define   STE_HLEVCHGGRAPICSON     -44005 /* Operator Height level or Model \
                           leveling changed !\n\This will cause inconsitent \
                           grapics.\n\Replot graphics before continue work !! */

/* Graphic routine error numbers */

#define   STE_GWRONGPAR            -45004 /* Wrong parameter %s in routine %s */
#define   STE_GSTNOTOPEN           -45005 /* Stereoplotter not open */
#define   STE_GSGOPEN              -45007 /* Segment already open */
#define   STE_GSGNOTOPEN           -45008 /* Segment not open */
#define   STE_GSGNOTFOUND          -45009 /* Segment not found */

/* CONTROL routine error numbers */ 

#define   STE_TOO_MANY_APL         -46001 /* Too many Applications try to \
                                             attach PHODIS ST */
#define   STE_NO_SUCH_TASK         -46002 /* Task %s does not exist ! */
#define   STE_PROCNOTPROPATT       -46003 /* Process can't properly \
                                             attach to PHODIS ST ! */
#define   STE_NOFREESHMKEY         -46004 /* No free SHM key available ! */
#define   STE_ILLEGALSHMKEY        -46005 /* Illegal SHM key : %s  !*/
#define   STE_NOFREESHMWIN         -46006 /* No free SHM for new Window  !*/
#define   STE_NOINFOSHM            -46007 /* INFO SHM does not exists ! */
#define   STE_MAYBEDEFECTSHM       -46008 /* Trouble with SHM !\
                                             SHM can be corrupt. */
#define   STE_NEEDTOOMANYGSHM      -46009 /* Too many Graphic SHM's are \
                                             requested ! */
#define   STE_CANTATTINFOSHM       -46010 /* Can't attach to INFO SHM ! */
#define   STE_CANTCREATEPSTSHM     -46011 /* Can't create PHODIS ST \
                                             shared memory ! */
#define   STE_CANTREMOVEPSTSHM     -46012 /* Can't remove existing shared \
                                             memory with PHODIS ST key %s ! */
#define   STE_CANTWRITEINFOSHM     -46013 /* Can't write to INFO SHM ! */
#define   STW_CANTWRSHMHDR         -46014 /* Can't write SHM Header for \
                                             pst, pstinput, pstdisplay ! */
#define   STE_CANTDELPSTSHM        -46015 /* Can't delete PHODIS ST SHM ! */
#define   STW_USINGDEFSHMSIZ       -46016 /* Application connects with illegal \
                                             SHM size !\n\Using default SHM \
                                             size : SHMSIZ = %s */
#define   STW_CANTSTARTWS          -46100 /* Can't start stereo workstation */
#define   STW_USINGSHMDEFSIZE      -46101 /* Using default SHM size ! */
#define   STE_ERRORINPROC          -46102 /* %s Error(s) occured in \
                                             process %s ( pid = %s ) ! */
#define   STW_ASSUMWSTYP           -46103 /* Unknown work station type ! \n \
                                             Assuming work station type : %s */
#define   STE_NOEPIIMGAVAL         -46104 /* No epipolar images available !\n \
                                             Start generation of epipolar \ 
                                             images first. */
#define   STE_CANTLOADMODEL        -46105 /* Can't load model %s ! */
#define   STW_WSTYPREQEPIIMG       -46106 /* Work station type %s requires \
                                             epipolar images ! */
#define   STE_WSTYPNOTSUP          -46107 /* Work station type %s not \
                                             supported ! */
#define   STE_NOMODROTATIONS       -46107 /* Rotation angles of %s model do not exist */
#define   STE_GRACTIVE             -46108 /* Graphics application still \
                                             connected !\n \
                                             Terminate program first. */
#define   STE_PSTNOTREADY          -46109 /* Connection to stereoplotter \
                                             refused !\n \
                                             Stereplotter not ready ! \
                                             Try again later. */

/* DISPLAY routine error numbers */ 

#define   STE_NO_SUCH_WIN          -47000 /* Window no. : %s does not exist ! */
#define   STE_ILLEGALBUFINFO       -47001 /* Illegal buffer information : \
                                             %s !*/
#define   STE_NOTALLWINPARSET      -47002 /* Not all window parameters set ! */
#define   STE_NOWINOPEN            -47003 /* No window opened ! */ 
#define   STE_NOREFPNT             -47004 /* Reference point missing ! */ 
#define   STE_NOIMAGELOAD          -47005 /* Image definition missing ! */
#define   STE_NOORIENT             -47006 /* Orientation missing ! */
#define   STE_ILLEGALGCOD          -47007 /* Illegal Graphic code ! */
#define   STW_PRLDVGBRDTOSMALL     -47008 /* Border defintion for Image-Pre- \
                                             Loading-Border to small ! */
#define   STE_CANTWRITEWININFO     -47009 /* Can't write window information \
                                             to SHM ! */
#define   STW_NOOFCHANILLLEAGL     -47010 /* Number of chanels %s in file %s \
                                             is illegal */
#define   STE_NOIMGAGEDEFINED      -47011 /* No images defined */ 
#define   STE_ILLEGALPENNUMBER     -47012 /* Illegal pen nuber %s */ 
#define   STE_NOPENCOLOR           -47013 /* No color defined for pen %s */ 
#define   STE_ILLEGALPIXSIZE       -47014 /* Illegal pixel size %s */ 
#define   STE_ILLEGALCHANNEL       -47015 /* Illegal chanel %s */ 
#define   STE_ILLEGALPLANE         -47016 /* Illegal plane selected %s \n\
                                             Plane is not 0=normal or \
                                             1=overdraw or 2=underdraw ! */ 
#define   STE_NOCOLORSLEFT         -47017 /* No colors left ! \n \
                                             Maximum number of defineable \
                                             pens : %s !*/ 
#define	  STE_STDNOINIT		   -47020 /* internal error (missing \
					     initialisation) function %s */
#define   STE_STDINTERNAL	   -47021 /* internal error: %s */
#define	  STE_STDNOHW		   -47022 /* wrong hardware, missing %s */
#define   STW_REMOTEDISPLAY        -47023 /* ST10 may only be started on \
                                             display :0.0 */
#define   STW_NOST10HARDWARE       -47024 /* ST10 requires High/Maximum \
                                             IMPACT with TRAM option board */
#define   STW_NOST10LICENSE        -47025 /* No ST10 license found */
#define   STW_FORCEDTOST30         -47026 /* Switching to ST30 */
#define   STW_NOST20HARDWARE       -47027 /* ST20 requires O2 \
                                             with CRM graphics board */
#define   STW_NOST20LICENSE        -47028 /* No ST20 license found */

/* INPUT routine error numbers */        

#define   STE_NO_SUCH_DEV          -48000 /* No such device : %s ! */
#define   STE_STA_NOT_OK           -48001 /* Device status %s not ok ! */

/* SWC error numbers */

#define	  PHW_SWCNOSUCHIMAGE	   -49000 /* Image not found in SWC */
#define	  PHE_SWCWRONGWSTYPE	   -49001 /* function %s called with wrong WSTYPE (expected %s) */

/**** Texts for PHODIS OP ****/
#define   OPE_SID_ILLEGAL          -21000

#define   OPE_USRCFG_CANNOTGEN     -20000

#define   OPE_FILCANNOTOPEN        -23100
#define   OPE_FNAMSTRC_FNAMEMPTY   -23200
#define   OPE_FNAMSTRC_WRONG       -23201
#define   OPE_FTYPWRONG            -23300

#define   OPE_OIPARSTAT_UNKNOWN    -23400
#define   OPM_FEWPARSINPUT         -23401
#define   OPE_THREEPOINTS_LINE     -23402   /* three points form a line, not a rectangle */
#define   OPE_TWOPOINTS_NOTDIST    -23403   /* two identical points */

#define   OPE_INPFILE_WRONG        -24000
#define   OPE_OIINPPAR_WRONG       -24001
#define   OPE_TOBIGAZIMUT          -24002  /* azimuth to large */
#define   OPE_ILLEGALPOINTER       -24003  /* uninitialized PHODIS OP internal pointer */
#define   OPE_DIFFSETUPIMG         -24004  /* setup file %s: incorrect data for image */
#define   OPE_AREAMODE             -24005  /* setup file %s: illegal ortho area mode */
#define   OPE_DEFINES              -24006  /* setup file %s: illegal ortho section */
#define   OPE_AREAPOLY             -24007  /* polygon input not implemented */
#define   OPE_AREAMODE2            -24008  /* illegal ortho area mode */
#define   OPE_PIXRES               -24009  /* illegal pixel resolution */
#define   OPE_ILLEGALCAM           -24010  /* setup file %s: illegal camera section */
#define   OPE_RECNOIMAGE           -24011  /* Ortho record: no image available */
#define   OPE_RECNODTM             -24012  /* Ortho record: no DTM available */
#define   OPE_RECNOORTHO           -24013  /* Ortho record: illegal information */
#define   OPE_NOCAM                -24014  /* Ortho initialization: no camera for image %s available ! */
#define   OPE_NOIO                 -24015  /* Ortho initialization: no interior orientation for image %s available ! */
#define   OPE_NOEO                 -24016  /* Ortho initialization: no exterior orientation for image %s available ! */
#define   OPE_ILLEGALDTM           -24017  /* setup file %s: illegal DTM section */
#define   OPE_OIOUTSIDEDTM         -24018  /* Orthoarea outside DTM %s */
#define   OPE_NEWOUTSIDEDTM        -24019  /* Internal used rotated DTM points outside given DTM */
#define   OPE_NOORTHORECORD        -24020  /* No record for ortho  %s */
#define   OPW_NOORTHOSINPROJECT    -24021  /* No orthos in project */
#define   OPE_NOACESSTOORTHO       -24022  /* No access to ortho image */
#define   OPE_NOACCESSTODTM        -24023  /* No access to DTM %s */
#define   OPE_PATCHPCOORLIMIT      -24025  /* Ortho patch pixel coordinates < 0 */
#define   OPE_PATCHNOPTABLEENTRY   -24026  /* No entries in patch table */
#define   OPE_PATCHUPDATE          -24027  /* Cannot update patch table */
#define   OPE_PATCHDTMROWS         -24028  /* Not enough DTM rows for patch */
#define   OPE_PATCHDTMCOLS         -24029  /* Not enough DTM columns for patch */
#define   OPE_PATCHLLUL            -24030  /* Patch border ll-ul */
#define   OPE_PATCHULUR            -24031  /* Patch border ul-ur */
#define   OPE_PATCHURLR            -24032  /* Patch border ur-lr */
#define   OPE_PATCHLRLL            -24033  /* Patch border lr-ll */
#define   OPE_PATCHIMG             -24034  /* Patch outside image */
#define   OPE_PATCHDTM             -24035  /* Patch outside DTM */
#define   OPE_PATCHIMGDTM          -24036  /* DTM outside image */
#define   OPE_RADIOMETRIC          -24037  /* Illegal radiometric mode */
#define   OPE_CHANMODE             -24038  /* Illegal channel mode */
#define   OPE_PROFILIDENTPNT       -24039  /* Ortho profile: identic points */
#define   OPE_PROFILNODIST         -24040  /* Ortho profile: to small distance between two points */
#define   OPE_PROFILOPCOLS         -24041  /* Ortho profile: point overflow */
#define   OPE_CALCROWCOL           -24042  /* Ortho rectification: calculation of row or column in patch went wrong */
#define   OPE_CALCIMGROWCOL        -24043  /* Ortho rectification: access to area outside image -> %s */
#define   OPE_AREA1STCORNER        -24044  /* lower left corner outside image */
#define   OPE_AREA2NDCORNER        -24045  /* upper left corner outside image */
#define   OPE_AREA3RDCORNER        -24046  /* upper right corner outside image */
#define   OPE_AREA4THCORNER        -24047  /* lower right corner outside image */
#define   OPE_AREAOK               -24048  /* ortho area undefined */
#define   OPE_MDIFROWPIXELSIZE     -24049  /* Mosaic: different row pixelsize */
#define   OPE_MDIFCOLPIXELSIZE     -24050  /* Mosaic: different col pixelsize */
#define   OPE_MDIFAZIMUTH          -24051  /* Mosaic: different azimuth */
#define   OPE_MDIFNOOFCHANNELS     -24052  /* Mosaic: different no of channels */
#define   OPE_MDIFSCALE            -24053  /* Mosaic: different scales */
#define   OPE_MIMGGO               -24054  /* Mosaic: error in imggo program */
#define   OPE_MBASE                -24055  /* Mosaic: no proper base number found */
#define   OPE_MAREA                -24056  /* Mosaic display: overlap to small */
#define   OPE_MDISFONT             -24057  /* Mosaic display: Font not available */
#define   OPE_MDISIMAGE            -24058  /* Mosaic display: Can't create image */
#define   OPE_MDISXERROR           -24059  /* Mosaic display: X initialize error */
#define   OPE_MDISRUB              -24060  /* Mosaic display: Macro RUB_FD too low */
#define   OPE_MDISFILE             -24061  /* Mosaic display: Cannot create band width file %s */
#define   OPE_MDISSEAM             -24062  /* Mosaic display: Seam line error */
#define   OPE_MMMASKFILE           -24063  /* Mosaic: maskfile %s exists, check for running mosaic2 program or delete file */
#define   OPE_MMMOSAIC             -24064  /* Mosaic: Illegal name %s */
#define   OPE_GRIDCROSSCODE        -24065  /* Cross: Illegal crosscode */
#define   OPE_GRIDCROSSSIZE        -24066  /* Cross: cross outside Ortho */
#define   OPE_GRIDGUI              -24067  /* entered values illegal */
#define   OPE_EN2RCMODE            -24068  /* Wrong mode in input file (1 <= PHO_COMODE <= 4) */
#define   OPE_EN2RCUNIT            -24069  /* Wrong coordinate unit (0 <= PHO_COUNIT <= 2) */
#define   OPE_EN2RCFORMAT          -24070  /* Data in input file have wrong format */
#define   OPE_QCVALIDNOPOINTS      -24071  /* No valid points in file %s found */
#define   OPE_QCVALIDPOINTS        -24072  /* Illegal points in file %s found */
#define   OPE_QCNOIDENTPOINT       -24073  /* RMSE: No identic point numbers found */
#define   OPE_QCDOQTF              -24074  /* doqtf: Cannot calculate TF parameters */
#define   OPE_QCIUCVALUES          -24075  /* iuc: Not enough values in coordinate file %s */
#define   OPE_DOQSETUPGCP          -24076  /* check orthoimage and GCP file */

/* OP backdrop */
#define OPE_BACKROW      -24100 /* Row ortho image raster width <= 0.0 */
#define OPE_BACKCOL      -24101 /* Column ortho image raster width <= 0.0 */
#define OPE_BACKSCALE    -24102 /* Scale of ortho image <= 0.0 */
#define OPE_BACKEAST     -24103 /* Easting ground resolution <= 0.0 */
#define OPE_BACKNORTH    -24104 /* Northing ground resolution <= 0.0 */
#define OPE_BACKZOOM     -24105 /* Zoom factor <= 0 */
#define OPE_BACKDATA     -24106 /* No ortho image data available */
#define OPE_BACKSCREENX  -24107 /* Cols of screen set to <= 0 */
#define OPE_BACKSCREENY  -24108 /* Rows of screen set to <= 0 */
#define OPE_BACKAREA     -24109 /* Plot area outside ortho image area */
#define OPE_BACKMEMROWS  -24110 /* MemRows < 1 */
#define OPE_BACKCOLBEG   -24111 /* Colbeg in oi negative */
#define OPE_BACKROWBEG   -24112 /* Rowbeg in oi negative */
#define OPE_BACKOPROW    -24113 /* Rows in ortho <= 0 */
#define OPE_BACKOPCOL    -24114 /* Columns in ortho <= 0 */
#define OPE_BACKOPCHAN   -24115 /* Channels in ortho <= 0 */
#define OPE_BACKOPELEN   -24116 /* Easting size of ortho <= 0 */
#define OPE_BACKOPNLEN   -24117 /* Northing size of ortho <= 0 */

/* OP PostScript */
#define OPE_PSAREAH      -24130 /* Graphic outside printer area y: %s */
#define OPE_PSAREAB      -24131 /* Graphic outside printer area x: %s */
#define OPE_PSWRITE      -24132 /* File %s write error */
#define OPE_PSREAD       -24133 /* File %s read error */
#define OPE_FORMATNOTSUP -24134 /* PostScript format %s not supported */



/**** Texts for PHODIS SC ****/
/*        -40000  ...  -30001        */
#define   SCD_SCAI_ERR001          -30001 /* SCAI Error 001 : Wrong SCSI command */
#define   SCD_SCAI_ERR002          -30002 /* SCAI Error 002 : Timeout during SCSI command */
#define   SCD_SCAI_ERR003          -30003 /* SCAI Error 003 : General error during SCSI command */
#define   SCD_SCAI_ERR004          -30004 /* SCAI Error 004 : Obsolete data in SCSI command */
#define   SCD_SCAI_ERR005          -30005 /* SCAI Error 005 : Timeout in SCSI processor command */
#define   SCE_SCAI_ERR006          -30006 /* SCAI Error 006 : Undefined opcode */
#define   SCD_SCAI_ERR007          -30007 /* SCAI Error 007 : Missing ACK/NAK after command code */
#define   SCE_SCAI_ERR008          -30008 /* SCAI Error 008 : Missing ACK/NAK as SCSI processor response */
#define   SCE_SCAI_ERR009          -30009 /* SCAI Error 009 : Negative receipt in control program */
#define   SCE_SCAI_ERR010          -30010 /* SCAI Error 010 : General error in digitizing program */
#define   SCD_SCAI_ERR011          -30011 /* SCAI Error 011 : Error during start of drives */
#define   SCD_SCAI_ERR012          -30012 /* SCAI Error 012 : Error during request of drive status */
#define   SCD_SCAI_ERR013          -30013 /* SCAI Error 013 : Timeout during drive command */
#define   SCW_SCAI_ERR014          -30014 /* SCAI Error 014 : Error in drive range (at least one drive) */
#define   SCD_SCAI_ERR015          -30015 /* SCAI Error 015 : Error in drive position during drive command */
#define   SCM_SCAI_ERR016          -30016 /* SCAI Error 016 : Hood of scanner is open */
#define   SCD_SCAI_ERR017          -30017 /* SCAI Error 017 : Temperature at illumination lamp too high */
#define   SCD_SCAI_ERR018          -30018 /* SCAI Error 018 : Illumination lamp #1 is down */
#define   SCD_SCAI_ERR019          -30019 /* SCAI Error 019 : Illumination lamp #2 is down */
#define   SCD_SCAI_ERR020          -30020 /* SCAI Error 020 : Illumination lamps out of control */
#define   SCD_SCAI_ERR021          -30021 /* SCAI Error 021 : At least one cable connection is broken */
#define   SCD_SCAI_ERR022          -30022 /* SCAI Error 022 : At least one amplifier is overheated */
#define   SCE_SCAI_ERR023          -30023 /* SCAI Error 023 : Error at display unit */
#define   SCD_SCAI_ERR024          -30024 /* SCAI Error 024 : Error in lifting/lowering of glass plate */
#define   SCD_SCAI_ERR025          -30025 /* SCAI Error 025 : Error in scanner hardware control */
#define   SCW_SCAI_ERR026          -30026 /* SCAI Error 026 : Obsolete color control selected */
#define   SCW_SCAI_ERR027          -30027 /* SCAI Error 027 : Obsolete color channel selected */
#define   SCW_SCAI_ERR028          -30028 /* SCAI Error 028 : Obsolete color depth selected */
#define   SCE_SCAI_ERR029          -30029 /* SCAI Error 029 : Obsolete transfer mode selected */
#define   SCD_SCAI_ERR030          -30030 /* SCAI Error 030 : IR filter could not be selected properly */
#define   SCD_SCAI_ERR031          -30031 /* SCAI Error 031 : Timeout during wait for drive */
#define   SCD_SCAI_ERR032          -30032 /* SCAI Error 032 : Glass plate in wrong (upper) position */
#define   SCD_SCAI_ERR033          -30033 /* SCAI Error 033 : Error in computing scan position */
#define   SCD_SCAI_ERR034          -30034 /* SCAI Error 034 : Error in reaching a position */
#define   SCD_SCAI_ERR035          -30035 /* SCAI Error 035 : Drive pair stopped due to error */
#define   SCE_SCAI_ERR036          -30036 /* SCAI Error 036 : Host requests more data than available */
#define   SCE_SCAI_ERR037          -30037 /* SCAI Error 037 : Host requires less data than available */
#define   SCE_SCAI_ERR038          -30038 /* SCAI Error 038 : Host requests full block not available */
#define   SCD_SCAI_ERR039          -30039 /* SCAI Error 039 : FIFO overflow at SCSI or CCD PCB */
#define   SCD_SCAI_ERR040          -30040 /* SCAI Error 040 : Control program couldn't change own variables */
#define   SCD_SCAI_ERR041          -30041 /* SCAI Error 041 : Error in normalization procedure */
#define   SCD_SCAI_ERR042          -30042 /* SCAI Error 042 : Parameter(s) out of range */
#define   SCD_SCAI_ERR043          -30043 /* SCAI Error 043 : Error in generating LookUpTable */
#define   SCD_SCAI_ERR044          -30044 /* SCAI Error 044 : Color correction values request brig=4/20 */
#define   SCD_SCAI_ERR045          -30045 /* SCAI Error 045 : Send command during receipt of scan data */
#define   SCD_SCAI_ERR046          -30046 /* SCAI Error 046 : Parameter range error in 'initials.dat' */
#define   SCD_SCAI_ERR047          -30047 /* SCAI Error 047 : File 'initials.dat' is missing */

#define   SCE_SCAI_ERR255          -30255 /* SCAI Error 255 : Overflow in SCAI error list */

#define   SCE_SCSI_ERR000          -30300 /* SCSI ERROR   0 : No SCSI error */
#define   SCE_SCSI_ERR001          -30301 /* SCSI ERROR  -1 : SCSI device already open */
#define   SCE_SCSI_ERR002          -30302 /* SCSI ERROR  -2 : SCSI bus error */
#define   SCE_SCSI_ERR003          -30303 /* SCSI ERROR  -3 : SCSI device denies operation */
#define   SCE_SCSI_ERR004          -30304 /* SCSI ERROR  -4 : Device answer not ACK */
#define   SCE_SCSI_ERR005          -30305 /* SCSI ERROR  -5 : Device answer not STX */
#define   SCE_SCSI_ERR006          -30306 /* SCSI ERROR  -6 : Device busy */
#define   SCE_SCSI_ERR007          -30307 /* SCSI ERROR  -7 : Last data block received */
#define   SCE_SCSI_ERR008          -30308 /* SCSI ERROR  -8 : Power on detected */
#define   SCE_SCSI_ERR009          -30309 /* SCSI ERROR  -9 : Wrong operation code */
#define   SCE_SCSI_ERR010          -30310 /* SCSI ERROR -10 : SCSI request sense */
#define   SCE_SCSI_ERR011          -30311 /* SCSI ERROR -11 : Wrong colormode */
#define   SCE_SCSI_ERR012          -30312 /* SCSI ERROR -12 : Wrong exposure time */
#define   SCE_SCSI_ERR013          -30313 /* SCSI ERROR -13 : Wrong resolution */
#define   SCE_SCSI_ERR014          -30314 /* SCSI ERROR -14 : Wrong data format */
#define   SCE_SCSI_ERR015          -30315 /* SCSI ERROR -15 : Wrong scan area */
#define   SCE_SCSI_ERR016          -30316 /* SCSI ERROR -16 : Wrong brightness */
#define   SCE_SCSI_ERR017          -30317 /* SCSI ERROR -17 : Wrong gamma correction */
#define   SCE_SCSI_ERR018          -30318 /* SCSI ERROR -18 : Wrong color correction */
#define   SCE_SCSI_ERR019          -30319 /* SCSI ERROR -19 : Wrong gamma LUT */
#define   SCE_SCSI_ERR020          -30320 /* SCSI ERROR -20 : Memory allocation error */
#define   SCE_SCSI_ERR021          -30321 /* SCSI ERROR -21 : Wrong scan speed */
#define   SCE_SCSI_ERR022          -30322 /* SCSI ERROR -22 : Wrong scan display text */
#define   SCE_SCSI_ERR023          -30322 /* SCSI ERROR -23 : Wrong film thickness */
#define   SCE_SCSI_ERR024          -30322 /* SCSI ERROR -24 : Wrong roll diameter */
#define   SCE_SCSI_ERR025          -30322 /* SCSI ERROR -25 : Wrong photo size */
#define   SCE_SCSI_ERR026          -30322 /* SCSI ERROR -26 : unused */
#define   SCE_START_ERROR          -30400 /* Process start error : %s */

#define   PHW_NOCHANGE             -30999 /* Parameter not changed */
#define   SCE_PARFILE              -31000 /* Parameter file %s error : %s */
#define   SCW_PARNOLOAD            -31001 /* Parameter file %s not loaded */
#define   SCE_DELCURR_PAR          -31002 /* Current parameter file %s cannot be deleted */
#define   SCE_NOTDEL_PAR           -31003 /* Parameter file %s not removed */
#define   SCE_SHORTL_PAR           -31004 /* Line %s in parameter file %s too short */
#define   SCE_WRONG_PAR            -31005 /* Line %s in parameter file %s is wrong */
#define   SCW_UNSUPPORTED_PAR      -31006 /* Parameter %s is unsupported */
#define   SCE_OLD_PAR              -31007 /* Parameter %s has wrong version */
#define   SCE_LISTFILE             -31009 /* List file %s error : %s */

#define   SCE_FMASK_ILLCHR         -31011 /* File mask contains illegal character */
#define   SCE_FMASK_SECOP          -31012 /* File mask contains second open character */
#define   SCE_FMASK_CLOSE          -31013 /* File mask contains close before open character */
#define   SCE_FMASK_NONE           -31014 /* File mask contains no mask character */
#define   SCE_FMASK_LAST           -31015 /* End of file mask reached */
#define   SCE_FMASK_FIRST          -31016 /* Begin of file mask reached */
#define   SCE_FMASK_OPEN           -31017 /* File mask without close character */
#define   SCE_FMASK_MATCH          -31018 /* Filename don't match file mask \n%s\n%s*/
#define   SCE_AREA_WRONG           -31019 /* Scan area is wrong */
#define   SCW_SCAN_DEVI_DEF        -31020 /* Using scanner default device name : %s */
#define   SCE_SCAN_DEVI_WRONG      -31021 /* Wrong scanner device name %s in configuration file */
#define   SCW_CALI_NOPARABEL       -31055 /* Couldn't compute regression parabel*/
#define   SCE_CALI_ILL_DIST        -31100 /* Calibration alignment distance out of range */
#define   SCE_CALI_ILL_PHI         -31101 /* Calibration alignment angle out of range */
#define   SCE_CALI_FILE            -31102 /* Calibration file %s error %s*/
#define   SCE_CALI_SHORTLINE       -31103 /* Calibration file %s line too short %s*/
#define   SCE_CALI_WRONGLINE       -31104 /* Calibration file %s line wrong %s*/
#define   SCW_CALI_MAXPOINT        -31105 /* Calibration file %s contains wrong number of points (3 ... 25) */
#define   SCW_CALI_MAX_MEASURE     -31106 /* Measurement point overflow. Maximum is %s*/
#define   SCW_CALI_WRONG_MEASURE   -31107 /* Wrong measurement point */
#define   SCE_CALI_ILL_SLOPE       -31108 /* Measurement points out of tolerance */
#define   SCE_SINFILE              -31200 /* Scan information file %s error : %s */
#define   SCE_SINREMOVE            -31201 /* Scan information file removed due to previous error */
#define   SCE_NOCOLORTIFF          -31202 /* Selected combination (color/resolution/imageformat/orientation) is not supported */
#define   SCE_NOAIOPYM             -31203 /* AIO without pyramids not supported*/
#define   SCM_PARIDXNAME           -31204 /* Parameter index and name mismatch %s */
#define   SCM_SCAISTARTERROR       -31205 /* SCAI errors during startup */
#define   SCE_FIDU_NOTENOUGH       -31206 /* Not enough (>= 2) fiducials selected */
#define   SCW_FIDU_NOTSCANNED      -31207 /* Fiducials not scanned */
#define   SCM_FIDU_ABORTED         -31208 /* Fiducial scan aborted */
#define   SCM_SCAN_ABORTED         -31209 /* Scan aborted */
#define   SCM_CALI_ABORTED         -31210 /* Calibration scan aborted */
#define   SCE_FIDU_WRONGAREA       -31211 /* Photo misplaced! Fiducials outside */
#define   SCM_OVER_ABORTED         -31212 /* Film overview scan aborted */
#define   SCM_OVER_ACCESSERR       -31213 /* Film overview file access failed */
#define   SCE_NOTDEL_FILM          -31224 /* Film file %s not deleted */
#define   SCE_NOTDEL_FLIGHT        -31225 /* Flight data file %s not deleted */
#define   SCE_NOTDEL_OVER          -31226 /* Film overview file %s not deleted */
#define   SCW_PHONUMNOTFOUND       -31227 /* Photo number not found */
#define   SCW_WRONG_PHOTOPOSITION  -31228 /* Wrong photo position */
#define   SCW_WRONG_PHOTOINDEX     -31229 /* Wrong photo index */
#define   SCE_FILMACCESS           -31230 /* Film file %s access error */
#define   SCE_FILMNONE             -31231 /* File %s is not a film file */
#define   SCE_FILMWRONG            -31232 /* Film file has wrong record */
#define   SCE_FILMNOTOPEN          -31233 /* Film file is not available */
#define   SCE_SCAIBUTTONDIS        -31234 /* SCAI buttons are not disabled */
#define   SCE_FILMNOTALIGNED       -31235 /* Film is not aligned */
#define   SCE_FILMSIZECHANGE       -31236 /* Size of film file can't be changed */
#define   SCE_FILMLSTFILE          -31237 /* Film list file %s error : %s */
#define   SCE_FILMPROTFILE         -31238 /* Film protocol file %s error : %s */
#define   SCE_ILLALIGNPAT          -31239 /* Illegal film alignment pattern */
#define   SCE_ILLPHOTOORI          -31240 /* Illegal photo orientation */
#define   SCE_FILMWORKFILE         -31241 /* Film work file %s error : %s */
#define   SCE_FILMWRONGPOS         -31242 /* The roll film positioning is not precise enough  or at least in combination with scan area */
#define   SCE_IMGTOOLARGEE         -31243 /* Image size too large */
#define   SCE_SCANOVERFLOW         -31244 /* Scan data overflow! Scan aborted */
#define   SCW_FILMPRJMISMATCH      -31245 /* New film file requires project %s*/
#define   SCE_FILMUPDATEFAIL       -31246 /* Updating film file %s to new revision failed! */
#define   SCE_LINENOTFOUND         -31247  /* %sline not found */
#define   SCE_SHMTOOSMALL          -31248  /* Shared memory too small */
#define   SCW_FILMOVNOTVALID       -31249  /* Film overview not found or not valid */
#define   SCW_NOINDIVIDUALPAR      -31250  /* Photo has no individual parameter */
#define   SCE_FILMWRKFILE          -31251 /* Film work file %s error : %s */
#define   SCW_FILMISALIGNED        -31252 /* Film is aligned. No change! */
#define   SCW_FILMNOINCREMENT      -31253 /* Image file and photo number increment required */

#define   SCE_LUT_ERRORINLINE      -32000 /* Error in Line %s: %s */
#define   SCE_LUT_NOTSUPPORTED     -32001 /* LUT with %s bit not supported */
#define   SCE_LUT_CANTCREATE       -32002 /* Creating LUT %s failed */

/**** Texts for PHODIS AR ****/

/**** Texts for PHODIS DTM ****/
/*        50001 60000         */
#define PHE_HIFIFILENOTFOUND                  -50002 /* cannot find file */
#define PHE_HIFIFILENOTREADABLE               -50004 /* data base file is not readable */
#define PHE_HIFICANNOTDUMPDTM                 -50008 /* cannot dump memory into binary file */
#define PHE_HIFIWARNING                       -50009 /* warning of module hifi, does not cause error handling in main module */
#define PHE_HIFIIAGETDATASETNOTAVAILABLE      -50010 /* hifi, iaget, dataset not available */
#define PHE_HIFIIAGETERRORNO2                 -50011 /* hifi, iaget, error 2, this type of point is not allowed */
#define PHE_HIFIIAGETERRORNO4                 -50012 /* hifi, iaget, error 4, the number of the dataset is not correct */
#define PHE_HIFIIAGETERRORNO5                 -50013 /* hifi, iaget, error 5, no memory on array */
#define PHE_HIFIIAGETERRORNO6                 -50014 /* hifi, iaget, error 6, can't open file PNTTYP.INF */
#define PHE_HIFIIAGETERRORNO7                 -50015 /* hifi, iaget, error 6, can't close file PNTTYP.INF */
#define PHE_HIFIIAGETERRORNO11                -50016 /* hifi, iaget, error 11, the number of passed coordinates is not correct */
#define PHE_HIFIIAGETERRORNO20                -50017 /* hifi, iaget, error 20, you can not access this type of point inside the loaded working area */
#define PHE_HIFIIAGETERRORNO26                -50018 /* hifi, iaget, error 26, you have not set the working area */
#define PHE_HIFIIAGETERRORNO96                -50019 /* hifi, iaget, error 96, can't open the file warn.gis */
#define  PHE_HIFIIAGETERRORNO999              -50020 /* hifi, iaget, error 999, not specified error */
#define  PHE_HIFIDBSINFERRORNO15              -50021 /* hifi, dbsinf, error 15, file with dtm-information (hifi-database) not found */
#define  PHE_HIFIDBSINFERRORNO16              -50022 /* hifi, dbsinf, error 16, hifi-database is still open, can't reopen the file ! */
#define  PHE_HIFIDBSINFERRORNO17              -50023 /* hifi, dbsinf, error 17, can't open hifi-database */
#define  PHE_HIFIDBLOADERRORNO1               -50024 /* hifi, dbload, error 1 */
#define  PHE_HIFIDBLOADERRORNO2               -50025 /* hifi, dbload, error 2 */
#define  PHE_HIFIDBLOADERRORNO4               -50026 /* hifi, dbload, error 4 */
#define  PHE_HIFIDBLOADERRORNO5               -50027 /* hifi, dbload, error 5 */
#define  PHE_HIFIDBLOADERRORNO6               -50028 /* hifi, dbload, error 6 */
#define  PHE_HIFIDBLOADERRORNO7               -50029 /* hifi, dbload, error 7 */
#define  PHE_HIFIDBLOADERRORNO8               -50030 /* hifi, dbload, error 8 */
#define  PHE_HIFIDBLOADERRORNO9               -50031 /* hifi, dbload, error 9 */
#define  PHE_HIFIDBLOADERRORNO11              -50032 /* hifi, dbload, error 11 */
#define  PHE_HIFIDBLOADERRORNO12              -50033 /* hifi, dbload, error 12 */
#define  PHE_HIFIDBLOADERRORNO13              -50034 /* hifi, dbload, error 13 */
#define  PHE_HIFIDBLOADERRORNO15              -50035 /* hifi, dbload, error 15 */
#define  PHE_HIFIDBLOADERRORNO16              -50036 /* hifi, dbload, error 16 */
#define  PHE_HIFIDBLOADERRORNO17              -50037 /* hifi, dbload, error 17 */
#define  PHE_HIFIDBLOADERRORNO19              -50038 /* hifi, dbload, error 19 */
#define  PHE_HIFIDBLOADERRORNO21              -50039 /* hifi, dbload, error 21 */
#define  PHE_HIFIDBLOADERRORNO25              -50040 /* hifi, dbload, error 25 */
#define  PHE_HIFIDBLOADERRORNO39              -50041 /* hifi, dbload, error 39 */
#define  PHE_HIFIDBLOADERRORNO58              -50042 /* hifi, dbload, error 58 */
#define  PHE_HIFIDBLOADERRORNO60              -50043 /* hifi, dbload, error 60 */
#define  PHE_HIFIDBLOADERRORNO61              -50044 /* hifi, dbload, error 61 */
#define  PHE_HIFIDBLOADERRORNO66              -50045 /* hifi, dbload, error 66 */
#define  PHE_HIFIDBLOADERRORNO67              -50046 /* hifi, dbload, error 67 */
#define  PHE_HIFIDBLOADERRORNO75              -50047 /* hifi, dbload, error 75 */
#define  PHE_HIFIDBLOADERRORNO87              -50048 /* hifi, dbload, error 87 */
#define  PHE_HIFIDBLOADERRORNO89              -50049 /* hifi, dbload, error 89 */
#define  PHE_HIFIDBLOADERRORNO102             -50050 /* hifi, dbload, error 102 */
#define  PHE_HIFIDBLOADERRORNO900             -50051 /* hifi, dbload, error 902 */
#define  PHE_HIFIDBLOADERRORNO998             -50052 /* hifi, dbload, error 998 */
#define  PHE_HIFIDBLOADERRORNO999             -50053 /* hifi, dbload, error 999 */
#define  PHE_HIFIIASAVEERRORNO90              -50054 /* hifi, iasave, error 90, can't open the restore file */
#define  PHE_HIFIIARESTERRORNO90              -50055 /* hifi, iarest, error 90, can't open the restore file */
#define  PHE_HIFIDBBACKERRORNO1               -50056 /* hifi, dbback, error 1 */
#define  PHE_HIFIDBBACKERRORNO2               -50057 /* hifi, dbback, error 2 */
#define  PHE_HIFIDBBACKERRORNO4               -50058 /* hifi, dbback, error 4 */
#define  PHE_HIFIDBBACKERRORNO5               -50059 /* hifi, dbback, error 5 */
#define  PHE_HIFIDBBACKERRORNO6               -50060 /* hifi, dbback, error 6 */
#define  PHE_HIFIDBBACKERRORNO7               -50061 /* hifi, dbback, error 7 */
#define  PHE_HIFIDBBACKERRORNO11              -50062 /* hifi, dbback, error 11 */
#define  PHE_HIFIDBBACKERRORNO12              -50063 /* hifi, dbback, error 12 */
#define  PHE_HIFIDBBACKERRORNO15              -50064 /* hifi, dbback, error 15 */
#define  PHE_HIFIDBBACKERRORNO16              -50065 /* hifi, dbback, error 16 */
#define  PHE_HIFIDBBACKERRORNO17              -50066 /* hifi, dbback, error 17 */
#define  PHE_HIFIDBBACKERRORNO18              -50067 /* hifi, dbback, error 18 */
#define  PHE_HIFIDBBACKERRORNO20              -50068 /* hifi, dbback, error 20 */
#define  PHE_HIFIDBBACKERRORNO26              -50069 /* hifi, dbback, error 26 */
#define  PHE_HIFIDBBACKERRORNO73              -50070 /* hifi, dbback, error 73 */
#define  PHE_HIFIDBBACKERRORNO76              -50071 /* hifi, dbback, error 76 */
#define  PHE_HIFIDBBACKERRORNO77              -50072 /* hifi, dbback, error 77 */
#define  PHE_HIFIDBBACKERRORNO78              -50073 /* hifi, dbback, error 78 */
#define  PHE_HIFIDBBACKERRORNO79              -50074 /* hifi, dbback, error 79 */
#define  PHE_HIFIDBBACKERRORNO80              -50075 /* hifi, dbback, error 80 */
#define  PHE_HIFIDBBACKERRORNO96              -50076 /* hifi, dbback, error 96 */
#define  PHE_HIFIDBBACKERRORNO99              -50077 /* hifi, dbback, error 99 */
#define  PHE_HIFIDBBACKERRORNO998             -50078 /* hifi, dbback, error 998 */
#define  PHE_HIFIDBBACKERRORNO999             -50079 /* hifi, dbback, error 999 */
#define  PHE_HIFIIAFXYERRORNO1                -50080 /* hifi, iafxy, error 1 */
#define  PHE_HIFIIAFXYERRORNO2                -50081 /* hifi, iafxy, error 2 */
#define  PHE_HIFIIAFXYERRORNO3                -50082 /* hifi, iafxy, error 3 */
#define  PHE_HIFIIAFXYERRORNO4                -50083 /* hifi, iafxy, error 4 */
#define  PHE_HIFIIAFXYERRORNO5                -50084 /* hifi, iafxy, error 5 */
#define  PHE_HIFIIAFXYERRORNO6                -50085 /* hifi, iafxy, error 6 */
#define  PHE_HIFIIAFXYERRORNO7                -50086 /* hifi, iafxy, error 7 */
#define  PHE_HIFIIAFXYERRORNO8                -50087 /* hifi, iafxy, error 8 */
#define  PHE_HIFIIAFXYERRORNO10               -50088 /* hifi, iafxy, error 10 */
#define  PHE_HIFIIAFXYERRORNO11               -50089 /* hifi, iafxy, error 11 */
#define  PHE_HIFIIAFXYERRORNO35               -50090 /* hifi, iafxy, error 35 */
#define  PHE_HIFIIAFXYERRORNO38               -50091 /* hifi, iafxy, error 38 */
#define  PHE_HIFIIAFXYERRORNO41               -50092 /* hifi, iafxy, error 41 */
#define  PHE_HIFIIAFXYERRORNO42               -50093 /* hifi, iafxy, error 42 */
#define  PHE_HIFIIAFXYERRORNO53               -50094 /* hifi, iafxy, error 53 */
#define  PHE_HIFIIAFXYERRORNO99               -50095 /* hifi, iafxy, error 99 */
#define  PHE_HIFIIAFXYERRORNO998              -50096 /* hifi, iafxy, error 998 */
#define  PHE_HIFIIAFXYERRORNO999              -50097 /* hifi, iafxy, error 999 */
#define  PHE_HIFIIAINFERRORNO99               -50098 /* hifi, iainf, error 99 */
#define  PHE_HIFIIAINFERRORNO999              -50099 /* hifi, iainf, error 999 */
#define  PHE_HIFICANNOTSPECIFYERROR           -50100 /* cannot specify error caused */
#define  PHE_TMINITIALIZE                     -50101 /* Cannot initialize TM function package */ 
#define  PHE_TMNOTINITIALIZED                 -50102 /* TM function package not initialized */
#define  PHE_TMNOTATMFILE                     -50103 /* %s is not a TERRAMODEL file */
#define  PHE_TMNOLAYERINDEX                   -50104 /* Cannot read layerindex */
#define  PHE_TMNOLAYERNAME                    -50105 /* Cannot read layername */
#define  PHE_TMPOINTEXTENT                    -50106 /* Cannot read extents */
#define  PHE_TMLINK                           -50107 /* Cannot link TIN */
#define  PHE_TMGRID                           -50108 /* Cannot compute grid elevations */
#define  PHE_TMPOLYSEG                        -50109 /* Computing DTM bounding polygon failed */
#define  PHE_TMUNITS                          -50110 /* Cannot read UNITS from TIN */
#define  PHE_TMPOINT                          -50111 /* Cannot compute elevation for single point */
#define PHE_DCZDATATYPE                       -50150 /* wrong elevation data type */
#define PHE_DCZELEVATIONDATASIZE              -50151 /* wrong elevation data size */
#define PHE_DCZOLDNEWTYPE                     -50152 /* cannot determine filesize of file %s */
#define PHE_DCZHEADER                         -50153 /* cannot read DTM header */
#define PHE_DCZDATA                           -50154 /* cannot read DTM data */
#define PHE_DCZUNDEFINEDCOOR                  -50155 /* undefined DTM coordinate */
#define PHE_DCZPOINT                          -50156 /* DTM point outside raster */
#define PHE_DCZRASTERWIDTH                    -50157 /* illegal value for raster width or lenght */
#define PHE_DCZORDER                          -50158 /* illegal x,y,z order */
#define PHE_DCZFACTOR                         -50159 /* illegal factor */
#define PHE_DCZDIFFERCORNER                   -50160 /* DTM's have different lower left corners */
#define PHE_DCZDIFFERRC                       -50161 /* DTM's have different rows/cols */
#define PHE_DCZDIFFERRASTER                   -50162 /* DTM's have different width/height */
#define PHW_DCZDIVISORRESET                   -50163 /* Divisor = 0, reset to 1. */
#define PHE_DCZINTERSECTION                   -50164 /* intersection */
#define PHE_DCZHANDDLE                        -50165 /* dcz: no DTM handle free */
#define PHE_DCZINIT                           -50166 /* dcz: package not initialized */
#define PHE_DCZID                             -50167 /* dcz: no valid DTM ID */
#define PHE_DTMCHECKPOINT                     -50168 /* no valid points in check point file found */
#define PHE_DTMRMSE                           -50169 /* number of check points < 2 */
#define PHE_DTMNOSUPPORT                      -50170 /* unknown DTM format */
#define PHE_SCATTACH                          -50200 /* cannot attach %s */
#define PHE_SCPROFILE                         -50201 /* profile has less than 2 points */
#define PHE_SCALLPOINTS                       -50202 /* allpoints not implemented */
#define PHE_SCELEVATION                       -50203 /* cannot compute elevation */

#define  PHE_NOTSDEFFILE                      -50301 /* Default control file \
                                             for DEM auto correlation : %s \
                                             does not exist !\n              \
                                             File could be generated by \
                                             creating a TopoSURF control file \
                                             for project : %s */
#define  PHE_CANTEXECDEMPROC                  -50302 /* Illegal orientation \
                                                        state  or \n\
                                                        illegal model name \
                                                        : %s */
#define  PHE_ASSUMINGPIXSIZ                   -50303 /* No pixel size given. \
                                                        Assuming %s micron \
                                                        pixel */ 
#define  PHE_DEMGENERABORT                    -50304 /* Process DEM generation \
                                                        aborted */
#define PHD_BADELL   -50305 /* East lower left is bigger than East upper right */ 
#define PHD_BADNLL   -50306 /* North lower left is bigger than North upper right */
#define PHD_BADDE    -50307 /* Raster spacing in east direction is less equal 0 */ 
#define PHD_BADDN    -50308 /* Raster spacing in north direction is less equal 0 */
#define PHD_BADESIZE -50309 /* Eastern DTM extension is less than given raster spacing */
#define PHD_BADNSIZE -50310 /* Northern DTM extension is less than given raster spacing */
#define PHE_NODTMFILE -50311 /* No DTM file defined */


/**** Texts for PHODIS TS ****/
/*        60001 61000        */
#define  PHE_UNKNOWNCODEDETECTED      -60001 /* Unknown code detected %s \n\
                                                Line not tranfered : %s */
#define  PHW_POINTOUTOFAREA           -60002 /* DEM start point is out of \
                                                model area */
#define  PHE_GRIDOUTOFAREA            -60003 /* No start point found in model \
                                                area \n\
                                                Grid is out of model area */
#define  PHW_GENERATIONINPROCESS      -60004 /* DEM Generation for model: %s \
                                                already in process */
#define  PHW_1STCHARISNOCHAR          -60005 /* Model name does not start \
                                                with a letter */

/**** Texts for PHODIS TF ****/
/*        70001 71000        */
#define  PHE_NOVALIDMEMBERPOINTERINCTFF       -7001 /* No valid member pointer in ctff */
#define  PHE_TFPACKNOTINITIALIZED             -7002 /* TF pack not initialized */
#define  PHE_NOTFFAMILIESTORELEASE            -7003 /* No tf families to release */
#define  PHE_NOTFFAMILYAVAILABLE              -7004 /* No tf family available */
#define  PHE_CAMERAPOINTERISNULL              -7005 /* Camera pointer is null */
#define  PHE_NOCURRENTMEMBERAVAILABLE         -7006 /* No current member available */
#define  PHE_NOCTFFAVAILABLE                  -7007 /* No ctffav ailable */
#define  PHE_NOCURRENTTFFAMILYAVAILABLE       -7008 /* No current tf family available */
#define  PHE_NOTFFAMILYFOUNDTORELEASE         -7009 /* No tf family found to release */
#define  PHE_NOTFMEMBERFOUNDTORELEASE         -7010 /* No tf member found to release */
#define  PHE_NOMEMFORNEWMEMBER                -7011 /* No mem for new member */
#define  PHE_NOSUCHTFMEMBERINCTFF             -7012 /* No such tf member in ctff */
#define  PHE_NOMEMFORDISTORTIONSAVAILABLE     -7013 /* No mem for distortions available */
#define  PHE_IOPOINTERISNULL                  -7015 /* IO pointer is null */
#define  PHE_COULDNOTFINDTFMEMBER             -7016 /* Could not find tf member
*/
#define  PHE_COULDNOTPUTTFPARAMETERS          -7017 /* Could not put tf parameters */
#define  PHE_CTFCOULDNOTFREEALLMEMBERS        -7018 /* ctf could not free all members */
#define  PHE_CMBRNOTKNOWN                     -7020 /* cmbr not known */
#define  PHE_CTFNOTKNOWN                      -7021 /* ctf not known */
#define  PHE_NODISTORTIONVALUESAVAILABLE      -7022 /* No distortion values available */
#define  PHE_NOMEMFORTFMEMBERS                -7023 /* No mem for tf members */
#define  PHE_NOVALIDTFMEMBERPOINTER           -7025 /* No valid tf member pointer */
#define  PHE_NOMEMFORTFFAMLIY                 -7027 /* No mem for tf famliy */
#define  PHE_NOTFDATAAVAILABLE                -7028 /* No tf data available */
#define  PHE_TFIDNOTAVAILABLE                 -7029 /* tf ID not available */
#define  PHE_IMAGEIDNOTKNOWNINCTFF            -7030 /* Image ID not known in ctff */
#define  PHE_CTFFCOULDNOTFREETFFAMILY         -7031 /* ctff could not free tf family */
#define  PHE_CTFFCOULDNOTFREETFMEMBER         -7032 /* ctff could not free tf member */
#define  PHE_TFFNOTKNOWN                      -7033 /* tff not known */
#define  PHE_TFFCOULDNOTFREEALLMEMBERS        -7034 /* tff could not free all members */
#define  PHE_COUTNOTFREETFF                   -7035 /* Can't not free tff */
#define  PHE_NOTFFAVAILABLE                   -7036 /* No tff available */
#define  PHE_MEMBERPOINTERISNULL              -7037 /* Member pointer is null */
#define  PHE_NOMEMORY                         -7038 /* No memory */
#define  PHE_SCALEISZERO                      -7039 /* Scale is zero */
#define  PHE_READINGTFPARAMETERSFROMASCIIFILE -7040 /* Reading tf parameters from ASCII file */
#define  PHE_CANNOTALLOCATEMEMORYFORBUFFER    -7041 /* Can not allocate memory for buffer */
#define  PHE_CANNOTOPENFILE                   -7042 /* Can not open file */
#define  PHE_READINGCOORDFROMAFILE            -7043 /* Reading coord from a file */
#define  PHE_READINGTFMEMBERFROMASCIIFILE     -7044 /* Reading tf member from ASCII file */

#define  PHE_TFNOTAVAILABLE                   -7045 /* tf not available */
#define  PHE_TFFUNCTIONPOITERISNULL           -7046 /* tf function poiter is null */
#define  PHE_ROTMATRIXISSINGULAR              -7047 /* Rot matrix is singular */
#define  PHE_STEREOPOINTERISNULL              -7048 /* Stereo pointer is null */
#define  PHE_WRONGSEARCHSTRING                -7049 /* Wrong search string */
#define  PHE_WRONGSEARCHID                    -7050 /* Wrong search id */
#define  PHE_WRONGCALPARAM                    -7051 /* Wrong call param */
#define  PHE_TFMODNOTAVAILABLE                -7052 /* Transformation of Model: %s not available */
#define  PHE_TOFEWTFPARAM                     -7053 /* There are to few TF parameters for Model: %s */  
#define  PHE_TFIMGNOTAVAILABLE                -7054 /* Transformation of Image: %s not available */
#define  PHE_GETROTNOTAVAILABLE               -7055 /* Get image rotation is not available */
#define  PHE_INQROTNOTAVAILABLE               -7056 /* Inquire image rotation is not available */
/**** Texts for PHODIS AT and PUK ****/
/*    AT  80001 - 81000              */
#define   PHE_AT_QUERY     -80001 /* Illegal database query \n Query "%s" \n Reason "%s" \n Module %s */
#define   PHE_AT_INTERP    -80002 /* Internal error \n Command "%s" \n Reason "%s" */
#define   PHE_AT_PARAM     -80003 /* Invalid value for "%s". Value "%s" */ 
#define   PHE_AT_INTRINSIC -80004 /* Internal error \n File "%s" Modul "%s" */ 
#define   PHE_AT_SUCHIMAGE -80005 /* No such image number "%s" in the block */
#define   PHE_AT_X11       -80006 /* X error in function "%s" \n File "%s" Modul "%s" */
#define   PHE_AT_SUCHFILE  -80007 /* No such file "%s" \n File "%s" Modul "%s" */ 
#define   PHE_AT_ACCESS    -80008 /* Can't access file "%s" \n File "%s" Modul "%s" */
#define   PHE_AT_CHANNEL   -80009 /* Illegal channel "%s" for image "%s" \n Modul "%s" */
#define   PHE_AT_ROTSEQ    -80010 /* Illegal rotation sequence "%s" for image "%s" \n Modul "%s" */
#define   PHE_AT_NOBLOCKS  -80011 /* No blocks defined for the actual project */
#define   PHE_AT_NOFILE    -80012 /* No file defined for %"s". */
#define   PHE_AT_NOIMAGE   -80013 /* No image found \n File "%s" Modul "%s" */
#define   PHE_AT_STRIPS    -80014 /* To many strips in this block */
#define   PHE_AT_IMAGES    -80015 /* To many images in this block */
#define   PHE_AT_CONNECT   -80016 /* Can't connect to the database deamon \n Reason "%s" */
#define   PHE_AT_SELECT    -80017 /* Can't select block %s for project %s \n Reason "%s" */
#define   PHE_AT_MATCH     -80018 /* LSM matching failed. \n Source image "%s". Target image "%s". */
#define   PHE_AT_NOPHOTO   -80019 /* No image found with photo number %s \n File "%s" Modul "%s" */
#define   PHE_AT_NOBLOCK   -80020 /* No active block selected \n File "%s" Modul "%s" */
#define   PHE_AT_NOCONNECT -80021 /* No connection to database \n File "%s" Modul "%s" */
#define   PHE_AT_NOKEY     -80022 /* No image found with key number %s \n File "%s" Modul "%s" */
#define   PHE_AT_SUBBLOCK  -80023 /* Illegal subblock name %s. */
#define   PHE_AT_SUBBLOCK0 -80024 /* You can't edit subblock 0 ! */
#define   PHW_AT_SUBBLOCK_1 -80025 /* You are using a trick when editing subblock %s. \n Are you really sure ? */

#define   PHD_AT_INTERPINI -80301 /* Internal error \n Command "Create interpreter" \n Reason "%s" */

/*    PUK 81001 - 90000              */
#define   IFPD_NOTENOUGHMEMORY       -81001 /* not enough memory left in %s */
#define   IFPD_IMAGEREADERROR        -81011 /* no image values in %s */
#define   IFPD_FILECOULDNOTBEOPENED  -81021 /* file %s can't be opened in %s */
#define   IFPD_FILEINFALSEFORMAT      -81025 /* file %s is no P2-PGM-File in %s */
#define   IFPD_FILECOULDNOTBECREATED -81031 /* file %s can't be created in %s */
#define   IFPE_MASKISOUTOFSEARCHAREA  -81041 /* mask is out of searchimage */
#define   IFPD_NOISMFILEISOPEN       -81051 /* no ism files to close for %s */
#define   IFPD_NOSUCHPARAMETER       -81061 /* there is no such parameter in %s */
#define   IFPD_FALSECASE              -81071 /* this case is impossible in %s */
#define   IFPE_CHANGESIZETILEORWINDOW -81081 /* tile to small or window to big in %s */
#define   IFPE_TOFEWINTERESTPOINTS    -81091 /* to few points for computing robust points with robust algorithm */
#define   IFPE_NOUSEFULPYRAMIDLEVEL   -81101 /* no useful pyramidlevel could be determined in %s */
#define   IFPE_OUTOFPYRAMIDIMAGE      -81111 /* one pyramidimage is out of area in %s */
#define   IFPE_NOINVERSE              -81121 /* inverse couldn't be computed in %s */
#define   IFPE_MOREIMAGESTHANALLOWED  -81131 /* more images than allowed in struct of %s */
#define  IFPM_MATCHFAILED            -82000 /* Can't match point */
#define  IFPM_MATCHMAYBEOK           -82001 /* Matched point may be o.k. */
#define  PHW_NOTALLPARSET            -82002 /* Parameter %s not set */
#define  PHW_POINTIDLOWER            -82003 /* !!!!   Caution   !!!! \n\
                                               New initial name %s \
                                               is less than current name %s.\n \
                                               Already used point names may be \
                                               overwritten */

#endif    /* _PHO_TXT_D_ */
