
/*--------------------------------------------------------------
 *
 *  $RCSfile: phodis_st_d.h,v $
 *
 *  Copyright (c) Carl Zeiss 1992
 *  $Date: 1998/07/21 19:10:10 $
 *  $Author: rwa $
 *  $Locker:  $
 *  $Revision: 1.1 $
 *  $Source: /bio/reo/rwa/devel/phodis_convert/RCS/phodis_st_d.h,v $
 *  $State: Exp $
 *
 *--------------------------------------------------------------
 */

#ifndef phodis_st_d
#define phodis_st_d

  /* Bitmask for hex values 
   *
   *  BIT    1   2   3   4   5   6   7   8
   *  ------------------------------------
   *  HEX    1   2   4   8  10  20  40  80   use : 0xHEX
   */ 
  
  /* GLOBAL DEFINIES for PHODIS ST */
  
  /******************************************************************************/
  
  /*
   * If, for some reason, stereo.h and libstereo.a aren't available, the
   * following #define's may be used instead of the previous #include:
   * #define YMAXSTEREO 491
   * #define YOFFSET 532
   *
   * I am anticipating the definitions potentially changing in the
   * future (due to incompatible screen formats, for example), and want
   * to minimize the number of changes I'll have to make.
   */
  
#define YMAXSTEREO 492
#define YOFFSET 532
  
  /* Defines to identify the graphic board.
   * The following definitions are similar to the definitions of the
   * include <invent.h>.
   */

/* defines for graphic types */
#define G_VGX           8
#define G_VGXT          9
#define G_LIGHT        10
#define G_GR2          11
#define G_RE           12

/* defines for GR2 graphics options */
                    /* bitmasks */
#define GO_GR2_XS      0x0
#define GO_GR2_XSZ     0x1
#define GO_GR2_XS24    0x2
#define GO_GR2_XS24Z   0x3
#define GO_GR2_XSM     0x4
#define GO_GR2_ELAN    0x7
#define GO_GR2_XZ      0x13 
#define GO_GR3_XSM     0x44  
#define GO_GR3_ELAN    0x47  
#define GO_GU1_EXTREME 0xa3   
  
/* General defines */
#define STEREO_MOD     2
#define MONO_MOD       1
  
#define PHO_RGBmode 1
#define PHO_Rmode   2
#define PHO_Gmode   3
#define PHO_Bmode   4
#define PHO_BWmode  5

#define RGB     "RGB"
#define R       "R"
#define G       "G"
#define B       "B"
#define BW      "BW"

#define PSEUDO       "pseudo"     /* Steroplotter mode pseudo */
#define ORTHO        "ortho"      /* Steroplotter mode ortho */
#define MLEFT        "mono left"  /* Steroplotter mode mono left */
#define MRIGHT       "mono right" /* Steroplotter mode mono right */

#define STPLON       "on"         /* Steroplotter on */
#define STPLOFF      "off"        /* Steroplotter off */

#define MIFCtyp 1
#define FIMCtyp 2
#define ST10typ	3
#define ST20typ	4

#define FIMC    "FIMC"
#define MIFC    "MIFC"
#define ST10	"ST10"
#define ST20	"ST20"

/* Defines for window status */
#define E_WINOPENSET   0x1
#define E_REFPNTSET    0x2
#define E_IMAGELOAD    0x4
#define E_ORIENTSET    0x8
#define E_UPDATEWINSET 0x10
#define E_STEREROACTIV 0x20
#define E_WINREALIZED  0x40
  
/* Defines for viewing modes */
#define E_V_BIN_L      10
#define E_V_BIN_R      11
#define E_V_ST_OR      12
#define E_V_ST_PS      13
  
/* Defines for recording modes */
#define E_NO_REC       20
#define E_R_DZ         21
#define E_R_DIST       22
#define E_R_TIME       23
#define E_R_TUBE       24
  
/* Defines for zooming modes */
#define E_NOFRAC       0
#define E_FRAC         1

#define MINZOOM       -9.0
#define MAXZOOM        8.0
#define ZOOMINI        1.0
#define ZOOMFRAC       E_NOFRAC

/* Defines for info border */
#define CBRDSIZ        30
  
/* Defines for contrast/brightness interpolation type */
#define E_LINEAR       0
#define E_QUAD         1
  
/* Defines for correlation mode */
#define E_RTZ               1
#define E_SGL               2
#define E_H_PREDICT         4
#define E_M_PREDICT         8
#define E_RTZ_H_PREDICT     (E_RTZ | E_H_PREDICT)
#define E_RTZ_M_PREDICT     (E_RTZ | E_M_PREDICT)
#define E_RTZ_HM_PREDICT    (E_RTZ | E_H_PREDICT | E_M_PREDICT)
#define E_SGL_H_PREDICT     (E_SGL | E_H_PREDICT)

/* Defines for GCP symbols */
#define XCROSS           (( int ) 1)
#define CROSS            (( int ) 2)
#define CIRCLE           (( int ) 3)
#define TRIANGLE         (( int ) 4)
#define RECTANGLE        (( int ) 5)
#define CIRCLEPOINT      (( int ) 6)
#define TRIANGLEPOINT    (( int ) 7)
#define RECTANGLEPOINT   (( int ) 8)

/* Defines for GCP symbols */
#define GCP_RED     (( int ) 1)
#define GCP_GREEN   (( int ) 2)
#define GCP_BLUE    (( int ) 3)
#define GCP_ORANGE  (( int ) 4)

/* Defines for P-Mouse events */
#define NOFUNCTION        0        /* no function */
#define LOCATOR           1        /* send locator */
#define CHOICE            2        /* send choice */
#define LOCATORCHOICE     3        /* send locator and choice */
#define BEGSTREAM         5        /* start recording mode and send locator */
#define BEGSTREAMCHOICE   7        /* start recording mode and send locator
                                      and choice */
#define ENDSTREAM         9        /* stop recording mode and send locator */
#define ENDSTREAMCHOICE   11       /* stop recordintp_setkmod mode and send
                                      locator and choice */
#define KEEP              32       /* keep previous setting */
#define PARALAX           64       /* image hold / release */
#define MENU              512      /* menue choice */
#define PICK              1024     /* send pick */

/* Defines for program start and terminate */
#define E_STA_OK       0
#define E_STA_NOTOK    1
  
#define E_DISPLAY      1
#define E_INPUT        2
  
#define E_TR_USE       1
#define E_NOTR_USE     2
   
#define E_GRAPHIC      0x1
#define E_SPLOTTER     0x2
#define E_TERMGR       0x4
  
#define E_SHM_LOCK     1
#define E_SHM_NOLOCK   2
  
/* structure identifier (sid) */
#define SID_OPWINDOW          (Ulong)3000001
#define SID_CLWINDOW          (Ulong)3000002
#define SID_STWINPAR          (Ulong)3000003
#define SID_REALIZWIN         (Ulong)3000004
  
#define SID_STREFPNT          (Ulong)3000011
#define SID_LDIMAGE           (Ulong)3000012
#define SID_FIXIMG            (Ulong)3000013
  
#define SID_STCORDISP         (Ulong)3000021
#define SID_STCURSOR          (Ulong)3000022
#define SID_CURPOS            (Ulong)3000023
#define SID_PROJECT           (Ulong)3000024
#define SID_NEWWSTYPE         (Ulong)3000025
#define SID_INQWSTYPE         (Ulong)3000026
#define SID_SYNCPNT           (Ulong)3000027
#define SID_PSTMODEL          (Ulong)3000028
#define SID_STINQCUR          (Ulong)3000029
#define SID_STINQGRA          (Ulong)3000030
#define SID_ZOOM              (Ulong)3000031
#define SID_MOVETO            (Ulong)3000032
#define SID_STEYEDIST         (Ulong)3000033
#define SID_CHCONTRST         (Ulong)3000034
#define SID_CHBRIGHTN         (Ulong)3000035
#define SID_ROTATEIMG         (Ulong)3000036
#define SID_MVMOVMOD          (Ulong)3000037
#define SID_STLWIDTH          (Ulong)3000038
#define SID_STSHIFT           (Ulong)3000039
#define SID_STGCOD            (Ulong)3000040
#define SID_SNDDEL            (Ulong)3000041
#define SID_PSTSCREEN         (Ulong)3000042
#define SID_NEWCOR            (Ulong)3000043
#define SID_STCRES            (Ulong)3000044
#define SID_STCMAP            (Ulong)3000045
#define SID_STALTMOD          (Ulong)3000046
#define SID_CHKINCON          (Ulong)3000047
#define SID_ACTPAR            (Ulong)3000048
#define SID_DEMOSTR           (Ulong)3000049
  
#define SID_STMOVMOD          (Ulong)3000051
#define SID_STVIEMOD          (Ulong)3000052
#define SID_STAUTOCORR        (Ulong)3000053
  
#define SID_UPWINPOS          (Ulong)3000061
#define SID_ERROR             (Ulong)3000062
#define SID_ERR_BUF           (Ulong)3000063
#define SID_NEWORIENT         (Ulong)3000064
#define SID_GETEVENT          (Ulong)3000065
  
#define SID_START             (Ulong)3000071
#define SID_END               (Ulong)3000072
#define SID_STAPPL            (Ulong)3000073
#define SID_CLEAR             (Ulong)3000074
#define SID_BREAK             (Ulong)3000075
#define SID_TERMCTR           (Ulong)3000076
#define SID_LOADMODEL         (Ulong)3000077
#define SID_LOADIMAGE         (Ulong)3000078
#define SID_LOADORIENT        (Ulong)3000079
  
#define SID_WINTAB            (Ulong)3000081
#define SID_LSTKEY            (Ulong)3000082 
#define SID_LSTCHO            (Ulong)3000083
#define SID_LSTTBL            (Ulong)3000084
#define SID_REVCOD            (Ulong)3000085
   
#define SID_OPINPUT           (Ulong)3000091
#define SID_CLINPUT           (Ulong)3000092
  
#define SID_STRECPAR          (Ulong)3000101
#define SID_DEFKEY            (Ulong)3000102
#define SID_STEVENTMOD        (Ulong)3000103
#define SID_STCONFIG          (Ulong)3000104
#define SID_STCORTYP          (Ulong)3000105
#define SID_RELMOVE           (Ulong)3000106
#define SID_KEY               (Ulong)3000107
  
#define SID_CONNECT           (Ulong)3000111
#define SID_NEWGSHM           (Ulong)3000112
#define SID_IQGSHM            (Ulong)3000113
#define SID_IQGSHMK           (Ulong)3000114
#define SID_NEWGSHMK          (Ulong)3000115

#endif
