/*--------------------------------------------------------------
 *
 *  $RCSfile: rec.h,v $
 *
 *  Copyright (c) Carl Zeiss 1992
 *  $Date: 1998/07/21 19:10:10 $
 *  $Author: rwa $
 *  $Locker:  $
 *  $Revision: 1.1 $
 *  $Source: /bio/reo/rwa/devel/phodis_convert/RCS/rec.h,v $
 *  $State: Exp $
 *
 *--------------------------------------------------------------
 *--------------------------------------------------------------
 */

#ifndef __rec__
#define __rec__

/*	Defines */
#define RECAppend		-1					/* Append record */
#define RECJoker		(Ulong) 0x0			/* Wildcard for userdefined filetype*/

/*	Datentypen */
typedef int RecHdl;							/*	file handle */

typedef enum {
	RECMaxOpenF,
	RECActOpenF,
	RECPrgVers,
	RECFileN,
	RECRecNo,
	RECCreate,
	RECUpdate,
	RECAccess,
	RECFileVers,
	RECAccType,
	RECGarbageNo
} RecInfo;

typedef union {
	int		i;
	Ulong	l;
	char	*pc;
	Date_s	d;
} RecInfoData;

/*	Prototypen */

/* BEGMAN
description ............:
	information about binary - io system
return value ...........: 
references .............:
MANEND */

int rec_state (
	const RecInfo   eInfo,          /* -> informationtype */
	RecInfoData     *ptInfo);       /* <- infodata */



/* BEGMAN
description ............:
	opens a binary file
caveats ................:
	the check of the userdefined filetype is not
	implemented
return value ...........: 
MANEND */

int rec_open (
	char          *pcFile,          /* -> filename */
	const Ulong   lMode,            /* -> openMode (READ, WRITE, UPDATE, UPDWRI)*/
	const Ulong   lType,		    /* -> usertype */
	RecHdl        *ptHdl);          /* <- handle */



/* BEGMAN
description ............:
	closes a binary file
return value ...........: 
MANEND */

int rec_close (
	const RecHdl  tHdl);            /* -> handle */



/* BEGMAN
description ............:
	information about a open binary file
return value ...........: 
MANEND */

int rec_info    (
	const RecHdl  tHdl,             /* -> handle */
	const RecInfo eInfo,            /* -> informationtype */
	RecInfoData   *ptInfo);         /* <- informationdata */



/* BEGMAN
description ............:
	reads a valid record of a open binary file
return value ...........: 
MANEND */

int rec_read	(
	const RecHdl tHdl,				/* -> handle */
	const int	 iNo,				/* -> record number */
	char		 *pcData,			/* <- record data */
	const int	 iMaxLen,			/* -> size of record buffer */
	int			 *piLen);			/* <- record length */



/* BEGMAN
description ............:
	writes a record to a open binary file
caveats ................:
	if the recordlenght is not a multiple of 4
	the results of the (possible) byteswap are
	undefined
return value ...........: 
MANEND */

int rec_write	(
	const RecHdl tHdl,				/* -> handle */
	const int	 iNo,				/* -> record number */
	char		 *pcData,			/* -> record data */
	const int	 iLen);				/* -> recordlength in bytes */



/* BEGMAN
description ............:
	delets a valid record of a open binary file
return value ...........: 
MANEND */

int rec_delete	(
	const RecHdl tHdl,				/* -> handle */
	const int	 iNo);				/* -> record number */



/* BEGMAN
description ............:
	length of a valid record of an open binary file
return value ...........: 
MANEND */

int rec_length	(
	const RecHdl tHdl,				/* -> handle */
	const int	 iNo,				/* -> record number */
	int			 *piLen);			/* <- record length */

#endif
