
/*--------------------------------------------------------------
 *
 *  $RCSfile: trf.h,v $
 *
 *  Copyright (c) Carl Zeiss 1992
 *  $Date: 1998/07/21 19:10:10 $
 *  $Author: rwa $
 *  $Locker:  $
 *  $Revision: 1.1 $
 *  $Source: /bio/reo/rwa/devel/phodis_convert/RCS/trf.h,v $
 *  $State: Exp $
 *
 *--------------------------------------------------------------
 *--------------------------------------------------------------
 */

#ifndef _trf__
#define _trf__

#define  E_WRTRANS      5
#define  E_WRLTRANS     6
#define  E_WRRTRANS     7
#define  E_WILTRANS     9
#define  E_WIRTRANS    10
#define  E_WSLTRANS    12
#define  E_WSRTRANS    13
/* -------------------------------------------------------------------------- */
#define  E_MRTRANS     18
#define  E_MRLTRANS    19
#define  E_MRRTRANS    20
#define  E_MITRANS     21
#define  E_MILTRANS    22
#define  E_MIRTRANS    23
#define  E_MSTRANS     24
#define  E_MSLTRANS    25
#define  E_MSRTRANS    26
/* -------------------------------------------------------------------------- */
#define  E_PRTRANS     29
#define  E_PLWTRANS    32
#define  E_PLMTRANS    33
#define  E_PLRLTRANS   34
#define  E_PLILTRANS   35
#define  E_PLSLTRANS   36
#define  E_PRWTRANS    37
#define  E_PRMTRANS    38
#define  E_PRRRTRANS   39
#define  E_PRIRTRANS   40
#define  E_PRSRTRANS   41
/* -------------------------------------------------------------------------- */
#define  E_RWTRANS     42
#define  E_RMTRANS     43
#define  E_RPTRANS     44
#define  E_RITRANS     45
#define  E_RSTRANS     46
#define  E_RLWTRANS    47
#define  E_RLMTRANS    48
#define  E_RLPLTRANS   49
#define  E_RLILTRANS   50
#define  E_RLSLTRANS   51
#define  E_RRWTRANS    52
#define  E_RRMTRANS    53
#define  E_RRPRTRANS   54
#define  E_RRIRTRANS   55
#define  E_RRSRTRANS   56
/* -------------------------------------------------------------------------- */
#define  E_IMTRANS     58
#define  E_IRTRANS     60
#define  E_ILWTRANS    62
#define  E_ILMTRANS    63
#define  E_ILPLTRANS   64
#define  E_ILRLTRANS   65
#define  E_ILSLTRANS   66
#define  E_IRWTRANS    67
#define  E_IRMTRANS    68
#define  E_IRPRTRANS   69
#define  E_IRRRTRANS   70
#define  E_IRSRTRANS   71
/* -------------------------------------------------------------------------- */
#define  E_SMTRANS     73
#define  E_SRTRANS     75
#define  E_SLWTRANS    77
#define  E_SLMTRANS    78
#define  E_SLPLTRANS   79
#define  E_SLRLTRANS   80
#define  E_SLILTRANS   81
#define  E_SRWTRANS    82
#define  E_SRMTRANS    83
#define  E_SRPRTRANS   84
#define  E_SRRRTRANS   85
#define  E_SRIRTRANS   86
/* -------------------------------------------------------------------------- */
#define  E_EPTRANS     87
#define  E_ELPLTRANS   88
#define  E_ERPRTRANS   89
#define  E_PETRANS     90
#define  E_PLELTRANS   91
#define  E_PRERTRANS   92


/* -------------------------------------------------------------------------- */
#define  E_NOVALIDMEMBERPOINTERINCTFF          -1
#define  E_TFPACKNOTINITIALIZED                -2
#define  E_NOTFFAMILIESTORELEASE               -3
#define  E_NOTFFAMILYAVAILABLE                 -4
#define  E_CAMERAPOINTERISNULL                 -5
#define  E_NOCURRENTMEMBERAVAILABLE            -6
#define  E_NOCTFFAVAILABLE                     -7
#define  E_NOCURRENTTFFAMILYAVAILABLE          -8
#define  E_NOTFFAMILYFOUNDTORELEASE            -9
#define  E_NOTFMEMBERFOUNDTORELEASE           -10
#define  E_NOMEMFORNEWMEMBER                  -11
#define  E_NOSUCHTFMEMBERINCTFF               -12
#define  E_NOMEMFORDISTORTIONSAVAILABLE       -13
#define  E_IOPOINTERISNULL                    -15
#define  E_COULDNOTFINDTFMEMBER               -16
#define  E_COULDNOTPUTTFPARAMETERS            -17
#define  E_CTFCOULDNOTFREEALLMEMBERS          -18
#define  E_CMBRNOTKNOWN                       -20
#define  E_CTFNOTKNOWN                        -21
#define  E_NODISTORTIONVALUESAVAILABLE        -22
#define  E_NOMEMFORTFMEMBERS                  -23
#define  E_NOVALIDTFMEMBERPOINTER             -25
#define  E_NOMEMFORTFFAMLIY                   -27
#define  E_NOTFDATAAVAILABLE                  -28
#define  E_TFIDNOTAVAILABLE                   -29
#define  E_IMAGEIDNOTKNOWNINCTFF              -30
#define  E_CTFFCOULDNOTFREETFFAMILY           -31
#define  E_CTFFCOULDNOTFREETFMEMBER           -32
#define  E_TFFNOTKNOWN                        -33
#define  E_TFFCOULDNOTFREEALLMEMBERS          -34
#define  E_COUTNOTFREETFF                     -35
#define  E_NOTFFAVAILABLE                     -36
#define  E_MEMBERPOINTERISNULL                -37
#define  E_NOMEMORY                           -38
#define  E_SCALEISZERO                        -39
#define  E_READINGTFPARAMETERSFROMASCIIFILE   -40
#define  E_CANNOTALLOCATEMEMORYFORBUFFER      -41
#define  E_CANNOTOPENFILE                     -42
#define  E_READINGCOORDFROMAFILE              -43
#define  E_READINGTFMEMBERFROMASCIIFILE       -44
#define  E_TFNOTAVAILABLE                     -45
#define  E_TFFUNCTIONPOITERISNULL             -46
#define  E_ROTMATRIXISSINGULAR                -47
#define  E_STEREOPOINTERISNULL                -48
/* -------------------------------------------------------------------------- */


#define ETF      0     /* definition of plane tf family type */
#define FTF      2     /* definition of foreign tf family type */
#define GTF      3     /* definition of geodetic tf family type */
#define CTF      4     /* definition of cartographic tf family type */

#define MAX_ETF    8     /* maximum number of different plane tf */
#define MAX_FTF  256     /* maximum number of different plane tf */


/***************************/
/* DEFINES                 */
/***************************/


#define  E_WMTRANS      1
#define  E_WPTRANS      2
#define  E_WPLTRANS     3
#define  E_WPRTRANS     4
#define  E_WITRANS      8
#define  E_WSTRANS     11
/* -------------------------------------------------------------------------- */#define  E_MWTRANS     14
#define  E_MPTRANS     15
#define  E_MPLTRANS    16
#define  E_MPRTRANS    17
/* -------------------------------------------------------------------------- */#define  E_PWTRANS     27
#define  E_PMTRANS     28
#define  E_PITRANS     30
#define  E_PSTRANS     31
/* -------------------------------------------------------------------------- */#define  E_IWTRANS     57
#define  E_IPTRANS     59
#define  E_ISTRANS     61
/* -------------------------------------------------------------------------- */#define  E_SWTRANS     72
#define  E_SPTRANS     74
#define  E_SITRANS     76
/* -------------------------------------------------------------------------- */



#define PTF      1     /* definition of photogrammetric tf family type */

#define MAX_PTF   56     /* maximum number of different photogrammetric tf */
#define MAX_TF   512     /* maximum number of tf families */

#define NMBRS    128     /* # of photogrammetric tf_members reserved for 1 */
                         /* tf_family */

/* global variables for tf-package */

typedef struct tf_mbr {         /* data structure for 1 tf_member */
  int              id;          /* ID of this member 'mbr' of a tf_family */
  char            *tf;          /* tf_parameters (=coefficients) */
                                /* This is a type casted pointer. For photo- */
                                /* grammetric purposes this pointer will */
                                /* hold the data structure 'Transform_s' */
  int            (*func)( char *,
                          int,
                          double *,
                          double * );
  struct tf_mbr   *stereo;      /* ptr to stereo partner of tf_member */
  struct tf_mbr   *next;        /* ptr to next tf_member */
} TFmbr_s, *TFmbr_sp;



typedef struct tf_family {       /* data structure for 1 tf_family */
  int                 id;        /* ID of the tf_family */
  char               *modname;   /* Name of model of the stereo image pair */

  char               *imgname_l; /* Name of the left iamge */
  double              Zfly_l;    /* left image: height of fly */
  double              Zmed_l;    /* left image: medium height of fly */
  int                 id_l;      /* left image: ID */
  int                 imgtype_l; /* left image: type */
                                 /* 1 :=  ORIGINAL_IMAGE */
                                 /* 2 :=  EPIPOLAR_IMAGE */
  double              focl_l;    /* left image: focal length [mm] */
  double              x0_l;      /* left image: x_photo of principal point */
  double              y0_l;      /* left image: y_photo of principal point */
                                 /* The principal point is assumed to be the */
                                 /* point of (best) symmetry */
  int                 dstron_l;  /* left image: apply distortions ? */
                                 /* -1 :=  already included */
                                 /*  0 :=  don't apply */
                                 /*  1 :=  apply */
  int                 rfrcon_l;  /* left image: apply refraction ? */
                                 /* -1 :=  already included */
                                 /*  0 :=  don't apply */
                                 /*  1 :=  apply */
  int                 crvton_l;  /* left image: apply curvature */
                                 /*                (e.g. earth's curvature)? */
                                 /* -1 :=  already included */
                                 /*  0 :=  don't apply */
                                 /*  1 :=  apply */
  double              radius_l;  /* left image: radius of curvature [m] */
  int                 ndist_l;   /* # of distortion locations and values */
  Point2d_s          *dist_l;    /* distortion of right image */
  Transform_s         tf_l;      /* left image: tf from pixel into photo */

  int                 id_r;      /* right image: ID */
  int                 imgtype_r; /* right image: type */
                                 /* 1 :=  ORIGINAL_IMAGE */
                                 /* 2 :=  EPIPOLAR_IMAGE */
  char               *imgname_r; /* Name of the right image */
  double              Zfly_r;    /* right image: height of fly */
  double              Zmed_r;    /* right image: medium height of fly */
  double              focl_r;    /* right image: focal length [mm] */
  double              x0_r;      /* right image: x_photo of principal point */
  double              y0_r;      /* right image: y_photo of principal point */
                                 /* The principal point is assumed to be the */
                                 /* point of (best) symmetry */
  int                 dstron_r;  /* right image: apply distortions ? */
                                 /* 0  :=  don't apply */
                                 /* 1  :=  apply */
  int                 rfrcon_r;  /* right image: apply refraction ? */
                                 /* 0  :=  don't apply */
                                 /* 1  :=  apply */
  int                 crvton_r;  /* right image: apply curvature */
                                 /*                (e.g. earth's curvature)? */
                                 /* 0  :=  don't apply */
                                 /* 1  :=  apply */
  double              radius_r;  /* right image: radius of curvature [m] */
  int                 ndist_r;   /* # of distortion locations and values */
  Point2d_s          *dist_r;    /* distortion of right image */
  Transform_s         tf_r;      /* right image: tf from pixel into photo */
  double              xmcntr;    /* x model centre in world coordinates */
  double              ymcntr;    /* y model centre in world coordinates */
  double              zmcntr;    /* z model centre in world coordinates */
  double              mscale;    /* model scale */
  double              heightlev; /* operator height level */

  int                 nmbrs;     /* # of members 'mbr'; in this family */
  int                 mbravl[NMBRS];
                                 /* vector for available tf_members */
                                 /*  0  =  not available */
                                 /*  1  =      available */
  TFmbr_s            *mbr;       /* ptr to tf_members */

  struct tf_family   *next;      /* ptr to next tf_family */
} TFfamily_s, *TFfamily_sp;


typedef struct tagStfFunctions {
    int (*init)                 (void);
    int (*getinit)              (void);
    int (*close)                (void);
    int (*newfamily)            (char *mod_name, int left_id,
                                 char *left_imgname, int right_id,
                                 char *right_imgname, int *tffid);
    int (*activate)             (int tffid);
    int (*inqtffid)             (char *strname, int phonum, int searchid,
                                 int *tffid);
    int (*puttfparams)          (int mbrid, int tfsize, char *tfptr);
    int (*puttf)                (int mbrid, int tfsize, char *tfptr,
                                 int (*func)());
    int (*getnewmbr)            (int tfsize, TFmbr_s **lmbr);
    int (*initmbr)              (int tfsize, TFmbr_s *lmbr);
    int (*tf)                   (int mbrid, int npts, double *from,
                                 double *to);
    int (*counttff)             (int *ntff);
    int (*countmbr)             (int *nmbr);
    int (*freetff)              (int tffid);
    int (*freectff)             (int *tfid);
    int (*freembr)              (TFmbr_s *cmbr);
    int (*freembrall)           (TFmbr_s *lmbr);
    int (*freetffall)           (void);
    int (*putio)                (int imageid, Interior_s *ioptr,
                                 Camera_s *camptr);
    int (*putepio)              (int imageid, Interior_s *ioptr,
                                 Camera_s *camptr);
    int (*putheights)           (int imageid, double dZfly, double dZmed);
    int (*putimgtype)           (int imageid, int iImgType);
    int (*putdstr)              (int imageid, Distortion_s *psDistortion);
    int (*p2predparam)          (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*p2predcparam)         (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*pred2pparam)          (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*predc2pparam)         (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*twoXp2predparam)      (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*twoXp2predcparam)     (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*twoXpred2pparam)      (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*twoXpredc2pparam)     (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*fourParam)            (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*sixParam)             (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*twoXSixParam)         (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*eightParam)           (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*eightProjective)      (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*collinear)            (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*twoCollinear)         (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*invcollinear)         (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*fifteenParam)         (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*fifteenInvparam)      (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*select)               (int mbrid, TFmbr_s *lmbr, int (*func)());
    int (*findmbr)              (int mbrid, TFmbr_s **mbr);
    int (*inqmparam)            (double *mparam);
    int (*fifteenInvert)        (char *mmat, char **tmat);
    int (*threeXThreeTranspose) (char *mmat, char **tmat);
    int (*sixInvert)            (char *mmat, char **tmat);
    int (*twoXTwoInvert)        (double a11, double a12,
                                 double a21, double a22,
                                 double *b11, double *b12,
                                 double *b21, double *b22);
    void (*dumptf)              (Transform_s *tfdata);
    int (*inqversion)           (double *version);
    int (*getparamff)           (char *filename, Transform_s **ltf);
    int (*getmbrff)             (char *filename, TFmbr_s **mbrptr);
    int (*epi2p_p2i)            (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*twoEpi2p_p2i)         (char *cptr, int npts, double *fromvec,
                                 double *tovec);
    int (*setheightlev)         (double  deltaheight);
    int (*getheightlev)         (double *deltaheight);
    int (*getrotations)         (double *modelCoordinates, double *leftCappa, double *rightCappa);
    int (*inqrotations)         (double *leftCappa, double *rightCappa);
} stfFunctions, *PStfFunctions;

extern stfFunctions     czStfFunctions;


/***************************/
/* PROTOTYPES              */
/***************************/


/* BEGMAN
================================================================
description ............:

  initialise the shared transformation library

  This function initializes the tf-package <=tfpack>.  It has to
  be called first in order to work with any function of tfpack or
  tfpack will not respond.

return value ...........:
  OKRET if no error
  < 0   if phodis internal error
  > 0   if system error
MANEND */

int tf_init (
    PStfFunctions	userFunctions);

/* BEGMAN
================================================================
description.............:

  This function  to get the actual initializes status of the tf-package

return value ...........:
  FALSE tf-package NOT initialized 
  TRUE  tf-package     initialized 
MANEND */

int tf_getinit (void);

/* BEGMAN
================================================================
description.............:

  This function close the tf-package and give free all tf_families

return value ...........:
  FALSE tf-package NOT initialized 
  TRUE  tf-package     initialized 
MANEND */

int tf_close (void);

/* BEGMAN
================================================================
description.............:

      Gets a new tf_family ID. This function takes as arguments 'left_id'
      and 'right_id' which specify left and right image id's. A new tf_fa-
      mily is generated and its id returned in 'tffid'.


return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_newfamily(         /*    get a new tf id */
    char *mod_name,       /* -> name of stereo model */
    int   left_id,        /* -> id of left image */
    char *left_imgname,   /* -> name of left image */
    int   right_id,       /* -> id of right image */
    char * right_imgname, /* -> name of right image */
    int  *tffid );        /* <- tf id */

/* BEGMAN
================================================================
description.............:

      Activates a tf_family identified by 'tffid'. Any subsequent call to
      tfpack will use transformations from this tf_family until this
      function is called with another valid value for 'tfid'.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_activate(                /*    activate a tf */
    int tffid );                /* -> tf id of the transformation to activate */

/* BEGMAN
================================================================
description.............:

      Gets an existing tf_family ID.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_inqtffid(      /*    activate a tf_family */
    char *strname,    /* -> search string */
    int   phonum,     /* -> photo number to search */
    int   searchid,   /* -> id of search */
                      /*    0 = search model */
                      /*    1 = search left image */
                      /*    2 = search right image */
                      /*    3 = search left photo number */
                      /*    4 = search right photo number */
    int  *tffid );    /* <- tf_family id for the tf to activate */

/* BEGMAN
================================================================
description.............:

      Puts the parameters of a tf_member into the current tf_family
      being active in tfpack.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_puttfparams(
    int          mbrid,         /* -> member id */
    int          tfsize,        /* -> size <bytes> of transformation para- */
                                /*     meters data structure */
    char        *tfptr );       /* -> ptr to transformation parameters */

/* BEGMAN
================================================================
description.............:

      This function puts the parameters of a tf_member and the pointer
      of the tf_function to be applied into the current tf_family
      being active in tfpack.


return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_puttf(
    int          mbrid,         /* -> member id */
    int          tfsize,        /* -> size <bytes> of transformation para- */
                                /*     meters data structure */
    char        *tfptr,         /* -> ptr to transformation parameters */
    int        (*func)(void) );     /* -> ptr to tf_function to be applied for */
                              /*     'mbrid' */

/* BEGMAN
================================================================
description.............:

      This function gets a new tf_member. It allocates the required
      memory for 1 tf_member and initializes the structure elements.

return value ...........:
      OKRET if no error1
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_getnewmbr(
    int       tfsize,           /* -> size [bytes] of transformation */
                                /*     parameters data structure */
    TFmbr_s **lmbr );           /* <- ptr to ptr of the new tf_member */

/* BEGMAN
================================================================
description.............:

      This function initializes the elements of 1 new tf_member;

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_initmbr(
    int      tfsize,          /* -> size of transformation parameters <bytes> */
    TFmbr_s *lmbr );          /* -> ptr to tf_member to be initialized */

/* BEGMAN
================================================================
description.............:

      This function transforms 'npts' on 'from_vec' into the according
      new coordinate values in 'to_vec'. The transformation to be appl-
      ied is selected by 'tf_id'. The internal structures of 'from_vec'
      and 'to_vec' are dependent on 'tfid' which is usually a defined
      variable name. Examples are given below:

      tf< E_WMTRANS, 5, from_vec, to_vec >

      In this case 'from_vec' holds the coordinates of 5 points in the
      sequence: XYZXYZXYZXYZXYZ
      and 'to_vec' will hold the transformed coordinates of the 5 points
      in the sequence: UVWUVWUVWUVWUVW


      List of allowed enumerations:
         E_WMTRANS      Transformation from world to model
         E_WPTRANS      Transformation from world to photo
         E_WITRANS      Transformation from world to image
         E_MWTRANS      Transformation from model to world
         E_MPTRANS      Transformation from model to photo
         E_MITRANS      Transformation from model to image
         E_PWTRANS      Transformation from photo to world
         E_PMTRANS      Transformation from photo to model
         E_PITRANS      Transformation from photo to image
         E_IWTRANS      Transformation from image to world
         E_IMTRANS      Transformation from image to model
         E_IPTRANS      Transformation from image to photo

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf(
    int     mbrid,   /* -> tf_member to use from 'ctff' */
    int     npts,    /* -> number of points to transform */
    double *from,    /* -> 'from' data pointer, data depending on 'mbrid' */
    double *to );    /* <- 'to' data pointer, data depending on 'mbrid' */

/* BEGMAN
================================================================
description.............:

      This function returns the number of known, i.e. allocated and
      available, tf_families.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_counttff(
    int     *ntff );            /* <- number of available tf_families */

/* BEGMAN
================================================================
description.............:

      This function counts the tf_members of the current tf_family.
      It helps to reorganize the tf_family for faster access to the
      tf_members of this family.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_countmbr(
    int    *nmbr );             /* <- number of available tf_members */

/* BEGMAN
================================================================
description.............:

      This function removes a tf_family from the linked 
      list of tf_families and releases the occupied memory.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_freetff(
    int tffid );                 /* -> tfid to release */

/* BEGMAN
================================================================
description.............:

      This function removes the current tf_family <ctff> from the linked 
      list of tf_families and releases the occupied memory. New 'ctff'
      becomes the tf_family before the 'ctff' so far. If there is none
      'ctff' becomes NULL.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_freectff(
    int *tfid );                   /* <- tfid of new current tf_family after */
                                   /*    releasing the <old> current tf_family */
                                   /*    0  if no tf_family is available */

/* BEGMAN
================================================================
description.............:

      This function releses the memory occupied by 1 tf_member of the
      current tf_family 'ctff'.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_freembr(
    TFmbr_s *cmbr );              /* -> current tf_member, to be released */

/* BEGMAN
================================================================
description.............:

      This function releases the occupied memory of all tf_members of
      the current tf_family 'ctff'. 

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_freembrall(
    TFmbr_s *lmbr );               /* -> ptr to 1st tf_member of a tf_family; */
                                   /*     The linked list of all tf_members of */
                                   /*     this family is released. */

/* BEGMAN
================================================================
description.............:

      This function releases the memory of all tf_families which are
      known by and accessible for tfpack. This function recursively
      calls tf_freetff.

      After all tf_families have been released the tfpack is deacti-
      vated. In order to re-start the tfpack again the user has to 
      call tf_init. This allows the user to start over with tfpack
      within one program-session.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_freetffall(void);

/* BEGMAN
================================================================
description.............:

      This function puts the interior orientation values of 1 image 
      specified in 'image_id' into the current tf_family of tfpack.
      In the same way the data of the camera are treated.

      All relevant data of the interior orientation and the camera are
      copied into tfpack's memory space. The user may release the 
      'ioptr' and 'camptr' after successfull termination of this function.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_putio(
  int         imageid,           /* -> image id for which to store the */
                                 /*     interior orientation; the value */
                                 /*     has to be either left-img-id or */
                                 /*     right-img-id */
  Interior_s *ioptr,             /* -> ptr to interior orientation data */
                                 /*     structure */
  Camera_s   *camptr );          /* -> ptr to camera data structure */

/* BEGMAN
================================================================
description.............:

      This function puts the interior orientation values of 1 image 
      specified in 'image_id' into the current tf_family of tfpack.
      In the same way the data of the camera are treated.

      All relevant data of the interior orientation and the camera are
      copied into tfpack's memory space. The user may release the 
      'ioptr' and 'camptr' after successfull termination of this function.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_putepio(
  int         imageid,           /* -> image id for which to store the */
                                 /*     interior orientation; the value */
                                 /*     has to be either left-img-id or */
                                 /*     right-img-id */
  Interior_s *ioptr,             /* -> ptr to interior orientation data */
                                 /*     structure */
  Camera_s   *camptr );          /* -> ptr to camera data structure */

/* BEGMAN
================================================================
description.............:

   store height and medium height of fly to compute earth curvature

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_putheights(
  int         imageid,           /* -> image id for which to store the */
                                 /*    interior orientation; the value */
                                 /*    has to be either left-img-id or */
                                 /*    right-img-id */
  double      dZfly,             /* -> height of fly */ 
  double      dZmed );           /* -> medium height of fly */

/* BEGMAN
================================================================
description.............:

   store type of image to do different between image and epipolar image

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_putimgtype(
  int         imageid,           /* -> image id for which to store the */
                                 /*    interior orientation; the value */
                                 /*    has to be either left-img-id or */
                                 /*    right-img-id */
  int         iImgType);         /* -> type of image */
                                 /*    1 :=  ORIGINAL_IMAGE */
                                 /*    2 :=  EPIPOLAR_IMAGE */

/* BEGMAN
================================================================
description.............:

      This function puts the distortion values for 1 image specified 
      by 'image_id' into the current tf_family. The locations and
      values pointer of the Distortion_s 'dstrptr' is the important
      structure element. It is assumed that in this data structure
      Point2d_s 'dist' are stored the locations 'mm' and values 'um'
      of the distortions.

      All relevant data of the distorions are copied into
      tfpack's memory space. The user may release the 'dstrptr' after
      successfull termination of this function.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_putdstr(
  int            imageid,        /* -> image id for which to store the */
                                 /*     interior orientation; the value */
                                 /*     has to be either left-img-id or */
                                 /*     right-img-id */
  Distortion_s  *psDistortion ); /* -> ptr to distortion data structure */

/* BEGMAN
================================================================
description.............:

      This function computes with distortion reduced photo coordinates

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_p2predparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function computes with earth curvature reduced photo coordinates

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_p2predcparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function computes photo coordinates from with distortion reduced 
      photo coordinates

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_pred2pparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function computes photo coordinates from with earth curvature reduced 
      photo coordinates

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_predc2pparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function is used for left and right from-coordinates in 
      order to reduce them into left and right to-coordinates.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_2xp2predparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function is used for left and right from-coordinates in 
      order to reduce them into left and right to-coordinates.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_2xp2predcparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function is used for reduced left and right from-coordinates in 
      order to adjust them into left and right to-coordinates.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_2xpred2pparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function is used for reduced left and right from-coordinates in 
      order to adjust them into left and right to-coordinates.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_2xpredc2pparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function performes a 4 parameter transformation
      There are 2 translations and 2 scales.
      The Transform_s data structure holds in following elements
      from zero different values:

            a0  0  0  a3
             0 b1  0  b3
             0  0  0   0
             0  0  0   0

      with     a0 = scale in X;     b1 = scale in Y
               a3 = Shift in X;     b3 = Shift in Y;

      The transformation equation applied is:

      tovec[i*2  ] = (fromvec[i*2  ] * a0);+ a3
      tovec[i*2+1] = (fromvec[i*2+1] * b1);+ b3

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_4param(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function performes a 6 parameter transformation.
      Depending on the meaning of the parameters this transforma-
      tion can be a:

        a);rigid body       (3-param.: 2 shifts, 1 rotation);
        b);plane conformal  (4-param.: 2 shifts, 1 rotation,  1 scale);
        c);affine           (6-param.: 2 shifts, 2 rotations, 2 scales);

      transformation. The from zero different elements in the data
      structure Transform_s are:

            a0 a1  0  a3
            b0 b1  0  b3
             0  0  0   0
             0  0  0   0

      The transformation equation applied is:

      tovec[i*2  ] = (fromvec[i*2] * a0);+ (fromvec[i*2+1] * a1);+ a3
      tovec[i*2+1] = (fromvec[i*2] * b0);+ (fromvec[i*2+1] * b1);+ b3

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_6param(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function performes a 2x6 parameter transformation.
      This function is used for left and right from-coordinates in 
      order to transform them into left and right to-coordinates.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_2x6param(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2x2D */
                                 /*     coordinates */
                                 /*     Xl1,Yl1,Xr1,Yr1... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     xl1,yl1,xr1,yr2,..... */

/* BEGMAN
================================================================
description.............:

      This function performes a 8 parameter transformation.
      The geometric interpretation is that there are 2 translations
      2 rotations, 2 scales, and 2 mixed terms.
      The Transform_s data structure holds in following elements 
      from zero different values:

            a0 a1 a2  a3
            b0 b1 b2  b3
             0  0  0   0
             0  0  0   0

               a3 = Shift in X;     b3 = Shift in Y;

      The transformation equation applied is:

      tovec[i*2  ] = (fromvec[i*2  ] * a0);                 + 
                     (fromvec[i*2+1] * a1);                 +
                     (fromvec[i*2  ] * fromvec[i*2+1] * a2);+
                     a3
      tovec[i*2+1] = (fromvec[i*2  ] * b0);                 +
                     (fromvec[i*2+1] * b1);                 +
                     (fromvec[i*2  ] * fromvec[i*2+1] * b2);+
                     b3
return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_8param(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function performes the plane projective equation which
      requires 8 parameters.
      The Transform_s data structure holds in following elements
      from zero different values:

            a0 a1 a2   0
            b0 b1 b2   0
            c0 c1  1   0
             0  0  0   0

      The transformation equation applied is:

      tovec[i*2  ] = ((fromvec[i*2  ] * tf->a0);+
                      (fromvec[i*2+1] * tf->a1);+ tf->a2);/
                     ((fromvec[i*2  ] * tf->c0);+
                      (fromvec[i*2+1] * tf->c1);+ (double);1.0);

      tovec[i*2+1] = ((fromvec[i*2  ] * tf->b0);+
                      (fromvec[i*2+1] * tf->b1);+ tf->b2);/
                     ((fromvec[i*2  ] * tf->c0);+
                      (fromvec[i*2+1] * tf->c1);+ (double);1.0);

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_8projective(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function transforms 3D coordinates in 'fromvec' into 2D
      coordinates 'tovec'. Usually the 3D coordinates represent ei-
      ther 'world'- or 'model'-coordinates whereas the 2D coordinates
      represent 'not reduced' photo coordinates.

      The Transform_s data structure holds in following elements
      from zero different values:

            a0 a1 a2 a3
            b0 b1 b2 b3
            c0 c1 c2 c3
            d0 d1 d2  1
   
      with   a0, a1, a2, b0, b1, b2, c0, c1, c2  elements of the rota-
             tion matrix; a3, b3, c3 station coordinates (X0,Y0,Z0);of
             the projection centre; 
             d0 = x0, d1 = y0, d2 = focal_length.

      The transformation equation applied is

      help = (foclen);/
             ( ((X - X0);* r13);+ ((Y - Y0);* r23);+ ((Z - Z0);* r33); );

      ximg = ximg0 - ( ((X - X0);* r11);+
                       ((Y - Y0);* r21);+
                       ((Z - Z0);* r31);  );* help

      yimg = yimg0 - ( ((X - X0);* r12);+
                       ((Y - Y0);* r22);+
                       ((Z - Z0);* r32);  );* help


return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_collinear(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,Zfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function transforms 3D coordinates in 'fromvec' into 2x2D
      coordinates 'tovec'. Usually the 3D coordinates represent ei-
      ther 'world'- or 'model'-coordinates whereas the 2x2D coordinates
      represent (not reduced);photo coordinates of left and right photo.


      The 'tovec' holds 1st 'npts*2' coordinates of the left photo in 
      the sequence ;xy,xy,...', and 2nd 'npts*2' coordinates of the
      right photo.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_2collinear(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,Zfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      This function transforms 2x2D coordinates in 'fromvec' into 3D
      coordinates 'tovec'. Usually the 2x2D coordinates represent ei-
      ther 'photo'- or 'image'-coordinates whereas the 3D coordinates
      represent e.g. 'model' or 'world' coordinates. There are 2 
      'Transform_s' data structures stored in contigous memory space
      of 'cptr' passed into this function, the first one for the left 
      image the second one for the right image.

      Each Transform_s data structure holds in following elements
      from zero different values:

                         left               right

                      a0 a1 a2 a3        a0 a1 a2 a3
                      b0 b1 b2 b3        b0 b1 b2 b3
                      c0 c1 c2 c3        c0 c1 c2 c3
                      d0 d1 d2  1        d0 d1 d2  1
   
      with:  a0, a1, a2, b0, b1, b2, c0, c1, c2  elements of the rota-
             tion matrix; 
             a3, b3, c3 translation values 
             d0 = x0, d1 = y0, d2 = focal_length.

      The transformation equation applied is:

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_invcollinear(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2x2D */
                                 /*     coordinates in the order: */
                                 /*     xl,yl,xr,yr,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     xm,ym,zm,... */

/* BEGMAN
================================================================
description.............:

      This function transforms 3D coordinates in 'fromvec' into 3D
      coordinates 'tovec' of another space. Usually the 'fromvec' 3D 
      coordinates represent e.g. 'world'-coordinates and the 'tovec'
      3D coordinates represent 'not reduced' 'model'-coordinates.

      The Transform_s data structure holds in following elements
      from zero different values:

            a0 a1 a2 a3
            b0 b1 b2 b3
            c0 c1 c2 c3
            d0 d1 d2  1

      with:  a0, a1, a2, b0, b1, b2, c0, c1, c2  elements of the rota-
             tion matrix; a3, b3, c3 translation vector 'X0,Y0,Z0'
             d0, d1, d2 scales for X,Y,Z.
             Usually the scale is homogeneous, i.e. d0=d1=d2. These
             values can be used to on-line scale e.g. from 'feet' into
             'm'.

      The transformation equation applied is:

      tovec[i*3  ] = ( (fromvec[i*3  ] * tf->a0);+
                       (fromvec[i*3+1] * tf->a1);+
                       (fromvec[i*3+2] * tf->a2) );* tf->d0 + tf->a3

      tovec[i*3+1] = ( (fromvec[i*3  ] * tf->b0);+
                       (fromvec[i*3+1] * tf->b1);+
                       (fromvec[i*3+2] * tf->b2) );* tf->d1 + tf->b3

      tovec[i*3+2] = ( (fromvec[i*3  ] * tf->c0);+
                       (fromvec[i*3+1] * tf->c1);+
                       (fromvec[i*3+2] * tf->c2) );* tf->d2 + tf->c3

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_15param(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,Zfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,Zto,... */

/* BEGMAN
================================================================
description.............:

      This function transforms 3D coordinates in 'fromvec' into 3D
      coordinates 'tovec' of another space. Usually the 'fromvec' 3D 
      coordinates represent e.g. 'model'-coordinates and the 'tovec'
      3D coordinates represent  'world'-coordinates.

      The Transform_s data structure holds in following elements
      from zero different values:

            a0 a1 a2 a3
            b0 b1 b2 b3
            c0 c1 c2 c3
            d0 d1 d2  1

      with:  a0, a1, a2, b0, b1, b2, c0, c1, c2  elements of the rota-
             tion matrix; a3, b3, c3 translation vector (X0,Y0,Z0);;
             d0, d1, d2 scales for X,Y,Z.
             Usually the scale is homogeneous, i.e. d0=d1=d2. These
             values can be used to on-line scale e.g. from [feet] into
             [m].

      The transformation equation applied is:

      tovec[i*3  ] = ( ((fromvec[i*3  ] - tf->a3);* tf->a0);+
                       ((fromvec[i*3+1] - tf->a3);* tf->a1);+
                       ((fromvec[i*3+2] - tf->a3);* tf->a2) );/ tf->d2

      tovec[i*3+1] = ( ((fromvec[i*3  ] - tf->a3);* tf->b0);+
                       ((fromvec[i*3+1] - tf->a3);* tf->b1);+
                       ((fromvec[i*3+2] - tf->a3);* tf->b2) );/ tf->d2

      tovec[i*3+2] = ( ((fromvec[i*3  ] - tf->a3);* tf->c0);+
                       ((fromvec[i*3+1] - tf->a3);* tf->c1);+
                       ((fromvec[i*3+2] - tf->a3);* tf->c2) );/ tf->d2

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_15invparam(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,Zfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,Zto,... */

/* BEGMAN
================================================================
description.............:

      This function selects the tf_function to be applied for a given
      'tfid' which specifies a certain tf_member.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_select(
  int       mbrid,               /* -> tf_member id for which to select the */
                                 /*     tf_function pointer */
  TFmbr_s  *lmbr,                /* <- ptr to selected tf_member */
  int     (*func)(void) );           /* -> ptr to tf_function applied with */
                                 /*     'mbrid' */

/* BEGMAN
================================================================
description.............:

      This function searches for a certain member in the linked list of
      tf_members. This tf_member is identified by 'mbrid'. The pointer 
      to the found tf_member is returned in 'mbr'. 
      

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_findmbr(
  int       mbrid,               /* -> tf_member id for which to select the */
                                 /*     tf_function pointer */
  TFmbr_s **mbr );               /* <- ptr to tf_member with id 'mbrid' */

/* BEGMAN
================================================================
description.............:

      This function returns the model parameters. These are:
  
              a);coordinates of model center in world coordinates
              b);scale (1:'scale');.

      The returned pointer holds the model parameters as follows:

              mparam[0] = model_x_coordinate     [world]
              mparam[1] = model_y_coordinate     [world]
              mparam[2] = model_z_coordinate     [world]
              mparam[3] = model_scale

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_inqmparam(
  double   *mparam );             /* <- ptr to model parameters */

/* BEGMAN
================================================================
description.............:

      This function inverts the 15 parameter transformation. This trans-
      formation is supposed to be orthogonal, i.e. the transposed com-
      puted rottation matrix R(t);is identical with the inverse given 
      rotation matrix R. Following is done:

      given:        w = w0 + l M m;
      wanted:       m = m0 + k M(t);w

      with:         w   spatial coord. vector in coord. system w
                         (e.g. w = world);
                    w0  spatial coord. in coord. system w of origin 
                         of coord. system m
                    l   scale factor in order to scale from coord.
                         system m into coord. system w
                    M   rotation matrix (3x3);
                    m   spatial coord. vector in coord. system m
                         (e.g. m = model);
                    m0  spatial coord. in coord. system m of origin
                         of coord. system w
                    k   scale factor in order to scale from coord.
                         system w into coord. system m
  
      The wanted transformation parameters are returned in data structure
      'Transform_s'.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_15invert(
  char     *mmat,                    /* -> type casted ptr to tf_parameters */
  char    **tmat  );                 /* <- inverted 'mmat' */

/* BEGMAN
================================================================
description.............:

      This function transposes the elements of a 3x3 rotation matrix.
      This matrix is orthogonal, i.e. the transposed rotation matrix 
      is equivalent with the inverse rotation matrix.

      The function expects a type casted 'Transform_s' structure and
      transposes the 3x3 elements of the rotation matrix.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_3x3transpose(
  char     *mmat,                    /* -> type casted ptr to tf_parameters */
  char    **tmat  );                 /* <- transposed 3x3 rotmat of 'mmat' */

/* BEGMAN
================================================================
description.............:

      This function inverts the 6 parameter transformation. This trans-
      formation is supposed to be orthogonal, i.e. the transposed com-
      puted rotation matrix R(t);is identical with the inverse given 
      rotation matrix R. Following is done:

      given:        p = p0 + l M i;
      wanted:       i = i0 + k M(t);p

      with:         p   spatial coord. vector in coord. system p
                         (e.g. p = photo);
                    p0  spatial coord. in coord. system p of origin 
                         of coord. system i
                    l   scale factor in order to scale from coord.
                         system i into coord. system p
                    M   rotation matrix (3x3);
                    i   spatial coord. vector in coord. system i
                         (e.g. i = image);
                    i0  spatial coord. in coord. system i of origin
                         of coord. system p
                    k   scale factor in order to scale from coord.
                         system p into coord. system i
  
      The wanted transformation parameters are returned in data structure
      'Transform_s'.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_6invert(
  char     *mmat,                    /* -> type casted ptr to tf_parameters */
  char    **tmat  );                 /* <- inverted 'mmat' */

/* BEGMAN
================================================================
description.............:

      This function inverts a 2x2 coefficient matrix.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */



int tf_2x2invert( 
  double   a11, 
  double   a12, 
  double   a21, 
  double   a22, 
  double  *b11,
  double  *b12, 
  double  *b21, 
  double  *b22 );

/* BEGMAN
================================================================
description.............:

      This function writes tf_parameters onto 'stderr'.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


void tf_dumptf(                    /* This function writes tf_parameters */
                                   /* onto 'stderr' */
  Transform_s  *tfdata );          /* -> pointer to tf_parameters */

/* BEGMAN
================================================================
description.............:

      This function returns the version number of tf_pack.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */


int tf_inqversion(
  double   *version );                      /* <- tf_pack version number */

/* BEGMAN
================================================================
description.............:

      This function reads the elements of a 'Transform_s' data structure
      from an ASCII-file. The order of data is

               a0 a1 a2 a3
               b0 b1 b2 b3
               c0 c1 c2 c3
               d0 d1 d2 d3

      i.e. there are 4 lines each holdin 4 values '=parameters'.

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_getparamff(
  char         *filename,                   /* -> tf_parameter file name */
  Transform_s **ltf );                      /* <- tf_pack version number */

/* BEGMAN
================================================================
description.............:

      This function reads the tf_memberid and the elements of a 
      'Transform_s' data structure from an ASCII-file. The order 
      of data is

               mbrid
               a0 a1 a2 a3
               b0 b1 b2 b3
               c0 c1 c2 c3
               d0 d1 d2 d3

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_getmbrff(
  char         *filename,                   /* -> tf_parameter file name */
  TFmbr_s     **mbrptr );                   /* <- ptr to ptr of tf_members */

/* BEGMAN
================================================================
description.............:

      This function 2D coordinates of epipolar image in 'fromvec' into 2D
      coordinates of digital image 'tovec'. The 2D 'tovec' coordinates
      represent 'not reduced' photo coordinates. 

return value ...........:
  ignore
MANEND */

int tf_epi2p_p2i(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     xfrom,yfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     xto,yto,... */

/* BEGMAN
================================================================
description.............:

      This function 2x2D coordinates of epipolar image in 'fromvec' into 2x2D
      coordinates of digital image 'tovec'. The 2x2D 'tovec' coordinates
      represent 'not reduced' photo coordinates 1. 

return value ...........:
  ignore
MANEND */

int tf_2epi2p_p2i(
  char          *cptr,           /* -> type casted ptr to tf_parameters */
  int            npts,           /* -> number of points to transform */
  double        *fromvec,        /* -> ptr to coordinates which are to be */
                                 /*     transformed. The vector holds 3D */
                                 /*     coordinates in the order: */
                                 /*     Xfrom,Yfrom,Zfrom,... */
  double        *tovec );        /* <- ptr to coordinates which are trans- */
                                 /*     formed. The vector holds 2D */
                                 /*     coordinates in the order: */
                                 /*     Xto,Yto,... */

/* BEGMAN
================================================================
description.............:

      trf_initimg

return value ...........:
  ignore
MANEND */


int trf_initimg (
  char  *imgnam,    /* -> image name */
  int    imgid);    /* -> image ID */
                    /*    1 = left image in tf_family */
                    /*    2 = right image in tf_family */

/* BEGMAN
================================================================
description.............:

trf_tfstrcmult

return value ...........:
ignore
MANEND */


int trf_tfstrcmult (
Transform_s   tfstrc_1st,    /* -> */
Transform_s   tfstrc_2nd,    /* -> */
Transform_s  *tfstrc_new);   /* <- */

/* BEGMAN
================================================================
description.............:

trf_close

return value ...........:
ignore
MANEND */


int trf_close( void );

/* BEGMAN
================================================================
description ............:

  tf_source = tf_inverse = | a0  a1  a2  a3 |
                           |                |
                           | b0  b1  b2  b3 |
                           |                |
                           | c0  c1  c2  c3 |
                           |                |
                           | d0  d1  d2  d3 |

return value ...........:
  0              = O.K.
  PHD_MALLOCERROR = no memory for matrix allocation
MANEND */

int trf_tfsrc2inv(
  Transform_s  tf_source,   /* -> structur with source tf parameters */
  Transform_sp tf_inverse); /* <- structur with inverse tf parameters */

/* BEGMAN
================================================================
description ............:

  distortion reduced photo coordinates will be adjusted

return value ...........:
  0 if no error
 !0 if error
MANEND */

int trf_Pred2PDist2D(
    double     dXcoord,      /* -> x photo coordinate */
    double     dYcoord,      /* -> y photo coordinate */
    double     dX0coord,     /* -> x0 PPA photo coordinate */
    double     dY0coord,     /* -> y0 PPA photo coordinate */
    Point2d_s *psDist2D,     /* -> distortion table */
    double    *pdXredcoord,  /* <- with distortion reduced x coordinate */
    double    *pdYredcoord); /* <- with distortion reduced y coordinate */

/* BEGMAN
================================================================
description ............:

  photo coordinates will be reduced with distortion

return value ...........:
  0 if no error
 !0 if error
MANEND */

int trf_P2PredDist2D(
    double     dXcoord,      /* -> x photo coordinate */
    double     dYcoord,      /* -> y photo coordinate */
    double     dX0coord,     /* -> x0 PPA photo coordinate */
    double     dY0coord,     /* -> y0 PPA photo coordinate */
    Point2d_s *psDist2D,     /* -> distortion table */
    double    *pdXredcoord,  /* <- with distortion reduced x coordinate */
    double    *pdYredcoord); /* <- with distortion reduced y coordinate */

/* BEGMAN
================================================================
description ............:

  generate 2D Table from distortion structure. In the new table are x-element
  for locations=r and y-element for values=distortion of r*r.

return value ...........:
  0 if no error
 !0 if error
MANEND */

int trf_genDist2DTbl(
    Distortion_s  *psDist,           /* -> distortion structure */
    Point2d_s    **ppsDistortion2D); /* <- table of new generated dist. */

/* BEGMAN
================================================================
description ............:

  photo coordinates will be corrected with earth curvature

return value ...........:
  0 if no error
 !0 if error
MANEND */

int trf_P2PredCurv(
    double     dXcoord,      /* -> x photo coordinate */
    double     dYcoord,      /* -> y photo coordinate */
    double     dConstant,    /* -> constant term */
    double     dQuadrFocl,   /* -> square of focal lenght */
    double    *pdXredcoord,  /* <- with curvature reduced x coordinate */
    double    *pdYredcoord); /* <- with curvature reduced y coordinate */

/* BEGMAN
================================================================
description ............:

  with earth curvature corrected photo coordinates will be adjusted 

return value ...........:
  0 if no error
 !0 if error
MANEND */

int trf_Pred2PCurv(
    double     dXcoord,      /* -> x photo coordinate */
    double     dYcoord,      /* -> y photo coordinate */
    double     dConstant,    /* -> constant term */
    double     dQuadrFocl,   /* -> square of focal lenght */
    double    *pdXredcoord,  /* <- with curvature reduced x coordinate */
    double    *pdYredcoord); /* <- with curvature reduced y coordinate */

/* BEGMAN
================================================================
description.............:

      This function set the operator height level

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_setheightlev(
    double     dDeltaHeight);  /* -> Operator height level */

/* BEGMAN
================================================================
description.............:

      This function get the operator height level

return value ...........:
      OKRET if no error
      < 0   if phodis internal error
      > 0   if system error
MANEND */

int tf_getheightlev(
    double    *dDeltaHeight ); /* <- Operator height level */

/* BEGMAN
================================================================
description ............:

  The function checks the type of distortion. If it isn't equal constant
  interval, so it'll be computed again onto these type. It must be called
  before trf_genDist2DTbl function.

return value ...........:
  0 if no error
 !0 if error
MANEND */

int trf_chckCamDist(
    Camera_sp spCamera); /* <-> camera structure to check */

/* BEGMAN
================================================================
description ............:


return value ...........:
  0 if no error
 !0 if error
MANEND */

int tf_getrotations(
    double    *dpModelCoords,
    double    *dpLeftKappa,
    double    *dpRightKappa ); /*  */

/* BEGMAN
================================================================
description ............:


return value ...........:
  0 if no error
 !0 if error
MANEND */

int tf_inqrotations(
    double    *dpLeftKappa,
    double    *dpRightKappa ); /*  */


#endif
