/*--------------------------------------------------------------
 *
 *  $RCSfile: vpe_d.h,v $
 *
 *  Copyright (c) Carl Zeiss 1992
 *  $Date: 1998/07/21 19:10:10 $
 *  $Author: rwa $
 *  $Locker:  $
 *  $Revision: 1.1 $
 *  $Source: /bio/reo/rwa/devel/phodis_convert/RCS/vpe_d.h,v $
 *  $State: Exp $
 *
 *--------------------------------------------------------------
 *--------------------------------------------------------------
 */


/* BEGINC
description : Standard defines
INCEND */
 
#ifndef _vpe_d__
#define _vpe_d__

/* earlier definitions from vpe.h */
typedef unsigned char       Uchar;
typedef unsigned short      Ushort;
typedef unsigned int        Uint;
typedef unsigned long       Ulong;

#define  ERRORRET (( int ) - 1)  /* function return value for errors */
#define  OKRET    (( int ) 0)    /* function return value in case of no error */

#define  EPSILON           0.000001
#define  PI            ((double)M_PI)
#define  RHOGON        ((double)200.0 / PI)
#define  RHODEG        ((double)180.0 / PI)

#define DEG2DMS(deg)  ( (int)deg + ( (int)( (deg - (int)deg )*60 ) )*.01 + \
                        ( ((deg - (int)deg)*60) - \
                          (int)( (deg - (int)deg )*60 ) )*60  * 0.0001 )

#define DMS2DEG(dms)  ( (double)((int)dms) +\
                        ((double)((int)((dms - (int)dms)*100)))/60 +\
                        ((((dms - (int)dms)*100) - (int)((dms - (int)dms)*100))\
                        *100)/3600 )

#define  NINT(a)       (((a)<0) ? (int)((a)-0.5):(int)((a)+0.5))

#define UNIT_m          ((int)0)
#define UNIT_ft         ((int)1)
#define UNIT_usft       ((int)2)
#define UNIT_inch       ((int)3)
#define UNIT_usinch     ((int)4)
#define UNIT_km         ((int)5)
#define UNIT_dm         ((int)6)
#define UNIT_cm         ((int)7)
#define UNIT_mm         ((int)8)
#define UNIT_um         ((int)9)
#define UNIT_mile       ((int)10)

#define UNIT_rad        ((int)0) /* Angle in Radian */
#define UNIT_grad       ((int)1) /* Angle in Grad(=400) */
#define UNIT_degdec     ((int)2) /* Angle in Degree.Decimal(=360) */
#define UNIT_degminsec  ((int)3) /* Angle in Degree.MinSec(=360) */

/* globals */

#define LEN16            16
#define LEN32            32
#define LEN64            64
#define LEN256          256
#define LEN512          512

#define ONLINE            1
#define OFFLINE           0

/* global strings */

#define STR_YES          "yes"
#define STR_NO           "no"
#define STR_OFF          "off"
#define STR_ON           "on"
#define STR_UNDEFINED    "undefined"
#define STR_DEFINED      "defined"
#define STR_SEPCHR       ","

/* keywords, filenames ... */

#define KEYWORDID        "PHO_"    /* Identifier for keywords */
#define KEYWORDIDLEN         4     /* Length of keyword identifier */

#define MAXKEYWORDS      LEN16     /* max. KEYWORDS allowed in a string */
#define MAXKEYWORDLEN       25     /* max. KEYWORDS allowed in a string */
#define MAXLINELEN       LEN256    /* max. len of line in ASCII file */
#define MAXFILENAME      LEN32
#define MAXFILEPATH      LEN256
#define MAXPOINTID       LEN16
#define MAXFILEDESC         60     /* max len of file descriptors */
#define MAXFILEEXT           6     /* max file extension          */
#define FILDIRSEP          "/"     
#define FILEXTSEP          "."     
#define FILCOMCHR          "#"     
#define MAXPRJNAME          17     /* max len of project names    */

#define MAXLUTVAL        4096      /* max entries for LUT structure */
#define MAXPHBREF          64      /* max entries in PHB structure */
#define DIMIND              0      /* index of di file in PHB block */
#define OIMIND              1      /* index of oi file in PHB block */


typedef  char FILENAME[MAXFILENAME];     /* id of a filename */
typedef  char FILEPATH[MAXFILEPATH];     /* id of a filepath */
typedef  char FILEEXT[MAXFILEEXT];       /* id of a filepath */
typedef  char POINTID[MAXPOINTID];       /* id of a point */

#define ASCIIHEADERLEN     60   /* max length ASCII Fileheader description */

/* OP V2.x compatibility */

#define MaxIdenticPnts     1000      /* max no of identic pnts for transform */
#define MaxTfPars           6        /* max tf parameters Helmert/Affin */


/* defines for import PS1 heade file */
#define MAXFIDNO           8
#define ANZCORNER          4
/* end of impexp defines */
	
#define MAXLINE          512
#define NAMLEN           256
#define ASCLINLEN80       80      /* IRIX allows 256 char.  for file names */
#define MAXFILNAMLEN     14
#define MAXPRJNAMLEN     10
#define MAXPRJTITLEN     256
#define MAXKEYWLEN       32
#define MAXDIRANZ        32
#define MAXEXTANZ        MAXDIRANZ
#define MAXFMTANZ        MAXDIRANZ
#define MAXCUNITSANZ     MAXDIRANZ
#define MAXAUNITSANZ     MAXDIRANZ
#define MAXDATEFMTANZ    MAXDIRANZ
#define MAXDIRLEN        (NAMLEN-MAXFILNAMLEN)
#define MAXEXTLEN        MAXFILNAMLEN
#define MAXFMTLEN        MAXKEYWLEN
#define MAXSPECLEN       MAXKEYWLEN
#define MAXSYMBLEN      (MAXKEYWLEN/2)

#define OREA      "r"   /* Opens for reading */
#define REWR     "r+"   /* Opens for both reading & writing */
#define OWRI      "w"   /* Opens an emty fil for writing */
#define WRRE     "w+"   /* Opens for both reading & writing */
#define APWR      "a"   /* Opens for writing at the end of the file */
#define APRE     "a+"   /* Opens for reading & appending */


#define STRING      0
#define CHARACTER   1
#define DECIMAL     2
#define LDECIMAL    3
#define FLOATING    4
#define LFLOATING   5
#define EXPON       6
#define UDECIMAL    7
#define UOKTAL      8
#define UHEXDECIMAL 9

#define   SZ_CHAR       ((long)( sizeof(char) ))
#define   SZ_UCHAR      ((long)( sizeof(Uchar) ))
#define   SZ_SHORT      ((long)( sizeof(short) ))
#define   SZ_USHORT     ((long)( sizeof(Ushort) ))
#define   SZ_INT        ((long)( sizeof(int) ))
#define   SZ_UINT       ((long)( sizeof(Uint) ))
#define   SZ_LONG       ((long)( sizeof(long) ))
#define   SZ_ULONG      ((long)( sizeof(Ulong) ))
#define   SZ_FLOAT      ((long)( sizeof(float) ))
#define   SZ_DOUBLE     ((long)( sizeof(double) ))

/* conversion */
#define TLD2TLD       0
#define TLD2TIFF      1
#define TLD2RAW       2
#define TLD2DOQ       3
#define TLD2CT        4
#define TLD2PS        5
#define TLD2SUN       6
#define TIFF2TLD      7
#define TIFF2CT       8
#define RAW2TLD       9
#define RAW2RAW      10
#define DOQ2TLD      11

/* DTMs */
#define CZ    1                  /* Carl Zeiss */
#define TM    2                  /* Terramodel */
#define HIFI  3                  /* HIFI */
#define SCOPE 4                  /* SCOPE */


#define UNDEFCOORD    ((double)999999999.999)


/* list of file types which can occur in PHODIS */

#define CAM_TYP      10
#define HLP_TYP      20
#define MAN_TYP      30
#define ERR_TYP      40
#define LOG_TYP      50
#define TMP_TYP      60
#define PAT_TYP      70
#define FMK_TYP      80
#define IMG_TYP      90
#define EPI_TYP     100
#define DTM_TYP     110
#define GCP_TYP     120
#define PEX_TYP     130
#define DAT_TYP     140
#define OIM_TYP     150
#define PUZ_TYP     160
#define MOS_TYP     170
#define DI_TYP      180
#define OI_TYP      190
#define CAL_TYP     200
#define SSR_TYP     210

/* internal date */

typedef struct Date {
  int     day;
  int     month;                     /* month, 1=january      */
  int     year;                      /* year, full, e.g. 1991 */
  int     hour;
  int     minute;
  int     sec;
} Date_s, *Date_sp;

#define MMDDYY              0
#define DDMMYY              1
#define YYMMDD              2
#define MMDDYYHMS           3
#define DDMMYYHMS           4
#define YYMMDDHMS           5
#define MMDDYYYY            6
#define DDMMYYYY            7
#define YYYYMMDD            8
#define MMDDYYYYHMS         9
#define DDMMYYYYHMS        10
#define YYYYMMDDHMS        11
#define TTMMJJ             12
#define TTMMJJJJ           13
#define TTMMJJHMS          14
#define TTMMJJJJHMS        15

/* file access modes */

#define NONEXCLUSIVE     0         /* file open with no lock */
#define EXCLUSIVE        1         /* file open with no lock */

#define READ              1          /* read existing file */
#define WRITE             2          /* delete existing file, write new one */
#define UPDATE            3          /* update existing file */
#define UPDCRE            4          /* update or if not exist, create */
#define APPEND            5          /* append data at an existing file: TIFF/Sued */


/* file mask defines */

#define F_0RWXRWXRWX   00777         /* UNIX file access rights */
#define F_0RW_RW_RW_   00666
#define F_0RW_RW_R__   00664
#define F_0R__R__R__   00444
#define F_0R__R_____   00440
#define F_0R________   00400
#define F_0_W__W__W_   00222
#define F_0_W__W____   00220
#define F_0_W_______   00200
#define F_SRWXRWXRWX   04777
#define F_SRW_RW_RW_   04666
#define F_SR__R__R__   04444
#define F_SR__R_____   04440
#define F_SR________   04400
#define F_S_W__W__W_   04222
#define F_S_W__W____   04220
#define F_S_W_______   04200

/* swab definitions */

#define SWAB2  2                   /* swab 2 bytes */
#define SWAB4  4                   /* swab 4 bytes */
#define NSWAB  0                   /* swab no bytes */

/* image element access */

#define CSmplHdr          "SmplHdr"
#define COverview         "Overview"
#define CImage            "Image"


/* supported image file types */

#define FILETYP_TILED             0      /* CARL ZEISS image format */
#define FILETYP_COT               1      /* Intergraph cot format 65 */
#define FILETYP_CZBINARY          2
#define FILETYP_UNDEFINED        -1

/* channels in images */

#define MAXCHAN                   4
#define CHAN_DEF                  0
#define CHAN_ONE                  1
#define CHAN_TWO                  2
#define CHAN_THREE                3
#define CHAN_EXT                  8
#define CHAN_1                    1
#define CHAN_2                    2
#define CHAN_3                    4
#define CHAN_12                   3
#define CHAN_13                   5
#define CHAN_23                   6
#define CHAN_123                  7

/* File Header 0 type definitions */

#define FT_UNKNOWN                0       
#define FT_PRJOP                  1        /* OP project file */
#define FT_PRJ                    2        /* PHODIS project file */
#define FT_MMEM                   3        /* PHODIS model photomemory file */
#define FT_GCP                    4        /* PHODIS GCP file */

/* process start */

#define  FG  0
#define  BG  1


/* version definitions */

#define VERS0                     "V0.0"


/* error handling definitions */
 
#define MAXTXTSTACKDEPTH          25        /* max. pushed errors */
#define MAXTXTLEN                 4096      /* txt message maximal len */
#define MESSAGELEVEL              0         /* text level MESSAGE */
#define WARNINGLEVEL              1         /* text level WARNING */
#define ERRORLEVEL                2         /* text level ERROR */
#define DISASTERLEVEL             3         /* text level DISASTER */

/* coord. */

#define UNDEFCOOR       ((double)999999.9)

/* process and runstring options */

#define  PROCSTARTOPT  46051
#define  STARTOPT_RM   "-S"
#define  STARTOPT_KEEP "-s"
#define  STARTOPT_HELP "-h"
#define  ISTARTOPT_RM   	1
#define  ISTARTOPT_KEEP 	2   
#define  ISTARTOPT_NO   	3
#define  ISTARTOPT_HELP 	0

/* global keywords for PHODIS process control files */

#define PHO_PROJECT       "PHO_PROJECT"
#define PHO_MODEL         "PHO_MODEL"
#define PHO_MODELINCREASE "PHO_MODELINCREASE"
#define PHO_STEREOMODE    "PHO_STEREOMODE"
#define PHO_STEREOPLOTTER "PHO_STEREOPLOTTER"
#define PHO_GCPFILE       "PHO_GCPFILE"
#define PHO_IMAGE         "PHO_IMAGE"
#define PHO_TMAT          "PHO_TMAT"
#define PHO_TORI          "PHO_TORI"
#define PHO_CAMERA        "PHO_CAMERA"
#define PHO_GUISTART      "PHO_GUISTART"
#define PHO_PRTFIL        "PHO_PRTFIL"
#define PHO_STATUS        "PHO_STATUS"
#define PHO_TITLE         "PHO_TITLE"
#define PHO_RETURN        "PHO_RETURN"
#define PHO_TERMALWAYS    "PHO_TERMALWAYS"
#define PHO_TERMNOERROR   "PHO_TERMNOERROR"
#define PHO_OVERVIEW      "PHO_OVERVIEW"
#define PHO_CRADIUS       "PHO_EARTHRADIUS"
#define PHO_EPICORR       "PHO_EPIIMAGECORR"

#define PHO_PYSTEPS       "PHO_PYSTEPS"      /* gen_pyra */
#define PHO_PYFIL         "PHO_PYFIL"
#define PHO_PYFACT        "PHO_PYFACT"
#define PHO_PYFILTER      "PHO_PYFILTER"
#define PHO_PYUSERKERNEL  "PHO_PYUSERKERNEL"
#define PHO_PYCHAN        "PHO_PYCHAN"       

#define PHO_ATM           "PHO_ATM"          /* atm-mbo switch */
#define SAT_LSTIMGL       "SAT_LSTIMGL"      /* last used left image name */
#define SAT_LSTIMGR       "SAT_LSTIMGR"      /* last used right image name */
#define SAT_GCP           "SAT_GCP"          /* last used gcp name */
#define SAT_LSTNAMES      "SAT_LSTNAMES"     /* last used tie/new cntrl names */


/* global keywords for PHODIS process initialization files */

#define PHO_CURSOR        "PHO_CURSOR" /* PHO_CURSOR <size> <color> <type> <transp> <state> */

/* header for process initialization files */

#define VPEINIHDR        "PHODIS process initialization file"



/* 
** phodis parameters for epipolar geometry 
*/
#define SF                2        /* size factor for mem */
#define ASF              20        /* max avl size factor for mem */
#define MAXMEMAVL      1024*ASF    /* max mem avl for phips */
#define MAXMEMROWS     1024*SF     /* max no of rows in mem */
#define MAXMEMCOLS     1024*SF     /* max no of cols in mem */
#define MAXPATCHES    10000        /* max no of patches */
#define MAXCHANNELS       3        /* max no of chan. concurrently in mem */

#define OP                0        /* ID number to build image patches */
#define EPI               1        /* ID number to build image patches */

#define BILINEAR          1        /* bilinear interpolation of gray value */
#define BICUBIC           2        /* bicubic interpolation of gray value */

#define BW_MODE           1        /* rectification of BW image */
#define RGB_MODE          3        /* rectification of RGB image */
/*
** end of epipolar parameters
*/

/* 
** constant declarations        
*/
#define    EPS    1.0e-12
#define    R4EPS  1.0e-5
#define    R8EPS  1.0e-10
#define    R4NUL  0.0
#define    I4MAX (pow( (double) 256, (double) 4) /  2) - 1
#define    I4MIN -(pow( (double) 256, (double) 4) /  2)
#define    U4MAX (pow( (double) 256, (double) 4) )
#define    R8MAX (pow( (double) 256, (double) 8) /  2) - 1
#define    R8MIN -(pow( (double) 256, (double) 8) /  2)
#define    I4UNDEF  I4MIN
#define    R8UNDEF  R8MIN
#define    TRUE   1
#define    FALSE  0

#define    LINEINSIDEBOX     -1  /* line is entirely inside the box */
#define    LINEOUTSIDEBOX     1  /* line is entirely outside the box */
#define    LINECUTSBOX        2  /* line cuts the box */

#define    POINTINSIDEAREA    0  /* point is inside of area */
#define    POINTOUTSIDEAREA   1  /* point is outside of area */
#define    POINTNOTDEFINED    2  /* point is outside of area */
#define    POINTONEDGE       -1  /* point is on the edge */

#define    ISECOUTSIDELINE    0 /* intersection is outside the lines */
#define    ISECINSIDELINE1    1 /* intersection is inside of 1st line */
#define    ISECINSIDELINE2    2 /* intersection is inside of 2nd line */
#define    ISECINSIDELINE12   3 /* intersection is inside of both line *

#define    NOCOND_LINEPP      0  /* no condition & line define of 2 points */
#define    ISEC_LINE1         1  /* intersection have to be on 1st line */
#define    ISEC_LINE2         2  /* intersection have to be on 2nd line */
#define    ISEC_LINE12        3  /* intersection have to be inside 1st and 
                                 ** 2nd line */
#define    NOCOND_LINEPB     10  /* no condition & line define of points 
                                 ** and bearing */
#define    NOCHECK            0  /* no checking by intersection */
/*
** end of plnf parameters
*/

/* 
** parameters of math_util funtions 
*/
#define TINY 1.0E-20
/*
** end of math_util parameters
*/

/* 
** parameters of utl funtions 
*/
#define PHO_PRJDIR          "PHO_ROOT/prj/"
#define PHO_CFGFILE         "PHO_HOME/phodis.cfg"
#define PHO_CFGFILENAME     "phodis.cfg"
#define SLASHCHAR           '/'
#define SLASHSTRING         "/"
#define DOTCHAR             '.'
#define SEPCHARDOT          "."
#define SEPCHARSNL          " \n"



/* Coordinate System                           */
#define NAMELEN        11
#define METERNAME      "METER"
#define KMETERNAME     "KILOMETER"
#define MMETERNAME     "MMETER"
#define FOOTNAME       "FOOT"
#define USFOOTNAME     "USFOOT"
#define INCHNAME       "INCH"
#define USINCHNAME     "USINCH"
#define METERUNIT      1.
#define KMETERUNIT     1000.
#define MMETERUNIT     0.001
#define FOOTUNIT       0.3048
#define USFOOTUNIT     12./39.37
#define INCHUNIT       0.0254
#define USINCHUNIT     1./39.37
#define METER_SH_NAME  "[m]"
#define KMETER_SH_NAME "[km]"
#define MMETER_SH_NAME "[mm]"
#define FOOT_SH_NAME   "[ft]"
#define USFOOT_SH_NAME "[usft]"
#define INCH_SH_NAME   "[in]"
#define USINCH_SH_NAME "[usin]"
#define GRADNAME       "GRAD"
#define DEGNAME        "DEGREE"
#define RADNAME        "RADIAN"
#define DMSNAME        "DMS"
#define GRAD_SH_NAME   "[grd]"
#define DEG_SH_NAME    "[deg]"
#define RAD_SH_NAME    "[rad]"
#define DMS_SH_NAME    "[dms]"
#define C1_DEF_NAME    "X"
#define C2_DEF_NAME    "Y"
#define C3_DEF_NAME    "Z"
#define DI_DEF_NAME    "GRAD"
#define DI_DEF_SH_NAME "[grd]"
#define C1_DEF_DIR     "+"
#define C2_DEF_DIR     "+"
#define C3_DEF_DIR     "+"
#define C1_DEF_UNIT    "METER"
#define C2_DEF_UNIT    "METER"
#define C3_DEF_UNIT    "METER"
#define C1_DEF_FMT     "14.3"
#define C2_DEF_FMT     "14.3"
#define C3_DEF_FMT     "8.2"
#define DI_DEF_FMT     "10.4"
#define DI_DEF_FAC     0.015707963
#define DEF_DIO_SEQ    "21"
#define DEF_CIO_SEQ    "123"

/*
** phb parameters
*/

/* Global defines of phb structures */

#define MAXDIST                     5     /* miscellaneous */
#define USD                      1024
#define REF_PPA                     1     /* reference points */
#define REF_PPS                     2
#define REF_FC                      3
#define CAMERAEXT                "cam"   /* default file extensions */
#define DIEXT                    "di" 
#define OIEXT                    "oi" 
#define STA_MEASURED                1     /* status values */
#define STA_IMPORTED_PEX            2     
#define DIST_TYPE_NO                0     /* distortion types */
#define DIST_TYPE_CONST             1     
#define DIST_TYPE_VAR               2     
#define DIST_TYPE_ANG               3     
#define ITYP_POSITIVE               1     /* image types */
#define ITYP_NEGATIVE               2     
#define PHB_EORISTAT_NAV            0     /* state of orientations */
#define PHB_EORISTAT_MAN            1     
#define PHB_EORISTAT_SEM            2     
#define PHB_EORISTAT_AUT            3     
#define PHB_EORISTAT_IMPPAR         4     
#define PHB_EORISTAT_IMPROT         5     
#define PHB_EORISTAT_EPI            6     
#define PHB_IORISTAT_NAV            0
#define PHB_IORISTAT_MAN            1
#define PHB_IORISTAT_SEM            2
#define PHB_IORISTAT_AUT            3
#define PHB_IORISTAT_IMP            4
#define PHB_IORISTAT_EPI            5
#define TF_TYPE_UNDEF               0     /* transformation types */
#define TF_TYPE_SC                  1  
#define TF_TYPE_TR                  2 
#define TF_TYPE_SCTR                3
#define TF_TYPE_RO                  4
#define TF_TYPE_SCRO                5
#define TF_TYPE_TRRO                6
#define TF_TYPE_SCTRRO              7    
#define TF_TYPE_HELMERT             8   
#define TF_TYPE_AFFIN               9  
#define TF_TYPE_BILINEAR           10 
#define TF_TYPE_PROJEKTIV2D        11
#define TF_TYPE_PROJEKTIV3D        12
#define PHB_CAMTYP_GENERIC          0    /* camera types */
#define PHB_CAMTYP_METRIC           1   
#define PHB_CAMTYP_RESEAU           2   
#define PHB_CAMTYP_RMKTOP           3  
#define PHB_CAMTYP_RMKA             4 
#define PHB_CAMTYP_LMK              5 
#define PHB_CAMTYP_RC102030         6 
#define PHB_CAMTYP_UMKSCAN          7 
#define PHB_CAMTYP_UMK              8 
#define PHB_CAMTYP_SPOT             9 
#define PHB_CAMTYP_LINESENSOR      10 
#define PHB_CFIDINVAR           10000    /* fiducial pattern constants */
#define PHB_CFIDIMGID             100   
#define PHB_PATIDFACT            1024
#define DIREF_UNDEF                 0    /* reference states */
#define DIREF_NOTEXIST              1 
#define DIREF_EXIST                 2 
#define DIREF_NOIMG                 3 
#define DIREF_WRONG                -1 
#define DI_EXIST_NOT               -1
#define DI_EXIST_DI                 0
#define DI_EXIST_IMGHDR             1
#define DI_EXIST_DIDEF              2
#define DI_AVAIL_IORI               1
#define DI_AVAIL_EORI               2
#define DI_AVAIL_CAME               4  
#define DI_IMG_EPI                  1  
#define ROTSEQ_OPK                  1   /* omega phi kappa rot. axes */
#define ROTSEQ_POK                  2   /* phi omega kappa rot. axes */

#define IEPRT_HELMERT               "HELMERT"
#define IEPRT_AFFIN                 "AFFIN"

/* Photo memory */
/* Meaning of bits in di.imgmea->status values  */
/* Bit  0 :  0 : measured in PHODIS             */
/*        :  1 : imported                       */
/* Bit  1 :  0 : image coordinates              */
/*        :  1 : photo coordinates              */ 
/* Bit  2 :  0 : manual measurement             */
/*        :  1 : automatic measurement          */
/* Bit  3 :  0 : unused                         */
/*        :  1 : unused                         */
/* Bit  4 :  0 : unused                         */
/*        :  1 : vertical control point         */
/* Bit  5 :  0 : unused                         */
/*        :  1 : horizontal control point       */
/* Bit  6 :  0 : unused                         */
/*        :  1 : full control point             */
/* Bit  7 :  0 : unused                         */
/*        :  1 : new point (from ATriang.)      */
/* Bit  8 :  0 : unused                         */
/*        :  1 : image corner point             */
/* Bit  9 :  0 : unused                         */
/*        :  1 : tie point (from ATriang.)      */
/* e.g. : di.imgmea->status = PM_STATUS  (binary : 000) */
/*        => : pixel coords, manually measured  (default) */
/*        di.imgmea->status = PM_STATUS|PM_IMPORT|PM_PHOCOO (binary : 011) */
/*        => : phorex imported, photo coords, manually measured */
/* if bits 5,6,7 and 8 are 0 then the point is a pure orientation point */
/* if di.imgmea->status = PM_CORNER :           */
/* - image corner points in ground coordinates  */
/* - calculated during exterior/absolute orientation */
/* - all other bits of status are 0 */
/* - not transfered via PHOREX, only for internal purposes */

#define PM_STATUS              0X0000    /* default status (see above) */
#define PM_IMPORT              0X0001    /* phorex imported */     
#define PM_PHOCOO              0X0002    /* photo coordinates */    
#define PM_AUTMEA              0X0004    /* automatic measurement */

#define PM_GCPVER              0X0010    /* vertical control point */
#define PM_GCPHOR              0X0020    /* planimetric control point */
#define PM_GCPFUL              0X0040    /* full control point */
#define PM_NEWPNT              0X0080    /* new control point    (AT-Meas.)  */
#define PM_CORNER              0X0100    /* image corner point */
#define PM_TIEPNT              0X0200    /* tie point    (AT-Meas.)  */
#define PM_RWS                 0X0400    /* rws point, meo */

#define IMGCORNER_LL "IMGCORNER_LL"      /* name of image corner points */
#define IMGCORNER_LR "IMGCORNER_LR"
#define IMGCORNER_UL "IMGCORNER_UL"
#define IMGCORNER_UR "IMGCORNER_UR"

/*
** end of phb parameters
*/

/*
** model parameters
*/
#define   UNDEF                 0       /* undefined */
/*>>>>>>><<<<<<*/
/* GCP defines */
/*>>>>>>><<<<<<*/
#define   DELETED               1       /* deleted     */
#define   DEFINED               2       /* defined     */
#define   SKIPED                3       /* skiped      */
#define   GCPNOTDEFINED         4       /* not defined */

#define   MAXMODELNAME         16
#define   MAXMODELINFO        256
#define   MAXIMGINF            32
#define   MAXRESLEN           512

#define   RELORI_OKROT          10
#define   RELORI_OKPAR          11
#define   RELORI_OK             20

#define   RELORI_PARNOTAV        0
#define   RELORI_PARUNDEF        1
#define   RELORI_PARINDEP        2
#define   RELORI_PARLEFTFIX      3
#define   RELORI_PARRIGHTFIX     4

#define   ABSORI_OKROT          10      /* only rotation matrix available */
#define   ABSORI_OKPAR          11      /* only orientation parameters av. */
#define   ABSORI_OK             20      /* rotmat and pars available */

#define   MODEL_OK              1 
#define   MODEL_NOTOK           2 

#define   MODEL_UNDEF           0 
#define   MODEL_ORTHO           1 
#define   MODEL_PSEUDO          2 

#define   RELABS              0x1       /* model rel & abs oriented */
#define   BUNDLE              0x2       /* model bundle oriented */
#define   SPATRES             0x4       /* model spatial resection oriented */

#define   EPI_OK                0       /* epi images for model available */
#define   EPI_OKNOORI           1       /* epi img available but no ext ori */
#define   EPI_NOTOK             2       /* no epi images available */

#define   AUTO                  1       /* automatic relative orientation */
#define   MAN                   2       /* manual    relative orientation */
#define   BLOCK                 3       /* derived from block adjustment */
                                        /* with independent models */
#define   BUNDLE2               4       /* derived from bundle adjustment
                                           with two images */
#define   BUNDLE3               5       /* derived from bundle adjustment
                                           with three or more images */
#define   IMPORT                6       /* imported via PHOREX */

#define   PST10                10       /* workstation type */
#define   PST20                20       /* workstation type */
#define   PST30                30       /* workstation type */

#define   ORIGINAL_IMAGE       1        /* use original images */
#define   EPIPOLAR_IMAGE       2        /* use epipolar images */

/* Structure identifiers (sid) */
/*     1000000 <=    PHODIS     < 2000000  */
/*     2000000 <=    PHODIS OP  < 3000000  */
/*     3000000 <=    PHODIS ST  < 4000000  */
/*     4000000 <=    PHODIS SC  < 5000000  */
/*     5000000 <=    PHODIS AT  < 6000000  */
/*     6000000 <=    PHODIS AR  < 7000000  */

/* Structure identifiers (sid) */
/*     1000000 <=    PHODIS     < 2000000  */

#define PHO_SID_SHMHEAD  (Ulong)  1000000

#define SID_TILE                  1000001
#define SID_RWTILE                1000002
#define SID_PICTURE               1000004
#define SID_IMAGE                 1000120
#define SID_HISTOGRAM             1000121
#define SID_LUT                   1000122
#define SID_PHB                   1000123

#define SID_OVERVIEW              1000210


#define SID_BHdr1        (Ulong)  1000010
#define SID_Binary       (Ulong)  1000011

#define PHO_SID_MODEL    (Ulong)  1000100

#define SID_C2MD         (Ulong)  1000384
#define SID_C2D          (Ulong)  1000385
#define SID_C3D          (Ulong)  1000386
#define SID_FILTER       (Ulong)  1000387
#define SID_TRANSFORM    (Ulong)  1000388
#define SID_DISTORTION   (Ulong)  1000389
#define SID_RESEAU       (Ulong)  1000390
#define SID_GRID         (Ulong)  1000391
#define SID_TRIANGLE     (Ulong)  1000392
#define SID_CONTOURLINE  (Ulong)  1000393
#define SID_PROFILE      (Ulong)  1000394
#define SID_MASSPOINTS   (Ulong)  1000395
#define SID_CAMERA       (Ulong)  1000396
#define SID_DI           (Ulong)  1000397
#define SID_OI           (Ulong)  1000398
#define SID_DTM          (Ulong)  1000399
#define SID_PYRAMID      (Ulong)  1000400
#define SID_DTMC3D       (Ulong)  1000401
#define SID_DTMTRIANGLE  (Ulong)  1000402
#define SID_EPISTE       (Ulong)  1000403
#define SID_INTERIOR     (Ulong)  1000404
#define SID_EXTERIOR     (Ulong)  1000405
#define SID_EPI          (Ulong)  1000406
#define SID_PRJKEY       (Ulong)  1000407
#define SID_PRJMOD       (Ulong)  1000408
#define SID_PRJOP        (Ulong)  1000409
#define SID_PRJFNAM      (Ulong)  1000410
#define SID_CSYS         (Ulong)  1000411
#define SID_CLIST        (Ulong)  1000412

#define SID_SWCIMG       (Ulong)  1000500
#define SID_SWCMEM       (Ulong)  1000501
#define SID_SWCPOS       (Ulong)  1000502
#define SID_SWCPAR       (Ulong)  1000503

/* Structure identifiers (sid) */
/*     2000000 <=    PHODIS OP  < 3000000  */

/* Structure identifiers (sid) */
/*     3000000 <=    PHODIS ST  < 4000000  */

#define SID_OPWINDOW          (Ulong)3000001
#define SID_CLWINDOW          (Ulong)3000002
#define SID_STWINPAR          (Ulong)3000003
#define SID_REALIZWIN         (Ulong)3000004

#define SID_STREFPNT          (Ulong)3000011
#define SID_LDIMAGE           (Ulong)3000012
#define SID_FIXIMG            (Ulong)3000013

#define SID_STCORDISP         (Ulong)3000021
#define SID_STCURSOR          (Ulong)3000022
#define SID_CURPOS            (Ulong)3000023
#define SID_PROJECT           (Ulong)3000024
#define SID_NEWWSTYPE         (Ulong)3000025
#define SID_INQWSTYPE         (Ulong)3000026
#define SID_SYNCPNT           (Ulong)3000027
#define SID_PSTMODEL          (Ulong)3000028
#define SID_STINQCUR          (Ulong)3000029
#define SID_STINQGRA          (Ulong)3000030
#define SID_ZOOM              (Ulong)3000031
#define SID_MOVETO            (Ulong)3000032
#define SID_STEYEDIST         (Ulong)3000033
#define SID_CHCONTRST         (Ulong)3000034
#define SID_CHBRIGHTN         (Ulong)3000035
#define SID_ROTATEIMG         (Ulong)3000036
#define SID_MVMOVMOD          (Ulong)3000037
#define SID_STLWIDTH          (Ulong)3000038
#define SID_STSHIFT           (Ulong)3000039
#define SID_STGCOD            (Ulong)3000040
#define SID_SNDDEL            (Ulong)3000041
#define SID_PSTSCREEN         (Ulong)3000042
#define SID_NEWCOR            (Ulong)3000043
#define SID_STCRES            (Ulong)3000044
#define SID_STCMAP            (Ulong)3000045
#define SID_STALTMOD          (Ulong)3000046
#define SID_CHKINCON          (Ulong)3000047
#define SID_ACTPAR            (Ulong)3000048
#define SID_DEMOSTR           (Ulong)3000049

#define SID_STMOVMOD          (Ulong)3000051
#define SID_STVIEMOD          (Ulong)3000052
#define SID_STAUTOCORR        (Ulong)3000053

#define SID_UPWINPOS          (Ulong)3000061
#define SID_ERROR             (Ulong)3000062
#define SID_ERR_BUF           (Ulong)3000063
#define SID_NEWORIENT         (Ulong)3000064
#define SID_GETEVENT          (Ulong)3000065

#define SID_START             (Ulong)3000071
#define SID_END               (Ulong)3000072
#define SID_STAPPL            (Ulong)3000073
#define SID_CLEAR             (Ulong)3000074
#define SID_BREAK             (Ulong)3000075
#define SID_TERMCTR           (Ulong)3000076
#define SID_LOADMODEL         (Ulong)3000077
#define SID_LOADIMAGE         (Ulong)3000078
#define SID_LOADORIENT        (Ulong)3000079

#define SID_WINTAB            (Ulong)3000081
#define SID_LSTKEY            (Ulong)3000082
#define SID_LSTCHO            (Ulong)3000083
#define SID_LSTTBL            (Ulong)3000084
#define SID_REVCOD            (Ulong)3000085

#define SID_OPINPUT           (Ulong)3000091
#define SID_CLINPUT           (Ulong)3000092

#define SID_STRECPAR          (Ulong)3000101
#define SID_DEFKEY            (Ulong)3000102
#define SID_STEVENTMOD        (Ulong)3000103
#define SID_STCONFIG          (Ulong)3000104
#define SID_STCORTYP          (Ulong)3000105
#define SID_RELMOVE           (Ulong)3000106
#define SID_KEY               (Ulong)3000107

#define SID_CONNECT           (Ulong)3000111
#define SID_NEWGSHM           (Ulong)3000112
#define SID_IQGSHM            (Ulong)3000113
#define SID_IQGSHMK           (Ulong)3000114
#define SID_NEWGSHMK          (Ulong)3000115

/* Structure identifiers (sid) */
/*     4000000 <=    PHODIS SC  < 5000000  */

/* Structure identifiers (sid) */
/*     5000000 <=    PHODIS AT  < 6000000  */

/* Structure identifiers (sid) */
/*     6000000 <=    PHODIS AR  < 7000000  */

/*
** pyramid parameters
*/

#define PYRAEXT                 "pym"   /* default file extension */
#define PYMNUM                  9       /* max. number of pym levels */
#define PYMSTEP                 2       /* default step between pym levels */

#endif
