C  ******************************************************************
C  *                                                                *
C  *            *****     SUBROUTINE ccf_refine   *****             *
C  *                                                                *
C  ******************************************************************
	SUBROUTINE ccf_refine (IMG_ADDR, BKG, NCOL, NROW, DX, DY)
C
	IMPLICIT NONE
C
	INCLUDE 'em.cmm'
C
	COMMON /CCF_REFINE_COM/ RES_MIN, RES_MAX, X_SHIFT, Y_SHIFT
	INTEGER*4 BKG, FFT1_ADDR, FFT2_ADDR, NCOL, NROW
	INTEGER*4 IDIM1, IDIM2, ARRAY_SIZE, NPEAK, MPEAK, NLIM
	INTEGER*4 I, J, CC_MAP, FFT_NFAC
	INTEGER*2 IMG_ADDR(1)
	PARAMETER (NLIM=5000)
	REAL*4    PEAKS (3,NLIM)
	REAL*4    RES_MIN, RES_MAX, RES_TMP1, RES_TMP2
	REAL*4    X_SHIFT, Y_SHIFT
	REAL*4    MIN_OLD, MAX_OLD
	integer*4  DX, DY
C  ----------------------------------------------------------------------------
C
	FFT_NFAC = 1		    
	FFT_ORIGX  = NCOL/2
	FFT_ORIGY  = NROW/2
	CALL FFT_SETDIM_DEF_SAME (NCOL,NROW,IDIM1,IDIM2,FFT_NFAC)
	CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT1_ADDR)
	CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT2_ADDR)
C	write(6, *) IDIM1,IDIM2, FFT1_ADDR, FFT2_ADDR
C       ************************************************************
C------*    SET CORRELATION RESOLUTION LIMITS: RES_MIN,RES_MAX    *
C       ************************************************************
C	RES_TMP1 = 0 
C	RES_TMP2 = SQRT(FLOAT(IDIM1/(2*FFT_NFAC))**2.0 +
C	1                  FLOAT(IDIM2/(2*FFT_NFAC))**2.0)
C	write(6,*) "res_tmp2 is:", res_tmp2
C	RES_MIN = RES_TMP1*FFT_NFAC
C	RES_MAX = RES_TMP2*FFT_NFAC/2
        RES_MIN = 1
        RES_MAX = 15 
C
C	SET IMAGE REFERENCE CENTER 
C
	X_SHIFT = 0 
	Y_SHIFT = 0 
C
C	PRINT *, ' '
C	PRINT *, '*****************************************'
C	PRINT *, '* Fourier transform first IMAGE         *'
C	PRINT *, '*****************************************'
C
	IMG_BKG = BKG
	CALL IMG_FFT_FILL (IMG_ADDR, NCOL, NROW,
	1                  %VAL(FFT1_ADDR), IDIM1, IDIM2)
	CALL FFT_2D (%VAL(FFT1_ADDR), IDIM1, IDIM2)
C
C	PRINT *, '*****************************************'
C	PRINT *, '* Fourier transform rotated IMAGE       *'
C	PRINT *, '*****************************************'
C
	ARRAY_SIZE = 2*IDIM1*IDIM2                        ! # LONG WORDS
	CALL COPY_R4 (%VAL(FFT1_ADDR), %VAL(FFT2_ADDR), ARRAY_SIZE)
	FFT_FULL = .TRUE.
	CALL FFT_FLIP (%VAL(FFT2_ADDR), IDIM1, IDIM2)
	X_SHIFT = FLOAT (IDIM1 - NCOL + 1)
	Y_SHIFT = FLOAT (IDIM2 - NROW + 1)
	CALL FFT_PSHIFT (%VAL(FFT2_ADDR), IDIM1, IDIM2, X_SHIFT, Y_SHIFT)
C
C	PRINT *, '*****************************************'
C	PRINT *, '* Compute the cross-correlation pattern *'
C	PRINT *, '*****************************************'
	CALL LIB$GET_VM (4*IDIM1*IDIM2, CC_MAP)
	CALL CCF_FFT (%VAL(FFT1_ADDR), %VAL(FFT2_ADDR), %VAL(CC_MAP),
	1             IDIM1, IDIM2, RES_MIN, RES_MAX)
	MIN_OLD = MAP_MIN
	MAX_OLD = MAP_MAX
	CALL MAP_SCALE (1, %VAL(CC_MAP), IDIM1, IDIM2, 1, MIN_OLD,
	1               MAX_OLD, 1.0, 255.0)
C
	CALL MAP_PEAKSEARCH (%VAL(CC_MAP), IDIM1, IDIM2, PEAKS, NLIM,
	1                    NPEAK, 230.0)
	CALL PEAK_SORT_HI (PEAKS, NPEAK)
	CALL PEAK_CHK  (PEAKS, NPEAK, MPEAK, 1.5)
	CALL PEAK_SORT_HI (PEAKS, NPEAK)
  800	CALL ccf_refine_peak (%VAL(CC_MAP), IDIM1, IDIM2, PEAKS, NPEAK, 
	1 X_SHIFT, Y_SHIFT, DX, DY )
C
	CALL LIB$FREE_VM (8*IDIM1*IDIM2, FFT1_ADDR)
	CALL LIB$FREE_VM (8*IDIM1*IDIM2, FFT2_ADDR)
	CALL LIB$FREE_VM (4*IDIM1*IDIM2, CC_MAP)
	RETURN
C
	END
C  ******************************************************************
C  *                                                                *
C  *            *****  SUBROUTINE ref_ccf_refine  *****             *
C  *                                                                *
C  ******************************************************************
	SUBROUTINE ref_ccf_refine (REF_FFT_ADDR, IMG_ADDR, BKG, 
	1			   NCOL, NROW, IDIM1, IDIM2, DX, DY)
C
	IMPLICIT NONE
C
	INCLUDE 'em.cmm'
C
	COMMON /CCF_REFINE_COM/ RES_MIN, RES_MAX, X_SHIFT, Y_SHIFT
	INTEGER*4 BKG, FFT_ADDR, NCOL, NROW
	INTEGER*4 IDIM1, IDIM2, ARRAY_SIZE, NPEAK, MPEAK, NLIM
	INTEGER*4 I, J, CC_MAP, FFT_NFAC
	INTEGER*2 IMG_ADDR(1)
	REAL*4    REF_FFT_ADDR(1)
	PARAMETER (NLIM=5000)
	REAL*4    PEAKS (3,NLIM)
	REAL*4    RES_MIN, RES_MAX, RES_TMP1, RES_TMP2
	REAL*4    X_SHIFT, Y_SHIFT
	REAL*4    MIN_OLD, MAX_OLD
	integer*4  DX, DY
C  ----------------------------------------------------------------------
C
	FFT_NFAC = 1		    
	FFT_ORIGX  = NCOL/2 
	FFT_ORIGY  = NROW/2 
	CALL LIB$GET_VM (8*IDIM1*IDIM2, FFT_ADDR)
C
C       ************************************************************
C------*    SET CORRELATION RESOLUTION LIMITS: RES_MIN,RES_MAX    *
C       ************************************************************
C	RES_TMP1 = 0 
C	RES_TMP2 = SQRT(FLOAT(IDIM1/(2*FFT_NFAC))**2.0 +
C	1                  FLOAT(IDIM2/(2*FFT_NFAC))**2.0)
C	write(6,*) "res_tmp2 is:", res_tmp2
C	RES_MIN = RES_TMP1*FFT_NFAC
C	RES_MAX = RES_TMP2*FFT_NFAC/2
        RES_MIN = 1
        RES_MAX = 15 
C
C	SET IMAGE REFERENCE CENTER 
C
	X_SHIFT = 0 
	Y_SHIFT = 0 
C
C	PRINT *, ' '
C	PRINT *, '********************************************'
C	PRINT *, '* Fourier transform current particle IMAGE *'
C	PRINT *, '********************************************'
	IMG_BKG = BKG
	CALL IMG_FFT_FILL (IMG_ADDR, NCOL, NROW,
	1                  %VAL(FFT_ADDR), IDIM1, IDIM2)
C
	CALL FFT_2D (%VAL(FFT_ADDR), IDIM1, IDIM2)
C
	ARRAY_SIZE = 2*IDIM1*IDIM2                           ! # LONG WORDS
	FFT_FULL = .TRUE.
C
C	PRINT *, '************************************************'
C	PRINT *, '* Compute the cross-correlation with reference *'
C	PRINT *, '************************************************'
	CALL LIB$GET_VM (4*IDIM1*IDIM2, CC_MAP)
	CALL CCF_FFT (%VAL(FFT_ADDR), REF_FFT_ADDR, %VAL(CC_MAP),
	1             IDIM1, IDIM2, RES_MIN, RES_MAX)
	MIN_OLD = MAP_MIN
	MAX_OLD = MAP_MAX
	CALL MAP_SCALE (1, %VAL(CC_MAP), IDIM1, IDIM2, 1, MIN_OLD,
	1               MAX_OLD, 1.0, 255.0)
C
	CALL MAP_PEAKSEARCH (%VAL(CC_MAP), IDIM1, IDIM2, PEAKS, NLIM,
	1                    NPEAK, 230.0)
	CALL PEAK_SORT_HI (PEAKS, NPEAK)
	CALL PEAK_CHK  (PEAKS, NPEAK, MPEAK, 1.5)
	CALL PEAK_SORT_HI (PEAKS, NPEAK)
  800	CALL ccf_refine_peak (%VAL(CC_MAP), IDIM1, IDIM2, PEAKS, NPEAK, 
	1 X_SHIFT, Y_SHIFT, DX, DY )
C
	CALL LIB$FREE_VM (8*IDIM1*IDIM2, FFT_ADDR)
	CALL LIB$FREE_VM (4*IDIM1*IDIM2, CC_MAP)
	RETURN
C
	END

C  ******************************************************************
C  *                                                                *
C  *          *****     SUBROUTINE ccf_refine_peak     *****        *
C  *                                                                *
C  *    SUBROUTINE TO compute CORRELATION MAP PEAK ARRAY            *
C  ******************************************************************
C
	SUBROUTINE ccf_refine_peak (CC_MAP, NCOL, NROW, PEAKS, NPEAK, 
	1 X_SHIFT, Y_SHIFT, DX, DY)
C
	IMPLICIT NONE
C
	INCLUDE 'em.cmm'
C
	INTEGER*4 NLIM, NPEAK, IX, IY
	INTEGER*4 NCOL, NROW, DX, DY
	INTEGER*2 I, J, IMG(15,15)
	INTEGER*2 IPEAKX, IPEAKY
	REAL*4    AMPS(15,15)
	REAL*4    PEAKS(3,NPEAK), HALFX, HALFY, CC_MAP(NCOL,NROW)
	REAL*4    PEAKX, PEAKY
	REAL*4    X_SHIFT, Y_SHIFT
C  ----------------------------------------------------------------------------
C
  100	HALFX   = FLOAT(NCOL)/2.0
	HALFY   = FLOAT(NROW)/2.0
	IPEAKX = NINT(PEAKS(1,1)) - 1
	IPEAKY = NINT(PEAKS(2,1)) - 1
	IF(IPEAKX.GT.INT(HALFX)) IPEAKX = IPEAKX - NCOL
	IF(IPEAKY.GT.INT(HALFY)) IPEAKY = IPEAKY - NROW
	DX = -NINT(IPEAKX/2.0)
	DY = -NINT(IPEAKY/2.0)
C	WRITE(6,'('' The central point should shift: '',
C	1 2I5)') DX, DY
	RETURN
	END
C
C  ******************************************************************
C  *                                                                *
C  *            *****  SUBROUTINE fft_avg_ref  *****                *
C  *                                                                *
C  ******************************************************************
	SUBROUTINE fft_avg_ref (REF_IMG_ADDR, REF_FFT_ADDR, 
	1			REF_BKG, NCOL, NROW, IDIM1, IDIM2)
C	
	IMPLICIT NONE
C
	INCLUDE 'em.cmm'
C
	INTEGER*4 FFT_NFAC, IDIM1,IDIM2, REF_BKG, NCOL, NROW
	INTEGER*2 REF_IMG_ADDR(1) 
 	REAL*4    REF_FFT_ADDR(1)
C------------------------------------------------------------------
	FFT_NFAC = 1
	FFT_ORIGX  = NCOL/2
	FFT_ORIGY  = NROW/2
	CALL FFT_SETDIM_DEF_SAME (NCOL,NROW,IDIM1,IDIM2,FFT_NFAC)
C
C       PRINT *, '*******************************************'
C       PRINT *, '* Fourier transform reference IMAGE       *'
C       PRINT *, '*******************************************'
	IMG_BKG = REF_BKG
	CALL IMG_FFT_FILL (REF_IMG_ADDR, NCOL, NROW,
	1		   REF_FFT_ADDR, IDIM1, IDIM2)
	CALL FFT_2D (REF_FFT_ADDR, IDIM1, IDIM2)
C
	RETURN
C
	END
C






