#include <stdio.h>
#include <math.h>
#include "fitutil.h"
void mrqmin(int x[], double y[], double sig[], double a[], int ia[],
	int ma, double **covar, double **alpha, double *chisq,
	void (*funcs)(int, int, double [], double *, double [], int, int, int, double,
	int, double, double, double), 
	double *alamda, int num_gauss_bkg, int num_gauss_ctf, double wavelength,
	int idim_half, double res_hi, double A, double Cs, double pixel_size)
/*program: Numerical Recipe in C, p687
  modified by Wei Zhang, pass more paramerters and change float into double*/
{
  int j, k, l;
  static int mfit;
  static double ochisq, *atry, *beta, *da, **oneda;


  if (*alamda < 0.0) {
    atry=(double *) malloc (ma * sizeof(double ));
    beta=(double *) malloc (ma * sizeof(double ));
    da  =(double *) malloc (ma * sizeof(double ));
    for (mfit=0,j=0;j<ma;j++)
      if (ia[j]) mfit++;
    oneda=(double **) malloc ( mfit * sizeof(double ));
    oneda[0] = (double *) malloc (mfit* sizeof(double ));
    for (j=1; j<mfit; j++) oneda[j] = oneda[j-1] + 1 ;

    *alamda=0.001;      
    mrqcof(x,y,sig,a,ia,ma,alpha,beta,chisq,funcs,num_gauss_bkg,num_gauss_ctf,
           wavelength, idim_half, res_hi, A, Cs, pixel_size);
    ochisq=(*chisq);
    for(j=0;j<ma;j++) atry[j]=a[j];
  }

  for (j=0;j<mfit;j++) {
    for (k=0;k<mfit;k++) covar[j][k]=alpha[j][k];
    covar[j][j]=alpha[j][j]*(1.0+(*alamda));
    oneda[j][0]=beta[j];
  }

  gaussj(covar, mfit, oneda, 1);

  for (j=0;j<mfit;j++) da[j]=oneda[j][0];
  if (*alamda == 0.0) {
    covsrt(covar, ma, ia, mfit);
    free(oneda[0]);
    free(oneda);
    free(da);
    free(atry);
    return;
  }
  for (j=0, l=0; l<ma; l++)
    if(ia[l]) atry[l]=a[l]+da[j++];

  mrqcof(x,y,sig,atry,ia,ma,covar,da,chisq,funcs,num_gauss_bkg,num_gauss_ctf,
         wavelength, idim_half, res_hi, A, Cs, pixel_size);
  if(*chisq<ochisq) {
    *alamda *= 0.1;
    ochisq=(*chisq);
    for (j=0;j<mfit; j++) {
      for (k=0;k<mfit;k++) alpha[j][k]=covar[j][k];
      beta[j]=da[j];
    }
    for(l=0;l<ma;l++) a[l]=atry[l];
  } else {
    *alamda *= 10.0;
    *chisq=ochisq;
  }
 
}
