C **********************************************************************
C *              *****     SUBROUTINE D_STATS     *****                *
C *                                                                    *
C *    ROUTINE TO DETERMINE THE MIN/MAX, AVERAGE AND STD FOR VALUES    *
C *     IN THE "FFT" real ARRAY.                                       *
C *    the array is (0:hkl_max, -hkl_max:hkl_max) of real              *
C **********************************************************************

      SUBROUTINE  D_STATS( fftavg, hkl_max, MAP_AVG, MAP_STD, 
     +                     CA1D_AVG, CA1D_STD)
C
      IMPLICIT NONE
      include '../include/vax_minmax.inc'
C
Cji  arguments
      integer hkl_max
      real fftavg(0:hkl_max, -hkl_max:hkl_max)    
      double precision  CA1D_AVG(hkl_max), CA1D_STD(hkl_max)
      real MAP_STD, MAP_AVG
C
Cji local 
      REAL MAP_MIN, MAP_MAX, R, X, PNT, VAR
      REAL  CA1D_CNT(hkl_max)
      INTEGER  I, J, RI, array_size
      double precision TOT, SUMSQ
C
       MAP_MIN  = R4_MAX
       MAP_MAX  = R4_MIN
       SUMSQ    = 0.0
       TOT      = 0.0
C
       DO I = 1, hkl_max
         CA1D_AVG(I) = 0.0
         CA1D_STD(I) = 0.0
         CA1D_CNT(I) = 0.0
       ENDDO
C
       DO I = 0, hkl_max
         DO J = - hkl_max, hkl_max
           X       = fftavg(I, J)
           SUMSQ   = SUMSQ + X**2
           TOT     = TOT + X
           MAP_MIN = AMIN1(MAP_MIN,X)
           MAP_MAX = AMAX1(MAP_MAX,X)

           R  = SQRT (float(I*I + J*J))
           RI = int(R)
C        
           IF ((RI.LT.hkl_max).AND.(RI.NE.0)) THEN

             PNT = 1.0 - (R - RI)
             CA1D_AVG(RI) = CA1D_AVG(RI) + X*PNT
             CA1D_CNT(RI) = CA1D_CNT(RI) + PNT
             CA1D_STD(RI) = CA1D_STD(RI) + X*X*PNT
             CA1D_AVG(RI+1) = CA1D_AVG(RI+1) + X*(1.0-PNT)
             CA1D_CNT(RI+1) = CA1D_CNT(RI+1) + 1.0 - PNT
             CA1D_STD(RI+1) = CA1D_STD(RI+1) + X*X*(1.0-PNT)
           elseif (RI.EQ.hkl_max) THEN
C        
             PNT = 1.0 - (R - RI)
             CA1D_AVG(RI) = CA1D_AVG(RI) + X*PNT
             CA1D_CNT(RI) = CA1D_CNT(RI) + PNT
             CA1D_STD(RI) = CA1D_STD(RI) + X*X*PNT
           ENDIF
C       
         ENDDO
       ENDDO
C
       ARRAY_SIZE= (hkl_max +1)*(2*hkl_max + 1)
       MAP_AVG = TOT/FLOAT(ARRAY_SIZE)
       MAP_STD = 0.0
       VAR     = (SUMSQ/FLOAT(ARRAY_SIZE))-(MAP_AVG*MAP_AVG)
       IF(VAR.GE.0.0) MAP_STD = SQRT(VAR)
       WRITE(*,1000)
       WRITE(*,1001)
 1000  FORMAT('                  STATICS: averaged FFT')
 1001  FORMAT('FFTSIZE   MINIMUM     MAXIMUM        AVERAGE        STD',
     1 /,' ------------------------------------------------------',/)
C
       WRITE(*,*)hkl_max, MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
c
       DO I = 1, hkl_max
         CA1D_AVG(I)=CA1D_AVG(I)/CA1D_CNT(I)
         CA1D_STD(I)=CA1D_STD(I)/CA1D_CNT(I)
         CA1D_STD(I)=CA1D_STD(I)-CA1D_AVG(I)*CA1D_AVG(I)
         IF(CA1D_STD(I).GE.0.0) THEN
           CA1D_STD(I)= SQRT (CA1D_STD(I))
         ELSE
           PRINT *, 'CHECK YOUR DATA!'
         ENDIF
C
         CA1D_AVG(I) = CA1D_AVG(I)/map_avg
         CA1D_STD(I) = CA1D_STD(I)/map_avg
Cji         WRITE(LUN_CA1D,*)I, CA1D(I)/map_avg, CA1D_STD(I)/map_avg
         print *, I, CA1D_AVG(I), CA1D_STD(I)
C
       ENDDO
C
      return
      end
