
#include "fitutil.h"

void mrqcof(double x[], double y[], double sig[], int ndata, double a[], int ia[],
  int ma, double **alpha, double beta[], double *chisq,
  void (*funcs)(double, double [], double *, double [], int, int, int, double, int, 
  double, double, double),
  int num_gauss_bkg, int num_gauss_ctf, double wavelength, int idim_half, double A,
  double Cs, double pixel_size)
 
  /* Used by mrqmin to evaluate the linearized fitting matrix alpha, and vector 
     beta and calculate chi square 
     
     program: Numerical Recipe in C, p686
     modified by Wei Zhang, pass more parameters and change float into double*/ 
{
  int i, j, k, l, m, mfit;
  double ymod, wt, sig2i, dy, *dyda;
  
  dyda=(double *) malloc (ma * sizeof(double));
  mfit = 0;
  for (j=0;j<ma;j++)
      if(ia[j]) mfit++;
  for(j=0;j<mfit;j++) {
      for (k=0;k<=j;k++) alpha[j][k]=0.0;
      beta[j]=0.0;
  }
  *chisq=0.0;
  for (i=0;i<ndata; i++) { 
    (*funcs)(x[i],a,&ymod,dyda,ma, num_gauss_bkg, num_gauss_ctf, wavelength, idim_half,
      A, Cs, pixel_size);    
    sig2i=1.0/(sig[i]*sig[i]);    
    dy=y[i]-ymod;
    for (j=-1,l=0;l<ma;l++) {
       if (ia[l]) {
         wt=dyda[l]*sig2i;
         for (j++,k=0,m=0;m<=l;m++)
           if(ia[m]) alpha[j][k++]+=wt*dyda[m];
         beta[j] += dy*wt;
       }
     }
     *chisq +=dy*dy*sig2i;
  }
  for (j=1;j<mfit;j++)
     for (k=0;k<j; k++) alpha[k][j]=alpha[j][k];

  free(dyda);
}
