       subroutine exch_intp(hkl_min,hkl_max,intpl,f_hkl_ref,f_hkl)
C
Cji *******************************************************************
Cji Subroutine exch_intp used in cmpt_intrps
Cji Created by Yongchang Ji
Cji Function: exchange the data in f_hkl_ref and store in f_hkl 
C * Input:                                                        *
C *   hkl_min (Integer) -- The minimum index of HKL space.        *
C *   hkl_max (Integer) -- The maximum index of HKL space.        *
C *   f_hkl_ref (complex)    -- the whole result of interpolation 
C * Output:           
C *   f_hkl --- the result of interpolation of each slab
C *  
C *   - Yongchang Ji, Final Version, Aug.2000 -- Jan. 2002             *
C
Cji *******************************************************************
      implicit none
C
      include 'mpif.h'
      include '../include/allprogs.inc'

C Arguments
C
      integer  hkl_min, hkl_max
      
      real     intpl( hkl_min:hkl_max, hkl_min:hkl_max, 
     +                  0:hkl_max )
      complex  f_hkl_ref( hkl_min:hkl_max, hkl_min:hkl_max, 
     +                    0:hkl_max )
      complex  f_hkl( hkl_min:hkl_max, hkl_min:hkl_max,
     +                frst_lst_iq(1,iam):frst_lst_iq(2,iam))
C -----------------------------------------------------------------
C Local
      integer  il, ik, ih, nod, count
      real     ctfval1( hkl_min:hkl_max, hkl_min:hkl_max,
     +                frst_lst_iq(1,iam):frst_lst_iq(2,iam))
C -----------------------------------------------------------------
      do nod = 0, num_nodes-1
        count = (hkl_max - hkl_min +1)**2 * 
     +          (frst_lst_iq(2,nod) - frst_lst_iq(1,nod) + 1)
        call mpi_reduce(f_hkl_ref(hkl_min,hkl_min,frst_lst_iq(1,nod)),
     +                f_hkl, count, MPI_COMPLEX, MPI_SUM, nod, 
     +                mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,'exch_intp',
     +     'Error in calling MPI_reduce')
C
        call mpi_reduce(intpl(hkl_min,hkl_min,frst_lst_iq(1,nod)),
     +                ctfval1, count, MPI_REAL, MPI_SUM, nod, 
     +                mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,'exch_intp',
     +     'Error in calling MPI_reduce')
      enddo
C
      do il = frst_lst_iq(1,iam),frst_lst_iq(2,iam) 
        do ik = hkl_min, hkl_max
          do ih = hkl_min, hkl_max
            if (ctfval1(ih,ik,il).gt.0.0) then 
              f_hkl(ih,ik,il) = f_hkl(ih,ik,il) / ctfval1(ih,ik,il)
            else 
              f_hkl(ih,ik,il) = 0.0
            endif
          enddo
        enddo
      enddo

      return
      end
