      Subroutine cmpt_ort(fft_klh,  pixels_array, hkl_min,
     +             hkl_max, t_analy, t_fftanaly, 
     +             mem_cmpt, total_views , ctf_val, ctf2, disef, 
     +             fno, ca_index, ca_table, ca_len)
C **********************************************************************
      implicit none
C
      include 'mpif.h'
      include '../include/allprogs.inc'
      include '../include/info.inc'
      include '../include/com_01.inc'
      include '../include/vax_minmax.inc'
C 
C Arguments
C
      integer hkl_min,hkl_max, total_views, fno
Cji      complex fft_klh( hkl_min:hkl_max, hkl_min:hkl_max,
Cji     +               frst_lst_iq(1,iam):frst_lst_iq(2,iam) ) 
      complex fft_klh( hkl_min:hkl_max, hkl_min:hkl_max, 0:hkl_max)
      real    pixels_array(npix_row, npix_col, view_perread)
      real    ctf_val( (nfc_2d_row+1)* (2*nfc_2d_col+1) )
      real    ctf2( 0:nfc_2d_row, -nfc_2d_col:nfc_2d_col )
      real    disef( 0:nfc_2d_row, -nfc_2d_col:nfc_2d_col )
      double precision mem_cmpt, t_analy, t_fftanaly
      integer ca_len
      real*4  ca_index(4,ca_len)
      COMPLEX ca_table( (1+nfc_2d_row)*(1+2*nfc_2d_col), ca_len)
C Local
      integer view, symm, i, j, k, cc, max_node_eq, num_hkl
      integer mem_size, start_view, end_view, last_node,
     +        num_views, tmp_row, tmp_col, radius
      integer theta, phi, omega, ort_out, viewno, centeru, centerv
      integer min_angles(1:3), sendcount(0:num_nodes),
     +        disp(0:num_nodes), minu, minv
C 
      real    angles_rad(1:3),angles_deg(1:3),center(1:2),imgmagfactor,
     +        num_annulus,value,min_value, min_annul, min_cannul
     +        , du, dv, dr, fftscalfac, tmpomega, tmpomega2, tmpannul
      real    rot_mat(1:3,1:3), 
     +        dist(-Nangle:Nangle,-Nangle:Nangle,-Nangle:Nangle),
     +     distcen(-Ncenter:Ncenter,-Ncenter:Ncenter,-Ncenter:Ncenter)
      real    orient(0:6, max_views), rffta_omega(1), rffta(1), 
     +        rffta_trns(1), orient_new(0:7, max_views/num_nodes+1)
     +        , orient_out(0:7, max_views)
C 
      complex fc_2d((1+nfc_2d_row)*(1+2*nfc_2d_col),-Nangle:Nangle)
     +        , fc_2d_intp((1+nfc_2d_row)*(1+2*nfc_2d_col))
     +        , fc_2d_bak((1+nfc_2d_row)*(1+2*nfc_2d_col))
C
C     Pointer variables
C
      pointer ( pnt_rffta_omega, rffta_omega )
      pointer ( pnt_rffta,       rffta       )
      pointer ( pnt_rffta_trns,  rffta_trns  )
C
      double precision wtime, t1, t2, time,
     +       mem_orient, mem_pixels, mem_rffta_omega, mem_rffta,
     +       mem_rffta_trns, mem_ico_x, mem_ico_y, mem_ico_z,
     +       mem_ico_x_ref, mem_ico_y_ref, mem_ico_z_ref,
     +       mem_ico_x_original, mem_ico_y_original,
     +       mem_ico_z_original, mem_fc_2d
      data   mem_orient / 0.0D0 /, mem_pixels / 0.0D0 /, 
     +       mem_rffta_omega / 0.0D0 /, mem_rffta / 0.0D0 /,
     +       mem_rffta_trns / 0.0D0 /, mem_ico_x / 0.0D0 /,
     +       mem_ico_y / 0.0D0 /, mem_ico_z / 0.0D0 /,
     +       mem_ico_x_ref / 0.0D0 /, mem_ico_y_ref / 0.0D0 /,
     +       mem_ico_z_ref / 0.0D0 /, mem_ico_x_original / 0.0D0 /,
     +       mem_ico_y_original / 0.0D0 /, mem_ico_z_original / 0.0D0 /,
     +       mem_fc_2d / 0.0D0 /
C      
      character*12 subname
      character*64 fname
      data subname/ 'cmpt_ort' /
C 
      integer cmalloc
C
C ----------------------------------------------------------------------
C
C     Allocate storage for subroutine FFTANALY
C
      pnt_rffta_omega = cmalloc( 4 * nrffta_omega )
      mem_rffta_omega = dble(4 * nrffta_omega)
      mem_size        = nrffta_row * nrffta_col
      pnt_rffta       = cmalloc( 4 * mem_size )
      pnt_rffta_trns  = cmalloc( 4 * mem_size )
      mem_rffta       = dble( 4 * mem_size )
      mem_rffta_trns  = dble( 4 * mem_size )

      mem_orient      = dble(4*8*max_views)
      mem_size        = ( 1 + nfc_2d_row ) * ( 1 + 2 * nfc_2d_col )
      mem_fc_2d       = dble( (2*Nangle+3) * mem_size )

      mem_cmpt = 3*mem_orient + mem_rffta_omega + 
     +    mem_rffta + mem_rffta_trns + mem_fc_2d
     +    + (2*Nangle+1)*(2*Nangle+1)*(2*Nangle+1)
     +    + (2*Ncenter+1)*(2*Ncenter+1)*(2*Ncenter+1)
C
      if(( pnt_rffta_omega .eq. 0 ) .or.
     +    ( pnt_rffta       .eq. 0 ) .or.
     +    ( pnt_rffta_trns  .eq. 0 ) ) then
        print 9000, subname, pnt_rffta_omega, pnt_rffta,
     +              pnt_rffta_trns
 9000   format(/' Memory allocation failed in >> ',a,' <<'/
     +          '  PNT_PIXELS      =', i15/
     +          '  PNT_RFFTA_OMEGA =', i15/
     +          '  PNT_RFFTA       =', i15/
     +          '  PNT_RFFTA_TRNS  =', i15)
        call error_stop (progname, subname, ' Memory allocation failed')
      endif
C
Cji   to initialize the value of rffta_omega(nrfft_col+15)
Cji   that is rffta_omega(nrffta_omega)
C       Initialize the FFT parameters used to transform rows of RFFTA
C       each row has length NRFFTA_COL
C
      call vrffti( nrffta_col, rffta_omega )
C
C ----------------------------------------------------------------------
      num_views = 0 
      viewno = 0 
      t1 = wtime()
C
      if( iam .eq. 0 ) then
C                                                        CALL READORIENT
C                                                        ***************
        call readorient(orient, max_views, ort_file_name, num_views,
     +                  npix_row, npix_col)
C
        write(stdoutput,1001) iam, ort_file_name, num_views, max_views
 1001   format(/' Node = ',i2,':  Read orientation file: ',a/,
     +    12x,' Number of views     = ', i9, i9)
C
Cji     write out new ort file head
        call increment_fname(ort_file_name, ort_out_name)
        ort_out = 11
        OPEN (UNIT=ort_out, FILE=ort_out_name)
        WRITE(ort_out,'(A)') pix_file_name
        WRITE(ort_out,1010) PIXSIZS(fno), units, VOLTS(fno), 
     +        AMPFACS(fno), DELF_MAJS(fno), DELF_MINS(fno), 
     +        ANG_MAJS(fno), CS_COEFFS(fno)
 1010   FORMAT (1X,F8.4,',',I2,',',F10.1,',',4(F10.4,','),F8.2) 
C
      endif
C
      if( num_nodes .gt. 1 ) then
C                                                        ***************
	call mpi_bcast(num_views, 1, mpi_integer,
     +                 0, mpi_comm_world, mpi_err)
	if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_BCAST num_views')

	call mpi_bcast(orient, 7*max_views, mpi_real,
     +                 0, mpi_comm_world, mpi_err)
	if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_BCAST orient')
C
      endif

      t2 = wtime()
      time = t2 - t1
      t_analy = t_analy + time
C
      total_views = total_views + num_views
C
      num_annulus = float(nrffta_row)*angstrom_per_pix/res_max 
      min_annul = float(nrffta_row)*angstrom_per_pix/res_min 
C
Cji   I just give the min annuals for center refine at 200A
Cji   but I didn't use this min_cannul when I refine center
      min_cannul = float(nrffta_row)*angstrom_per_pix/200
C
      if (num_annulus .ge. nrffta_row/2.) 
     +     call error_stop(progname,subname, 
     +     'Resolution is too high, smaller than 2*angstrom_per_pix')
      if (iam.eq.0) then
        print *,min_annul,num_annulus,Dangle,Nangle,Dcenter,Ncenter
      endif
C
Cji  we seperate all the views by view_perread, 
Cji  each time we read at most view_perread * num_nodes pixels and deal with them

      DO 1200 j = 0, (num_views-1)/(view_perread*num_nodes)
C 
        t1 = wtime()
C
        start_view = 1 + j * view_perread*num_nodes
        end_view   = start_view + view_perread*num_nodes - 1
        if (end_view .gt. num_views) end_view = num_views
C
Cji     the pix_file_name has been opened in aamain
Cji       Read the current end_view-start_view+1 pixel frames.
C
        call set_indices(num_nodes, start_view, end_view,
     +         frst_lst_view, max_node_eq )
C                                                        CALL READ_FILES
C                                                        ***************
Cji  processor 0 read pixels_array, then send to processor i
        do i = num_nodes - 1 , 0 , -1
           if (frst_lst_view(2, i) .GE. frst_lst_view(1, i)) then
             call read_files(pixels_array, frst_lst_view(1,i),
     +               frst_lst_view(2,i), i, orient)
           endif
        enddo
C
        t2 = wtime()
        time = t2 - t1
        t_analy = t_analy + time
C
Cji      do with each view and pixel in  per read
C
      start_view = frst_lst_view(1,iam)
      end_view   = frst_lst_view(2,iam)

      if (start_view .GT. end_view) goto 1151
      do 1150 view = start_view, end_view
C
C       Get the orientation angles and center of next pixel frame
C       Also changes OMEGA from the range (0,360) deg to (-90,270) deg.
C       Because the orient used by BIO not consistent with defination 
C                                                         CALL GETORIENT
C                                                         **************
        call getorient( orient, max_views, view,
     +     angles_rad, angles_deg, center, imgmagfactor)
C
C------------------------------------------------------------
C       Compute Discrete Fourier Transform of pixel values:
C                                                          CALL FFTANALY
C                                                          *************
        t1 = wtime()
C
        call fftanaly( npix_row, npix_col,
     +           pixels_array(1, 1, view-start_view+1), center,
     +           nrffta_omega, rffta_omega, nrffta_row, 
     +           nrffta_col, rffta, rffta_trns, nfc_2d_row, 
     +           nfc_2d_col, fc_2d_bak )
C
Cji ctf correction
C 
        IF(CTFMODE.GT.0 .and. CTFMODE.LE.4)  then
          do tmp_row = 1, ( 1 + nfc_2d_row ) * ( 1 + 2 * nfc_2d_col ) 
            fc_2d_bak(tmp_row) = fc_2d_bak(tmp_row) * ctf_val(tmp_row)
          enddo
        endif
C
C------------------------------------------------------------
Cji begin test, to print out the amplitude and phase of the FFT 2D space
Cji        call outimg(fc_2d_bak,-nfc_2d_col,nfc_2d_row,
Cji     +              'fc_2d_bak.amp ','fc_2d_bak.pha ')
Cji        stop
Cji end of test
C------------------------------------------------------------
C
        radius = ifix(num_annulus)+1
        tmpannul = float(nfc_2d_row)
        tmpomega  = angles_deg(3)
C
C------------------------------------------------------------
Cji  if we uncomment the CCCC
Cji  it will calculate the scalfactor in FFT domain which used for imgmagfactor
        tmpomega2 = - tmpomega
        call rotateomega(fc_2d_bak, nfc_2d_row, nfc_2d_col, 
     +                   fc_2d(1,0), tmpomega2, tmpannul)
        angles_rad(1)= angles_deg(1)*deg_to_rad
        angles_rad(2)= angles_deg(2)*deg_to_rad
        angles_rad(3)= -(0.+90.)*deg_to_rad
C
Cji     add wrapper to cache cuts
        call interplwrap(fft_klh, hkl_min, hkl_max, hkl_max,
     +                   fc_2d_intp, imgmagfactor, angles_rad,
     +                   ca_index, ca_table, ca_len)
Cji        call setrotmat( angles_rad, rot_mat)
Cji        call interpl_3d(fft_klh, hkl_min, hkl_max, radius,
Cji     +                 rot_mat, fc_2d_intp, imgmagfactor)
        call imgcompfac(fc_2d(1,0), hkl_min, hkl_max,
     +                  fc_2d_intp, fftscalfac)
        print *, iam, 'image / cut fftscalfac:', fftscalfac
Cji apply the scalfactor in FFT domain 
        do tmp_row = 1, ( 1 + nfc_2d_row ) * ( 1 + 2 * nfc_2d_col ) 
          fc_2d_bak(tmp_row) = fc_2d_bak(tmp_row) / fftscalfac
        enddo
C
C------------------------------------------------------------
        t2 = wtime()
        time = t2 - t1
        t_fftanaly = t_fftanaly + time
C
Cji rotate omega get projection [-Nangle, Nangle]
        do omega = -Nangle, Nangle
          tmpomega2 = - (tmpomega + Dangle*omega)
          call rotateomega(fc_2d_bak, nfc_2d_row, nfc_2d_col, 
     +                     fc_2d(1,omega), tmpomega2, tmpannul)
        enddo
C
        do theta = -Nangle, Nangle
          do phi   = -Nangle, Nangle
            do omega = -Nangle, Nangle
              dist(theta,phi,omega) = R4_MAX
            enddo
          enddo
        enddo
C
Cji loop to refine orientation
C
        min_value = R4_MAX
 1110   min_angles(1) = 0
        min_angles(2) = 0
        min_angles(3) = 0
C
        if (Nangle .eq. 0) goto 1111
C
Cji we compare the cut at omega=0 with these rotated projection to reduce interpolation times
        angles_rad(3)= -(0. + 90.) * deg_to_rad
        do theta = -Nangle, Nangle  
          angles_rad(1)= (Dangle*theta+angles_deg(1))*deg_to_rad
          do phi   = -Nangle, Nangle  
            angles_rad(2)= (Dangle*phi+angles_deg(2))*deg_to_rad
C
Cji         Omega should be 360-omega-90, that is -(omega+90)
Cji         interpolate cut with omega=0 and compared with the fc_2d's rotatations
Cji         so its orientation for setrotmat should be ( angles_rad(1), angles_rad(2), -90.)
Cji     add wrapper to cache cuts
            call interplwrap(fft_klh, hkl_min, hkl_max, hkl_max,
     +                   fc_2d_intp, imgmagfactor, angles_rad,
     +                   ca_index, ca_table, ca_len)
Cji            call setrotmat( angles_rad, rot_mat)
Cji            call interpl_3d(fft_klh, hkl_min, hkl_max, radius,
Cji     +                 rot_mat, fc_2d_intp, imgmagfactor) 
            do omega = -Nangle, Nangle  
Cji1              angles_rad(3)=-(Dangle*omega+angles_deg(3)+90.)*deg_to_rad
Cji1              call setrotmat( angles_rad, rot_mat)
Cji1              call interpl_3d(fft_klh, hkl_min, hkl_max, radius,
Cji1     +                 rot_mat, fc_2d_intp, imgmagfactor) 
              if (dist(theta,phi,omega).GE.R4_MAX-1) then
                call imgcomport(fc_2d_intp, hkl_min, hkl_max, 
     +                  fc_2d(1,omega), disef, min_annul, num_annulus,
     +                  value, funcmode)
                dist(theta, phi, omega) = value
C
                if ( value .lt. min_value) then
                   min_value = value
                   min_angles(1) = theta
                   min_angles(2) = phi
                   min_angles(3) = omega
                endif
              endif
            enddo
          enddo
        enddo
C
        print *, iam, 'min_value=', min_value,'<=',
     +        min_angles(1), min_angles(2), min_angles(3)
C
        if ( abs(float(min_angles(1))) .gt. Nangle*0.5 .or. 
     +       abs(float(min_angles(2))) .gt. Nangle*0.5 .or.
     +       abs(float(min_angles(3))) .gt. Nangle*0.5 ) then
          angles_deg(1) = angles_deg(1) + min_angles(1) * Dangle
          angles_deg(2) = angles_deg(2) + min_angles(2) * Dangle
          angles_deg(3) = angles_deg(3) + min_angles(3) * Dangle
C
Cji we compare the cut at omega=0 with these rotated projection to reduce interpolation times
          if ( min_angles(3) .ne. 0 ) then 
            tmpomega  = angles_deg(3)
            do omega = -Nangle, Nangle
              tmpomega2 = -(tmpomega + Dangle*omega)
              call rotateomega(fc_2d_bak, nfc_2d_row, nfc_2d_col, 
     +                     fc_2d(1,omega), tmpomega2, tmpannul)
            enddo
          endif
Cji         slide dist windows to make min dist value is in center
          call slide_angles(dist, Nangle, min_angles)
C
          goto  1110
        endif
C
1111    angles_deg(1)        = angles_deg(1)+min_angles(1)*Dangle
        angles_deg(2)        = angles_deg(2)+min_angles(2)*Dangle
        angles_deg(3)        = angles_deg(3)+min_angles(3)*Dangle
        if ( symm_code .gt. 1) then 
          call to_asym_unit(symm_code, 
     +                angles_deg(1), angles_deg(2), angles_deg(3))
        endif 
Cji     update new orientation
        viewno               = viewno +1
        orient_new(0,viewno) = orient(0, view)
        orient_new(1,viewno) = angles_deg(1)
        orient_new(2,viewno) = angles_deg(2)
        orient_new(3,viewno) = angles_deg(3)
        orient_new(4,viewno) = orient(4,view)
        orient_new(5,viewno) = orient(5,view)
        orient_new(6,viewno) = orient(6,view)
        orient_new(7,viewno) = min_value
C
        if (Ncenter .eq. 0) goto 1121
C     ----------------------------------------------------------
Cji   refine center
C       rotate fc_2d_bak to omega = 0
        tmpomega2 = - angles_deg(3)
        call rotateomega(fc_2d_bak, nfc_2d_row, nfc_2d_col, 
     +                     fc_2d(1,0), tmpomega2, tmpannul)
C       interpolation cut
        angles_rad(1)= orient_new(1,viewno)*deg_to_rad
        angles_rad(2)= orient_new(2,viewno)*deg_to_rad
        angles_rad(3)= -(0. + 90.)*deg_to_rad
C
Cji     add wrapper to cache cuts
        call interplwrap(fft_klh, hkl_min, hkl_max, hkl_max,
     +                   fc_2d_intp, imgmagfactor, angles_rad,
     +                   ca_index, ca_table, ca_len)
Cji        call setrotmat( angles_rad, rot_mat)
Cji        call interpl_3d(fft_klh, hkl_min, hkl_max, hkl_max, 
Cji     +       rot_mat, fc_2d_intp, imgmagfactor) 
C
        do centeru = -Ncenter, Ncenter
          do centerv  = -Ncenter, Ncenter
              distcen(centeru,centerv,0)= R4_MAX
          enddo
        enddo
        min_value = R4_MAX
        minu      = 0
        minv      = 0
C
Cji loop to refine center
C
 1120   min_angles(1) = 0
        min_angles(2) = 0
        min_angles(3) = 0
C
        do centeru = -Ncenter, Ncenter 
          du = Dcenter * (centeru + minu)
          do centerv = -Ncenter, Ncenter 
            if (distcen(centeru,centerv,0).GE.R4_MAX-1) then
              dv = Dcenter * (centerv + minv)
Cji we have use fc_2d(1,0) to store the correctly rotated image, 
Cji then we use fc_2d_bak to store recentered image
              call recenter(fc_2d(1,0), nfc_2d_row, nfc_2d_col,
     +              fc_2d_bak,  du, dv)
              call imgcompcet(fc_2d_intp, hkl_min, hkl_max, 
     +              fc_2d_bak, disef, min_annul, num_annulus, value)
              distcen(centeru,centerv,0) = value
              if ( value .lt. min_value) then
                min_value = value
                min_angles(1) = centeru
                min_angles(2) = centerv
              endif
            endif
          enddo
        enddo
C
        print *, iam, 'min_value=', min_value,'center=(',
     +        min_angles(1), min_angles(2), ')'
C
Cji comment out the slide window for center refine
Cji        if ( abs(float(min_angles(1))) .gt. Ncenter*0.5 .or. 
Cji     +       abs(float(min_angles(2))) .gt. Ncenter*0.5 ) then
Cji          minu = minu + min_angles(1) 
Cji          minv = minv + min_angles(2)
C
Cji         slide dist windows to make min distcen value is in center
Cji          call slide_angles(distcen, Ncenter, min_angles)
C
Cji          goto  1120
Cji        endif
Cji endof comment
C
Cji   I need to rotate the xy also because we have rotate the image to omega=0
       tmpomega = angles_deg(3)
       du = (minu+min_angles(1))*Dcenter  
       dv = (minv+min_angles(2))*Dcenter
       dr = sqrt( du**2 + dv**2)
       if (du .ne. 0) then
          tmpomega2 = atan2d(dv, du)
       else
          if (dv .ge. 0)  then
            tmpomega2 = 90.
          else
            tmpomega2 = -90.
          endif
       endif
       du = dr * cosd(tmpomega2 + tmpomega)
       dv = dr * sind(tmpomega2 + tmpomega)
C
Cji       orient_new(4,viewno)=orient(4,view)+(minu+min_angles(1))*Dcenter
Cji       orient_new(5,viewno)=orient(5,view)+(minv+min_angles(2))*Dcenter
       orient_new(4,viewno)=orient(4,view)+ du
       orient_new(5,viewno)=orient(5,view)+ dv
       orient_new(6,viewno)=orient(6,view)
       orient_new(7,viewno)=min_value
C
        if (abs(orient_new(4,viewno)-npix_row/2).gt.0.1*npix_row .or.
     +      abs(orient_new(5,viewno)-npix_row/2).gt.0.1*npix_row) then
          print *, nint(orient_new(0, viewno)), 
     +     "center is abnormal(>=10%)"
Cji          orient_new(4,viewno) = npix_row/2
Cji          orient_new(5,viewno) = npix_row/2
        endif
 1121   print *, nint(orient(0, view)),(orient(cc, view),cc=1,6)
        print *, nint(orient_new(0, viewno)), 
     +              (orient_new(cc, viewno),cc=1,6)
C
 1150 continue
 1151 continue
 1200 continue                    
C    
Cji   gather the new orient_new 
      call set_indices(num_nodes, 1, num_views,
     +       frst_lst_view, max_node_eq )
      do i = 0, num_nodes-1
        sendcount(i)=(frst_lst_view(2,i)-frst_lst_view(1,i)+1)*8
        if (i.eq.0) then 
          disp(0) = 0
        else
          disp(i) = disp(i-1) + sendcount(i-1)
        endif
      enddo
C
      call mpi_gatherv(orient_new,sendcount(iam),mpi_real,orient_out,
     +           sendcount,disp,mpi_real,0,mpi_comm_world,mpi_err)
      if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +   'Error in calling MPI_gatherv orient_out')
C
Cji   write out new orient data
C
      if (iam.eq.0) then
        do view = 1, num_views
          WRITE(ort_out,1020) nint(orient_out(0, view)) ,
     +                       (orient_out(cc, view),cc=1,7)
        enddo
       CLOSE (UNIT=ort_out)
 1020  FORMAT(I7,',',4(F8.3,','),F7.3,',',F6.3,',',F10.3,',',' ,',' ,')
      endif
C
C     Free memory allocated in this subroutine.
C
      call cfree( pnt_rffta_omega )
      call cfree( pnt_rffta       )
      call cfree( pnt_rffta_trns  )
C
      return
      end
