Cji**************************************************************************

        SUBROUTINE interplwrap(F3D, hkl_min, hkl_max, radius,
     +                         F2D, imgmagfactor, angles_rad,
     +                         IDindex, DataTable, len)
        
        IMPLICIT NONE
        include '../include/allprogs.inc'
C Argument
        INTEGER*4 hkl_min, hkl_max, radius, len
        REAL*4    imgmagfactor, angles_rad(3)
C
Cji        COMPLEX F3D( hkl_min:hkl_max, hkl_min:hkl_max,
Cji     +               frst_lst_iq(1,iam):frst_lst_iq(2,iam) )
Cji F3D (K,L,H) complex(Kmin:Kmax, Lmin:Lmax, H_slab 0:Hmax)
C
        complex   F3D( hkl_min:hkl_max, hkl_min:hkl_max, 0:hkl_max)
        COMPLEX   F2D( (hkl_max+1)*(-hkl_min+hkl_max+1) )
C
Cji     the data of IDindex is :angles_rad(1), angles_rad(2), angles_rad(3), and a index to DataTable
Cji     so when we shift the IDindex, we will not shift the data in DataTable at all,
Cji     because we only shift the index of DataTable by using IDindex(4,i)
        real*4    IDindex(4,len)
        COMPLEX   DataTable( (hkl_max+1)*(-hkl_min+hkl_max+1), len)
C
C local 
        REAL*4    rot_mat(3,3), temp(4)
        integer   i, j, k, id
C
        do i = 1, len

          if ( IDindex(1,i) .eq. angles_rad(1) 
     +       .and. IDindex(2,i) .eq. angles_rad(2)
     +       .and. IDindex(3,i) .eq. angles_rad(3)) then
C
Cji    find the cut from cache, exchaneg position to the last, because I use Recent visited method               
               temp(1) = IDindex(1,i)
               temp(2) = IDindex(2,i)
               temp(3) = IDindex(3,i)
               temp(4) = IDindex(4,i)
               print *, "find cache at:", i, temp(1), temp(2), temp(4)
               do j = i+1, len
                  IDindex(1,j-1) = IDindex(1,j)
                  IDindex(2,j-1) = IDindex(2,j)
                  IDindex(3,j-1) = IDindex(3,j)
                  IDindex(4,j-1) = IDindex(4,j)
               enddo
               IDindex(1,len) = temp(1)
               IDindex(2,len) = temp(2)
               IDindex(3,len) = temp(3)
               IDindex(4,len) = temp(4)
Cji    copy the cached cut to the 2D 
               k = nint(temp(4))
               do j = 1, (hkl_max+1)*(-hkl_min+hkl_max+1)
                  F2D(j) = DataTable(j, k)
               enddo
               return
          endif
        enddo
C
Cji     not find in the cache at all, shift up the IDindex, and use the last one to create new cut
        k = nint(IDindex(4,1))
        do j = 2, len
           IDindex(1,j-1) = IDindex(1,j)
           IDindex(2,j-1) = IDindex(2,j)
           IDindex(3,j-1) = IDindex(3,j)
           IDindex(4,j-1) = IDindex(4,j)
        enddo
        IDindex(1,len) =  angles_rad(1)
        IDindex(2,len) =  angles_rad(2)
        IDindex(3,len) =  angles_rad(3)
        IDindex(4,len) =  float(k)
C               
Cji    create cut
        call setrotmat(angles_rad, rot_mat)
        call interpl_3d(F3D, hkl_min, hkl_max, radius,
     +                 rot_mat, F2D, imgmagfactor) 
Cji    cache the cut
        do j = 1, (hkl_max+1)*(-hkl_min+hkl_max+1)
           DataTable(j, k) = F2D(j)
        enddo
C
        return
        END
