      subroutine recenter(fft_2d, nfc_2d_row, nfc_2d_col, fc_2d,
     +             du, dv)
C **********************************************************************
C shift fft_2d by center(du, dv) and save to fc_2d
C **********************************************************************
      implicit none
      include '../include/allprogs.inc'
C
C Arguments
      integer*4   nfc_2d_row, nfc_2d_col
      complex     fc_2d( 0:nfc_2d_row, -nfc_2d_col:nfc_2d_col )
      complex     fft_2d( 0:nfc_2d_row, -nfc_2d_col:nfc_2d_col )
      real*4      du, dv 
C Local
      complex     c_exp, c_exp_1
      real*4      thetau, thetav
      integer*4   nfc_2d_end, h, k 
      character*9 subname
      data        subname / 'Center' /

Cji copy source fft_2d to dest fc_2d
      Do h = 0, nfc_2d_row
        Do k = -nfc_2d_col, nfc_2d_col
          fc_2d(h,k) = fft_2d(h,k)
        enddo
      enddo
C
      nfc_2d_end = nfc_2d_row
C
Cji*************************************************************
Cji  exp( 2 pi i [ H * DU / ROW_PERIOD + K * DV / COL_PERIOD ] )
Cji  = complex(cos(2 pi [ H * DU / ROW_PERIOD + K * DV / COL_PERIOD ]),
Cji            sin(2 pi [ H * DU / ROW_PERIOD + K * DV / COL_PERIOD ]))
Cji  center correction by ( DU, DV )

C     Modify the Fourier coefficient so as to translate the origin
C     of the pixels by ( DU, DV ).  The coefficient FC_2D(K,H)
C     is multiplied by
C          exp( 2 pi i [ H * DU / ROW_PERIOD + K * DV / COL_PERIOD ] )
C        = exp( i H THETAU ) * exp( i K THETAV )

Cji      dv      = center_v - float( ifix( center_v ) )
      thetav  = twopi * dv / float( 2*nfc_2d_end )
      c_exp_1 = cmplx( cos( thetav ), sin( thetav ) )

C     Use the BLAS routine CSCAL to multiply the K-th column of complex
C     FC_2D by C_EXP**K for K = 1, ..., NFC_2D_END
C     and by CONJG( C_EXP(K) ) for K = -1, ..., -NFC_2D_END. 
C     Syntax:
C        CSCAL(vectorlength, complex constant, complex vector, stride)

      c_exp   = c_exp_1
      do 1150 k = 1, nfc_2d_end
        call cscal(nfc_2d_end,        c_exp  , fc_2d( 1,  k), 1 )
        call cscal(nfc_2d_end, conjg( c_exp ), fc_2d( 1, -k), 1 )
        c_exp = c_exp * c_exp_1
 1150 continue

C     Impose periodic boundary conditions.
      do 1160 h = 1, nfc_2d_end
        fc_2d( h, nfc_2d_end ) = 0.5 * (  fc_2d( h,   nfc_2d_end )
     +                                  + fc_2d( h, - nfc_2d_end ) )
        fc_2d( h,-nfc_2d_end ) = fc_2d( h, nfc_2d_end )
 1160 continue

Cji      du      = center_u - float( ifix( center_u ) )
      thetau  = twopi * du / float( 2*nfc_2d_end )
      c_exp_1 = cmplx( cos( thetau ), sin( thetau ) )

C     Use the BLAS routine CSCAL to multiply the H-th row of FC_2D
C     by C_EXP_1**H

      c_exp   = c_exp_1
      do 1170 h =  1, nfc_2d_end
        call cscal( (2*nfc_2d_end+1), c_exp, fc_2d(h,-nfc_2d_end),
     +              (nfc_2d_end+1))
        c_exp = c_exp * c_exp_1
 1170 continue

C     Impose periodic boundary conditions; use conjugate symmetry
      do 1180 k = 1, nfc_2d_end
        fc_2d( nfc_2d_end,  k ) = 0.5 * ( fc_2d( nfc_2d_end, k )
     +                              + conjg( fc_2d( nfc_2d_end, -k ) ) )
        fc_2d( nfc_2d_end, -k ) = conjg( fc_2d( nfc_2d_end, k ) )
 1180 continue

      return
      end
