      subroutine error_stop(prog_name,subname,char_string)
C                                                             ERROR_STOP
C *****************************************************************
C *                                                               *
C * Subroutine: error_stop                                        *
C * Author: Robert E. Lynch (rel@cs.purdue.edu)                   *
C * Date:   1997                                                  *
C * Used in: aamain.f -- The main program                         *
C *          exchange_1.f -- The subroutine for exchanging data   *
C *                          for solving linear system            *
C *          exchange_2.f -- The subroutine for exchanging data   *
C *                          for 1-D Fourier synthesis            *
C *          fftanaly.f   -- The subroutine for FFT analysis      *
C *          fftsynth_1.f -- The subroutine for 2-D Fourier       *
C *                          synthesis                            *
C *          fftsynth_2.f -- The subroutine for 1-D Fourier       *
C *                          synthesis                            *
C *          cmpt_intrps.f -- The subroutine for Fourier          *
C *                           transform and interpolation         *
C *          info.f -- The subroutine for reading values of       *
C *                    parameters promptly or from an input file  *
C *                    to run the program                         *
C *          intlz_params.f -- The subroutine for setting         *
C *                            dependent parameters               *
C *          matrixentries.f -- The subroutine for interpolation  *
C *          mpi_subs.f -- The subroutines for communications     *
C *                        using MPI                              *
C *          output_density.f -- The subrouting for outputing     *
C *                              calculated density               *
C *          ran_sin_cos.f -- The subroutine for getting sin and  *
C *                           cos values of a random angle        *
C *          solvesys.f   -- The subroutines for combining data   *
C *                          of estimates of 3D DFT.              *
C * Function: Reporting errors while executing the program and    *
C *           stop the program.                                   *
C * Usage:    call error_stop(prog_name,subname,char_string)      *
C * Input:                                                        *
C *   "prog_name" (Character*) -- The name of the 3DR program.    *
C *   "subname" (Character*) -- The name of the subroutine where  *
C *                             the error occurs.                 *
C *   "char_string" (Character*) -- A string variable reporting   *
C *                                 the sort of the error.        *
C *                                                               *
C * Modification history:                                         *
C *     - Hong Lin, Version 1.0, Aug.18, 1998                     *
C *     - Hong Lin, Version 2.0, Oct. 1, 1999                     *
C *   - Yongchang Ji, Final Version, Aug.2000 -- Jan. 2002             *

C *                                                               *
C *****************************************************************
      implicit none
      include 'mpif.h'
      include '../include/allprogs.inc'
 
C Arguments
      character*(*) prog_name, subname, char_string
 
      write(stdoutput,1000) iam, prog_name, subname, char_string
 1000 format(//' ENTERED ERROR_STOP'/
     + ' NODE        = ',i5/
     + ' PROG_NAME   = >>',a,'<<'/
     + ' SUBNAME     = >>',a,'<<'/
     + ' CHAR_STRING = >>',a,'<<'/ )
 
        call MPI_Abort( MPI_COMM_WORLD, 2, mpi_err)
	stop
      return
      end

C   ----------------------------------------------------------------
Cji THis routine add for C procedure exit()
Cji because C procedure exit() cann't quit the running program

      subroutine fexit(val)
      implicit none
      include 'mpif.h'
      integer val,val1
      val = val + 1
      call MPI_Abort( MPI_COMM_WORLD, val, val1)
      stop
      return
      end
