      subroutine symmcode(symm_code, num_symm)
C                                                               SYMMCODE
C **********************************************************************
C * Subroutine symmcode                                                *
C * Author: Hong Lin (linh@cs.purdue.edu)                              *
C * Input:  symm_code (Integer)                                        *
C * Output: num_symm  (Integer)                                        *
C * Modification history:                                              *
C *   - Creation, Nov.22, 1999, Hong Lin.                              *
C *   - R.E.Lynch, Aug 1, 2000                                         *
C *     Changed name to symmcode from calculate_symmetry               *
C *     Added data subname                                             *
C *     Changed arguments in call of error_stop                        *
C *   - Yongchang Ji, Final Version, Aug.2000 -- Jan. 2002             *

C * Algorithm:                                                         *
C *   Changes symmetry code to number of matrices to replicate object  *
C **********************************************************************
      implicit none
      include '../include/allprogs.inc'
C
      integer symm_code, num_symm
      character*8 subname
      data subname / 'symmcode' /
C -------------------------------------------------------------------
      if (symm_code.le.8) then
        num_symm = symm_code
      elseif (symm_code .eq. 532) then
        num_symm = 60
      elseif (symm_code .eq. 222) then
        num_symm = 4
      elseif (symm_code .eq. 32) then
        num_symm = 6
      elseif (symm_code .eq. 52) then
        num_symm = 10
      elseif (symm_code .eq. 622) then
        num_symm = 12
      elseif (symm_code .eq. 72) then
        num_symm = 14
      elseif (symm_code .eq. 822) then
        num_symm = 16
      else
        write(stdoutput,1000) symm_code
 1000   format(//' Error in value of symmetry code SYMM = ',i10/
     +         ' Acceptible values:',
     +         '    less-equal 8, 532, 222, 32, 52, 622, 72, and 822')
        call error_stop(progname,subname, 
     1         'Error in symmetry code!')
      endif
C
      return 
      end
