      SUBROUTINE FFT3D_FILLpha (MAP, NCOL, NROW, NSEC, FFT)
      IMPLICIT NONE
      INTEGER*4 NCOL, NROW, NSEC, I, J, K
      REAL*4    MAP(NCOL,NROW,NSEC), FFT(2*NCOL,NROW,NSEC)
      DO J = 1,NROW
        DO I = 1,NCOL
          DO K = 1,NSEC
            MAP(I,J,k)=atan(FFT(2*I,J,k)*FFT(2*I-1,J,k)/
     +           (FFT(2*I-1,J,k)**2+.000001))*180/3.1416
Cji      MAP(I,J,K)=FFT(2*I,J,K)
          ENDDO
        ENDDO
      ENDDO
      RETURN 
      END

      SUBROUTINE FFT3D_FILLamp (MAP, NCOL, NROW, NSEC, FFT)
      IMPLICIT NONE
      INTEGER*4 NCOL, NROW, NSEC, I, J, K
      REAL*4    MAP(NCOL,NROW,NSEC), FFT(2*NCOL,NROW,NSEC)
      DO J = 1,NROW
        DO I = 1,NCOL
          DO K = 1,NSEC
      MAP(I,J,K)=sqrt(FFT(2*I-1,J,K)**2+FFT(2*I,J,K)**2)/10
Cji      MAP(I,J,K)=log(FFT(2*I-1,J,K)**2+FFT(2*I,J,K)**2)
Cji      MAP(I,J,K)=FFT(2*I-1,J,K)
          ENDDO
        ENDDO
      ENDDO
      RETURN 
      END

      SUBROUTINE tmpout(DENSITY_MAP, den_x, den_y, max_z_slab, fname)

      IMPLICIT NONE
C
      integer den_x,den_y, max_z_slab,SFAC, MINP
      real   density_map(  den_x, den_y, max_z_slab)
      CHARACTER*64  fname


      Call prjoutinit(max_z_slab,den_x,den_y,fname)
      CALL prjout(DENSITY_MAP, max_z_slab, den_x, den_y, SFAC, MINP)
      CALL prjoutclose()
      return
      end



	SUBROUTINE outimg(fft,hkl_min,hkl_max,id)
C
	IMPLICIT NONE
C
        INTEGER*4 hkl_min, hkl_max, num_hkl,id, col
        COMPLEX  FFT(0:hkl_max,hkl_min:hkl_max)
Cji Local

        real*4 map(0:hkl_max,hkl_min:hkl_max)
        character*64 fname

        num_hkl = hkl_max - hkl_min +1
        col = hkl_max+1

        CALL FFT3D_FILLamp(map,col,num_hkl,1,fft)
        if (id.eq.1) fname = 'fft2d.intp1.amp.pif'
        if (id.eq.2) fname = 'fft2d.intp2.amp.pif'
        call tmpout1(map,hkl_max+1,num_hkl,1,fname)

        CALL FFT3D_FILLpha(map,col,num_hkl,1,fft)
        if (id.eq.1) fname = 'fft2d.intp1.pha.pif'
        if (id.eq.2) fname = 'fft2d.intp2.pha.pif'
        call tmpout1(map, hkl_max+1,num_hkl,1,fname)

        RETURN
        END



      SUBROUTINE tmpout1(DENSITY_MAP, den_x, den_y, max_z_slab, fname)
C
      IMPLICIT NONE
C
      include '../include/allprogs.inc'
      include '../include/vax_minmax.inc'
      INCLUDE '../include/pifhead.inc'
      type (PIFHEAD_T) MAPHEAD, IMGHEAD
      COMMON /PIFHEAD/   MAPHEAD, IMGHEAD
C
        integer den_x,den_y, max_z_slab
        real   density_map(  den_x, den_y, max_z_slab)

C
C Input argument, the density to be written into external file.
C ============================================================================
C
	INTEGER COL, ROW, SEC, nx,ny,nz
        integer i,j,k, p1,p2,p3,p4,p5,p6
	REAL    SCALE1, SCALE2, FACTOR
	REAL    MAP_SCALEF, temp1, temp2
	CHARACTER (*) fname
        BYTE      versionStr(11), READWRITE(4)
C
     	logical debug_gen
	data debug_gen / .false. /
C
	character*14 subname
C	character file_title1(40), file_title2(40)
	data subname / 'output_density' /
	data versionStr(1) / 'l' /, versionStr(2) / 'i' /,
     +       versionStr(3) / 'b' /, versionStr(4) / 'P' /,
     +       versionStr(5) / 'I' /, versionStr(6) / 'F' /,
     +       versionStr(7) / ' ' /, versionStr(8) / '1' /,
     +       versionStr(9) / '.' /, versionStr(10) / '0' /,
     +       versionStr(11) / '0' /
C	data file_title1 / 
C     1 'E','QUINE HERPES INTERMEDIATES #1856 60' / file_title2 /
C     1 'PARTICLE RECONSTRUCTION 99**3(79 ANNULI)' /
C  ----------------------------------------------------------------------------
C
C  *****************************************************************************
C  *    SET UP MAP_MIN and MAP_MAX TO calculate float scale factor "MAP_SCALEF *
C  *****************************************************************************
C
        nx = den_x
        ny = den_y 
        nz = max_z_slab

        temp1 = density_map(1,1,1)
        temp2 = density_map(1,1,1)
        p1=1
        p2=1
        p3=1
        p4=1
        p5=1
        p6=1
        Do i = 1, nx
        Do j = 1, ny
        Do k = 1, nz
          if (temp1.GT.density_map(i,j,k)) then
             temp1 = density_map(i,j,k)
             p1=i
             p2=j
             p3=k
          endif
          if (temp2.LT.density_map(i,j,k)) then
             temp2 = density_map(i,j,k)
             p4=i
             p5=j
             p6=k
          endif
        ENDDO
        ENDDO
        ENDDO
      
C  *******************************************
C  *    SET UP PIF FORMAT MAP OUTPUT FILE    *
C  *******************************************
C
        print *,iam,fname, 'size', nx,ny,nz
        print *,iam,temp1,'(',p1,p2,p3,')',temp2,'(',p4,p5,p6,')'


	CALL PIF_INIT_HEAD (MAPHEAD)
	MAPHEAD%LUNUM = 8
	READWRITE(1)  = 'w'
	CALL PIF_OPEN (FNAME, MAPHEAD%LUNUM, READWRITE)
	MAPHEAD%NIMG       =    1
        MAPHEAD%IMGNUM     =    1
        MAPHEAD%MODE       =   20
           MAPHEAD%NUMCOLS = nx
           MAPHEAD%NUMROWS = ny
           MAPHEAD%NUMSECS = nz
C
CTSB	ACTUALLY NOT THE UNBINNED SIZE IF MAP_MAGFAC NOT = 1.0
C
Cji       MAPHEAD%SCALEF = 32767./max(abs(temp1),abs(temp2))
        MAPHEAD%SCALEF = 1
	MAPHEAD%recipFloatScaleFactor = 1
	MAPHEAD%endianNess = 0
	DO I =1,11
	  MAPHEAD%versionStr(i) = versionStr(i)
	ENDDO
	MAPHEAD%img_bkg    = 0
	MAPHEAD%BINFACTOR  = 1
	MAPHEAD%A_CELL     = nx
	MAPHEAD%B_CELL     = ny
	MAPHEAD%C_CELL     = nz
	MAPHEAD%dataI4_min = temp1
	MAPHEAD%dataI4_max = temp2
	MAPHEAD%DATAR4_MIN = 0
	MAPHEAD%DATAR4_MAX = 0
C
	CALL PIF_WRITE_GH (MAPHEAD)
	MAPHEAD%IMGNUM = 1
	CALL PIF_WRITE_DH (MAPHEAD)
C
        Do SEC = 1, max_z_slab
	  CALL PIF_WRITE_SECI2 (MAPHEAD,
     +           density_map(1,1,SEC),nx,ny,SEC)
        ENDDO
	CALL PIF_CLOSE (MAPHEAD%LUNUM)
C
1000  RETURN
      END
