       subroutine exch_intp(hkl_min,hkl_max,intpl,tmppl)
C
Cji *******************************************************************
Cji Subroutine exch_intp used in cmpt_intrps
Cji Created by Yongchang Ji
Cji Function: exchange the data in f_hkl_ref and store in f_hkl 
C * Input:                                                        *
C *   hkl_min (Integer) -- The minimum index of HKL space.        *
C *   hkl_max (Integer) -- The maximum index of HKL space.        *
C *   f_hkl_ref (complex)    -- the whole result of interpolation 
C * Output:           
C *   f_hkl --- the result of interpolation of each slab
C *  
C *   - Yongchang Ji, Final Version, Aug.2000 -- Jan. 2002             *
C
Cji *******************************************************************
      implicit none
C
      include 'mpif.h'
      include '../include/allprogs.inc'

C Arguments
C
      integer  hkl_min, hkl_max
      
      double precision intpl(3, hkl_min:hkl_max, hkl_min:hkl_max, 
     +                  0:hkl_max )
      double precision tmppl(3, hkl_min:hkl_max, hkl_min:hkl_max,
     +                frst_lst_iq(1,iam):frst_lst_iq(2,iam))
C -----------------------------------------------------------------
C Local
      integer  il, ik, ih, nod, count
C -----------------------------------------------------------------
      do nod = 0, num_nodes-1
C
        count = (hkl_max - hkl_min +1)**2 * 3 *
     +          (frst_lst_iq(2,nod) - frst_lst_iq(1,nod) + 1)
C
        call mpi_reduce(intpl(1,hkl_min,hkl_min,frst_lst_iq(1,nod)),
     +                tmppl, count, MPI_DOUBLE_PRECISION, MPI_SUM,
     +                nod, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,'exch_intp',
     +     'Error in calling MPI_reduce')
      enddo
C
      return
      end
