      subroutine stdfunc(hkl_min, hkl_max, first_iq, last_iq, f_hkl)
C **********************************************************************
      implicit none
C
      include 'mpif.h'
      include '../include/allprogs.inc'

      integer  hkl_min, hkl_max, first_iq, last_iq
      complex  f_hkl(hkl_min:hkl_max, hkl_min:hkl_max,
     +               first_iq:last_iq)
C -----------------------------------------------------------------
C
C Local
C
      integer  il, ik, ih
      integer  id(100), i, j , idtmp
      real     rad(100), realpart, imagpart, dstar
      double precision  avg1(100), std1(100), stdvavg1(100),
     +                  avg2(100), std2(100), stdvavg2(100), 
     +                  avg3(100), std3(100), stdvavg3(100)
      double precision avg1tmp,std1tmp,avg2tmp,std2tmp,avg3tmp,std3tmp
C -----------------------------------------------------------------
C
      do i = 1,100
         id(i)   =0
         rad(i)  =0.0
         avg1(i) =0.0
         std1(i) =0.0
         avg2(i) =0.0
         std2(i) =0.0
         avg3(i) =0.0
         std3(i) =0.0
      enddo

      rad(1) = hkl_max * 1.0 / 4    
      do i = 2, 100
         rad(i) = rad(1) * i**(0.33333333)
         if (rad(i).GT.float(hkl_max)) then
           rad(i) = float(hkl_max)
         endif
      enddo

      do il = first_iq, last_iq 
	do ik = hkl_min, hkl_max
	  do ih = hkl_min, hkl_max
            dstar = sqrt(float(ih**2 + ik**2 + il**2))
            j = 1
            do i = 1,100
               if (dstar.GT.rad(i)) then
                 j = i+1
               endif
            enddo
            id(j) = id(j) + 1
            realpart = real(f_hkl(ih,ik,il))
            imagpart = aimag(f_hkl(ih,ik,il))
            avg1(j) = avg1(j) + realpart
            std1(j) = std1(j) + realpart**2
            avg2(j) = avg2(j) + imagpart
            std2(j) = std2(j) + imagpart**2
            avg3(j) = avg3(j) + sqrt(realpart**2 + imagpart**2)
            std3(j) = std3(j) + realpart**2 + imagpart**2
	  enddo
	enddo
      enddo
      if (iam.eq.0) then
         print *, '  id   ,  radius  ,observs,  real-avg ,  imag-avg ,',
     +            ' ampli-avg ,  real-std ,  imag-std , ampli-std ,',
     +            'real-std/avg,imag-std/avg,ampli-std/avg'
      endif
      do i = 1, 100
        call mpi_reduce(id(i), idtmp, 1, MPI_INTEGER, MPI_SUM,
     +                   0,mpi_comm_world, mpi_err)
        call mpi_reduce(avg1(i),avg1tmp,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     +                   0,mpi_comm_world, mpi_err)
        call mpi_reduce(std1(i),std1tmp,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     +                   0,mpi_comm_world, mpi_err)
        call mpi_reduce(avg2(i),avg2tmp,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     +                   0,mpi_comm_world, mpi_err)
        call mpi_reduce(std2(i),std2tmp,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     +                   0,mpi_comm_world, mpi_err)
        call mpi_reduce(avg3(i),avg3tmp,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     +                   0,mpi_comm_world, mpi_err)
        call mpi_reduce(std3(i),std3tmp,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     +                   0,mpi_comm_world, mpi_err)
         if ( idtmp.gt.0 .and. iam.eq.0) then
            avg1tmp = avg1tmp / idtmp
            std1tmp = sqrt( abs( std1tmp/idtmp - avg1tmp**2 ))
            stdvavg1(i) = std1tmp / avg1tmp
            avg2tmp = avg2tmp / idtmp
            std2tmp = sqrt( abs( std2tmp/idtmp - avg2tmp**2 ))
            stdvavg2(i) = std2tmp / avg2tmp
            avg3tmp = avg3tmp / idtmp
            std3tmp = sqrt( abs( std3tmp/idtmp - avg3tmp**2 ))
            stdvavg3(i) = std3tmp / avg3tmp

            print 2211, i, rad(i), idtmp, avg1tmp,  avg2tmp, avg3tmp,
     +  std1tmp, std2tmp, std3tmp, stdvavg1(i), stdvavg2(i),stdvavg3(i)

         endif
      enddo
 2211 format(i8, f12.3, i8, 10f12.3)

C
      return
      end
