      PROGRAM POR
C **********************************************************************
      implicit none
C
      include 'mpif.h'
      include '../include/allprogs.inc'
      include '../include/info.inc'
      include '../include/com_01.inc'
      include '../include/mem_time.inc'
      
      DATA PROGNAME / 'POR ' /

      logical confine_3D
      data confine_3D / .false. / 

C ----------------------------------------------------------------------
C Local variables, used only in the main routine
C
      integer first_iq, last_iq, max_iq_slab, max_node_eqns,
     +        first_z,last_z, first_hk,last_hk, max_hk_slab, num_hkl,
     +        den_min_x, den_max_x, den_min_y, den_max_y, 
     +        den_min_z, den_max_z, node, mem_size, 
     +        min_xyz, max_xyz, hkl_min, hkl_max, max_z_slab,
     +        first_rr_out, last_rr_out, max_rr_out_slab,
     +        first_u, last_u, max_u_slab,
     +        first_y, last_y, max_y_slab,
     +        interpolants_size

      integer nrffts_1_row, nrffts_1_col, nrffts_1_omega,
     +        nrffts_2_row, nrffts_2_col, nrffts_2_omega,
     +        max_axis
C
      logical iam_continues_cmpt_intrps, 
     +        iam_continues_solve_fftsynth_1,
     +        iam_continues_fftsynth_2
 
C -----------------------------------------------------------------
C     The next arrays variables have their lenghts defined dynamically
C     by calls to cmalloc; pointers are used for each of these.

      real f_vru(1), f_vru_tmp(1), pixels_array(1), F_XK_dZ(1),
     +  rho(1), interpolants(1), density_map(1), ctf_val(1),
     +  ctf2(1), disef(1),map3d(1), rffta_omega(1)
C
      complex f_hkl(1),f_hkl_ref(1),fft_interp(1),fft3d(1),fft_klh(1)
C
      pointer ( pnt_map3d,            map3d            )
      pointer ( pnt_fft3d,            fft3d            )
      pointer ( pnt_fft_klh,          fft_klh          )
      pointer ( pnt_fft_interp,       fft_interp       )
      pointer ( pnt_rffta_omega,      rffta_omega      )
      pointer ( pnt_f_vru,            f_vru            )
      pointer ( pnt_f_vru_tmp,        f_vru_tmp        )
      pointer ( pnt_pixels_array,     pixels_array     )
      pointer ( pnt_ctf_val     ,     ctf_val          )
      pointer ( pnt_ctf2     ,        ctf2          )
      pointer ( pnt_disef     ,       disef         )
      pointer ( pnt_F_XK_dZ,          F_XK_dZ          )
      pointer ( pnt_rho,              rho              )
      pointer ( pnt_interpolants,     interpolants     )
      pointer ( pnt_density_map,      density_map      )
      pointer ( pnt_f_hkl,            f_hkl            )
      pointer ( pnt_f_hkl_ref,        f_hkl_ref        )

      character*17 subname
      character*64 fname
      data subname / 'POR main routine' /

      REAL    MAP_MIN, MAP_MAX, Weight
     +        , mapprjbig, imgprjbig, enlargefact
      real    angles_rad(1:3), rot_mat(1:3,1:3)
C
C     cmalloc assigns lenths of memory for variables
      integer cmalloc, i, j, k, total_views
      external cfree

C *********************************************************************
C *                      Initialization                               *
C *********************************************************************

      test_time   = .true.
      test_memory = .true.
      call usage

Cji !!used for odd (oddeven =1)or even ( oddeven=2), else all
      oddeven = 0 
      skipone = 1  !! always be 1, used for skip one image when oddeven = 1 or 2

C                                                         INITIALIZE MPI
C                                                         **************
        call MPI_INIT ( mpi_err )
        if (mpi_err.ne.0) call error_stop(progname, subname, 
     +    'Error in MPI_INIT')
        call MPI_COMM_RANK ( MPI_COMM_WORLD, iam, mpi_err )
        if (mpi_err.ne.0) call error_stop(progname, subname, 
     +    'Error in MPI_COMM_RANK')
        call MPI_COMM_SIZE ( MPI_COMM_WORLD, num_nodes, mpi_err )
        if (mpi_err.ne.0) call error_stop(progname, subname, 
     +    'Error in MPI_COMM_SIZE')
        if (num_nodes .gt. max_numnodes) then
           write(stdoutput, 9001) num_nodes, max_numnodes
 9001      format(//' Requested number of nodes = NUM_NODES    = ',i10/
     +              ' Available number of nodes = MAX_NUMNODES = ',i10/)
          call error_stop(progname, subname,  
     +    'NUM_NODES requested exceeds MAX_NUMNODES')
        endif
C
        t1 = wtime()
C
      if( iam .eq. 0 ) then
        print 1122, num_nodes
 1122   format(' Number of Nodes =',i5)
C                                                              *********
C       Read User's Control-Input
Cji     I have change the control_input to multi files.
C
        call info
C        
      endif
C
      if( num_nodes .gt. 1 ) then
C                                                  CALL BCAST_PARAMETERS
C                                        *******************************
C       Broadcast User's parameters and PIF File Header to other nodes.
        call bcast_parameters 
C
      endif
C                                                      CALL INTLZ_PARAMS
C                                                      *****************
      call intlz_params(hkl_min, hkl_max, num_hkl, min_xyz, max_xyz, 
     +        nrffta_row, nrffta_col, nrffta_omega, nfc_2d_row, 
     +        nfc_2d_col, nrffts_1_row, nrffts_1_col, 
     +        nrffts_1_omega, nrffts_2_row, nrffts_2_col, 
     +        nrffts_2_omega, den_min_x, den_max_x, den_min_y, 
     +        den_max_y, den_min_z, den_max_z,
     +        confine_3D,
     +        max_axis )

Cji 01/06/01 added 2 print statements after call of intlz_params
        if( iam .eq. 0 ) then
          print *, ' zero_fill after  call of INTLZ_PARAMS =',zero_fill
          print *, ' nrffta_row after call of INTLZ_PARAMS =',nrffta_row
        endif
C                                                      CALL INTLZ_ARRAYS
C                                                      *****************
      call intlz_arrays( hkl_min, hkl_max, min_xyz, max_xyz,
     +       min_y, max_y, min_z, max_z, max_views, num_symm,
     +       first_hk, last_hk, max_hk_slab, first_iq, last_iq,
     +       max_iq_slab, first_rr_out, last_rr_out, max_rr_out_slab,
     +       first_u, last_u, max_u_slab, first_view, last_view,
     +       first_y, last_y, max_y_slab, first_z, last_z, max_z_slab,
     +       max_node_eqns, npix_row,
     +       iam_continues_cmpt_intrps,
     +       iam_continues_solve_fftsynth_1, iam_continues_fftsynth_2)
C
C ---------- End of Initializationl --- Synchronize all the nodes ------

      call mpi_barrier(mpi_comm_world, mpi_err)
      t2 = wtime()
      t_init = t2 - t1
      
C **********************************************************************
C *             3D DFT of input 3D density map                         *
C **********************************************************************
      mem_size = npix_col * npix_row * max_y_slab
      pnt_map3d = cmalloc( 4 * mem_size)
      mem_map3d = dble(4 * mem_size) 
      if ( pnt_map3d .eq. 0 ) call error_stop (progname, subname,
     +      '3D density map memory allocation failed')
      mem_total = mem_total + mem_map3d
      mem_peak  = max(mem_peak, mem_total)
C      
      call read_map(map3d,max_y_slab,mapprjbig)
C
Cji  3d DFT, and exchange 8 quater
C
      pnt_rffta_omega = cmalloc( 4 * nrffta_omega )
      if(pnt_rffta_omega .eq. 0) call error_stop (progname, subname,
     +    'Error in allocating memory for nrffta_omega')
C
      call vrffti( nrffta_col, rffta_omega )
C
      mem_size = (hkl_max+1)* num_hkl * (last_y - first_y + 1) 
      pnt_fft3d = cmalloc( 8 * mem_size)
      mem_fft3d = dble(8 * mem_size) 
      if( pnt_fft3d .eq. 0 ) then
          call error_stop (progname, subname,
     +      '3D density fft map memory allocation failed')
      endif
      mem_total = mem_total + mem_fft3d
      mem_peak  = max(mem_peak, mem_total)
C   
Cji   FFT3D, (X,Y,Z) real -> (H,K,Z) complex(0:Hmax, Kmin:Kmax, Z_slab Zmin:Zmax)
Cji because I change intlz_params.f to make -hkl_min = hkl_max = nfc_2d_row = nfc_2d_col
C
      do i = 0, last_y - first_y
        call fft_2dfft(map3d(i*npix_col*npix_row+1), npix_row, npix_col, 
     +    nrffta_omega, rffta_omega, nrffta_row, nrffta_col, 
     +    hkl_max, hkl_max, FFT3D(i*(hkl_max+1)*num_hkl+1))
      enddo
C
      call cfree(pnt_map3d)
      mem_total = mem_total - mem_map3d
      call mpi_barrier(mpi_comm_world, mpi_err)
C
Cji need exchange data between nodes from Z_slab to H_slab
C
      if (num_nodes.gt.1) then
C
        mem_size = (hkl_max+1)*num_hkl*(last_y - first_y + 1)
        pnt_fft_klh = cmalloc( 8 * mem_size)
        if( pnt_fft_klh .eq. 0 ) then
          call error_stop (progname, subname,
     +      '3D density fft exchange memory 1 allocation failed')
        endif
        mem_total = mem_total + 8*mem_size 
        mem_peak  = max(mem_peak, mem_total)

        call arrange_3d_1(FFT3D, fft_klh, hkl_min, hkl_max)

        call cfree(pnt_fft3d)
        mem_total = mem_total - mem_fft3d
        mem_fft3d = 8 * mem_size

        mem_size = (last_iq-first_iq+1)*num_hkl*npix_row
        pnt_fft3d = cmalloc( 8 * mem_size)
        if( pnt_fft3d.eq. 0 ) then
          call error_stop (progname, subname,
     +      '3D density fft exchange memory 2 allocation failed')
        endif
        mem_total = mem_total + 8*mem_size 
        mem_peak  = max(mem_peak, mem_total)

        call exch_3d_1(fft_klh, hkl_min, hkl_max, FFT3D, npix_row)

        call cfree(pnt_fft_klh)
        mem_total = mem_total - mem_fft3d
        mem_fft3d = 8 * mem_size
C
      endif
C
Cji   1D fft, (H,K,Z)-->(K,L,H) complex(Kmin:Kmax, Lmin:Lmax, H_slab 0:Hmax)
C 
      mem_size = (last_iq-first_iq+1)* num_hkl**2
      pnt_fft_klh = cmalloc( 8 * mem_size)
      if( pnt_fft_klh .eq. 0 ) then
        call error_stop (progname, subname,
     +    '3D density fft 1dfft allocation failed')
      endif
      mem_total = mem_total +8*mem_size 
      mem_peak  = max(mem_peak, mem_total)
C
      CALL cfft_1d(FFT3D, fft_klh, hkl_min, hkl_max, npix_row,
     +             nrffta_omega, rffta_omega)
C     
      call cfree(pnt_fft3d)
      mem_total = mem_total - mem_fft3d
      mem_fft3d = 8 * mem_size

C
Cji   gather 3Dfft fft_klh in to a full 3D fft map fft3d
      mem_size = num_hkl*num_hkl*(hkl_max+1)
      pnt_fft3d = cmalloc( 8 * mem_size)
      if( pnt_fft3d .eq. 0 ) then
          call error_stop (progname, subname,
     +      '3D fft memory allocation failed')
      endif
      mem_total = mem_total + 8 * mem_size
      mem_peak  = max(mem_peak, mem_total)
C
Cji apply tmpfac to the whole map.
      if (ctfmode.GT.0 .and. ctfmode.LE.3 .and. TEMPFAC.gt.0.0) then
        call maptempfac(fft_klh, hkl_max, TEMPFAC, PIXSIZS(1), units)
      endif
C
      call gather3d(fft_klh, hkl_max, fft3d)

      call cfree(pnt_fft_klh)
      mem_total = mem_total - mem_fft3d
      mem_fft3d = dble(8 * mem_size) 
C
      call mpi_barrier(mpi_comm_world, mpi_err)
      t1 = wtime()
      t_3dfft = t1 - t2
C
C **********************************************************************
C *             refine orientation of all input files               *
C **********************************************************************
C
Cji  initialize the CTF mem for half fft_size matrix
C
      mem_size = (nfc_2d_row +1) * (nfc_2d_col * 2 +1)
      pnt_ctf_val = cmalloc( 4 * mem_size )
      pnt_ctf2 = cmalloc( 4 * mem_size )
      pnt_disef = cmalloc( 4 * mem_size )
      mem_ctf_val = dble( 12 * mem_size)

      if( pnt_ctf_val.eq.0.or.pnt_ctf2.eq.0.or.pnt_disef.eq.0) then
        print 9010, subname,  pnt_disef
 9010   format(/' Memory allocation failed in >> ',a,' <<'/
     +          '  pnt_ctf_val =', i15)
        call error_stop (progname, subname,
     +      ' Memory allocation failed')
      endif

      mem_total = mem_total + mem_ctf_val
      mem_peak  = max(mem_peak, mem_total)

C
Cji  loop for all the input parameter files to do cmpt_ort.
      t_analy     = 0
      t_fftanaly    = 0
      total_views = 0
      mem_cmpt_intrps = 0

      do 2000 i = 1, NFILES

Cji      initialize the parameters for one image file.

        if (iam .eq. 0) then
          pix_file_name = IMG_FNAMES(i)
          ort_file_name = PARAM_FNAMES(i)
C                                             ******PIF_OPEN************
          call PIF_OPEN (pix_file_name, pix_file_unit, 'r')
          call read_1_pif(imgprjbig)
          enlargefact = mapprjbig / (imgprjbig*sqrt(float(nrffta_col)))
          print *, 'enlargefact=',enlargefact, imgprjbig, mapprjbig
        endif
C
        call mpi_bcast(enlargefact, 1, mpi_real,
     +                 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_BCAST enlargefact')

        npix_row    =  NPIX(i)
        npix_col    =  NPIX(i)
        max_views   =  NIDS(i)
        angstrom_per_pix = PIXSIZS(i)

        mem_size =   view_perread * npix_row * npix_col
        pnt_pixels_array = cmalloc( 4 * mem_size )
        mem_pixels_array = dble(4 * mem_size)
C
        if( pnt_pixels_array .eq. 0) then
          print 9012, subname, pnt_pixels_array 
 9012     format(/' Memory allocation failed in >> ',a,' <<'/
     +          '  pnt_pixels_array =', i15)
          call error_stop (progname, subname,  
     +      ' Memory allocation failed')
        endif
        mem_total = mem_total + mem_pixels_array
        mem_peak  = max(mem_peak, mem_total)
C
Cji  initialize the CTF value  for half fft_size matrix
          do k = 1, (nfc_2d_row +1) * (nfc_2d_col * 2 +1)
              ctf_val(k) = 0.0
              ctf2(k) = 1.0
              disef(k) = 1.0
          enddo
        
        IF (funcweight .GT.0.0 ) then 
         call disef_para(disef, nfc_2d_row, nfc_2d_col, funcweight,
     +                   PIXSIZS(i), units)
        endif

        IF (CTFMODE.GT.0 .and. CTFMODE.LE.3)  then
          Weight = enlargefact
C                                                          CALL CTF_PARA
C                                                      *****************
Cji using parameter res_max, res_max to avoid soft border for ctfval
C
          call ctf_para(ctf_val, ctf2, nfc_2d_row, nfc_2d_col,
     +         CTFMODE, Filter, TEMPFAC, WIENER, WIENER2,
     +         PIXSIZS(i), units, VOLTS(i), 
     +         DELF_MAJS(i), DELF_MINS(i), ANG_MAJS(i), AMPFACS(i), 
     +         CS_COEFFS(i), Weight, res_max, res_max)
        endif
C
Cji read image, and refine its orientation
C                                                       CALL CMPT_INTRPS
C                                                       ****************
        mem_cmpt = 0

        call cmpt_ort(fft3d, pixels_array, hkl_min, hkl_max,
     +       t_analy, t_fftanaly, mem_cmpt, total_views, ctf_val, ctf2
     +       , disef, i)

        mem_cmpt_intrps = max(mem_cmpt_intrps, mem_cmpt)
        mem_peak  = max(mem_peak, mem_total+mem_cmpt)

C     Free memory for the array used in loading pixel frames.
        call cfree(pnt_pixels_array)
        mem_total = mem_total - mem_pixels_array
C
Cji    finish read the pif file, Close PIF file.
C
        if(  iam .eq. 0 ) then
          call pif_close (pix_file_unit)
          print *, 'total_view = ', total_views
        endif

 2000 continue

      call cfree(pnt_ctf_val)
      call cfree(pnt_ctf2)
      call cfree(pnt_disef)
      call cfree(pnt_fft3d)
      mem_total = mem_total - mem_ctf_val - mem_fft3d
C
Cji end of all the parameter files
C
      call mpi_barrier(mpi_comm_world, mpi_err)
      t2 = wtime()
      t_interp = t2 - t1 - t_fftanaly - t_analy
C
C ***************************************************************************
C
      if (mem_total .ne. 0) print *,'mem_total=',mem_total,
     +  'At the end, mem_total should be 0!!!'
C
      if ( iam .eq. 0 ) then
C     Print timing message.
C
        time = t_init + t_3dfft + t_fftanaly + t_analy + t_interp
C
        if (test_time) 
     +    print 40, iam, t_init,
     +                   t_3dfft,
     +                   t_analy,
     +                   t_fftanaly,
     +                   t_interp,
     +                   time
  40      format (/ 'Node ', i3, 
     +          ' Time used in initialization                      =',
     +        f15.4, ' ' / 8x,
     +          ' Time used in read map & 3DFFT                    =',
     +        f15.4, ' ' / 8x,
     +          ' Time used in read images                         =',
     +        f15.4, ' ' / 8x,
     +          ' Time used in FFT analysis of images              =',
     +        f15.4, ' ' / 8x,
     +          ' Time used in refine orientation & center         =', 
     +        f15.4, ' ' / 8x, 
     +          ' Total time used                                  =',
     +        f15.4)
C
C     Print memory allocating message.
C
         if (test_memory) print 60, iam, mem_peak, 
     +       mem_map3d, mem_fft3d, mem_pixels_array,
     +       mem_cmpt_intrps
   60    format(/ 'Node ', i3, ' Memory allocation in BYTES:', /
     +                  8x, ' Peak memory allocated   =', f18.1 /
     +                  8x, ' Memory for 3D Map       =', f18.1 /
     +                  8x, ' Memory for 3D FFT       =', f18.1 /
     +                  8x, ' Memory for PIXELS_ARRAY =', f18.1 /
     +                  8x, ' Memory used in CMPT_ORT =', f18.1 )
C
      end if
C
C     Finalize MPI
C
      call MPI_FINALIZE ( mpi_err )
C
      stop
      end
