      subroutine arrange_3d_1(FFT3D, F_TMP, hkl_min, hkl_max)
C                                                           
C **********************************************************************
C
      implicit none
      include '../include/allprogs.inc'
 
C Arguments
C
      integer hkl_min, hkl_max
C 
      complex FFT3D(0:hkl_max, hkl_min:hkl_max, 
     +               frst_lst_y(1,iam):frst_lst_y(2,iam))
C    
      complex F_TMP(1)
C =====================================================================
C 
C Local
C
      integer i,k,z, send_offset, recv_offset, nums
      character*16 subname
      data         subname / 'arrange_3D_1' /
C
      external scopy
C     Syntax:
C       CALL SCOPY( N, X, INCX, Y, INCY )
C         Copy vector X to vector Y
C             N    INTEGER*4: number of entries of X to be copied
C             X    REAL*4:    vector to be copied to Y; X must
C             have
C                     length at least N*INCX
C             INCX INTEGER*4: stride of X
C             Y    REAL*4:    vector copied from X; Y must have
C             length
C                     at least N*INCY
C             INCY INTEGER*4: stride of Y
C       The procedure is equivalent to
C            JY = 1
C            DO JX = 1, ( (N-1)*INCX + 1 ), INCX
C              Y(JY) = X(JX)
C              JY = JY + INCY
C            END DO
C ----------------------------------------------------------------------
Cji we move data    -----------    to           ----
Cji                 |a1| b1|c1|                 |a1|
Cji                 |  |   |  |                 |  |
Cji                 -----------                 ----
Cji                                             | b1|
Cji                                             |   |
Cji                                             -----
Cji                                             |c1|
Cji                                             |  |
Cji                                             ----
C

        
      recv_offset = 1
      do i = 0, num_nodes -1 
        nums = frst_lst_iq(2,i) - frst_lst_iq(1,i) + 1
        do z = frst_lst_y(1,iam), frst_lst_y(2,iam)
          do k = hkl_min, hkl_max
            call ccopy(nums,FFT3D(frst_lst_iq(1,i),k,z),1,
     +                      F_TMP(recv_offset),1)
            recv_offset = recv_offset + nums
          enddo
        enddo
      enddo
C
      return
      end
