Cji**************************************************************************

        SUBROUTINE interpl_3d(F3D,hkl_min,hkl_max, radius,
     +                        rot_mat,F2D,imgmagfactor)
        
        IMPLICIT NONE
        include '../include/allprogs.inc'
C Argument
        INTEGER*4 hkl_min, hkl_max, radius, rmax
        REAL*4    rot_mat(3,3), imgmagfactor
C
Cji        COMPLEX F3D( hkl_min:hkl_max, hkl_min:hkl_max,
Cji     +               frst_lst_iq(1,iam):frst_lst_iq(2,iam) )
Cji F3D (K,L,H) complex(Kmin:Kmax, Lmin:Lmax, H_slab 0:Hmax)
C
        complex F3D( hkl_min:hkl_max, hkl_min:hkl_max, 0:hkl_max)
        COMPLEX F2D( 0:hkl_max, hkl_min:hkl_max)
C local 
        INTEGER*4 row, col, ih_nest, il_nest, ik_nest,
     +       ih_minus, ih_plus, ik_minus, ik_plus, il_minus, il_plus

        REAL*4    h_prime, l_prime, k_prime, del_h,
     +     del_h_minus, del_h_plus, del_k, del_k_minus, del_k_plus,
     +     del_l, del_l_minus, del_l_plus, trow, tcol
        COMPLEX   t1,t2,t3,t4,t5,t6,t7,t8
C
        rmax = min( hkl_max, radius)
        Do col = 0, rmax
          tcol = col * imgmagfactor     !! apply imgmagfactor in fft domain
C
          Do row = -rmax, rmax
            trow = row * imgmagfactor   !!apply imgmagfactor in fft domain
C
Cji            h_prime = rot_mat(1,1)*tcol + rot_mat(1,2)*trow
Cji            k_prime = rot_mat(2,1)*tcol + rot_mat(2,2)*trow
Cji            l_prime = rot_mat(3,1)*tcol + rot_mat(3,2)*trow
Cji  because the setrotmat procedure has change the rotmat to be its inverse(also transpose)
Cji  so we change to use following formula
C
            h_prime = rot_mat(1,1)*tcol + rot_mat(2,1)*trow
            k_prime = rot_mat(1,2)*tcol + rot_mat(2,2)*trow
            l_prime = rot_mat(1,3)*tcol + rot_mat(2,3)*trow
C            
            if ( h_prime.lt.hkl_min .or. k_prime.lt.hkl_min .or.
     +           l_prime.lt.hkl_min .or. h_prime.gt.hkl_max .or.
     +           k_prime.gt.hkl_max .or. l_prime.gt.hkl_max .or.
     +           col*col + row*row .gt. rmax*rmax ) then
              F2D(col, row) = 0.
            else
              ih_nest = nint( h_prime )
              ik_nest = nint( k_prime )
              il_nest = nint( l_prime )
              del_h         = h_prime - float( ih_nest )
              if( del_h .ge. 0. ) then
                del_h_minus = del_h
                ih_minus    = ih_nest
              else
                del_h_minus = 1. + del_h
                ih_minus    = ih_nest - 1
              end if
              del_h_plus    = 1.0 - del_h_minus
              ih_plus       = 1   + ih_minus
C
              del_k         = k_prime - float( ik_nest )
              if( del_k .ge. 0. ) then
                del_k_minus = del_k
                ik_minus    = ik_nest
              else
                del_k_minus = 1. + del_k
                ik_minus    = ik_nest - 1
              end if
              del_k_plus    = 1.0 - del_k_minus
              ik_plus       = 1   + ik_minus
C
              del_l         = l_prime - float( il_nest )
              if( del_l .ge. 0. ) then
                del_l_minus = del_l
                il_minus    = il_nest
              else
                del_l_minus = 1. + del_l
                il_minus    = il_nest - 1
              endif
              del_l_plus    = 1.0 - del_l_minus
              il_plus       = 1   + il_minus
C
Cji  when the del_h,del_k,del_l is equal to 0, 
Cji  which means ?_prime is equal to hkl_min or hkl_max
Cji  the i?_plus or i?_minus may be out of range
              if ( ih_minus.lt.hkl_min ) ih_minus = ih_plus
              if ( ik_minus.lt.hkl_min ) ik_minus = ik_plus
              if ( il_minus.lt.hkl_min ) il_minus = il_plus
              if ( ih_plus.gt.hkl_max ) ih_plus = ih_minus
              if ( ik_plus.gt.hkl_max ) ik_plus = ik_minus
              if ( il_plus.gt.hkl_max ) il_plus = il_minus
C
              if (ih_minus .lt. 0) then
                   t1 = conjg( F3D(-ik_minus,-il_minus,-ih_minus))
                   t3 = conjg( F3D(-ik_minus,-il_plus,-ih_minus))
                   t5 = conjg( F3D(-ik_plus,-il_minus,-ih_minus))
                   t7 = conjg( F3D(-ik_plus,-il_plus,-ih_minus))
              else
                   t1 = F3D(ik_minus,il_minus,ih_minus)
                   t3 = F3D(ik_minus,il_plus,ih_minus)
                   t5 = F3D(ik_plus,il_minus,ih_minus)
                   t7 = F3D(ik_plus,il_plus,ih_minus)
              endif
C
              if (ih_plus .lt. 0) then
                   t2 = conjg( F3D(-ik_minus,-il_minus,-ih_plus))
                   t4 = conjg( F3D(-ik_minus,-il_plus,-ih_plus))
                   t6 = conjg( F3D(-ik_plus,-il_minus,-ih_plus))
                   t8 = conjg( F3D(-ik_plus,-il_plus,-ih_plus))
              else
                   t2 = F3D(ik_minus,il_minus,ih_plus)
                   t4 = F3D(ik_minus,il_plus,ih_plus)
                   t6 = F3D(ik_plus,il_minus,ih_plus)
                   t8 = F3D(ik_plus,il_plus,ih_plus)
              endif
C
              F2D(col, row) = 
     +            t1 * del_k_plus  * del_l_plus  * del_h_plus
     +          + t2 * del_k_plus  * del_l_plus  * del_h_minus
     +          + t3 * del_k_plus  * del_l_minus * del_h_plus
     +          + t4 * del_k_plus  * del_l_minus * del_h_minus
     +          + t5 * del_k_minus * del_l_plus  * del_h_plus
     +          + t6 * del_k_minus * del_l_plus  * del_h_minus
     +          + t7 * del_k_minus * del_l_minus * del_h_plus
     +          + t8 * del_k_minus * del_l_minus * del_h_minus
C
Cji restore the fft value which scaled by the imgmagfactor
             F2D(col, row) = F2D(col, row) * (imgmagfactor ** 2)
C
            endif
          enddo
        enddo
        END
