       subroutine comp_sfactor(f_1,f_2,hkl_max,res_max,res_min,
     +     nrffta_row, pixelsize, res_step, mem_cmpt)
      
        implicit none

        include 'mpif.h'
        include '../include/allprogs.inc'
Cji  Argument
        Character*8   subname
        DATA subNAME / 'comp_sf' /

        integer nrffta_row, res_step, hkl_max
        double precision mem_cmpt
        real res_max, res_min, pixelsize
        complex f_1( -hkl_max:hkl_max, -hkl_max:hkl_max,
     +               frst_lst_iq(1,iam):frst_lst_iq(2,iam) )
        complex f_2( -hkl_max:hkl_max, -hkl_max:hkl_max,
     +               frst_lst_iq(1,iam):frst_lst_iq(2,iam) )

Cji local
        REAL      res(res_step) 

        INTEGER   NTOT(res_step), sNTOT(res_step)
        DOUBLE PRECISION    F1SUM(res_step), sF1SUM(res_step),
     +            F2SUM(res_step), sF2SUM(res_step),
     +            SUMDAB(res_step), sSUMDAB(res_step),
     +            AVG_PDIF(res_step), sAVG_PDIF(res_step)
        DOUBLE PRECISION    F1SQSUM(res_step), sF1SQSUM(res_step),
     +            F2SQSUM(res_step), sF2SQSUM(res_step),
     +            F1_F2SUM(res_step), sF1_F2SUM(res_step),
     +            F1F2SUM(res_step), sF1F2SUM(res_step)

        REAL    CCOEF(res_step) , RFAC, Rphase

        integer h,k,l,i,bin
        real max_annulsq, min_annulsq, dstarsq, res_inc
        real PDIF, DENOM1, DENOM2, PHASE1, PHASE2
        real APART1, APART2, BPART1, BPART2, AMP1, AMP2
  
        mem_cmpt =  res_step * ( 12*4 + 8*8)
        max_annulsq = (float(nrffta_row)*pixelsize/res_max)**2
        min_annulsq = (float(nrffta_row)*pixelsize/res_min)**2
        res_inc   = (max_annulsq - min_annulsq)/res_step

        DO I = 1,res_step                          ! INITIALIZE ARRAYS
          res(I) = nrffta_row*pixelsize/sqrt(min_annulsq+i*res_inc)
          NTOT(I)     =   0
          AVG_PDIF(I) = 0.0
          F1_F2SUM(I) = 0.0
          F1SUM(I)    = 0.0
          F2SUM(I)    = 0.0
          F1F2SUM(I)  = 0.0
          F1SQSUM(I)  = 0.0
          F2SQSUM(I)  = 0.0
          SUMDAB(I)    = 0.0
        ENDDO


        do l = frst_lst_iq(1,iam), frst_lst_iq(2,iam)
        do k = -hkl_max, hkl_max
        do h = -hkl_max, hkl_max
          dstarsq = float(h**2 + k**2 + l**2)
          if(dstarsq.GE.min_annulsq.and.dstarsq.LE.max_annulsq)then
            bin = (dstarsq - min_annulsq)/res_inc + 1  
            if (bin.gt.res_step) bin = res_step
            
            CALL cplex2AP(f_1(h,k,l), APART1, BPART1,
     +              AMP1, PHASE1, rad_to_deg)
            CALL cplex2AP(f_2(h,k,l), APART2, BPART2,
     +              AMP2, PHASE2, rad_to_deg)

            PDIF   = ABS(PHASE1 - PHASE2)
            IF(PDIF.GT.180.0) PDIF = 360.0 - PDIF
            AVG_PDIF(BIN) = AVG_PDIF(BIN) + PDIF
            F1_F2SUM(BIN) = F1_F2SUM(BIN) + ABS(AMP1 - AMP2)
            F1SUM(BIN)    = F1SUM(BIN) + AMP1
            F2SUM(BIN)    = F2SUM(BIN) + AMP2
            F1SQSUM(BIN)  = F1SQSUM(BIN) + AMP1*AMP1
            F2SQSUM(BIN)  = F2SQSUM(BIN) + AMP2*AMP2
            F1F2SUM(BIN)  = F1F2SUM(BIN) + AMP1*AMP2
            SUMDAB(BIN)   = SUMDAB(BIN) + 
     +             sqrt((APART1 - APART2)**2 + (BPART1 - BPART2)**2)
            NTOT(BIN)     = NTOT(BIN) + 1
          endif
        enddo
        enddo
        enddo
        
        call mpi_reduce(NTOT, sNTOT, res_step, MPI_INTEGER, 
     +                 MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(AVG_PDIF, sAVG_PDIF, res_step, 
     +      MPI_DOUBLE_PRECISION,MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(F1_F2SUM, sF1_F2SUM, res_step, 
     +      MPI_DOUBLE_PRECISION,MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(F1SUM, sF1SUM, res_step, MPI_DOUBLE_PRECISION,
     +                 MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(F2SUM, sF2SUM, res_step,MPI_DOUBLE_PRECISION, 
     +                 MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(F1SQSUM, sF1SQSUM, res_step, 
     +      MPI_DOUBLE_PRECISION, MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(F2SQSUM, sF2SQSUM, res_step, 
     +      MPI_DOUBLE_PRECISION, MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(F1F2SUM, sF1F2SUM, res_step, 
     +      MPI_DOUBLE_PRECISION, MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')
        call mpi_reduce(SUMDAB,sSUMDAB,res_step,MPI_DOUBLE_PRECISION,
     +                 MPI_SUM, 0, mpi_comm_world, mpi_err)
        if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +     'Error in calling MPI_reduce')

C
      if (iam.eq.0) then
        Write(*,'(/,2A)') '   Bin#  Resolution  observ  ',
     +                '   R-SF       CC     R-phase  phase-diff',
     +                     '  ------  --------  -------- ', 
     +                ' --------  --------  --------  -------- '
        WRITE(*,1000) 0, res_min, 0, 0.0, 1.0, 0.0, 0.0

        DO I = 1, res_step
          CCOEF(I) = 1.0
          IF(sNTOT(I).GT.0) THEN
            DENOM1    = sF1SQSUM(I) - (sF1SUM(I)**2)/sNTOT(I)
            DENOM2   = sF2SQSUM(I) - (sF2SUM(I)**2)/sNTOT(I)
            IF(DENOM1.GT.0.0 .AND. DENOM2.GT.0.0) THEN
            CCOEF(I) = (sF1F2SUM(I) - (sF1SUM(I)*sF2SUM(I)/sNTOT(I)))/
     1                    ( SQRT(DENOM1) * SQRT(DENOM2) )
            ENDIF
            RFAC     = sF1_F2SUM(I)/sF1SUM(I)
            Rphase   = sSUMDAB(I)/ sF1SUM(I)
            AVG_PDIF(I) = sAVG_PDIF(I)/FLOAT(sNTOT(I))
          ENDIF

          WRITE(*,1000) I, res(I), sNTOT(I), RFAC,
     1               CCOEF(I), Rphase, AVG_PDIF(I)
        ENDDO
 1000     FORMAT (I8, F10.2, I10, 4F10.3)
      endif

Cji R-SF = sum(F1-kF2) / sum F1
Cji      S1 = sum(<F1>-F1)(<F2>-F2)
Cji      S2 = sum(<F1>-F1)^2
Cji      S3 = sum(<F2>-F2)^2
Cji CC  = S1 / sqrt(S2*S3)
Cji      A = F1 cos(phi1*deg_to_rad) - F2 cos(phi2*deg_to_rad)
Cji      B = F2 sin(phi2*deg_to_rad) - F1 sin(phi1*deg_to_rad)
Cji R-phase =  sum(sqrt(A^2+B^2))
Cji            _________________
Cji              sum F1
Cji
Cji phase-diff =   sum |phi1-phi2|
Cji               _________________
Cji                # observations

      End



      subroutine cplex2AP(c1, APART, BPART, AMP, PHI, RADIAN)

        implicit none
        Complex c1
        REAL  AMP, PHI, APART, BPART, RADIAN

        APART = real(c1)
        BPART = aimag(c1)
        AMP   = SQRT(APART**2 + BPART**2)
        PHI   = 0.0
        IF(APART.EQ.0.0) THEN
          IF(BPART.GT.0.0) PHI =  90.0
          IF(BPART.LT.0.0) PHI = 270.0
        ELSE
          PHI = ATAN2(BPART,APART)*RADIAN
          PHI = AMOD(PHI,360.0)
          IF(PHI.LT.0.0) PHI = 360.0 + PHI
        ENDIF
      end
