
/* STEVE - ignore the next few lines I'm just doing this for
   my environment over here... */
/* #include "/bio/reo2/sbw/prog/libCtf/libCtf.c" */
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#ifdef VMS
#include "libr$dev:libPIF.h"
#else
#include "../libr/libPIF.h" 
#endif



#ifdef VMS
extern void img_fft_fill_rob();
extern void fft_dsp_rob();
extern void fft_2d_rob();
extern void mapdsp_gplot_rob();
extern int  calcBackground();
extern void apply_ctf_rtn();
#else
extern void img_fft_fill_rob_();
extern void fft_dsp_rob_();
extern void fft_2d_rob_();
extern void mapdsp_gplot_rob_();
#endif




typedef struct __imgHead_t__
  {/* IMAGEHEAD_T */
    int    header;
    int    image;
  }/* IMAGEHEAD_T */ imgHead_t;

pifHead_t pifHead;



#define HEADER     512
#define PI         3.141592654


#define FFT_FORWARD  1
#define FFT_BACKWARD -1









/*******************************************************************
 * calcfloatFFT() - Stuff the buffer and calc the FFT.
 * return floating data
*/
void calcfloatFFT(BYTE *byte_buffer, float *fftImage_buffer2, 
	     int numCols, int numRows, int img_bkg, int fftSize, int ksign)
{/* CALCFFT */
  int i,m,j,k,thisPixel,fftRow,fftCol,fftHeight,fftWidth,
        thisNcols,thisNrows,arg1,arg2,arg3,arg4,jindx,jindxp1;
  float distThis;
  int insideLimits,strtAvg,endAvg,thisImg,thisNimg,useRectangle;
  int iform,linear,idim1,idim2;
  float thisMin,thisMax,maxF,minF,offset,recipThisNimg;
  float scaleFactor, thisFFTvalue, thisFloat, thisSign;
  float recipSize,maxFFTvalue,minFFTvalue;
/*  float *fftImage_buffer2;*/
  int iTrecip,iTidim2, thisBackground;
  unsigned short *temp_buffer;
  int thisMaxInt,thisMinInt,sliderSize, array_size, hiPixel,loPixel;
  int fftDispType, debugSwitch;

  fftHeight=fftWidth=idim1= idim2= fftSize; 

  temp_buffer= (unsigned short *)malloc(
		sizeof(unsigned short)*numCols*numRows);
  if (temp_buffer == NULL) {
    printf("malloc of temp_buffer in calcfloatFFT returned NULL pointer\n");
    exit(23);
  }

/*  fftImage_buffer2= (float *)malloc(sizeof(float)*(idim1*(idim2*2)));*/
  /* only if forward FFT */
  if (ksign == FFT_FORWARD) {
    /* Init out the FFT buffers */
    for(i=0;i<idim1;i++)
      for(j=0;j<(idim2*2);j++)
	{/* Init all */
	  fftImage_buffer2[(i*(idim2*2))+j]= 0.0;
	}/* Init all */
  

    for(i=0;i<numRows;i++) {
      for(j=0;j<numCols;j++)  {/* Do all */
  	  temp_buffer[((i*numCols)+j)]= (unsigned short)
	    byte_buffer[((i*numCols)+j)];
      }/* Do all */
    }

  } /* if ksign == FFTFORWARD */	      

  thisBackground = img_bkg;
  printf("Using background [%d]\n",thisBackground);

     
  iform = 1;       /* Data is imaginary */
#ifdef VMS
  img_fft_fill_rob(temp_buffer, &numCols, &numRows, 
		   fftImage_buffer2, 
		   &fftSize, &fftSize, &thisBackground);
  
  fft_2d_rob (fftImage_buffer2, &fftSize, &fftSize,
	      &ksign, &iform);
#else	      
  /* only if forward FFT */
  if (ksign == FFT_FORWARD) 
    {
      img_fft_fill_rob_(temp_buffer, &numCols, &numRows, 
			fftImage_buffer2, 
			&fftSize, &fftSize, &thisBackground);
    }
  fft_2d_rob_ (fftImage_buffer2, &fftSize, &fftSize,
	       &ksign, &iform);
#endif

  free(temp_buffer);
/*  free(fftImage_buffer2); */

}/* CALCFFT */


/******************************************************
 * calcStats() - Calculates statistics from the image
*/
void calcStats(float *inbuffer, int *img_bkg, int *img_min,
	  int *img_max, float *img_avg, float *img_std,
	  int width, int height, int boxWidth)
{/* CALCSTATS */
  int i,j;
  int pixelValue,tot;
  float totValues;
  double var,sumsq;

  /* Init all */
  *img_bkg = 0;
  *img_min = 9999;
  *img_max = -9999;
  *img_avg = 0;
  *img_std = 0;

  /* Accumulate intermediate values */
  totValues = tot = 0;
  var = sumsq = 0.0;
  for(i=0;i<height;i++)
    {/* height */
      for(j=0;j<width;j++)
	{/* Look at all pixels */
	  pixelValue = (int)inbuffer[((i*width)+j)];
	  if(pixelValue > 0) 
	    {/* Only use non-zeros */
	      *img_min = MIN(*img_min,pixelValue);
	      *img_max = MAX(*img_max,pixelValue);
	      sumsq += (pixelValue * pixelValue);
	      totValues +=  (float)pixelValue;
	      tot++;
	    }/* Only use non-zeros */
	}/* Look at all pixels */
    }/* height */
  
  /* Calc the background */
    *img_bkg= (short)calcBackground(inbuffer, width, height, boxWidth );


  /* Calc stats */
  *img_avg = (float)((float)totValues / (float)(width * height));
  *img_std = 0.0;
  var = (sumsq / (float)(width*height)) - (*img_avg * *img_avg);
  if(var > 0.0)
    *img_std = (float)sqrt(var);
  else *img_std = (float)sqrt(fabs(var));

}/* CALCSTATS */

/********************************************************
 * calcBoxI4Stats() - Calculates statistics from the MAP.
*/
void calcBoxI4Stats(float *inbuffer, int *img_bkg, float *map_min,
	  float *map_max, float *img_avg, float *img_std,
	  int width, int height, int nSecs)
{/* calcBoxI4Stats */
  int i,j,k;
  int tot;
  float totValues;
  double var,sumsq;
  float pixelValue;
  float totBkgValues;
  int   totBkg;

  /* Init all */
  *img_bkg = 0;
  *map_min =  *map_max = inbuffer[0];
  *img_avg = 0.0;
  *img_std = 0.0;

  /* Accumulate intermediate values */
  totValues = 0.0;
  tot = 0;
  totBkgValues = 0.0;
  totBkg = 0;
  var = sumsq = 0.0;
  for(k=0;k<nSecs;k++)
    {/* Do all secs */
      for(i=0;i<height;i++)
	{/* height */
	  for(j=0;j<width;j++)
	    {/* Look at all pixels */
	      pixelValue = (float)inbuffer[((k*height*width)+(i*width)+j)];
	      /* Use non-zeros also */
	      *map_min = MIN(*map_min,pixelValue);
	      *map_max = MAX(*map_max,pixelValue);
	      sumsq += (pixelValue * pixelValue);
	      totValues +=  (float)pixelValue;
	      tot++;
	      if(i==0 || j==0 || (i==(height-1)) || (j==(width-1)))
		{/* Use for bkg */
		  totBkgValues += (float)inbuffer[((k*height*width)+
						   (i*width)+j)];
		  totBkg++;
		}/* Use for bkg */
	    }/* Look at all pixels */
	}/* height */
    }/* Do all secs */
  
  /* Calc the background */
  if(totBkg > 0)
    *img_bkg= (float)(totBkgValues/(float)totBkg);

  /* Calc stats */
  *img_avg = (float)((float)totValues / (float)(width * height * nSecs));
  *img_std = 0.0;
  var = (sumsq / (float)(width * height * nSecs)) - (*img_avg * *img_avg);
  if(var > 0.0)
    *img_std = (float)sqrt(var);

}/* calcBoxI4Stats */
/**************************************************************
 * calcBackground() - Calculate statistics about the image.
 * Used by the stuffDisplayBoxBuffer() routine(s) to mask the
 * background of the boxed images.
*/
int calcBackground(float *inBuf, int width, int height, int boxWidth )
{/* CALCBACKGROUND */
  int i,j,totPnts,xcen,ycen,iMycen,jMxcen,thisRadius;
  float absTmp,back,std,avg,var,sumSq,distnce,cutOff,tmp,xSq,ySq;
  float recipSizeFactor;
  float b1;

  /* Init the background value */
  back = 0.0;
  thisRadius= ( (width - 1) / 2);
  recipSizeFactor = 1.0;

  /* Which method do they want? */
  sumSq = 0.0;
  back = 0.0;
    {/* Average it */
	{/* Calc for circle boxes */
	  xcen = ycen = thisRadius;
	  totPnts = 0;
	  for(i=0;i<height;i++)
	    for(j=0;j<width;j++)
	      {/* Look at all pixels */

		b1= inBuf[((i*boxWidth)+j)];
		iMycen = (i*recipSizeFactor)-ycen;
		jMxcen = (j*recipSizeFactor)-xcen;
		xSq= (iMycen)*(iMycen);
		ySq= (jMxcen)*(jMxcen);
		distnce = (float)sqrt((double)(xSq+ySq)); 
		if(distnce>=thisRadius && ((distnce-1.0)<= thisRadius))
		  {/* we've found one on the thisRadius */
		    tmp  =  (float)b1;
		    back += tmp;
		    totPnts++;
		    sumSq += (float)((float)tmp*(float)tmp);
		}/* we've found one on the thisRadius */
	      }/* Look at all pixels */

	  std     = 0.0;
	  avg = 0.0;
	  if(totPnts > 0)
	    {/* OK to do */
	      avg     = back/totPnts;
	      var     = (sumSq/totPnts) - (avg*avg);
	      if(var >= 0.0) 
		std = sqrt(var);
	    }/* OK to do */
	  
	/*'****************************************************'
	 *'*  Throw out data points more than 2*STD from AVG  *'
	 *'****************************************************'*/
	  back   = 0.0;
	  totPnts = 0;
	  sumSq  = 0.0;

	  /* We need to throw away the "dark" stuff because that is
	   * likely where the adjoining particle is contributing to our
	   * concept of background */
#ifdef ORIG_ROWKS
	  cutOff= avg + (2.0*std);
#else
	  cutOff= avg - (2.0*std);
#endif
	  for(i=0;i<height;i++)
	    for(j=0;j<width;j++)
	      {/* Look at all pixels */
		b1 = inBuf[((i*boxWidth)+j)];
		tmp= (float)b1;
		iMycen = (i*recipSizeFactor)-ycen;
		jMxcen = (j*recipSizeFactor)-xcen;
		xSq= (iMycen)*(iMycen);
		ySq= (jMxcen)*(jMxcen);
		distnce = (float)sqrt((double)(xSq+ySq)); 
		if(distnce>=thisRadius && ((distnce-1.0)<= thisRadius))
		  {/* we've found one on the thisRadius */
		    if(tmp < avg)
		      absTmp = avg + (avg - (float)tmp);
		    else absTmp = (float)tmp;
#ifdef ORIG_ROWKS
		    if(absTmp <= cutOff) 
#else
		    if(absTmp > cutOff) 
#endif
		      {/* then       */
			back   += tmp;
			totPnts++;
			sumSq  += (tmp*tmp);
		      }/* then       */
		}/* we've found one on the thisRadius */
	      }/* Look at all pixels */

	  std = 0.0;
	  avg = 0.0;
	  if(totPnts > 0)
	    {/* OK to do */
	      avg = back/totPnts;
	      var = (sumSq/totPnts) - (avg*avg);
	      if(var >= 0.0) 
		std = sqrt(var);
	    }/* OK to do */
	  
	  back = (int)(avg);
	  
	}/* Calc for circle boxes */
    }/* Average it */
  
  return((int)back);
			    
}/* CALCBACKGROUND */



/*************************************************************
 * calcScaleFactor() - Calculate the factor needed to convert
 * out floatIntegers into floats when we read this file later.
 * Just scan all of our values and pick a value that maintains 
 * out dynamic rarenge.
*/
void calcScaleFactor(float *floatScaleFactor, 
		     float *recipFloatScaleFactor, 
		     float img_min, float img_max,
		     float img_avg, float img_std,
		     int fileType)
{/* CALCSCALEFACTOR */
  float minVal,maxVal;
#define MAXINT   2147483647    
#define MAXSHORT 32768

  minVal= img_avg;
  maxVal= img_avg;

  minVal= MIN(minVal,img_min);
  minVal= MIN(minVal,img_max);
  minVal= MIN(minVal,img_avg);
  minVal= MIN(minVal,img_std);

  maxVal= MAX(maxVal,img_min);
  maxVal= MAX(maxVal,img_max);
  maxVal= MAX(maxVal,img_avg);
  maxVal= MAX(maxVal,img_std);

  /* Get greatest magnitude */
  if(minVal < 0.0)
    minVal = 0.0 - minVal;
  maxVal = MAX(minVal,maxVal);
  /* Now let's give it a little extra so we're guaranteed not
   * to run over the top */
  maxVal *= 1.02;

  *floatScaleFactor = (double)((double) MAXINT / (double) maxVal);

  *recipFloatScaleFactor = (double)((double)1.0 / (double)*floatScaleFactor); 

}/* CALCSCALEFACTOR */






/*************************************************************************/

int main(int argc, char **argv)
{/* MAIN */
  int       ii,jj,i,j,k;
  fString_t fName,readWrite,descrStrF;
  fString_t fName2,readWrite2,descrStrF2;
  int       luNum,luNum2,fftSize;
  int       img_bkg;
/*  imgHead_t imageOffsets[32]; */
  int       nimg, htype, numCols, numRows, numSecs,
            mode, endianNess, img_min, img_max, imgOffset;
  int       fftCols,fftRows,fftSecs;
  int       thispixel, thisImg;
  int       ctfmode;
  float     map_min, map_max;
  float     phi;
  float     defocus;       /* in microns */
  float     floatScaleFactor, recipFloatScaleFactor, 
            img_avg, img_std, junkFloat;
  float     PixelSize, volts, waveLength, SphericalAbbr;
  float     ampContrast;
  float     floatscale, maxval, minval;
  char      versionStr[55];
  char      descriptionStr[128];
  char      timeStr[128];
  char      micrographStr[128];
  char      scanNumberStr[128];
  char      inPutString[512];
  float     *fft_float_buffer, *img_float_buffer;
  BYTE      *byte_buffer;
  forPifHead_t outputHeader;


  if(argc < 3)
    {/* Usage */
      printf("USAGE  ctf-image my-box.pif my-box.prf\n\
       (input is PIF, output is I4 PIF (prf == purdue 'real' format))\n\n");
      exit(0);
    }/* Usage */

/* info for input file */
  fName.addr = (char *)malloc(sizeof(char)*64);
  sprintf(fName.addr,"a_onebox.pif");
  sprintf(fName.addr,argv[1]);
  readWrite.addr = (char *)malloc(sizeof(char)*4);
  sprintf(readWrite.addr,"r");
  descrStrF.addr = (char *)malloc(sizeof(char)*1024);
  printf("Input file %s\n", fName.addr);

/* info for output file */
  fName2.addr = (char *)malloc(sizeof(char)*64);
  sprintf(fName2.addr,argv[2]);
  readWrite2.addr = (char *)malloc(sizeof(char)*4);
  sprintf(readWrite2.addr,"w");
  descrStrF2.addr = (char *)malloc(sizeof(char)*1024);
  printf("Output file %s\n", fName2.addr);

  printf("\nWhat is the defocus (in microns, with underfocus positive)\n");
  scanf("%s",inPutString);
  defocus = (float)strtod(inPutString,0);
  if (defocus < 0.0)
    printf("Warning: underfocus is positive\n");

  printf("\nWhat is the spherical abbration (in mm)\n");
  scanf("%s",inPutString);
  SphericalAbbr = (float)strtod(inPutString,0);

  printf("\nWhat is the amplitude contrast (0.0 to 1.0)\n");
  scanf("%s",inPutString);
  ampContrast = (float)strtod(inPutString,0);
  if( (ampContrast < 0.0) || (ampContrast > 1.0) )
    { 
      printf("\n out of range for amplitude contrast, setting to 0.0\n");
      ampContrast = 0.0;
    }

  printf("\nWhat is the pixel size (in Angstroms)\n");
  scanf("%s",inPutString);
  PixelSize = (float)strtod(inPutString,0);

  printf("\nWhat is the voltage (in kV)\n");
  scanf("%s",inPutString);
  volts = (float)strtod(inPutString,0);
 
  volts *= 1000;


  luNum = 7;
#ifdef VMS
  pif_open_vms_(&fName, &luNum, readWrite.addr);
#else
  pif_open_(fName.addr, &luNum, readWrite.addr);
#endif

  if(!pif_read_header_(&luNum,
		       &nimg,
		       &recipFloatScaleFactor,
		       &htype, &numCols, &numRows, &numSecs,
		       &mode, &endianNess, versionStr))
    {/* Error */
      printf("Trouble reading header [%s].\n",fName.addr);
      exit(0);
    }/* Error */


/* what is luNum? */
/* luNum is a 'flag' for each open file, a different number for each one*/
  luNum2 = 17;

#ifdef VMS
  pif_open_vms_(&fName2, &luNum2, readWrite2.addr);
#else
  pif_open_(fName2.addr, &luNum2, readWrite2.addr);
#endif

/* Could be bad ...
  pif_write_header_(&luNum2,
		   &nimg,
		   &recipFloatScaleFactor,
	           &htype, &numCols, &numRows, &numSecs,
		   &mode, &endianNess, versionStr);
*/

  if (numCols <= 128)
    {
      fftSize = 128;
    }
  else if (numCols <= 256)
    {
      fftSize = 256;
    }
  else if (numCols <= 512)
    {
      fftSize = 512;
    }
  else
    {
      fftSize = 1024;
    }
  /* Init these for FFT's */
  fftSecs = 1;
  fftCols= fftSize;
  fftRows= fftSize;
  printf("FFT size = %d\n", fftSize);

  /* for write_boxi4 */
  mode = 46;
  
  /* Initialize the header with some default values */
  pif_init_head(&outputHeader);
  
  /* Now stuff it with what we've got here */
  outputHeader.luNum = luNum2;
  outputHeader.numCols = numCols;
  outputHeader.numRows = numRows;
  outputHeader.numSecs = 1;
  outputHeader.mode = 46;
  outputHeader.htype = 1;
  outputHeader.nimg = nimg;
  
  /* Write the big kahuna global header */
  pif_write_gh(&outputHeader);
  
  /* Only need to do this once ... */
  byte_buffer = (BYTE *)malloc(sizeof(BYTE)*(numCols*numRows*numSecs));
  fft_float_buffer = (float *)malloc(sizeof(float)*(fftSize*fftSize*2));
  img_float_buffer = (float *)malloc(sizeof(float)*(numCols*numRows*nimg));
  
  
  if (fft_float_buffer == NULL) {
    printf("malloc of fft_float_buffer returned a NULL pointer\n");
    exit(22);
  }
  if (byte_buffer == NULL) {
    printf("malloc of byte_buffer returned a NULL pointer\n");
    exit(23);
  }
  if (img_float_buffer == NULL) {
    printf("malloc of img_float_buffer returned a NULL pointer\n");
    exit(23);
  }
  
  for(i=0; i < nimg; i++) 
    {/* Do all images */
      printf("processing image %d\n",i);
      /* header of image i */
      thisImg = i+1;  /* For FORTRAN */
      pif_read_image_header_(&luNum, &thisImg,
			     &recipFloatScaleFactor,
			     &img_bkg, &img_min, &img_max,
			     &img_avg, &img_std,
			     &numCols, &numRows, &numSecs,
			     &imgOffset, &mode,
			     &htype, &descrStrF);
      
      /*      imageOffsets[i].header= imgOffset; */
      /*printf("before malloc, fftSize = %d, numCols = %d\n", fftSize, numCols);*/

      pif_read_byte_image_(&luNum, byte_buffer,
			   &imgOffset,
			   &numCols, &numRows, &numSecs);
      /*      imageOffsets[i].image= imgOffset;*/
      
      /* transform each image */
      calcfloatFFT(byte_buffer, fft_float_buffer, 
		   numCols,numRows,img_bkg,fftSize, FFT_FORWARD);
      printf("transformed image %d\n", i);
      
      ctfmode = 1;
      phi = 0.0;

      apply_ctf_rtn(&ctfmode, fft_float_buffer,&numCols, 
		    &numRows, &fftSize, &fftSize, &i, 
		    &volts, &PixelSize,
		    &ampContrast,
		    &defocus, &defocus,
		    &phi, &SphericalAbbr
		    );
      
      /* back transform each image */
      calcfloatFFT(byte_buffer, fft_float_buffer, 
		   numCols,numRows,img_bkg,fftSize, FFT_BACKWARD);
      printf("back transformed image %d\n", i);
  
/******************************************************************/
/*  None of the next section is necessary due to use of int4 image */
/*******************************************************************/
    
      /* find min and maximum value in new real image */
/*      maxval = 0.0;
 *     minval = 100.0;
 *     for(ii=0; ii < numCols; ii++) 
*	{
*	  for(jj=0; jj< numRows; jj++) 
*	    {
*	      thispixel = (int)( (ii * ( fftSize * 2 )) + (2 * jj));
*	      if ( fft_float_buffer[thispixel] > maxval) 
*		maxval = fft_float_buffer[thispixel];	      
*	      if ( fft_float_buffer[thispixel] < minval )
*		minval = fft_float_buffer[thispixel];
*	    }
*	}
*/
      /* to stretch contrast to 254 values */
/*      floatscale = 253.0 / (maxval - minval);
 *     
 *     printf("min %f, max %f, scale %f\n", minval, maxval, floatscale);
 */     
      /* set image background to middle */
/*      img_bkg = 127;
 */     
      /* stuff image into byte_buffer */
/*      for(ii=0; ii < numCols; ii++)*/ 
/*	{*/ /* end ii */
/*	  for(jj=0; jj< numRows; jj++) 
*	    {
*	      thispixel = (int)( (ii * ( fftSize * 2 )) + (2 * jj));
*	      byte_buffer[(ii * numCols)+jj] = img_bkg;
*/	      /*	fft_float_buffer[thispixel] += (float)(img_bkg); */
/* chose one of the next two options */
	      /* stretch to max contrast */
/*	      byte_buffer[(ii * numCols)+jj] = 
*		rint((fft_float_buffer[thispixel] - minval) * floatscale);
*	      byte_buffer[(ii * numCols)+jj] += 1;
*/	      
/* no contrast stretching */
	      /* check to make sure not out of bounds */
/*	      if ((img_bkg + rint(fft_float_buffer[thispixel])) > 254)
*		{
*		  byte_buffer[(ii * numCols)+jj] = 254;
*		}
*	      else
*		{
*		  if ((img_bkg + rint(fft_float_buffer[thispixel])) < 2)
*		    {		
*		      byte_buffer[(ii * numCols)+jj] = 2;
*		    }
*		  else
*		    {
*		      byte_buffer[(ii * numCols)+jj] += 
*			rint(fft_float_buffer[thispixel]);
*		    }
*		}
*/
/*	      byte_buffer[(ii*numCols)+jj] += 
*		rint(fft_float_buffer[thispixel]);
*/	      
	   /* }*/ /* end jj */
	/* }*/ /* end ii */
      
      /* move from fft_float_buffer to img_float_buffer */

      for(ii=0; ii < numCols; ii++) 
	{ /* ii */
	  for(jj=0; jj< numRows; jj++) 
	    {
	      thispixel = (int)( (ii * ( fftSize * 2 )) + (2 * jj));
	      img_float_buffer[(i*numCols*numRows)+(ii * numCols)+jj] = 
		fft_float_buffer[thispixel] + (float)img_bkg;      
	    } /* end jj */
	} /* end ii */
      
    }/* Do all images */


  calcBoxI4Stats(img_float_buffer, 
		 &img_bkg, &map_min,
		 &map_max, &img_avg, &img_std,
		 numCols, numRows, nimg);
  
  printf("map_min map_max [%f,%f]\n",map_min,map_max);


  calcScaleFactor(&floatScaleFactor, 
		  &recipFloatScaleFactor, 
		  map_min, map_max,
		  img_avg, img_std,
		  0); 


  /* Now stuff it with what we've got here */
  outputHeader.floatScaleFactor = (float)floatScaleFactor;
  printf("outputHeader.floatScaleFactor = %f\n", 
	 outputHeader.floatScaleFactor);
  outputHeader.recipFloatScaleFactor =(float)(1.0/
					      (float)floatScaleFactor);
  printf("outputHeader.recipFloatScaleFactor = %f\n", 
	 outputHeader.recipFloatScaleFactor);
  outputHeader.img_bkg = img_bkg;
  printf("outputHeader.img_bkg = %d\n", outputHeader.img_bkg);
#ifdef STEVE_WAY
  outputHeader.datai4_min = (int)rint(map_min);
#else
  outputHeader.datai4_min = (int)(map_min);
#endif
  printf("outputHeader.datai4_min = %d\n", outputHeader.datai4_min);
#ifdef STEVE_WAY
  outputHeader.datai4_max = (int)rint(map_max);
#else
  outputHeader.datai4_max = (int)(map_max);
#endif
  printf("outputHeader.datai4_max = %d\n", outputHeader.datai4_max);
  outputHeader.datar4_min = map_min;
  printf("outputHeader.datar4_min = %f\n", outputHeader.datar4_min);
  outputHeader.datar4_max = map_max;
  printf("outputHeader.datar4_max = %f\n", outputHeader.datar4_max);
  outputHeader.datar4_avg = img_avg;
  printf("outputHeader.datar4_avg = %f\n", outputHeader.datar4_avg);
  outputHeader.datar4_std = img_std;
  printf("outputHeader.datar4_std = %f\n", outputHeader.datar4_std);
  
  /* Write the big kahuna global header */
  pif_write_gh(&outputHeader);
  

  for(i=0; i < nimg; i++) 
    {/* Do all images */

      printf("Writing image %d\n",i);

      calcBoxI4Stats((img_float_buffer+(i*numCols*numRows)), 
		     &img_bkg, &map_min,
		     &map_max, &img_avg, &img_std,
		     numCols, numRows, 1);
      
      printf("map_min map_max [%f,%f]\n",map_min,map_max);

      outputHeader.img_bkg = img_bkg;
#ifdef STEVE_WAY
      outputHeader.datai4_min = (int)rint(map_min);
      outputHeader.datai4_max = (int)rint(map_max);
#else
      outputHeader.datai4_min = (int)(map_min);
      outputHeader.datai4_max = (int)(map_max);
#endif
      outputHeader.datar4_min = map_min;
      outputHeader.datar4_max = map_max;
      outputHeader.datar4_avg = img_avg;
      outputHeader.datar4_std = img_std;
	  

      /* Write the header for this image */
      outputHeader.imgNum = i+1;
      pif_write_dh(&outputHeader);

      /* Now write the real data */
      pif_write_boxi4(&outputHeader, (img_float_buffer+(i*numCols*numRows)));

    }/* Do all images */
  
  free(byte_buffer);
  free(fft_float_buffer);
  free(img_float_buffer);
  
  pif_close_(&luNum);
  free(fName.addr);
  pif_close_(&luNum2);
  free(fName2.addr);
  
  printf("finished ok\n");
  
  
}/* MAIN */




