C *****************************************************************************
C	EMPFT SUBROUTINES
C *****************************************************************************
C
C	GLOBAL
C	GLOBAL_CC
C	REFINE
C	REFINE_CC
C
C	ADJUST_NVIEW_MOD
C	AVG_PFTIMG
C	CALC_AVGS
C       CALC_MOD_TPS
C       CALC_TP_MASK
C	FILL_PARAMS
C	FREEMEM0
C	FREEMEM1
C	FREEMEM2
C	FREEMEM3
C	FREEMEM4
C	FREEMEM_REFINE
C	GETMEM0
C	GETMEM1
C	GETMEM2
C	GETMEM3
C	GETMEM4
C	GETMEM_REFINE
C	GETMEM_REFINE2
C	GET_BESTMAG
C	GET_BESTPRJ
C	GET_ITHE2
C	GET_NVIEW_MOD
C	GET_PHIOMEGA
C	GET_PRJS_G
C	GET_PFTS_G
C	GET_PRJSPFTS_R
C	GET_THEPHI
C	GET_THEPHI_R
C	GET_TPO_G
C	GET_TPO_R
C	GET_T1T2P1
C	GET_XY
C	LIST_CCS
C	LOADSTATS_R
C	PFILE_INFO
C	PHIMAX
C	PRJAVG_FFT
C	SAVE_PRJS
C	WRITE_PARAMS
C
C	PFTCC
C	PFTCC_FILL_G
C	PFTCC_PEAK
C	CC_RADII
C	PFTCC_RES

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GLOBAL     *****                  *
C  *                                                                          *
C  *    GLOBAL SEARCH FOR THETA,PHI,OMEGA,X,Y PARAMETERS (MODE.NE.3)          *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    MODIFIED  3-FEB-1998 BY T. BAKER (Parameters in arrays).              *
C  *    MODIFIED 27-FEB-1998 BY T. BAKER (Add UNIX compatibility).            *
C  *    MODIFIED  1-JUN-1998 BY TSB/SBW (Add CTF routines).                   *
C  *    LAST MODIFIED 24-JUL-02 BY TSB/RWA (Fix COMPARE_MODE=1 bugs).         *
C  ****************************************************************************
C
	SUBROUTINE GLOBAL (NCOL, NROW, NSEC, NCOLBIN, NROWBIN, NSECBIN, 
	1 NROT, NANNULI, NPIX, NFILES, NIDS_TOT, FIDS, IDS, TS, PS, OS,
	2 XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, COMPARE_MODE, FILT_FAC)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/VAX_MINMAX.INC'
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	COMMON/PFT_COM/ MODE, BIN, ILIST, MAG_CEN, MAG_STEP, 
	1 MAG_NUM, MAG_NORM, XCEN_MODEL, YCEN_MODEL, SYM, DTHE, DPHI_90, 
	2 PFTRAD_LO, PFTRAD_HI, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, 
	3 ANN_HI, VAROPT, SIGCUT, RES_MIN, RES_MAX, IDIM1, IDIM2, RADIUS, 
	4 DEL_ANG, NVIEW_MOD, NTHE, NPHI, PARAM_FNAMES, IMG_FNAMES
C
	INTEGER*4 NCOL, NROW, NSEC, NCOLBIN, NROWBIN, NSECBIN, JCUT
	INTEGER*4 NROT, NANNULI, BIN, NTHE, NPHI, NVIEW_MOD, NPIX
	INTEGER*4 MODE, ILIST, SYM, IDIM1, IDIM2, MAG_NORM, MAG_NUM
	INTEGER*4 NFILES, ANN_LO, ANN_HI
	real*4    IMG_BKG
	real*4    IMG_MIN, IMG_MAX
	INTEGER*4 NIDS_TOT, FIDS(NIDS_TOT), IDS(NIDS_TOT), COMPARE_MODE
	CHARACTER PARAM_FNAMES(999)*256, IMG_FNAMES(999)*256
C
C	ARRAY POINTERS
C
	INTEGER*4 ITMP(1)
	REAL*4    MOD_TS(1), MOD_PS(1), PRJ_AVG(1), PRJS(1)
	REAL*4    MAP3D(1), PRJ(1), PROJN(1)
	POINTER   (MOD_TS_P,MOD_TS), (MOD_PS_P,MOD_PS), (ITMP_P,ITMP)
	POINTER   (PRJ_AVG_P,PRJ_AVG), (PRJ_P,PRJ)
	POINTER   (MAP3D_P,MAP3D), (PRJS_P,PRJS), (PROJN_P,PROJN)
C
	REAL*4  TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4  XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4  PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
        REAL*4  IMG_AVG, IMG_STD, RES_MIN, RES_MAX
	REAL*4  DTHE, DPHI_90, THE1, THE2, PHI1, XCEN_MODEL, YCEN_MODEL
	REAL*4  PFTRAD_LO, PFTRAD_HI, DEL_ANG, FILT_FAC(10)
	REAL*4  MAG_CEN, MAG_STEP, SIGCUT, RADIUS
	REAL*4  PIXRES_MIN, PIXRES_MAX
	LOGICAL VAROPT, MALLOC
C -----------------------------------------------------------------------------
C
	CALL GETMEM1 (NROT, NCOLBIN, NROWBIN, NVIEW_MOD, NPIX, PRJ_AVG_P, 
	1 PRJS_P, MOD_TS_P, MOD_PS_P, PRJ_P, PROJN_P, ITMP_P)
C  **************************************************************
C  *  Get THE1, THE2, & PHI1;                                   *
C  *  Calculate grid of model THETAs and PHIs in search window  *
C  **************************************************************
	CALL GET_T1T2P1 (SYM, THE1, THE2, PHI1)
	CALL CALC_MOD_TPS (MOD_TS, MOD_PS, THE1, THE2, PHI1, DTHE, 
	1  DPHI_90, NTHE, NPHI, NVIEW_MOD, SYM, MODE, mod_ts_p)

C  ***********************************************************************
C  *  MODE.GT.0:        Calculate projections.                           *
C  *  MODE.EQ.-1 or -2: Use PRJs already stored on disk.                 *
C  *                                                                     *
C  *  Unless MODE = -1 or -2, read entire 3D MAP into core memory.       *
C  ***********************************************************************

	IF(MODE.LT.0) GO TO 800
	MAP3D_P = MALLOC (4*NCOLBIN*NROWBIN*NSECBIN)
	IF(MAP3D_P.EQ.0) THEN
	  PRINT *, '**********************************************'
	  PRINT *, '* Not enough memory for 3D map: EXIT program *'
	  CALL TSBEND
	ENDIF
	CALL PIF_READ_WMAPI2 (MAPHEAD, MAP3D, NCOLBIN, NROWBIN, NSECBIN)
        CALL PIF_CLOSE (1)
	CALL GET_PRJS_G (NVIEW_MOD, NCOLBIN, NROWBIN, NSECBIN, PROJN,
	1 PRJ, MAP3D, MOD_TS, MOD_PS, PRJ_AVG, ITMP, PRJS)
Ca	   print *, 'get_prjs_g - ', ncolbin, nrowbin
Ca	   call pif_debug_write(prj_avg,ncolbin,nrowbin)
Ca	   call tsbend
	CALL FREE (MAP3D_P)
C  ***********************************
C  *  Determine THETA,PHI,OMEGA,X,Y  *
C  ***********************************
 800	CALL GLOBAL_CC (MODE, BIN, NROT, NANNULI, NVIEW_MOD, DTHE,
	1 DPHI_90, THE1, PHI1, IDIM1, IDIM2, RES_MIN, RES_MAX, 
	2 PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, JCUT, RADIUS, NTHE, 
	3 NPHI, SYM, ILIST, MAG_CEN, NFILES, MAG_STEP, MAG_NUM, 
	4 MOD_TS, MOD_PS, IMG_BKG, IMG_MIN, IMG_MAX, IMG_AVG, IMG_STD,
	5 PRJ_AVG, PRJS, PRJ, VAROPT, NCOLBIN, NROWBIN, NSECBIN,
	6 NIDS_TOT, PARAM_FNAMES, IMG_FNAMES, FIDS, IDS, TS, PS, OS, 
	7 XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, COMPARE_MODE, FILT_FAC,
	8 SIGCUT, NPIX, XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, PFTRAD_HI,
	9 PROJN, ITMP)
C
  900	CALL FREEMEM1 (PRJ_AVG_P, PRJS_P, MOD_TS_P, MOD_PS_P,
	1 PROJN_P, PRJ_P, ITMP_P)
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE REFINE     *****                  *
C  *                                                                          *
C  *    REFINE THETA,PHI,OMEGA,X,Y PARAMETERS (MODE.EQ.3).                    *
C  *                                                                          *
C  *    APRIL 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.          *
C  *                                                                          *
C  *    MODIFIED  4-MAY-1998 BY T. BAKER (Sliding window code).               * 
C  *    LAST MODIFIED  4-DEC-98 BY SBW (Add FFT6 for CTF stuff).              *
C  ****************************************************************************
C
	SUBROUTINE REFINE (NCOL, NROW, NSEC, NCOLBIN, NROWBIN, NSECBIN, 
	1 NROT, NANNULI, NPIX, NFILES, NIDS_TOT, FIDS, IDS, TS, PS, OS, 
	2 XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, COMPARE_MODE, PI, RADIAN)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/VAX_MINMAX.INC'
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	COMMON/PFT_COM/ MODE, BIN, ILIST, MAG_CEN, MAG_STEP, 
	1 MAG_NUM, MAG_NORM, XCEN_MODEL, YCEN_MODEL, SYM, DTHE, DPHI_90, 
	2 PFTRAD_LO, PFTRAD_HI, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, 
	3 ANN_HI, VAROPT, SIGCUT, RES_MIN, RES_MAX, IDIM1, IDIM2, RADIUS, 
	4 DEL_ANG, NVIEW_MOD, NTHE, NPHI, PARAM_FNAMES, IMG_FNAMES
C
	INTEGER*4 I, NCOL, NROW, NSEC, NCOLBIN, NROWBIN, NSECBIN, JCUT
	INTEGER*4 FILE, FILE_LAST, NUNIQUE, NVIEW_THISIMG, ITHE1, ITHE2
	INTEGER*4 NROT, NANNULI, BIN, NTHE, NPHI, NVIEW_MOD, NPIX
	INTEGER*4 MODE, ILIST, SYM, IDIM1, IDIM2, MAG_NORM, MAG_NUM
	INTEGER*4 NFILES, ANN_LO, ANN_HI
	real*4    IMG_MIN, IMG_MAX
	INTEGER*4 N_INCORE, NIDS_TOT, FIDS(NIDS_TOT), IDS(NIDS_TOT)
	INTEGER*4 WINDOW, OFFSET, IMG_NUM, IMG_NUM1, IMG_LAST, COMPARE_MODE
	real*4    IMG_BKG
	REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
        REAL*4    IMG_AVG, IMG_STD, RES_MIN, RES_MAX, SIGCUT, RADIUS
	REAL*4    DTHE, DPHI_90, THE1, THE2, PHI1, XCEN_MODEL, YCEN_MODEL
	REAL*4    PFTRAD_LO, PFTRAD_HI, DEL_ANG, MAG_CEN, MAG_STEP, PHIMAX
	REAL*4    PIXRES_MIN, PIXRES_MAX, THE_MAX, PI, RADIAN
	CHARACTER PARAM_FNAMES(999)*256, IMG_FNAMES(999)*256
	CHARACTER IMG_FILENAME*256
	BYTE      READWRITE(4)
	LOGICAL   VAROPT, MALLOC, SLIDE
C
C	ARRAY POINTERS
C
	real*4    IMG(1), MSKIMG(1)
	INTEGER*4 ITMP(1), MASK(1)
	REAL*4    MOD_TS(1), MOD_PS(1), PFTS(1), PMAP(1), DPHIS(1)
        REAL*4    MAP3D(1), PRJ(1), PRJS(1), PROJN(1), PFFT(1)
	REAL*4    PFT_AVGS(1), TMP(1), SQ2(1), VAR(1), RMS(1), AVER(1)
	REAL*4    FFT1(1), FFT3(1), FFT4(1), FFT5(1), FFT6(1), R4_IMG(1)
	REAL*4    BESTPRJ(1), PRJ_ROT(1), CCOR(1), MSKPRJ(1)
	REAL*4    R4_PIMG(1), FLTPMAP(1), POLAR_PRJ(1)
	REAL*4    TMP1(1), TMP2(1), TMP3(1), A_ARRAY(1), PFTIMG(1)
	POINTER   (MOD_TS_P,MOD_TS), (MOD_PS_P,MOD_PS), (ITMP_P,ITMP)
	POINTER   (PFTS_P,PFTS), (PFFT_P,PFFT), (PMAP_P,PMAP)
        POINTER   (MAP3D_P,MAP3D), (PRJS_P,PRJS), (PROJN_P,PROJN)
	POINTER   (PFT_AVGS_P,PFT_AVGS), (TMP_P,TMP), (SQ2_P,SQ2)
	POINTER   (PRJ_P,PRJ), (VAR_P,VAR), (RMS_P,RMS), (AVER_P,AVER)
	POINTER   (IMG_P,IMG), (DPHIS_P,DPHIS), (MASK_P,MASK)
	POINTER   (FFT1_P,FFT1), (FFT3_P,FFT3), (A_ARRAY_P,A_ARRAY)
	POINTER   (FFT4_P,FFT4), (FFT5_P,FFT5), (FFT6_P,FFT6)
	POINTER   (FLTPMAP_P,FLTPMAP)
	POINTER   (R4_IMG_P,R4_IMG), (BESTPRJ_P,BESTPRJ)
	POINTER   (PRJ_ROT_P,PRJ_ROT), (POLAR_PRJ_P,POLAR_PRJ)
	POINTER   (PFTIMG_P,PFTIMG), (R4_PIMG_P,R4_PIMG)
	POINTER   (TMP1_P,TMP1), (TMP2_P,TMP2), (TMP3_P,TMP3)
	POINTER   (CCOR_P,CCOR), (MSKIMG_P,MSKIMG), (MSKPRJ_P,MSKPRJ)
C -----------------------------------------------------------------------------
C
C  ****************************************************
C  *    GET THETA BOUNDS ON GRID VALUES               *
C  *    DETERMINE SIZE OF MASK ARRAY (2,NPHI,NTHE)    *
C  ****************************************************
	THE1 = (NINT( (TS(1) - INT(TS(1))) /DTHE) * DTHE) + INT(TS(1)) 
	1 - 3*DTHE
	THE2 = (NINT( (TS(NIDS_TOT) - INT(TS(NIDS_TOT))) /DTHE) * DTHE) 
	1 + NINT(TS(NIDS_TOT)) + 3*DTHE
	IF(THE1.LT.0.0)   THE1 =   0.0
	IF(THE2.GT.180.0) THE2 = 180.0
	NTHE = NINT((THE2-THE1)/DTHE) + 1
	NPHI = NINT((PHIMAX(SYM,90.)/DPHI_90)) + 1 + 3 	  ! "+3" to allow extra
	NVIEW_MOD = NTHE*NPHI		       ! Mask built for NVIEW_MOD views
C  **********************************************************************
C  *  Allocate virtual memory and read entire 3D MAP into core memory.  *
C  **********************************************************************
	CALL GETMEM_REFINE (NPIX, NROT, NANNULI, NCOLBIN, NROWBIN, 
	1 NSECBIN, NTHE, NPHI, IDIM1, IDIM2, MAP3D_P, MOD_TS_P, MOD_PS_P, 
	2 IMG_P, R4_IMG_P, R4_PIMG_P, PRJ_P, PROJN_P, BESTPRJ_P, PMAP_P, 
	3 PFFT_P, VAR_P, RMS_P, AVER_P, MASK_P, DPHIS_P, FFT1_P, FFT3_P, 
	4 FFT4_P, FFT5_P, FFT6_P, MSKIMG_P, MSKPRJ_P, PRJ_ROT_P, PFTIMG_P, 
	5 FLTPMAP_P, POLAR_PRJ_P, A_ARRAY_P, ITMP_P, TMP_P, TMP1_P, 
	6 TMP2_P, TMP3_P)
	CALL PIF_READ_WMAPI2 (MAPHEAD, MAP3D, NCOLBIN, NROWBIN, NSECBIN)
        CALL PIF_CLOSE (1)
	CALL CALC_TP_MASK (NTHE, NPHI, NIDS_TOT, TS, PS, MOD_TS, MOD_PS, 
	1 MASK, DPHIS, THE1, THE2, DTHE, DPHI_90, NUNIQUE)
ccc	call pif_write_debugi4 ('mask.pif', mask, nphi, nthe)
C  **************************************************************************
c  *    Allocate memory for PRJS and PFTS arrays                            *
C  *    If not enough, for now STOP program. Later add SLIDING WINDOW code  *
C  **************************************************************************
	CALL GETMEM_REFINE2 (NUNIQUE, N_INCORE, NCOLBIN, NROWBIN, NTHE, 
	1 NPHI, NPIX, CCOR_P, PFT_AVGS_P, SQ2_P, PRJS_P, PFTS_P, MASK, 
	2 ITHE2, SLIDE)
	ITHE1         = 1
	THE_MAX       = MOD_TS(ITHE2)-3*DTHE  ! MAX THETA ALLOWED THIS WINDOW
	WINDOW        = 0
	OFFSET        = 0
	FILE_LAST     = FIDS(1)
	IMGHEAD.LUNUM = 7                       ! UNIT FOR INPUT IMAGE FILE
	READWRITE(1)  = 'r'
C  **********************************************************
C  *    OPEN UP THE VERY FIRST IMAGE FILE AND ITS HEADER    *
C  **********************************************************
	IMG_NUM1     = 1
	FILE         = FIDS(1)
	IMG_FILENAME = IMG_FNAMES(FILE)
	CALL PIF_OPEN (IMG_FILENAME, IMGHEAD.LUNUM, READWRITE)
	CALL PIF_READ_GH (IMGHEAD)
C
  100	WINDOW = WINDOW + 1
	IF(WINDOW.GT.1) PRINT *, 'Processing window', WINDOW
C         ******************************************************
C---------*  Calculate PRJS and PFTS in current search window  *
C         ******************************************************
	  CALL GET_PRJSPFTS_R (NTHE, NPHI, N_INCORE, NCOLBIN, NROWBIN, 
	1  NSECBIN, NROT, NANNULI, PROJN, PRJ, PRJS, MAP3D, MOD_TS, 
	2  MOD_PS, ITMP, PMAP, XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, 
	3  PFTRAD_HI, DEL_ANG, PFFT, A_ARRAY, PFTS, MASK, ITHE1, ITHE2, 
	4  OFFSET, COMPARE_MODE, IDIM1, IDIM2, FFT6, BIN, PI, RADIAN)
C         *******************************************
C---------*    MAIN LOOP THROUGH NIDS_TOT IMAGES    *
C         *******************************************
	  DO IMG_NUM = IMG_NUM1,NIDS_TOT
	    IMG_LAST = IMG_NUM
	    IF(TS(IMG_NUM).GT.THE_MAX) GO TO 800     ! TRAP FOR TOO LARGE THETA 
	    FILE         = FIDS(IMG_NUM)
	    IMG_FILENAME = IMG_FNAMES(FILE)
C	    *********************************************
C-----------*    OPEN THE CORRECT IMAGE DATA FILE       *
C	    *********************************************
	    IF(FILE_LAST.NE.FILE) THEN               ! CLOSE CURRENT IMAGE FILE
	      CALL PIF_CLOSE (IMGHEAD.LUNUM)
	      CALL PIF_OPEN (IMG_FILENAME, IMGHEAD.LUNUM, READWRITE)
	      CALL PIF_READ_GH (IMGHEAD)
	      FILE_LAST = FILE
	    ENDIF
C	    ***********************
C-----------*  Read in raw IMG    *
C	    ***********************
	    IMGHEAD.IMGNUM = IDS(IMG_NUM)        ! SPECIFY WHICH "IMG" YOU WANT
	    CALL PIF_READ_DH (IMGHEAD)
	    IMG_BKG = IMGHEAD.IMG_BKG
	    if(imgHead.mode .eq. 6) then
Ca	       CALL PIF_READ_IMGI1 (IMGHEAD, IMG, NCOLBIN, NROWBIN, 
Ca	1            IDS(IMG_NUM))
	       print *, '*************************************************'
	       print *, ' Error - Image data must be in mode==46 float.'
	       print *, '*************************************************'
	       call tsbend
	    else if(imgHead.mode .eq. 7) then
Ca	       CALL PIF_READ_IMGI2 (IMGHEAD, IMG, NCOLBIN, NROWBIN, 
Ca	1            IDS(IMG_NUM))
	       print *, '*************************************************'
	       print *, ' Error - Image data must be in mode==46 float.'
	       print *, '*************************************************'
	       call tsbend
	    else if(imgHead.mode .eq. 46) then
	       print *, 'Calling pif_read_imgi4 - ', ncolbin,nrowbin
	       CALL PIF_READ_IMGI4 (IMGHEAD, IMG, NCOLBIN, NROWBIN, 
	1            IDS(IMG_NUM))
	       call tsbend
	    else
	       print *, 'Invalid PIF mode - ', imgHead.mode
	       call tsbend
	    endif
C	    ********************************************
C-----------*  Load PFT_AVGS and SQ2 for this IMAGE    *
C           ********************************************
	    CALL LOADSTATS_R (N_INCORE, PFTS, PFT_AVGS, NROT, NANNULI, 
	1    SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, RMS, 
	2    AVER, VAROPT, SIGCUT, TMP, MASK, NTHE, NPHI, TS(IMG_NUM), 
	3    PS(IMG_NUM), MOD_TS, DTHE, DPHIS, NVIEW_THISIMG)
C           ***************************************************************
C-----------*  Determine best THETA,PHI,OMEGA, and origin for this image  *
C           ***************************************************************
	    CALL REFINE_CC (IMG_NUM, NVIEW_THISIMG, BIN, NROT, 
	1    NANNULI, DTHE, DPHI_90, THE1, PHI1, IDIM1, IDIM2, RES_MIN, 
	2    RES_MAX, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI,JCUT, RADIUS, 
	3    SYM, ILIST, MAG_CEN, NFILES, MAG_STEP, MAG_NUM, PRJS, PFTS, 
	4    PFT_AVGS, SQ2, MOD_TS, MOD_PS, VAR, IMG_BKG, IMG_MIN, IMG_MAX, 
	5    IMG_AVG, IMG_STD, VAROPT, NCOLBIN, NROWBIN, NIDS_TOT, IMG, 
	6    IDS, TS, PS, OS, XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, 
	7    N_INCORE, MASK, NTHE, NPHI, DPHIS, FFT1, FFT3, FFT4, FFT5, 
	8    MSKIMG, MSKPRJ, R4_IMG, BESTPRJ, PRJ_ROT, PFTIMG, PFFT, 
	9    R4_PIMG, FLTPMAP, POLAR_PRJ, A_ARRAY, TMP1, TMP2, TMP3, CCOR, 
	1    COMPARE_MODE, FILE)
	    WRITE(*,1000)  IMG_NUM, TS(IMG_NUM), PS(IMG_NUM), OS(IMG_NUM),
	1    XS(IMG_NUM), YS(IMG_NUM), MAGS(IMG_NUM), PFT_CCS(IMG_NUM), 
	2    PRJ_CCS(IMG_NUM), CMP_CCS(IMG_NUM)

ccc	call pif_write_debugi4 ('mask.pif', mask, nphi, nthe)

	  ENDDO				       ! DO IMG_NUM = IMG_NUM1,NIDS_TOT
	  GO TO 900
  800	  IMG_NUM1 = IMG_LAST
	  CALL GET_ITHE2 (N_INCORE, NCOLBIN, NROWBIN, NROT, NANNULI, 
	1 NTHE, NPHI, ITHE1, ITHE2, MASK, PRJS, PFTS, SLIDE, OFFSET)
	  IF(SLIDE) THEN
	    THE_MAX = MOD_TS(ITHE2)-3*DTHE	! MAX THETA ALLOWED THIS WINDOW
	    GO TO 100
	  ENDIF
C  ****************************************************************************
C  *    DEALLOCATE UNNEEDED MEMORY BEFORE EXITING SUBROUTINE    *
C  **************************************************************
  900	CALL FREEMEM_REFINE (MAP3D_P, MOD_TS_P, MOD_PS_P, PRJ_P, 
	1 PRJS_P, PROJN_P, PMAP_P, PFTS_P, PFFT_P, ITMP_P, PFT_AVGS_P, 
	2 SQ2_P, VAR_P, RMS_P, AVER_P, TMP_P, IMG_P, FFT1_P, FFT3_P, 
	3 FFT4_P, FFT5_P, FFT6_P, MSKIMG_P, MSKPRJ_P, R4_IMG_P, BESTPRJ_P, 
	4 PRJ_ROT_P, PFTIMG_P, R4_PIMG_P, FLTPMAP_P, POLAR_PRJ_P, 
	5 A_ARRAY_P, CCOR_P, TMP1_P, TMP2_P, TMP3_P)
C
	RETURN
 1000	FORMAT (1X,I6,',',4(F8.3,','),F7.3,',',3(F6.3,','),F6.3)
	END

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE REFINE_CC     *****               *
C  *                                                                          *
C  *    CROSS-CORRELATE POLAR FFT DATA TO DETERMINE AND REFINE PARTICLE       *
C  *     ORIENTATIONS (REFINE MODE VERSION).                                  *
C  *                                                                          *
C  *	Note: PHI1 = PHIIN (the particle's PHI orientation)                   *
C  *                                                                          *
C  *    LOGICAL UNITS: 1 = FILE CONTAINING 3D MODEL                           *
C  *                   2 = INPUT PARAMETERS DATA FILE(s)                      *
C  *                   7 = INPUT RAW IMAGE DATA                               *
C  *                   8 = STATS OUTPUT FILE (EMPFT.RES1)                     *
C  *                   9 = STATS OUTPUT FILE (EMPFT.RADS)                     *
C  *                  10 = STATS OUTPUT FILE (EMPFT.RES2)                     *
C  *                                                                          *
C  *    Protocol:                                                             *
C  *     1. Compute polar map from raw image.                                 *
C  *     2. Compute polar FFT (PFT) of raw image.                             *
C  *     3. Cross-correlate raw PFT with data base of reference PFTs.         *
C  *     4. Cross-correlate raw image with "best" projection to resolve       *
C  *        PHI ambiquity and determine OMEGA.                                *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *                                                                          *
C  *    MODIFIED 19-JAN-1998 BY T. BAKER (Adapted from old PFTCC subroutine). *
C  *    MODIFIED  5-FEB-1998 BY T. BAKER (Clean up).                          *
C  *    MODIFIED  4-MAY-1998 BY T. BAKER (Implement new code).                *
C  *    MODIFIED 23-JUL-1999 BY TSB (Implement SBW's CTF code).               *
C  *    LAST MODIFIED 25-AUG-1999 BY TSB (Implement TSB's CTF code).          *
Ca Todo     Make sure to handle COMPARE_MODE==1 and COMPARE_MODE==3 for refine          *
C  ****************************************************************************
C
	SUBROUTINE REFINE_CC (IMG_NUM, NVIEW_THISIMG, BIN, NROT, 
	1  NANNULI, DTHE, DPHI_90, THE1, PHI1, IDIM1, IDIM2, RES_MIN, 
	2  RES_MAX, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, JCUT, 
	3  RADIUS, SYM, ILIST, MAG_CEN, NFILES, MAG_STEP, MAG_NUM, PRJS, 
	4  PFTS, PFT_AVGS, SQ2, MOD_TS, MOD_PS, VAR, IMG_BKG, IMG_MIN, 
	5  IMG_MAX, IMG_AVG, IMG_STD, VAROPT, NCOLBIN, NROWBIN, 
	6  NIDS_TOT, IMG, IDS, TS, PS, OS, XS, YS, MAGS, PFT_CCS, 
	7  PRJ_CCS, CMP_CCS, N_INCORE, MASK, NTHE, NPHI, DPHIS, FFT1, 
	8  FFT3, FFT4, FFT5, MSKIMG, MSKPRJ, R4_IMG, BESTPRJ, PRJ_ROT, 
	9  PFTIMG, PFFT, R4_PIMG, FLTPMAP, POLAR_PRJ, A_ARRAY, TMP1, 
	1  TMP2, TMP3, CCOR, COMPARE_MODE, FILE)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	COMMON/CTF_COM/PIXSIZ, UNITS, VOLTS, AMP_FAC, FOCUS_MAJ, 
	1 FOCUS_MIN, ANG_MAJ, CS_COEFF
C
	INTEGER*4 BIN, LUN, I, J, COMPARE_MODE
	real*4    IMG_MIN, IMG_MAX
	INTEGER*4 NCOLBIN, NROWBIN, SYM, FILE, INDEX, ILIST, UNITS(999)
	INTEGER*4 NROT, NANNULI, IDIM1, IDIM2, JCUT, NTHE, NPHI, NFILES
	INTEGER*4 IMG_NUM, NIMG, NIDS_TOT, NVIEW_THISIMG, MASK(NPHI,NTHE,2)
	INTEGER*4 ANN_LO, ANN_HI, N1, N2, MAG_NUM, THISNSEC, flag
	INTEGER*4 IDS(NIDS_TOT), VAR(NROT,NANNULI), N_INCORE, ITH, IPH
	real*4    IMG(NCOLBIN,NROWBIN), MSKIMG(NCOLBIN,NROWBIN) 
	real*4    IMG_BKG
	REAL*4    COL_BY_2, ROW_BY_2, COL_BY_10, ROW_BY_10, DELX, DELY
	REAL*4    DPHIS(NTHE), WAVELENGTH, WAVEL, TFAC
	REAL*4    FFT1(2*IDIM1,IDIM2), FFT3(2*IDIM1,IDIM2)
	REAL*4    FFT4(2*IDIM1,IDIM2), FFT5(2*IDIM1,IDIM2) 
	REAL*4    R4_IMG(NCOLBIN,NROWBIN), R4_PIMG(NROT,NANNULI)
	REAL*4    MSKPRJ(NCOLBIN,NROWBIN), POLAR_PRJ(NROT,NANNULI)
	REAL*4    BESTPRJ(NCOLBIN,NROWBIN), PRJ_ROT(NCOLBIN,NROWBIN)
	REAL*4    PFFT(2*NROT,NANNULI), FLTPMAP(NROT,NANNULI)
	REAL*4    TMP1(NCOLBIN,NROWBIN), TMP2(2*IDIM1,IDIM2)
	REAL*4    TMP3(2*IDIM1,IDIM2), CCOR(N_INCORE)
	REAL*4    A_ARRAY(2*NROT), PFTIMG((NROT/4),NANNULI)
	REAL*4    PIXSIZ(999), VOLTS(999), AMP_FAC(999), CS_COEFF(999)
	REAL*4    FOCUS_MAJ(999), FOCUS_MIN(999), ANG_MAJ(999)
C
	REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
	REAL*4    IMG_AVG, IMG_STD, PI, RADIAN, DEGREE
	REAL*4    DTHE, DPHI, DPHI_90, THE1, PHI1, DEL_ANG, DEL_PIXRES
	REAL*4    THE_BEST, PHI_BEST, OME_BEST, PIXRES_MIN, PIXRES_MAX
	REAL*4    AVG, SQ1, RADIUS, CC_PFT, CC_PRJ, CC_CMP, CC_AVG
	REAL*4    XCEN, YCEN, XCEN_MOD, YCEN_MOD, RES_MIN, RES_MAX
	REAL*4    CC_RES_GLOBAL(2,20), CC_RAD_GLOBAL(2,200)
	REAL*4    BEST_MAG, MAG, MAG_STEP, MAG_CEN, MAG_LO
	REAL*4    PFTS(NROT,NANNULI,N_INCORE), MOD_TS(NTHE)
	REAL*4    MOD_PS(NPHI,NTHE), SQ2(N_INCORE), PFT_AVGS(N_INCORE)
	REAL*4    PRJS(NCOLBIN,NROWBIN,N_INCORE)
	REAL*4    IMG_SCALEF, FFT_FZERO, FFT_ORIGX, FFT_ORIGY
	LOGICAL   FLIP, VAROPT, FFT_FULL, MALLOC, SIGN
	DATA      CC_RES_GLOBAL/40*0.0/, CC_RAD_GLOBAL/400*0.0/
	logical   end_fit
C  ----------------------------------------------------------------------------
C
	CALL PIRADDEG (PI, RADIAN, DEGREE)
C  *******************************
C  *  Set up initial parameters  *
C  *******************************
	DEL_PIXRES = 0.025
        DEL_ANG    = 360.0/FLOAT(NROT)
	COL_BY_2   = FLOAT(NCOLBIN/2)
	ROW_BY_2   = FLOAT(NROWBIN/2)
	COL_BY_10  = FLOAT(NCOLBIN/10)
	ROW_BY_10  = FLOAT(NROWBIN/10)
	XCEN_MOD   = (NCOLBIN+1)/2  ! X center for PRJs (real space coordinate)
	YCEN_MOD   = (NROWBIN+1)/2  ! Y center for PRJs (real space coordinate)
	CC_AVG     = 0.0
C  *****************************************************************
C  *   Convert raw IMG from INT*2 to REAL*4 format (IMG->R4_IMG)   *
C  *   Use MAGS(IMG_NUM) for initial MAG scale factor.             *
C  *   Use XS(IMG_NUM) and YS(IMG_NUM) for initial X,Y origins     *
C  *   If MAG does not equal 1.0, scale image by MAG	           *
C  *   Compute FFT of image					   *
C  *****************************************************************
	CALL R4_IMG_MAP (IMG, R4_IMG, NCOLBIN, NROWBIN, IMG_BKG)
	FFT_ORIGX = NCOLBIN/2
	FFT_ORIGY = NROWBIN/2
C       **************************************************************
C-------*  Apply CTF to FFT to downweight data according to Steve    *
C       *   Fuller scheme.  Implemented by SBW.                      *
C       **************************************************************
Ca      Make sure to handle COMPARE_MODE==1 and COMPARE_MODE==3 here ???
        IF(COMPARE_MODE.EQ.2) THEN
	  CALL MAP_FFT_FILL (R4_IMG, NCOLBIN, NROWBIN, 1, 1, FFT1, 
	1  IDIM1, IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	  CALL FFT_2D (FFT1, IDIM1, IDIM2)
	  WAVELENGTH = WAVEL (VOLTS(FILE))
	  TFAC    = 0.0				! HARDWIRE THIS FOR NOW
C         ****************************************************************
C---------*  2-May-00 Hardwire input parameters to CTF_MULTIPLY such as  *
C         *  mode=1; Cc=0.0, BETA=0.0, dE=0.0; These will *not* impose   *
C         *  a decay factor on the data.                                 *
C         ****************************************************************
	  CALL CTF_MULTIPLY (1, FFT1, IDIM1, IDIM2, UNITS(FILE), 
	1  BIN*PIXSIZ(FILE), PI, RADIAN, WAVELENGTH, FOCUS_MAJ(FILE), 
	2  FOCUS_MIN(FILE), ANG_MAJ(FILE), AMP_FAC(FILE), 
	2  CS_COEFF(FILE), 0.0, 0.0, 0.0, VOLTS(FILE), TFAC, FFT_FULL)
	  CALL FFT_2D_BACK (FFT1, IDIM1, IDIM2)
	  CALL FFT_MAP_FILL (FFT1, IDIM1, IDIM2, R4_IMG, NCOLBIN, 
	1  NROWBIN, 1, 1, FFT_FULL)
	  WRITE(*,'(A,I4,A,2F8.4,A,F8.4)') 'Applied CTF to image ',
	1  IDS(FILE), ' with defocus values', FOCUS_MAJ(FILE),
	2  FOCUS_MIN(FILE), ' and ANG_MAJ =', ANG_MAJ(FILE)
	ENDIF
C
	XCEN      = ((XS(IMG_NUM)+1.0)/BIN)-1.0      ! NEED IN BINNED FFT SPACE
	YCEN      = ((YS(IMG_NUM)+1.0)/BIN)-1.0      ! NEED IN BINNED FFT SPACE
	MAG       = MAGS(IMG_NUM)
	IF(MAG.EQ.1.0) GO TO 100
	CALL INTERP2D (R4_IMG, NCOLBIN, NROWBIN, XCEN, YCEN, XCEN, 
	1  YCEN, 0.0, MAG, 0.0)
  100	CALL MAP_FFT_FILL (R4_IMG, NCOLBIN, NROWBIN, 1, 1, FFT1, IDIM1, 
	1 IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	CALL FFT_2D (FFT1, IDIM1, IDIM2)
	XCEN = XCEN + 1.0  		     ! Return to real space coordinates
	YCEN = YCEN + 1.0
C	*******************************************************************
C-------*  Sometimes EMPFT crashes with a division-by-0 error in          *
C	*  GET_THEPHI (called below). It turns out that GET_XY            *
C	*  (above) returns a bad origin due to poor matching between an   *
C	*  image and its reference, and then MAP_POLAR (below) fills the  *
C	*  polar array with zero since the origin can be too far off the  *
C	*  edge of the cartesian array. The div-by-0 occurs because the   *
C	*  sum-of-sqaures (SQ1) for the polar array is zero.  Check here  * 
C	*  for (XCEN,YCEN) being away from the center of the image array  *
C	*  (NCOLBIN/2,NROWBIN/2) and post warnings. If it is way off, the *
C	*  user can try to skip this particle and go on to the next,      *
C	*  rather than crash in GET_THEPHI.                               *
C	*******************************************************************
	DELX = ABS(XCEN-COL_BY_2)
	DELY = ABS(YCEN-ROW_BY_2)
	IF(DELX.GT.COL_BY_2 .OR. DELY.GT.ROW_BY_2)  THEN
	   WRITE (*,1000) IMG_NUM, XCEN*BIN, YCEN*BIN
	 ELSE IF (DELX.GT.COL_BY_10 .OR. DELY.GT.ROW_BY_10)  THEN
	  WRITE (*,1010) IMG_NUM, XCEN*BIN, YCEN*BIN
	ENDIF
C  ******************************************************************
C  *    ITH,IPH ARE THE "MASK" COORDINATES OF THE CURRENT IMAGE     *
C  ******************************************************************
	ITH = NINT ( (TS(IMG_NUM)-MOD_TS(1))/DTHE ) + 1
	IPH = NINT (ABS(PS(IMG_NUM))/DPHIS(ITH)) + 1
	CALL GET_TPO_R (NCOLBIN, NROWBIN, NROT, NANNULI, N_INCORE, 
	1 NVIEW_THISIMG, NTHE, NPHI, MASK, MOD_TS, MOD_PS, ITH, IPH, 
	2 PFT_AVGS, R4_IMG, R4_PIMG, PRJS, BESTPRJ, POLAR_PRJ, PFTS, 
	3 PFFT, PFTIMG, JCUT, XCEN, YCEN, XCEN_MOD, YCEN_MOD, RADIUS, 
	4 DEL_ANG, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, 
	5 PI, AVG, SQ1, SQ2, THE_BEST, PHI_BEST, OME_BEST, DEL_PIXRES, 
	6 CC_PFT, CC_PRJ, CCOR, A_ARRAY, FLIP, INDEX)
C
	IF(FLIP) THEN
	  THE_BEST = 180.0 - THE_BEST
	  IF(THE_BEST.EQ.0.0 .OR. THE_BEST.EQ.180.0) THEN
	     PHI_BEST = 0.0
	   ELSE
	     PHI_BEST = PHI_BEST + 180.0
	  ENDIF
	  IF(THE_BEST.NE.180.0)  OME_BEST = OME_BEST + 180.0
	  CALL MAP_XFLIP (BESTPRJ, NCOLBIN, NROWBIN, 0)
	ENDIF
C  ***********************
C  *  Refine X,Y origin  *
C  ***********************
	CALL COPY_R4 (BESTPRJ, PRJ_ROT, NCOLBIN*NROWBIN)
	IF(OME_BEST.EQ.0.0) GO TO 200
	CALL INTERP2D (PRJ_ROT, NCOLBIN, NROWBIN, XCEN_MOD-1.0, 
	1 YCEN_MOD-1.0, XCEN_MOD-1.0, YCEN_MOD-1.0, OME_BEST, 1.0, 0.0)
  200	CALL MAP_FFT_FILL (PRJ_ROT, NCOLBIN, NROWBIN, 1, 1, FFT3, IDIM1,
	1 IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	CALL FFT_2D (FFT3, IDIM1, IDIM2)
	CALL GET_XY (FFT1, FFT3, XCEN, YCEN, IDIM1, IDIM2, RES_MAX, 
	1 FFT_ORIGX, FFT_ORIGY, flag, end_fit) !debug end_fit!)
	if(flag .lt. 0) then
	   print *, 'WARNING:  The highest CC peak is outside the '
	   print *, '          30% search box.  Particle #',img_num
	endif
	XCEN = XCEN + 1.0  		     ! Return to real space coordinates
	YCEN = YCEN + 1.0
C  *******************************************************************
C  *  Again test 1) for centers off the Cartesian array              *
C  *             2) for centers more than 10% from array center      *
C  *  Such origins may indicate poor data                            *
C  *******************************************************************
	DELX = ABS(XCEN-COL_BY_2)
	DELY = ABS(YCEN-ROW_BY_2)
	IF(DELX.GT.COL_BY_2 .OR. DELY.GT.ROW_BY_2)  THEN
	   WRITE(*,1000) IMG_NUM, XCEN*BIN, YCEN*BIN
	 ELSE IF (DELX.GT.COL_BY_10 .OR. DELY.GT.ROW_BY_10)  THEN
	   WRITE(*,1010) IMG_NUM, XCEN*BIN, YCEN*BIN
	ENDIF
C  **************************************************************************
C  *  Find/refine MAG scale factor and CMP coefficient, use a routine       *
C  *  adapted from CMP program, IMG and BESTPRJ are compared in real space  *
C  **************************************************************************
	IF(MAG_CEN.LE.0.0) THEN
	   MAG_LO = MAG     - (((MAG_NUM-1)/2)*MAG_STEP)
	  ELSE
	   MAG_LO = MAG_CEN - (((MAG_NUM-1)/2)*MAG_STEP)
	ENDIF
	CALL GET_BESTMAG (IMG, BESTPRJ, TMP1, TMP2, TMP3, NCOLBIN, 
	1 NROWBIN, IDIM1, IDIM2, FLOAT(ANN_LO), FLOAT(ANN_HI), RES_MIN, 
	2 RES_MAX, XCEN-1.0, YCEN-1.0, OME_BEST, MAG_LO, MAG_NUM, 
	3 MAG_STEP, BEST_MAG, CC_CMP, IMG_BKG, FFT_ORIGX, FFT_ORIGY)
	MAG = BEST_MAG
C  *********************************************************************
C  *    IF ILIST > 0                                                   *
C  *    RECOMPUTE POLAR MAP OF RAW IMAGE WITH NEWEST X,Y ORIGIN        *
C  *    RECOMPUTE POLAR MAP OF ROTATED PROJECTION                      *
C  *    COMPUTE COEFFICIENTS AS A FUNCTION OF RESOLUTION AND RADIUS    *
C  *    WRITE TO EXTRA OUTPUT FILES (UNITS 8,9,10)                     *
C  *********************************************************************
	IF(ILIST.LE.0) GO TO 500
	CALL LIST_CCS (BIN, NCOLBIN, NROWBIN, IDIM1, IDIM2, NROT, NANNULI, 
	1 IMG,  MSKIMG, R4_IMG,  FFT1,  FFT3,  FFT4,  FFT5,  PRJ_ROT,  
	2 MSKPRJ, POLAR_PRJ, R4_PIMG,  FLTPMAP, IMG_NUM, IMG_BKG, XCEN, 
	3 YCEN, XCEN_MOD, YCEN_MOD, FFT_ORIGX, FFT_ORIGY, RES_MIN, 
	4 RES_MAX, ANN_LO, ANN_HI, RADIUS, PIXRES_MAX, DEL_PIXRES, 
	5 DEL_ANG, CC_AVG, CC_RES_GLOBAL, CC_RAD_GLOBAL)
  500	DPHI = DPHI_90 / SIND(THE_BEST)
	IF(THE_BEST.EQ.0.0 .OR. THE_BEST.EQ.180.0) DPHI = 0.0
C  *******************************************************************
C  *  If not asymmetric, check if orientation is in asymmetric unit  *
C  *  and return to asymmetric unit if orientation lies outside      *
C  *******************************************************************
	IF(SYM.EQ.1) GO TO 600
	CALL TO_ASYM_UNIT (SYM, THE_BEST, PHI_BEST, OME_BEST)
C
  600	IF(OME_BEST.LT.0.0) OME_BEST = OME_BEST + 360.0      ! Keep positive
	XS(IMG_NUM)      = (XCEN*BIN) - 1.0		! FOURIER SPACE COORDS
	YS(IMG_NUM)      = (YCEN*BIN) - 1.0		! FOURIER SPACE COORDS
	TS(IMG_NUM)      = THE_BEST
	PS(IMG_NUM)      = PHI_BEST
	OS(IMG_NUM)      = OME_BEST
	MAGS(IMG_NUM)    = MAG
	PFT_CCS(IMG_NUM) = CC_PFT
	PRJ_CCS(IMG_NUM) = CC_PRJ
	CMP_CCS(IMG_NUM) = CC_CMP
C  ****************************************************************************
C  *  Write extra output to files if user wishes (ILIST > 0)  *
C  ************************************************************
ccc	nimgs not defined because only considering one image at a time here
ccc	IF (ILIST.GE.1) THEN
ccc	  J = NINT(1/(PIXRES_MAX*DEL_PIXRES))
ccc	  WRITE(8,1020)
ccc	  WRITE(8,'(A,10F7.3)') ' AVG', (CC_RES_GLOBAL(1,I)/FLOAT(NIMGS),
ccc	1				I=1,J)
ccc	  WRITE(10,1020)
ccc	  WRITE(10,'(A,10F7.3)') ' AVG', (CC_RES_GLOBAL(2,I)/FLOAT(NIMGS),
ccc	1				 I=1,J)
ccc	  WRITE(9,1030) NIMGS
ccc	  DO I = 1,ANN_HI+1
ccc	    WRITE(9,'(I4,2F7.3)') I-1, CC_RAD_GLOBAL(1,I)/FLOAT(NIMGS),
ccc	1			       CC_RAD_GLOBAL(2,I)/FLOAT(NIMGS)
ccc	  ENDDO
ccc	ENDIF
C
	RETURN
 1000	FORMAT (' WARNING - estimated center is off edge of array:',/,
	1       ' IMG_NUM, XCEN, YCEN = ', I, 2F10.3)
 1010	FORMAT (' WARNING - estimated center is more than 10% from ',
	1       'array center:',/,' IMG_NUM, XCEN, YCEN = ', I, 2F10.3)
 1020	FORMAT(74('-')) 
 1030	FORMAT (' AVERAGE correlation coefficients as function ',
	1	  'of radius for num images:',I4)
	END

C  *************************************************************************
C  *									   *
C  *             *****     SUBROUTINE ADJUST_NVIEW_MOD     *****           *
C  *									   *
C  *  If THETA = 0 or 180 then PHI is undetermined and there are (NPHI-1)  *
C  *  fewer possible orientations.  Adjust NVIEW_MOD accordingly.  It will *
C  *  be changed back to the NTHE*NPHI value after the analysis is over.   *
C  *  (This reversion will occur in the main program.)  Used only in       *
C  *  REFINE mode.                                                         *
C  *									   *
C  *  D. Belnap, 30 Jan 1997, NIH					   *
C  *************************************************************************
C
	SUBROUTINE ADJUST_NVIEW_MOD (THETA1, THETA2, DEL_THE, 
	1  NVIEW_MOD, NPHI)
C
	IMPLICIT NONE
C
	INTEGER*4 NVIEW_MOD, NPHI
	REAL*4    THE, THETA1, THETA2, DEL_THE
C ----------------------------------------------------------------------------
C
	THE = THETA1
	DO WHILE (THE.LE.THETA2)
	  IF (THE.EQ.0.0 .OR. THE.EQ.180.0) THEN
	    NVIEW_MOD = NVIEW_MOD - NPHI + 1
	  ENDIF
	  THE = THE + DEL_THE
	ENDDO
C
	END

C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE AVG_PFTIMG     *****                *
C  *                                                                          *
C  *    COMPUTES THE AVERAGE VALUES OF "PFTIMG".                              *
C  *                                                                          *
C  *    APRIL 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.          *
C  *                                                                          *
C  *    LAST MODIFIED 29-APR-1998 BY T. BAKER (Renamed from PFTCC_AVG).       *
C  ****************************************************************************
C
	SUBROUTINE AVG_PFTIMG (PFTIMG, NROT, NANNULI, JCUT, PIXRES_MIN,
	1 PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, SQ1)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 NROT, NANNULI, J, JN, RSAVE, JSAVE, JCUT
        INTEGER*4 ANN_LO, ANN_HI, IR, R, VAR((NROT/4),NANNULI)
	REAL*4    PTS, PFTIMG((NROT/4),NANNULI), TEST, AVG, SQ1
	REAL*4    PIXRES, PIXRES_MIN, PIXRES_MAX, PI, TWOPIR
	LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
	TEST = R4_MIN
	AVG  =    0.0
	SQ1  =    0.0
        PTS  =    0.0
C
	DO IR = ANN_LO,ANN_HI
	  R      = MIN(NANNULI, IR+1)
	  TWOPIR = 2.0*PI*FLOAT(IR)
	  DO JN = JCUT,((NROT/4) - 1)
	    IF(JN.GT.0) THEN				! TRAP FOR Jo
	       PIXRES = TWOPIR/FLOAT(JN)
	     ELSE
	       PIXRES = 1000.0
	    ENDIF
	    IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 100
	    J = JN + 1
            IF ((VAROPT.AND.(VAR(J,R).ne.0)) .OR. .NOT.VAROPT) THEN
              PTS = PTS + 1.0
	      AVG = AVG + PFTIMG(J,R)
	      SQ1 = SQ1 + PFTIMG(J,R)**2
	      IF(PFTIMG(J,R).GT.TEST) THEN
	        TEST  = PFTIMG(J,R)
	        RSAVE = R
	        JSAVE = J
	      ENDIF
            ENDIF
  100	  ENDDO
	ENDDO
	AVG = AVG/PTS
C
CCC	PRINT *
CCC	PRINT *, 'The maximum peak in the polar-FFT, outside the Jo is:'
CCC	PRINT *, 'RADIUS            =', JSAVE-1
CCC	PRINT *, 'SPATIAL FREQUENCY =', RSAVE-1
CCC	PRINT *, 'VALUE AT POINT    =', PFTIMG(RSAVE,JSAVE)
CCC	PRINT *
CCC	PRINT *,'Average (excluding orders < JCUT & annuli < ANN_LO) =',AVG
C
	RETURN
	END

C  ****************************************************************************
C  *									      *
C  *                 *****     SUBROUTINE CALC_AVGS     *****                 *
C  *									      *
C  *  Computes average and std values of MAG, CC_PFT, CC_PRJ, and CC_CMP.     *
C  *									      *
C  *    D. Belnap, July 1996						      *
C  *    LAST MODIFIED 23-APR-1998 BY T. BAKER                                 *
C  ****************************************************************************
C
	SUBROUTINE CALC_AVGS (NIDS_TOT,MAGS,PFT_CCS,PRJ_CCS,CMP_CCS)
C
	IMPLICIT NONE
C
	INTEGER*4 ID, NIDS_TOT
	REAL*4    MAGS(NIDS_TOT), MAGS_AVG, MAGS_STD
	REAL*4    PFT_CCS(NIDS_TOT), PFTCC_AVG, PFTCC_STD
	REAL*4    PRJ_CCS(NIDS_TOT), PRJCC_AVG, PRJCC_STD
	REAL*4    CMP_CCS(NIDS_TOT), CMPCC_AVG, CMPCC_STD
C -----------------------------------------------------------------------------
C
	IF(NIDS_TOT.LE.0) RETURN
C
	WRITE(*,100) NIDS_TOT
  100	FORMAT (' ====================================================',
	1	'=====',
	2       /,' Compute average MAG factor and coefficients,',
	3	' N = ',I7,/,
	4       ' ====================================================',
	5	'=====')
C  ***************************
C  *  Initialze parameters   *
C  ***************************
	MAGS_AVG  = 0.0
	MAGS_STD  = 0.0
	PFTCC_AVG = 0.0
	PFTCC_STD = 0.0
	PRJCC_AVG = 0.0
	PRJCC_STD = 0.0
	CMPCC_AVG = 0.0
	CMPCC_STD = 0.0
C
	DO ID = 1,NIDS_TOT
	  MAGS_AVG  = MAGS_AVG  + MAGS(ID)
	  PFTCC_AVG = PFTCC_AVG + PFT_CCS(ID)
	  PRJCC_AVG = PRJCC_AVG + PRJ_CCS(ID)
	  CMPCC_AVG = CMPCC_AVG + CMP_CCS(ID)
	ENDDO
	MAGS_AVG  = MAGS_AVG  / FLOAT(NIDS_TOT)
	PFTCC_AVG = PFTCC_AVG / FLOAT(NIDS_TOT)
	PRJCC_AVG = PRJCC_AVG / FLOAT(NIDS_TOT)
	CMPCC_AVG = CMPCC_AVG / FLOAT(NIDS_TOT)
C  ***************************************************************
C  *  Calculate and list coefficients and standard deviations    *
C  ***************************************************************
	IF(NIDS_TOT.GT.1) THEN
	  DO ID = 1,NIDS_TOT
	    MAGS_STD  =  MAGS_STD  + (MAGS(ID)   - MAGS_AVG)**2
	    PFTCC_STD =  PFTCC_STD + (PFT_CCS(ID) - PFTCC_AVG)**2
	    PRJCC_STD =  PRJCC_STD + (PRJ_CCS(ID) - PRJCC_AVG)**2
	    CMPCC_STD =  CMPCC_STD + (CMP_CCS(ID) - CMPCC_AVG)**2
	  ENDDO
	  MAGS_STD  = SQRT( MAGS_STD  / FLOAT(NIDS_TOT-1) )
	  PFTCC_STD = SQRT( PFTCC_STD / FLOAT(NIDS_TOT-1) )
	  PRJCC_STD = SQRT( PRJCC_STD / FLOAT(NIDS_TOT-1) )
	  CMPCC_STD = SQRT( CMPCC_STD / FLOAT(NIDS_TOT-1) )
	ENDIF
C
	WRITE(*,1000) '                     Average  Std. Dev.'
	WRITE(*,1000) '---------------------------------------'
	WRITE(*,1000) ' MAG factor      ', MAGS_AVG,  MAGS_STD
	WRITE(*,1000) ' PFT Coefficient ', PFTCC_AVG, PFTCC_STD
	WRITE(*,1000) ' PRJ Coefficient ', PRJCC_AVG, PRJCC_STD
	WRITE(*,1000) ' CMP Coefficient ', CMPCC_AVG, CMPCC_STD
 1000	FORMAT(A,2(F10.3))
C
	RETURN
	END

C  *************************************************************************
C  *									   *
C  *               *****     SUBROUTINE CALC_MOD_TPS     *****             *
C  *									   *
C  *  Calculates THETA and PHI orientation angles within the search window *
C  *   for computing projections and PFT data from the model.              *
C  *									   *
C  *  DEL_PHI = DEL_PHI_90 / sin(THE), avoids oversampling near THE=0,180  *
C  *  If THE=0,180 then PHI is undefined, here it is set to 0.0.           *
C  *									   *
C  *  D. Belnap, 30 Jan 1997, NIH					   *
C  *************************************************************************
C
	SUBROUTINE CALC_MOD_TPS (MOD_TS, MOD_PS, THE1, THE2, PHI1, 
	1 DEL_THE, DEL_PHI_90, NTH, NPH, NVIEW_MOD, SYM, MODE, mod_ts_p)
C
	IMPLICIT NONE
C
	INTEGER*4 NTH, NPH, NVIEW_MOD, SYM, MODE, NUM, ITHE, IPHI
	INTEGER*4 THE_OUTBOUNDS
	REAL*4    MOD_TS(NVIEW_MOD), MOD_PS(NVIEW_MOD), THE1, THE2, PHI1
	REAL*4    DEL_THE, DEL_PHI_90, DEL_PHI, THE, PH, PHIMAX
	real*4    mod_ts_fake(1)
	pointer   (mod_ts_p,mod_ts_fake)
C ----------------------------------------------------------------------------
C
	NUM = 0
	THE = THE1
C
	IF(MODE.EQ.3) THEN					! REFINE MODE
	   DO ITHE = 1,NTH
	     IF (THE.EQ.0.0 .OR. THE.EQ.180.0) THEN
	        NUM         = NUM + 1
	        MOD_TS(NUM) = THE
	        MOD_PS(NUM) = 0.0
	      ELSE
	        DEL_PHI = DEL_PHI_90 / SIND(THE)
	        PH = PHI1 - DEL_PHI*(NPH/2)	    !If (REFINE), PHI1 = PHIIN
C	        ***************************************************************
C	        * In REFINE, THE may be <0 or >180, if so "special" treatment *
C	        ***************************************************************
	        IF (THE.LT.0.0) THEN
		   THE_OUTBOUNDS = 1
		   PH            = PH + 180.0
		   THE           = ABS(THE)
		 ELSE IF (THE.GT.180.0) THEN
		   THE_OUTBOUNDS = 2
		   PH            = PH + 180.0
		   THE           = 360.0 - THE
		 ELSE
		   THE_OUTBOUNDS = 0
	        ENDIF					!End if (THE < 0)
	        DO IPHI = 1,NPH
		  NUM         = NUM + 1
		  MOD_TS(NUM) = THE
		  MOD_PS(NUM) = PH
		  PH 	      = PH + DEL_PHI
	        ENDDO
C               **********************************************
C---------------*  RESET THETA IF THE_OUTBOUNDS IS 1 OR 2    *
C               **********************************************
	        IF (THE_OUTBOUNDS.EQ.1) THE = -THE		! RESET THE 
	        IF (THE_OUTBOUNDS.EQ.2) THE = 360.0 - THE	! RESET THE 
	     ENDIF				!End if (THE = 0,180)
	     THE = THE + DEL_THE
	   ENDDO					!End do ITHE = 1,NTH
	 ELSE						   ! GLOBAL SEARCH MODE
	   NTH = NINT((THE2-THE1)/DEL_THE) + 1
	   DO ITHE = 1,NTH
	     IF (THE.EQ.0.0 .OR. THE.EQ.180.0) THEN
		NUM         = NUM + 1
		MOD_TS(NUM) = THE
		MOD_PS(NUM) = 0.0
	      ELSE
		DEL_PHI = DEL_PHI_90 / SIND(THE)
Ca  Misha and Rob Dec 2003 - changed the line below so we won't 
Ca  iterate outisde the ASU.
Ca		NPH = NINT((PHIMAX(SYM,THE)-PHI1)/DEL_PHI) + 1
		NPH = INT((PHIMAX(SYM,THE)-PHI1)/DEL_PHI) + 1
		PH = PHI1
		DO IPHI = 1,NPH
		  NUM         = NUM + 1
		  MOD_TS(NUM) = THE
		  MOD_PS(NUM) = PH
		  PH          = PH + DEL_PHI
		ENDDO
	     ENDIF
	     IF (SYM.EQ.532 .AND. THE.EQ.69.09484255211070) THEN
	        THE = 69.0 + DEL_THE		!DEL_THE unlikely to be < 0.1
	      ELSE
	        THE = THE + DEL_THE
	     ENDIF
	   ENDDO		!End do ITHE = 1,NTH
	ENDIF
C
	END

C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE CALC_TP_MASK     *****              *
C  *                                                                          *
C  *    "MASK" ARRAY SERVES TWO PURPOSES:                                     *
C  *      1. TALLY # MODEL PROJECTIONS NEEDED AT EACH THE,PHI GRID POINT.     *
C  *      2. SIGNIFY AN ID FOR EACH UNIQUE PROJECTION THAT THEN IDENTIFIES    *
C  *         THE LOCATION OF APPROPRIATE DATA IN THE PFTS AND PRJS ARRAYS.    *
C  *                                                                          *
C  *    APRIL 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.          *
C  *                                                                          *
C  *    LAST MODIFIED 28-APR-1998 BY T. BAKER (Implement new code).           *
C  ****************************************************************************
C
	SUBROUTINE CALC_TP_MASK (NTHE, NPHI, NIDS_TOT, TS, PS, MOD_TS, 
	1 MOD_PS, MASK, DPHIS, THE1, THE2, DTHE, DPHI_90, NUNIQUE)
C
	IMPLICIT NONE
C
	INTEGER*4 NTHE, NPHI, NIDS_TOT, ITH, IPH, ITHE, IPHI, ID
	INTEGER*4 I, J, ITHETA, NUM, NUNIQUE, NNPHI, MASK(NPHI,NTHE,2)
	REAL*4    THETA, PHI, MOD_TS(NTHE), MOD_PS(NPHI,NTHE)
	REAL*4    PHT_PHIMAX, TS(NIDS_TOT), PS(NIDS_TOT), DPHIS(NTHE)
	REAL*4    DELTA, THE1, THE2, DTHE, DPHI_90, DPHI, SPEED
	LOGICAL   SIGN
C  ----------------------------------------------------------------------------
C
	NUM     = 0
	NUNIQUE = 0
C  ***************************
C  *    INITIALIZE "MASK"    *
C  ***************************
	DO J = 1,NTHE
	  DO I = 1,NPHI
	    MASK (I,J,1) = 0
	    MASK (I,J,2) = 0
	  ENDDO
	ENDDO
C  **********************************************
C  *    FILL UP DPHIS, MOD_TS, MOD_PS ARRAYS    *
C  **********************************************
	DO J = 1,NTHE
	  THETA = THE1 + (J-1)*DTHE
	  MOD_TS(J) = THETA
	  IF(THETA.EQ.0.0 .OR. THETA.EQ.180.0) THEN
	     DPHIS(J) = 0.0
	   ELSE
	     DPHIS(J) = DPHI_90/SIND(THETA)
	  ENDIF
	  DO I = 1,NPHI
	    MOD_PS(I,J) = (I-1)*DPHIS(J)
	  ENDDO
	ENDDO
C  *************************************************************
C  *    RESET TS,PS ARRAYS SO T,P VALUES LIE AT GRID POINTS    *
C  *************************************************************
	DO ID = 1, NIDS_TOT
	  SIGN   = .TRUE.
	  ITHETA = NINT(TS(ID))
	  DELTA  = TS(ID) - ITHETA
	  TS(ID) = ITHETA + NINT(DELTA/DTHE)*DTHE
	  DPHI   = DPHI_90/SIND(TS(ID))
	  IF(PS(ID).LT.0.0) SIGN = .FALSE.
	  PS(ID) = NINT(ABS(PS(ID))/DPHI) * DPHI
	  IF(.NOT.SIGN) PS(ID) = -PS(ID)
	ENDDO
C  ********************************************************
C  *    MAP THE "WINDOW" FOR EACH PARTICLE INTO "MASK"    *
C  ********************************************************
	DO ID = 1, NIDS_TOT
	  ITH = NINT( ((TS(ID)-THE1)/DTHE) ) + 1
	  DO 300 ITHE = ITH-3,ITH+3
	    IF(ITHE.GE.1 .AND. ITHE.LE.NTHE) THEN
	      IPH = NINT( ABS(PS(ID))/DPHIS(ITHE) ) + 1
	      DO 200 IPHI = IPH-3,IPH+3
	        IF(IPHI.GE.1 .AND. IPHI.LE.NPHI) THEN
	          MASK(IPHI,ITHE,1) = MASK(IPHI,ITHE,1) + 1
	          NUM               = NUM + 1
	          IF(MASK(IPHI,ITHE,1).EQ.1) NUNIQUE = NUNIQUE + 1
	        ENDIF
  200	      ENDDO				 ! LOOP OVER PHI GRID POINTS
	    ENDIF
  300	  ENDDO					 ! LOOP OVER THETA GRID POINTS

ccc	call pif_write_debugi4 ('mask.pif', mask, nphi, nthe)

	ENDDO					 ! LOOP OVER ALL PARTICLES
C  ***************************************
C  *    VT SCREEN OUTPUT FOR DEBUGGING   *
C  ***************************************
ccc	nnphi = 66
ccc	if(nphi.lt.66) nnphi = nphi
ccc	DO I = 1,NTHE
ccc	  WRITE(*,1000) (MASK(J,I,1),J=1,NNPHI)
ccc	ENDDO
C
	PRINT '(I8,A)', NUM, ' total number of projections needed'
	PRINT '(I8,A)', NUNIQUE, ' of these are unique'
	SPEED = FLOAT(NUM)/FLOAT(NUNIQUE)
	PRINT '(A,F5.2,A)', ' Potential compute savings:', SPEED, ' times'
C  ******************************************************************
C  *    FILL MASK(IP,IT,2) WITH POINTERS TO PFTS AND PRJS ARRAYS    *
C  ******************************************************************
	NUM = 0
	DO J = 1,NTHE
	  DO I = 1,NPHI
	    IF(MASK(I,J,1).NE.0) THEN
	      NUM         = NUM + 1
	      MASK(I,J,2) = NUM
	    ENDIF
	  ENDDO
	ENDDO
C
	RETURN
 1000	FORMAT(1X,66I2)
	END

C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE FILL_PARAMS     *****               *
C  *                                                                          *
C  *    FILL UP THE PARAMETER ARRAYS BY READING DATA IN FROM ALL PARAMETER    *
C  *     FILES (UNIT = 2).                                                    *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED 26-MAY-1998 BY RWA/TSB (Bug in NN variable).            *
C  ****************************************************************************
C
	SUBROUTINE FILL_PARAMS (MODE, NFILES, NIDS_TOT, NIDS, FIDS, 
	1 IDS, TS, PS, OS, XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, 
	2 PARAM_FNAMES)
C	
	IMPLICIT NONE
C
	INTEGER*4 MODE, ID, NFILES, NIDS_TOT, FILE, NN, NIDS(999)
	INTEGER*4 FIDS(NIDS_TOT), IDS(NIDS_TOT), IDS_TOT
	REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
	CHARACTER PARAM_FNAMES(999)*256, IMG_FILENAME*256
C  ----------------------------------------------------------------------------
C
	IF(IABS(MODE).EQ.1) THEN	! GLOBAL MODE: USES ALL IMAGES IN FILES
	  IDS_TOT = 0
	  DO FILE = 1, NFILES
	    DO ID = 1,NIDS(FILE)
	      IDS_TOT       = IDS_TOT + 1
	      IDS(IDS_TOT)  = ID
	      FIDS(IDS_TOT) = FILE
	    ENDDO
	  ENDDO
	  RETURN
	ENDIF
C
	NN = 1
C  *************************************************************
C  * Loop through PARAMETER files and retrieve particle info   *
C  *************************************************************
	DO 900 FILE = 1,NFILES
	  NN = NN -1		       ! Needed to handle EOF on 2nd PARAM file
	  IF(FILE.GT.1) CLOSE (UNIT=2)
	  OPEN (UNIT=2, FILE=PARAM_FNAMES(FILE), STATUS='OLD', ERR=996,
	1      ACCESS='SEQUENTIAL', FORM='FORMATTED', READONLY)
	  READ (2,'(A)',ERR=997) 				! DUMMY READ #1
	  READ (2,'(A)',ERR=998)				! DUMMY READ #2
  100	  NN = NN + 1
	  IF(NN.GT.NIDS_TOT) GO TO 900
	  READ (2,'(I,9F)',END=900,ERR=999) IDS(NN), TS(NN), PS(NN), 
	1  OS(NN), XS(NN), YS(NN), MAGS(NN), PFT_CCS(NN), PRJ_CCS(NN),
	2  CMP_CCS(NN)
	  FIDS(NN) = FILE
	  GO TO 100
  900	ENDDO
	NN = NN -1
 	RETURN
C
  996	PRINT *, '***********************************'
	PRINT *, '* ERROR trying to OPEN PARAM file *'
	CALL TSBEND
  997	PRINT *, '****************************************************'
	PRINT *, '* FILL_PARAMS ERROR reading 1st line of PARAM file *'
	CALL TSBEND
  998	PRINT *, '****************************************************'
	PRINT *, '* FILL_PARAMS ERROR reading 2nd line of PARAM file *'
	CALL TSBEND
  999	PRINT *, '**************************************************'
	PRINT *, '* FILL_PARAMS ERROR reading data from PARAM file *'
	CALL TSBEND
	END

C  ****************************************************************************
C  *                                                                          *
C  *                  *****     SUBROUTINE FREEMEM0     *****                 *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED 26-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM0 (FIDS_P, IDS_P, TS_P, PS_P, OS_P, XS_P, 
	1 YS_P, MAGS_P, CC1S_P, CC2S_P, CC3S_P)
C
	IMPLICIT NONE
C
	INTEGER*4 FIDS(1), IDS(1)
	REAL*4    TS(1), PS(1), OS(1), XS(1), YS(1), MAGS(1), CC1S(1)
	REAL*4    CC2S(1), CC3S(1)
	POINTER   (TS_P,TS), (PS_P,PS), (OS_P,OS), (MAGS_P,MAGS)
	POINTER   (FIDS_P,FIDS), (IDS_P,IDS), (XS_P,XS), (YS_P,YS)
	POINTER   (CC1S_P,CC1S), (CC2S_P,CC2S), (CC3S_P,CC3S)
C  ----------------------------------------------------------------------------
C
	CALL FREE (FIDS_P)
	CALL FREE (IDS_P)
	CALL FREE (TS_P)
	CALL FREE (PS_P)
	CALL FREE (OS_P)
	CALL FREE (XS_P)
	CALL FREE (YS_P)
	CALL FREE (MAGS_P)
	CALL FREE (CC1S_P)
	CALL FREE (CC2S_P)
	CALL FREE (CC3S_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM1     *****                *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 27-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM1 (PRJ_AVG_P, PRJS_P, THETAS_P, PHIS_P,
	1 PROJN_P, PRJ_P, ITMP_P)
C
	IMPLICIT NONE
C
	INTEGER*4 ITMP(1)
	REAL*4    THETAS(1), PHIS(1), PRJ_AVG(1), PRJS(1), PROJN(1), PRJ(1)
	POINTER   (PRJ_AVG_P,PRJ_AVG), (PRJS_P,PRJS)
	POINTER   (THETAS_P,THETAS), (PHIS_P,PHIS), (ITMP_P,ITMP)
	POINTER   (PRJ_P,PRJ), (PROJN_P,PROJN)
C  ----------------------------------------------------------------------------
C
	CALL FREE (PRJ_AVG_P)
	CALL FREE (PRJS_P)
	CALL FREE (THETAS_P)
	CALL FREE (PHIS_P)
	CALL FREE (PROJN_P)
	CALL FREE (ITMP_P)
	CALL FREE (PRJ_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM2     *****                *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 27-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM2 (PRJ_P)
C
	IMPLICIT NONE
C
	REAL*4    PRJ(1)
	POINTER   (PRJ_P,PRJ)
C  ----------------------------------------------------------------------------
C
	CALL FREE (PRJ_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM3     *****                *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS                         *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 27-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM3 (PFT_AVGS_P,SQ2_P,VAR_P,RMS_P,AVER_P,TMP_P)
C
	IMPLICIT NONE
C
	REAL*4  PFT_AVGS(1), TMP(1), SQ2(1), VAR(1), RMS(1), AVER(1)
	POINTER (PFT_AVGS_P,PFT_AVGS), (TMP_P,TMP), (SQ2_P,SQ2)
	POINTER (VAR_P,VAR), (RMS_P,RMS), (AVER_P,AVER)
C  ----------------------------------------------------------------------------
C
	CALL FREE (PFT_AVGS_P)
	CALL FREE (SQ2_P)
	CALL FREE (VAR_P)
	CALL FREE (RMS_P)
	CALL FREE (AVER_P)
	CALL FREE (TMP_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE FREEMEM4     *****                *
C  *                                                                          *
C  *    FREE UP MEMORY.                                                       *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 26-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM4 (FFT1_P, FFT3_P, IMG_P, R4_IMG_P, 
	1 PRJ_ROT_P, PFTIMG_P, PFFT_P, PMAP_P, FLTPMAP_P, PPRJ_P, A_P, 
	2 CCOR_P, ICOR_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NROT, NANNULI, NVIEW_MOD
	real*4    IMG(1)
	INTEGER*4 ICOR(1)
	REAL*4    FFT1(1), FFT3(1), R4_IMG(1), PRJ(1), PRJ_ROT(1)
	REAL*4    PFTIMG(1), PFFT(1), PMAP(1), FLTPMAP(1)
	REAL*4    PPRJ(1), A(1), CCOR(1)
	POINTER   (FFT1_P,FFT1), (FFT3_P,FFT3), (IMG_P,IMG)
	POINTER   (R4_IMG_P,R4_IMG), (PRJ_P,PRJ), (PRJ_ROT_P,PRJ_ROT)
	POINTER   (PFTIMG_P,PFTIMG), (PFFT_P,PFFT), (PMAP_P,PMAP)
	POINTER   (FLTPMAP_P,FLTPMAP), (PPRJ_P,PPRJ), (A_P,A)
	POINTER   (CCOR_P,CCOR), (ICOR_P,ICOR)
C  ----------------------------------------------------------------------------
C
	CALL FREE (FFT1_P)
	CALL FREE (FFT3_P)
	CALL FREE (IMG_P)
	CALL FREE (R4_IMG_P)
	CALL FREE (PRJ_ROT_P)
	CALL FREE (PFTIMG_P)
	CALL FREE (PFFT_P)
	CALL FREE (PMAP_P)
	CALL FREE (FLTPMAP_P)
	CALL FREE (PPRJ_P)
	CALL FREE (A_P)
	CALL FREE (CCOR_P)
	CALL FREE (ICOR_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                *****     SUBROUTINE FREEMEM_REFINE     *****             *
C  *                                                                          *
C  *    RELEASE MEMORY TAKEN BY DYNAMIC MEMORY ARRAYS IN REFINE MODE.         *
C  *                                                                          *
C  *    APRIL 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.          *
C  *    LAST MODIFIED  4-DEC-98 BY SBW (Add FFT6 for CTF stuff).              *
C  ****************************************************************************
C
	SUBROUTINE FREEMEM_REFINE (MAP3D_P, MOD_TS_P, MOD_PS_P, PRJ_P, 
	1 PRJS_P, PROJN_P, PMAP_P, PFTS_P, PFFT_P, ITMP_P, PFT_AVGS_P,
	2 SQ2_P, VAR_P, RMS_P, AVER_P, TMP_P, IMG_P, FFT1_P, FFT3_P, 
	3 FFT4_P, FFT5_P, FFT6_P, MSKIMG_P, MSKPRJ_P, R4_IMG_P, BESTPRJ_P, 
	4 PRJ_ROT_P, PFTIMG_P, R4_PIMG_P, FLTPMAP_P, POLAR_PRJ_P, 
	5 A_ARRAY_P, CCOR_P, TMP1_P, TMP2_P, TMP3_P)
C
	IMPLICIT NONE
C
	reaL*4    IMG(1)
	INTEGER*4 ITMP(1)
	REAL*4    MAP3D(1), MOD_TS(1), MOD_PS(1), PMAP(1), TMP(1)
        REAL*4    PRJ(1), PROJN(1), PFFT(1), VAR(1), RMS(1), AVER(1)
	REAL*4    FFT1(1), FFT3(1), FFT4(1), FFT5(1), FFT6(1), A_ARRAY(1)
	REAL*4    R4_IMG(1), R4_PIMG(1), BESTPRJ(1), PRJ_ROT(1)
	REAL*4    PFTIMG(1), POLAR_PRJ(1), MSKIMG(1), MSKPRJ(1)
	REAL*4    FLTPMAP(1), TMP1(1), TMP2(1), TMP3(1), CCOR(1)
	REAL*4    PRJS(1), PFTS(1), PFT_AVGS(1), SQ2(1)
	POINTER   (ITMP_P,ITMP), (MOD_TS_P,MOD_TS), (MOD_PS_P,MOD_PS)
	POINTER   (PFFT_P,PFFT), (PMAP_P,PMAP), (TMP_P,TMP)
        POINTER   (MAP3D_P,MAP3D), (PRJ_P,PRJ), (PROJN_P,PROJN)
	POINTER   (IMG_P,IMG), (VAR_P,VAR), (RMS_P,RMS), (AVER_P,AVER)
	POINTER   (FFT1_P,FFT1), (FFT3_P,FFT3), (FFT4_P,FFT4)
	POINTER   (FFT5_P,FFT5), (FFT6_P,FFT6)
	pointer   (R4_IMG_P,R4_IMG), (R4_PIMG_P,R4_PIMG)
	POINTER   (MSKIMG_P,MSKIMG), (MSKPRJ_P,MSKPRJ), (PFTS_P,PFTS)
	POINTER   (BESTPRJ_P,BESTPRJ), (PRJ_ROT_P,PRJ_ROT)
	POINTER   (PFTIMG_P,PFTIMG), (PFT_AVGS_P,PFT_AVGS), (SQ2_P,SQ2)
	POINTER   (FLTPMAP_P,FLTPMAP), (POLAR_PRJ_P,POLAR_PRJ)
	POINTER   (CCOR_P,CCOR), (A_ARRAY_P,A_ARRAY), (PRJS_P,PRJS)
	POINTER   (TMP1_P,TMP1), (TMP2_P,TMP2), (TMP3_P,TMP3)
C  ----------------------------------------------------------------------------
C
	CALL FREE (IMG_P)
	CALL FREE (MAP3D_P)
	CALL FREE (MOD_TS_P)
	CALL FREE (MOD_PS_P)
	CALL FREE (PRJ_P)
	CALL FREE (PROJN_P)
	CALL FREE (PMAP_P)
	CALL FREE (PFTS_P)
	CALL FREE (PFFT_P)
	CALL FREE (ITMP_P)
	CALL FREE (VAR_P)
	CALL FREE (RMS_P)
	CALL FREE (AVER_P)
	CALL FREE (TMP_P)
	CALL FREE (R4_IMG_P)
	CALL FREE (R4_PIMG_P)
	CALL FREE (FFT1_P)
	CALL FREE (FFT3_P)
	CALL FREE (FFT4_P)
	CALL FREE (FFT5_P)
	CALL FREE (FFT6_P)
	CALL FREE (MSKIMG_P)
	CALL FREE (MSKPRJ_P)
	CALL FREE (BESTPRJ_P)
	CALL FREE (PRJ_ROT_P)
	CALL FREE (PFTIMG_P)
	CALL FREE (PFT_AVGS_P)
	CALL FREE (SQ2_P)
	CALL FREE (FLTPMAP_P)
	CALL FREE (POLAR_PRJ_P)
	CALL FREE (A_ARRAY_P)
	CALL FREE (CCOR_P)
	CALL FREE (TMP1_P)
	CALL FREE (TMP2_P)
	CALL FREE (TMP3_P)
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM0     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED 26-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE GETMEM0 (NIDS_TOT, FIDS_P, IDS_P, TS_P, PS_P, OS_P, 
	1 XS_P, YS_P, MAGS_P, CC1S_P, CC2S_P, CC3S_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NIDS_TOT, FIDS(1), IDS(1)
	REAL*4    TS(1), PS(1), OS(1), XS(1), YS(1), MAGS(1), CC1S(1)
	REAL*4    CC2S(1), CC3S(1)
	POINTER   (TS_P,TS), (PS_P,PS), (OS_P,OS), (MAGS_P,MAGS)
	POINTER   (FIDS_P,FIDS), (IDS_P,IDS), (XS_P,XS), (YS_P,YS)
	POINTER   (CC1S_P,CC1S), (CC2S_P,CC2S), (CC3S_P,CC3S)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	FIDS_P = MALLOC(4*NIDS_TOT)
	IDS_P  = MALLOC(4*NIDS_TOT)
	TS_P   = MALLOC(4*NIDS_TOT)
	PS_P   = MALLOC(4*NIDS_TOT)
	OS_P   = MALLOC(4*NIDS_TOT)
	XS_P   = MALLOC(4*NIDS_TOT)
	YS_P   = MALLOC(4*NIDS_TOT)
	MAGS_P = MALLOC(4*NIDS_TOT)
	CC1S_P = MALLOC(4*NIDS_TOT)
	CC2S_P = MALLOC(4*NIDS_TOT)
	CC3S_P = MALLOC(4*NIDS_TOT)
C
	IF(FIDS_P.EQ.0 .OR. IDS_P.EQ.0 .OR. TS_P.EQ.0 .OR. PS_P.EQ.0 .OR. 
	1 OS_P.EQ.0 .OR. MAGS_P.EQ.0 .OR. CC1S_P.EQ.0 .OR. CC2S_P.EQ.0
	2 .OR. CC3S_P.EQ.0) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM0 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM1     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 27-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE GETMEM1 (NROT, NCOLBIN, NROWBIN, NVIEW_MOD, NPIX, 
	1 PRJ_AVG_P, PRJS_P, THETAS_P, PHIS_P, PRJ_P, PROJN_P, ITMP_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NROT, NCOLBIN, NROWBIN, NVIEW_MOD, NPIX, ITMP(1)
	integer*8 tempVal
	REAL*4    THETAS(1), PHIS(1), PRJ_AVG(1), PRJS(1), PRJ(1), PROJN(1)
	POINTER   (THETAS_P,THETAS), (PHIS_P,PHIS), (ITMP_P,ITMP)
	POINTER   (PRJ_P,PRJ), (PROJN_P,PROJN)
	POINTER   (PRJ_AVG_P,PRJ_AVG), (PRJS_P,PRJS)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	PRJ_AVG_P = MALLOC (4*NCOLBIN*NROWBIN)
	PRJS_P    = MALLOC (4*NCOLBIN*NROWBIN*NVIEW_MOD)
	tempVal =  (NCOLBIN*NROWBIN*NVIEW_MOD)
	tempVal =  (4*tempVal)
	if(tempVal .gt. 4000000000) then
	   print *, '***************************************************'
	   print *, 'You''re asking for too much memory.'
	   print *, '   Number of cols   - ', ncolbin
	   print *, '   Number of rows   - ', nrowbin
	   print *, '   Number of views  - ', nview_mod
	   print *, '   == ', tempVal, ' total bytes requested.'
	   print *, '          (4 bytes per pixel) '
	   call tsbend
	endif
	THETAS_P  = MALLOC (4*NVIEW_MOD)
	PHIS_P    = MALLOC (4*NVIEW_MOD)
	PRJ_P     = MALLOC (4*NCOLBIN*NROWBIN)
	PROJN_P   = MALLOC (4*NCOLBIN*NROWBIN)
	ITMP_P    = MALLOC (4*NCOLBIN)
C
	IF(PRJ_AVG_P.EQ.0 .OR. PRJS_P.EQ.0 .OR. 
	1 THETAS_P.EQ.0   .OR. PHIS_P.EQ.0 .OR. PRJ_P.EQ.0  .OR.
	2 PROJN_P.EQ.0    .OR. ITMP_P.EQ.0) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM1 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM3     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    MODIFIED 27-FEB-1998 BY TSB (Make UNIX compatible).                   *
C  *    LAST MODIFIED 27-FEB-1998 BY TSB (Fix VAR allocation to INT*4).       *
C  ****************************************************************************
C
	SUBROUTINE GETMEM3 (NVIEW_MOD, NPIX, NROT, NANNULI, PFT_AVGS_P, 
	1 SQ2_P, VAR_P, RMS_P, AVER_P, TMP_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NVIEW_MOD, NPIX, NROT, NANNULI
	REAL*4    PFT_AVGS(1), TMP(1), SQ2(1), VAR(1), RMS(1), AVER(1)
	POINTER   (PFT_AVGS_P,PFT_AVGS), (TMP_P,TMP), (SQ2_P,SQ2)
	POINTER   (VAR_P,VAR), (RMS_P,RMS), (AVER_P,AVER)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	PFT_AVGS_P = MALLOC (4*NVIEW_MOD)
	SQ2_P      = MALLOC (4*NVIEW_MOD)
	VAR_P      = MALLOC (4*NPIX)
	RMS_P      = MALLOC (4*NPIX)
	AVER_P     = MALLOC (4*NPIX)
	TMP_P      = MALLOC (NROT*NANNULI)
	IF(PFT_AVGS_P.EQ.0 .OR. SQ2_P.EQ.0 .OR. VAR_P.EQ.0 .OR. 
	1 RMS_P.EQ.0 .OR. AVER_P.EQ.0 .OR. TMP_P.EQ.0) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM3 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GETMEM4     *****                 *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS                                          *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED 26-FEB-1998 BY TSB (Make UNIX compatible).              *
C  ****************************************************************************
C
	SUBROUTINE GETMEM4 (NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, 
	1 NVIEW_MOD, FFT1_P, FFT3_P, IMG_P, R4_IMG_P, PRJ_ROT_P, 
	2 PFTIMG_P, PFFT_P, PMAP_P, FLTPMAP_P, A_P, CCOR_P, ICOR_P, PPRJ_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, NVIEW_MOD
	real*4    IMG(1)
	INTEGER*4 ICOR(1)
	REAL*4    FFT1(1), FFT3(1), R4_IMG(1), PRJ_ROT(1), A(1)
	REAL*4    PFTIMG(1), PFFT(1), PMAP(1), FLTPMAP(1), PPRJ(1)
	REAL*4    CCOR(1)
	POINTER   (FFT1_P,FFT1), (FFT3_P,FFT3), (IMG_P,IMG)
	POINTER   (R4_IMG_P,R4_IMG), (PRJ_ROT_P,PRJ_ROT)
	POINTER   (PFTIMG_P,PFTIMG), (PFFT_P,PFFT), (PMAP_P,PMAP)
	POINTER   (FLTPMAP_P,FLTPMAP), (A_P,A), (PPRJ_P,PPRJ)
	POINTER   (CCOR_P,CCOR), (ICOR_P,ICOR)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	FFT1_P    = MALLOC (8*IDIM1*IDIM2)      		    ! RAW IMAGE
	FFT3_P    = MALLOC (8*IDIM1*IDIM2) 		      ! MOD PRJ @ T,P,O
	IMG_P     = MALLOC (4*NCOL*NROW)
	R4_IMG_P  = MALLOC (4*NCOL*NROW)
	PRJ_ROT_P = MALLOC (4*NCOL*NROW)
	PFTIMG_P  = MALLOC (NROT*NANNULI)
	PFFT_P    = MALLOC (4*2*NROT*NANNULI)
	PMAP_P    = MALLOC (4*NROT*NANNULI)
	FLTPMAP_P = MALLOC (4*NROT*NANNULI)
	PPRJ_P    = MALLOC (4*NROT*NANNULI)
	A_P       = MALLOC (4*2*NROT)
	CCOR_P    = MALLOC (4*NVIEW_MOD)
	ICOR_P    = MALLOC (4*NVIEW_MOD)
	IF(FFT1_P.EQ.0   .OR.    FFT3_P.EQ.0 .OR. IMG_P.EQ.0     .OR. 
	1 R4_IMG_P.EQ.0  .OR. PRJ_ROT_P.EQ.0 .OR. 
	2 PFTIMG_P.EQ.0  .OR. PFFT_P.EQ.0    .OR. PMAP_P.EQ.0    .OR. 
	3 FLTPMAP_P.EQ.0 .OR. A_P.EQ.0       .OR.
	4 CCOR_P.EQ.0 .OR. ICOR_P.EQ.0) THEN
	  PRINT *, '*************************************************'
	  PRINT *, '* GETMEM4 memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                *****     SUBROUTINE GETMEM_REFINE     *****              *
C  *                                                                          *
C  *    SET UP DYNAMIC MEMORY ARRAYS FOR REFINE MODE                          *
C  *                                                                          *
C  *    APRIL 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.          *
C  *    LAST MODIFIED  4-DEC-98 BY SBW (Add FFT6 for CTF stuff).              *
C  ****************************************************************************
C
	SUBROUTINE GETMEM_REFINE (NPIX, NROT, NANNULI, NCOLBIN, NROWBIN, 
	1 NSECBIN, NTHE, NPHI, IDIM1, IDIM2, MAP3D_P, MOD_TS_P, MOD_PS_P, 
	2 IMG_P, R4_IMG_P, R4_PIMG_P, PRJ_P, PROJN_P, BESTPRJ_P, PMAP_P, 
	3 PFFT_P, VAR_P, RMS_P, AVER_P, MASK_P, DPHIS_P, FFT1_P, FFT3_P, 
	4 FFT4_P, FFT5_P, FFT6_P, MSKIMG_P, MSKPRJ_P, PRJ_ROT_P, PFTIMG_P, 
	5 FLTPMAP_P, POLAR_PRJ_P, A_ARRAY_P, ITMP_P, TMP_P, TMP1_P, 
	6 TMP2_P, TMP3_P)
C
	IMPLICIT NONE
C
	INTEGER*4 NPIX, NROT, NANNULI, NCOLBIN, NROWBIN, NSECBIN
	INTEGER*4 NTHE, NPHI, ITMP(1), MASK(1), IDIM1, IDIM2
	real*4    IMG(1)
	REAL*4    MAP3D(1), MOD_TS(1), MOD_PS(1), PMAP(1)
        REAL*4    PRJ(1), PROJN(1), PFFT(1), A_ARRAY(1), DPHIS(1)
	REAL*4    VAR(1), RMS(1), AVER(1), TMP(1)
	REAL*4    FFT1(1), FFT3(1), FFT4(1), FFT5(1), FFT6(1)
	REAL*4    R4_IMG(1), R4_PIMG(1), BESTPRJ(1), PRJ_ROT(1)
	REAL*4    PFTIMG(1), FLTPMAP(1), POLAR_PRJ(1)
	REAL*4    CCOR(1), TMP1(1), TMP2(1), TMP3(1)
	REAL*4    MSKIMG(1), MSKPRJ(1)
	POINTER   (ITMP_P,ITMP), (MOD_TS_P,MOD_TS), (MOD_PS_P,MOD_PS)
	POINTER   (PFFT_P,PFFT), (PMAP_P,PMAP), (A_ARRAY_P,A_ARRAY)
        POINTER   (MAP3D_P,MAP3D), (PROJN_P,PROJN), (PRJ_P,PRJ)
	POINTER   (VAR_P,VAR), (RMS_P,RMS), (AVER_P,AVER), (TMP_P,TMP)
	POINTER   (IMG_P,IMG), (DPHIS_P,DPHIS), (MASK_P,MASK)
	POINTER   (FFT1_P,FFT1), (FFT3_P,FFT3), (FFT4_P,FFT4)
	POINTER   (FFT5_P,FFT5), (FFT6_P,FFT6)
	pointer   (R4_IMG_P,R4_IMG), (R4_PIMG_P,R4_PIMG)
	POINTER   (MSKIMG_P,MSKIMG), (MSKPRJ_P,MSKPRJ)
	POINTER   (BESTPRJ_P,BESTPRJ), (PRJ_ROT_P,PRJ_ROT)
	POINTER   (PFTIMG_P,PFTIMG)
	POINTER   (FLTPMAP_P,FLTPMAP), (POLAR_PRJ_P,POLAR_PRJ)
	POINTER   (TMP1_P,TMP1), (TMP2_P,TMP2), (TMP3_P,TMP3)
	LOGICAL   MALLOC
C  ----------------------------------------------------------------------------
C
	MAP3D_P     = MALLOC (4*NCOLBIN*NROWBIN*NSECBIN)
	MOD_TS_P    = MALLOC (4*NTHE)
	MOD_PS_P    = MALLOC (4*NPHI*NTHE)
	IMG_P       = MALLOC (2*NCOLBIN*NROWBIN)
	R4_IMG_P    = MALLOC (4*NCOLBIN*NROWBIN)	      ! FLOAT RAW IMAGE
	R4_PIMG_P   = MALLOC (4*NROT*NANNULI)		! FLOAT POLAR RAW IMAGE
	PRJ_P       = MALLOC (4*NCOLBIN*NROWBIN)
	PROJN_P     = MALLOC (4*NCOLBIN*NROWBIN)
	PMAP_P      = MALLOC (4*NROT*NANNULI)
	PFFT_P      = MALLOC (4*2*NROT*NANNULI)
	VAR_P       = MALLOC (2*NPIX)
	RMS_P       = MALLOC (4*NPIX)
	AVER_P      = MALLOC (4*NPIX)
	MASK_P      = MALLOC (4*2*NPHI*NTHE)
	DPHIS_P     = MALLOC (4*NTHE)
	FFT1_P      = MALLOC (8*IDIM1*IDIM2)      	     ! FFT OF RAW IMAGE
	FFT3_P      = MALLOC (8*IDIM1*IDIM2) 		      ! MOD PRJ @ T,P,O
	FFT4_P      = MALLOC (8*IDIM1*IDIM2)		       ! MASKED RAW IMG
	FFT5_P      = MALLOC (8*IDIM1*IDIM2)		       ! MASKED MOD PRJ
	FFT6_P      = MALLOC (8*IDIM1*IDIM2)                 ! FOR APPLYING CTF
	BESTPRJ_P   = MALLOC (4*NCOLBIN*NROWBIN)	! BEST MODEL PROJECTION
	PRJ_ROT_P   = MALLOC (4*NCOLBIN*NROWBIN)
	PFTIMG_P    = MALLOC (NROT*NANNULI)
	FLTPMAP_P   = MALLOC (4*NROT*NANNULI)
	POLAR_PRJ_P = MALLOC (4*NROT*NANNULI)
	MSKIMG_P    = MALLOC (4*NCOLBIN*NROWBIN)
	MSKPRJ_P    = MALLOC (4*NCOLBIN*NROWBIN)
	A_ARRAY_P   = MALLOC (4*2*NROT)
	ITMP_P      = MALLOC (4*NCOLBIN)
	TMP_P       = MALLOC (NROT*NANNULI)
	TMP1_P      = MALLOC (4*NCOLBIN*NROWBIN)
	TMP2_P      = MALLOC (8*IDIM1*IDIM2)
	TMP3_P      = MALLOC (8*IDIM1*IDIM2)
C
	IF(  ITMP_P.EQ.0 .OR.    MOD_TS_P.EQ.0 .OR.  MOD_PS_P.EQ.0 .OR.
	1   MAP3D_P.EQ.0 .OR.     PROJN_P.EQ.0 .OR.    PMAP_P.EQ.0 .OR. 
	2    PFFT_P.EQ.0 .OR.       VAR_P.EQ.0 .OR.     RMS_P.EQ.0 .OR.
	3    AVER_P.EQ.0 .OR.       TMP_P.EQ.0 .OR.     PRJ_P.EQ.0 .OR.
	5     IMG_P.EQ.0 .OR.      MASK_P.EQ.0 .OR.   DPHIS_P.EQ.0 .OR.
	6    FFT1_P.EQ.0 .OR.      FFT3_P.EQ.0 .OR.    FFT4_P.EQ.0 .OR. 
	7    FFT5_P.EQ.0 .OR.    MSKIMG_P.EQ.0 .OR.  MSKPRJ_P.EQ.0 .OR.
	8  R4_IMG_P.EQ.0 .OR.   BESTPRJ_P.EQ.0 .OR. PRJ_ROT_P.EQ.0 .OR. 
	9  PFTIMG_P.EQ.0 .OR.   R4_PIMG_P.EQ.0 .OR. FLTPMAP_P.EQ.0 .OR. 
	1 POLAR_PRJ_P.EQ.0 .OR. A_ARRAY_P.EQ.0 .OR. FFT6_P.EQ.0 .OR. 
	2    TMP1_P.EQ.0 .OR.      TMP2_P.EQ.0 .OR.    TMP3_P.EQ.0) THEN
	  PRINT *, '*******************************************************'
	  PRINT *, '* GETMEM_REFINE memory allocation error: EXIT program *'
	  CALL TSBEND
	ENDIF
C
	RETURN
	END	

C  ****************************************************************************
C  *                                                                          *
C  *                *****     SUBROUTINE GETMEM_REFINE2     *****             *
C  *                                                                          *
C  *    DETERMINE SIZE OF PRJ/PFT ARRAYS THAT CAN BE PROCESSED.               *
C  *                                                                          *
C  *    IF CAN'T CALCULATE AND STORE ALL NEEDED MODEL VIEWS, THEN RESORT TO   *
C  *     SLIDING WINDOW APPROACH, IN WHICH THE ASYMMETRIC UNIT IS DIVIDED     *
C  *     INTO SMALL ENOUGH WINDOWS TO PROCESS A SUB-SET OF IMAGES.            *
C  *                                                                          *
C  *    MAY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.            *
C  ****************************************************************************
C
	SUBROUTINE GETMEM_REFINE2 (NUNIQUE, N_INCORE, NCOLBIN, NROWBIN, 
	1 NTHE, NPHI, NPIX, CCOR_P, PFT_AVGS_P, SQ2_P, PRJS_P, PFTS_P, 
	2 MASK, ITHE2, SLIDE)
C
	IMPLICIT NONE
C
	INTEGER*4 NUNIQUE, N_INCORE, NCOLBIN, NROWBIN, NTHE, NPHI, I, J
	INTEGER*4 NUM_THIS_THE, ITEST, NPIX, MASK(NPHI,NTHE,2), ITHE2
	REAL*4    CCOR(1), PFT_AVGS(1), SQ2(1), PRJS(1), PFTS(1)
	POINTER   (CCOR_P,CCOR), (PFT_AVGS_P,PFT_AVGS)
	POINTER   (SQ2_P,SQ2), (PRJS_P,PRJS), (PFTS_P,PFTS)
	LOGICAL   MALLOC, SLIDE, test
C  ----------------------------------------------------------------------------
C
	SLIDE      = .FALSE.
	ITHE2      = NTHE
	test = .true.
	N_INCORE   = NUNIQUE
  100	CCOR_P     = MALLOC (4*N_INCORE)
	PFT_AVGS_P = MALLOC (4*N_INCORE)
	SQ2_P      = MALLOC (4*N_INCORE)
	PRJS_P     = MALLOC (4*NCOLBIN*NROWBIN*N_INCORE)
	PFTS_P     = MALLOC (4*NPIX*N_INCORE)
C
	IF(CCOR_P.EQ.0 .OR. PFT_AVGS_P.EQ.0 .OR.  SQ2_P.EQ.0 .OR.
	1  PRJS_P.EQ.0 .OR.     PFTS_P.EQ.0 .or. test) THEN
ccc	1  PRJS_P.EQ.0 .OR.     PFTS_P.EQ.0) THEN
	  CALL FREE (CCOR_P)
	  CALL FREE (PFT_AVGS_P)
	  CALL FREE (SQ2_P)
	  CALL FREE (PRJS_P)
	  CALL FREE (PFTS_P)
C         **********************************************************
C---------*    HERE IF NEED TO INCREASE NUMBER OF SEARCH WINDOWS   *
C         **********************************************************
	  N_INCORE = N_INCORE/2
	  SLIDE    = .TRUE.
C         ******************************************************************
C---------*    SEE HOW MANY VIEWS CAN BE PROCESSED WITH RESTRICTION THAT   *
C         *     ONLY FULL ROWS (THETA VALUE IS THE SAME) ARE PROCESSED.    *
C         ******************************************************************
	  ITEST = 0
	  DO J = 1,NTHE
	    NUM_THIS_THE = 0
	    DO I = 1,NPHI
	      IF(MASK(I,J,1).GE.1) ITEST = ITEST + 1
	      NUM_THIS_THE = NUM_THIS_THE + 1
	      IF(ITEST.GT.N_INCORE) THEN
	        N_INCORE = ITEST - NUM_THIS_THE
	        IF(N_INCORE.LE.0) THEN
	          PRINT *, '*********************************'
	          PRINT *, '* N_INCORE .LE. 0: STOP PROGRAM *'
	          CALL TSBEND
	        ENDIF
	test = .false.
	        ITHE2 = J-1
	        GO TO 100
	      ENDIF
	    ENDDO
	  ENDDO
	  N_INCORE = ITEST
	test = .false.
	  GO TO 100
	ENDIF
C
	IF(.NOT.SLIDE) RETURN
	PRINT *, '***************************************************'
	PRINT *, '* Not enough memory to fit asu in search window.  *'
	PRINT *, '*  Use sliding window search procedure.           *'
	PRINT *, '***************************************************'
C
	RETURN
	END	

C  ***************************************************************************
C  *                                                                         *
C  *                 *****     SUBROUTINE GET_BESTMAG     *****              *
C  *                                                                         *
C  *	Compares an image against a model 2D projection over a range of      *
C  *    magnifications.  Returns the MAG factor with the best PRJ/IMG        *
C  *    correlation.  Correlation done in real space.	                     *
C  *								             *
C  *	Modified from IMG_CMP_PRJ, July 1996, by D. Belnap                   *
C  *    MODIFIED  8-JAN-1998 BY T. BAKER (Changed from SCALE to MAG)         *
C  *    LAST MODIFIED 22-APR-1998 BY T. BAKER (Renamed from PFTCC_GETMAG).   *
C  ***************************************************************************
C
	SUBROUTINE GET_BESTMAG (IMG, PRJ, TMP, FFTI, FFTM, NCOL, NROW, 
	1 IDIM1, IDIM2, RADLO, RADHI, RESMIN, RESMAX, X_CEN, Y_CEN, 
	2 OME_BEST, MAG_LO, MAG_NUM, MAG_STEP, BEST_MAG, BEST_CCOEF, 
	3 IMG_BKG, FFT_ORIGX, FFT_ORIGY)
C
	IMPLICIT NONE
C
	INTEGER*4 I, J, K, NCOL, NROW, IDIM1, IDIM2, MAG_NUM
	real*4    IMG(NCOL,NROW)
	real*4    IMG_BKG
	REAL*4    TOT, PRJ(NCOL,NROW), TMP(NCOL,NROW), A, B
	REAL*4    FFTI(2*IDIM1,IDIM2), FFTM(2*IDIM1,IDIM2)
	REAL*4    MAG, MAG_STEP, MAG_LO, X_CEN, Y_CEN, RESMIN, RESMAX
	REAL*4    CCOEF, BEST_CCOEF, BEST_MAG, OME_BEST
	REAL*4    RADLO, RADHI, RADDSQ, RADLOSQ, RADHISQ, YSQ
	REAL*4    FFT_ORIGX, FFT_ORIGY, FFT_FZERO
	REAL*8    SUMA, SUMB, SUMASQ, SUMBSQ, SUMAB
	LOGICAL   FFT_FULL
C  ---------------------------------------------------------------------------
C
C  *******************************
C  *    Initialize parameters    *
C  *******************************
	RADLOSQ    = RADLO*RADLO
	RADHISQ    = RADHI*RADHI
	BEST_CCOEF = 0.0
	BEST_MAG   = 1.0
C  **************************************************************
C  *  Filter in reciprocal space if RESMIN or RESMAX are > 0.0  *
C  **************************************************************
	IF (RESMIN.GT.0.0 .OR. RESMAX.GT.0.0) THEN
	  CALL R4_IMG_FFT_FILL (IMG, NCOL, NROW, FFTI, IDIM1, IDIM2,
	1  IMG_BKG, FFT_ORIGX, FFT_ORIGY, FFT_FZERO, FFT_FULL, 0)
	  CALL MAP_FFT_FILL (PRJ, NCOL, NROW, 1, 1, FFTM, IDIM1, IDIM2, 
	1  FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	  CALL FFT_2D (FFTI, IDIM1, IDIM2)
	  CALL FFT_2D (FFTM, IDIM1, IDIM2)
	  IF (RESMAX.GT.0.0) THEN
	    CALL FFT_LOP (FFTI, IDIM1, IDIM2, RESMAX, 0.0, .TRUE.)
	    CALL FFT_LOP (FFTM, IDIM1, IDIM2, RESMAX, 0.0, .TRUE.)
	  ENDIF
	  IF (RESMIN.GT.0.0) THEN
	    CALL FFT_HIP (FFTI, IDIM1, IDIM2, RESMIN, 0.0, .TRUE.)
	    CALL FFT_HIP (FFTM, IDIM1, IDIM2, RESMIN, 0.0, .TRUE.)
	  ENDIF
	  CALL FFT_2D_BACK (FFTI, IDIM1, IDIM2)		       ! Back-transform
	  CALL FFT_2D_BACK (FFTM, IDIM1, IDIM2)		       ! Back-transform
	  CALL FFT_IMG_FILL (FFTI, IDIM1, IDIM2, IMG, NCOL, NROW,
	1  FFT_FULL, IMG_BKG, 0)
	  CALL FFT_MAP_FILL (FFTM, IDIM1, IDIM2, PRJ, NCOL, NROW, 1, 1,
	1  FFT_FULL)
	ENDIF
C  ***************************************************************
C  *    LOOP THROUGH SPECIFIED MAGNIFICATION SCALE FACTOR RANGE  *
C  ***************************************************************
	MAG = MAG_LO
	DO I = 1,MAG_NUM		! INITIALIZE PARAMETERS FOR EACH LOOP
	  SUMA    = 0.0
	  SUMB    = 0.0
	  SUMAB   = 0.0
	  SUMASQ  = 0.0
	  SUMBSQ  = 0.0
	  TOT     = 0.0
	  DO K = 1,NROW		         ! Load PRJ ("Gold standard") into TMP
	    DO J = 1,NCOL
	      TMP(J,K) = PRJ(J,K)
	    ENDDO
	  ENDDO
C	  *******************************************************
C	  *  Scale projection and move it to X,Y origin of IMG  *
C	  *******************************************************
	  CALL INTERP2D (TMP, NCOL, NROW, X_CEN, Y_CEN,
	1  FLOAT(NCOL-1)/2.0, FLOAT(NROW-1)/2.0, OME_BEST, MAG, 0.0)
C	  **********************************************************
C	  *  Loop through IMG and PRJ, get values for coefficient  *
C	  *  calculation, J and K must be within RADLO and RADHI   *
C	  **********************************************************
	  DO K = 1,NROW
	    YSQ = (FLOAT(K)-Y_CEN+1.0)**2
	    DO J = 1,NCOL
	      RADDSQ = (FLOAT(J)-X_CEN+1.0)**2 + YSQ
	      IF(RADDSQ.GE.RADLOSQ .AND. RADDSQ.LE.RADHISQ) THEN
		A      = IMG(J,K) - IMG_BKG
		B      = TMP(J,K)
		SUMA   = SUMA + A
		SUMB   = SUMB + B
		SUMAB  = SUMAB + A*B
		SUMASQ = SUMASQ + A*A
		SUMBSQ = SUMBSQ + B*B
		TOT    = TOT + 1.0
	      ENDIF
	    ENDDO
	  ENDDO
C	  *************************************
C	  *  Compute correlation coefficient  *
C	  *************************************
	  IF(TOT.EQ.0. .OR. (SUMASQ-SUMA*SUMA).EQ.0. .OR.
	1  (SUMBSQ-SUMB*SUMB).EQ.0.) THEN
	     CCOEF = 1.0E-20
	   ELSE
	     CCOEF = (SUMAB - (SUMA*SUMB)/TOT) /
	1            (SQRT(SUMASQ - (SUMA*SUMA)/TOT)*
	2             SQRT(SUMBSQ - (SUMB*SUMB)/TOT))
	  ENDIF
	  IF(ABS(CCOEF).GT.ABS(BEST_CCOEF)) THEN	! Test for best CCOEF
	    BEST_CCOEF = CCOEF
	    BEST_MAG   = MAG
	  ENDIF
D	  WRITE(6,'(A,2F10.4)') ' CCOEF, MAG =', CCOEF, MAG
	  MAG = MAG + MAG_STEP			     ! Increment MAG i DO loop
	ENDDO
C
 999	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE GET_BESTPRJ       *****               *
C  *                                                                           *
C  *    READ IN THE APPROPRIATE PROJECTION FOR CROSS-CORRELATION WITH THE      *
C  *     RAW IMAGE.                                                            *
C  *                                                                           *
C  *    ADDITIONAL TEST FOR DO-LOOP: NUM.LE.NVIEW_MOD (KAD)                    *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *                                                                           *
C  *    MODIFIED 23-DEC-1997 BY T. BAKER (Using PRJS in memory).               *
C  *    MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PFTs/PRJs).            *
C  *    MODIFIED  6-FEB-1998 BY TSB (Use of INDEX instead of T/P arrays).      *
C  *    MODIFIED 26-FEB-1998 BY TSB (Make UNIX compatible).                    *
C  *    LAST MODIFIED 29-APR-1998 BY TSB (Renamed from PFTCC_GETPRJ).          *
C  *****************************************************************************
C
	SUBROUTINE GET_BESTPRJ (BESTPRJ, NCOLBIN, NROWBIN, NVIEWS,
	1 PRJS, MODE, INDEX, PRJHEAD)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ PRJHEAD
C
	INTEGER*4 NCOLBIN, NROWBIN, I, J, NUM, NVIEWS, MODE
	INTEGER*4 INDEX
	REAL*4    BESTPRJ(NCOLBIN,NROWBIN), PRJS(NCOLBIN,NROWBIN,NVIEWS)
C  ----------------------------------------------------------------------------
C
	IF(MODE.LT.0) GO TO 100
C  *************************************************************************
C  *    HERE TO READ IN THE BEST MODEL PROJECTION STORED IN CORE MEMORY    *
C  *************************************************************************
	DO J = 1,NROWBIN
	  DO I = 1,NCOLBIN
	    BESTPRJ(I,J) = PRJS(I,J,INDEX)
	  ENDDO
	ENDDO
	RETURN
C  **********************************************************************
C  *    HERE IF PRJ DATA STORED ON DISK: Just read the section needed   *
C  **********************************************************************
  100	CALL PIF_READ_SECI4 (PRJHEAD, BESTPRJ, NCOLBIN, NROWBIN, INDEX)
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE GET_ITHE2     *****               *
C  *                                                                          *
C  *    DETERMINE THE THETA LIMIT FOR THE NEXT WINDOW OF MEMORY.              *
C  *                                                                          *
C  *    MAY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.            *
C  ****************************************************************************
C
	SUBROUTINE GET_ITHE2 (N_INCORE, NCOLBIN, NROWBIN, NROT, NANNULI, 
	1 NTHE, NPHI, ITHE1, ITHE2, MASK, PRJS, PFTS, SLIDE, OFFSET)
C
	IMPLICIT NONE
C
	INTEGER*4 N_INCORE, ITHE1, ITHE2, NTHE, NPHI, I, J, NUM_THIS_THE
	INTEGER*4 MASK(NPHI,NTHE,2), ID_OLD, ID_NEW, IPHI, ITHE
	INTEGER*4 NROT_BY_4, NA, NR, COL, ROW, ITEST
	INTEGER*4 NCOLBIN, NROWBIN, NANNULI, NROT, OFFSET, ITHE_REUSE
	REAL*4    PRJS(NCOLBIN,NROWBIN,N_INCORE)
	REAL*4    PFTS((NROT/4),NANNULI,N_INCORE)
	LOGICAL   SLIDE
C  ----------------------------------------------------------------------------
C
C  **********************************************
C  *    FIND PRJ/PFT DATA THAT CAN BE REUSED    *
C  **********************************************
	DO ITHE = ITHE1,ITHE2
	  DO IPHI = 1,NPHI
	    IF(MASK(IPHI,ITHE,1).GE.1) THEN 		! FOUND REUSABLE DATA
	      ITHE_REUSE = ITHE
	      GO TO 100
	    ENDIF
	  ENDDO
	ENDDO
C  ****************************************************************************
C  *    HERE IF NO DATA OVERLAP AND HENCE NO NEED TO COPY TO TOP OF ARRAYS    *
C  ****************************************************************************
	ITHE1  = ITHE2 + 1
	OFFSET = 0
	GO TO 200
C  *****************************************************************
C  *    MOVE THE REUSABLE PRJ/PFT DATA TO THE TOP OF THE ARRAYS    *
C  *****************************************************************
  100	NROT_BY_4 = NROT/4
	ITHE1     = ITHE_REUSE
	ID_NEW    = 0
C
	DO ITHE = ITHE1,ITHE2
	  DO IPHI = 1,NPHI
	    IF(MASK(IPHI,ITHE,1).GE.1) THEN
	      ID_OLD            = MASK(IPHI,ITHE,2)
	      ID_NEW            = ID_NEW + 1
	      DO ROW = 1,NROWBIN
	        DO COL = 1,NCOLBIN
	          PRJS(COL,ROW,ID_NEW) = PRJS(COL,ROW,ID_OLD)
	        ENDDO
	      ENDDO
	      DO NA = 1,NANNULI
	        DO NR = 1,NROT_BY_4
	          PFTS(NR,NA,ID_NEW) = PFTS(NR,NA,ID_OLD)
	        ENDDO
	      ENDDO
	    ENDIF
	  ENDDO
	ENDDO
	OFFSET   = ID_NEW
C
  200	IF(ITHE1.GT.NTHE) THEN
	  SLIDE = .FALSE.
	  RETURN
	ENDIF
C       ******************************************************************
C       *    DETERMINE NEW UPPER LIMIT ON THETA FOR NEXT WINDOW.         *
C-------*    SEE HOW MANY VIEWS CAN BE PROCESSED - RESTRICTION IS THAT   *
C       *     ONLY FULL ROWS (SAME THETA VALUE) ARE PROCESSED.           *
C       ******************************************************************
	ITEST = 0
	ITHE2 = NTHE
C
	DO ITHE = ITHE1,NTHE
	  NUM_THIS_THE = 0
	  DO IPHI = 1,NPHI
	    IF(MASK(IPHI,ITHE,1).GE.1) THEN
	      ITEST             = ITEST + 1
	      MASK(IPHI,ITHE,2) = ITEST
	      NUM_THIS_THE      = NUM_THIS_THE + 1
	    ENDIF
	    IF(ITEST.GT.N_INCORE) THEN
	      ITEST = ITEST - NUM_THIS_THE
	      IF(ITEST-OFFSET.LE.0) THEN
	        PRINT *, '************************************************'
	        PRINT *, '* GET_ITHE2: Can not process another THETA row *'
	        PRINT *, '* STOP PROGRAM                                 *'
	        CALL TSBEND
	      ENDIF
	      ITHE2 = ITHE - 1
	      GO TO 300
	    ENDIF
	  ENDDO					    ! DO IPHI = 1,NPHI
	ENDDO					    ! DO ITHE = ITHE_NEW,NTHE
C
  300	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE GET_NVIEW_MOD     *****               *
C  *                                                                           *
C  *    ROUTINE FOR CALCULATING NTHE AND NVIEW_MOD FOR ASYMMETRIC UNIT.        *
C  *                                                                           *
C  *	PURDUE UNIVERSITY DEC 3000, January 1994, D. Belnap.		       *
C  *    LAST MODIFIED 24-DEC-1997 BY T. BAKER (Use NVIEW_MOD variable).        *
C  *****************************************************************************
C
	SUBROUTINE GET_NVIEW_MOD (SYM, DTHE, DPHI_90, NTHE, NVIEW_MOD)
C
	IMPLICIT NONE
C
	INTEGER*4  SYM, NTHE, NPHI, NVIEW_MOD, I
	REAL*4     DTHE, DPHI, DPHI_90, THETA, THE1, THE2, PHI1
	REAL*4     PHIMAX
C -----------------------------------------------------------------------------
C
	CALL GET_T1T2P1 (SYM, THE1, THE2, PHI1)
	NTHE      = NINT((THE2-THE1)/DTHE) + 1
	THETA     = THE1
	NVIEW_MOD = 0
	DO I = 1,NTHE
	  IF (THETA.EQ.0.0 .OR. THETA.EQ.180.0) THEN
	     NPHI = 1				!At THETA = 0 or 180, PHI = 0.0
	   ELSE
	     DPHI = DPHI_90 / SIND(THETA)
Ca Misha and Rob Dec 2003 - Changed the line below to prevent iterating
Ca outside the ASU.
Ca	     NPHI = NINT( (PHIMAX(SYM,THETA)-PHI1) / DPHI )  +  1
	     NPHI =  INT( (PHIMAX(SYM,THETA)-PHI1) / DPHI )  +  1
	  ENDIF
	  NVIEW_MOD = NVIEW_MOD + NPHI
	  IF (SYM.EQ.532 .AND. THETA.EQ.69.09484255211070) THEN
	     THETA = 69.0 + DTHE
	   ELSE
	     THETA = THETA + DTHE
	  ENDIF
	ENDDO
	RETURN
C
	END

C  *****************************************************************************
C  *                                                                           *
C  *                 *****     SUBROUTINE GET_PHIOMEGA     *****               *
C  *                                                                           *
C  *    FIND BEST OMEGA VALUE AND TEST FOR BEST PHI (POSITIVE OR NEGATIVE).    *
C  *                                                                           *
C  *    NOTE: REAL SPACE CORRELATION COEFFICIENTS ARE USED.                    *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *                                                                           *
C  *    LAST MODIFIED 29-APR-1998 BY T. BAKER (Renamed from PFTCC_GETPO).      *
C  *****************************************************************************
C
	SUBROUTINE GET_PHIOMEGA (R4_PIMG, POLAR_PRJ, NROT, NANNULI, 
	1 DEL_ANG, OME_BEST, ANN_LO, ANN_HI, FLIP, CCPRJ_BEST, MODE)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 NROT, NANNULI, I, II, J, ANN_LO, ANN_HI, IXOFF
	INTEGER*4 XBEST1, XBEST2, MODE
	REAL*4    R4_PIMG(NROT,NANNULI), POLAR_PRJ(NROT,NANNULI)
	REAL*4    A, B, SUMA, SUMB, SUMAB, SUMASQ, SUMBSQ, DIFFERENCE
	REAL*4    CCPRJ, CCPRJ_MAX1, CCPRJ_MAX2, CCPRJ_BEST, TOT
	REAL*4    OMEGA1, OMEGA2, OME_BEST, DEL_ANG
	LOGICAL   FLIP
C  -----------------------------------------------------------------------------
C
	CCPRJ_MAX1 = R4_MIN
	CCPRJ_MAX2 = R4_MIN
	SUMA       = 0.0
	SUMB       = 0.0
	TOT        = 0.0
C
	DO J = ANN_LO,ANN_HI
	  DO I = 1,NROT
	    SUMA = SUMA + R4_PIMG(I,J+1)*J
	    SUMB = SUMB + POLAR_PRJ(I,J+1)*J
	    TOT  = TOT + 1.0
	  ENDDO
	ENDDO
C  ********************************************
C  *    CHECK FOR POSITIVE PHI ANGLE FIRST    *
C  ********************************************
	DO IXOFF = 0,NROT-1
	  SUMAB  = 0.0
	  SUMASQ = 0.0
	  SUMBSQ = 0.0
	  DO J = ANN_LO,ANN_HI
	    DO I = 1,NROT
	      II     = I + IXOFF
	      IF(II.GT.NROT) II = II - NROT
	      A      = R4_PIMG(I,J+1)*J
	      B      = POLAR_PRJ(II,J+1)*J
	      SUMAB  = SUMAB  + A*B
	      SUMASQ = SUMASQ + A*A
	      SUMBSQ = SUMBSQ + B*B
	    ENDDO
	  ENDDO
	  CCPRJ = (SUMAB - (SUMA*SUMB)/TOT) /
	1         (SQRT(SUMASQ - (SUMA*SUMA)/TOT)*
	2          SQRT(SUMBSQ - (SUMB*SUMB)/TOT))
CCC	  WRITE(6,'(A,I4,F10.3)') ' IX,CCPRJ =', IXOFF, CCPRJ
	  IF(CCPRJ.GT.CCPRJ_MAX1) THEN
	    CCPRJ_MAX1 = CCPRJ
	    XBEST1     = IXOFF
	  ENDIF
	ENDDO
	OMEGA1 = 360.0 - DEL_ANG*XBEST1
CCC	WRITE(*,'(A,F8.1,F10.3)') ' OMEGA1,CCPRJ =', OMEGA1, CCPRJ_MAX1
C  ******************************************
C  *    NOW CHECK FOR NEGATIVE PHI ANGLE    *
C  ******************************************
	DO IXOFF = 0,NROT-1
	  SUMAB  = 0.0
	  SUMASQ = 0.0
	  SUMBSQ = 0.0
	  DO J = ANN_LO,ANN_HI
	    DO I = 1,NROT
	      II     = NROT + 1 - I - IXOFF
	      IF(II.LE.0) II = II + NROT
	      A      = R4_PIMG(I,J+1)*J
	      B      = POLAR_PRJ(II,J+1)*J
	      SUMAB  = SUMAB  + A*B
	      SUMASQ = SUMASQ + A*A
	      SUMBSQ = SUMBSQ + B*B
	    ENDDO
	  ENDDO
	  CCPRJ = (SUMAB - (SUMA*SUMB)/TOT) /
	1         (SQRT(SUMASQ - (SUMA*SUMA)/TOT)*
	2         SQRT(SUMBSQ - (SUMB*SUMB)/TOT))
CCC	WRITE(*,'(A,I4,F10.3)') ' IX,CCPRJ =', IXOFF, CCPRJ
	  IF(CCPRJ.GT.CCPRJ_MAX2) THEN
	    CCPRJ_MAX2 = CCPRJ
	    XBEST2     = IXOFF
	  ENDIF
	ENDDO
	OMEGA2 = 360.0 - DEL_ANG*XBEST2
CCC	WRITE(*,'(A,F8.1,F10.3)') ' OMEGA2,CCPRJ =', OMEGA2, CCPRJ_MAX2
C
Ca      Calculate the difference between max2 and max1.  If it's 
Ca      significant at all then see if we have to flip it or not.
Ca      We put this in because there are subtle precision differences
Ca      between out SGI Indigo (IRIX 5.3) and our Alpha VAX (VMS 6.1).	
C
        difference = ABS(ccprj_max2 - ccprj_max1)
        if(difference .gt. 0.0001) then
	  IF(CCPRJ_MAX2.GT.CCPRJ_MAX1) THEN
	     FLIP       = .TRUE.
	     OME_BEST   = OMEGA2
	     CCPRJ_BEST = CCPRJ_MAX2
	  ELSE
	     FLIP       = .FALSE.
	     OME_BEST   = OMEGA1
	     CCPRJ_BEST = CCPRJ_MAX1
	  ENDIF
	ELSE
	   FLIP       = .FALSE.
	   OME_BEST   = OMEGA1
	   CCPRJ_BEST = CCPRJ_MAX1
	ENDIF
C
CCC	PRINT *,'CCPRJ_BEST,FLIP = ',CCPRJ_BEST,FLIP
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *              *****     SUBROUTINE GET_PRJS_G     *****                   *
C  *                                                                          *
C  *    CREATE GOLD STANDARD DATABASE OF 3D RECONSTRUCTION PROJECTIONS        *
C  *                                                                          *
C  *    July 2002 PURDUE UNIVERSITY Linux-Intel, T. BAKER.                    *
C  ****************************************************************************
C
	SUBROUTINE GET_PRJS_G (NVIEW_MOD, NCOLBIN, NROWBIN, NSECBIN, PROJN,
	1 PRJ, MAP3D, MOD_TS, MOD_PS, PRJ_AVG, ITMP, PRJS)
C
	IMPLICIT NONE
C

	INTEGER*4 NVIEW_MOD, NCOLBIN, NROWBIN, NSECBIN, ID, ITMP(NCOLBIN)
	REAL*4    MOD_TS(NVIEW_MOD), MOD_PS(NVIEW_MOD)
	REAL*4    MAP3D(NCOLBIN,NROWBIN,NSECBIN), PROJN(NCOLBIN,NROWBIN)
	REAL*4    PRJ(NCOLBIN,NROWBIN)
	REAL*4    PRJ_AVG(NCOLBIN,NROWBIN), PRJS(NCOLBIN,NROWBIN,NVIEW_MOD)
	real*4    temp1,temp2,temp3
	integer*4  sym
C  ----------------------------------------------------------------------------
C
	WRITE(*,1000)
	DO ID = 1,NVIEW_MOD
	  WRITE(*,1010) ID, MOD_TS(ID), MOD_PS(ID)
Ca  Misha and Rob - debugging code 
Ca	  temp1 =  mod_ts(id)
Ca	  temp2 =  mod_ps(id)
Ca	  temp3 = 0.0
Ca	  sym = 532
Ca	  CALL TO_ASYM_UNIT (SYM, mod_ts(id), mod_ps(id), temp3)
Ca	  if(temp1 .ne. mod_ts(id) .or. temp2 .ne. mod_ps(id) .or.
Ca	1    temp3 .ne. 0.0                      ) then
Ca	     print *, 'Changed orientations!!',temp1,temp2,0.0
Ca	     print *, mod_ts(id),mod_ps(id),temp3
Ca	  endif
C         **************************************************************
C---------*    NOTE USE OF OMEGA = 90.0 TO GET CORRECT ORIENTATIONS    *
C         **************************************************************
	  CALL MAP_PRJ (1, NCOLBIN, NROWBIN, NSECBIN, PROJN, PRJ, MAP3D,
	1  MOD_TS(ID), MOD_PS(ID), 90.0, 1.0, FLOAT(NSECBIN), 90., 90., 90.)
	  CALL SAVE_PRJS (PRJ, NCOLBIN, NROWBIN, ID, PRJ_AVG, NVIEW_MOD, 
	1  ITMP, PRJS)
	ENDDO
C
 1000	FORMAT('  View # Theta    Phi',/,21('-'),/)
 1010	FORMAT ('+',I5,F8.2,F7.2)
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE CALC_PFTS_G     *****               *
C  *                                                                          *
C  *    STEPS CARRIED OUT BY THIS ROUTINE (GLOBAL MODE ONLY):                 *
C  *     1. COPY 2D PROJECTION FROM PRJS_GOLD.                                *
C  *     2. IMPOSE CTF ON PROJECTION [COMPARE_MODE=1]                         *
C  *     3. CONVERT 2D CARTESIAN PROJECTION MAP INTO 2D POLAR MAP.            *
C  *     4. FOURIER TRANSFORM THE POLAR MAP.                                  *
C  *     5. SAVE POLAR FFT IN PFTS ARRAY.                                     *
C  *                                                                          *
C  *    JULY 2002 PURDUE UNIVERSITY Linux-Intel, T. BAKER/R. ASHMORE.         *
C  ****************************************************************************
C
	SUBROUTINE CALC_PFTS_G (FILE, NVIEW_MOD, NCOL, NROW, NSEC, NROT, 
	1 NANNULI, PROJN, PRJ, PRJ_AVG, ITMP, PMAP, XCEN_MODEL, 
	2 YCEN_MODEL, PFTRAD_LO, PFTRAD_HI, DEL_ANG, PFFT, A, PFTS, PRJS, 
	3 PRJS_GOLD, COMPARE_MODE, IDIM1, IDIM2, BIN, PI, RADIAN,
	4 img_fnames)
C
	IMPLICIT NONE
C
	COMMON/CTF_COM/PIXSIZ, UNITS, VOLTS, AMP_FAC, FOCUS_MAJ, 
	1 FOCUS_MIN, ANG_MAJ, CS_COEFF
C
	INTEGER*4 NVIEW_MOD, NCOL, NROW, NSEC, NROT, NANNULI, ID
	INTEGER*4 I, J, ITMP(NCOL), COMPARE_MODE, IDIM1, IDIM2
	INTEGER*4 FILE, BIN, UNITS(999)
	REAL*4    PIXSIZ(999), VOLTS(999), AMP_FAC(999), CS_COEFF(999)
	REAL*4    FOCUS_MAJ(999), FOCUS_MIN(999), ANG_MAJ(999)
	REAL*4    DEL_ANG, XCEN_MODEL, YCEN_MODEL, FFT(1)
	REAL*4    WAVELENGTH, WAVEL, TFAC, PI, RADIAN
	REAL*4    PFTRAD_LO, PFTRAD_HI, PFFT(NROT*2,NANNULI), A(NROT*2)
	REAL*4    PROJN(NCOL,NROW)
	REAL*4    PRJ(NCOL,NROW), PMAP(NROT,NANNULI)
	REAL*4    PRJ_AVG(NCOL,NROW), PRJS(NCOL,NROW,NVIEW_MOD)
	REAL*4    PRJS_GOLD(NCOL,NROW,NVIEW_MOD)
	REAL*4    PFTS((NROT/4),NANNULI,NVIEW_MOD)
	REAL*4    FFT_ORIGX, FFT_ORIGY, FFT_FZERO
	CHARACTER IMG_FNAMES(999)*256
	POINTER   (FFT_P,FFT)
	LOGICAL   FFT_FULL, MALLOC
C  ----------------------------------------------------------------------------
C
	FFT_P = MALLOC (8*IDIM1*IDIM2)
C
Ca	WRITE(*,'(A,I5)') ' Computing PFT database for micrograph', FILE
	WRITE(*,'(A,A)') ' Computing PFT database for micrograph - ', 
	1     img_fnames(FILE)
C
	DO ID = 1,NVIEW_MOD
	   DO J = 1,NROW
	      DO I = 1,NCOL
		 PRJ(I,J) = PRJS_GOLD(I,J,ID)
	      ENDDO
	   ENDDO
C         *******************************************************
C---------*    Impose CTF to projections if COMPARE_MODE = 1    *
C         *******************************************************
	  IF(COMPARE_MODE.EQ.1) THEN
	    FFT_ORIGX = NCOL/2
	    FFT_ORIGY = NROW/2
	    CALL MAP_FFT_FILL (PRJ, NCOL, NROW, 1, 1, FFT, IDIM1, 
	1    IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	    CALL FFT_2D (FFT, IDIM1, IDIM2)
	    WAVELENGTH = WAVEL (VOLTS(FILE))
	    TFAC       = 0.0				! HARDWIRE THIS FOR NOW
C           ****************************************************************
C-----------*  2-May-00 Hardwire input parameters to CTF_MULTIPLY such as  *
C           *  mode=1; Cc=0.0, BETA=0.0, dE=0.0; These will *not* impose   *
C           *  a decay factor on the data.                                 *
C           ****************************************************************
	    CALL CTF_MULTIPLY (1, FFT, IDIM1, IDIM2, UNITS(FILE), 
	1    BIN*PIXSIZ(FILE), PI, RADIAN, WAVELENGTH, FOCUS_MAJ(FILE), 
	2    FOCUS_MIN(FILE), ANG_MAJ(FILE), AMP_FAC(FILE), 
	3    CS_COEFF(FILE), 0.0, 0.0, 0.0, VOLTS(FILE), TFAC, FFT_FULL)
C
	    CALL FFT_2D_BACK (FFT, IDIM1, IDIM2)
	    CALL FFT_MAP_FILL (FFT, IDIM1, IDIM2, PRJ, NCOL, NROW, 1, 1,
	1    FFT_FULL)
	  ENDIF
	  CALL SAVE_PRJS (PRJ, NCOL, NROW, ID, PRJ_AVG, NVIEW_MOD, ITMP,
	1  PRJS)
	  CALL MAP_POLAR (PRJ, NCOL, NROW, PMAP, NROT, NANNULI,
	1  XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, PFTRAD_HI, DEL_ANG)
	  CALL PMAP_FFT (PMAP, PFFT, A, NROT, NANNULI)
C         ************************************************
C---------*    Store current 2D PFFT in 3D PFTS array    *
C         ************************************************
	  DO J = 1,NANNULI
	    DO I = 1,(NROT/4)
	      PFTS(I,J,ID) = SQRT (PFFT(2*I-1,J)**2 + PFFT(2*I,J)**2)
	    ENDDO
	  ENDDO
	ENDDO                  ! MAIN LOOP THROUGH NVIEW_MOD MODEL PROJECTIONS
C
	CALL FREE (FFT_P)
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *              *****     SUBROUTINE GET_PRJSPFTS_R     *****               *
C  *                                                                          *
C  *    STEPS CARRIED OUT BY THIS ROUTINE (REFINE MODE ONLY):                 *
C  *     1. PROJECT 3D MAP ALONG NVIEW_MOD THETA,PHI,OMEGA(=90) ORIENTATIONS. *
C  *     2. 2D PROJECTION SAVED IN PRJ ARRAY.                                 *
C  *     3. IMPOSE CTF ON PROJECTION [OPTIONAL]                               *
C  *     4. CONVERT 2D CARTESIAN PROJECTION MAP INTO 2D POLAR MAP.            *
C  *     5. FOURIER TRANSFORM THE POLAR MAP.                                  *
C  *     6. SAVE POLAR FFT IN PFTS ARRAY.                                     *
C  *                                                                          *
C  *    APRIL 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.          *
C  *                                                                          *
C  *    MODIFIED  5-MAY-1998 BY T. BAKER (Implement sliding window).          *
C  *    MODIFIED 23-JUL-1999 BY TSB (Implement SBW's CTF code).               *
C  *    LAST MODIFIED 25-AUG-1999 BY TSB (Implement TSB's CTF code).          *
C  ****************************************************************************
C
	SUBROUTINE GET_PRJSPFTS_R (NTHE, NPHI, N_INCORE, NCOLBIN, NROWBIN, 
	1 NSECBIN, NROT, NANNULI, PROJN, PRJ, PRJS, MAP3D, MOD_TS, 
	2 MOD_PS, ITMP, PMAP, XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, 
	3 PFTRAD_HI, DEL_ANG, PFFT, A, PFTS, MASK, ITHE1, ITHE2, OFFSET,
	4 COMPARE_MODE, IDIM1, IDIM2, FFT6, BIN,PI, RADIAN)
C
	IMPLICIT NONE
C
	COMMON/CTF_COM/PIXSIZ, UNITS, VOLTS, AMP_FAC, FOCUS_MAJ, 
	1 FOCUS_MIN, ANG_MAJ, CS_COEFF
C
	INTEGER*4 NVIEW_MOD, NCOLBIN, NROWBIN, NSECBIN, NROT, NANNULI, ID
	INTEGER*4 I, J, ITMP(NCOLBIN), N_INCORE, NTHE, NPHI, ITH, IPH
	INTEGER*4 MASK(NPHI,NTHE,2), ITHE1, ITHE2, ID_LAST, OFFSET
	INTEGER*4 ID_PRINT, COMPARE_MODE, IDIM1, IDIM2, FILE, BIN
	INTEGER*4 UNITS(999)
	REAL*4    PIXSIZ(999), VOLTS(999), AMP_FAC(999), CS_COEFF(999)
	REAL*4    FOCUS_MAJ(999), FOCUS_MIN(999), ANG_MAJ(999)
	REAL*4    DEL_ANG, XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, PFTRAD_HI
	REAL*4    WAVELENGTH, WAVEL, TFAC, PI, RADIAN
	REAL*4    MOD_TS(NTHE), MOD_PS(NPHI,NTHE)
	REAL*4    PFFT(NROT*2,NANNULI), A(NROT*2), PROJN(NCOLBIN,NROWBIN)
	REAL*4    MAP3D(NCOLBIN,NROWBIN,NSECBIN), PRJ(NCOLBIN,NROWBIN)
	REAL*4    PRJS(NCOLBIN,NROWBIN,N_INCORE), PMAP(NROT,NANNULI)
	REAL*4    PFTS((NROT/4),NANNULI,N_INCORE)
	REAL*4    FFT_ORIGX, FFT_ORIGY, FFT_FZERO, FFT6(2*IDIM1,IDIM2)
	DATA	  ID_LAST/0/
	SAVE      ID_LAST
	LOGICAL   FFT_FULL
C  ----------------------------------------------------------------------------
C
	WRITE(*,1000)
	DO 100 ITH = ITHE1,ITHE2
	  DO 200 IPH = 1,NPHI
	    ID = MASK(IPH,ITH,2)
	    IF(MASK(IPH,ITH,1).LE.0 .OR. ID.LE.OFFSET) GO TO 200
	    ID_PRINT = ID + ID_LAST - OFFSET
	    WRITE(*,1010) ID_PRINT, MOD_TS(ITH), MOD_PS(IPH,ITH)
C           **************************************************************
C-----------*    NOTE USE OF OMEGA = 90.0 TO GET CORRECT ORIENTATIONS    *
C           **************************************************************
	    CALL MAP_PRJ (1, NCOLBIN, NROWBIN, NSECBIN, PROJN, PRJ, 
	1    MAP3D, MOD_TS(ITH), ABS(MOD_PS(IPH,ITH)), 90.0, 1.0, 
	2    FLOAT(NSECBIN), 90., 90., 90.)
C           **************************************************
C-----------*    Impose CTF to projections if COMPARE_MODE = 1    *
C           *    Code implemented by SBW                     *
C           **************************************************
	    IF(COMPARE_MODE.EQ.1) THEN
	      FFT_ORIGX = NCOLBIN/2
	      FFT_ORIGY = NROWBIN/2
	      FILE = 1
	      CALL MAP_FFT_FILL (PRJ, NCOLBIN, NROWBIN, 1, 1, FFT6, 
	1      IDIM1, IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	      CALL FFT_2D (FFT6, IDIM1, IDIM2)

	      WAVELENGTH = WAVEL (VOLTS(FILE))
	      TFAC    = 0.0				! HARDWIRE THIS FOR NOW
C             ****************************************************************
C-------------*  2-May-00 Hardwire input parameters to CTF_MULTIPLY such as  *
C             *  mode=1; Cc=0.0, BETA=0.0, dE=0.0; These will *not* impose   *
C             *  a decay factor on the data.                                 *
C             ****************************************************************
	      CALL CTF_MULTIPLY (1, FFT6, IDIM1, IDIM2, UNITS(FILE), 
	1      BIN*PIXSIZ(FILE), PI, RADIAN, WAVELENGTH, FOCUS_MAJ(FILE), 
	2      FOCUS_MIN(FILE), ANG_MAJ(FILE), AMP_FAC(FILE), 
	2      CS_COEFF(FILE), 0.0, 0.0, 0.0, VOLTS(FILE), TFAC, FFT_FULL)
	      CALL FFT_2D_BACK (FFT6, IDIM1, IDIM2)
	      CALL FFT_MAP_FILL (FFT6, IDIM1, IDIM2, PRJ, NCOLBIN,
	1      NROWBIN, 1, 1, FFT_FULL)
	    ENDIF 
	    DO J = 1,NROWBIN		! Store current 2D PRJ in 3D PRJS array
	      DO I = 1,NCOLBIN
	        PRJS(I,J,ID) = PRJ(I,J)
	      ENDDO
	    ENDDO
	    CALL MAP_POLAR (PRJ, NCOLBIN, NROWBIN, PMAP, NROT, NANNULI,
	1    XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, PFTRAD_HI, DEL_ANG)
	    CALL PMAP_FFT (PMAP, PFFT, A, NROT, NANNULI)
	    DO J = 1,NANNULI	       ! Store current 2D PFFT in 3D PFTS array
	      DO I = 1,(NROT/4)
	        PFTS(I,J,ID) = SQRT (PFFT(2*I-1,J)**2 + PFFT(2*I,J)**2)
	      ENDDO
	    ENDDO
  200	  ENDDO							! LOOP OVER PHI
  100	ENDDO							! LOOP OVER THE
C
	ID_LAST = ID_PRINT
	RETURN
 1000	FORMAT('  View # Theta    Phi',/,21('-'),/)
 1010	FORMAT ('+',I5,F8.2,F7.2)
	END

C  *****************************************************************************
C  *                                                                           *
C  *                 *****     SUBROUTINE GET_THEPHI     *****                 *
C  *                                                                           *
C  *    DETERMINES THE BEST THETA,PHI ORIENTATION.                             *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *    MODIFIED 18-AUG-1993 BY T. BAKER.                                      *
C  *	MODIFIED xx_APR-1996 BY DMB (Fixed bug in extended output).            *
C  *	LAST MODIFIED 23-APR-1998 BY T. BAKER (Renamed from PFTCC_GETTP).      *
C  *****************************************************************************
C
	SUBROUTINE GET_THEPHI (PFTIMG, PFTS, PFT_AVGS, NROT, NANNULI, 
	1 NVIEW_MOD, SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, CCPFT, ANN_LO, 
	2 ANN_HI, VAR, VAROPT, CCOR, ICOR, PI, DEL_PIXRES, AVG, SQ1, 
	3 ILIST, INDEX)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 INDEX, NROT, NANNULI, NVIEW_MOD, I, J, ID, J2, ILIST, JN
	INTEGER*4 JCUT, VAR((NROT/4),NANNULI), ANN_LO, ANN_HI, NRAD
	INTEGER*4 ICOR(NVIEW_MOD), IR, R, NLIM, NRES
	PARAMETER (NLIM=200)
	REAL*4    PFTIMG((NROT/4),NANNULI)
	REAL*4    TOT, AMIN, AMAX, PFTS((NROT/4),NANNULI,NVIEW_MOD)
	REAL*4    CCOR(NVIEW_MOD), PFT_AVGS(NVIEW_MOD), NPTS, PTS(NLIM)
	REAL*4    AVG, SQ1, SQ2(NVIEW_MOD), CCPFT, DIV1, DIV2, PI
	REAL*4    DUM1, DUM2
	REAL*4    CCRES(50), CCRAD(NLIM), DEL_PIXRES, TWOPIR, TOTS(NLIM)
	REAL*4    AVG3(NLIM), AVG4(NLIM), SQ3(NLIM), SQ4(NLIM)
	REAL*4    PIXRES, PIXRES_MIN, PIXRES_MAX
	LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
C  *********************************
C  *    INITIALIZE "CCOR" ARRAY    *
C  *********************************
	DO ID = 1,NVIEW_MOD
	  CCOR(ID) = R4_MIN
	ENDDO
C
	J2 = (NROT/4) - 1
C
	DO ID = 1,NVIEW_MOD
	  NPTS = 0.0
	  TOT  = 0.0
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR + 1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 300
	      J = JN + 1
              IF((VAROPT .AND.(VAR(J,R).ne.0)) .OR. .NOT.VAROPT) THEN
                NPTS = NPTS + 1.0
	        TOT  = TOT + PFTIMG(J,R)*PFTS(J,R,ID)
              ENDIF
  300	    ENDDO
	  ENDDO
	  DIV1     = SQRT (SQ1 - NPTS*(AVG**2))
	  DIV2     = SQRT (SQ2(ID)-NPTS*(PFT_AVGS(ID)**2))
	  CCOR(ID) = (TOT-AVG*PFT_AVGS(ID)*NPTS)/(DIV1*DIV2)
	ENDDO
C
	AMAX = R4_MIN
	AMIN = R4_MAX
C
	DO ID = 1,NVIEW_MOD
	  IF(CCOR(ID).GT.AMAX) THEN
	    AMAX  = CCOR(ID)
	    INDEX = ID
	  ENDIF
	  IF(CCOR(ID).LT.AMIN .AND. CCOR(ID).NE.R4_MIN) AMIN = CCOR(ID)
	ENDDO
C
	CCPFT    = AMAX
C  ****************************************************************
C  *    If ILIST > 0, then compute and print extra information    *
C  ****************************************************************
	IF(ILIST.LT.1) RETURN
ccc
ccc	I commented out the ILIST = 1 code, 30 Dec 1996.  D. Belnap
ccc
C	*********************************************************************
C	*    COMPUTE CORRELATION COEFFICIENTS AS A FUNCTION OF PIXEL RES    *
C	*********************************************************************
c	DO I = 1,NLIM
c	  PTS(I)  = 0.0
c	  TOTS(I) = 0.0
c	  SQ3(I)  = 0.0
c	  SQ4(I)  = 0.0
c	  AVG3(I) = 0.0
c	  AVG4(I) = 0.0
c	ENDDO
C
c	NRES = 0
c	DO ID = 1,NVIEW_MOD
c	  IF(THETA(ID).EQ.THE_BEST .AND. PHI(ID).EQ.PHI_BEST) THEN
c	    DO IR = ANN_LO,ANN_HI
c	      R      = min(NANNULI, IR + 1)
c	      TWOPIR = 2.0*PI*FLOAT(IR)
c	      DO JN = JCUT,J2
c	        IF(JN.GT.0) THEN			! TRAP FOR Jo
c	           PIXRES = TWOPIR/FLOAT(JN)
c	         ELSE
c	           PIXRES = 1000.0
c	        ENDIF
c	        IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 400
c	        I = INT(1.0/(PIXRES*DEL_PIXRES)) + 1
c	        IF(I.GT.50) GO TO 400
c	        IF(I.GT.NRES) NRES = I
c	        J = JN + 1
c               IF((VAROPT .AND.VAR(J,R)) .OR. .NOT.VAROPT) THEN
c                PTS(I)  = PTS(I) + 1.0
c	          AVG3(I) = AVG3(I) + PFTIMG(J,R)
c	          AVG4(I) = AVG4(I) + PFTS(J,R,ID)
c	          TOTS(I) = TOTS(I) + PFTIMG(J,R)*PFTS(J,R,ID)
c	          SQ3(I)  = SQ3(I) + PFTIMG(J,R)**2
c	          SQ4(I)  = SQ4(I) + PFTS(J,R,ID)**2
c               ENDIF
c  400	      ENDDO
c	    ENDDO
c	    DO I = 1,NRES
c	      IF(PTS(I).LE.0.0) THEN
c	        AVG3(I) = 0.0
c	        AVG4(I) = 0.0
c	       ELSE
c	         AVG3(I) = AVG3(I)/PTS(I)
c	         AVG4(I) = AVG4(I)/PTS(I)
c	      ENDIF
c	      DUM1 = SQ3(I) - PTS(I)*(AVG3(I)**2)
c	      DUM2 = SQ4(I) - PTS(I)*(AVG4(I)**2)
c	      IF(DUM1.LE.0.0 .OR. DUM2.LE.0.0) THEN
c	         CCRES(I) = 0.0
c	       ELSE
c	         DIV1 = SQRT (DUM1)
c	         DIV2 = SQRT (DUM2)
c	         CCRES(I) = (TOTS(I)-AVG3(I)*AVG4(I)*PTS(I)) /
c	1                              (DIV1*DIV2)
c	      ENDIF
c	      WRITE(6,'(F6.3,F8.3,F10.0,F10.1)') I*DEL_PIXRES,
c	1      CCRES(I), PTS(I), AVG3(I)
c	    ENDDO
c	    GO TO 500
c	  ENDIF
c	ENDDO
C
C	******************************************************************
C	*    COMPUTE CORRELATION COEFFICIENTS AS A FUNCTION OF RADIUS    *
C	******************************************************************
c  500	DO I = 1,NLIM
c	  PTS(I)   = 0.0
c	  TOTS(I)  = 0.0
c	  SQ3(I)   = 0.0
c	  SQ4(I)   = 0.0
c	  AVG3(I)  = 0.0
c	  AVG4(I)  = 0.0
c	  CCRAD(I) = 0.0
c	ENDDO
C
c	NRAD     = 0
c	DO ID = 1,NVIEW_MOD
c	  IF(THETA(ID).EQ.THE_BEST .AND. PHI(ID).EQ.PHI_BEST) THEN
c	    DO IR = ANN_LO,ANN_HI
c	      R      = min(NANNULI, IR + 1)
c	      TWOPIR = 2.0*PI*FLOAT(IR)
c	      DO JN = JCUT,J2
c	        IF(JN.GT.0) THEN			! TRAP FOR Jo
c	           PIXRES = TWOPIR/FLOAT(JN)
c	         ELSE
c	           PIXRES = 1000.0
c	        ENDIF
c	        IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 600
c	        I = R
c	        IF(I.GT.NLIM) GO TO 600
c	        IF(I.GT.NRAD) NRAD = I
c	        J = JN + 1
c               IF((VAROPT .AND.VAR(J,R)) .OR. .NOT.VAROPT) THEN
c                PTS(I)  = PTS(I) + 1.0
c	          AVG3(I) = AVG3(I) + PFTIMG(J,R)
c	          AVG4(I) = AVG4(I) + PFTS(J,R,ID)
c	          TOTS(I) = TOTS(I) + PFTIMG(J,R)*PFTS(J,R,ID)
c	          SQ3(I)  = SQ3(I) + PFTIMG(J,R)**2
c	          SQ4(I)  = SQ4(I) + PFTS(J,R,ID)**2
c               ENDIF
c  600	      ENDDO
c	    ENDDO
c	    DO I = 1,NRAD
c	      IF(PTS(I).LE.0.0) THEN
c	        AVG3(I) = 0.0
c	        AVG4(I) = 0.0
c	       ELSE
c	         AVG3(I) = AVG3(I)/PTS(I)
c	         AVG4(I) = AVG4(I)/PTS(I)
c	      ENDIF
c	      DUM1 = SQ3(I) - PTS(I)*(AVG3(I)**2)
c	      DUM2 = SQ4(I) - PTS(I)*(AVG4(I)**2)
c	      IF(DUM1.LE.0.0 .OR. DUM2.LE.0.0) THEN
c	         CCRAD(I) = 0.0
c	       ELSE
c	         DIV1 = SQRT (DUM1)
c	         DIV2 = SQRT (DUM2)
c	         CCRAD(I) = (TOTS(I)-AVG3(I)*AVG4(I)*PTS(I)) /
c	1                   (DIV1*DIV2)
c	      ENDIF
c	      WRITE(6,'(I5,F8.3,F10.0,F10.1)') (I-1), CCRAD(I),
c	1           PTS(I), AVG3(I)
c	    ENDDO
c	    WRITE(6,'(A,F8.3)') ' Overall CC =', CCPFT
c	    GO TO 900
c	  ENDIF
c	ENDDO
C
C	*****************************************************************
C	*  If ILIST = 2, print out CCs for each of the NVIEW_MOD views  *
C	*****************************************************************
  900	IF(ILIST.NE.2)  RETURN
C
	PRINT *,'ABS(Sum of differences (with JCUT and ANN_LO ))'
	PRINT *
	PRINT *,'Num           THETA(Num)     PHI(Num)         ICOR(Num)'
	PRINT *,'-------------------------------------------------------'
	DO ID = 1,NVIEW_MOD
	  IF(CCOR(ID).NE.R4_MIN) THEN
	     ICOR(ID) = NINT( (CCOR(ID)-AMIN)*100.0/(AMAX-AMIN) )
	   ELSE
	     ICOR(ID) = 0
	  ENDIF
CCC	WRITE(6,1000) ID, THETA(ID), PHI(ID), ICOR(ID)
	ENDDO
	PRINT *
	PRINT *
C
 1000	FORMAT (I9, '     ',F10.3,'    ',F10.3,'       ',I9)
	END

C  *****************************************************************************
C  *                                                                           *
C  *                 *****     SUBROUTINE GET_THEPHI_R     *****               *
C  *                                                                           *
C  *    DETERMINES THE BEST THETA,PHI ORIENTATION (REFINE MODE).               *
C  *                                                                           *
C  *    APRIL 1998 PURDUE UNIVERSITY VAX 8550, T. BAKER.                       *
C  *                                                                           *
C  *	LAST MODIFIED 29-APR-1998 BY T. BAKER (Adapted from PFTCC_GETTP).      *
C  *****************************************************************************
C
	SUBROUTINE GET_THEPHI_R (PFTIMG, PFTS, PFT_AVGS, NROT, NANNULI, 
	1 NUNIQUE, SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, CCPFT, ANN_LO, 
	2 ANN_HI, VAR, VAROPT, CCOR, PI, DEL_PIXRES, AVG, SQ1, INDEX, 
	3 MASK, NTHE, NPHI, ITH, IPH, NVIEWS)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/VAX_MINMAX.INC'
C
	INTEGER*4 INDEX, NROT, NANNULI, NUNIQUE, I, J, ID, JN, IR, R
	INTEGER*4 JCUT, VAR((NROT/4),NANNULI), ANN_LO, ANN_HI, NRAD
	INTEGER*4 NTHE, NPHI, MASK(NPHI,NTHE,2), ITHE, IPHI, ITH, IPH
	INTEGER*4 NVIEWS, NUM, ITHE1, ITHE2, IPHI1, IPHI2
	REAL*4    PFTIMG((NROT/4),NANNULI), PIXRES, PIXRES_MIN, PIXRES_MAX
	REAL*4    PFTS((NROT/4),NANNULI,NUNIQUE), PFT_AVGS(NVIEWS)
	REAL*4    CCOR(NVIEWS), TOT, AMAX, NPTS, CCPFT, DIV1, DIV2, PI
	REAL*4    DEL_PIXRES, TWOPIR, AVG, SQ1, SQ2(NVIEWS)
	LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
	AMAX = R4_MIN
C  *********************************
C  *    INITIALIZE "CCOR" ARRAY    *
C  *********************************
	DO I = 1,NVIEWS
	  CCOR(I) = R4_MIN
	ENDDO
C
	NUM   = 0
	ITHE1 = ITH - 3
	ITHE2 = ITH + 3
	IPHI1 = IPH - 3
	IPHI2 = IPH + 3
	IF(ITHE1.LT.1)    ITHE1 =    1
	IF(ITHE2.GT.NTHE) ITHE2 = NTHE
	IF(IPHI1.LT.1)    IPHI1 =    1
	IF(IPHI2.GT.NPHI) IPHI2 = NPHI
C
	DO ITHE = ITHE1,ITHE2
	  DO IPHI = IPHI1,IPHI2
	    MASK(IPHI,ITHE,1) = MASK(IPHI,ITHE,1) - 1		! UPDATE MASK
	    NUM  = NUM  + 1
	    ID   = MASK(IPHI,ITHE,2)
	    NPTS = 0.0
	    TOT  = 0.0
	    DO IR = ANN_LO,ANN_HI
	      R      = MIN(NANNULI, IR + 1)
	      TWOPIR = 2.0*PI*FLOAT(IR)
	       DO JN = JCUT,((NROT/4) - 1)
	        IF(JN.GT.0) THEN				! TRAP FOR Jo
	           PIXRES = TWOPIR/FLOAT(JN)
	         ELSE
	           PIXRES = 1000.0
	        ENDIF
	        IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) 
	1        GO TO 300
	        J = JN + 1
                IF( (VAROPT.AND.(VAR(J,R).ne.0)) .OR. .NOT.VAROPT) THEN
                  NPTS = NPTS + 1.0
	          TOT  = TOT + PFTIMG(J,R)*PFTS(J,R,ID)
                ENDIF
  300	      ENDDO
	    ENDDO
	    DIV1      = SQRT (SQ1 - NPTS*(AVG**2))
	    DIV2      = SQRT (SQ2(NUM)-NPTS*(PFT_AVGS(NUM)**2))
	    CCOR(NUM) = (TOT-AVG*PFT_AVGS(NUM)*NPTS)/(DIV1*DIV2)
	    IF(CCOR(NUM).GT.AMAX) THEN
	      AMAX  = CCOR(NUM)
	      INDEX = ID
	      ITH   = ITHE
	      IPH   = IPHI
	    ENDIF
	  ENDDO					! DO IPHI = IPHI1,IPHI2
	ENDDO					! DO ITHE = ITHE1,ITHE2
C
	CCPFT = AMAX
C
	RETURN
	END

C  ***********************************************************************
C  *                                                                     *
C  *              *****     SUBROUTINE GET_T1T2P1     *****              *
C  *                                                                     *
C  *  Determines THE1, THE2, and PHI1 for ASU based on SYM chosen        *
C  *                                                                     *
C  *  PURDUE UNIVERSITY DEC 3000, Jan 1994, T. Baker and D. Belnap       *
C  *  Added SYM = 2-20, 30 Jan 1997, D. Belnap                           *
C  *  For SYM=1-20, THE2=90 & PHI1=-360/(2*SYM), 13 May 1998, D. Belnap  *
C  ***********************************************************************
C
	SUBROUTINE GET_T1T2P1 (SYM, THE1, THE2, PHI1)
C
	IMPLICIT NONE
C
	INTEGER*4 SYM
	REAL*4    THE1, THE2, PHI1
C  ----------------------------------------------------------------------------
C
C	*******************************************************************
C	*  Initial values.  These are all correct for N2 & N22 symmetry.  *
C	*******************************************************************
	THE1 =  0.0
	THE2 = 90.0
	PHI1 =  0.0
C	*******************************************************
C	*  Exceptions to the above values:                    *
C	*  SYM = 1    for asymmetric particle,                *
C	*      = 2-31 for particle with nfold about z-axis,   *
C	*      = 532  for icosahedral particle.               *
C	*******************************************************
	IF (SYM.GE.1 .AND. SYM.LE.31) THEN
	   PHI1 = -360.0/(2*FLOAT(SYM))
	 ELSE IF (SYM.EQ.532) THEN
	   THE1 = 69.09484255211070
	ENDIF
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                  *****     SUBROUTINE GET_TPO_G     *****                *
C  *                                                                          *
C  *    DETERMINE THETA, PHI, AND OMEGA FOR CURRENT IMAGE.                    *
C  *                                                                          *
C  *    Protocol:                                                             *
C  *     1. Compute polar image from raw (Cartesian) image (R4_IMG->R4_PIMG). *
C  *     2. Compute polar FFT (PFFT) from R4_PIMG.                            *
C  *     3. Convert image PFT to amplitudes & extract desired portion.        *
C  *     4. Find average value of image PFT (also termed particle PFT).       *
C  *     5. Cross-correlate particle PFT with all reference PFTS to get THETA *
C  *         and PHI (|PHI| for n22 and 532 symmetry, both THETA and PHI may  *
C  *         change if the object is asymmetric or n-fold.                    *
C  *     6. Read in the appropriate projection (PRJ) corresponding to THETA   *
C  *         and |PHI|.                                                       *
C  *     7. Convert PRJ to polar projection (POLAR_PRJ).                      *
C  *     8. Cross-correlate POLAR_PRJ with R4_PIMG to determine sign of       *
C  *         PHI and value of OMEGA (also THETA if SYM=1-20).                 *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *                                                                          *
C  *    MODIFIED  6-FEB-1998 BY T. BAKER (Extracted subs from PFTCC).         *
C  *    LAST MODIFIED 28-APR-1998 BY T. BAKER (GLOBAL specific).              *
C  ****************************************************************************
C
	SUBROUTINE GET_TPO_G (MODE, NCOL, NROW, NROT, NANNULI, NVIEW_MOD, 
	1  JCUT, ILIST, XCEN, YCEN, XCEN_MODEL, YCEN_MODEL, RADIUS, DEL_ANG, 
	2  PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, 
	3  SQ1, SQ2, MOD_TS, MOD_PS, THE_BEST, PHI_BEST, OME_BEST, 
	4  DEL_PIXRES, PFTS, PFT_AVGS, PRJS, CC_PFT, CC_PRJ, 
	5  R4_IMG, R4_PIMG, PFFT, PRJ, POLAR_PRJ, PFTIMG, ICOR, CCOR, 
	6  A_ARRAY, FLIP, INDEX, PRJHEAD)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ PRJHEAD
C
	INTEGER*4 NCOL, NROW, NROT, NANNULI, JCUT, ILIST, MODE
	INTEGER*4 ANN_LO, ANN_HI, NVIEW_MOD, VAR(NROT,NANNULI), INDEX
	INTEGER*4 ICOR(NVIEW_MOD), I, J
	REAL*4    XCEN, YCEN, XCEN_MODEL, YCEN_MODEL, DEL_PIXRES
	REAL*4    RADIUS, DEL_ANG, PIXRES_MIN, PIXRES_MAX, CC_PFT, CC_PRJ
	REAL*4    PI, AVG, SQ1, THE_BEST, PHI_BEST, OME_BEST
	REAL*4    MOD_TS(NVIEW_MOD), MOD_PS(NVIEW_MOD), SQ2(NVIEW_MOD)
	REAL*4    R4_IMG(NCOL,NROW), PRJ(NCOL,NROW), R4_PIMG(NROT,NANNULI)
	REAL*4    PRJS(NCOL,NROW,NVIEW_MOD), POLAR_PRJ(NROT,NANNULI)
	REAL*4    PFFT(2*NROT,NANNULI), PFTS(NROT,NANNULI,NVIEW_MOD)
	REAL*4    CCOR(NVIEW_MOD), PFT_AVGS(NVIEW_MOD)
	REAL*4    A_ARRAY(NROT*2), PFTIMG((NROT/4),NANNULI)
	LOGICAL   FLIP, VAROPT
C -----------------------------------------------------------------------------
C
	CALL MAP_POLAR (R4_IMG, NCOL, NROW, R4_PIMG, NROT, NANNULI, XCEN, 
	1 YCEN, 1.0, RADIUS, DEL_ANG)
C
	CALL PMAP_FFT (R4_PIMG, PFFT, A_ARRAY, NROT, NANNULI)
C 
	DO I = 1, NANNULI	       ! CONVERT PFFT A & B PARTS TO AMPLITUDES
          DO J = 1,(NROT/4)
	    PFTIMG(J,I) = SQRT (PFFT(2*J-1,I)**2 + PFFT(2*J,I)**2)
	  ENDDO
	ENDDO
C
	CALL AVG_PFTIMG (PFTIMG, NROT, NANNULI, JCUT, PIXRES_MIN, 
	1 PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, SQ1)
C
	CALL GET_THEPHI (PFTIMG,PFTS,PFT_AVGS,NROT,NANNULI,NVIEW_MOD, 
	1 SQ2,JCUT,PIXRES_MIN,PIXRES_MAX,CC_PFT,ANN_LO,ANN_HI, 
	2 VAR,VAROPT,CCOR,ICOR,PI,DEL_PIXRES,AVG,SQ1,ILIST,INDEX)
C
	THE_BEST = MOD_TS(INDEX)
	PHI_BEST = MOD_PS(INDEX)
	CALL GET_BESTPRJ (PRJ, NCOL, NROW, NVIEW_MOD, PRJS, MODE, 
	1 INDEX, PRJHEAD)
C
	CALL MAP_POLAR (PRJ, NCOL, NROW, POLAR_PRJ, NROT, NANNULI, 
	1 XCEN_MODEL, YCEN_MODEL, 1.0, RADIUS, DEL_ANG)
C
	CALL GET_PHIOMEGA (R4_PIMG, POLAR_PRJ, NROT, NANNULI, DEL_ANG, 
	1 OME_BEST, ANN_LO, ANN_HI, FLIP, CC_PRJ, MODE)
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                  *****     SUBROUTINE GET_TPO_R     *****                *
C  *                                                                          *
C  *    DETERMINE THETA, PHI, AND OMEGA FOR CURRENT IMAGE.                    *
C  *                                                                          *
C  *    Protocol:                                                             *
C  *     1. Compute polar image from raw (Cartesian) image (R4_IMG->R4_PIMG). *
C  *     2. Compute polar FFT (PFFT) from R4_PIMG.                            *
C  *     3. Convert image PFT to amplitudes & extract desired portion.        *
C  *     4. Find average value of image PFT (also termed particle PFT).       *
C  *     5. Cross-correlate particle PFT with all reference PFTS to get THETA *
C  *         and PHI (|PHI| for n22 and 532 symmetry, both THETA and PHI may  *
C  *         change if the object is asymmetric or n-fold.                    *
C  *     6. Load the best model projection (BESTPRJ) corresponding to THETA   *
C  *         and |PHI|.                                                       *
C  *     7. Convert BESTPRJ to polar projection (POLAR_PRJ).                       *
C  *     8. Cross-correlate POLAR_PRJ with R4_PIMG to determine sign of            *
C  *         PHI and value of OMEGA (also THETA if SYM=1-20).                 *
C  *                                                                          *
C  *    APRIL 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.          *
C  *                                                                          *
C  *    LAST MODIFIED 29-APR-1998 BY T. BAKER (REFINE specific).              *
C  ****************************************************************************
C
	SUBROUTINE GET_TPO_R (NCOLBIN, NROWBIN, NROT, NANNULI, NUNIQUE, 
	1 NVIEWS, NTHE, NPHI, MASK, MOD_TS, MOD_PS, ITH, IPH, PFT_AVGS, 
	2 R4_IMG, R4_PIMG, PRJS, BESTPRJ, POLAR_PRJ, PFTS, PFFT, PFTIMG, 
	3 JCUT, XCEN, YCEN, XCEN_MOD, YCEN_MOD, RADIUS, DEL_ANG, 
	4 PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, 
	5 SQ1, SQ2, THE_BEST, PHI_BEST, OME_BEST, DEL_PIXRES, CC_PFT, 
	6 CC_PRJ, CCOR, A_ARRAY, FLIP, INDEX)
C
	IMPLICIT NONE
C
	INTEGER*4 I, J, NCOLBIN, NROWBIN, NROT, NANNULI, JCUT
	INTEGER*4 ANN_LO, ANN_HI, NUNIQUE, VAR(NROT,NANNULI), INDEX
	INTEGER*4 NTHE, NPHI, NVIEWS, MASK(NPHI,NTHE,2), ITH, IPH
	REAL*4    XCEN, YCEN, XCEN_MOD, YCEN_MOD, DEL_PIXRES
	REAL*4    RADIUS, DEL_ANG, PIXRES_MIN, PIXRES_MAX, CC_PFT, CC_PRJ
	REAL*4    PI, AVG, SQ1, THE_BEST, PHI_BEST, OME_BEST
	REAL*4    MOD_TS(NTHE), MOD_PS(NPHI,NTHE), SQ2(NVIEWS)
	REAL*4    R4_IMG(NCOLBIN,NROWBIN), BESTPRJ(NCOLBIN,NROWBIN)
	REAL*4    R4_PIMG(NROT,NANNULI), PFT_AVGS(NVIEWS), CCOR(NUNIQUE)
	REAL*4    PRJS(NCOLBIN,NROWBIN,NUNIQUE), POLAR_PRJ(NROT,NANNULI)
	REAL*4    PFFT(2*NROT,NANNULI), PFTS(NROT,NANNULI,NUNIQUE)
	REAL*4    A_ARRAY(NROT*2), PFTIMG((NROT/4),NANNULI)
	LOGICAL   FLIP, VAROPT
C -----------------------------------------------------------------------------
C
	CALL MAP_POLAR (R4_IMG, NCOLBIN, NROWBIN, R4_PIMG, NROT, 
	1 NANNULI, XCEN, YCEN, 1.0, RADIUS, DEL_ANG)

CTSB	Does A_ARRAY need to be initialized here for safety                 ???
	CALL PMAP_FFT (R4_PIMG, PFFT, A_ARRAY, NROT, NANNULI)
C
        DO I = 1, NANNULI	       ! CONVERT PFFT A & B PARTS TO AMPLITUDES
          DO J = 1,(NROT/4)
	    PFTIMG(J,I) = SQRT (PFFT(2*J-1,I)**2 + PFFT(2*J,I)**2)
	  ENDDO
	ENDDO
C
	CALL AVG_PFTIMG (PFTIMG, NROT, NANNULI, JCUT, PIXRES_MIN, 
	1 PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, AVG, SQ1)
C
	CALL GET_THEPHI_R (PFTIMG, PFTS, PFT_AVGS, NROT, NANNULI, NUNIQUE, 
	1 SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, CC_PFT, ANN_LO, ANN_HI, VAR, 
	2 VAROPT, CCOR, PI, DEL_PIXRES, AVG, SQ1, INDEX, MASK, NTHE, NPHI, 
	3 ITH, IPH, NVIEWS)
C
	THE_BEST = MOD_TS(ITH)
	PHI_BEST = MOD_PS(IPH,ITH)
C
	DO J = 1,NROWBIN		        ! LOAD IN BEST MODEL PROJECTION
	  DO I = 1,NCOLBIN
	    BESTPRJ(I,J) = PRJS(I,J,INDEX)
	  ENDDO
	ENDDO
C
	CALL MAP_POLAR (BESTPRJ, NCOLBIN, NROWBIN, POLAR_PRJ, NROT, 
	1 NANNULI, XCEN_MOD, YCEN_MOD, 1.0, RADIUS, DEL_ANG)
C
	CALL GET_PHIOMEGA (R4_PIMG, POLAR_PRJ, NROT, NANNULI, DEL_ANG, 
	1 OME_BEST, ANN_LO, ANN_HI, FLIP, CC_PRJ, 3)
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                   *****     SUBROUTINE LIST_CCS     *****                *
C  *                                                                          *
C  *    COMPUTES AND THEN LISTS CORRELATION COEFFICIENTS AS A FUNCTION OF     *
C  *     PARTICLE RADIUS AND RESOLUTION.                                      *
C  *                                                                          *
C  *    JANUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.        *
C  *    LAST MODIFIED  4-JUN-1998 BY TSB (Use BIN to get correct radii).      *
C  ****************************************************************************
C
	SUBROUTINE LIST_CCS (BIN, NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, 
	1 IMG, MSKIMG, R4_IMG, FFT1, FFT3, FFT4, FFT5, PRJ_ROT, MSKPRJ, 
	2 PPRJ, PMAP, FLTPMAP, IMG_NUM, IMG_BKG, XCEN, YCEN, XCEN_MODEL, 
	3 YCEN_MODEL, FFT_ORIGX, FFT_ORIGY, RES_MIN, RES_MAX, ANN_LO, ANN_HI, 
	4 RADIUS, PIXRES_MAX, DEL_PIXRES, DEL_ANG, CC_AVG, CC_RES_GLOBAL, 
	5 CC_RAD_GLOBAL)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, IMG_NUM
	INTEGER*4 I, J, ANN_LO, ANN_HI, BIN
	real*4    IMG(NCOL,NROW), MSKIMG(NCOL,NROW)
	real*4    IMG_BKG
	REAL*4    XCEN, YCEN, XCEN_MODEL, YCEN_MODEL, FFT_ORIGX, FFT_ORIGY
	REAL*4    CCRES(2,20), CCRAD(2,200), DEL_PIXRES, RES_MIN, RES_MAX
	REAL*4    CC_RES_GLOBAL(2,20), CC_AVG, CC_RAD_GLOBAL(2,200)
	REAL*4    RADIUS, DEL_ANG, SUMRSQ, PIXRES_MAX, FFT_FZERO
	REAL*4    FFT1(2*IDIM1,IDIM2), FFT3(2*IDIM1,IDIM2)
	REAL*4    FFT4(2*IDIM1,IDIM2), FFT5(2*IDIM1,IDIM2)
	REAL*4    R4_IMG(NCOL,NROW), MSKPRJ(NCOL,NROW)
	REAL*4    PRJ_ROT(NCOL,NROW), FLTPMAP(NROT,NANNULI)
	REAL*4    PMAP(NROT,NANNULI), PPRJ(NROT,NANNULI)
	LOGICAL   FFT_FULL
C  ----------------------------------------------------------------------------
C
	CALL COPY_r4 (IMG, MSKIMG, NCOL*NROW)
	CALL R4_IMG_MASK (MSKIMG, NCOL, NROW, ANN_LO, ANN_HI, XCEN, YCEN, 
	1 IMG_BKG)
	CALL R4_IMG_FFT_FILL (MSKIMG, NCOL, NROW, FFT4, IDIM1, IDIM2, 
	1 IMG_BKG, FFT_ORIGX, FFT_ORIGY, FFT_FZERO, FFT_FULL, 0)
	CALL FFT_2D (FFT4, IDIM1, IDIM2)
	CALL COPY_R4 (PRJ_ROT, MSKPRJ, NCOL*NROW)
	CALL MAP_2DMASK (MSKPRJ, NCOL, NROW, FLOAT(ANN_LO), FLOAT(ANN_HI),
	1 XCEN_MODEL, YCEN_MODEL, 0.0)
	CALL MAP_FFT_FILL (MSKPRJ, NCOL, NROW, 1, 1, FFT5, IDIM1, IDIM2, 
	2 FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	CALL FFT_2D (FFT5, IDIM1, IDIM2)
	CALL PFTCC_RES (FFT1, FFT3, FFT4, FFT5, IDIM1, IDIM2, CCRES, 
	2 DEL_PIXRES)
	CALL FFT_FLT (FFT1, IDIM1, IDIM2, RES_MIN, RES_MAX, 0.0, 0.0, .TRUE.)
	CALL FFT_2DBT (FFT1, IDIM1, IDIM2, IMG, NCOL, NROW, FFT_FULL, 
	1 IMG_BKG)
	CALL R4_IMG_MAP (IMG, R4_IMG, NCOL, NROW, IMG_BKG)
	CALL MAP_POLAR (R4_IMG, NCOL, NROW, FLTPMAP, NROT, NANNULI, XCEN, 
	1 YCEN, 1.0, RADIUS, DEL_ANG)
	CALL MAP_POLAR (PRJ_ROT, NCOL, NROW, PPRJ, NROT, NANNULI, 
	1 XCEN_MODEL, YCEN_MODEL, 1.0, RADIUS, DEL_ANG)
	CALL CC_RADII (PMAP, FLTPMAP, PPRJ, NROT, NANNULI, ANN_HI, CCRAD)
C
	SUMRSQ = 0.0
	DO I = 1,ANN_HI+1
	  CC_RAD_GLOBAL(1,I) = CC_RAD_GLOBAL(1,I) + CCRAD(1,I)
	  CC_RAD_GLOBAL(2,I) = CC_RAD_GLOBAL(2,I) + CCRAD(2,I)
	  IF(I.GE.ANN_LO) THEN
	    SUMRSQ = SUMRSQ + (BIN*(I-1))**2
	    CC_AVG = CC_AVG + CCRAD(2,I)*((BIN*(I-1))**2)
	  ENDIF
	ENDDO
	IF(SUMRSQ.GT.0.0) THEN
	   CC_AVG = CC_AVG/SUMRSQ
	 ELSE
	   CC_AVG = 0.0
	ENDIF
	J = NINT(1/(PIXRES_MAX*DEL_PIXRES))
	DO I = 1,J
	  CC_RES_GLOBAL(1,I) = CC_RES_GLOBAL(1,I) + CCRES(1,I)
	  CC_RES_GLOBAL(2,I) = CC_RES_GLOBAL(2,I) + CCRES(2,I)
	ENDDO
	WRITE (8,1000) IMG_NUM, (CCRES(1,I),I=1,J)
	WRITE(10,1000) IMG_NUM, (CCRES(2,I),I=1,J)
	WRITE (9,1010) ' CCs vs radius for particle', IMG_NUM
	DO I = 1,ANN_HI+1
	  J = (I-1)*BIN
	  WRITE (9,1020) J, CCRAD(1,I), CCRAD(2,I)
	ENDDO
	WRITE (9,1030) CC_AVG, ' = Average CC for ANN_LO,ANN_HI=', 
	1 ANN_LO, ANN_HI
C
 1000	FORMAT(I6,20F7.3)
 1010	FORMAT(A,I6)
 1020	FORMAT(I5,2F10.3)
 1030	FORMAT(F7.3,A,2I4)
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                 *****     SUBROUTINE LOADSTATS_R     *****                *
C  *                                                                           *
C  *    READ IN POLAR FFTS FOR THE SEARCH WINDOW TO SET UP PFT_AVGS AND SQ2    *
C  *     ARRAYS.                                                               *
C  *                                                                           *
C  *    DECEMBER 1987  PURDUE UNIVERSITY VAX 11/750, T. BAKER                  *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, J. TESMER.                       *
C  *                                                                           *
C  *    Moved THETA,PHI calculations to CALC_MOD_TPS, 30 Jan 1997, D. Belnap   *
C  *    MODIFIED 23-DEC-1997 BY T. BAKER (Using memory for PFTS).              *
C  *    MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PFTs/PRJs).            *
C  *    MODIFIED  6-MAR-1998 BY TSB (Make UNIX compatible).                    *
C  *    MODIFIED 29-APR-1998 BY TSB (Adapted from PFTCC_FILL).                 *
C  *    LAST MODIFIED  4-MAY-1998 BY TSB (Implement sliding window).           *
C  *****************************************************************************
C
	SUBROUTINE LOADSTATS_R (N_INCORE, PFTS, PFT_AVGS, NROT, NANNULI, 
	1 SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, RMS, 
	2 AVER, VAROPT, SIGCUT, TMP, MASK, NTHE, NPHI, THETA, PHI, 
	3 MOD_TS, DTHE, DPHIS, NVIEW_THISIMG)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	INTEGER*4 NROT, NANNULI, NVIEW_THISIMG, I, J, JN, JCUT, NROT_BY_4
	INTEGER*4 ANN_LO, ANN_HI, IR, R, NUM, VAR((NROT/4),NANNULI)
	INTEGER*4 N_INCORE, NTHE, NPHI, MASK(NPHI,NTHE,2), MODEL_ID
	INTEGER*4 ITH, IPH, ITHE, IPHI, ITHE1, IPHI1, ITHE2, IPHI2
	REAL*4    RMS((NROT/4),NANNULI), AVER((NROT/4),NANNULI)
	REAL*4    TMP((NROT/4),NANNULI), PFTS((NROT/4),NANNULI,N_INCORE)
	REAL*4    PI, RADIAN, DEGREE, TMP2, SIGCUT, FACTOR, TWOPIR
	REAL*4    PFT_AVGS(N_INCORE), SQ2(N_INCORE), PTS, AVE, AVE2
	REAL*4    PIXRES, PIXRES_MIN, PIXRES_MAX, THETA, PHI, DTHE
	REAL*4    MOD_TS(NTHE), DPHIS(NTHE)
	LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
	CALL PIRADDEG (PI, RADIAN, DEGREE)
	NROT_BY_4  = NROT/4
C  *****************************************************
C  *    COUNT UP THE VIEWS AVAILABLE FOR THIS IMAGE    *
C  *****************************************************
	NVIEW_THISIMG = 0
	ITH           = NINT ( (THETA-MOD_TS(1))/DTHE ) + 1
	IPH           = NINT (ABS(PHI)/DPHIS(ITH)) + 1
	ITHE1         = ITH - 3
	ITHE2         = ITH + 3
	IPHI1         = IPH - 3
	IPHI2         = IPH + 3
	IF(ITHE1.LT.1)    ITHE1 =    1
	IF(ITHE2.GT.NTHE) ITHE2 = NTHE
	IF(IPHI1.LT.1)    IPHI1 =    1
	IF(IPHI2.GT.NPHI) IPHI2 = NPHI
C
	DO ITHE = ITHE1,ITHE2
	  DO IPHI = IPHI1,IPHI2
	    IF(MASK(IPHI,ITHE,1).GE.1) THEN	      ! IS THIS TEST NECESSARY?
	      NVIEW_THISIMG = NVIEW_THISIMG + 1
	    ENDIF
	  ENDDO
	ENDDO

CTSB	USE NVIEW_THISIMG = (ITHE2-ITHE1+1)*(IPHI2-IPHI1+1)	???

	FACTOR = 1.0/FLOAT(NVIEW_THISIMG)		! NORMALIZATION FACTOR
C
	DO ITHE = ITHE1,ITHE2
	  DO IPHI = IPHI1,IPHI2
	    IF(MASK(IPHI,ITHE,1).GE.1) THEN	     ! IS THIS TEST NECESSARY?
	      MODEL_ID = MASK(IPHI,ITHE,2)
	      PTS      = 0.0
	      DO IR = ANN_LO,ANN_HI
	        R      = MIN(NANNULI, IR+1)
	        TWOPIR = 2.0*PI*FLOAT(IR)
	        DO JN = JCUT,(NROT_BY_4 - 1)
	          IF(JN.GT.0) THEN				 ! TRAP FOR Jo
	             PIXRES = TWOPIR/FLOAT(JN)
	           ELSE 
	             PIXRES = 1000.0
	          ENDIF
	          IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) 
	1           GO TO 200
	          J    = JN + 1
	          PTS  = PTS + 1.0
                  TMP2 = PFTS(J,R,MODEL_ID)
                  IF(VAROPT) THEN
	            AVER(J,R) = AVER(J,R) + TMP2
                    VAR(J,R)  = 0
                  ENDIF
  200	        ENDDO
	      ENDDO
	    ENDIF
	  ENDDO					! DO IPHI = IPHI1,IPHI2
	ENDDO					! DO ITHE = ITHE1,ITHE2
C
        IF(.NOT.VAROPT) GO TO 500
C  ******************************
C  *    HERE IF SIGCUT > 0.0    *

C	***NOTE***  THIS NEEDS FIXING BECAUSE LOOP IS NOT CORRECT; ALSO ID NOT
C	RIGHT

C  ******************************
        AVE2 = 0.0
	DO IR = ANN_LO,ANN_HI
	  R      = MIN(NANNULI, IR+1)
	  TWOPIR = 2.0*PI*FLOAT(IR)
	  DO JN = JCUT,(NROT_BY_4 - 1)
	    IF(JN.GT.0) THEN					! TRAP FOR Jo
	       PIXRES = TWOPIR/FLOAT(JN)
	     ELSE
	       PIXRES = 1000.0
	    ENDIF
	    IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 300
	    J        = JN + 1
            RMS(J,R) = 0.0
	    AVE      = AVER(J,R)*FACTOR
            DO I = 1,NVIEW_THISIMG
              TMP2     = PFTS(J,R,I)
              RMS(J,R) = RMS(J,R) + (TMP2-AVE)**2
	    ENDDO
            RMS(J,R) = SQRT(RMS(J,R)*FACTOR)
            AVE2     = AVE2 + RMS(J,R)
  300	  ENDDO
	ENDDO
        NUM  = 0
        AVE2 = AVE2/PTS
	DO IR = ANN_LO,ANN_HI
	  R      = MIN(NANNULI, IR + 1)
	  TWOPIR = 2.0*PI*FLOAT(IR)
	  DO JN = JCUT,(NROT_BY_4 - 1)
	    IF(JN.GT.0) THEN				! TRAP FOR Jo
	       PIXRES = TWOPIR/FLOAT(JN)
	     ELSE
	       PIXRES = 1000.0
	    ENDIF
	    IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 400
	    J = JN + 1
            IF (RMS(J,R).GT.SIGCUT*AVE2) THEN
              VAR(J,R) = 1
              NUM      = NUM + 1 
            ENDIF
  400	  ENDDO
	ENDDO
	PRINT *,'VARIANCE:'
	PRINT *,'USING POINTS > ',SIGCUT,'*',AVE2
	PRINT *,'POINTS FROM PFFT BEING USED: ',NUM
C
  500	NUM = 0
	DO ITHE = ITHE1,ITHE2
	  DO IPHI = IPHI1,IPHI2
	    IF(MASK(IPHI,ITHE,1).GE.1) THEN	      ! IS THIS TEST NECESSARY?
	      NUM           = NUM + 1
	      MODEL_ID      = MASK(IPHI,ITHE,2)
	      PTS           = 0.0
	      PFT_AVGS(NUM) = 0.0
              SQ2(NUM)      = 0.0
	      DO IR = ANN_LO,ANN_HI
	        R      = MIN(NANNULI, IR+1)
	        TWOPIR = 2.0*PI*FLOAT(IR)
	        DO JN = JCUT,(NROT_BY_4 - 1)
	          IF(JN.GT.0) THEN				! TRAP FOR Jo
	             PIXRES = TWOPIR/FLOAT(JN)
	           ELSE
	             PIXRES = 1000.0
	          ENDIF
	          IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) 
	1           GO TO 600
	          J = JN + 1
                  IF((VAROPT.AND.(VAR(J,R).ne.0)) .OR. .NOT.VAROPT) THEN
	            PTS           = PTS + 1.0
                    TMP2          = PFTS(J,R,MODEL_ID)
	            PFT_AVGS(NUM) = PFT_AVGS(NUM) + TMP2
	            SQ2(NUM)      = SQ2(NUM) + TMP2**2
                  ENDIF
  600	        ENDDO
	      ENDDO
	      PFT_AVGS(NUM) = PFT_AVGS(NUM)/PTS
	    ENDIF
	  ENDDO					! DO IPHI = IPHI1,IPHI2
	ENDDO					! DO ITHE = ITHE1,ITHE2
C
	RETURN
	END

C  ************************************************************************
C  *								          *
C  *              *****     SUBROUTINE PFILE_INFO     *****               *
C  *								          *
C  *    READS IN  ALL PARAMETER FILENAMES AND CHECKS THE CORRESPONDING    *
C  *     IMAGE FILES TO BE SURE THE IMAGE AND MODEL DATA HAVE THE         *
C  *     SAME DIMENSIONS.                                                 *
C  *								          *
C  *	Prompts user for a parameter data file, opens file, counts        *
C  *	number of particles, finds highest particle number, gets          *
C  *	image filename from first line of file.			          *
C  *								          *
C  *	Adapted from PFT_GETPFILE written by DMB, May 1995.               *
C  *								          *
C  *	MODIFIED 19-JAN-1998 BY T. BAKER (Multiple inout files).          *
C  *	MODIFIED 22-JAN-1998 BY T. BAKER (CTF parameters).                *
C  *	MODIFIED  3-FEB-1998 BY T. BAKER (Save IMG_FILENAMES).            *
C  *    MODIFIED  6-MAR-1998 BY TSB (Make UNIX compatible).               *
C  *    MODIFIED  5-MAY-1998 BY TSB (Pass min pixel size to INFO).        *
C  *    LAST MODIFIED 25-AUG-1999 BY TSB (Add UNITS variable).            *
C  ************************************************************************
C
	SUBROUTINE PFILE_INFO (MODE, NCOL, NROW, NSEC, NFILES, NIDS, 
	1 NIDS_TOT, PARAM_FNAMES, IMG_FNAMES, PIXSIZE)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	COMMON/CTF_COM/PIXSIZ, UNITS, VOLTS, AMP_FAC, FOCUS_MAJ, 
	1 FOCUS_MIN, ANG_MAJ, CS_COEFF
C
	INTEGER*4 MODE, NIMG, LUN, MAX_ID, ID, NIDS_TOT
	INTEGER*4 NCOL, NROW, NSEC, NCIMG, NRIMG, NFILES
	INTEGER*4 NIDS(999), UNITS(999)
	REAL*4    IMG_SCALEF, PIXSIZ(999), VOLTS(999), AMP_FAC(999)
	REAL*4    FOCUS_MAJ(999), FOCUS_MIN(999), ANG_MAJ(999)
	REAL*4    CS_COEFF(999), PIXSIZE
	CHARACTER PARAM_FNAMES(999)*256, IMG_FNAMES(999)*256
	CHARACTER NEW_FNAME*256, FNAME*256
	BYTE      READWRITE(4)
C------------------------------------------------------------------------------
C
	NFILES   = 0			 ! COUNT THE NUMBER OF PARAMETER FILES
	NIDS_TOT = 0			 ! COUNT THE NUMBER OF IMAGES TO SEARCH
	PIXSIZE  = 1000000.0		 ! Minimum pixel size 
C
  	WRITE(*,'($,A)') 'PARAMETER DATA FILES: '
  100	READ (*,'(A)',ERR=950,END=999) FNAME
C  *************************************************************
C  *  Open file and read first line, make sure it is not data  *
C  *************************************************************
	IF(NFILES.NE.0) THEN
	  CLOSE (UNIT=2)
	  CALL PIF_CLOSE (7)
	ENDIF
	OPEN (UNIT=2, FILE=FNAME, STATUS='OLD', ERR=960,
	1     ACCESS='SEQUENTIAL', FORM='FORMATTED', READONLY)
	NFILES = NFILES + 1
	IF(NFILES.GT.999) GO TO 940
	READ (2,'(A)',ERR=970) IMG_FNAMES(NFILES)
Ca	READ (2,'(F,I,6F)',ERR=975) PIXSIZ(NFILES), UNITS(NFILES), 
	READ (2,*,ERR=975) PIXSIZ(NFILES), UNITS(NFILES), 
	1 VOLTS(NFILES), AMP_FAC(NFILES), FOCUS_MAJ(NFILES), 
	2 FOCUS_MIN(NFILES), ANG_MAJ(NFILES), CS_COEFF(NFILES)
	PARAM_FNAMES(NFILES) = FNAME
Ca      Now try and see if these param files are already in existence
	CALL INCREMENT_FNAME (PARAM_FNAMES(NFILES), NEW_FNAME)
	call chk_file_exists (NEW_FNAME)
Ca	OPEN (UNIT=11, FILE=NEW_FNAME, STATUS='NEW',
Ca	1 ACCESS='SEQUENTIAL', FORM='FORMATTED')
Ca	CLOSE (UNIT=11)
	IF(PIXSIZ(NFILES).LT.PIXSIZE) PIXSIZE = PIXSIZ(NFILES)
	PRINT *
	WRITE(*,'(A,I4,2A)') ' File #', NFILES, ' is: ', IMG_FNAMES(NFILES)
C  ************************************************************
C  *    OPEN UP PIF FORMAT IMAGE FILE AND CHECK TO MAKE SURE  *
C  *     MODEL MAP DATA SIZE AND IMAGE SIZE ARE EQUIVALENT    *
C  ************************************************************
	IMGHEAD.LUNUM = 7
	READWRITE(1)  = 'r'
	CALL PIF_OPEN (IMG_FNAMES(NFILES), IMGHEAD.LUNUM, READWRITE)
	CALL PIF_READ_GH (IMGHEAD)
	NIMG  = IMGHEAD.NIMG
	NCIMG = IMGHEAD.NUMCOLS
        NRIMG = IMGHEAD.NUMROWS
	IF(NCIMG.NE.NCOL .OR. NRIMG.NE.NROW) THEN
	  PRINT *, '=================================================='
	  PRINT *, '|  ERROR!!  Sizes of MAP and IMAGE are unequal.  |'
	  PRINT *, '|  Make them equivalent then rerun program.      |'
	  PRINT *, '=================================================='
	  PRINT *, 'NCOL (map)   = ', NCOL
	  PRINT *, 'NROW (map)   = ', NROW
	  PRINT *, 'NSEC (map)   = ', NSEC
	  PRINT *, 'NCOL (image) = ', NCIMG
	  PRINT *, 'NROW (image) = ', NRIMG
	  CALL TSBEND
	ENDIF
	IF(IABS(MODE).EQ.1) THEN
	  NIDS(NFILES) = NIMG
	  MAX_ID       = NIMG
	  NIDS_TOT     = NIDS_TOT + NIMG
	  GO TO 300
	ENDIF
C  ********************************************************************
C  *  Count particles in parameter file, find one with highest value  *
C  ********************************************************************
	NIDS(NFILES) = 0
	MAX_ID       = 0
  200	READ (2,'(I)',ERR=980,END=300) ID
	NIDS_TOT     = NIDS_TOT + 1
	NIDS(NFILES) = NIDS(NFILES) + 1
	MAX_ID       = MAX(MAX_ID, ID)
	GO TO 200
C  ****************************************************
C  *    HERE WHEN AT END OF CURRENT PARAMETER FILE    *
C  ****************************************************
  300	IF(NIDS(NFILES).EQ.0)  GO TO 990
	GO TO 100			! CHECK FOR ADDITIONAL PARAMETER FILES
C  ***************************************************************************
C  *    ERROR MESSAGES    *
C  ************************
  940	PRINT *, '***********************************************'
	PRINT *, '* More than 999 parameter files: EXIT program *'
	CALL TSBEND
  950	PRINT *, '**************************************************'
	PRINT *, '* Error reading parameter filename: EXIT program *'
	CALL TSBEND
  960	PRINT *, '**********************************************'
	PRINT *, '* Error opening parameter file: EXIT program *'
	CALL TSBEND
  970	PRINT *, '**********************************************'
	PRINT *, '* Error reading IMAGE filename: EXIT program *'
	CALL TSBEND
  975	PRINT *, '**********************************************'
	PRINT *, '* READ ERROR: 2nd record of PARAMETER file   *'
	PRINT *, '* HINT: Did you specify UNITS?               *'
	CALL TSBEND
  980	PRINT *, '*******************************************'
	PRINT *, '* Error reading particle ID: EXIT program *'
	CALL TSBEND
  990	PRINT *, '*********************************************'
	PRINT *, '* PARAM file contains no data: EXIT program *'
	CALL TSBEND
  999	WRITE(*,'(I5,A,I6,A)') NFILES, ' PARAMETER files and total of', 
	1 NIDS_TOT, ' images for PFT search.'
	CLOSE (UNIT=2)
	CALL PIF_CLOSE (7)
	RETURN
C
	END

C  ****************************************************************************
C  *                                                                          *
C  *                      *****   FUNCTION PHIMAX   *****                     *
C  *                                                                          *
C  *  Determines PHIMAX based on SYM chosen			              *
C  *                                                                          *
C  *  PURDUE UNIVERSITY DEC 3000, Jan,Jun 1994, T. Baker and D. Belnap        *
C  *  Added 222, 522, 622, & 722 symmetries, Dec 1996, Jan 1997, D. Belnap    *
C  *  Added 2-20 n-fold symmetries, 30 Jan 1997, D. Belnap                    *
C  *    LAST MODIFIED 24-APR-1998 BY T. BAKER (Renamed and added more SYM.)   *
C  ****************************************************************************
C
	REAL*4 FUNCTION PHIMAX (SYM, THETA)
C
	IMPLICIT NONE
C
	INTEGER*4 SYM
	REAL*4    THETA
C -----------------------------------------------------------------------------
C
	PHIMAX = 180.0				      ! FOR ASYMMETRIC OBJECTS
	IF (SYM.EQ.532) THEN
	   CALL ICO_CALCPHIMAX (THETA, PHIMAX)
	 ELSE IF (SYM.GE.2 .AND. SYM.LE.20) THEN
	   PHIMAX = 360.0 / FLOAT(SYM*2)
	 ELSE IF (SYM.EQ.222) THEN
	   PHIMAX = 360.0/4.0				    ! = 90.0 degrees
	 ELSE IF (SYM.EQ.32) THEN
	   PHIMAX = 360.0/6.0				    ! = 60.0 degrees
	 ELSE IF (SYM.EQ.422) THEN
	   PHIMAX = 360.0/8.0				    ! = 45.0 degrees
	 ELSE IF (SYM.EQ.52) THEN
	   PHIMAX = 360.0/10.0				    ! = 36.0 degrees
	 ELSE IF (SYM.EQ.622) THEN
	   PHIMAX = 360.0/12.0				    ! = 30.0 degrees
	 ELSE IF (SYM.EQ.72) THEN
	   PHIMAX = 360.0/14.0				    ! = 25.7 degrees
	 ELSE IF (SYM.EQ.822) THEN
	   PHIMAX = 360.0/16.0				    ! = 22.5 degrees
	 ELSE IF (SYM.EQ.92) THEN
	   PHIMAX = 360.0/18.0				    ! = 20.0 degrees
	ENDIF
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE PRJAVG_FFT       *****                *
C  *                                                                           *
C  *    FOURIER TRANSFORM THE CIRCULARLY AVERAGED PROJECTION AVERAGE.          *
C  *    IF MODE.LT.0, READ IN THE CIRCULARLY AVERAGED PROJECTION AVERAGE FROM  *
C  *    DISK FILE.                                                             *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *    MODIFIED 15-DEC-1997 BY T. BAKER (Rid of EM.CMM).                      *
C  *    MODIFIED 23-DEC-1997 BY T. BAKER (Memory version of PRJ_AVG).          *
C  *    MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PRJ_AVG).              *
C  *    MODIFIED  6-MAR-1998 BY TSB (Make UNIX compatible).                    *
C  *    LAST MODIFIED 21-APR-1998 BY T. BAKER (Renamed from PFTCC_AVGFFT).     *
C  *****************************************************************************
C
	SUBROUTINE PRJAVG_FFT (PRJ_AVG, NCOL, NROW, NVIEW_MOD, FFT2,
	1 IDIM1, IDIM2, FFT_ORIGX, FFT_ORIGY, MODE, PRJHEAD)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ PRJHEAD
C
	INTEGER*4 NCOL, NROW, NVIEW_MOD, I, J, IDIM1, IDIM2, MODE
	INTEGER*4 SECNUM
	REAL*4    PRJ_AVG(NCOL,NROW), FFT2(2*IDIM1,IDIM2)
	REAL*4    FFT_ORIGX, FFT_ORIGY, FFT_FZERO
	LOGICAL   FFT_FULL
C  ----------------------------------------------------------------------------
C
	IF(MODE.LT.0) THEN			      ! USE DATA STORED ON DISK
	  CALL MAP_CLEAR (PRJ_AVG, NCOL, NROW, 1)
C         ********************************************************
C---------*  Note: The average projection is the NVIEW_MOD + 1   *
C         *        projection stored in the *.PIF format file.   *
C         ********************************************************
	  SECNUM = NVIEW_MOD + 1
	  CALL PIF_READ_SECI4 (PRJHEAD, PRJ_AVG, NCOL, NROW, SECNUM)
	ENDIF
C
	CALL MAP_FFT_FILL (PRJ_AVG, NCOL, NROW, 1, 1, FFT2, IDIM1, 
	1 IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	CALL FFT_2D (FFT2, IDIM1, IDIM2)
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                  *****     SUBROUTINE SAVE_PRJS     *****                 *
C  *                                                                           *
C  *    Computes PRJs and PRJ_AVG and stores data in core memory.              *
C  *                                                                           *
C  *    MODIFIED 16-APR-1996, BY DMB/CONWAY (Zero PRJ_AVG array on 1st PRJ     *
C  *    MODIFIED 30-DEC-1997 BY T. BAKER (Output PRJS to disk file).           *
C  *    MODIFIED 14-JAN-1998 BY T. BAKER (Remove option to write to disk).     *
C  *    LAST MODIFIED 21-APR-1998 BY T. BAKER (Renamed from PFT_PRJS_STORE).   *
C  *****************************************************************************
C
	SUBROUTINE SAVE_PRJS (PRJ, NCOLBIN, NROWBIN, ID, PRJ_AVG, 
	1 NVIEW_MOD, ITMP, PRJS)
C
	IMPLICIT NONE
C
	INTEGER*4 NCOLBIN, NROWBIN, ID, I, J, NVIEW_MOD, EM_WRT
	INTEGER*4 ITMP(NCOLBIN)
	REAL*4    PRJ(NCOLBIN,NROWBIN), DIV
	REAL*4    PRJ_AVG(NCOLBIN,NROWBIN), PRJS(NCOLBIN,NROWBIN,NVIEW_MOD)
	REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, XCEN_MOD, YCEN_MOD
C  ----------------------------------------------------------------------------
C
	IF(ID.EQ.1) THEN			     ! INITIALIZE PRJ_AVG ARRAY
	  CALL MAP_CLEAR (PRJ_AVG, NCOLBIN, NROWBIN, 1)
	ENDIF
C
	DO J = 1,NROWBIN
	  DO I = 1,NCOLBIN
	    PRJS(I,J,ID) = PRJ(I,J)
	    PRJ_AVG(I,J) = PRJ_AVG(I,J) + PRJ(I,J)
	  ENDDO
	ENDDO
Ca	if(id .gt. 10) then
Ca	   print *, 'save_prjs - ', ncolbin, nrowbin
Ca	   call pif_debug_write(prj_avg,ncolbin,nrowbin)
Ca	   call tsbend
Ca	endif
C  ****************************************************************************
C  *    SPECIAL CASE FOR CIRCULARLY AVERAGED PROJECTION    *
C  *********************************************************
	IF(ID.EQ.NVIEW_MOD) THEN	 ! CIRCULARLY AVERAGE PRJ_AVG AND SAVE
	  DIV = FLOAT(NVIEW_MOD)
	  DO J = 1,NROWBIN
	    DO I = 1,NCOLBIN
	      PRJ_AVG(I,J) = PRJ_AVG(I,J)/DIV		   ! TO NORMALIZE DATA
	    ENDDO
	  ENDDO
	  XCEN_MOD = (NCOLBIN+1)/2
	  YCEN_MOD = (NROWBIN+1)/2
	  EM_WRT = 0
	  CALL MAP_SYM (PRJ_AVG, NCOLBIN, NROWBIN, XCEN_MOD, YCEN_MOD, 101,
	1  MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, EM_WRT)
Ca	   print *, 'save_prjs - ', ncolbin, nrowbin
Ca	   call pif_debug_write(prj_avg,ncolbin,nrowbin)
Ca	   call tsbend
	ENDIF
C
	RETURN
	END

C  ****************************************************************************
C  *                                                                          *
C  *                *****     SUBROUTINE WRITE_PARAMS     *****               *
C  *                                                                          *
C  *    WRITES OUT THE CURRENT PARAMETER ARRAYS TO NEW PARAMETER FILES        *
C  *     FILES (UNIT = 11).                                                   *
C  *    ALSO NORMALIZES THE MAG SCALE FACTORS IF MAG_NORM SET = TO 1.         *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED  6-FEB-1998 BY T. BAKER (Add MAG normalization).        *
C  ****************************************************************************
C
	SUBROUTINE WRITE_PARAMS (NFILES, NIDS_TOT, FIDS, IDS, TS, PS, OS, 
	1 XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, PARAM_FNAMES, 
	2 IMG_FNAMES, MAG_NORM)
C	
	IMPLICIT NONE
C
	COMMON/CTF_COM/PIXSIZ, UNITS, VOLTS, AMP_FAC, FOCUS_MAJ, 
	1 FOCUS_MIN, ANG_MAJ, CS_COEFF
C
	INTEGER*4 STRING_LEN
	INTEGER*4 NFILES, NIDS_TOT, FILE, FILE_LAST, MAG_NORM
	INTEGER*4 ID, FIDS(NIDS_TOT), IDS(NIDS_TOT), UNITS(999)
	REAL*4    PIXSIZ(999), VOLTS(999), AMP_FAC(999), CS_COEFF(999)
	REAL*4    FOCUS_MAJ(999), FOCUS_MIN(999)
	REAL*4    ANG_MAJ(999), MAG_FACTOR
	REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
	CHARACTER PARAM_FNAMES(999)*256, IMG_FILENAME*256
	CHARACTER IMG_FNAMES(999)*256, NEW_FNAME*256
C  ----------------------------------------------------------------------------
C
C  *****************************************************
C  *    NORMALIZE MAG SCALE FACTORS IF MAG_NORM = 1    *
C  *****************************************************
	IF(MAG_NORM.EQ.1) THEN
	  MAG_FACTOR = 0.0
	  DO ID = 1, NIDS_TOT
	    MAG_FACTOR = MAG_FACTOR + MAGS(ID)
	  ENDDO
	  MAG_FACTOR = MAG_FACTOR/FLOAT(NIDS_TOT)
	  WRITE(*,'(A,F8.4,A)') ' Mean of MAG scale factors (=', 
	1  MAG_FACTOR,') normalized to 1.0'
	  MAG_FACTOR = 1.0/MAG_FACTOR
	  DO ID = 1, NIDS_TOT
	    MAGS(ID) = MAGS(ID)*MAG_FACTOR
	  ENDDO
	ENDIF
C
	CALL INCREMENT_FNAME (PARAM_FNAMES(1), NEW_FNAME)
Ca      This filename already guaranteed to be new in PFILE_INFO() above
Ca      See call to chk_file_exists()
	OPEN (UNIT=11, FILE=NEW_FNAME, STATUS='NEW',
	1 ACCESS='SEQUENTIAL', FORM='FORMATTED')
	IMG_FILENAME = IMG_FNAMES(1)
	IF(IMG_FILENAME(1:1).EQ.' ') THEN
	   WRITE(11,'(A)') IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	 ELSE
	   WRITE(11,'(A)') ' '//IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	ENDIF
	WRITE(11,1010) PIXSIZ(1), UNITS(1), VOLTS(1), AMP_FAC(1), 
	1 FOCUS_MAJ(1), FOCUS_MIN(1), ANG_MAJ(1), CS_COEFF(1)
	FILE_LAST = FIDS(1)
C
	DO ID = 1,NIDS_TOT
	  FILE = FIDS(ID)
	  IF(FILE_LAST.NE.FILE) THEN
	    CLOSE (UNIT=11)
	    CALL INCREMENT_FNAME (PARAM_FNAMES(FILE), NEW_FNAME)
	    OPEN (UNIT=11, FILE=NEW_FNAME, STATUS='NEW',
	1         ACCESS='SEQUENTIAL', FORM='FORMATTED')
	    IMG_FILENAME = IMG_FNAMES(FILE)
	    IF(IMG_FILENAME(1:1).EQ.' ') THEN
	       WRITE(11,'(A)') IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	     ELSE
	       WRITE(11,'(A)') ' '//IMG_FILENAME(1:STRING_LEN(IMG_FILENAME))
	    ENDIF
	    WRITE(11,1010) PIXSIZ(FILE), UNITS(FILE), VOLTS(FILE), 
	1    AMP_FAC(FILE), FOCUS_MAJ(FILE), FOCUS_MIN(FILE), 
	2    ANG_MAJ(FILE), CS_COEFF(FILE)
	    FILE_LAST = FIDS(ID)
	  ENDIF
	  WRITE(11,1020) IDS(ID), TS(ID), PS(ID), OS(ID), XS(ID), YS(ID),
	1  MAGS(ID), PFT_CCS(ID), PRJ_CCS(ID), CMP_CCS(ID)
	ENDDO
	CLOSE (UNIT=11)
C
 	RETURN
 1000	FORMAT (1X,I6,',',4(F8.3,','),F7.3,',',3(F6.3,','),F6.3)
 1010	FORMAT (1X,F8.4,',',I2,',',F10.1,',',3(F10.4,','),F10.4,',',F8.2)
 1020	FORMAT (1X,I6,',',4(F8.3,','),F7.3,',',3(F6.3,','),F6.3)
C
	END

C  *****************************************************************************
C  *                                                                           *
C  *                *****     SUBROUTINE PFTCC_FILL_G     *****                *
C  *                                                                           *
C  *    READ IN THE ENTIRE DATA SET OF POLAR FFTS FOR THE CHOSEN               *
C  *     SEARCH WINDOW.                                                        *
C  *                                                                           *
C  *    DECEMBER 1987  PURDUE UNIVERSITY VAX 11/750, T. BAKER                  *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, J. TESMER.                       *
C  *    Moved THETA,PHI calculations to CALC_MOD_TPS, 30 Jan 1997, D. Belnap   *
C  *    MODIFIED 19-DEC-1997 BY T. BAKER (Some output stuff).                  *
C  *    MODIFIED 23-DEC-1997 BY T. BAKER (Using memory for PFTS).              *
C  *    MODIFIED 14-JAN-1998 BY TSB/RWA (*.PIF input of PFTs/PRJs).            *
C  *    MODIFIED  6-MAR-1998 BY TSB (Make UNIX compatible).                    *
C  *    MODIFIED 27-APR-1998 BY TSB (Make GLOBAL compatible).                  *
C  *    LAST MODIFIED 24-JUL-2002 BY TSB (PFTs no longer store on disk).       *
C  *****************************************************************************
C
	SUBROUTINE PFTCC_FILL_G (PFTS, PFT_AVGS, NROT, NANNULI, 
	1 NVIEW_MOD, SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, 
	2 VAR, RMS, AVER, VAROPT, SIGCUT, TMP)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	INTEGER*4 NROT, NANNULI, NVIEW_MOD, I, J, JN, K, JCUT, J2
	INTEGER*4 ANN_LO, ANN_HI, IR, R, NUM, VAR((NROT/4),NANNULI)
	INTEGER*4 NROT_BY_4
	REAL*4    RMS((NROT/4),NANNULI), AVER((NROT/4),NANNULI)
	REAL*4    TMP((NROT/4),NANNULI), PFTS((NROT/4),NANNULI,NVIEW_MOD)
	REAL*4    TMP2, SIGCUT, PIXRES, PIXRES_MIN, PIXRES_MAX
	REAL*4    PFT_AVGS(NVIEW_MOD), PERCENT, PTS, AVE, AVE2
	REAL*4    PI, RADIAN, DEGREE, TWOPIR, SQ2(NVIEW_MOD)
	LOGICAL   VAROPT
C  ----------------------------------------------------------------------------
C
	CALL PIRADDEG (PI, RADIAN, DEGREE)
	NROT_BY_4 = NROT/4
	J2        = NROT_BY_4 - 1
        PTS       = 0.0
C
	DO K = 1,NVIEW_MOD
	  PTS = 0.0
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR+1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 200
	      J    = JN + 1
	      PTS  = PTS + 1.0
              TMP2 = PFTS(J,R,K)
              IF(VAROPT) THEN
                AVER(J,R) = AVER(J,R) + TMP2
                VAR(J,R)  = 0
              ENDIF
  200	    ENDDO
	  ENDDO
	ENDDO						  ! DO K = 1,NVIEW_MOD
C
        AVE2 = 0.0
        IF(VAROPT) THEN
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR+1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN					! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 300
	      J        = JN + 1
              RMS(J,R) = 0.0
	      AVE      = AVER(J,R)/FLOAT(NVIEW_MOD)
              DO K = 1,NVIEW_MOD
                TMP2     = PFTS(J,R,K)
                RMS(J,R) = RMS(J,R) + (TMP2-AVE)**2
	      ENDDO
              RMS(J,R) = SQRT(RMS(J,R)/NVIEW_MOD)
              AVE2     = AVE2 + RMS(J,R)
  300	    ENDDO
	  ENDDO
          NUM  = 0
          AVE2 = AVE2/PTS
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR + 1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 400
	      J = JN + 1
              IF (RMS(J,R).GT.SIGCUT*AVE2) THEN
                VAR(J,R) = 1
                NUM      = NUM + 1 
              ENDIF
  400	    ENDDO
	  ENDDO
C
	  PRINT *,'VARIANCE:'
	  PRINT *,'USING POINTS > ',SIGCUT,'*',AVE2
	  PRINT *,'POINTS FROM PFFT BEING USED: ',NUM
        ENDIF
C
	DO K = 1,NVIEW_MOD
	  PTS         = 0.0
	  PFT_AVGS(K) = 0.0
          SQ2(K)      = 0.0
	  DO IR = ANN_LO,ANN_HI
	    R      = MIN(NANNULI, IR+1)
	    TWOPIR = 2.0*PI*FLOAT(IR)
	    DO JN = JCUT,J2
	      IF(JN.GT.0) THEN				! TRAP FOR Jo
	         PIXRES = TWOPIR/FLOAT(JN)
	       ELSE
	         PIXRES = 1000.0
	      ENDIF
	      IF(PIXRES.LT.PIXRES_MAX .OR. PIXRES.GT.PIXRES_MIN) GO TO 500
	      J = JN + 1
              IF((VAROPT.AND.(VAR(J,R).ne.0)) .OR. .NOT.VAROPT) THEN
	        PTS         = PTS + 1.0
                TMP2        = PFTS(J,R,K)
	        PFT_AVGS(K) = PFT_AVGS(K) + TMP2
	        SQ2(K)      = SQ2(K) + TMP2**2
              ENDIF
  500	    ENDDO
	  ENDDO
	  PFT_AVGS(K) = PFT_AVGS(K)/PTS
	ENDDO
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                  *****     SUBROUTINE CC_RADII     *****                  *
C  *                                                                           *
C  *    FIND CORRELATION COEFICIENTS AS FUNCTION OF ANNULUS(RADIUS).           *
C  *                                                                           *
C  *    NOTE: REAL SPACE CORRELATION COEFFICIENTS ARE USED.                    *
C  *                                                                           *
C  *    CCRAD(1,N) = Correlation coefficient: PMAP vs. POLAR_PRJ.              *
C  *    CCRAD(2,N) = Correlation coefficient: filtered PMAP vs. POLAR_PRJ.     *
C  *                                                                           *
C  *    FEBRUARY 1993  PURDUE UNIVERSITY VAX 8550, T. BAKER.                   *
C  *    LAST MODIFIED  4-JUN-1998 BY TSB (Renamed CC_RADII).                   *
C  *****************************************************************************
C
	SUBROUTINE CC_RADII (PMAP, FLTPMAP, POLAR_PRJ, NROT, NANNULI, 
	1 ANN_HI, CCRAD)
C
	IMPLICIT NONE
C
	INTEGER*4 NROT, NANNULI, I, II, J, ANN_HI
	REAL*8    SUM12(2,200), SQ1(200), SQ2(200), SQ3(200)
	REAL*4    PMAP(NROT,NANNULI), POLAR_PRJ(NROT,NANNULI)
	REAL*4    FLTPMAP(NROT,NANNULI), DIV1, DIV2, DIV3
	REAL*4    CCRAD(2,200), AVG1(200), AVG2(200), AVG3(200)
C  ----------------------------------------------------------------------------
C
	DO I = 1,MIN(NANNULI, ANN_HI+1)
	  AVG1(I) = 0.0
	  AVG2(I) = 0.0
	  AVG3(I) = 0.0
	  SQ1(I)  = 0.0
	  SQ2(I)  = 0.0
	  SQ3(I)  = 0.0
	  DO II = 1,2
	    CCRAD(II,I) = 0.0
	    SUM12(II,I) = 0.0
	  ENDDO
	  DO J = 1,NROT
	    SUM12(1,I) = SUM12(1,I) + PMAP(J,I)*POLAR_PRJ(J,I)
	    SUM12(2,I) = SUM12(2,I) + FLTPMAP(J,I)*POLAR_PRJ(J,I)
	    AVG1(I)    = AVG1(I) + PMAP(J,I)
	    AVG2(I)    = AVG2(I) + POLAR_PRJ(J,I)
	    AVG3(I)    = AVG3(I) + FLTPMAP(J,I)
	    SQ1(I)     = SQ1(I) + PMAP(J,I)**2
	    SQ2(I)     = SQ2(I) + POLAR_PRJ(J,I)**2
	    SQ3(I)     = SQ3(I) + FLTPMAP(J,I)**2
	  ENDDO
	  AVG1(I) = AVG1(I)/FLOAT(NROT)
	  AVG2(I) = AVG2(I)/FLOAT(NROT)
	  AVG3(I) = AVG3(I)/FLOAT(NROT)
	  DIV1    = SQ1(I) - FLOAT(NROT)*(AVG1(I)**2)
	  DIV2    = SQ2(I) - FLOAT(NROT)*(AVG2(I)**2)
	  DIV3    = SQ3(I) - FLOAT(NROT)*(AVG3(I)**2)
	  DIV1    = sign(SQRT(abs(DIV1)), DIV1)
	  DIV2    = sign(SQRT(abs(DIV2)), DIV2)
	  DIV3    = sign(SQRT(abs(DIV3)), DIV3)
	  IF(DIV1*DIV2.LE.0.0) THEN
	     CCRAD(1,I) = 0.0
	   ELSE
	     CCRAD(1,I) = (SUM12(1,I)-AVG1(I)*AVG2(I)*FLOAT(NROT)) /
	1                           (DIV1*DIV2)
	  ENDIF
	  IF(DIV3*DIV2.LE.0.0) THEN
	     CCRAD(2,I) = 0.0
	   ELSE
	     CCRAD(2,I) = (SUM12(2,I)-AVG3(I)*AVG2(I)*FLOAT(NROT)) /
	1                           (DIV3*DIV2)
	  ENDIF
	ENDDO
C
	RETURN
	END

	SUBROUTINE PFTCC_RES (FFT1, FFT3, FFT4, FFT5, IDIM1, IDIM2, CC,
	1 DEL_PIXRES)
C
	IMPLICIT NONE
C
	INTEGER*4 IDIM1, IDIM2, IX, IY, XX, BIN, IXTEST
	INTEGER*4 I, J, IX2, IY2
	REAL*4    CC(2,20), RES, YSQ
	REAL*4    FFT1(2*IDIM1,IDIM2), FFT3(2*IDIM1,IDIM2)
	REAL*4    FFT4(2*IDIM1,IDIM2), FFT5(2*IDIM1,IDIM2)
	REAL*4    DEL_PIXRES, SUM13(20), SUM45(20), PTS(20)
	REAL*4    AVG1(20), AVG3(20), AVG4(20), AVG5(20)
	REAL*4    SQ1(20), SQ3(20), SQ4(20), SQ5(20)
	REAL*4    DIV1, DIV3, DIV4, DIV5, AMP1, AMP3, AMP4, AMP5
C  ----------------------------------------------------------------------------
C
	IXTEST  = IDIM1/2
C
C  ***************************
C  *    INITIALIZE ARRAYS    *
C  ***************************
	DO I = 1,20
	  DO J = 1,2
	    CC(J,I)    = 0.0
	  ENDDO
	  PTS(I)   = 0.0
	  SUM13(I) = 0.0
	  SUM45(I) = 0.0
	  AVG1(I)  = 0.0
	  AVG3(I)  = 0.0
	  AVG4(I)  = 0.0
	  AVG5(I)  = 0.0
	  SQ1(I)   = 0.0
	  SQ3(I)   = 0.0
	  SQ4(I)   = 0.0
	  SQ5(I)   = 0.0
	ENDDO
C
	IY2 = (IDIM2/2) + 1
	DO IY = 1,IY2
	  YSQ = FLOAT(IY-1)**2
	  IX2 = IDIM1
	  IF(IY.EQ.1 .OR. IY.EQ.IY2) THEN
	    IX2 = IDIM1/2
	  ENDIF
	  DO IX = 1,IX2
	    IF(IY.EQ.1 .AND. IX.EQ.1) GO TO 100
	    XX = (IX-1)*2 + 1
	    IF(IX.GT.IXTEST) THEN
	       RES = SQRT ( YSQ + FLOAT(IDIM1-IX+1)**2 ) 
	     ELSE
	       RES = SQRT ( YSQ + FLOAT(IX-1)**2 )
	    ENDIF
	    AMP1 = SQRT(FFT1(XX,IY)**2 + FFT1(XX+1,IY)**2)
	    AMP3 = SQRT(FFT3(XX,IY)**2 + FFT3(XX+1,IY)**2)
	    AMP4 = SQRT(FFT4(XX,IY)**2 + FFT4(XX+1,IY)**2)
	    AMP5 = SQRT(FFT5(XX,IY)**2 + FFT5(XX+1,IY)**2)
	    BIN        = INT( RES/(IDIM1*DEL_PIXRES) ) + 1
	    IF(BIN.GT.20) GO TO 100
	    PTS(BIN)   = PTS(BIN) + 1.0
	    SUM13(BIN) = SUM13(BIN) + AMP1*AMP3
	    SUM45(BIN) = SUM45(BIN) + AMP4*AMP5
	    AVG1(BIN)  = AVG1(BIN) + AMP1
	    AVG3(BIN)  = AVG3(BIN) + AMP3
	    AVG4(BIN)  = AVG4(BIN) + AMP4
	    AVG5(BIN)  = AVG5(BIN) + AMP5
	    SQ1(BIN)   = SQ1(BIN) + AMP1**2
	    SQ3(BIN)   = SQ3(BIN) + AMP3**2
	    SQ4(BIN)   = SQ4(BIN) + AMP4**2
	    SQ5(BIN)   = SQ5(BIN) + AMP5**2
  100	  ENDDO
	ENDDO
C
	DO I = 1,20
	  IF(PTS(I).LE.0.0) THEN
	     AVG1(I) = 0.0
	     AVG3(I) = 0.0
	     AVG4(I) = 0.0
	     AVG5(I) = 0.0
	   ELSE
	     AVG1(I) = AVG1(I)/PTS(I)
	     AVG3(I) = AVG3(I)/PTS(I)
	     AVG4(I) = AVG4(I)/PTS(I)
	     AVG5(I) = AVG5(I)/PTS(I)
	  ENDIF
	  DIV1 = SQ1(I) - PTS(I)*(AVG1(I)**2)
	  DIV3 = SQ3(I) - PTS(I)*(AVG3(I)**2)
	  DIV4 = SQ4(I) - PTS(I)*(AVG4(I)**2)
	  DIV5 = SQ5(I) - PTS(I)*(AVG5(I)**2)
	  DIV1 = sign(SQRT(abs(DIV1)), DIV1)
	  DIV3 = sign(SQRT(abs(DIV3)), DIV3)
	  DIV4 = sign(SQRT(abs(DIV4)), DIV4)
	  DIV5 = sign(SQRT(abs(DIV5)), DIV5)
	  IF(DIV1*DIV3.LE.0.0) THEN
	     CC(1,I) = 0.0
	   ELSE
	     CC(1,I) = (SUM13(I)-AVG1(I)*AVG3(I)*PTS(I))/(DIV1*DIV3)
	  ENDIF
	  IF(DIV4*DIV5.LE.0.0) THEN
	     CC(2,I) = 0.0
	   ELSE
	     CC(2,I) = (SUM45(I)-AVG4(I)*AVG5(I)*PTS(I))/(DIV4*DIV5)
	  ENDIF
	ENDDO
C
	RETURN
	END


C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE GLOBAL_CC      *****                *
C  *                                                                          *
C  *    CROSS-CORRELATE POLAR FFT DATA TO DETERMINE AND REFINE PARTICLE       *
C  *     ORIENTATIONS (GLOBAL MODE VERSION).                                  *
C  *                                                                          *
C  *    LOGICAL UNITS: 1 = REFERENCE 3D MAP                                   *
C  *                   2 = INPUT PARAMETERS DATA FILE(s)                      *
C  *                   3 = PRJ DATABASE FILE (DEFAULT = PFT.PRJS)             *
C  *                   4 = PFT DATABASE FILE (DEFAULT = PFT.PFTS)             *
C  *                   7 = INPUT RAW IMAGE DATA                               *
C  *                   8 = STATS OUTPUT FILE (EMPFT.RES1)                     *
C  *                   9 = STATS OUTPUT FILE (EMPFT.RADS)                     *
C  *                  10 = STATS OUTPUT FILE (EMPFT.RES2)                     *
C  *                                                                          *
C  *    Protocol:                                                             *
C  *     1. Get circularly averaged reference average projection.             *
C  *     2. Cross-correlate raw images with projection average to get         *
C  *        estimate of particle center.                                      *
C  *     3. Compute polar map from raw image.                                 *
C  *     4. Compute polar FFT (PFT) of raw image.                             *
C  *     5. Cross-correlate raw PFT with data base of reference PFTs.         *
C  *     6. Cross-correlate raw image with "best" projection to resolve       *
C  *        PHI ambiquity and determine OMEGA.                                *
C  *                                                                          *
C  *    AUGUST 1993  PURDUE UNIVERSITY VAX 4000/90, T. BAKER.                 *
C  *    Modified May 1995 by D. Belnap & J. Conway, PFTs now R*4 in file      *
C  *    Modified 20 May 1995, D. Belnap, added GLOBAL search option	      *
C  *    Modified July 1996, D. Belnap, added calc. and use of MAG & CC_CMP    *
C  *    Modified Oct 1996, D. Belnap, fixed bug in 2nd call to INTERP2D       *
C  *    Modified Dec 1996, D. Belnap, added J. Conway test for stray origins, *
C  *     moved PFTCC_FILL to MAIN, modified MAG search, minor fixes           *
C  *	Added 2-20 n-fold symmetries, 31 Jan 1997, D. Belnap                  *
C  *	Changed format of output data file, 12 Feb 1997, D. Belnap            *
C  *    Added PIF format RW Ashmore & James Conway 5/1997                     *
C  *                                                                          *
C  *    MODIFIED 17-DEC-1997 BY T. BAKER (Rid of EM.CMM).                     *
C  *    MODIFIED 24-DEC-1997 BY T. BAKER (Identify ARRAY pointers).           *
C  *    MODIFIED 19-JAN-1998 BY T. BAKER (Multiple parameter files).          *
C  *    MODIFIED  5-FEB-1998 BY T. BAKER (Use parameter arrays).              *
C  *    MODIFIED  6-MAR-1998 BY T. BAKER (Add UNIX compatibility).            *
C  *    MODIFIED 23-JUL-1999 BY TSB (Implement SBW's CTF code).               *
C  *    MODIFIED 25-AUG-1999 BY TSB (Implement TSB's CTF code).               *
C  *    MODIFIED 24-JUL-02 BY TSB/RWA (Add PRJS_GOLD array).                  *
C  *    LAST MODIFIED 25-OCT-2005 BY MBS, bug in XS(ID), YS(ID) calculations  *
C  ****************************************************************************
C
	SUBROUTINE GLOBAL_CC (MODE, BIN, NROT, NANNULI, NVIEW_MOD, 
	1 DTHE, DPHI_90, THE1, PHI1, IDIM1, IDIM2, RES_MIN, RES_MAX, 
	2 PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, JCUT, RADIUS, NTH, NPH,
	3 SYM, ILIST, MAG_CEN, NFILES, MAG_STEP, MAG_NUM, MOD_TS,
	4 MOD_PS, IMG_BKG, IMG_MIN, IMG_MAX, IMG_AVG, IMG_STD, PRJ_AVG,
	5 PRJS, PRJ, VAROPT, NCOL, NROW, NSEC, NIDS_TOT, PARAM_FNAMES,
	6 IMG_FNAMES, FIDS, IDS, TS, PS, OS, XS, YS, MAGS, PFT_CCS, 
	7 PRJ_CCS, CMP_CCS, COMPARE_MODE, FILT_FAC, SIGCUT, NPIX, 
	8 XCEN_MODEL, YCEN_MODEL, PFTRAD_LO, PFTRAD_HI, PROJN, ITMP)
C
	IMPLICIT NONE
C
	INCLUDE '/usr/local/baker/libSrc/libEMF/INCfiles/PIFHEAD.INC'
	RECORD /PIFHEAD_T/ MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
	COMMON /PIFHEAD/   MAPHEAD, IMGHEAD, PRJHEAD, PFTHEAD
C
	COMMON/CTF_COM/PIXSIZ, UNITS, VOLTS, AMP_FAC, FOCUS_MAJ, 
	1 FOCUS_MIN, ANG_MAJ, CS_COEFF
C
	INTEGER*4 MODE, BIN, LUN, I, J, NPIX
	real*4    IMG_MIN, IMG_MAX
	INTEGER*4 NCOL, NROW, NSEC, NVIEW_MOD, NTH, NPH, NFILES, ID
	INTEGER*4 NROT, NANNULI, IDIM1, IDIM2, JCUT
	INTEGER*4 NIMGS, NIMG, NIDS_TOT, FILE_LAST, INDEX, UNITS(999)
	INTEGER*4 ANN_LO, ANN_HI, N1, N2, MAG_NUM, SYM, FILE, ILIST
	INTEGER*4 FIDS(NIDS_TOT), IDS(NIDS_TOT), COMPARE_MODE, CTFMODE, FILTER
	INTEGER*4 ARRAY_SIZE, ITMP(NCOL)
	real*4    IMG_BKG
	REAL*4    PIXSIZ(999), VOLTS(999), AMP_FAC(999), CS_COEFF(999)
	REAL*4    FOCUS_MAJ(999), FOCUS_MIN(999), ANG_MAJ(999)
	REAL*4    WAVELENGTH, WAVEL, TFAC, FILT_FAC(10), SIGCUT
	REAL*4    PFTRAD_LO, PFTRAD_HI
C
C	ARRAY POINTERS
C
	REAL*4    FFT1(1), FFT2(1), FFT3(1), FFT4(1), FFT5(1), R4_IMG(1)
	REAL*4    PRJ_ROT(1), CCOR(1), MSKIMG(1), MSKPRJ(1), PFTS(1), A(1)
	REAL*4    PFFT(1), PMAP(1), FLTPMAP(1), PPRJ(1), PRJS_GOLD(1)
	REAL*4    TMP0(1), TMP1(1), TMP2(1), A_ARRAY(1), PFTIMG(1)
	REAL*4    PFT_AVGS(1), TMP(1), SQ2(1), VAR(1), RMS(1), AVER(1)
	real*4    IMG(1)
	INTEGER*4 ICOR(1), flag
	POINTER   (FFT1_P,FFT1), (FFT2_P,FFT2), (FFT3_P,FFT3)
	POINTER   (FFT4_P,FFT4), (FFT5_P,FFT5), (IMG_P,IMG), (A_P,A)
	POINTER   (R4_IMG_P,R4_IMG), (PRJ_ROT_P,PRJ_ROT), (PFTS_P,PFTS)
	POINTER   (PFTIMG_P,PFTIMG), (PFFT_P,PFFT), (PMAP_P,PMAP)
	POINTER   (FLTPMAP_P,FLTPMAP), (PPRJ_P,PPRJ), (A_ARRAY_P,A_ARRAY)
	POINTER   (CCOR_P,CCOR), (ICOR_P,ICOR)
	POINTER   (TMP0_P,TMP0), (TMP1_P,TMP1), (TMP2_P,TMP2)
	POINTER   (MSKIMG_P,MSKIMG), (MSKPRJ_P,MSKPRJ)
	POINTER   (PRJS_GOLD_P,PRJS_GOLD)
	POINTER   (PFT_AVGS_P,PFT_AVGS), (TMP_P,TMP), (SQ2_P,SQ2)
	POINTER   (VAR_P,VAR), (RMS_P,RMS), (AVER_P,AVER)
C
	REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
	REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
	REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
	REAL*4    IMG_AVG, IMG_STD, PI, RADIAN, DEGREE
	REAL*4    DTHE, DPHI, DPHI_90, THE1, PHI1, DEL_ANG, DEL_PIXRES
	REAL*4    THE_BEST, PHI_BEST, OME_BEST, PIXRES_MIN, PIXRES_MAX
	REAL*4    AVG, SQ1, RADIUS, CC_PFT, CC_PRJ, CC_CMP
	REAL*4    XCEN, YCEN, XCEN_MODEL, YCEN_MODEL, RES_MIN, RES_MAX
	REAL*4    CC_RES_GLOBAL(2,20), CC_AVG, CC_RAD_GLOBAL(2,200)
	REAL*4    BEST_MAG, MAG, MAG_STEP, MAG_CEN, MAG_LO
	REAL*4    MOD_TS(NVIEW_MOD), MOD_PS(NVIEW_MOD)
	REAL*4    PRJ_AVG(NCOL,NROW), PRJS(NCOL,NROW,NVIEW_MOD)
	REAL*4    IMG_SCALEF, FFT_FZERO, FFT_ORIGX, FFT_ORIGY
	REAL*4    PROJN(NCOL,NROW), PRJ(NCOL,NROW)
	LOGICAL   FLIP, VAROPT, FFT_FULL, MALLOC, FIRST_TIME
	DATA      CC_RES_GLOBAL/40*0.0/, CC_RAD_GLOBAL/400*0.0/
	CHARACTER PARAM_FNAMES(999)*256, IMG_FILENAME*256
	CHARACTER IMG_FNAMES(999)*256
	BYTE      READWRITE(4)
	logical   end_fit/.false./
C  ----------------------------------------------------------------------------
C
	CALL PIRADDEG (PI, RADIAN, DEGREE)
C       *********************************************************
C       *  SAVE PROJECTION DATA BASE INTO GOLD STANDARD ARRAY   *
C       *********************************************************
	PRJS_GOLD_P = MALLOC (4*NCOL*NROW*NVIEW_MOD)
c       MBS Check malloc return
	IF(PRJS_GOLD_P.eq.0) then
	   write(*,*)'Could not allocate memory for PRJS_GOLD'
	   stop
	end if
	ARRAY_SIZE  = NCOL*NROW*NVIEW_MOD
	CALL COPY_R4 (PRJS, PRJS_GOLD, ARRAY_SIZE)
C  *******************************
C  *  Set up initial parameters  *
C  *******************************
	NIMGS      = 0
	DEL_PIXRES = 0.025
	DEL_ANG    = 360.0/FLOAT(NROT)
C  *****************************
C  *  Allocate virtual memory  *
C  *****************************
	CALL GETMEM3 (NVIEW_MOD, NPIX, NROT, NANNULI, PFT_AVGS_P, SQ2_P, 
	1 VAR_P, RMS_P, AVER_P, TMP_P)
	PFTS_P    = MALLOC (4*NPIX*NVIEW_MOD)
c       MBS Check malloc return
	IF(PFTS_P.eq.0) then
	   write(*,*)
	1'Could not allocate memory for PRJS_GOLD, make coarser search angle'
	   stop
	end if
	A_P       = MALLOC (4*2*NROT)
c       MBS Check malloc return
	IF(A_P.eq.0) then
	   write(*,*)
	1'Could not allocate memory for rotations, make coarser search angle'
	   stop
	end if
	CALL GETMEM4 (NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, NVIEW_MOD, 
	1 FFT1_P, FFT3_P, IMG_P, R4_IMG_P, PRJ_ROT_P, PFTIMG_P, 
	2 PFFT_P, PMAP_P, FLTPMAP_P, A_ARRAY_P, CCOR_P, ICOR_P, PPRJ_P)
	FFT2_P = MALLOC (8*IDIM1*IDIM2)			       ! MODEL CAVG
C
	IF(ILIST.GE.1) THEN
	  FFT4_P   = MALLOC (8*IDIM1*IDIM2)		       ! MASKED RAW IMG
	  FFT5_P   = MALLOC (8*IDIM1*IDIM2)     	       ! MASKED MOD PRJ
	  MSKIMG_P = MALLOC (4*NCOL*NROW)
	  MSKPRJ_P = MALLOC (4*NCOL*NROW)
c       MBS Check malloc returns
	  IF(FFT4_P.eq.0 .or.FFT5_P .or.MSKIMG_P .or. MSKPRJ_P) then
	     write(*,*)'Could not allocate memory for ffts and msks'
	     stop
	  end if
	ENDIF
C  *************************************************************
C  *    Loop through raw images as given in PARAMETER files    *
C  *************************************************************
	FILE_LAST  = FIDS(1)
	FIRST_TIME = .TRUE.
	DO ID = 1,NIDS_TOT
	   FILE = FIDS(ID)
C  ******************************************************************
C  *  If new micrograph then need to recalculate the PFTS database  *
C  ******************************************************************
Ca	  IF(FIRST_TIME .OR. (FILE.NE.FILE_LAST .AND. 
Ca	1    COMPARE_MODE.EQ.1)) THEN
	   IF(FIRST_TIME .OR. (FILE.NE.FILE_LAST)) THEN
	      FIRST_TIME = .FALSE.
Ca	       print *, 'BEFORE prjsvg_fft - ', ncol, nrow
Ca	       call pif_debug_write(prj_avg,ncol,nrow)
Ca	       call tsbend
	      CALL CALC_PFTS_G (FILE, NVIEW_MOD, NCOL, NROW, NSEC, 
	1    NROT, NANNULI, PROJN, PRJ, PRJ_AVG, ITMP, PMAP, XCEN_MODEL, 
	2    YCEN_MODEL, PFTRAD_LO, PFTRAD_HI, DEL_ANG, PFFT, A, PFTS, PRJS, 
	3    PRJS_GOLD, COMPARE_MODE, IDIM1, IDIM2, BIN, PI, RADIAN,
	4    img_fnames)
	      IF(IABS(MODE).EQ.1) THEN ! COMPUTE FFT OF CIRCULARLY-AVERAGED REFERENCE
		 CALL PRJAVG_FFT (PRJ_AVG, NCOL, NROW, NVIEW_MOD, FFT2, 
	1     IDIM1, IDIM2, FFT_ORIGX, FFT_ORIGY, MODE, PRJHEAD)
	      ENDIF
C	************************************
C	*  Load PFTs and THETA,PHI arrays  *
C	************************************
	      CALL PFTCC_FILL_G (PFTS, PFT_AVGS, NROT, NANNULI, NVIEW_MOD, 
	1    SQ2, JCUT, PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, RMS, 
	2    AVER, VAROPT, SIGCUT, TMP)
	   ENDIF
C
	   IMG_FILENAME = IMG_FNAMES(FILE)
C         *********************************************
C---------*    OPEN THE CORRECT IMAGE DATA FILE       *
C         *********************************************
	   IMGHEAD.LUNUM = 7	! UNIT FOR INPUT IMAGE FILE
	   READWRITE(1)  = 'r'
	   IF(ID.EQ.1) THEN
	      CALL PIF_OPEN (IMG_FILENAME, IMGHEAD.LUNUM, READWRITE)
	      CALL PIF_READ_GH (IMGHEAD)
	   ENDIF
	   IF(FILE_LAST.NE.FILE) THEN ! CLOSE CURRENT IMAGE FILE
	      CALL PIF_CLOSE (IMGHEAD.LUNUM)
	      CALL PIF_OPEN (IMG_FILENAME, IMGHEAD.LUNUM, READWRITE)
	      CALL PIF_READ_GH (IMGHEAD)
	      FILE_LAST = FILE
	   ENDIF
C
	   CC_AVG = 0.0
	   NIMGS  = NIMGS + 1
C	  **********************************************************
C---------*  Read in raw IMG and convert to floating point format  *
C	  **********************************************************
	   IMGHEAD.IMGNUM = IDS(ID) ! SPECIFY WHICH "IMG" YOU WANT
	   CALL PIF_READ_DH (IMGHEAD)
	   IMG_BKG = IMGHEAD.IMG_BKG
	   if(imgHead.mode .eq. 6) then
Ca	     CALL PIF_READ_IMGI1 (IMGHEAD, IMG, NCOL, NROW, IDS(ID))
	      print *, '*************************************************'
	      print *, ' Error - Image data must be in mode==46 float.'
	      print *, '*************************************************'
	      call tsbend
	   else if(imgHead.mode .eq. 7) then
Ca	     CALL PIF_READ_IMGI2 (IMGHEAD, IMG, NCOL, NROW, IDS(ID))
	      print *, '*************************************************'
	      print *, ' Error - Image data must be in mode==46 float.'
	      print *, '*************************************************'
	      call tsbend
	   else if(imgHead.mode .eq. 46) then
	      CALL PIF_READ_IMGI4 (IMGHEAD, IMG, NCOL, NROW, IDS(ID))
	   else
	      print *, 'Invalid PIF mode - ', imgHead.mode
	      call tsbend
	   endif

C         *****************************************************************
C---------*    Low-pass Fourier filter the image to help TPO calculation  *
C         *    This replace the IMG_MAP call.                             *
C         *****************************************************************
	   CALL R4_IMG_FFT (IMG, NCOL, NROW, FFT1, IDIM1, IDIM2,
	1	IMG_BKG, FFT_ORIGX, FFT_ORIGY, FFT_FZERO, FFT_FULL, 0)
Ca	  print *, 'idim1,idim2 - ', idim1,idim2
Ca	  call debug_fft_buffer(fft1, idim1,idim2, 0)
Ca	  call tsbend
C         ********************************************************************
C---------* COMPARE_MODE = 3:                                                *
C         *  Divide raw images by CTF before comparing images to projections *
C         ********************************************************************
	   IF(COMPARE_MODE.EQ.3) THEN
	      CTFMODE = 1
	      FILTER  = 2
	      TFAC    = 0.0	! Hardwired for now 20-Jun-02
	      CALL CTF_DIVIDE (CTFMODE, FILTER, FFT1, IDIM1, IDIM2, 
	1	   UNITS(FILE), BIN*PIXSIZ(FILE), PI, RADIAN, WAVELENGTH, 
	2	   FOCUS_MAJ(FILE), FOCUS_MIN(FILE), ANG_MAJ(FILE), 
	3	   AMP_FAC(FILE), CS_COEFF(FILE), FILT_FAC, TFAC, FFT_FULL, 
	4	   0.0, 0.0, 0.0, VOLTS(FILE)) ! CC,BETA,De set TO 0.0
	   ENDIF
	   CALL FFT_LOP (FFT1, IDIM1, IDIM2, RES_MAX, 2.0, FFT_FULL)
	   CALL FFT_2D_BACK (FFT1, IDIM1, IDIM2)
C         *********************************************************
C---------*  Store modified version of image into R4_IMG and IMG  *
C         *********************************************************
	   CALL FFT_MAP_FILL (FFT1, IDIM1, IDIM2, R4_IMG, NCOL, NROW, 1,
	1	1, FFT_FULL)
	   CALL FFT_IMG_FILL (FFT1, IDIM1, IDIM2, IMG, NCOL, NROW,
	1	FFT_FULL, IMG_BKG, 0)
C       
	   FFT_ORIGX = NCOL/2
	   FFT_ORIGY = NROW/2
C       **************************************************************
C---------*  Apply CTF to FFT to downweight data according to Steve    *
C         *   Fuller scheme.  Implemented by SBW.                      *
C         **************************************************************
	   IF(COMPARE_MODE.EQ.2) THEN
	      CALL MAP_FFT_FILL (R4_IMG, NCOL, NROW, 1, 1, FFT1, IDIM1, 
	1	   IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	      CALL FFT_2D (FFT1, IDIM1, IDIM2)
	      WAVELENGTH = WAVEL (VOLTS(FILE))
	      TFAC    = 0.0	! HARDWIRE THIS FOR NOW
C           ****************************************************************
C-----------*  2-May-00 Hardwire input parameters to CTF_MULTIPLY such as  *
C           *  mode=1; Cc=0.0, BETA=0.0, dE=0.0; These will *not* impose   *
C           *  a decay factor on the data.                                 *
C           ****************************************************************
	      CALL CTF_MULTIPLY (1, FFT1, IDIM1, IDIM2, UNITS(FILE), 
	1	   BIN*PIXSIZ(FILE), PI, RADIAN, WAVELENGTH, FOCUS_MAJ(FILE), 
	2	   FOCUS_MIN(FILE), ANG_MAJ(FILE), AMP_FAC(FILE), 
	2	   CS_COEFF(FILE), 0.0, 0.0, 0.0, VOLTS(FILE), TFAC, FFT_FULL)
	      CALL FFT_2D_BACK (FFT1, IDIM1, IDIM2)
	      CALL FFT_MAP_FILL (FFT1, IDIM1, IDIM2, R4_IMG, NCOL, NROW, 1,
	1	   1, FFT_FULL)
	      WRITE(*,'(A,I4,A,2F8.4,A,F8.4)') 'Applied CTF to image ',
	1	   ID, ' with defocus values', FOCUS_MAJ(FILE),
	2	   FOCUS_MIN(FILE), ' and ANG_MAJ =', ANG_MAJ(FILE)
	   ENDIF
C	  ********************************************************************
C---------*   I. Get initial MAG scale factor (1.0 is default)               *
C	  *      A) GLOBAL search mode, initial sc. factor = MAG_CEN         *
C	  *      B) GLOBAL mode, read from input parameter file              *
C	  *  II. Get initial X,Y origins				     *
C	  *      A) IABS(MODE).EQ.1, estimate by cross-correlation with cir- *
C         *         cularly averaged reference, RES_MIN=1.0 (no choice)      *
C	  *      B) IABS(MODE).EQ.2, read from input parameter file.         *
C	  * III. If MAG does not equal 1.0, scale image by MAG	             *
C	  *  IV. Compute FFT of image					     *
C	  ********************************************************************
	   IF(IABS(MODE).EQ.1) THEN ! GLOBAL MODE #1 (NO ORGINS)
	      CALL MAP_FFT_FILL (R4_IMG, NCOL, NROW, 1, 1, FFT1,
	1	   IDIM1, IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	      CALL FFT_2D (FFT1, IDIM1, IDIM2)
Ca	     print *, 'idim1,idim2 - ', idim1,idim2
Ca	     call debug_fft_buffer(fft1, idim1,idim2, 0)
Ca	     call debug_fft_buffer(fft2, idim1,idim2, 1)
Ca	     call tsbend
	      CALL GET_XY (FFT1, FFT2, XCEN, YCEN, IDIM1, IDIM2, 
	1	 RES_MAX, FFT_ORIGX, FFT_ORIGY, flag, end_fit) !end_fit MBS
	      if(flag .lt. 0) then
		 print *, 'WARNING:  Center is more than 30% off '
		 print *, '          Particle #', id
	      endif
	      MAG = MAG_CEN
	      IF (MAG.NE.1.0) THEN
Ca  RWA July 2004 - We have decided NOT to do anything with MAG in GLOBAL
Ca  Mode.
		 print *, 'MAG .ne. 1.0 ignored.'
Ca	       CALL INTERP2D (R4_IMG, NCOL, NROW, XCEN, YCEN, XCEN, YCEN, 
Ca	1	0.0, MAG, 0.0)
		 CALL MAP_FFT_FILL (R4_IMG,NCOL,NROW,1,1,FFT1,IDIM1,IDIM2,
	1	      FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
		 CALL FFT_2D (FFT1, IDIM1, IDIM2)
	      ENDIF
	   ELSE			! GLOBAL MODE #2 (WITH ORGINS)
	      XCEN = ((XS(ID) + 1.0)/BIN) - 1.0	! NEED IN BINNED FFT SPACE
	      YCEN = ((YS(ID) + 1.0)/BIN) - 1.0	! NEED IN BINNED FFT SPACE
	      MAG  = MAGS(ID)
	      IF(MAG.NE.1.0) THEN
Ca  RWA July 2004 - We have decided NOT to do anything with MAG in GLOBAL
Ca  Mode.
		 print *, 'MAG .ne. 1.0 ignored.'
Ca	       CALL INTERP2D (R4_IMG, NCOL, NROW, XCEN, YCEN, XCEN, YCEN,
Ca	1       0.0, MAG, 0.0)
	      ENDIF
	      CALL MAP_FFT_FILL (R4_IMG, NCOL, NROW, 1, 1, FFT1,IDIM1, 
	1     IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	      CALL FFT_2D (FFT1, IDIM1, IDIM2)
	   ENDIF

Ca	  call debug_fft_buffer(fft1, idim1,idim2, 0)
Ca	  call debug_fft_buffer(fft2, idim1,idim2, 1)
Ca	  call tsbend

	   XCEN = XCEN + 1.0	! Get back into real space
	   YCEN = YCEN + 1.0
C	  *******************************************************************
C---------*  Sometimes EMPFT crashes with a division-by-0 error in          *
C	  *  GET_THEPHI (called below). It turns out that GET_XY            *
C	  *  (above) returns a bad origin due to poor matching between an   *
C	  *  image and its reference, and then MAP_POLAR (below) fills the  *
C	  *  polar array with zero since the origin can be too far off the  *
C	  *  edge of the cartesian array. The div-by-0 occurs because the   *
C	  *  sum-of-sqaures (SQ1) for the polar array is zero.  Check here  * 
C	  *  for (XCEN,YCEN) being away from the center of the image array  *
C	  *  (NCOL/2,NROW/2) and post warnings. If it is way off, the user  *
C	  *  can try to skip this particle and go on to the next, rather    *
C	  *  than crash in GET_THEPHI.                                      *
C	  *******************************************************************
	   IF (ABS(XCEN-FLOAT(NCOL/2)).GT.FLOAT(NCOL/2) .OR. 
	1     ABS(YCEN-FLOAT(NROW/2)).GT.FLOAT(NROW/2))  THEN
Ca	     WRITE (*,410) IDS(ID), XCEN*BIN, YCEN*BIN
	   ELSE IF (ABS(XCEN-FLOAT(NCOL/2)).GT.FLOAT(NCOL/10) .OR.
	1           ABS(YCEN-FLOAT(NROW/2)).GT.FLOAT(NROW/10))  THEN
	      WRITE (*,415) IDS(ID), XCEN*BIN, YCEN*BIN
	   ENDIF
 410	   FORMAT (' WARNING - estimated center is off edge of array:',/,
	1         ' IMG_NUM, XCEN, YCEN = ', I, 2F10.3)
 415	   FORMAT (' WARNING - estimated center is more than 10% from ',
	1         'array center:',/,' IMG_NUM, XCEN, YCEN = ', I, 2F10.3)
C
	   CALL GET_TPO_G (MODE, NCOL, NROW, NROT, NANNULI, NVIEW_MOD, 
	1  JCUT, ILIST, XCEN, YCEN, XCEN_MODEL, YCEN_MODEL, RADIUS, DEL_ANG, 
	2  PIXRES_MIN, PIXRES_MAX, ANN_LO, ANN_HI, VAR, VAROPT, PI, 
	3  AVG, SQ1, SQ2, MOD_TS, MOD_PS, THE_BEST, PHI_BEST, OME_BEST, 
	4  DEL_PIXRES, PFTS, PFT_AVGS, PRJS, CC_PFT, CC_PRJ, R4_IMG, 
	5  PMAP, PFFT, PRJ, PPRJ, PFTIMG, ICOR, CCOR, A_ARRAY, FLIP,
	6  INDEX, PRJHEAD)
C
	   IF(FLIP) THEN
	      THE_BEST = 180.0 - THE_BEST
	      IF(THE_BEST.EQ.0.0 .OR. THE_BEST.EQ.180.0) THEN
		 PHI_BEST = 0.0
	      ELSE
		 PHI_BEST = PHI_BEST + 180.0
	      ENDIF
	      IF(THE_BEST.NE.180.0)  OME_BEST = OME_BEST + 180.0
	      CALL MAP_XFLIP (PRJ, NCOL, NROW, 0)
	   ENDIF
C	  ***********************
C---------*  Refine X,Y origin  *
C	  ***********************
	   CALL COPY_R4 (PRJ, PRJ_ROT, NCOL*NROW)
	   IF (OME_BEST.NE.0.0) THEN
	      CALL INTERP2D (PRJ_ROT, NCOL, NROW, XCEN_MODEL-1.0, 
	1    YCEN_MODEL-1.0, XCEN_MODEL-1.0, YCEN_MODEL-1.0, OME_BEST, 1.0,
	2    0.0)
	   ENDIF
	   CALL MAP_FFT_FILL (PRJ_ROT, NCOL, NROW, 1, 1, FFT3, IDIM1, 
	1  IDIM2, FFT_FZERO, FFT_ORIGX, FFT_ORIGY, FFT_FULL, 0)
	   CALL FFT_2D (FFT3, IDIM1, IDIM2)
	   if(id.eq.nids_tot)end_fit = .true.
	   CALL GET_XY (FFT1, FFT3, XCEN, YCEN, IDIM1, IDIM2, RES_MAX, 
	1  FFT_ORIGX, FFT_ORIGY, flag, end_fit) !end_fit MBS
c$$$	  print *, 'GETXY- ',xcen,ycen,flag

	   if(flag .lt. 0) then
	      print *, 'WARNING:  Center is more than 30% off '
	      print *, '          Particle #', id
	   endif
	   XCEN = XCEN + 1.0	! Get back into real space
	   YCEN = YCEN + 1.0
C	  *******************************************************************
C---------*  Again test 1) for centers off the Cartesian array              *
C	  *             2) for centers more than 10% from array center      *
C	  *  Such origins may indicate poor data                            *
C	  *******************************************************************
	   IF (ABS(XCEN-FLOAT(NCOL/2)).GT.FLOAT(NCOL/2) .OR. 
	1	ABS(YCEN-FLOAT(NROW/2)).GT.FLOAT(NROW/2))  THEN
	      WRITE (*,410) IDS(ID), XCEN*BIN, YCEN*BIN
	   ELSE IF (ABS(XCEN-FLOAT(NCOL/2)).GT.FLOAT(NCOL/10) .OR.
	1           ABS(YCEN-FLOAT(NROW/2)).GT.FLOAT(NROW/10))  THEN
	      WRITE (*,415) IDS(ID), XCEN*BIN, YCEN*BIN
	   ENDIF
C	  *********************************************************************
C---------*  Find/refine MAG scale factor and CMP coefficient, use a routine  *
C	  *  adapted from CMP program, IMG and PRJ are compared in real space *
C	  *********************************************************************
	   IF (MAG_CEN.LE.0.0) THEN
	      MAG_LO = MAG     - (((MAG_NUM-1)/2)*MAG_STEP)
	   ELSE
	      MAG_LO = MAG_CEN - (((MAG_NUM-1)/2)*MAG_STEP)
	   ENDIF
	   TMP0_P = MALLOC (4*NCOL*NROW)
	   TMP1_P = MALLOC (8*IDIM1*IDIM2)
	   TMP2_P = MALLOC (8*IDIM1*IDIM2)
Ca  RWA July 2004 - This is different???  e.g. We're just doing statistics
Ca  on MAG here???
	   CALL GET_BESTMAG (IMG, PRJ, TMP0, TMP1, TMP2, NCOL, NROW, IDIM1, 
	1  IDIM2, FLOAT(ANN_LO), FLOAT(ANN_HI), RES_MIN, RES_MAX, XCEN-1.0, 
	2  YCEN-1.0, OME_BEST, MAG_LO, MAG_NUM, MAG_STEP, BEST_MAG, CC_CMP, 
	3  IMG_BKG, FFT_ORIGX, FFT_ORIGY)
	   IF(TMP0_P.NE.0) CALL FREE (TMP0_P)
	   IF(TMP1_P.NE.0) CALL FREE (TMP1_P)
	   IF(TMP2_P.NE.0) CALL FREE (TMP2_P)
	   MAG    = BEST_MAG
C	  *********************************************************************
C	  *    IF ILIST > 0                                                   *
C---------*    RECOMPUTE POLAR MAP OF RAW IMAGE WITH NEWEST X,Y ORIGIN        *
C	  *    RECOMPUTE POLAR MAP OF ROTATED PROJECTION                      *
C	  *    COMPUTE COEFFICIENTS AS A FUNCTION OF RESOLUTION AND RADIUS    *
C	  *    WRITE TO EXTRA OUTPUT FILES (UNITS 8,9,10)                     *
C	  *********************************************************************
	   IF(ILIST.LE.0) GO TO 500
	   CALL LIST_CCS (BIN, NCOL, NROW, IDIM1, IDIM2, NROT, NANNULI, 
	1  IMG,  MSKIMG, R4_IMG,  FFT1,  FFT3,  FFT4,  FFT5,  PRJ_ROT,  
	2  MSKPRJ, PPRJ, PMAP,  FLTPMAP, IDS(ID), IMG_BKG, XCEN, YCEN, 
	3  XCEN_MODEL, YCEN_MODEL, FFT_ORIGX, FFT_ORIGY, RES_MIN, RES_MAX, 
	4  ANN_LO, ANN_HI, RADIUS, PIXRES_MAX, DEL_PIXRES, DEL_ANG, CC_AVG, 
	5  CC_RES_GLOBAL, CC_RAD_GLOBAL)
C	  *******************************************************************
C---------*  If not asymmetric, check if orientation is in asymmetric unit  *
C	  *  and return to asymmetric unit if orientation lies outside      *
C	  *******************************************************************
 500	   IF (SYM.NE.1) THEN
	      CALL TO_ASYM_UNIT (SYM, THE_BEST, PHI_BEST, OME_BEST)
	   ENDIF
	   IF (OME_BEST.LT.0.0) OME_BEST = OME_BEST + 360.0 ! Keep positive
	   IF (OME_BEST.ge.360.0) OME_BEST = OME_BEST - 360.0 ! Keep within 0 - 360
C         ****************************************************************
C---------*  WRITE TO OUTPUT DATA FILE (DEFAULT = EMPFT.DAT) AND SCREEN  *
C         ****************************************************************
c$$$	   XS(ID)      = (XCEN*BIN) - 1.0
c$$$	   YS(ID)      = (YCEN*BIN) - 1.0
	   XS(ID)      = (XCEN - 1.0)*BIN                      !MBS 10/25/05
	   YS(ID)      = (YCEN - 1.0)*BIN                      !MBS 10/25/05
	   TS(ID)      = THE_BEST
	   PS(ID)      = PHI_BEST
	   OS(ID)      = OME_BEST
	   MAGS(ID)    = MAG
	   PFT_CCS(ID) = CC_PFT
	   PRJ_CCS(ID) = CC_PRJ
	   CMP_CCS(ID) = CC_CMP
	   WRITE(*,1110)  IDS(ID), TS(ID), PS(ID), OS(ID), XS(ID), YS(ID),
	1	MAGS(ID), PFT_CCS(ID), PRJ_CCS(ID), CMP_CCS(ID)
 1110	   FORMAT (1X,I6,',',4(F8.3,','),F7.3,',',3(F6.3,','),F6.3)
	ENDDO			! End of "DO ID = 1,NIDS_TOT"
C  ****************************************************************************
C  *  Write extra output to files if user wishes (ILIST > 0)  *
C  *   UNIT 8 = STATS OUTPUT FILE (EMPFT.RES1)                *
C  *        9 = STATS OUTPUT FILE (EMPFT.RADS)                *
C  *       10 = STATS OUTPUT FILE (EMPFT.RES2)                *
C  ************************************************************
	IF (ILIST.GE.1) THEN
	   J = NINT(1/(PIXRES_MAX*DEL_PIXRES))
	   WRITE(8,1209)
	   WRITE(8,'(A,10F7.3)') ' AVG', (CC_RES_GLOBAL(1,I)/FLOAT(NIMGS),
	1				I=1,J)
	   WRITE(10,1209)
	   WRITE(10,'(A,10F7.3)') ' AVG', (CC_RES_GLOBAL(2,I)/FLOAT(NIMGS),
	1				 I=1,J)
	   WRITE(9,1210) NIMGS
	   DO I = 1,ANN_HI+1
	      J = (I-1)*BIN
	      WRITE(9,1211) J, CC_RAD_GLOBAL(1,I)/FLOAT(NIMGS), 
	1                    CC_RAD_GLOBAL(2,I)/FLOAT(NIMGS)
	   ENDDO
	ENDIF
 1209	FORMAT(74('-')) 
 1210	FORMAT (' AVERAGE correlation coefficients as function ',
	1 'of radius for', I6,' images'/,' CCs are for unfiltered/',
	2 'filtered IMG vs. POLAR_PRJ',/,' Radius Unfiltered Filtered',
	3 /,'---------------------------')
 1211	FORMAT(I5,2F10.3)
C
C  **************************************************************
C  *    DEALLOCATE UNNEEDED MEMORY BEFORE EXITING SUBROUTINE    *
C  **************************************************************
	CALL FREEMEM3 (PFT_AVGS_P, SQ2_P, VAR_P, RMS_P, AVER_P, TMP_P)
	CALL FREEMEM4 (FFT1_P, FFT3_P, IMG_P, R4_IMG_P, PRJ_ROT_P, 
	1 PFTIMG_P, PFFT_P, PMAP_P, FLTPMAP_P, PPRJ_P, A_ARRAY_P,
	2 CCOR_P, ICOR_P)
	IF(A_P.NE.0) CALL FREE (A_P)
	IF(PFTS_P.NE.0) CALL FREE (PFTS_P)
	IF(PRJS_GOLD_P.NE.0) CALL FREE (PRJS_GOLD_P)
C
	IF(ILIST.GE.1) THEN
	  IF(FFT4_P.NE.0)   CALL FREE (FFT4_P)
	  IF(FFT5_P.NE.0)   CALL FREE (FFT5_P)
	  IF(MSKIMG_P.NE.0) CALL FREE (MSKIMG_P)
	  IF(MSKPRJ_P.NE.0) CALL FREE (MSKPRJ_P)
	ENDIF
	IF(IABS(MODE).EQ.1 .AND. FFT2_P.NE.0)  CALL FREE (FFT2_P)
C
	RETURN
	END

C  *****************************************************************************
C  *                                                                           *
C  *                    *****     SUBROUTINE GET_XY     *****                  *
C  *                                                                           *
C  *    ROUTINE FOR ESTIMATING THE ORIGINS OF ICOSAHEDRAL PARTICLES BY         *
C  *     CROSS-CORRELATION WITH CIRCULARLY-AVERAGED REFERENCE.                 *
C  *                                                                           *
C  *    NOTE: "RES_MIN" here = 1.0 (NO CHOICE ALLOWED)                         *
C  *                                                                           *
C  *    MAY 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER.                        *
C  *    LAST MODIFIED 17-DEC-1997 BY T. BAKER (Rid of EM.CMM).                 *
C  *****************************************************************************
C
	SUBROUTINE GET_XY (FFT1, FFT2, XCEN, YCEN, IDIM1, IDIM2,
	1 RES_MAX, FFT_ORIGX, FFT_ORIGY, flag, end_fit) !end_fit MBS
C
	IMPLICIT NONE
C
	INTEGER*4 IDIM1, IDIM2, EM_WRT, flag
	REAL*4    RES_MAX, XCEN, YCEN, FFT_ORIGX, FFT_ORIGY
	REAL*4    FFT1(2*IDIM1,IDIM2), FFT2(2*IDIM1,IDIM2)
	REAL*4    MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, CC_MAP(1)
	character fname*256
	POINTER   (CC_MAP_P,CC_MAP)
	LOGICAL   MALLOC
	logical   end_fit
C  ----------------------------------------------------------------------------
C
	EM_WRT = 0
	CC_MAP_P = MALLOC (4*IDIM1*IDIM2)			! ADD ERROR MSG
	if(cc_map_p .eq. 0) then
          write(*,*)'Not enough memory for cc_map in get_xy()'
          stop
	endif
	CALL CCF_FFT (FFT1, FFT2, CC_MAP, IDIM1, IDIM2, 1.0, RES_MAX, 
	1 MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD, EM_WRT)
	CALL PFTCC_PEAK (CC_MAP, IDIM1, IDIM2, XCEN, YCEN, FFT_ORIGX, 
	1 FFT_ORIGY, flag, end_fit) !end_fit MBS
Ca	print *, 'Writing dummy.pif'
Ca	fname = 'dummy.pif'
Ca	call pif_write_debugi4(fname, cc_map,idim1,idim2)
Ca	call tsbend
	IF(CC_MAP_P.NE.0) CALL FREE (CC_MAP_P)
C
	RETURN
	END


C  ******************************************************************
C  *                                                                *
C  *           *****     SUBROUTINE PFTCC_PEAK     *****            *
C  *                                                                *
C  *    SUBROUTINE FIND PEAK OF CROSS-CORRELATION "MAP".            *
C  *    MODIFIED 17-SEP-2004 BY MBS, put surface fitting            *
C  *    LAST MODIFIED 25-OCT-2005 BY MBS, bug fixed in XCEN, YCEN   *
C  ******************************************************************
C
	SUBROUTINE PFTCC_PEAK (CC_MAP, NCOL, NROW, XCEN, YCEN, FFT_ORIGX,
	1 FFT_ORIGY, flag, end_fit) !end_fit MBS
C
	IMPLICIT NONE
C
	INTEGER*4 icor,jcor,icor2,jcor2                                 !MBS
	parameter (icor=15,jcor=15)
	INTEGER*4 IX, IY, IPX, IPY, NCOL, NROW
	INTEGER*4 I, J
c ORIG	INTEGER*4 I, J, IPEAKX, IPEAKY
	integer*4 incX,incY, excX, excY, lPeakX,lPeakY,flag
	REAL*4    AMPS(icor,jcor), XCEN, YCEN, PEAK, FFT_ORIGX, FFT_ORIGY
	REAL*4    HALFX, HALFY, CC_MAP(NCOL,NROW), PEAKX, PEAKY,lPeak
C       MBS
	CHARACTER fname*64, fname1*64
	integer*4 iopt/0/,mx,my,k
	integer*4 kx/3/,ky/3/
	integer*4 nxest,nyest,nx,ny,lwrk,kwrk,ier
	integer*4 iwrk(1)
	real*4    fit_max
	real*4    xb,xe,yb,ye,s,fp
	real*4    step, rangex, rangey
	real*4    xcoord(icor), ycoord(jcor)
	real*4    surf_fit(1)
	real*4    surf_diff(icor,jcor)
	real*4    tx(1),ty(1),c(1),wrk(1)
	LOGICAL   end_fit, malloc, init, first/.true./
	pointer   (ty_p,ty), (tx_p,tx), (c_p,c), (wrk_p,wrk), (iwrk_p,iwrk)
	pointer   (surf_fit_p,surf_fit)
C       MBS
C  ----------------------------------------------------------------------------
C
	incX  =  0.3 * ((ncol+1)/2)
	incY  =  0.3 * ((nrow+1)/2)
	excX  =  0.1 * ((ncol+1)/2)
	excY  =  0.1 * ((nrow+1)/2)

	icor2 = (icor + 1)/2                                     !MBS
	jcor2 = (jcor + 1)/2                                     !MBS	

c$$$	call MAP_PEAK (CC_MAP, NCOL, NROW, IPx, IPy, PEAK)
c$$$	lPeak = peak

	CALL MAP_PEAK_RESTR (CC_MAP, NCOL, NROW, IPX, IPY, PEAK,
	1           lPeakX,lPeakY,lPeak, incX,incY, excX, excY)
C
c	flag = 0
	if(peak .ne. lPeak) then
	   flag = -99
	endif
	HALFX = FLOAT(NCOL)/2.0
	HALFY = FLOAT(NROW)/2.0
C
	DO J = 1,jcor
	  IY = IPY + (J-jcor2)
	  IF(IY.LE.0)    IY = IY + NROW
	  IF(IY.GT.NROW) IY = IY - NROW
	   ycoord(j) = IY
	  DO I = 1,icor
	    IX = IPX + (I-icor2)
	    IF(IX.LE.0)    IX = IX + NCOL
	    IF(IX.GT.NCOL) IX = IX - NCOL
	    if (j.eq.1) xcoord(i) = IX
	    AMPS(j,i) = CC_MAP(IX,IY)   !MBS 10/26/05
c	    AMPS(I,J) = CC_MAP(IX,IY)
	  ENDDO
	ENDDO
c$$$	DO J = 15,1,-1
c$$$	  WRITE(6,'(1X,15f15.2))') (AMPS(I,J),I=1,15)
c$$$	ENDDO
c$$$	stop
c$$$	print *, 'Here - ipx,ipy ', ipx,ipy, ncol,nrow
Ca ORIG	IPEAKX = IPX - 1
Ca	IPEAKY = IPY - 1
c$$$	IPEAKX = IPX - halfx - 1 
c$$$	IPEAKY = IPY - halfy - 1
CaORIG	IF(IPEAKX.GT.INT(HALFX)) IPEAKX = IPEAKX - NCOL
Ca	IF(IPEAKY.GT.INT(HALFY)) IPEAKY = IPEAKY - NROW
Ca	IF(IPEAKX.lT.0.0) IPEAKX = IPEAKX + 1
Ca	IF(IPEAKY.lT.0.0) IPEAKY = IPEAKY + 1
c$$$	CALL TRUS_POLYS (AMPS, IPEAKX, IPEAKY, PEAKX, PEAKY)
Ca	print *, 'ipeakx,peakx,ipeaky,peaky:',ipeakx,peakx,ipeaky,peaky

c$$$	fname  = 'search_maps_xy.pif'
c$$$	fname1 = 'search_maps_fit_xy.pif'

	mx = icor
	my = jcor

	xb = xcoord(1)
	xe = xcoord(mx)
	yb = ycoord(1)
	ye = ycoord(my)

	s = 0.00001
	nxest = mx+kx+1
	nyest = my+ky+1

	step = 1.
	surf_fit_p = malloc (4*mx*my)
	if (surf_fit_p.eq.0) then
	   write(*,'(a)')'Could not allocate memory for surf_fit'
	   stop
	end if

	tx_p = malloc (4*nxest)
	if (tx_p.eq.0) then
	   write(*,'(a)')'Could not allocate memory for tx'
	   stop
	end if
	ty_p = malloc (4*nyest)
	if (ty_p.eq.0) then
	   write(*,'(a)')'Could not allocate memory for ty'
	   stop
	end if
	c_p = malloc (4*(nxest-kx-1)*(nyest-ky-1))
	if (c_p.eq.0) then
	   write(*,'(a)')'Could not allocate memory for knots array'
	   stop
	end if
	lwrk = 4+nxest*(my+2*kx+5)+nyest*(2*ky+5)+mx*(kx+1)+my*(ky+1)
	1     +max(my,nxest)
	wrk_p = malloc (4*lwrk)
	if (wrk_p.eq.0) then
	   write(*,'(a)')'Could not allocate memory for wrk array'
	   stop
	end if
	kwrk = 3+mx+my+nxest+nyest
	iwrk_p = malloc (4*kwrk)
	if (iwrk_p.eq.0) then
	   write(*,'(a)')'Could not allocate memory for iwrk array'
	   stop
	end if

	ier = 2
	do while(ier.ne.0) 
	   call regrid(iopt,mx,xcoord,my,ycoord,AMPS,xb,xe,yb,ye,kx,ky,s,
	1	nxest,nyest,nx,tx,ny,ty,c,fp,wrk,lwrk,iwrk,kwrk,ier)
c$$$	   write(*,*)'nx,ny,fp:',nx,ny,fp
c$$$	   write(*,*)'mx,my:',mx,my
c$$$	   write(*,*)'xcoord:',(xcoord(i),i = 1,mx)
c$$$	   write(*,*)'ycoord:',(ycoord(i),i = 1,my)
c$$$	   write(*,*)'tx:',(tx(i),i = 1,nx)
c$$$	   write(*,*)'ty:',(ty(i),i = 1,ny)
c$$$	   write(*,*)'spline coefficients:'
c$$$	   do j = 1,ny-ky-1
c$$$	      write(*,'(10f5.2)')(c((ny-ky-1)*(i-1)+j),i=1,nx-kx-1)
c$$$	   end do
c$$$	   write(*,*)"ier =", ier, "s =", s
	   if(ier.eq.10) then
	      write(*,*)"Check dimensions etc. in regrid call"
	      stop
	   end if
	   if(ier.eq.-2) then
	      if(s.gt.1.e-6) then
		 write(*,*)"Smoothing factor too big, dividing by 10"
		 s = s/10.
	      else
		 ier = 0
	      end if
	   else if(ier.eq.-1) then
c$$$	      write(*,*)"Interpolating spline returned"
	      ier = 0
	   else if(ier.eq.1) then
	      write(*,*)"nxest or nyest are too small, increasing by 5"
	      nxest = nxest + 5
	      nyest = nyest + 5
	   else if(ier.eq.2 .or. ier.eq.3) then
	      write(*,*)"Smoothing factor too small, increasing 2x"
	      s = s*2.
	   end if
	end do

	write(*,'(a,2i6)')"Best origin by simple search    :",IPX,IPY
	k = 0
	do while(k.lt.2)
	   call bispev(tx,nx,ty,ny,c,kx,ky,xcoord,mx,ycoord,my,surf_fit,
	1	wrk,lwrk,iwrk,kwrk,ier)
	   if(ier.eq.10) then
	      write(*,*)"Check dimensions etc. in bispev call"
	      stop
	   end if

	   if(k.eq.0) then
	      if(first) then
		 init = .true.
		 first = .not. first
	      end if
c$$$	      call write_debug_fit (fname1, surf_fit, icor, icor, 46,
c$$$	1	   end_fit, 21, init)
	   end if
c$$$	   write(*,*)'mx,my:',mx,my
c$$$	   write(*,*)'xcoord:',(xcoord(i),i = 1,mx)
c$$$	   write(*,*)'ycoord:',(ycoord(i),i = 1,my)
c$$$	   write(*,*)'tx:',(tx(i),i = 1,nx)
c$$$	   write(*,*)'ty:',(ty(i),i = 1,ny)
c$$$	   write(*,*)'spline function:'
c$$$	   do j = 1,my
c$$$	      write(*,'(10f5.2)')(surf_fit(my*(i-1)+j),i=1,mx)
c$$$	   end do
c       Initialize parameters
	   fit_max = -1.e38
	   PEAKX         = -10000.
	   PEAKY         = -10000.
	   do j = 1, my
	      do i = 1, mx
		 if(surf_fit(j+(i-1)*mx) .gt. fit_max) then
		    fit_max = surf_fit(j+(i-1)*mx)
		    PEAKX = xcoord(i)
		    PEAKY = ycoord(j)
c$$$		    surf_diff(i,j) = amps(i,j) - surf_fit(j+(i-1)*mx)
		 end if
	      end do
	   end do
	   write(*,'(a,3f12.4)')"Best origin by surface fit, step:",
	1	PEAKX,PEAKY,step
	   if(PEAKX .ne. -10000. .and. PEAKY .ne. -10000.) then
	      step = step/10.
	      rangex = step*(icor2-1)
	      rangey = step*(jcor2-1)
	      i = 1
	      do xcen = PEAKX-rangex,PEAKX+rangex,step
		 xcoord(i) = xcen
		 i = i + 1
	      end do
	      i = 1
	      do ycen = PEAKY-rangey,PEAKY+rangey,step
		 ycoord(i) = ycen
		 i = i + 1
	      end do
	   else
	      write(*,*) 'Surface fit failed, max not found'
	      stop
	   end if
	   k = k + 1
	end do
c$$$	call write_debug_orig (fname, amps, icor, jcor, 46, end_fit,
c$$$	1    20, init)
c$$$c        call write_debug_fit (fname1, surf_diff, icor, jcor, 46, end_fit,
	if(init) init = .false.
	if(tx_p.ne.0)call free(tx_p)
	if(ty_p.ne.0)call free(ty_p)
	if(c_p.ne.0)call free(c_p)
	if(wrk_p.ne.0)call free(wrk_p)
	if(iwrk_p.ne.0)call free(iwrk_p)
	if(surf_fit_p.ne.0)call free(surf_fit_p)

	XCEN = FFT_ORIGX - (PEAKX - halfx - 1)          !MBS 10/25/05
	YCEN = FFT_ORIGY - (PEAKY - halfy - 1)          !MBS 10/25/05
c$$$	print *, 'xcen,ycen - ',xcen,ycen
c$$$	call tsbend
C
	RETURN
	END

