
#include <stdio.h>
#include <math.h>
#define DEBUG1 0

void fpoly_ctf(int idx, int idy, double a[], double *ymode, double dyda[], int na, int order_poly1,
	int order_poly2, double  wavelength, int idim_half, double  A, double  Cs,
	double  pixel_size )
{
	int i, j, k, orderb, orderd;
  	double  arg1, arg2, dvalue, defmajor, defminor, angle, theta1;
  	double  fw, fw2, theta, def, PI, ctf, ctf2, tmp1, tmp2;
        double  cosph, sinph, costh, sinth, dctfdth;
 	
 	PI=3.141592653589793238;
	angle    = a[na-1];
	defminor = a[na-2];
	defmajor = a[na-3];

        if (idx!=0) theta1 = atan2(idy,idx);
        else {
           if (idy >=0) theta1 = PI/2;
           else theta1 = -PI/2;
        }
        theta1 -= angle;
        cosph = cos(theta1);
        sinph = sin(theta1);
        def     = defmajor*cosph*cosph + defminor*sinph*sinph;

   	fw =wavelength*sqrt(idx*idx + idy*idy)/(idim_half*2.0* pixel_size );
	fw2= fw*fw;
	theta = PI*2.0*(Cs*fw2*fw2/4.0-def*fw2/2.0)/wavelength;
        costh = cos(theta);
        sinth = sin(theta);
	ctf = sqrt(1.0-A*A)*sinth-A*costh;
 	ctf2 = ctf*ctf;
	dctfdth = sqrt(1.0-A*A)*costh+A*sinth;
  
        orderb = floor(sqrt(2*order_poly1)) -1;
        orderd = floor(sqrt(2*order_poly2)) -1;

/* compute B + ctf*ctf*D */
/* we formulate the B and D in the order of x, 2nd order is y, 
   such as order 2:  a0 + a1*y + a2*y*y + a3*x + a4*x*y + a5*x*x  
   such as order 3:  a0 + a1*y + a2*y*y + a3*y*y*y + a4*x + a5*x*y + a6*x*y*y + a7*x*x +a8*x*x*y + a9*x*x*x 
*/
  	*ymode=0.0;
        arg1 = 1;
        k    = 0;
        for (i = 0; i<= orderb; i++) {
           arg2  = 1;
           for (j = 0; j <= orderb - i; j++){
               dyda[k] = arg1 * arg2;
               *ymode += a[k] * dyda[k];
               arg2   *= idy;
               k++;
           }
           arg1  *= idx;
        }
       
        dvalue = 0.0;
   	arg1 = 1;
        for (i = 0; i<= orderd; i++) {
           arg2  = 1;
           for (j = 0; j <= orderd - i; j++){
               dyda[k] = ctf2 * arg1 * arg2;
               *ymode += a[k] * dyda[k];
               dvalue += a[k] * arg1 * arg2;
               arg2   *= idy;
               k++;
           }
           arg1  *= idx;
        }

/* compute using defocus major */
    	dyda[na-3]= -2.0*PI*ctf*dvalue*fw2*dctfdth*cosph*cosph /wavelength;
/* compute using defocus minor */
    	dyda[na-2]= -2.0*PI*ctf*dvalue*fw2*dctfdth*sinph*sinph /wavelength ;
/* compute using angle */
    	dyda[na-1]= -4.0*PI*ctf*dvalue*fw2*(defmajor-defminor)*dctfdth*sinph*cosph /wavelength;
 	
 	if(DEBUG1) {   
     	   printf("\nX is %d, \n Y is %d\n", idx, idy);
    	   printf("   ymode = %f\n", *ymode);
            for(i=0;i<na; i++)  
                printf("   a[%d] = %f\n",i, a[i]);
            for(i=0;i<na; i++)
                printf("   dyda[%d] = %f\n",i, dyda[i]);
        } 
}
