
#include <math.h>
#define DEBUG1 0

void fpoly_ctf(double  x, double  a[], double  *y, double  dyda[], int na, int order_poly1,
	int order_poly2, double  wavelength, int idim_half, double  A, double  Cs,
	double  pixel_size )
{
	int i;
  	double  fac, ex, arg, y1;
  	double  fw, fw2, theta, defocus, PI, ctf, ctf2;
 	
 	PI=3.14159265358979323;
	defocus = a[na-1];
  	*y=0.0;
  	y1=0.0;
   	fw =wavelength*x/(idim_half*2.0* pixel_size );
	fw2= fw*fw;
	theta = PI*2.0*(Cs*fw2*fw2/4.0-defocus*fw2/2.0)/wavelength;
	ctf = sqrt(1.0-A*A)*sin(theta)-A*cos(theta);
 	ctf2 = ctf*ctf;
  
  	arg =x ;
  	*y = a[0]; 
  	dyda[0]=1;
  	for (i=1; i<order_poly1 ; i++) {
    	     *y += a[i]*arg;
    	     dyda[i]=arg;
    	     arg=x*arg;
    	}
   	arg = x;
   	y1 = a[order_poly1]; 
   	*y+= ctf2*a[order_poly1];
   	dyda[order_poly1]=ctf2;
   	for (i=order_poly1+1; i<na-1; i++) { 
    	     y1+= a[i]*arg;
    	     *y += ctf2*a[i]*arg;
    	     dyda[i]=ctf2*arg;
    	     arg=x*arg;
   	} 
/*    	dyda[na-1]= -2.0*ctf*y1*(ctf+2.0*A*cos(theta))*PI*fw2/wavelength;
*/
    	dyda[na-1]= -2.0*ctf*y1*(sqrt(1.0-A*A)*cos(theta)+A*sin(theta))*PI*fw2/wavelength;
 	
 	if(DEBUG1) {   
     	   printf("\nX is %f\n", x);
    	   printf("   ymode = %f\n", *y);
            for(i=0;i<na; i++)  
                printf("   a[%d] = %f\n",i, a[i]);
            for(i=0;i<na; i++)
                printf("   dyda[%d] = %f\n",i, dyda[i]);
          } 
}
